<?php
/* ********************************************************************
 * Interleave
 * Copyright (c) 2001-2016 Atomos Applications The Netherlands - www.atomos.nl - info@atomos.nl - www.interleave.nl - info@interleave.nl
 * Licensed under the GNU GPL. For full terms see http://www.gnu.org/
 *
 * admin.php. This script forsees in some (most) general admin tasks
 *
 * Check http://www.interleave.nl/ for more information
 *
 * BUILD / RELEASE :: 7.0.20161227
 *
 **********************************************************************
 */
$_GET['SkipMainNavigation'] = true;
require_once "initiate.php";

global $lang, $database, $host, $user, $pass;

if (isset($_REQUEST['phpinfo'])) {

	MustBeAdmin();
	$_REQUEST['nonavbar'] = 1;
	phpinfo();
	exit;

} elseif ($_REQUEST['ExportSettings']) {

	MustBeAdmin();
	$_REQUEST['nonavbar'] = 1;
	ExportSettings();
	exit;

}

ShowHeaders();

if ($_REQUEST['BeThisUser'] && (is_administrator() || CheckFunctionAccess("UserAdminSudo") == "ok")) {

	if (!is_administrator($_REQUEST['BeThisUser'])) {

		if (!is_administrator()) {
			// User with privilege to log in as other user
			if (GetGroup($GLOBALS['USERID']) == GetGroup($_REQUEST['BeThisUser'])) {
				PrintAD("You can only log in as a user not belonging to your own group. Access denied.");
				EndHTML();
				exit;
			}
		}

		log_msg("Administrative user " . GetUserName($GLOBALS['USERID']) . " switched to the profile of user " . GetUserName($_REQUEST['BeThisUser']));
		mcq("UPDATE CRMsessions SET name='" . mres(GetUserLoginNameByID($_REQUEST['BeThisUser'])) . "' WHERE temp='" . mres($GLOBALS['sessionid']) . "'");
		$GLOBALS['USERID'] = $_REQUEST['BeThisUser'];
		?>
			<script type="text/javascript">
			<!--
				alert('You are now logged in as <?php echo GetUserName($_REQUEST['BeThisUser']);?>. You have to\nlog out and in again to go back to your own account.');
				window.location.href = 'index.php';
			//-->
			</script>
		<?php
		EndHTML();
		exit;
	} else {
		PrintAD("You cannot log in as another administrator, that would be unethical. Sorry.");
	}
}

/* beyond this point only admin functions */

MustBeAdmin();

if (!$_REQUEST['nonavbar'] && is_administrator()) {
	AdminTabs();
}

if (isset($_REQUEST['check_database_fields'])) {
	check_database_fields();
} elseif (isset($_REQUEST['dropds'])) {

	AdminChangesDropCache();
	print '<h1>Data structures dropped</h1>';
} elseif ($_REQUEST['DropAllCache']) {
	DropAllCache();
	print " <span class=\"okmsg\">Done</span>";
} elseif (isset($_GET['AnalyzeTables'])) {
	foreach ($GLOBALS['UC']['PersonalDataStructure'] AS $props) {
	mcq("ANALYZE TABLE `CRM" . $props['name_in_database'] . "`");
	}
	print "<span class=\"okmsg\">Done</span>";
} elseif (isset($_REQUEST['recreate_mysql_triggers'])) {
	$triggers = return_mysql_trigger_queries();
	print '<pre>';
	foreach ($triggers AS $sql) {
		print htme($sql) . "\n";
		mcq($sql);
	}
	print '</pre>';
	print " <span class=\"okmsg\">Done</span>";
} elseif (isset($_REQUEST['create_indices'])) {
	print "<span class=\"okmsg\">Done</span>";
	create_indices();

} elseif (isset($_GET['CalendarAdmin'])) {

	CalendarAdmin();

} elseif (ipi($_REQUEST['normalize'])) {

	NormalizeField($_REQUEST['normalize'], $_REQUEST['action']);

} elseif ($_REQUEST['checkfiles'] == 1) {

	$do = false;
	if ($_REQUEST['do_deletes'] == 1) {
		$do = true;
	}
	find_and_delete_orphaned_files_in_db_and_on_disk($do);

} elseif ($_REQUEST['qlog'] && $_REQUEST['logstash']) {

	$msg = PopStashValue($_REQUEST['logstash']);
	print "<pre>" . htme($msg) . "</pre>";

} elseif (isset($_REQUEST['MailQueueManager'])) {

	MailQueueManager();

} elseif (isset($_REQUEST['get_list_options_and_descriptions'])) {

	print '<table class="crm filtertable"><thead><tr><th>Tag</th><th>Description</th><th>Valid options</th><th>Default value</th></tr></thead>';
	foreach (get_list_options_and_descriptions() AS $tag => $arr) {
		print '<tr><td>' . htme($tag) . '</td><td>' . htme($arr['Description']) . '</td><td>' . htme(implode(", ", $arr['Valid'])) . '</td><td>' . htme($arr['Default']) . '</tr></tr>';
	}
	print '</table>';

} elseif (ipi($_REQUEST['get_default_form_for_table'])) {

	print "<textarea rows=\"30\" cols=\"150\">" . ReturnDefaultFormForTable("t" . $_REQUEST['get_default_form_for_table'], true, true, true) . "</textarea>";

} elseif (isset($_REQUEST['FindAndReplace'])) {

	print "<form name='farForm' id='JS_farForm' action='' method='post'>";
	if ($_POST['far_field'] != "" && $_POST['lookFor'] != "" && ($_POST['goReplace'] || $_POST['far_field'] == "%%all_config%%")) {

		if ($_POST['far_field'] != "%%all_config%%") {
			$tmp = explode(".", $_POST['far_field']);
			$table = "CRM" . $tmp[0];
			$sql = "UPDATE " . $table . " SET CRM" . $_POST['far_field'] . " = REPLACE(CRM" . $_POST['far_field'] . ",'" . mres($_POST['lookFor']) . "','" . mres($_POST['replaceWith']) . "') WHERE CRM" . $_POST['far_field'] . " LIKE '%" . $_POST['lookFor'] . "%'";
			mcq($sql);
		} else {


			$fields = array("extrafieldrequiredconditions.value", "extrafields.name","extrafields.remarks", "extrafields.displaylistname", "extrafields.defaultval", "flextabledefs.tablename", "flextabledefs.addlinktext", "flextabledefs.comment", "flextabledefs.headerhtml", "languages.TEXT", "modules.module_name", "modules.module_description", "modules.module_code","templates.templatename", "templates.content", "templates.template_subject", "extrafields.calculation");

			foreach ($fields AS $field) {
				$tmp = explode(".", $field);
				$table = "CRM" . $tmp[0];
				$sql = "UPDATE " . $table . " SET CRM" . $field . " = REPLACE(CRM" . $field . ",'" . mres($_POST['lookFor']) . "','" . mres($_POST['replaceWith']) . "') WHERE CRM" . $field . " LIKE '%" . mres($_POST['lookFor']) . "%'";
				mcq($sql);
				print "Updated: " . $field . "<br>";
			}


			// options moet nog (serialized)

		}

		print "Replacements made.";
	} elseif ($_POST['far_field'] != "" && $_POST['lookFor'] != "") {
		$tmp = explode(".", $_POST['far_field']);
		$table = "CRM" . $tmp[0];
		$tmp = db_GetValue("SELECT COUNT(*) FROM " . $table . " WHERE CRM" . $_POST['far_field'] . " LIKE '%" . $_POST['lookFor'] . "%'");
		print $tmp . " records will be changed. Continue?<br><br>";
		print "<input type=\"submit\" name=\"farSubmit\" id=\"JS_farSubmit\" value=\"Replace!\">";
		print "<input type=\"hidden\" name=\"FindAndReplace\" id=\"JS_FindAndReplace\" value=\"1\">";
		print "<input type=\"hidden\" name=\"goReplace\" id=\"JS_goReplace\" value=\"1\">";
		print "<input type=\"hidden\" name=\"far_field\" id=\"JS_far_field\" value=\"". htme($_POST['far_field']) . "\">";
		print "<input type=\"hidden\" name=\"lookFor\" id=\"JS_lookFor\" value=\"". htme($_POST['lookFor']) . "\">";
		print "<input type=\"hidden\" name=\"replaceWith\" id=\"JS_replaceWith\" value=\"" . htme($_POST['replaceWith']) . "\">";
	} else {

		print "In field:<br>";
		$fields = array("templates.content" => "All template contents", "templates.template_subject" => "All template subjects", "templates.templatename" => "All template names", "extrafields.options" => "All field options", "binfiles.filename" => "All filenames (binfiles)", "%%all_config%%" => "All configuration items, no confirmation");


		$tmp = db_GetArray("SELECT id,tabletype, name FROM CRMextrafields WHERE deleted='n'");
		foreach ($tmp AS $field) {
			if (is_numeric($field['tabletype'])) $field['tabletype'] = "flextable" . $field['tabletype'];
			$fields[$field['tabletype'] . ".EFID" . $field['id']] = $field['name'] . " (" . $field['tabletype'] . ")";
		}
		print "<select name=\"far_field\" id=\"JS_far_field\">";
		foreach ($fields AS $field => $desc) {
			print "<option value=\"" . $field . "\">" . $desc . "</option>";
		}
		print "</select>";
		print " " . ReturnDropDownSearchField("JS_far_field");

		print "<br>Replace all occurrences of:<br>";
		print "<input type='text' name='lookFor' id='JS_lookFor' size='50'>";
		print "<br>with:<br>";
		print "<input type=\"text\" name=\"replaceWith\" id=\"JS_replaceWith\" size=\"50\"><br><br>";
		print "<input type=\"submit\" name=\"farSubmit\" id=\"JS_farSubmit\" value=\"Next step\">";
		print "<input type=\"hidden\" name=\"FindAndReplace\" id=\"JS_FindAndReplace\" value=\"1\">";

	}
	print "</form>";
} elseif ($_REQUEST['UpdateTemplate']) {

	$filename = GetTemplateName($_REQUEST['UpdateTemplate']);
	if ($_FILES['userfile'] <> "") {
		print "File received<br>";
		print "Received file : " . $_FILES['userfile']['name'] . "<br>";
		if ($filename <> $_FILES['userfile']['name']) {
			print "ERROR: File names must be the same!<br>";
		} else {
			mcq("UPDATE CRMtemplates SET binary_content='" . mres(file_get_contents($_FILES['userfile']['tmp_name'])) . "' WHERE templateid='" . mres($_REQUEST['UpdateTemplate']) . "'");
			print "File updated!<br>";
		}
	} else {

		print "<table><td>&nbsp;&nbsp;&nbsp;&nbsp;</td><td>";
		print "Update RTF template " . $_REQUEST['UpdateTemplate'] . ": " . $filename . "<br><br>";
		print "<form method='post' action='' id='uploadAFile' enctype='multipart/form-data'><div class='showinline'><input type='hidden' name='max_file_size' value='52428800'><input type='hidden' name='templates' value='1'><input name='userfile' type='file'> <input type='submit' value='Update template'>";
		print "<input type='hidden' name='UpdateTemplate' value='" . htme($_REQUEST['UpdateTemplate']) . "'>";
		print "</div></form>";
		print "</td></tr></table>";
	}

} elseif (isset($_REQUEST['ArchiveLog'])) {

	ArchiveLog($_REQUEST['log'], $_REQUEST['date_from']);

} elseif ($_REQUEST['excessfields']) {

	DropUnusedFieldsFromDatabase();

} elseif ($_REQUEST['DeleteOldVersions'] == 1) {

	DeleteOldVersions();

} elseif ($_REQUEST['RecalculateCalculations']) {

	print '<pre>';
	recalc_calculations("", true, true);
	print '</pre>';
	print "All calculations were re-calculated.";

	qlog(INFO, "All calculations were re-calculated.");

	$_REQUEST['datman'] = 1;
} elseif ($_REQUEST['RunCompression']) {

	ProcessArchiving();

} elseif ($_REQUEST['ImportSettings']) {

	ImportSettings();

} elseif ($_REQUEST['log']) {

	list($number_of_records, $output) = make_list(array("table" => "uselog"));
	print $output;

} elseif (isset($_REQUEST['GeneralFiles']) || isset($_REQUEST['SystemFiles'])  || isset($_REQUEST['PublicFiles'])) {


	if ($_POST['reimport']) {
		$fid = $_POST['reimport'];
		/* a fileid of an export file was given, to re-import */
		$filename = GetFileName($fid);
		if (strpos($filename, "_archive_b4_") !== false) {
			$filename1 = CopyFileToDisk($fid);
			$filename2 = tempnam("","log_archive_uncompressed_");
			scmd("tar -xvzOf $filename1 > $filename2");
			unlink($filename1);
			print exec("file $filename2");
			$fp = fopen($filename2, "r");
			if ($fp) {
				while (($line = fgets($fp)) !== false) {
					// process the line read.
					mcq($line);
				}

				fclose($fp);
				mcq("UPDATE CRMbinfiles SET filename = REPLACE(filename, 'b4_', 'b4-REIMPORTED_') WHERE fileid='" . $fid . "'");
			} else {
				// error opening the file.
				print 'Error. Did nothing.<br>';
			}
			unlink($filename2);
		} else {
			PrintAD("This is not an Interleave archive file");
		}

	}

	$tag = "";
	if (isset($_REQUEST['GeneralFiles'])) {

		print '<h1>General purpose files</h1>';
		print "<div>These files are accessible for every user with a valid session.</div>";
		print "<div>To refer to these files, create a hyperlink in your template to csv.php?fileid={file-id}.</div>";
		print '<form name="generalfiles" id="JS_generalfiles" method="post" action="">';
		print FileUploadBox('generalpurpose', 0, 0);
		print '</form>';

		list($number_of_records, $output) = make_list(array("table" => "files", "listid" => "generalpurposefiles", "hiddenfilter" => array("files-type" => array("generalpurpose"))));

	} elseif (isset($_REQUEST['PublicFiles'])) {

		print '<h1>Public files</h1>';
		print "<div>These files are accessible for the whole word, even if not logged in.</div>";
		print "<div>To refer to these files, create a hyperlink in your template to publicfile.php?filename={{filename}}.</div>";
		print '<form name="publicfiles" id="JS_publicfiles" method="post" action="">';
		print FileUploadBox('public', 0, 0);
		print '</form>';

		list($number_of_records, $output) = make_list(array("table" => "files", "listid" => "publicfiles", "hiddenfilter" => array("files-type" => array("public"))));

	} else {

		print '<h1>System files</h1>';
		print "<div>These files are only accessible for administrators.</div>";
		print '<form name="generalfiles" id="JS_generalfiles" method="post" action="">';
		print FileUploadBox('system', 0, 0);
		print '</form>';
		list($number_of_records, $output) = make_list(array("table" => "files", "listid" => "systemfiles", "hiddenfilter" => array("files-type" => array("generalpurpose"))));
		print '<form name="import_export" method="post" action="admin.php?SystemFiles=1">Re-import exported archive file (enter fileid): <input  size="4" name="reimport" id="JS_reimport"> <input type="submit" value="Import"></form>';
	}
	print $output;

} elseif ($_REQUEST['templates']) {

	$dnd = false;
	if (!$_REQUEST['t1'] && !$_REQUEST['editHTMLtemplate']) {
		$_REQUEST['t1'] = "add";
	    $_REQUEST['nav'] = "add";
		$dnd = true;
	}

	$tabbs = array();

	$tabbs["html"] =        array("admin.php?templates=1&amp;nav=html&amp;t1=html","Plain HTML/CSS", "All plain HTML and CSS templates ");
	$tabbs["htmlforms"] =   array("admin.php?templates=1&amp;nav=htmlforms&amp;t1=htmlf" ,"Forms",  "Record forms");
	$tabbs["dashtemplates"] =   array("admin.php?templates=1&amp;nav=dashtemplates&amp;t1=dash"   , "Dashboard",  "Templates used for custom made dashboards");
	$tabbs["htmlreports"] = array("admin.php?templates=1&amp;nav=htmlreports&amp;t1=htmlr" , "HTML Summary page reports",  "Summary page report templates");

	$tabbs["pdfreports"] =  array("admin.php?templates=1&amp;nav=pdfreports&amp;t1=pdfr"   , "PDF Reports",  "PDF templates (in HTML)");


	if ($_REQUEST['nav'] == "taglist") {
			print "Tag overview";
			print "<table class='crm'><tr><td>";
			AvailableTags();
			print "</td></tr></table>";
			EndHTML();
			exit;
	} elseif (!$_FILES['userfile']['tmp_name'] =="" && !$_FILES['userfile']['name']=="" && !$_FILES['userfile']['size']=="" && !$_FILES['userfile']['type']=="") {

			//  A file was attached

			// Read contents of uploaded file into variable

				$fp=fopen($_FILES['userfile']['tmp_name'] ,"rb");
				$filecontent=fread($fp,filesize($_FILES['userfile']['tmp_name'] ));
				fclose($fp);

				 mcq("INSERT INTO CRMtemplates(templatename, templatetype, content, binary_content,username,timestamp_last_change,show_on_add_list) VALUES('". mres($_FILES['userfile']['name']) . "','" . mres($_REQUEST['filetype']) . "','%%BLOB%%','" . mres($filecontent) . "','" . mres($GLOBALS['USERID']) . "',NOW(),'n')");

				unset($filecontent);
				unset($_FILES['userfile']['tmp_name'] );
				unset($_FILES['userfile']['name']);
				unset($_FILES['userfile']['size']);
				unset($_FILES['userfile']['type']);
				print '<div class="okmsg">Template created</div>';
	}
	if ($_REQUEST['new_HTML_template']) {
		qlog(INFO, "Empty HTML template created");
		mcq("INSERT INTO CRMtemplates(templatename, templatetype, content, username, timestamp_last_change, show_on_add_list) VALUES('". mres($_REQUEST['new_HTML_template']) . "','" . mres($_REQUEST['filetype']) . "','[empty]','" . $GLOBALS['USERID'] . "',NOW(), 'n')");
		$t = db_GetInsertId();
		print '<div class="okmsg">Template created</div>';
		mcq("INSERT INTO CRMtemplateaccessrules (template) VALUES(" . $t . ")");
		print '<div class="warnmsg">This newly created template is accessible only for administrators. <a onclick="PopFancyBox(\'\',\'choose_templaterights.php?template=' . $t . '\')">Change this here</a>.</div>';
		$_REQUEST['editHTMLtemplate'] = $t;
	}

	if ($_REQUEST['editHTMLtemplate']) {
		if ($_REQUEST['saveHTMLtemplate'] && isset($_REQUEST['data'])) {

//			if ($_REQUEST['subject'] == "") {
//				$_REQUEST['subject'] = "[no subject specified]";
//			} else {
				$_REQUEST['subject'] = RemoveFieldnamesFromTags($_REQUEST['subject']);
//			}
			//AdminChangesDropCache();

			if ($_REQUEST['stylesheet'] == "") $_REQUEST['stylesheet'] = "0";
			if ($_REQUEST['ShowOnAddList'] == "") $_REQUEST['ShowOnAddList'] = db_GetValue("SELECT show_on_add_list FROM CRMtemplates WHERE templateid='" . mres($_REQUEST['saveHTMLtemplate']) . "'");

			// Versioning
			//mcq("INSERT INTO CRMtemplates (binary_content, content, orientation, page_id, show_on_add_list, stylesheet, template_subject, templatename, templatetype, username) SELECT binary_content, content, orientation, page_id, show_on_add_list, stylesheet, template_subject, templatename, templatetype, username FROM CRMtemplates WHERE templateid='" . $_REQUEST['saveHTMLtemplate'] . "'");
			//$new = db_GetInsertId();
			//mcq("UPDATE CRMtemplates SET version_belonging_to = '" . $_REQUEST['saveHTMLtemplate'] . "' WHERE templateid='" . $new . "'");

			$sql = "UPDATE CRMtemplates SET orientation='" . mres($_REQUEST['orientation']) . "', show_on_add_list='" . mres($_REQUEST['ShowOnAddList']) . "', template_subject='" . mres($_REQUEST['subject']) . "', templatename='" . mres($_REQUEST['newfilename']) . "', stylesheet='" . mres($_REQUEST['stylesheet']) . "',page_id='" . mres($_REQUEST['page_id']) . "' WHERE templateid='" . mres($_REQUEST['saveHTMLtemplate']) . "'";

			if (GetTemplateType($_REQUEST['saveHTMLtemplate']) == "TEMPLATE_REPORT_PDF" || GetTemplateType($_REQUEST['saveHTMLtemplate']) == "TEMPLATE_PLAIN") {
				$FormatNumbers = GetAttribute("template", "FormatNumbers", $_REQUEST['saveHTMLtemplate']);
				if ($FormatNumbers == "") SetAttribute("template", "FormatNumbers", "No", $_REQUEST['saveHTMLtemplate'], array('No', 'Yes'));
			}
			$DontUseHTMLEditor = GetAttribute("template", "DontUseHTMLEditor", $_REQUEST['saveHTMLtemplate']);
			if ($DontUseHTMLEditor == "") SetAttribute("template", "DontUseHTMLEditor", "No", $_REQUEST['saveHTMLtemplate'], array('No', 'Yes'));

			if (GetTemplateType($_REQUEST['saveHTMLtemplate']) == "TEMPLATE_REPORT_PDF") {
				$AllowUserToEditParsedResultBeforeCreatingPDF = GetAttribute("template", "AllowUserToEditParsedResultBeforeCreatingPDF", $_REQUEST['saveHTMLtemplate']);
				if ($AllowUserToEditParsedResultBeforeCreatingPDF == "") SetAttribute("template", "AllowUserToEditParsedResultBeforeCreatingPDF", "No", $_REQUEST['saveHTMLtemplate'], array('No', 'Yes'));

				$EditBeforeParseHTML = GetAttribute("template", "EditBeforeParseHTML", $_REQUEST['saveHTMLtemplate']);
				if ($EditBeforeParseHTML == "") SetAttribute("template", "EditBeforeParseHTML", "Please review your document", $_REQUEST['saveHTMLtemplate']);

				$EditBeforeParseButtonText = GetAttribute("template", "EditBeforeParseButtonText", $_REQUEST['saveHTMLtemplate']);
				if ($EditBeforeParseButtonText == "") SetAttribute("template", "EditBeforeParseButtonText", "Download PDF document", $_REQUEST['saveHTMLtemplate']);

				$HideHeader = GetAttribute("template", "HideHeader", $_REQUEST['saveHTMLtemplate']);
				if ($HideHeader == "") SetAttribute("template", "HideHeader", "No", $_REQUEST['saveHTMLtemplate'], array('No', 'Yes'));

				$HideFooter = GetAttribute("template", "HideFooter", $_REQUEST['saveHTMLtemplate']);
				if ($HideFooter == "") SetAttribute("template", "HideFooter", "No", $_REQUEST['saveHTMLtemplate'], array('No', 'Yes'));

				$LogoFileLocation = GetAttribute("template", "LogoFileLocation", $_REQUEST['saveHTMLtemplate']);
				if ($LogoFileLocation == "") SetAttribute("template", "LogoFileLocation", "images/interleave.gif", $_REQUEST['saveHTMLtemplate']);

				$PDFPageDimensions = GetAttribute("template", "PDFPageDimensions", $_REQUEST['saveHTMLtemplate']);
				if ($PDFPageDimensions == "") SetAttribute("template", "PDFPageDimensions", "{{none}}", $_REQUEST['saveHTMLtemplate']);

				$FooterContent = GetAttribute("template", "FooterContent", $_REQUEST['saveHTMLtemplate']);
				if ($FooterContent == "") SetAttribute("template", "FooterContent", "{{none}}", $_REQUEST['saveHTMLtemplate']);

			}

			mcq($sql);
			if ($_REQUEST['data'] != "unsupported") {

				SetAttribute("template", "SaveComments " . date('Y-m-d H:i:s') . " " . GetUserName($GLOBALS['USERID']), $_REQUEST['saveComments'], $_REQUEST['saveHTMLtemplate']);
				$sql = "UPDATE CRMtemplates SET content='" . mres(RemoveFieldnamesFromTags($_REQUEST['data'])) . "' WHERE templateid='" . mres($_REQUEST['saveHTMLtemplate']) . "'";
				mcq($sql);


			}
/*
			if ($_REQUEST['fromlisturl']) {
				?>
					<script type="text/javascript">
					<!--
						window.location.href = '<?php echo base64_decode($_REQUEST['fromlisturl']); ?>';
					//-->
					</script>
				<?php
			}
			*/
		}
		$sql = "SELECT * FROM CRMtemplates WHERE CRMtemplates.templateid='" . mres($_REQUEST['editHTMLtemplate'])  . "' AND LEFT(templatetype,8)='TEMPLATE'";

		$row = db_GetRow($sql);

		$table = "templates";
		$recordid = $row['templateid'];
		print familytree($table, $recordid, $_REQUEST['starttable'], $_REQUEST['startrecordid'], $_REQUEST['fromlist']);
		print "<h1>" . htme($GLOBALS['UC']['PersonalDataStructure'][$table]["singular"] . " " . get_refer_layout_for_record($table, $recordid)) . "</h1>";

		print "<form id='editHTMLtemplateform' method='post' action=''><div class='showinline'>";
		print '<input type="hidden" name="starttable" value="' . htme($_REQUEST['starttable']) . '">';
		print '<input type="hidden" name="startrecordid" value="' . htme($_REQUEST['startrecordid']) . '">';
		print '<input type="hidden" name="fromlist" value="' . htme($_REQUEST['fromlist']) . '">';
		/*if ($_REQUEST['fromlist']) {
				print "<input type='hidden' name='fromlisturl' value='" . htme($_REQUEST['fromlist']) . "'><input type='hidden' name='fromlistnow' value='1'>";
			}*/
		print "<input type='hidden' name='templates' value='1'>";
		print "<input type='hidden' name='editHTMLtemplate' value='" . $_REQUEST['editHTMLtemplate'] . "'>";
		print "<input type='hidden' name='saveHTMLtemplate' value='" . $_REQUEST['editHTMLtemplate'] . "'>";

		print "<table class='form-table'>";

		if ($row['templatename'] == "Default form") {

			print "<tr><td>File name</td><td><input type='text' size='70' name='newfilenameblabla' disabled value='" . htme($row['templatename']) . "'><input type='hidden' size='70' name='newfilename' value='" . htme($row['templatename']) . "'></td></tr>";
			print "<tr><td>Subject/description</td><td><input type='text' size='70' name='subject' value='" . htme(AddFieldnamesToTags($row['template_subject'])) . "'></td></tr>";

		} else {
			if ($row['templatetype'] == "TEMPLATE_REPORT_PDF" || $row['templatetype'] == "TEMPLATE_PLAIN") {
				print "<tr><td>Header title &amp; internal name</td><td><input type='text' size='70' name='newfilename' value='" . htme($row['templatename']) . "'></td></tr>";
				print "<tr><td>File name (tags are allowed)</td><td><input type='text' size='70' name='subject' value='" . htme(AddFieldnamesToTags($row['template_subject'])) . "'></td></tr>";
			} elseif ($row['templatetype'] == "TEMPLATE_PLAIN") {
				print "<tr><td>File name</td><td><input type='text' size='70' name='newfilename' value='" . htme($row['templatename']) . "'></td></tr>";
				print "<tr><td>Subject/description</td><td><input type='text' size='70' name='subject' value='" . htme(AddFieldnamesToTags($row['template_subject'])) . "'></td></tr>";
			} else {
				print "<tr><td>File name</td><td><input type='text' size='70' name='newfilename' value='" . htme($row['templatename']) . "'></td></tr>";
				print "<tr><td>Subject/description</td><td><input type='text' size='70' name='subject' value='" . htme(AddFieldnamesToTags($row['template_subject'])) . "'></td></tr>";
			}
		}
		if ($row['templatetype'] == "TEMPLATE_HTML" || $row['templatetype'] == "TEMPLATE_MENU" || $row['templatetype'] == "TEMPLATE_DASHBOARD" || $row['templatetype'] == "TEMPLATE_HTML_FORM" || $row['templatetype'] == "TEMPLATE_PDF" || $row['templatetype'] == "TEMPLATE_REPORT_PDF") {
			print "<tr><td>Style sheet</td><td>";
			print "<select name='stylesheet'>";
			print "<option value=''>System default CSS template</option>";
			$ins = "";
			if ($row['stylesheet'] == 2147483647) {
					$ins = "selected";
				}
			print "<option value='2147483647' " . $ins . ">No CSS template</option>";

			foreach (GetStyleSheets() AS $sheet) {
				$ins = "";
				if ($row['stylesheet'] == $sheet['templateid']) {
					$ins = "selected";
				}
				print "<option value='" . $sheet['templateid'] . "' " . $ins . ">" . $sheet['templatename'] . " (" . AddFieldnamesToTags($sheet['template_subject']) . ")</option>";
			}
			print "</select></td></tr>";
		}

		$prt = "";
		$extrains = "";
		if (($_REQUEST['nav'] == "htmlforms" || $_REQUEST['nav'] == "all") && GetTemplateType($_REQUEST['editHTMLtemplate']) == "TEMPLATE_HTML_FORM" ) {
			$prt = "<tr><td>Show this form on the add-entity menu</td>";
			$extrains = "&nbsp;&nbsp;A user must have access to this form in order to be able to use it! Check the user or profile to allow access.";
		} elseif ($_REQUEST['nav'] == "pdfreports") {
			$prt = "<tr><td>Use Interleave logo header</td>";
			$extrains = "";
		}

		if ($prt) {
			print $prt;
			print "<td><select name='ShowOnAddList'>";
			$ins1 = "";
			$ins2 = "";

			if ($row['show_on_add_list'] == "n") {
				$ins1 = "selected";
			} else {
				$ins2 = "selected";
			}
			print "<option value='n' " . $ins1 . ">No</option><option value='y' " . $ins2 . ">Yes</option>";

			print "</select>" . $extrains;
			print "</td></tr>";
		}

		if ($row['templatetype'] == "TEMPLATE_REPORT_PDF") {
			print "<tr><td>Page orientation</td><td><select name='orientation'>";
			print "<option value='P'>Portrait</option>";
			$sel = "";
			if ($row['orientation'] == "L") $sel = "selected";
			print "<option value='L' " . $sel . ">Landscape</option>";
			print "</select></td></tr>";
		}

		print "<tr><td>Page id</td><td><input type=\"text\" name=\"page_id\" id=\"JS_page_id\" size=\"20\" value=\"" . htme($row['page_id']) . "\"> To be used to open this template by referring to page.php?{{Page id}} or /{{Page id}} (with url beautification)";
		print "<tr><td>Comments/changes</td><td><input type=\"text\" name=\"saveComments\" id=\"JS_saveComments\" size=\"70\">&nbsp;&nbsp; <input type='submit' value='Save'> <a href=\"admin.php?templates=1&amp;deletetemplate=" . htme($_REQUEST['editHTMLtemplate']) . "\" onclick=\"return confirm('Are you sure?')\" class=\"likebutton\">Delete</a> " . AttributeLink("template", $_REQUEST['editHTMLtemplate'], "Attributes", "", true);

		print " <a onclick=\"PopFancyBoxExtraLarge('Table tags', 'flextable.php?nonavbar=1&amp;showtags";
		$ft = db_GetValue("SELECT recordid FROM CRMflextabledefs WHERE formid='" . mres($_REQUEST['editHTMLtemplate']) . "'");

		if (ipi($ft)) {
			print "=t" . $ft;
		}
		print "');\" class=\"likebutton\">Tag list</a>";

                if (ipi($row['templateid']))
                {
                        $listoptions = array();
                        $listoptions["table"] = "templateaccessrules";
                        $listoptions["hiddenfilter"]["templateaccessrules-template"][] = $row['templateid'];
                        $listoptions["type_of_list"] = "sublist";
                        list($number_of_records, $output) = make_list($listoptions);
                        //print $output;
                        print ' <input type="button" onclick="PopFancyBox(\'\',\'choose_templaterights.php?template=' . $row['templateid'] . '\')" value="' . $number_of_records . ' access rules">';
                }

		print "</td></tr>";
		print '<tr><td colspan="2">';
		if (GetTemplateType($_REQUEST['editHTMLtemplate']) != "TEMPLATE_PLAIN") {
			$ls = new SaferScript("<?php ?>" . GetTemplate($_REQUEST['editHTMLtemplate']) . "<?php ?>");

			$ls->allowHarmlessCalls();

			print_r($ls->parse());
		}

		print '</td></tr>';
		print "<tr><td colspan='2'>";
		$noedit = false;

		if ($row['templatetype'] == "TEMPLATE_CSS" || $row['templatetype'] == "TEMPLATE_XML" || $_REQUEST['code_editor']) {
			$syntax = "";
			if ($row['templatetype'] == "TEMPLATE_CSS") {
				$syntax = "css";
			} elseif ($row['templatetype'] == "TEMPLATE_XML") {
				$syntax = "xml";
			} else {
				$syntax = "php";
				print ValidatePHPSyntax($row['content']) . "<br>";
			}

			?>
			<script type="text/javascript" src="lib/editarea/edit_area/edit_area_full.js"></script>
			<script type="text/javascript">
			editAreaLoader.init({
			    id : "csscode"			// textarea id
			    ,start_highlight: true	// if start with highlight
			    ,allow_resize: "both"
				,syntax_selection_allow: "css"
				,word_wrap: true
			    ,allow_toggle: true
			    ,language: "en"
			    ,syntax: "<?php echo $syntax;?>"
			});
			</script>
			<?php
				print "<textarea id='csscode' rows='35' cols='140' name='data'>" . htme(AddFieldnamesToTags(($row['content']))) . "</textarea>";

		} elseif ($row['templatetype'] == "TEMPLATE_DASHBOARD" || $row['templatetype'] == "TEMPLATE_MENU" || strstr($row['templatetype'], "TEMPLATE_HTML") || $row['templatetype'] == "TEMPLATE_REPORT_PDF") {

				if (strstr($row['content'], "<?")) {
					print "<span class='warnmsg'>This template contains inline PHP</span> <a href='admin.php?templates=1&amp;nav=" . $_REQUEST['nav'] . "&amp;editHTMLtemplate=" . $_REQUEST['editHTMLtemplate'] . "&amp;code_editor=1&amp;fromlist=" . htme($_REQUEST['fromlist']) . "'> [switch to code-editor]</a>";
				}
				if (strstr($row['content'], "\$\$EXCLUDE") || strstr($row['content'], "\$\$DEFAULT")) {
					print "&nbsp;<span class='warnmsg'>This template contains form directives</span>";
				}
				print "<textarea id='editor' rows='70' cols='140' name='data'>" . htme(AddFieldnamesToTags(($row['content']))) . "</textarea>";
				if (GetAttribute("template", "DontUseHTMLEditor", $_REQUEST['editHTMLtemplate']) != "Yes") {
					//2015-06-10 Jeroen dit stylesheet overruled alle andere stylesgeet in de editor; dit zou alleen in gebruik moeten zijn bij emails
					$templatecss = "";
					if ($row['stylesheet'] > 0)
					{
						$templatecss = "csv.php?GetCSS=" . $row['stylesheet'] . "&nodefault=1&amp;" . date('U');
					}
					print make_html_editor("editor", true, $templatecss, true);
				}
		} else {
			print "This file cannot be edited on-line<input type='hidden' name='data' value='unsupported'>";
			print '<br><br><a href="csv.php?templateid=' .  htme($_REQUEST['editHTMLtemplate']) . '">Download document</a><br><br><a href="admin.php?UpdateTemplate=' . htme($_REQUEST['editHTMLtemplate']) . '">Update/overwite this template</a>';
			$noedit = true;
		}
		print "</td></tr>";

		if (ipi($row['templateid']))
		{
			print '<tr><td colspan="2"><ul>';
			foreach (db_GetArray("SELECT templateid, templatename FROM CRMtemplates WHERE content LIKE '%@TEMPLATE" . $row['templateid'] . "%' AND version_belonging_to=0") as $row)
			{
				print '<li>This template is used on template <a href="admin.php?templates=1&amp;editHTMLtemplate=' . $row['templateid'] . '">' . $row['templateid'] . ' ' . htme($row['templatename']) . '</a></li>';
			}
			$num = preg_match_all("/\@TEMPLATE([0-9]+)\@/", $row['content'], $matches);
			for ($x = 0; $x < $num; $x++)
			{
				print '<li>This template uses template <a href="admin.php?templates=1&amp;editHTMLtemplate=' . $matches[1][$x] . '">' . $matches[1][$x] . ' ' . htme(GetTemplateName($matches[1][$x])) . '</a></li>';
			}
//			print_r($matches);
			print '</ul></td></tr>';
		}

		if (!$noedit) {
			print "<tr><td><input type='submit' value='Save'></td><td></td></tr>";
				print "<tr><td colspan=\"2\">Change log:<pre>";
				foreach (db_GetArray("SELECT * FROM CRMattributes WHERE identifier='template' AND entity='" . mres($_REQUEST['editHTMLtemplate']) . "' AND attribute LIKE 'SaveComments%' ORDER BY STR_TO_DATE(SUBSTRING(attribute,14,19), '%Y-%m-%d %H:%i:%s') DESC") AS $row) {
					print str_replace("SaveComments ", "", $row['attribute']) . " :: " . htme($row['value']) . "\n";
				}
				print "</pre></td></tr>";
		}

		print "<tr><td colspan='2'>";
		if ($_REQUEST['editHTMLtemplate']) {
			AvailableTags();
		}

		print "</td></tr>";
		print "</table>";
		print "</div></form>";
	} else {

		if (!$dnd) {
			$c = db_GetFlatArray("SELECT CRMtemplates.templateid FROM CRMtemplates WHERE CRMtemplates.templatetype='TEMPLATE_HTML_FORM' AND CRMtemplates.version_belonging_to=0 AND CRMtemplates.templateid NOT IN (SELECT CRMflextabledefs.formid FROM CRMflextabledefs)");

			$d= array();
			$e = array();
			$f = array();
			foreach ($c AS $tid) {
				if (db_GetValue("SELECT COUNT(*) FROM CRMtemplates WHERE (CRMtemplates.content LIKE '%template_to_use=" . $tid . "%' OR CRMtemplates.content LIKE '%template=" . $tid . "%') AND version_belonging_to=0") == 0) {
					$d[] = $tid;
				}
			}
			foreach ($d AS $tid) {
				if (db_GetValue("SELECT COUNT(*) FROM CRMextrafields WHERE CRMextrafields.fieldtype='comment' AND options='" . $tid . "'") == 0) {
					$e[] = $tid;
				}
			}
			foreach ($e AS $tid) {
				if (db_GetValue("SELECT COUNT(*) FROM CRMextrafields WHERE CRMextrafields.fieldtype='comment' AND options='" . $tid . "'") == 0) {
					$f[] = $tid;
				}
			}
			if (count($f) > 0) {
				print '<span class="warnmsg">The following form templates are not directly in use by a table, used as a template for a comment field or used as an inline form: ';
				print implode(", ", $f);
				print '. <a href="admin.php?templates=1&t1=all&SkipMainNavigation&deltemplates=1">Delete them</a>.</span>';
			}
			if ($_REQUEST['deltemplates'] == 1) {
				mcq("DELETE FROM CRMtemplates WHERE templateid IN (" . implode(",", $f) . ") OR version_belonging_to IN (" . implode(",", $f) . ")");
			}
			$ins = "";
			$lo = array("table" => "templates", "hiddenfilter" => array("templates-version_belonging_to" => array("0")));

			if ($_REQUEST['type'] != "") {
				$lo["hiddenfilter"]["templates-templatetype"] = array($_REQUEST['type']);
			}

			list($number_of_records, $output) = make_list($lo);
			print $output;

		}
		if ($_REQUEST['t1']=="add" || $_REQUEST['t1']=="") {
			$a = "";
			$a = "<h1>Create a new template</h1>";
			$a .= "<h2>Carefully select the document type</h2>";
			$a .= "<form id='html' method='post' action=''>";
			$a .= "<table>";
			$a .= "<tr><td>Name <input type='text' name='new_HTML_template'>&nbsp;&nbsp;Document type <select name='filetype'><option value='TEMPLATE_HTML'>HTML Plain template</option><option value='TEMPLATE_HTML_FORM'>HTML Form template</option><option value='TEMPLATE_DASHBOARD'>HTML Dashboard template</option><option value='TEMPLATE_MENU'>HTML Menu template</option>";

			$a .= "<option value='TEMPLATE_REPORT_PDF'>HTML/PDF Report template</option><option value='TEMPLATE_CSS'>CSS Stylesheet</option><option value='TEMPLATE_XML'>XML template</option></select>&nbsp;&nbsp;<input class='txt' type='submit' name='sb' value='Create'><input type='hidden' name='templates' value='1'>";
			$a .= "</table></form>";
			$a .= "<table>";

			$a .= "<ul><li>HTML Plain template: A plain HTML template to use as email, a page (custom tab) or as comment field</li>";

			$a .= "<li>HTML Summary page report template: A template to use as a report on the summary page</li>";
			$a .= "<li>HTML/PDF Report template: A template to use as a PDF-report</li>";
			$a .= "<li>CSS template: Cascading stylesheet</li>";
			$a .= "</ul></td></tr></table>";
			$a .= "<form method='post' id='bla123' enctype='multipart/form-data' action=''>";
			$a .= "<h2>Upload a template</h2>";
			$a .=  "<table><tr><td colspan='6'><input type='hidden' name='max_file_size' value='52428800'><input type='hidden' name='templates' value='1'><input name='userfile' type='file'>&nbsp;&nbsp;&nbsp;&nbsp;Document type:&nbsp;<select name='filetype'><option value='TEMPLATE_PLAIN'>Other type (can be any of .docx, .xlsx, .rtf and all OO formats)</option></select>&nbsp;&nbsp;<input class='txt' type='submit' name='sb' value='Upload'>";
			$a .= "</td></tr></table></form>";

			print $a;
		}
	}

} elseif ($_REQUEST['ViewJournal']) {

	list($number_of_records, $output) = make_list(array("table" => "journal", "use_adaptive_filters" => false));
	print $output;

} elseif ($_REQUEST['ViewDataJournal']) {

	list($number_of_records, $output) = make_list(array("table" => "datajournal", "use_adaptive_filters" => false));
	print $output;

} elseif ($_REQUEST['EditSysVar']) {

	EditSysVar($_REQUEST['EditSysVar']);

} elseif ($_REQUEST['ImportSettings']) {

	ImportSettings();

} elseif ($_REQUEST['deldb'] && $_REQUEST['daba']) {	// Delete a repository

	$_REQUEST['daba']--;
	if (!$_REQUEST['Confirmed']) {
		$curpassword = db_GetValue("SELECT password FROM CRMloginusers WHERE id='" . mres($GLOBALS['USERID']) . "'");

		DB_Connect($_REQUEST['daba']);

		$foreignpassword = db_GetValue("SELECT password FROM CRMloginusers WHERE id='" . mres($GLOBALS['USERID']) . "' AND administrator='Yes'");

		if ($curpassword<>$foreignpassword) {
				print "<tr><tr>";
				PrintAD("access to function denied");
				log_msg("Somebody (" . $GLOBALS['USERNAME'] . ") tried to delete this repository");
				EndHTML();
				exit;
		}

		$title = GetSetting("title");

		$dabb = $_REQUEST['daba'];
		$_REQUEST['daba']++;

		print "<tr><td>";
		$deltables = "";
		foreach ($GLOBALS['UC']['PersonalDataStructure'] AS $props) {
			$deltables.= "<br>DROP TABLE `CRM" . $props['name_in_database'] . "`";
		}

		print "Are you sure you want to delete repository '" . $title . "' running on database " . $database[$dabb] . "?<br><br><span class='warnmsg'>WARNING! All your data in repository " . $title . " will be deleted!</span><br><br>SQL statements: <br><table><tr><td>" . $deltables . "</td></tr></table><br><br><a href='admin.php?deldb=1&amp;daba=" . $_REQUEST['daba'] . "&amp;Confirmed=1'>yes</a>";
	} else {
		$sql = "SELECT password FROM CRMloginusers WHERE id='" . mres($GLOBALS['USERID']) . "'";
		$curpassword = db_GetValue($sql);

		DB_Connect($_REQUEST['daba']);


		$sql = "SELECT password FROM CRMloginusers WHERE id='" . mres($GLOBALS['USERID']) . "' AND administrator='Yes'";
		$foreignpassword = db_GetValue($sql);

		if ($curpassword<>$foreignpassword) {
				print "<tr><tr>";
				PrintAD("access to function denied");
				log_msg("Somebody (" . $GLOBALS['USERNAME'] . ") tried to delete this repository");
				EndHTML();
				exit;
		}

		$title = GetSetting("title");

//		$sql = "DROP DATABASE $database[$_REQUEST['daba']]";
		$deltables = array();
		$p = 0;
		foreach ($GLOBALS['UC']['PersonalDataStructure'] AS $props) {
			$deltables[$p++] = "DROP TABLE `CRM" . $props['name_in_database'] . "`";
		}
		for ($t=0;$t<$p;$t++) {
			//print "<br>$deltables[$t]";
			mcq($deltables[$t]);
		}
		print "Repository $title was deleted.<br><br>";

	}
} elseif ($_REQUEST['sessionscheck'] && $_REQUEST['daba']) {

		$_REQUEST['daba']--;

		$sql = "SELECT password FROM CRMloginusers WHERE id='" . mres($GLOBALS['USERID']) . "'";
		$curpassword = db_GetValue($sql);

		DB_Connect($_REQUEST['daba']);
		$sql = "SELECT password FROM CRMloginusers WHERE id='" . mres($GLOBALS['USERID']) . "' AND administrator='Yes'";
		$foreignpassword = db_GetValue($sql);

		if ($curpassword<>$foreignpassword) {

				PrintAD("access to function denied");

		} else {

			if ($_REQUEST['sessionscheck']=="delsessions") {
					$sql="DELETE FROM CRMsessions";
					mcq($sql);
					print "Sessions table " . $_REQUEST['daba'] . ":" . $database[$_REQUEST['daba']] . " was emptied.";

					EndHTML();
					exit;
			}

			print "You can safely empty this table <em>but all people currently using this repository will loose their session requiring them to login again.</em> Please mind that when you are working in this repository, you will loose your session too after emptying the sessions table.";
			$_REQUEST['daba']++;

			print "<br><a href='admin.php?sessionscheck=delsessions&amp;daba=" . $_REQUEST['daba'] . "'>Click here to empty the session table.</a>";

			list($number_of_records, $output) = make_list(array("table" => "sessions"));
			print $output;

		}

} elseif ($_REQUEST['checkcfg'] && $_REQUEST['daba']) {

		$_REQUEST['daba']--;
		$sql = "SELECT password FROM CRMloginusers WHERE id='" . mres($GLOBALS['USERID']) . "'";
		$curpassword = db_GetValue($sql);

		if (DB_Connect($_REQUEST['daba'])) {
		} else {
			print "<span class='errmsg'>This database doesn't exist!</span>";
			EndHTML();
			exit;
		}

		$sql = "SELECT password FROM CRMloginusers WHERE id='" . mres($GLOBALS['USERID']) . "' AND administrator='Yes'";
		$foreignpassword = db_GetValue($sql);
		if ($curpassword<>$foreignpassword) {
				print "<tr><tr>";
				PrintAD("access to function denied");
				log_msg("Somebody (" . $GLOBALS['USERNAME'] . ") tried to access the Edit Fields function unauthorized");
				EndHTML();
				exit;
		}
		check_config();

} elseif ($_REQUEST['checkcfg'] && $_REQUEST['daba']) {

		$_REQUEST['daba']--;
		$sql = "SELECT password FROM CRMloginusers WHERE id='" . mres($GLOBALS['USERID']) . "'";
		$curpassword = db_GetValue($sql);
		if (DB_Connect($_REQUEST['daba'])) {
		} else {
			print "<span class='errmsg'>This database doesn't exist!</span>";
			EndHTML();
			exit;
		}

		$sql = "SELECT password FROM CRMloginusers WHERE id='" . mres($GLOBALS['USERID']) . "' AND administrator='Yes'";
		$foreignpassword = db_GetValue($sql);
		if ($curpassword<>$foreignpassword) {
				print "<tr><tr>";
				PrintAD("access to function denied");
				log_msg("Somebody (" . $GLOBALS['USERNAME'] . ") tried to access the Edit Fields function unauthorized");
				EndHTML();
				exit;
		}
		check_config();

} elseif ($_REQUEST['ts'] && $_REQUEST['daba']) {	// Show table status in plain text

		$_REQUEST['daba']--;

		$sql = "SELECT password FROM CRMloginusers WHERE id='" . mres($GLOBALS['USERID']) . "'";
		$curpassword = db_GetValue($sql);
		if (DB_Connect($_REQUEST['daba'])) {
		} else {
			print "<span class='errmsg'>This database doesn't exist!</span>";
			EndHTML();
			exit;
		}

		$sql = "SELECT password FROM CRMloginusers WHERE id='" . mres($GLOBALS['USERID']) . "' AND administrator='Yes'";
		$foreignpassword = db_GetValue($sql);
		if ($curpassword<>$foreignpassword) {
				print "<tr><tr>";
				PrintAD("access to function denied");
				log_msg("Somebody (" . $GLOBALS['USERNAME'] . ") tried to access the table status overview unauthorized");
				EndHTML();
				exit;
		}
		$title = GetSetting("title");
		print "<table><tr><td>Table status query for database $title</td></tr></table>";
		$sql = "SHOW TABLE STATUS";
		print PHT($sql, "", "", "crm sortable filtertable");

} elseif ($_REQUEST['manageres']) {

		$tabbs = array();
		$tabbs[] = array("admin.php?reposman=1&amp;resman=1&amp;manageres=1", "Current repositories");
		$tabbs[] = array("install.php?AddRepository=1&amp;step=1","New repository");

		PlainNav($tabbs);


		print "<strong>Repository management</strong><br>";
		print "In this section you can add and remove your Interleave repositories as well as edit your extra<br>fields of all repositories where you (" . $GLOBALS['USERNAME'] . ") have an <strong>admin</strong> account with the same password as in this repository.<br><br>Please note that when you run several repositories in one database, the displayed size will be the sum of all repository sizes!<br><br>";

		print "<table class='crm sortable'>";
		print "<thead><tr><th>ResId</th><th>Host</th><th>Database</th><th>Repository title</th><th>Status</th><th>Size</th><th>DB version</th><th>Entities</th><th>Sessions</th><th>Total records</th><th>Maintenance mode</th><th></th><th></th><th></th><th></th><th></th></tr></thead>";
		print "<tbody>";
		// Get all possible Interleave repository titles from all possible databases
		$row = DB_GetRow("SELECT password FROM CRMloginusers WHERE id='" . mres($GLOBALS['USERID']) . "'");
		$curpassword = $row['password'];
		for ($r=0;$r<64;$r++) {
			if ($host[$r]) {
					if (DB_Connect($r)) {
					} else {
						// removed slave connect
						$host[$r] = $host[$r];

					}
			}
		}
		require $GLOBALS['CONFIGFILE'];
		$tot_size = 0;
		$tot_ent = 0;
		$tot_rec = 0;
		if (sizeof($pass)>0) {

				for ($r=0;$r<64;$r++) {
					if ($user[$r]) {
						ClearAllRunningCache();
						if (DB_Connect($r)) {

								SwitchToRepos($r);
								$row = DB_GetRow("SELECT password FROM CRMloginusers WHERE name='" . mres($GLOBALS['USERNAME']) . "' AND administrator='Yes'");
								$foreignpassword = $row['password'];
								$size = 0;
								$DBVERSION = "";
								if ($curpassword==$foreignpassword) {

									//unset($tot_ent);
									$title = GetSetting('title');
									$DBVERSION = GetSetting('DBVERSION');
									$maintenance_mode = GetSetting('MAINTENANCE_MODE');;
									$enum = 0;


									$tot_ent += $enum;

									$sql = "SELECT COUNT(*) FROM CRMsessions";
									$sess = db_GetValue($sql);
									$sql = "SHOW TABLE STATUS";
									foreach (db_GetArray($sql) as $stat)
									{
										$size += $stat["Data_length"];
										$size += $stat["Index_length"];
									}

									$tot_size += (($size/1024)/1024);
									$size = FormatNumber((($size/1024)/1024),2) . " MB";
									if ($DBVERSION=="") {
										$DBVERSION="Prior to 1.9.0";
									}
									if ($DBVERSION == $GLOBALS['VERSION']) {
										$DBVERSION = "<span style='background-color: #33FF00'>" . $DBVERSION . "</span>";
									} elseif ($DBVERSION > $GLOBALS['VERSION']) {
									} elseif ($DBVERSION < $GLOBALS['VERSION']) {
										$DBVERSION = "<span style='background-color: #FF9966'>" . $DBVERSION . "</span>";
									}

									$bla = CountTotalNumOfRecords();
									$ins = "";
									if ($GLOBALS['FAULT']) {
										$ins = "<span class='errmsg'>ERROR " . $GLOBALS['FAULT'] . "</span>";
										unset($GLOBALS['FAULT']);
									} else {
										$ins = "<span class='okmsg'>OK</span>";
									}
									print "<tr><td>$r</td><td>" . $host[$r] . "</td><td>$database[$r]</td><td>$title</td><td>" . $ins . "</td><td>" . $size . "</td><td>$DBVERSION</td><td>$enum</td><td>$sess</td>";
									unset($size);

									if ($bla) {
										print "<td>" . FormatNumber($bla,0) . "</td>";
										$tot_rec = $tot_rec + $bla;
									} else {
										print "<td>n/a</td>";
									}


									if ($maintenance_mode == "Yes") {
										print "<td><span class='warnmsg'>" . $maintenance_mode . "</span></td>";
									} else {
										print "<td><span class='okmsg'>" . $maintenance_mode . "</span></td>";
									}

									print "<td><a onclick=\"PopFancyBoxExtraLarge('Table status', 'admin.php?ts=1&amp;daba=" . ($r+1) . "&amp;nonavbar=1');\"><span class=\"fa fa-table\"></span></a></td><td><a href='admin.php?sessionscheck=1&amp;daba=" . ($r+1) . "'><span class=\"fa fa-users\"></span></a>&nbsp;</td><td><a href='admin.php?checkcfg=1&amp;daba=" . ($r+1) . "'><span class=\"fa fa-wrench\"></span></a></td><td><a href='admin.php?deldb=1&amp;daba=" . ($r+1) . "'><span class=\"fa fa-times\"></span></a></td>";

									print "</tr>";
								} else {
									print "<tr><td>$r</td><td>$host[$r]</td><td>$database[$r]</td><td><span style='color: #FF3300;'>Access denied or non-existent </span></td><td>n/a</td><td>n/a</td><td>n/a</td><td>n/a</td><td>n/a</td><td>n/a</td><td>n/a</td><td>n/a</td><td>n/a</td><td>n/a</td><td>n/a</td><td>n/a</td></tr>";
								}

						} else {
							 print "<tr><td>$r</td><td>$host[$r]</td><td>$database[$r]</td><td>n/a</td><td><span style='color: #FF3300;'>Database host onreachable</span></td><td></td><td>n/a</td><td>n/a</td><td>n/a</td><td>n/a</td><td>n/a</td><td>n/a</td><td>n/a</td><td>n/a</td><td>n/a</td><td>n/a</td><td>n/a</td></tr>";
						}

						}
					}
					?>
			<?php
				}
					SwitchToRepos($GLOBALS['repository']);

		print "</tbody>";
		print "</table>";
		SwitchToRepos($GLOBALS['repository']);
		print "<br>Total entities: " . FormatNumber($tot_ent) . " - Total records: " . FormatNumber($tot_rec) . " - Total size: " . ceil($tot_size) . " MB<br><br>";

} elseif ($_REQUEST['checkdb']) {

	CheckDB(true, 1);

} elseif ($_REQUEST['PerformDatabaseMaintenance']) {

	ini_set('display_errors', true);
	print '<h1>PerformDatabaseMaintenance (duedate)</h1>';
	require "dbupgrade.php";
	print '<pre>';
	PerformDatabaseMaintenance(true);
	print '</pre>';

} elseif ($_REQUEST['syscon'] || $_REQUEST['datman'] || $_REQUEST['actions']) {

	$USE_APC = false;
	if (function_exists("apc_fetch")) {
		$USE_APC = true;
	}

	$toprint = "";
	// Quadrant 1
	if ($_REQUEST['syscon']) {

		$toprint .= admin_inpage_nav(get_adminglobal_nav_items(), "System configuration");

		$toprint .= '<form method="get" action="listadmin.php">';
		$toprint .= '<input type="hidden" name="searchadmin" value="1">';
		$toprint .= '<input type="search" placeholder="search" name="search" value=""> ';
		$toprint .= '<input type="checkbox" name="whole_word_only" id="whole_word_only" value="1"> <label for="whole_word_only">whole word only</label> ';
		$toprint .= '<input type="submit" value="Search whole config">';
		$toprint .= '</form>';


	} elseif ($_REQUEST['sysman']) {

	} elseif ($_REQUEST['datman']) {

		$toprint .= admin_inpage_nav(get_datamanagement_nav_items(), "Data management");

	} elseif ($_REQUEST['actions']) {

		$toprint = "";
		$toprint .= "<h1>Actions</h1><form name='qb4nd' id='JS_qb4nd' action='admin.php?actions=1' method='post'>";
		$toprint .= "<table>";
		$toprint .= "<tr><td><a href='mailto:" . htme(implode(",", db_GetFlatArray("SELECT EMAIL FROM CRMloginusers WHERE active='yes' GROUP BY EMAIL"))) . "'>Send e-mail to all users</a><div>Send an e-mail to all Interleave users.</div></td></tr>";
		if ($_REQUEST['emm']) {

			mcq("UPDATE CRMsettings SET value='Yes' WHERE setting='MAINTENANCE_MODE'");

		} elseif ($_REQUEST['dmm']) {

			mcq("UPDATE CRMsettings SET value='No' WHERE setting='MAINTENANCE_MODE'");

		}
		if (GetSetting("MAINTENANCE_MODE") == "Yes") {
			$toprint .= "<tr><td><a href='admin.php?actions=1&amp;dmm=1'>Disable maintenance mode</a><div>Disable maintenance mode. This will re-enable logins from non-admin users</div></td></tr>";
		} else {
			$toprint .= "<tr><td><a href='admin.php?actions=1&amp;emm=1'>Enable maintenance mode</a><div>Disables logins from non-admin users. Use this when performing site maintenance.</div></td></tr>";
		}
		if (GetSetting("DevelopmentOrProduction") == "Development") {

			if ($_POST['qb4nd_content']) {
				$t = array();
				foreach ($_POST['qb4nd_content'] AS $line) {
					$lines = explode("|", $line);
					foreach ($lines AS $row) {
						if (trim($row) != "" && !stristr($row, "DROP DATABASE")) {
							if (substr($row, strlen($row)-1,1) != ";") {
								$row .= ";";
							}
							$t[] = $row;
						}
					}
				}

				SetAttribute("system", "QueriesBeforeNextDeploy", $t, 1);
			}
			if ($_POST['qfnd_content']) {
				$t = array();
				foreach ($_POST['qfnd_content'] AS $line) {
					$lines = explode("|", $line);
					foreach ($lines AS $row) {
						if (trim($row) != "" && !stristr($row, "DROP DATABASE")) {
							if (substr($row, strlen($row)-1,1) != ";") {
								$row .= ";";
							}
						$t[] = $row;
						}
					}
				}
				SetAttribute("system", "QueriesForNextDeploy", $t, 1);

			}

			$qb4nd = GetAttribute("system", "QueriesBeforeNextDeploy", 1);

			$toprint .= "<tr><td>Queries to be ran <strong>before</strong> next deploy (use | to seperate lines when pasting)<br>";
			foreach ($qb4nd AS $query) {
				$toprint .= "<input type='text' size='150' name='qb4nd_content[]' value='" . htme($query). "'>";
			}
			$toprint .= "<input type='text' size='150' name='qb4nd_content[]' value='' placeholder='Add query'>";
			$toprint .= "<input type='submit' name='submit2' value='Save'>";
			$qfnd = GetAttribute("system", "QueriesForNextDeploy", 1);

			$toprint .= "<tr><td>Queries to be ran <strong>after</strong> next deploy (use | to seperate lines when pasting)<br>";
			foreach ($qfnd AS $query) {
				$toprint .= "<input type='text' size='150' name='qfnd_content[]' value='" . htme($query). "'>";
			}
			$toprint .= "<input type='text' size='150' name='qfnd_content[]' value='' placeholder='Add query'>";



			$toprint .= "<input type='submit' name='submit1' value='Save'>";
			$toprint .= "</td></tr>";
		}

		if ($USE_APC) {
			$toprint .= "<tr><td><a href='admin.php?actions=1&amp;showapc=1'>View APC statistics</a><div>View the current APC cache status.</div></td></tr>";

		}


		$toprint .= "</table></form>";
	}



	print "<div class='adminLinkTable'>";

	print $toprint;

	print "</div>";

	if ($USE_APC && $_REQUEST['showapc']) {


		print "<object height=\"600\" width=\"100%\" data=\"apc.php\" style=\"border-color:black;border-style:solid;border-width:1px;\" id=\"apcmessages\" type=\"text/html\"></object>";

	}
	log_msg("Administrative section accessed");



} elseif ($_REQUEST['chglansettings']) {

	$debug = false;
	log_msg("System values saved");
	if ($_REQUEST['lan']) {
			$sql = "DELETE FROM CRMlanguages WHERE TEXTID='current-language'";
			mcq($sql);
			$sql= "SELECT TEXT FROM CRMlanguages WHERE TEXTID='current-language'";
			if ($debug) { print "\nSQL: $sql\n"; }
			$result= db_GetRow($sql);

			if ($result['TEXTID']=="") {
				$sql= "INSERT INTO CRMlanguages(LANGID,TEXTID,TEXT) VALUES('GLOBAL','current-language','" . mres($_REQUEST['lan']) . "')";
					if ($debug) { print "\nSQL: $sql\n"; }
				mcq($sql);

			} else {
				$sql= "UPDATE CRMlanguages SET TEXT='" . mres($_REQUEST['lan']) . "' WHERE TEXTID='current-language'";
					if ($debug) { print "\nSQL: $sql\n"; }
				mcq($sql);
			}
	}
	/*
	if ($_REQUEST['lanmask']) {
			$sql = "DELETE FROM CRMlanguages WHERE TEXTID='current-language-mask'";
			mcq($sql);
			$sql= "SELECT TEXT FROM CRMlanguages WHERE TEXTID='current-language-mask'";
			if ($debug) { print "\nSQL: $sql\n"; }
			$result= db_GetRow($sql);

			if ($result[TEXTID]=="") {
				$sql= "INSERT INTO CRMlanguages(LANGID,TEXTID,TEXT) VALUES('GLOBAL','current-language-mask','" . mres($_REQUEST['lanmask']) . "')";
					if ($debug) { print "\nSQL: $sql\n"; }
				mcq($sql);

			} else {
				$sql= "UPDATE CRMlanguages SET TEXT='" . mres($_REQUEST['lanmask']) . "' WHERE TEXTID='current-language-mask'";
					if ($debug) { print "\nSQL: $sql\n"; }
				mcq($sql);

			}
	}
	*/

} elseif ($_REQUEST['sysval']) {


	log_msg("Change System Values section accessed");
	print "<h1>Global system settings</h1>";
	print AttributeLink("system", 2);

	print "<input type='hidden' name='sysval' value='1'>";

	print "<form id='settings' method='post' action=''>";
	print "<input type='hidden' name='password' value='" . htme($_REQUEST['password']) . "'>";
	print "<input type='hidden' name='chglansettings' value='1'>";


	list($number_of_records, $output) = make_list(array("table" => "settings"));
	print $output;

	print "System-wide default language:&nbsp;&nbsp;<select name='lan'>";

	$language_overall = db_GetValue("SELECT TEXT FROM CRMlanguages WHERE TEXTID='current-language' AND LANGID='GLOBAL'");

	foreach (db_GetFlatArray("SELECT LANGID FROM CRMlanguages GROUP BY LANGID") AS $lang_id) {
		$ins = "";
		if ($language_overall==$lang_id) {
			$ins = "selected";
		}
		print "<option value='" . $lang_id . "' " . $ins . ">" . $lang_id . "</option>";

	}
	print "</select>";

	print "&nbsp;&nbsp;<input type='submit' name='aplysettings' value='Apply language'>";
	print "</form>";


} elseif ($_REQUEST['Details'] == 1) {

	print "<h2>System information</h2>";
	require "config/config.inc.php";
	print "<table>";
	print "<tr><td colspan=\"2\"><strong>Host information</strong></td></tr>";
	print "<tr><td>Database name</td><td>" . $database[$GLOBALS['repository']] . "</td></tr>";
	print "<tr><td>Database hostname</td><td>&quot;" . $host[$GLOBALS['repository']] . "&quot;</td></tr>";
	print "<tr><td>Database user</td><td>&quot;" . $user[$GLOBALS['repository']] . "&quot;</td></tr>";
	print "<tr><td>Webserver hostname</td><td>" . gethostname() . "</td></tr>";
	print "<tr><td>Server id</td><td>" . $_SERVER['SERVER_SOFTWARE'] . "</td></tr>";
	print "<tr><td>PHP Version</td><td>" . phpversion() . "</td></tr>";

	print "<tr><td colspan=\"2\"><h2>Repository information</strong></td></tr>";
	print "<tr><td>Repository title</td><td>" .GetSetting("title") . "</td></tr>";
	print "<tr><td>Interleave version</td><td>" .$GLOBALS['CRM_VERSION'] . "</td></tr>";
	print "<tr><td>Record count</td><td>" . FormatNumber(CountTotalNumOfRecords(), 0) . "</td></tr>";

	$size = 0;
	$tot_size = 0;
	foreach (db_GetArray("SHOW TABLE STATUS") as $stat)
	{
		$size += $stat["Data_length"];
		$size += $stat["Index_length"];
	}

	$tot_size += (($size/1024)/1024);
	$size = FormatNumber((($size/1024)/1024),2) . " MB";

	print "<tr><td>Database size</td><td>" . $size . "</td></tr>";
	print "<tr><td>User accounts</td><td>" . FormatNumber(db_GetValue("SELECT COUNT(*) FROM CRMloginusers WHERE active='yes'"), 0) . "</td></tr>";
	print "<tr><td>Unique logins last 30 days</td><td>" . FormatNumber(count(db_GetArray("SELECT qs,timestamp_last_change,COUNT(*) FROM CRMuselog WHERE qs LIKE 'Login %' AND UNIX_TIMESTAMP(timestamp_last_change) >" . date('U', strtotime("30 days ago")) . " GROUP BY qs")), 0) . "</td></tr>";
	print "<tr><td>Total logins last 30 days</td><td>" . FormatNumber(db_GetValue("SELECT COUNT(*) FROM CRMuselog WHERE qs LIKE 'Login %' AND UNIX_TIMESTAMP(timestamp_last_change) >" . date('U', strtotime("30 days ago")) . ""), 0) . "</td></tr>";
	print "<tr><td>Total non-admin logins last 30 days</td><td>" . FormatNumber(db_GetValue("SELECT COUNT(*) FROM CRMuselog, CRMloginusers WHERE qs LIKE 'Login %' AND REPLACE(qs,'Login ', '') = CRMloginusers.name AND CRMloginusers.administrator!='yes' AND UNIX_TIMESTAMP(CRMuselog.timestamp_last_change) >" . date('U', strtotime("30 days ago")) . ""), 0) . "</td></tr>";
	print "</table>";

} else {


	print "<h1>System information</h1>";
	print "<p>Support tickets and feature requests can be submitted in the <a href='http://support.interleave.nl/' onclick=\"window.open(this.href); return false;\">Interleave Support &amp; Development repository</a>. When submitting a support request, always include the information as much information about your specific installation in your initial post.</p>";

	print "<h2>Commercial support / consultancy / hosting</h2><p>For hosting, consultancy or support of a more commercial nature the boys at <a href=\"http://atomos.nl\">Atomos Applications</a> are always happy to help! Visit the Interleave web site at <a href='http://www.interleave.nl' onclick=\"window.open(this.href); return false;\">http://www.interleave.nl</a> for new releases and the latest documentation.</p>";

	print "<h2>Details</h2>";
	print "<p><a onclick=\"PopFancyBoxLarge('', 'admin.php?Details=1&amp;nonavbar=1');\">Show installation details</a></p>";

	list($number_of_records, $output) = make_list(array("table" => "sessions", "perpage" => 5));
	print $output;
}
EndHTML();

?>
