<?php
/* ********************************************************************
* Interleave
* Copyright (c) 2001-2016 Atomos Applications The Netherlands - www.atomos.nl - info@atomos.nl - www.interleave.nl - info@interleave.nl
* Licensed under the GNU GPL. For full terms see http://www.gnu.org/
*
* This file handles attributes of any type
*
* Check http://www.interleave.nl/ for more information
*
* BUILD / RELEASE :: 7.0.20161227
*
**********************************************************************
*/
require_once "initiate.php";
require "attributedocumentation.php";
$GLOBALS["InAdminSection"] = true;

$_REQUEST['nonavbar'] = 1;
ShowHeaders();

$largebox = false;
$stop = false;
$item = "";
$description = "";
$error = false;

switch ($_REQUEST['ParentReference']) {
	case "module":
		if (!is_administrator()) {
			PrintAD("Access to this page/function denied.");
			$stop = true;
		} else {
			$item = "module";
			$description = db_GetValue("SELECT module_name FROM CRMmodules WHERE mid='" . mres($_REQUEST['EditAttributes']) . "'");
		}
	break;
	case "user":
		if (CheckFunctionAccess("UserAdmin") <> "ok" && !is_administrator()) {
			PrintAD("Access to this page/function denied.");
			$stop = true;
		} else {
			$item = "user";
			$description = GetUserName($_REQUEST['EditAttributes']);
		}
	break;
	case "group":
		if (CheckFunctionAccess("UserAdmin") <> "ok" && !is_administrator()) {
			PrintAD("Access to this page/function denied.");
			$stop = true;
		} else {
			$item = "group";
			$description = GetGroupName($_REQUEST['EditAttributes']);
		}
	break;
	case "flextable":
		MustBeAdmin();
		$item = "flextable";
		$description = GetFlextableNames($_REQUEST['EditAttributes']);
		$description = $description[0];
	break;
	case "extrafield":
		if (!is_administrator()) {
			PrintAD("Access to this page/function denied.");
			$stop = true;
		} else {
			$item = "extrafield";
			$description = $_REQUEST['EditAttributes'] . ": " . GetExtraFieldName($_REQUEST['EditAttributes']);
		}
	break;
	case "template":
		if (!is_administrator()) {
			PrintAD("Access to this page/function denied.");
			$stop = true;
		} else {
			$item = "template";
			$description = $_REQUEST['EditAttributes'] . ": " . GetTemplateName($_REQUEST['EditAttributes']);
		}
	break;
	case "system":
		if (!is_administrator()) {
			PrintAD("Access to this page/function denied.");
			$stop  = true;
		} else {		
			$item = "system";
			$description = $_REQUEST['EditAttributes'];
		}
	break;
	
	default: 
	$error = true;
	break;
}

if ($error) {

	PrintAD("No parent reference found.");

} elseif ($stop) {

	qlog(INFO, "A user tried to access attributes but isn't allowed to");

} elseif ($_REQUEST['EditAttributes'] || isset($_REQUEST['EditAttribute']) || $_REQUEST['OpenDirect'] != "") {
		$tmp_new_val = "";
		if ($_REQUEST['OpenDirect']) $_REQUEST['EditAttribute'] = base64_encode($_REQUEST['OpenDirect']);

		$t = GetAttribute($item, "%", $_REQUEST['EditAttributes']);

		$tmp = GetMissingAttributes($item, $_REQUEST['EditAttributes']);
		for ($x=0;$x<=sizeof($tmp);$x++) {
			if (array_key_exists($tmp[$x], $t)) {
				unset($tmp[$x]);
			}
		}
		$doc = "";
		foreach ($atdocs AS $key => $value) {
			if (strstr(base64_decode($_REQUEST['EditAttribute']), $key)) {
				$doc = $key;
			}
		}
		
		if (is_array($atdocs[$doc])) {
			print "<h1>" . $atdocs[$doc][0] . "</h1>";
			print "<p>" . $atdocs[$doc][1] . "</p>";
		} else {
			if ($item == "system") {
				print "<h1>System attributes</h1>";
			} else {
				print "<h1>Attributes for " . $item . " " . $description . " : " . base64_decode($_REQUEST['EditAttribute']) . "</h1>";
			}
		}

/*
	if (isset($_POST['NewAttributeName']) && $_POST['NewAttributeValue']) {
			if ($_POST['NewAttributeName'] == "") {
				$newattr = $_POST['NewAttributeNameSelect'];
			} else {
				$newattr = $_POST['NewAttributeName'];
			}
			SetAttribute($item, $newattr, $_POST['NewAttributeValue'], $_REQUEST['EditAttributes']);

		}
*/		
		if ($_REQUEST['DeleteAttribute']) {
			SetAttribute($item, base64_decode($_REQUEST['DeleteAttribute']), "", $_REQUEST['EditAttributes']);
			AdminChangesDropCache();
		}
	

						
	
	print "<form name='AddAttribute' method='post' action='attribute.php?nonavbar=1&amp;EditAttributes=" . $_REQUEST['EditAttributes'] . "&amp;ParentReference=" . $item . "'>";
		if (!$_REQUEST['EditAttribute']) {
			//print "<strong>Add a new attribute</strong>";
		}

		if (count($tmp) > 0 && !$_REQUEST['DeleteAttribute'] && !$_REQUEST['EditAttribute']) {
		} elseif ($_REQUEST['EditAttribute'] != "") {
			if ($_REQUEST['NewAttributeValue'] != "") {
				
				SetAttribute($item, base64_decode($_REQUEST['EditAttribute']), $_REQUEST['NewAttributeValue'], $_REQUEST['EditAttributes']);
				/* handigheidje */
				if (base64_decode($_REQUEST['EditAttribute']) == "InteractiveAlwaysInline" && $_REQUEST['NewAttributeValue'] == "Yes") {
					SetAttribute($item, "Interactive", "Yes", $_REQUEST['EditAttributes']);
					SetAttribute($item, "InteractiveDontReloadListOnChange", "Yes", $_REQUEST['EditAttributes']);
				}
				AdminChangesDropCache();
				//print "<input type='text' size='50' name='NewAttributeName' id='JS_NewAttributeName' value=''>";	
				
				if ($_REQUEST['close_on_next_load'] == 1) {
					 if (substr(base64_decode($_REQUEST['EditAttribute']), strlen(base64_decode($_REQUEST['EditAttribute'])) -3,3) == "PHP") {
						$result = ValidatePHPSyntax($_REQUEST['NewAttributeValue']);
						if (stristr($result, "parse error")) {
							$_REQUEST['OpenDirect'] = 1;
							print '<script type="text/javascript">alert("This code generates a parse error.");</script>';
						} else {
							print '<script type="text/javascript">CloseMe();</script>';
						}
					 } else {
						print '<script type="text/javascript">CloseMe();WhosMyDaddy().location.reload();</script>';
					 }
				} else {
					unset($_REQUEST['EditAttribute']);
				}
			}
			if ($_REQUEST['EditAttribute']) {
				$tmp_new_val = GetAttribute($item, base64_decode($_REQUEST['EditAttribute']), $_REQUEST['EditAttributes']);
				print "<input type='hidden' size='50' name='DisabledNewAttributeName' id='JS_NewAttributeName' value='" . htme(base64_decode($_REQUEST['EditAttribute'])) . "'>";	
				print "<input type='hidden' name='EditAttribute' value='" . htme($_REQUEST['EditAttribute']) . "'>";	
				print "<input type='hidden' name='ParentReference' value='" . htme($item) . "'>";	
				print "<input type='hidden' name='EditAttributes' value='" . htme($_REQUEST['EditAttributes']) . "'>";
				print "<input type='hidden' name='close_on_next_load' value='1'>";
				
			}

		} else {
			print "<input type='text' size='50' name='NewAttributeName' id='JS_NewAttributeName' value=''>";
		}

		$arr = GetAttributeAllowedOptions($item, base64_decode($_REQUEST['EditAttribute']));
		if (is_array($arr)) {
			print "<select name='NewAttributeValue' id='JS_NewAttributeValue'>";
			foreach ($arr AS $option) {
				$ins = "";
				if ($tmp_new_val == $option) {
					$ins = "selected";
				}
				print "<option value=\"" . htme($option) . "\" " . $ins . ">" . htme($option) . "</option>";
			}
			print "</select>";
		} else {
			if (strstr(base64_decode($_REQUEST['EditAttribute']), "HTML") && $_REQUEST['coditor'] != 1) {
				print "<a href='attribute.php?EditAttribute=" . htme($_REQUEST['EditAttribute']) . "&amp;ParentReference=" . htme($_REQUEST['ParentReference']) . "&amp;EditAttributes=" . htme($_REQUEST['EditAttributes']) . "&amp;coditor=1'>[code]</a>";
				print "<textarea name='NewAttributeValue' id='JS_NewAttributeValue' cols=80 rows=5>" . htme($tmp_new_val) . "</textarea>";
				print make_html_editor("JS_NewAttributeValue", false, false, true, "300", "95%");

			} elseif (($largebox || (stristr(base64_decode($_REQUEST['EditAttribute']), "text") && $_REQUEST['coditor'] != 1) || base64_decode($_REQUEST['EditAttribute']) == "ExtraSelectCondition")  && $_REQUEST['coditor'] != 1) {
				print "<a href='attribute.php?EditAttribute=" . htme($_REQUEST['EditAttribute']) . "&amp;ParentReference=" . htme($_REQUEST['ParentReference']) . "&amp;EditAttributes=" . htme($_REQUEST['EditAttributes']) . "&amp;coditor=1'>[code]</a><br>";
				print "<textarea name='NewAttributeValue' id='JS_NewAttributeValue' cols=80 rows=5>" . htme($tmp_new_val) . "</textarea>";
			} elseif (substr(base64_decode($_REQUEST['EditAttribute']), strlen(base64_decode($_REQUEST['EditAttribute'])) -3,3) == "PHP" || $_REQUEST['coditor'] == 1) {
					if ($tmp_new_val != "{{none}}" && $tmp_new_val != "") {
						print ValidatePHPSyntax($tmp_new_val) . "<br>";
					}
					?>
					<script type="text/javascript" src="lib/editarea/edit_area/edit_area_full.js"></script>
					<script type="text/javascript">
					editAreaLoader.init({
						id : "JS_NewAttributeValue"			// textarea id
						,start_highlight: true	// if start with highlight
						,allow_resize: "both"
						,syntax_selection_allow: "css,html,js,php"
						,word_wrap: true
						,allow_toggle: true
						,language: "en"
						,syntax: "php"
						,font_size: "9"
						,font_family: "monospace"

					});
					</script>
					<?php
					print "<textarea id='JS_NewAttributeValue' rows='15' cols='100' name='NewAttributeValue'>" . htme($tmp_new_val) . "</textarea>";
			} elseif (stristr(base64_decode($_REQUEST['EditAttribute']), "numof")) {
				print "<input type='text' name='NewAttributeValue' size='5' id='JS_NewAttributeValue' value='" . htme($tmp_new_val) . "'>";

			} elseif ($_REQUEST['EditAttribute']) {
				print "<input type='text' name='NewAttributeValue' size='50' id='JS_NewAttributeValue' value='" . htme($tmp_new_val) . "'>";
			}
		}
		if ($_REQUEST['OpenDirect']) {
			print "<input type='hidden' name='close_on_next_load' value='1'>";
		}
		if ($_REQUEST['EditAttribute']) {
			print "&nbsp;<input type='submit' value='Save'>";
		}
		if (!isset($_REQUEST['EditAttribute'])) {
			$t = GetAttribute($item, "%", $_REQUEST['EditAttributes']);

			$tmp = GetMissingAttributes($item, $_REQUEST['EditAttributes']);
			for ($x=0;$x<=sizeof($tmp);$x++) {
				if (array_key_exists($tmp[$x], $t)) {
					unset($tmp[$x]);
				}
			}

			

			print "<table class='crm filtertable crmclick'><thead><tr><th>Attribute name</th><th>Value</th><th>Description</th><th class=\"cntr\">Delete</th></tr></thead>";
			print '<tbody>';
			foreach ($t AS $field => $value) {
				$toshow = "";
				if ($tmp = unserialize($value)) {
					$nf = false;
					foreach ($tmp AS $key => $val) {
						$toshow .= ($nf) ? ", " : "";
						if ($val) {
							$toshow .= $val;
						} else {
							$toshow .= $key;
						}
						$nf = true;

					}
				} else {
					$toshow = $value;
				}
				$href1 = "";

				if ($field == "LastLogin" || $field == "LastLogout" || $field == "LastActivity") {
					$toshow = TransFormDate(date('d-m-Y', $toshow)) . " " . date('H:i', $toshow);
				}
				$doc = "";
				foreach ($atdocs AS $key => $value) {
					if (strstr($field, $key)) {
						$doc = $atdocs[$key][1];
					} 
				}
				if (!is_array($tmp)) {
					$href1 = " onclick=\"PopFancyBoxLarge('','attribute.php?EditAttribute=" . htme(base64_encode($field)) . "&amp;ParentReference=" . htme($item) . "&amp;EditAttributes=" . htme($_REQUEST['EditAttributes']) . "');\"";
				}
				print "<tr" . $href1 . "><td>" . $field . "</td><td>" .  fillout(htme($toshow),40,true) .   "</td><td>" .  $doc .  "</td><td class='cntr'><a href='attribute.php?nonavbar=1&amp;EditAttributes=" . $_REQUEST['EditAttributes'] . "&amp;DeleteAttribute=" . base64_encode($field) . "&amp;ParentReference=" . $item . "'><span class=\"fa fa-times\"></span></a></td></tr>";
			}

			print '</tbody>';
			print "</table>";
		}
		print "</form>";

}
EndHTML();

?>
