<?php

/*

CalendarServer example

This server features CalDAV support

*/
exit;

$path = explode("/", $_SERVER['PATH_INFO']);
$GLOBALS['overriderepository'] = $path[1];

$GLOBALS['REALMAUTH'] = true;
require_once "initiate.php";

function qlog_caldav($msg) {
	qlog(INFO, $msg);

}

qlog_caldav( "DAV Init, method:" . $_SERVER['REQUEST_METHOD'] . " " . str_replace("\n", "", string_r($_REQUEST)));
//$GLOBALS['LOGTEXT'] = false;
qlog_caldav( "DAV Init repository " . $GLOBALS['overriderepository']);

// settings
date_default_timezone_set('Canada/Eastern');

$baseUri = '';

// If you want to run the SabreDAV server in a custom location (using mod_rewrite for instance)
// You can override the baseUri here.
// $baseUri = '/';

/* Database */
// $pdo = new PDO('sqlite:data/db.sqlite');
$pdo = new PDO('mysql:host=localhost;dbname=CRMSTAGE', "crm", "crm_pwd");
$pdo->setAttribute(PDO::ATTR_ERRMODE,PDO::ERRMODE_EXCEPTION);
$pdo->calendarTableName = "bestatniet";

//Mapping PHP errors to exceptions
function exception_error_handler($errno, $errstr, $errfile, $errline ) {
    throw new ErrorException($errstr, 0, $errno, $errfile, $errline);
}
set_error_handler("exception_error_handler");

// Files we need
require_once 'lib/sabre/vendor/autoload.php';

// Backends
//$authBackend = new Sabre\DAV\Auth\Backend\PDO($pdo, "CRMcaldavusers");


use Sabre\DAV\Auth;



$calendarBackend = new Sabre\CalDAV\Backend\PDO($pdo);
$principalBackend = new Sabre\DAVACL\PrincipalBackend\PDO($pdo);

// Directory structure
$tree = [
    new Sabre\CalDAV\Principal\Collection($principalBackend),
    new Sabre\CalDAV\CalendarRootNode($principalBackend, $calendarBackend),
];

$server = new Sabre\DAV\Server($tree);

if (isset($baseUri))
    $server->setBaseUri($baseUri);

/* Server Plugins */
//$authPlugin = new Sabre\DAV\Auth\Plugin($authBackend,'SabreDAV');
// Creating the backend
$authBackend = new Auth\Backend\Apache();

// Creating the plugin. The realm parameter is ignored by the backend
$authPlugin = new Auth\Plugin($authBackend,'SabreDAV');
$server->addPlugin($authPlugin);

$aclPlugin = new Sabre\DAVACL\Plugin();
$server->addPlugin($aclPlugin);

/* CalDAV support */
$caldavPlugin = new Sabre\CalDAV\Plugin();
$server->addPlugin($caldavPlugin);

/* Calendar subscription support */
$server->addPlugin(
    new Sabre\CalDAV\Subscriptions\Plugin()
);


// Support for html frontend
$browser = new Sabre\DAV\Browser\Plugin();
$server->addPlugin($browser);

// And off we go!
$server->exec();
