<?php
/* ********************************************************************
 * Interleave
 * Copyright (c) 2001-2016 Hidde Fennema (info@crm-ctt.com)
 * Licensed under the GNU GPL. For full terms see http://www.gnu.org/
 *
 * config-vars.php: this script should only contain variable declarations
 * IT SHOULD CONTAIN NO PROGRAM LOGIC WHATSOVER AND IT MAY NOT GENERATE
 * ANY OUTPUT!
 *
 * Check http://www.interleave.nl/en/ for more information
 **********************************************************************

 This is not the Interleave config file. There is no need to adjust these
 settings for normal use. Only alter variables for debug use.

 Important:

 ->  For all file logging you need to have a file called "qlist.txt" in your  <-
 ->  Interleave installation directory which is writeable by the user under   <-
 ->  which your webserver runs.                                               <-

-->  Please be aware that all debug functions compromise security.            <--

*/

// Some PHP initial settings
// (mostly not allowed to change but trying won't hurt)

ini_set("magic_quotes_gpc","Off");							// Try to turn off magic quotes
ini_set("magic_quotes_runtime","Off");						// Try to turn off magic quotes runtime
error_reporting(E_ERROR);									// Try to set error reporting to errors only

define("CACHE", 1);											// Cache hits + the rest (e.g. *all* messaages) (quite useless)
define("INFO", 2);											// Informative, warnings and errors (e.g. all but CACHE)
define("WARNING", 3);										// Warnings and errors (access descisions are treated as warnings)
define("ERROR", 4);											// Only errors (start here)
define("DEBUG", 99);										// WARNING and ERROR messages and messages called with DEBUG log level (for development only)

// Easy debug options
$GLOBALS['logtext']						= false;			// CACHE, INFO, WARNING, ERROR or DEBUG (see above)
$GLOBALS['logrequests']					= false;			// Logs all requestst to querylog.txt
$GLOBALS['qlog_onscreen']				= false;			// Displays pop-up containing logtext log.
$GLOBALS['ShowTraceLink']				= false;			// Displays qlog trace link at end of page (same 25% slower as 'logtext').
$GLOBALS['log_slowest_query']			= false;			// Logs slowest SQL query of a page. logtext needs te be enabled.

// Advanced debug options
$GLOBALS['logqueries']					= false;			// Logs all queries (10% slower) - a file called querylog.txt must exist and it must be writable

// Security options

// To enable login try count (temporary block an IP after 10 failed attempts from the same IP) add 
// an empty *readable and writeable* file called "logins.txt" in the main installation directory 
// and set the variable below for notification.
if ($GLOBALS['LoginTryCountNotifyTo'] == "") {
	$GLOBALS['LoginTryCountNotifyTo']		= false;			// replace with "example@my-server.com"
}

// Insane debug options
$GLOBALS['ShowFunctionTrace']			= false;			// Adds complete backtrace to each qlog/logtext call. Adds ~5000 loglines per page load.

$GLOBALS['AUTHOR']						= "Hidde Fennema";
if ($GLOBALS['Overrides']['ProductName'] == "" || strstr($GLOBALS['Overrides']['ProductName'], " ")) {
	$GLOBALS['PRODUCT']						= "Interleave";		// Product name
} else {
	$GLOBALS['PRODUCT'] = $GLOBALS['Overrides']['ProductName'];
}

?>
