<?php
/* ********************************************************************
 * Interleave
 * Copyright (c) 2001-2016 Atomos Applications The Netherlands - www.atomos.nl - info@atomos.nl - www.interleave.nl - info@interleave.nl
 * Licensed under the GNU GPL. For full terms see the file COPYING.
 *
 * This file contains all database-type-specific functions
 *
 * Check http://www.interleave.nl/ for more information
 *
 * BUILD / RELEASE :: 7.0.20161227
 *
 **********************************************************************
 */
if (isset($_REQUEST['CorrectTablesAndFields'])) {
    require 'initiate.php';
    ShowHeaders();
    if (is_administrator()) {
        AdminTabs();
        echo '<h1>Fix all table comments and field types</h1>';

        if ($_REQUEST['go'] == 1) {
            echo '<h2>Following queries were ran</h2>';
            echo '<pre>';
            add_comments_to_tables_and_fields_and_alter_fields_to_correct_type(true, true, false, 'mysql');
            echo '</pre>';
        } else {
            echo '<h2>Following queries will be ran</h2>';
            echo '<pre>';
            add_comments_to_tables_and_fields_and_alter_fields_to_correct_type(true, true, true, 'mysql');
            echo '</pre>';
            echo '<a href="dbupgrade.php?CorrectTablesAndFields&SkipMainNavigation&amp;go=1">Run these queries now</a>';
        }
    }
    EndHTML();
}
require_once 'adminfunctions.php';
function IntermediateDatabaseUpgrade2()
{
    if ($GLOBALS['DontUpgradeTheDatabase']) {
        return true;
    }

    if (GetSetting('DBVERSION') < '5.5.0.4') {
        PrintAD('The database and software version are not the same. Use upgrade.php to upgrade.');
    } else {

        /* LATEN STAAN: dit is bewust. *mocht* er een query crashen tijdens de upgrade, dan ligt een hele applicatie eruit. */
        //$GLOBALS['allowed_number_of_mysql_crashes'] = 15;

        // =========================================================================================================================================== LANGUAGE TAGS

        // Language tags which need to be added per language. If the tag already exists it will not be overwritten.

        $language_tags = array();

        //"langtag" => "text for language tag",
        $language_tags['ENGLISH'] = array(
            'allowed' => 'allowed',
            'notallowed' => 'denied',
            'dependenciespreventtheremovalofthisrecord' => 'Dependencies prevent the removal of this record',
        );

        $language_tags['NEDERLANDS'] = array(
            'allowed' => 'toegestaan',
            'notallowed' => 'niet toegestaan',
            'dependenciespreventtheremovalofthisrecord' => 'Vanwege afhankelijkheden is het niet mogelijk dit record te verwijderen',
        );
        $language_tags['FRANCAIS'] = array(
            'allowed' => 'admis',
            'notallowed' => 'non admis',
            'dependenciespreventtheremovalofthisrecord' => 'Cet enregistrement ne peut pas être supprimé',
        );

        // =========================================================================================================================================== DROP INDICES

        // Drop indices(when they exist)
        // WATCH IT! Indices are dropped by NAME, not by set of fields

        $dropindices = array(
                array('binfiles', 'extractedascii'),
                array('journal', 'eid'),
                array('journal', 'eid_2'),
                array('journal', 'eid_3'),
                array('journal', 'eid_4'),
                array('journal', 'eid_5'),
                array('journal', 'eid_6'),
                array('journal', 'eid_7'),
                array('journal', 'eid_8'),
                array('journal', 'eid_9'),
                array('journal', 'eid_10'),
                array('journal', 'user'),
                array('journal', 'timestamp'),
                array('journal', 'type'),
                array('journal', 'type_2'),
                array('entitylocks', 'lockon_lockby_locktable'),
                array('entitylocks', 'lockon'),
                array('mailqueue', 'status_2'),
                array('mailqueue', 'flextableid_2'),
                array('mailqueue', 'flextablerecord_2'),
                array('mailqueue', 'entity_2'),
                array('mailqueue', 'worker_hash_2'),
                array('mailqueue', 'customer_2'),
                array('mailqueue', 'user_2'),
        );

        // Drop all "plain" indices on 'deleted' and 'refer'. We add 'refer' later on in combination with 'deleted', which is faster
        foreach (db_GetArray('SELECT recordid FROM CRMflextabledefs') as $ft) {
            $dropindices[] = array('flextable'.$ft['recordid'], 'refer');
            $dropindices[] = array('flextable'.$ft['recordid'], 'deleted');
        }

        // Drop all deleted_refer
        foreach (db_GetArray('SELECT recordid FROM CRMflextabledefs') as $ft) {
            $dropindices[] = array('flextable'.$ft['recordid'], 'deleted_refer');
        }

        // Drop all indices on ref-to-flex fields (because later on we re-create them including the deleted field)
        foreach (db_GetArray("SELECT tabletype, fieldtype, id FROM CRMextrafields WHERE deleted='n' AND fieldtype IN ('Reference to FlexTable','User-list of all CRM-CTT users','User-list of administrative CRM-CTT users', 'List of all groups', 'date/time')") as $field) {
            if (is_numeric($field['tabletype'])) {
                $field['tabletype'] = 'flextable'.$field['tabletype'];
            } elseif ($field['tabletype'] == 'user') {
                $field['tabletype'] = 'loginusers';
            } elseif ($field['tabletype'] == 'group') {
                $field['tabletype'] = 'userprofiles';
            } elseif ($field['tabletype'] == 'files') {
                $field['tabletype'] = 'binfiles';
            }

            if (substr($field['tabletype'], 0, 9) == 'flextable') { // flextable
                $dropindices[] = array($field['tabletype'], 'EFID'.$field['id']);
                $dropindices[] = array($field['tabletype'], 'EFID'.$field['id'].'_deleted');
            }
        }

        // =========================================================================================================================================== CREATE TABLES

        // Tables in the $newtables array will be created if they don't exist already

        $newtables = array(
            array('stats', "CREATE TABLE `CRMstats` ( `item` varchar(20) NOT NULL, `value` varchar(1024) NOT NULL, `count` int(11) NOT NULL, `sum` FLOAT NOT NULL, `avg` FLOAT NOT NULL, `timestamp_last_change` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Interleave statistics table'"),

            array('datastructures', " CREATE TABLE `CRMdatastructures` (`userid` int(11) NOT NULL, `datastructure` LONGTEXT NOT NULL, `timestamp_last_change` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP, PRIMARY KEY (`userid`)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Interleave data structure table'"),

            //array("extendedprivsuser", "CREATE TABLE `CRMextendedprivsuser` (`id` int(11) NOT NULL AUTO_INCREMENT, `userid` int(11) NOT NULL, `field` int(11) NOT NULL, `value` varchar(300) NOT NULL, `rule` enum('readonly','invisible') NOT NULL DEFAULT 'invisible',  `operand` enum('IS', 'IS NOT') NOT NULL DEFAULT 'IS', `timestamp_last_change` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP, PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Interleave extended privileges table for users'"),

            array('extendedprivsgroup', "CREATE TABLE `CRMextendedprivsgroup` (`id` int(11) NOT NULL AUTO_INCREMENT, `groupid` int(11) NOT NULL, `field` int(11) NOT NULL, `value` varchar(300) NOT NULL, `rule` enum('readonly','invisible') NOT NULL DEFAULT 'invisible', `operand` enum('IS', 'IS NOT') NOT NULL DEFAULT 'IS', `timestamp_last_change` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP, PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Interleave extended privileges table for groups'"),

            //array("tableaccessrights", "CREATE TABLE `CRMtableaccessrights` (  `id` int(11) NOT NULL AUTO_INCREMENT,  `group` int(11) NOT NULL DEFAULT '0',  `table` int(11) NOT NULL,  `read` enum('0', '1') NOT NULL DEFAULT '0',  `write` enum('0', '1') NOT NULL DEFAULT '0',  `add` enum('0', '1') NOT NULL DEFAULT '0',  `delete` enum('0', '1') NOT NULL DEFAULT '0',  `timestamp_last_change` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,  PRIMARY KEY (`id`)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Table access rights'"),

            array('rules', "CREATE TABLE `CRMrules` (  `id` int(11) NOT NULL AUTO_INCREMENT,  `enabled` enum('Yes', 'No') NOT NULL DEFAULT 'Yes', `table` VARCHAR(15), `name` VARCHAR(1024) NOT NULL,  `remarks` longtext NOT NULL, `timestamp_last_change` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP, PRIMARY KEY (`id`)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Interleave rules'"),

            array('ruleconditions', "CREATE TABLE `CRMruleconditions` (  `id` int(11) NOT NULL AUTO_INCREMENT,  `rule` int(11) NOT NULL, `enabled` enum('Yes', 'No') NOT NULL DEFAULT 'Yes',`condition` VARCHAR(50) NOT NULL,  `field` VARCHAR(1024) NOT NULL,  `matchvalue` VARCHAR(1024) NOT NULL, `timestamp_last_change` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP, PRIMARY KEY (`id`)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Interleave rule conditions'"),

            array('ruleactions', "CREATE TABLE `CRMruleactions` (  `id` int(11) NOT NULL AUTO_INCREMENT, `rule` int(11) NOT NULL, `enabled` enum('Yes', 'No') NOT NULL DEFAULT 'Yes', `action` VARCHAR(50) NOT NULL,  `field` VARCHAR(1024) NOT NULL,  `template` int(11) NOT NULL,  `attach` VARCHAR(15) NOT NULL,  `attach_matchvalue` VARCHAR(1024) NOT NULL,  `value` VARCHAR(8196) NOT NULL, `module_to_run` int(11) NOT NULL, `message_to_display` VARCHAR(1024) NOT NULL, `timestamp_last_change` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP, PRIMARY KEY (`id`)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Interleave rule actions'"),

            array('ruleactionconditions', "CREATE TABLE `CRMruleactionconditions` (  `id` int(11) NOT NULL AUTO_INCREMENT,  `ruleaction` int(11) NOT NULL, `enabled` enum('Yes', 'No') NOT NULL DEFAULT 'Yes',`condition` VARCHAR(50) NOT NULL,  `field` VARCHAR(1024) NOT NULL,  `matchvalue` VARCHAR(1024) NOT NULL, `timestamp_last_change` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP, PRIMARY KEY (`id`)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Interleave rule action conditions'"),

            array('calendars', "CREATE TABLE `CRMcalendars` (  `id` int(11) NOT NULL AUTO_INCREMENT,  `timestamp_last_change` timestamp NOT NULL DEFAULT '0000-00-00 00:00:00' ON UPDATE CURRENT_TIMESTAMP,  `deleted` enum('n','y') NOT NULL,  `description` varchar(255) NOT NULL,  `ref_start_date_time` VARCHAR(20) NOT NULL,  `ref_end_date_time` VARCHAR(20) NOT NULL,  `appointment_click_action` enum('None','Open record in popup','Open record in current window') NOT NULL,  `time_slots_in_week_view` enum('Yes','No') NOT NULL DEFAULT 'Yes',  `show_calendar_in_legend` enum('Yes','No') NOT NULL DEFAULT 'Yes',  `summary` varchar(512) NOT NULL DEFAULT '', `ref_organiser` varchar(20) NOT NULL,  `resource` varchar(1024) NOT NULL,  `comment` varchar(1024) NOT NULL,  `location` varchar(1024) NOT NULL,  `display_popup` enum('Yes','No') NOT NULL DEFAULT 'Yes',  `minutes_before_csv` varchar(50) NOT NULL DEFAULT '30,15,0',  `color_in_legend` varchar(7) NOT NULL, `calendar_object` varchar(15) NOT NULL, PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Interleave calendar definitions'"),

            array('tableaccessrules', "CREATE TABLE `CRMtableaccessrules` (  `id` int(11) NOT NULL AUTO_INCREMENT,  `enabled` enum('Yes', 'No') NOT NULL DEFAULT 'Yes', `table` int(11), `description` VARCHAR(1024) NOT NULL, `group` int(11), `read` enum('0','1') DEFAULT '0', `write` enum('0','1') DEFAULT '0', `add` enum('0','1') DEFAULT '0', `delete` enum('0','1') DEFAULT '0', `timestamp_last_change` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP, PRIMARY KEY (`id`)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Interleave table access rules'"),

            array('moduleaccessrules', "CREATE TABLE `CRMmoduleaccessrules` (  `id` int(11) NOT NULL AUTO_INCREMENT,  `enabled` enum('Yes', 'No') NOT NULL DEFAULT 'Yes', `module` int(11), `description` VARCHAR(1024) NOT NULL, `group` int(11), `execute` enum('0','1') DEFAULT '0', `timestamp_last_change` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP, PRIMARY KEY (`id`)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Interleave module access rules'"),

            array('fieldaccessrules', "CREATE TABLE `CRMfieldaccessrules` (  `id` int(11) NOT NULL AUTO_INCREMENT,  `enabled` enum('Yes', 'No') NOT NULL DEFAULT 'Yes', `field` int(11), `description` VARCHAR(1024) NOT NULL, `group` int(11), `read` enum('0','1') DEFAULT '0', `write` enum('0','1') DEFAULT '0', `timestamp_last_change` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP, PRIMARY KEY (`id`)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Interleave field access rules'"),

            array('calendaraccessrules', "CREATE TABLE `CRMcalendaraccessrules` (  `id` int(11) NOT NULL AUTO_INCREMENT,  `enabled` enum('Yes', 'No') NOT NULL DEFAULT 'Yes', `calendar` int(11), `description` VARCHAR(1024) NOT NULL, `group` int(11), `read` enum('0','1') DEFAULT '0', `timestamp_last_change` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP, PRIMARY KEY (`id`)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Interleave calendar access rules'"),

            array('templateaccessrules', "CREATE TABLE `CRMtemplateaccessrules` (  `id` int(11) NOT NULL AUTO_INCREMENT,  `enabled` enum('Yes', 'No') NOT NULL DEFAULT 'Yes', `template` int(11) NOT NULL DEFAULT 0, `description` VARCHAR(1024) NOT NULL, `group` int(11) NOT NULL DEFAULT 0, `read` enum('0','1') NOT NULL DEFAULT '0', `write` enum('0','1') NOT NULL DEFAULT '0', `timestamp_last_change` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP, PRIMARY KEY (`id`)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Interleave template access rules'"),

            array('downloadrules', "CREATE TABLE `CRMdownloadrules` ( `id` INT NOT NULL AUTO_INCREMENT , `table` INT NOT NULL , `group` INT NOT NULL , `max_rows` INT NOT NULL , `timestamp_last_change` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP , PRIMARY KEY (`id`)) ENGINE = InnoDB DEFAULT CHARSET=utf8 COMMENT = 'Interleave download rules'"),

            );

        // =========================================================================================================================================== DROP TABLES

        // Tables to drop (when they exist)

        $droptables = array('phonebook', 'webdav_locks', 'webdav_properties', 'searchindex', 'help', 'failoverquerystore', 'calendar', 'breadcrumtrail', 'contactmoments', 'extendedprivs', 'configsnapshots', 'accesscache', 'extendedprivsuser', 'tableaccessrights', 'triggers', 'triggerconditions', 'publishedpages', 'publishedpagescache', 'entity', 'customer', 'priorityvars', 'statusvars', 'entityformcache', 'tabmenudefinitions');

        //, "calendaraccessrules", "templateaccessrules", "calendars"
        // =========================================================================================================================================== CREATE COLUMNS

        // Columns in this array will be added to a table if they don't exist, and the
        // table will be altered if they DO exist but have some other type.

        /*
            WARNING: use the exact output of SHOW CREATE TABLE because these field definitions
            will be compared to that output.

            WRONG:

                enum('n','y') DEFAULT 'n' NOT NULL

                enum('AND', 'OR')

            RIGHT:

                enum('n','y') NOT NULL DEFAULT 'n'

                enum('AND','OR')

        */

        $fields = array(
            array('blobs', 'content', 'longblob NOT NULL'),
            array('binfiles', 'folder', 'int(11) NOT NULL'),
            array('attributes', 'entity', 'int(11) NOT NULL'),
            array('flextabledefs', 'listtemplate', 'int(11) NOT NULL'),
            array('extrafields', 'log_stats', "enum('n','y') NOT NULL DEFAULT 'n'"),
            array('todo', 'worker_hash', 'varchar(64) NOT NULL'),
            array('mailqueue', 'attach_to_dossier', "enum('','both','entity','customer') NOT NULL"),
            array('mailqueue', 'attach_as_filename', 'varchar(250) NOT NULL'),
            array('mailqueue', 'files_to_attach', 'longtext NOT NULL'),
            array('binfiles', 'offloaded', "enum('n','y') NOT NULL"),
            array('templates', 'page_id', 'VARCHAR(100) NOT NULL'),
            array('mailqueue', 'parse', "enum('y','n') NOT NULL DEFAULT 'y'"),
            array('languages', 'TEXT', 'VARCHAR(255) NOT NULL'),
            array('languages', 'TEXTID', 'VARCHAR(60) NOT NULL'),
            array('flextabledefs', 'sumnumrows', "enum('n','y') NOT NULL DEFAULT 'n'"),
            array('userprofiles', 'HIDEFROMASSIGNEEANDOWNERLISTS', "enum('n','y') NOT NULL DEFAULT 'n'"),
            array('sessions', 'timestamp_last_change', 'timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP'),
            array('internalmessages', 'shown_in_popup', "enum('n','y') NOT NULL DEFAULT 'n'"),
            array('extendedprivsgroup', 'field', 'int(11) NOT NULL'),
            //array("extendedprivsuser", "field", "int(11) NOT NULL"), // table is gedropped
            array('loginusers', 'name', 'VARCHAR(255) NOT NULL'), // is nu 50
            array('loginusers', 'EMAIL', 'VARCHAR(255) NOT NULL'), // is nu 150
            array('extrafields', 'binfilefield_for_table', 'VARCHAR(4) NOT NULL'),
            array('templates', 'version_belonging_to', 'int(11) NOT NULL'),
            array('modules', 'version_belonging_to', 'int(11) NOT NULL'),
        //	array("stats", "id", "int(11) NOT NULL AUTO_INCREMENT PRIMARY KEY FIRST"),
            array('extrafields', 'calculation', 'LONGTEXT NOT NULL'),
            array('flextabledefs', 'ordering', 'int(11) NOT NULL'),
            array('flextabledefs', 'comment', 'LONGTEXT NOT NULL'),
            array('rules', 'operator', "enum('AND','OR') NOT NULL DEFAULT 'AND'"),
            array('rules', 'log_passed', "enum('Yes','No') NOT NULL DEFAULT 'Yes'"),
            array('rules', 'log_failed', "enum('Yes','No') NOT NULL DEFAULT 'Yes'"),
            array('ruleactions', 'operator', "enum('AND','OR') NOT NULL DEFAULT 'AND'"),
            array('extendedprivsgroup', 'only_apply_for_field', "int(11) NOT NULL DEFAULT '0'"),
            array('calendars', 'listoptions', 'VARCHAR(2048) NOT NULL'),

            array('stats', 'timestamp_last_change', 'timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP'),
            array('datastructures', 'timestamp_last_change', 'timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP'),
            array('extendedprivsgroup', 'timestamp_last_change', 'timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP'),
            array('rules', 'timestamp_last_change', 'timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP'),
            array('ruleconditions', 'timestamp_last_change', 'timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP'),
            array('ruleactions', 'timestamp_last_change', 'timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP'),
            array('ruleactionconditions', 'timestamp_last_change', 'timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP'),
            array('calendars', 'timestamp_last_change', 'timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP'),
            array('tableaccessrules', 'timestamp_last_change', 'timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP'),
            array('moduleaccessrules', 'timestamp_last_change', 'timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP'),
            array('fieldaccessrules', 'timestamp_last_change', 'timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP'),
            array('calendaraccessrules', 'timestamp_last_change', 'timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP'),

            array('templateaccessrules', 'timestamp_last_change', 'timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP'),

            array('templateaccessrules', 'group', 'int(11) NOT NULL'),
            array('templateaccessrules', 'template', 'int(11) NOT NULL'),
            array('templateaccessrules', 'read', "enum('0','1') NOT NULL DEFAULT '0'"),
            array('templateaccessrules', 'write', "enum('0','1') NOT NULL DEFAULT '0'"),

            array('ruleactions', 'alternate_from_address', 'VARCHAR(512) NOT NULL'),
            array('calendars', 'sortorder', 'int(11) NOT NULL'),
            array('calendars', 'show_add_option', "enum('No','Yes') NOT NULL"),
            array('calendars', 'add_option_url_extras', 'VARCHAR(1024) NOT NULL'),

            array('ruleactions', 'order', 'int(11) NOT NULL'),
            array('ruleactions', 'remarks', 'LONGTEXT NOT NULL'),

            array('templates', 'template_subject', 'VARCHAR(2048) NOT NULL'),

            array('mailqueue', 'table', 'VARCHAR(15) NOT NULL'),
            array('extendedprivsgroup', 'visual_only', "enum('n','y') NOT NULL DEFAULT 'n'"),
            array('binfiles', 'coordinates', 'VARCHAR(40) NOT NULL'),

            array('attributes', 'allowed_values', "VARCHAR(2048) NOT NULL DEFAULT ''"),

            array('extrafields', 'calculation_type', "enum('database trigger','calculated on display') NOT NULL DEFAULT 'database trigger'"),

        );

        // =========================================================================================================================================== DROP COLUMNS

        // Drop fields (when they exist)
        // should be array(array("entity", "eid"))

        $dropfields = array(
            array('loginusers', 'show_only_once_message'),
            array('entitylocks', 'lockepoch'),
            array('entitylocks', 'lockid'),
            array('loginusers', 'type'),
            array('loginusers', 'exptime'),
            array('loginusers', 'openidurl'),
            array('loginusers', 'noexp'),
            array('loginusers', 'RECEIVEDAILYMAIL'),
            array('loginusers', 'RECEIVEALLOWNERUPDATES'),
            array('loginusers', 'RECEIVEALLASSIGNEEUPDATES'),
            array('loginusers', 'HIDEPBTAB'),
            array('loginusers', 'HIDECSVTAB'),
            array('loginusers', 'USEDASHBOARDASENTRY'),
            array('loginusers', 'DASHBOARDCACHE'),
            array('loginusers', 'IMPORTANTENTITIES'),
            array('loginusers', 'HIDEOVERDUEFROMDUELIST'),
            array('loginusers', 'personal_data_structure'),
            array('flextabledefs', 'users_may_select_columns'),
            array('userprofiles', 'RECEIVEALLOWNERUPDATES'),
            array('userprofiles', 'RECEIVEDAILYMAIL'),
            array('userprofiles', 'RECEIVEALLASSIGNEEUPDATES'),
            array('userprofiles', 'RECEIVEALLOWNERUPDATES'),
            array('userprofiles', 'HIDECSVTAB'),
            array('userprofiles', 'HIDESUMMARYTAB'),
            array('loginusers', 'HIDESUMMARYTAB'),
            array('userprofiles', 'HIDEENTITYTAB'),
            array('loginusers', 'HIDEENTITYTAB'),
            array('userprofiles', 'HIDEPBTAB'),
            array('userprofiles', 'HIDECUSTOMERTAB'),
            array('loginusers', 'HIDECUSTOMERTAB'),
            array('loginusers', 'HIDEOVERDUEFROMDUELIST'),
            array('calendars', 'accessarray'),
            array('tableaccessrules', 'add_child'),
            array('userprofiles', 'FORCESTARTFORM'),
            array('userprofiles', 'FORCEFORM'),
            array('userprofiles', 'LIMITTOCUSTOMERS'),
            array('userprofiles', 'FORCEUSERCLLIMIT'),
            array('userprofiles', 'ENTITYACCESSEVALMODULE'),
            array('userprofiles', 'CUSTOMERACCESSEVALMODULE'),
            array('userprofiles', 'ELISTLAYOUT'),
            array('userprofiles', 'CLISTLAYOUT'),
            array('userprofiles', 'SHOWDELETEDVIEWOPTION'),
            array('userprofiles', 'ADDFORMS'),
            array('userprofiles', 'ALLOWEDADDFORMS'),
            array('userprofiles', 'ALLOWEDSTATUSVARS'),
            array('userprofiles', 'ALLOWEDPRIORITYVARS'),
            array('userprofiles', 'BOSS'),
            array('userprofiles', 'SAVEDSEARCHES'),
            array('userprofiles', 'EMAILCREDENTIALS'),
            array('userprofiles', 'USERSPECTRUM'),
            array('userprofiles', 'parent_profile'),
            array('loginusers', 'LIMITTOCUSTOMERS'),
            array('loginusers', 'FORCESTARTFORM'),
            array('loginusers', 'FORCEFORM'),
            array('loginusers', 'ENTITYACCESSEVALMODULE'),
            array('loginusers', 'CUSTOMERACCESSEVALMODULE'),
            array('loginusers', 'ELISTLAYOUT'),
            array('loginusers', 'CLISTLAYOUT'),
            array('loginusers', 'SHOWDELETEDVIEWOPTION'),
            array('loginusers', 'ADDFORMS'),
            array('loginusers', 'ALLOWEDADDFORMS'),
            array('loginusers', 'ALLOWEDSTATUSVARS'),
            array('loginusers', 'ALLOWEDPRIORITYVARS'),
            array('loginusers', 'BOSS'),
            array('loginusers', 'LASTFILTER'),
            array('loginusers', 'LASTSORT'),
            array('loginusers', 'HIDEADDTAB'),
            array('flextabledefs', 'orientation'),
            array('flextabledefs', 'refers_to'),
            array('flextabledefs', 'table_default_reflayout'),
            array('flextabledefs', 'access_controlled_by_field'),
            array('flextabledefs', 'access_denied_method'),
            array('flextabledefs', 'table_layout'),
            array('flextabledefs', 'compact_view'),
            array('flextabledefs', 'skip_security'),
            array('flextabledefs', 'exclude_from_rep'),
            array('flextabledefs', 'accessarray'),
            array('flextabledefs', 'showfilters'),
            array('modules', 'module_accessarray'),
            array('extrafields', 'accessarray'),

        );
        foreach (db_GetArray('SELECT recordid FROM CRMflextabledefs') as $ft) {
            $dropfields[] = array('flextable'.$ft['recordid'], 'readonly');
            $dropfields[] = array('flextable'.$ft['recordid'], 'refer');
            $dropfields[] = array('flextable'.$ft['recordid'], 'formid');
            $dropfields[] = array('flextable'.$ft['recordid'], 'referfield');
        }

        // =========================================================================================================================================== DELETE SETTINGS

        // Settings to drop
        // should be array("SETTINGNAME1", "SETTINGNAME2"))

        $dropsettings = array();
        $dropsettings[] = 'HIDEPBTAB';
        $dropsettings[] = 'EmailNewEntities';
        $dropsettings[] = 'BODY_DUEDATE';
        $dropsettings[] = 'ShowNumOfAttachments';
        $dropsettings[] = 'ShowEmailButton';
        $dropsettings[] = 'ShowMainPageCalendar';
        $dropsettings[] = 'BODY_ENTITY_CUSTOMER_ADD';
        $dropsettings[] = 'UseWaitingAndDoesntBelongHere';
        $dropsettings[] = 'DisableCommentField';
        $dropsettings[] = 'DefaultVAT';
        $dropsettings[] = 'subject_new_entity';
        $dropsettings[] = 'subject_customer_couple';
        $dropsettings[] = 'subject_alarm';
        $dropsettings[] = 'ENABLE_SUBSCRIPTIONS';
        $dropsettings[] = 'SYNC_TIMEOUT';
        $dropsettings[] = 'ShowDefaultPDFReport';
        $dropsettings[] = 'InputNumbersWithSeperators';

        // =========================================================================================================================================== ATTRIBUTES

        // Attribute settings
        // Add settings here to add them to the global setting attribute list
        // Fetch system attributes with $val = GetAttribute("system", {{{SETTINGNAME]}}, 2) or with GetSetting("{{{SETTINGNAME]}}");

        $attribute_settings = array('UserImportTableHTML', '', '', 'DefaultExcel2007FontSize|11|12|13|14|15|16|17|18|19|20', 'DefaultExcel2007Font|Tahoma|Arial|Helvetica|Times New Roman', 'AllowFoldersInFilelists|Yes|No', 'NumberOfModuleToIncludeInAllPageloads', 'SendundeliverableEmailsToEmailAddress', 'ExcludeGroupsFromUserManagementCSV', 'DevelopmentOrProduction|Development|Production', "OffloadFilesPolicy|Don't offload files to disk|After a year|After 6 months|After 3 months|After 1 month|After 1 week|After 1 day", 'OffloadFilesURL', 'OffloadLocalPath', 'OffLoadedFilesDirectoryHash', 'OffLoadedFilesSSLKey', 'UseSkinCSS|No|Yes|Apple|Black and blue|Dark', 'ModuleToEvaluateOnEveryListBuild', 'HighlightSearchesInForms|Yes|No', 'TemplateNoOfJavascriptFileToIncludeInEveryPage', 'MobileInterfaceEnabled|No|Yes', 'TwoPhaseAuthenticationModuleNum', 'TwoPhaseAuthenticationRequired|None|Every time|Unknown IP|First login', 'RequireTwoPhaseAuthenticationForEveryOne|No|Yes', 'RequireTwoPhaseAuthenticationPerIPForAdmins|No|Yes', 'TwoPhaseAuthenticationTrustAllLocalIPRanges|No|Yes', 'DefaultPhoneNumberCountryCode', 'ImageThumbailCopyrightMessage', 'UseBrowserPreferredLanguage|No|Yes', 'UseURLBeautification|No|Yes', 'ShortName', 'WebAppEnabled|No|Yes', 'AddressToSendAllMailsToWhenInDevelopmentMode', 'WebAppThemeColor', 'WebAppBackgroundColor');

        $attribute_options_adjust = array(
                                'AvailableViews' => array('month,week,day', 'month,week,day,multiweek', 'month,week', 'month,week,multiweek', 'month,day', 'month,day,multiweek', 'week,day', 'week,day,multiweek', 'month', 'week', 'day', 'multiweek'),
                                'UseSkinCSS' => array('No', 'Yes', 'Apple', 'Black and blue', 'Dark'),
                            );

        // ===========================================================================================================================================
        // ===========================================================================================================================================
        // ===========================================================================================================================================
        // ================================================== End configurable section ===============================================================
        // ===========================================================================================================================================
        // ===========================================================================================================================================
        // ===========================================================================================================================================

        $version_when_done = $GLOBALS['VERSION'];

        echo '<pre>';
        //PerformDatabaseMaintenance(true);

        echo '</pre>';

        // Maintenance: check if all date/time fields are actually DATETIME fields in the database
        foreach (db_GetArray("SELECT id, tabletype FROM CRMextrafields WHERE fieldtype='date/time' AND deleted='n'") as $row) {
            if (is_numeric($row['tabletype'])) {
                $row['tabletype'] = 'flextable'.$row['tabletype'];
            }

            $sql = 'ALTER TABLE CRM'.$row['tabletype'].' CHANGE `EFID'.$row['id'].'` `EFID'.$row['id']."` DATETIME NOT NULL DEFAULT '0000-00-00 00:00:00'";
            mcq($sql);
        }

        foreach ($language_tags as $language => $tagarray) {
            //JH 2015-10-07 check of deze taal in gebruik is in deze repos
            if (db_GetValue("SELECT COUNT(*) FROM CRMlanguages WHERE LANGID='".mres($language)."'") > 0) {
                foreach ($tagarray as $tag => $value) {
                    $test = db_GetValue("SELECT COUNT(*) FROM CRMlanguages WHERE LANGID='".mres($language)."' AND TEXTID='".mres($tag)."'");
                    if ($test < 1) {
                        $sql = "INSERT INTO CRMlanguages(LANGID,TEXTID,TEXT) VALUES('".mres($language)."','".mres($tag)."','".mres($value)."')";
                        if (is_administrator()) {
                            print date('r').': '.$sql.'<br>';
                        }
                        mcq($sql);
                    }
                }
            }
        }

        // Delete all other indices
        foreach (db_GetArray("SELECT tabletype, fieldtype, id FROM CRMextrafields WHERE deleted='n' AND fieldtype NOT IN ('Reference to FlexTable','User-list of all CRM-CTT users','User-list of administrative CRM-CTT users', 'List of all groups', 'date/time', 'date (iso)')") as $field) {
            if (is_numeric($field['tabletype'])) {
                $field['tabletype'] = 'flextable'.$field['tabletype'];
            }
            if ($field['tabletype'] == 'user') {
                $field['tabletype'] = 'loginusers';
            }
            if ($field['tabletype'] == 'group') {
                $field['tabletype'] = 'userprofiles';
            }
            if ($field['tabletype'] == 'files') {
                $field['tabletype'] = 'binfiles';
            }

            $dropindices[] = array($field['tabletype'], 'EFID'.$field['id']);
            $dropindices[] = array($field['tabletype'], 'deleted_EFID'.$field['id']);
        }

        // Use function below to delete *all* old-style field indices

        foreach (db_GetArray("SELECT tabletype, fieldtype, id FROM CRMextrafields WHERE deleted='n'") as $field) {
            if (is_numeric($field['tabletype'])) {
                $field['tabletype'] = 'flextable'.$field['tabletype'];
            }
            if ($field['tabletype'] == 'user') {
                $field['tabletype'] = 'loginusers';
            }
            if ($field['tabletype'] == 'group') {
                $field['tabletype'] = 'userprofiles';
            }
            if ($field['tabletype'] == 'files') {
                $field['tabletype'] = 'binfiles';
            }

            if ($field['tabletype'] != 'loginusers' && $field['tabletype'] != 'userprofiles' && $field['tabletype'] != 'binfiles') {
                $dropindices[] = array($field['tabletype'], 'EFID'.$field['id']);
                $dropindices[] = array($field['tabletype'], 'EFID'.$field['id'].'_1');
                $dropindices[] = array($field['tabletype'], 'EFID'.$field['id'].'_2');
                $dropindices[] = array($field['tabletype'], 'EFID'.$field['id'].'_3');
                $dropindices[] = array($field['tabletype'], 'EFID'.$field['id'].'_4');
                $dropindices[] = array($field['tabletype'], 'EFID'.$field['id'].'_5');
            }
        }

        foreach (db_GetArray("SELECT id, fieldtype, tabletype FROM CRMextrafields WHERE deleted='n'") as $ftp) {
            if (is_numeric($ftp['tabletype'])) {
                $ftp['tabletype'] = 'flextable'.$ftp['tabletype'];
            }
            if ($ftp['tabletype'] == 'user') {
                $ftp['tabletype'] = 'loginusers';
            }
            if ($ftp['tabletype'] == 'group') {
                $ftp['tabletype'] = 'userprofiles';
            }
            if ($ftp['tabletype'] == 'files') {
                $ftp['tabletype'] = 'binfiles';
            }
            switch ($ftp['fieldtype']) {
                case 'Button':
                    //	Button BIT(1)
                    $fields[] = array($ftp['tabletype'], 'EFID'.$ftp['id'], 'BIT(1) NOT NULL');
                break;
                case 'comment':
                    // comment BIT(1)
                    $fields[] = array($ftp['tabletype'], 'EFID'.$ftp['id'], 'BIT(1) NOT NULL');
                break;

                case 'date':
                    // date VARCHAR(10)
                    $fields[] = array($ftp['tabletype'], 'EFID'.$ftp['id'], 'VARCHAR(10) NOT NULL');
                break;
                case 'Reference to FlexTable':
                    // Reference to FlexTable int(11)
                    $fields[] = array($ftp['tabletype'], 'EFID'.$ftp['id'], 'int(11) NOT NULL');
                break;
                case 'User-list of all CRM-CTT users':
                    // User-list of all CRM-CTT users int(11)
                    $fields[] = array($ftp['tabletype'], 'EFID'.$ftp['id'], 'int(11) NOT NULL');
                break;
                case 'User-list of administrative CRM-CTT users':
                    // User-list of administrative CRM-CTT users int(11)
                    $fields[] = array($ftp['tabletype'], 'EFID'.$ftp['id'], 'int(11) NOT NULL');
                break;
                case 'List of all groups':
                    // List of all groups int(11)
                    $fields[] = array($ftp['tabletype'], 'EFID'.$ftp['id'], 'int(11) NOT NULL');
                break;

            }
        }

        // Drop indices (when they exist)

        //////////////////////////////////////////////////////////////////////////////////////////////////////////////////
        //////////////////////////////////////////////////////////////////////////////////////////////////////////////////
        //////////////////////////////////////////////////////////////////////////////////////////////////////////////////
        foreach ($dropindices as $index) {
            if (TableHasIndexByName($index[0], $index[1])) {
                $sql = 'ALTER TABLE CRM'.$index[0].' DROP INDEX `'.$index[1].'`';
                mcq($sql);
                if (is_administrator()) {
                    print date('r').': '.$sql."<br>\n";
                }
            }
        }
        // The following checks should only run if the current user is an administrator
        if (is_administrator()) {
            FixTableAndFieldEngineAndCharset();
        }
        foreach ($droptables as $table) {
            if (SchemaHasTable('CRM'.$table)) {
                $sql = 'DROP TABLE CRM'.$table;
                mcq($sql);
                if (is_administrator()) {
                    print $sql.";<br>\n";
                }
            }
        }
        foreach (db_GetFlatArray('SHOW TABLES') as $table) {
            if (substr($table, 0, 3) == 'CRM') {
                /* must be 'ours' */
                $fields[] = array(str_replace('CRM', '', $table), 'timestamp_last_change', 'timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP');
            }
        }
        $current_tables = db_GetFlatArray('SHOW TABLES');
        foreach ($newtables as $table_to_create) {
            if (!in_array('CRM'.$table_to_create[0], $current_tables)) {
                mcq($table_to_create[1]);
                if (is_administrator()) {
                    echo date('r').': '.$table_to_create[1].'<br>';
                }
            }
        }
        $drops = array();
        foreach ($dropfields as $df) {
            if (TableHasField($df[0], $df[1], false) == 'yes') {
                $drops['CRM'.$df[0]][] = $df[1];
                //$sql = "ALTER TABLE CRM" . $df[0] . " DROP `" . $df[1] . "`";
                //mcq($sql);
                //if (is_administrator()) print date('r') . ": " . $sql . "<br>\n";
            }
        }
        foreach ($drops as $table => $ftr) {
            $sql = 'ALTER TABLE `'.$table.'` ';
            $nf = false;
            foreach ($ftr as $f) {
                if ($nf) {
                    $sql .= ',';
                }
                $sql .= ' DROP `'.$f.'`';
                $nf = true;
            }
            mcq($sql);
            if (is_administrator()) {
                print $sql.";<br>\n";
            }
        }

        foreach ($dropsettings as $setting) {
            $exists = db_GetValue("SELECT setting FROM CRMsettings WHERE setting='".mres($setting)."'");
            if ($exists == $setting) {
                $sql = "DELETE FROM CRMsettings WHERE setting='".$setting."'";
                mcq($sql);
                if (is_administrator()) {
                    print date('r').': '.$sql."<br>\n";
                }
            }
        }
        foreach ($fields as $field) {
            $check = '';
            $check = TableHasField($field[0], $field[1], $field[2]);
            if ($check == 'no') {
                $sql = 'ALTER TABLE CRM'.$field[0].' ADD `'.$field[1].'` '.$field[2];
                mcq($sql);
                if (is_administrator()) {
                    print date('r').': '.$sql."<br>\n";
                }
            } elseif ($check === 'wrongtype') {
                $sql = 'ALTER TABLE CRM'.$field[0].' CHANGE `'.$field[1].'` `'.$field[1].'` '.$field[2];
                mcq($sql);
                if (is_administrator()) {
                    print date('r').': '.$sql."<br>\n";
                }
            }
        }

        /* create indices if needed */
        if (is_administrator()) {
            print date('r').": Check indices...<br>\n";
        }
        create_indices();

        UpdateSetting('DBVERSION', $version_when_done);
    }

    foreach ($attribute_settings as $setting) {
        $ar = explode('|', $setting);
        if (count($ar) > 1) {
            $setting = $ar[0];
            $options = array();
            $defaultvalue = $ar[1];
            for ($i = 1; $i < count($ar); ++$i) {
                $options[] = $ar[$i];
            }
        } else {
            $options = false;
            $defaultvalue = '{{none}}';
        }
        if (db_GetValue("SELECT value FROM CRMattributes WHERE identifier='system' AND entity='2' AND attribute='".mres($setting)."'") == '') {
            mcq("INSERT INTO CRMattributes (entity, identifier, attribute, value, allowed_values) VALUES('2','system','".mres($setting)."','".mres($defaultvalue)."','".mres(serialize($options))."')");
        }
    }

    foreach ($attribute_options_adjust as $attr => $options) {
        $sql = "UPDATE CRMattributes SET allowed_values='".mres(serialize($options))."' WHERE attribute='".mres($attr)."'";
        mcq($sql);
    }

    /* move all files with koppelid=0 to system if not generalpurpose or public */
    mcq("UPDATE CRMbinfiles SET type='system', timestamp_last_change=timestamp_last_change WHERE koppelid=0 AND type NOT IN ('generalpurpose','public', 'system')");

    AdminChangesDropCache();
}
function FixTableAndFieldEngineAndCharset()
{
    // All tables should be UTF8 and the engine should be InnoDB
    foreach (db_GetFlatArray('SHOW TABLES') as $table) {
        // Strip the prefix in this case, it will be added back later
        if (substr($table, 0, 3) == 'CRM') { // Check if the table is "ours"

            $table = substr($table, strlen('CRM'), strlen($table) - strlen('CRM'));

                // Check if the table has the right character set. If not, fix.
                if (!TableHasProperty($table, 'CHARSET=utf8')) {
                    $sql = 'ALTER TABLE `CRM'.$table.'` DEFAULT CHARACTER SET utf8 COLLATE utf8_general_ci';
                    mcq($sql);
                    if (is_administrator()) {
                        print date('r').': '.$sql."<br>\n";
                    }
                }
                // Check if the table has the right engine. If not, fix.

                if (!TableHasProperty($table, 'ENGINE=InnoDB')) {
                    $sql = 'ALTER TABLE `CRM'.$table.'` ENGINE = INNODB ';
                    mcq($sql);
                    if (is_administrator()) {
                        print date('r').': '.$sql."<br>\n";
                    }
                }

            foreach (db_GetArray('SHOW FIELDS FROM CRM'.$table) as $field) {
                $weigh = FieldHasProperty($table, $field[0], 'CHARACTER SET latin1');
                if ($weigh != '' && $weigh != 'no') {
                    $sql = 'ALTER TABLE CRM'.$table.' CHANGE `'.$field[0].'` '.str_replace('CHARACTER SET latin1', 'CHARACTER SET utf8', $weigh);
                    $sql = str_replace('latin1_bin', 'utf8_general_ci', $sql);
                    mcq($sql);
                    if (is_administrator()) {
                        print date('r').': '.$sql."<br>\n";
                    }
                }
            }
        }
    }
}

function PerformDatabaseMaintenance($print = false)
{
    ClearAllRunningCache();

    // Some maintenance. This data was journaled by accident
    mcq("DELETE FROM CRMdatajournal WHERE field='attributes'");

    // Change all "Reference to FlexTable"-type fields which are not referring to an actual, existing flextable to a numeric field type
    mcq("UPDATE CRMextrafields SET fieldtype='numeric' WHERE fieldtype ='Reference to FlexTable' AND options NOT IN (SELECT recordid FROM CRMflextabledefs)");

    // Mark all fields as "deleted" if the flextable to which to refer doesn't exist
    mcq("UPDATE CRMextrafields SET deleted='y' WHERE fieldtype ='Reference to FlexTable' AND tabletype NOT IN ('user', 'group', 'files') AND tabletype NOT IN (SELECT recordid FROM CRMflextabledefs)");

    if ($print) {
        print date('r').': '."Maintenance on logs (trimming lines with more than 2 MB of data) ...\n";
    }

    mcq('UPDATE CRMuselog 		SET qs			= LEFT(qs, 2048), 		timestamp_last_change=timestamp_last_change WHERE LENGTH(qs) 		> 2097152');
    mcq('UPDATE CRMjournal 		SET message		= LEFT(message, 2048), 	timestamp_last_change=timestamp_last_change WHERE LENGTH(message) 	> 2097152');
    mcq('UPDATE CRMdatajournal 	SET from_val	= LEFT(from_val, 2048), timestamp_last_change=timestamp_last_change WHERE LENGTH(from_val) 	> 2097152');
    mcq('UPDATE CRMdatajournal 	SET to_val		= LEFT(to_val, 2048), 	timestamp_last_change=timestamp_last_change WHERE LENGTH(to_val) 	> 2097152');
    mcq('UPDATE CRMmailqueue 	SET template	= LEFT(template, 2048), timestamp_last_change=timestamp_last_change WHERE LENGTH(template) 	> 2097152');

    if ($print) {
        print date('r').': '."Maintenance on attributes (deleting attributes without parent) ...\n";
    }

    mcq("DELETE FROM CRMattributes WHERE identifier ='extrafield' 	AND entity NOT IN (SELECT id 			FROM CRMextrafields WHERE deleted='n');");
    mcq("DELETE FROM CRMattributes WHERE identifier ='user' 		AND entity NOT IN (SELECT id 			FROM CRMloginusers WHERE active='yes');");
    mcq("DELETE FROM CRMattributes WHERE identifier ='module' 		AND entity NOT IN (SELECT mid 			FROM CRMmodules);");
    mcq("DELETE FROM CRMattributes WHERE identifier ='flextable' 	AND entity NOT IN (SELECT recordid 		FROM CRMflextabledefs);");
    mcq("DELETE FROM CRMattributes WHERE identifier ='template' 	AND entity NOT IN (SELECT templateid 	FROM CRMtemplates);");
    mcq("DELETE FROM CRMattributes WHERE identifier ='group' 		AND entity NOT IN (SELECT id 			FROM CRMuserprofiles);");
    mcq("DELETE FROM CRMattributes WHERE identifier ='trigger'");

    // Delete values with empty arrays from attributes
    mcq("DELETE FROM CRMattributes WHERE value='a:0:{}'");


    if ($print) {
        print date('r').': '."Maintenance on logs (deleting logs without parent) ...\n";
    }

    mcq("DELETE FROM CRMjournal WHERE type='user' AND eid NOT IN (SELECT id from CRMloginusers)");
    mcq("DELETE FROM CRMjournal WHERE type='group' AND eid NOT IN (SELECT id from CRMuserprofiles)");

    foreach (db_GetFlatArray('SELECT recordid FROM CRMflextabledefs') as $ft) {
        mcq("DELETE FROM CRMjournal WHERE type='flextable".$ft."' AND eid NOT IN (SELECT recordid from CRMflextable".$ft.')');
    }
    mcq("DELETE FROM CRMjournal WHERE type='todo'");

    if ($print) {
        print date('r').': '."Maintenance on files (deleting files without parent) ...\n";
    }

    foreach (db_GetFlatArray('SELECT recordid FROM CRMflextabledefs') as $ft) {
        mcq("DELETE CRMbinfiles.*, CRMblobs.* FROM CRMbinfiles,CRMblobs WHERE CRMbinfiles.fileid=CRMblobs.fileid AND type ='flextable".$ft."' AND koppelid NOT IN (SELECT recordid from CRMflextable".$ft.')');
    }

    //delete system attributes
    mcq("DELETE FROM CRMattributes WHERE identifier='system' AND attribute IN ('AssigneeCustomValidationFunctionPHP','CategoryCustomValidationFunctionPHP','CategoryPlaceholder','CustomerDefaultReflayout','CustomerImportTableHTML','CustomerListAlwaysInPopup','CustomerListMainHeaderHTML','CustomerWebDAVDirectoryName','CustomernameCustomValidationFunctionPHP','DuedateCustomValidationFunctionPHP','EntityChildsInheritWriteRecordAccess','EntityCustomerCustomValidationFunctionPHP','EntityDefaultReflayout','EntityImportTableHTML','EntityListAlwaysInPopup','EntityListMainHeaderHTML','EntityWebDAVDirectoryName','IgnoreEntityCustomerRelationship','OwnerCustomValidationFunctionPHP','PriorityCustomValidationFunctionPHP','RecalculateAllUnderlyingEntitiesOnCustomerUpdate','ShowEntityListOpenEntityInPopupIcon','StatusCustomValidationFunctionPHP', 'UseRecord.php', 'UseNewSelections', 'IgnoreEntityAndCustomer', 'IgnoreReadonlyFieldInFlextableSecurity', 'EntityImportTableHTML', 'CustomerImportTableHTML', 'EntityListMainHeaderHTML', 'CustomerListMainHeaderHTML', 'EntityListAlwaysInPopup', 'CustomerListAlwaysInPopup', 'CategoryCustomValidationFunctionPHP', 'AssigneeCustomValidationFunctionPHP', 'OwnerCustomValidationFunctionPHP', 'CustomernameCustomValidationFunctionPHP', 'DuedateCustomValidationFunctionPHP', 'EntityCustomerCustomValidationFunctionPHP', 'CategoryPlaceholder', 'StatusCustomValidationFunctionPHP', 'PriorityCustomValidationFunctionPHP', 'RecalculateAllUnderlyingEntitiesOnCustomerUpdate', 'IgnoreEntityCustomerRelationship', 'EntityDefaultReflayout', 'CustomerDefaultReflayout', 'EntityChildsInheritWriteRecordAccess', 'ShowEntityListOpenEntityInPopupIcon', 'EntityWebDAVDirectoryName', 'CustomerWebDAVDirectoryName', 'FlextablesWhichArePartOfConfigurationCSV', 'AllowFoldersInFilelists-EXPIRIMENTAL', 'LDAP_LOGIN_ATTRIBUTE', 'UseInnerJoinInsteadOfLeftJoinForRequiredReferenceFields', '', 'LastSystemConfigurationModification', 'RecalculateEntitySiblingsOnEntityUpdate', 'ShowFieldHistory-priority', 'ShowFieldHistory-status', 'TwoPhaseAuthenticationShellCommand')");

    //delete field attributes
    mcq("DELETE FROM CRMattributes WHERE identifier='extrafield' AND attribute IN ('ExtraSelectCondition', 'AddNullValueAsOption', 'ComputationOutputType', 'ExtraClass', 'HideButtonWhenNotClickable', 'IgnoreUniqueValues-CommaSeprated', 'IgnoreValueChangesWhenRecalculating', 'InteractiveReloadListOnChange', 'MustBeUnique', 'RangeStep', 'RangeMax', 'RangeMin', 'ShowButtonInList', 'ShowSelectFromTablePopupIcon', 'UserIsAllowedToEditExtraField', 'SelectAllCheckboxesText')");
    //delete table attributes
    mcq("DELETE FROM CRMattributes WHERE identifier='flextable' AND attribute IN ('ExtraSelectConditionWhenSelectingReferOptions', 'EnableReferFieldFilter', 'ReferFieldSelectInPopup', 'IgnoreExtraSelectConditionWhenInline', 'HeaderHTMLAboveFormTables', 'ShowSortLinks', 'MaxNumOfRecordsPerParentRecord', 'DontRecalculateConnectedTablesOnRecalc', 'DontRecalculateOnRecalcOfParent', 'AllowReferChanges', 'DownloadRules', 'HideInteractiveFieldsFromMainList', 'ModuleToRunForAccess', 'ReferFieldName', 'ReferFieldShowSearchBox', 'ShowCountRecordsOnDemandButton', 'ViewOnTableSelectCondition')");

    /* be careful; only use this when you're sure the attrib name is 100% unique */
    mcq("DELETE FROM CRMattributes WHERE attribute IN ('SecuritySubselectForRecordAccessWriteForCustomer', 'SecuritySubselectForRecordAccessWriteForEntity', 'InlineFormNumOfSpareLines', 'InlineFormHeaderHTML','InlineFormFieldsToShow', 'InlineFormOnlyShowBlankLines', 'InlineFormReferSelectCondition','InlineFormReferSortByValue', 'InlineFormSaveButtonText','InlineFormShowHorizontalNumericTotal','InlineFormShowVerticalNumericTotal')");

    mcq("DELETE FROM CRMattributes WHERE identifier LIKE 'PC%'");

    mcq("DELETE FROM CRMattributes WHERE identifier ='extrafield' AND entity NOT IN (SELECT id FROM CRMextrafields WHERE deleted='n')");
    mcq("DELETE FROM CRMattributes WHERE identifier ='extrafield' AND entity IN (SELECT id FROM CRMextrafields WHERE tabletype IN ('entity', 'customer'))");

    mcq("update CRMattributes set value='{{none}}' where value='none' and attribute in ('RemoveExtraSelectCondionFromQueryLinkText', 'AddExtraSelectCondionToQueryLinkText', 'ExtraSelectCondition')");

    mcq("DELETE FROM CRMextrafields WHERE tabletype IN ('entity', 'customer')");

    // Delete the "Default form" which is only for entities
    mcq("DELETE FROM CRMtemplates WHERE templatename='Default form'");

    mcq("DELETE FROM CRMattributes WHERE attribute LIKE 'InlineForm%'");
    mcq("DELETE FROM CRMsettings WHERE setting IN ('ALSO_PROCESS_DELETED', 'AutoCompleteCategory', 'BODY_ENTITY_EDIT', 'BODY_TEMPLATE_CUSTOMER', 'CATEGORYBOXSIZE', 'CUSTOMCUSTOMERFORM', 'CalendarDefinitions', 'Category pulldown list', 'DISPLAYSAVEREMINDER', 'ENTITY_ADD_FORM', 'ENTITY_EDIT_FORM', 'ENTITY_LIMITED_ADD_FORM', 'ENTITY_LIMITED_EDIT_FORM', 'EnableCustInsert', 'EnableEntityJournaling', 'EnableEntityReporting', 'ForceCategoryPulldown', 'HIDEENTITYADDTABS', 'NextInvoiceNumberCounter', 'ONEENTITYPERCUSTOMER', 'PAGINATECUSTOMERLIST', 'PDF-ExtraFieldsInTable', 'PaginateMainEntityList', 'REQUIREDDEFAULTFIELDS', 'SHOWTABLEHEADEREVERY', 'STANDARD_TEXT', 'STICKYENTITY', 'ShowDeletedViewOption', 'ShowIconsAboveMainContentBox', 'ShowInactiveCustomers', 'ShowMainPageLinks', 'TriggerDays', 'USECUSTOMERSELECTPOPUP', 'subject_update_entity', 'EnableRepositorySwitcher', 'ForceSecureHTTP', 'AUTH_TYPE', 'LDAP_SERVER', 'LDAP_PORT', 'LDAP_PREFIX', 'LDAP_BIND_USERNAME', 'LDAP_BIND_PASSWORD', 'LDAP_BASE_DN', 'CHECKFORDOUBLEADDS', 'DISABLE_BINARY_SEARCH', 'EMAILINBOX', 'langoverride', 'LASTINVOICENUMBER', 'LASTLETTERNUMBER', 'LDAP_AUTO_ADD_USERS', 'LetUserEditOwnProfile')");

    // Delete obsolete language tags
    mcq("DELETE FROM CRMlanguages WHERE TEXTID IN ('abdnya', 'add', 'addcust', 'alled', 'allround', 'alreadyselected', 'andassignee', 'aohnsae', 'apseat', 'apseot', 'apsest', 'apsrft', 'assignedto', 'assignee', 'attachindividualtocustomer', 'attachindividualtoentity', 'category', 'close', 'closedate', 'confdel', 'contact', 'contactemail', 'contactphone', 'contacttitle', 'contents', 'createreport', 'createreports', 'creationdate', 'cuaeoay', 'curstat', 'custhomepage', 'customer', 'customeraddress', 'customers', 'custremarks', 'deap', 'delentities', 'deletefile', 'deletepb', 'deleting1', 'deleting2', 'donothing', 'dontbelonghere', 'downloadpdf', 'duedate', 'duration', 'eatm', 'eatu', 'eatw', 'ectm', 'ectw', 'edd', 'enddate', 'entities', 'entitiestoday', 'entity', 'entreportverbose', 'entrysaved', 'entsum', 'eobu', 'epc', 'ewfsea', 'incldel', 'includelog', 'lefae', 'listofentities_assigned', 'listofentities_owned', 'listofentities_recent', 'listofentities_today', 'newentity', 'noentities', 'noopen', 'oa', 'oepa', 'ofwhich', 'ombla', 'onavarage', 'ondaa', 'onlyactive', 'openentities', 'oqs', 'ownedby', 'owner', 'priority', 'private', 'rtftemplate', 'sae', 'saveasnewentity', 'selectsingle', 'selfassig', 'startdate', 'status', 'tel', 'vacc', 'viewbrief', 'viewinsertedentities', 'zailo', 'zoilo', 'closethisentity', 'deletethisentity', 'deletingentity', 'doesntbelonghere', 'entitiesfound', 'maninfoverb', 'physdelwarning', 'teaair', 'usrwarning', 'viewdelentities', 'addcusttodb', 'custdelexplain', 'custindb', 'delcust', 'intro1', 'intro2', 'intro3', 'intro4', 'nocustomers1', 'nousersandnocustomers1', 'dailymail', 'nimut', 'vacoa', 'ownassindb', 'addownass', 'addtopb', 'importinpb', 'impphone', 'pbexpmade', 'pbexport', 'pbrecadded', 'phonebook1', 'phonebookshort', 'adm', 'oaoedbh', 'tad', 'alarmdatev', 'briefover', 'editthis', 'brieflistdel', 'deleteerror', 'nonexistent', 'confirmdel', 'wasclosed', 'isdeleted', 'listofatt', 'inccont', 'hasfilessum', 'expired', 'thisiswaiting', 'delallclosed', 'physdel', 'etdbh', 'oefm', 'createinvoice', 'delafterproc', 'thisdoesntbelong')");
}

function add_comments_to_tables_and_fields_and_alter_fields_to_correct_type($print = false, $include_fields = false, $dry_run = false, $method = 'mysql')
{
    foreach (db_GetArray('SELECT * FROM CRMflextabledefs') as $ft) {
        $sql = 'ALTER TABLE CRMflextable'.$ft['recordid']." COMMENT 'Interleave data table \'".mres($ft['tablename'])."\''";
        if ($print) {
            print $sql.";\n";
        }
        if (!$dry_run) {
            mcq($sql);
        }
    }
    if ($include_fields) {
        // This will set all field comments. Disabled, run this only once.
        $sql = array();
        $in_query = false;

        foreach (db_GetArray("SELECT * FROM CRMextrafields WHERE deleted!='y' ".$in_query) as $ef) {
            if (ipi($ef['tabletype'])) {
                $ds_tablename = 't'.$ef['tabletype'];
                $il_tablename = 'CRMflextable'.$ef['tabletype'];
            } else {
                $ds_tablename = $ef['tabletype'];
                if ($ef['tabletype'] == 'user') {
                    $il_tablename = 'CRMloginusers';
                } elseif ($ef['tabletype'] == 'group') {
                    $il_tablename = 'CRMuserprofiles';
                } elseif ($ef['tabletype'] == 'files') {
                    $il_tablename = 'CRMbinfiles';
                } else {
                    $il_tablename = 'CRM'.$ef['tabletype'];
                }
            }
            if (GetAlterQueryBasedOnFieldType('f'.$ef['id'], $ds_tablename, $ef['fieldtype'], 'change', $method, $ef['name']) != '') {
                $sql[$il_tablename][] = str_replace('ALTER TABLE '.$il_tablename, '', GetAlterQueryBasedOnFieldType('f'.$ef['id'], $ds_tablename, $ef['fieldtype'], 'change', $method, $ef['name']));
            }
        }

        foreach ($sql as $table => $list_of_changes) {
            $query = 'ALTER TABLE '.$table.' '.implode(',', $list_of_changes);
            if ($print) {
                print $query.";\n";
            }
            if (!$dry_run) {
                mcq($query);
            }
        }
    }
}
