<?php
/* ********************************************************************
 * Interleave
 * Copyright (c) 2001-2016 Atomos Applications The Netherlands - www.atomos.nl - info@atomos.nl - www.interleave.nl - info@interleave.nl
 * Licensed under the GNU GPL. For full terms see http://www.gnu.org/
 *
 * This file handles language administration stuff like exporting
 * and importing of language packs, completion, adding, etc.
 *
 * Check http://www.interleave.nl/ for more information
 *
 * BUILD / RELEASE :: 7.0.20161227
 *
 **********************************************************************
 */
$_GET['SkipMainNavigation'] = true;
require_once "initiate.php";

MustBeAdmin();

if ($_REQUEST['export']) {
	if (!$_REQUEST['pack_to_export']) {
		ShowHeaders();
		print '<div class="errmsg">No language pack to export given! (' . $_REQUEST['pack_to_export'] . ')</div>';
		EndHTML();
	}
	else
	{
		$u=1;

		$sql= "SELECT * FROM CRMlanguages WHERE LANGID='" . mres($_REQUEST['pack_to_export']) . "'";
		$t = array();
		foreach (db_GetArray($sql) as $resarr) {

			$t[$u] = $resarr['LANGID'] . "|||" . $resarr['TEXTID'] . "|||" . $resarr['TEXT'];
			$t[$u] = str_replace("\n","",$t[$u]);

			$u++;

		}


		header("Content-Type: text/plain");
		header("Content-Disposition: attachment; filename=" . $_REQUEST['pack_to_export'] . ".CRM.txt" );
		print "# Interleave LANGUAGE PACK EXPORT FILE - Pack " . $_REQUEST['pack_to_export'] . ".\n";
		print "# Generated " . date("F j, Y, H:i") . " on Interleave version " . $GLOBALS['CRM_VERSION'] . ".\n";
		print "PACK|||" . $_REQUEST['pack_to_export'] . "|||" . ($u-1) . "\n";
		for ($x=1;$x<$u;$x++ ) {
			print $t[$x] . "\n";
		}
		log_msg("Language export: " . $_REQUEST['pack_to_export']);
		//EndHTML(false);
	}
	exit;
}
if ($_FILES['userfile']['tmp_name'] || $_REQUEST['packurl']) {
	require_once $GLOBALS['PATHTOINTERLEAVE'] . "config/config.inc.php";
	ShowHeaders();
	// Read contents of uploaded file into variable
	$file = "";
	if ($_REQUEST['packurl']) {
		$file = base64_decode($_REQUEST['packurl']);
	
	} else {
	
		$file = $_FILES['userfile']['tmp_name'];
	}
	

	$fc = file($file);
	$fc1 = array();
	$fc2 = array();
	$fc3 = array();

	for ($x=0;$x<sizeof($fc);$x++ ) {
			$tmp=explode("|||",$fc[$x]);
			$fc1[$x] = (trim($tmp[0]));
			$fc2[$x] = (trim($tmp[1]));
			$fc3[$x] = (trim($tmp[2]));
	}
	$tmp = $fc[2];
	$header=explode("|||",$tmp);
	$pack = $header[1];
	print("<br>Processing language pack " . $header[1] . " containing " . $header[2] . " entries.<br>");

	$default_lang_pack = db_GetValue("SELECT `TEXT` FROM CRMlanguages WHERE LANGID='GLOBAL' AND TEXTID='current-language'");

	$sql= "SELECT COUNT(*) FROM CRMlanguages WHERE LANGID='" . mres($default_lang_pack) . "'";
	$result= db_GetRow($sql);
	
	$outp = "";
	$outp .= "Your current default language pack (" . htme($default_lang_pack) . ") has " . $result[0] . " entries.<br>";
	$JUST_DO_IT = 0;
	if ($result[0]==0) {
		$JUST_DO_IT=1;
		$result[0]=$header[2];
		$outp .= "Overridden - you have no language packs at all<br>";
	}
	if (!$result[0]==$header[2]) {
		$outp .= "<span class='errmsg'>Values don't match</span><br>";
		}
	print($outp);

	$outp = "";
	$wrong = 0;
	$sql= "SELECT TEXTID FROM CRMlanguages WHERE LANGID='" . mres($default_lang_pack) . "'";
	foreach (db_GetArray($sql) as $resarr) {
				if (!in_array($resarr['TEXTID'],$fc2)) {
						$outp .= "<span class='errmsg'>Missing text identifier \"" . $resarr['TEXTID'] . "\"</span><br>";
						$wrong=1;
				}
	}
	if ($wrong && !$JUST_DO_IT) {

	} else {
		if ($JUST_DO_IT) {
			$outp .= "Installing base language pack<br>";
		} else {
		$outp .= "Pack is OK, all TEXTID's match.<br>";
		}
	}
	$sql= "SELECT DISTINCT LANGID FROM CRMlanguages";
	$p = 0;
	$tmparr = array();
	foreach (db_GetArray($sql) as $resarr) {
		$tmparr[$p++] = $resarr['LANGID'];	// All LANGID's in array
	}
	if (in_array($pack,$tmparr)) {
		$outp.="You already have a language pack " . $pack . " installed. Only new/unknown tags will be added.<br>";
	}
	print($outp);

	$outp = "";
	$imported=0;
	for ($p=3;$p<sizeof($fc2);$p++) {
		
		$tmp = db_GetValue("SELECT TEXTID FROM CRMlanguages WHERE LANGID='" . mres($fc1[$p]) . "' AND TEXTID = '" . mres($fc2[$p]) . "'");
		if ($tmp[0] == "") { 
			$sql = "INSERT INTO CRMlanguages(LANGID,TEXTID,TEXT) VALUES('" . mres($fc1[$p]) . "','" . mres($fc2[$p]) . "','" . mres($fc3[$p]) . "')";
			 mcq($sql);
			 $imported++;
		} else {
			print "Skipped tag " .  htme($fc1[$p]) . "\\" .  htme($fc2[$p]) . ", it already exists.<br>";
		}
	
	}
	$outp .= "<br><span class='okmsg'>" . $imported . " Language entries were imported</span>";

	print($outp);
	print "Run <a href=\"admin.php?PerformDatabaseMaintenance=1\">PerformDatabaseMaintenance (duedate)</a> to remove unused lang tags";
	log_msg("Language or language pack deployed (" . $pack . ", " . $p . " records)");
	EndHTML();
	exit;
}
if ($_REQUEST['lanlist']) {
	ShowHeaders();
	print "<table class=\"crm\">";
	print "<thead><th>Identifier</th><th>Value</th></thead>";
	print '<tbody>';
	$sql= "SELECT DISTINCT TEXTID FROM CRMlanguages";
	$p = 0;
	foreach (db_GetArray($sql) as $resarr) {
			$sql1 = "SELECT TEXT FROM CRMlanguages WHERE TEXTID='" . $resarr['TEXTID'] . "' AND LANGID='" . mres($_REQUEST['lanlist']) . "'";
			$resarr1=db_GetRow($sql1);
			if ($resarr1[0]) {
				print "<tr>";
				print "<td>" . $resarr['TEXTID'] . "</td>";
				print "<td>" . $resarr1[0] . "</td>";
				print "</tr>";
				$p++;
			}
	}
	print "<tr><td colspan='2'>" . $p . " entries found.</td></tr>";
	print '</tbody>';
	print "</table>";
	print $p . " entries found.";
	EndHTML();
	exit;
}
ShowHeaders();

AdminTabs();

$tabbs = array();
$tabbs[] = array("dictedit.php?packman=1", "Language overview");
$tabbs[] = array("dictedit.php?import=1", "Upload a pack file");
$tabbs[] = array("lan_entries.php?far=1", "Find &amp; replace");
$tabbs[] = array("dictedit.php?DLP=1", "Install from project website");
$tabbs[] = array("dictedit.php?at=1", "All tags", "comment", "All tags in one list");

PlainNav($tabbs);

if ($_REQUEST['DLP']) {
	GetPacksFromProjectPage();
	EndHTML();
	exit;
}
if ($_REQUEST['deletepack']) {
		$sql = "DELETE FROM CRMlanguages WHERE LANGID='" . mres($_REQUEST['deletepack']) . "'";
		mcq($sql);
		print("Language pack " . $_REQUEST['deletepack'] . " was deleted!");
		log_msg("Delete language pack " . $_REQUEST['deletepack']);
}
if ($_REQUEST['pack_to_delete']) {
		$a = "Are you sure you want to delete language pack " . $_REQUEST['pack_to_delete'] . "?";
		$a .= "<br><br><a href='dictedit.php?deletepack=" . $_REQUEST['pack_to_delete'] . "'>yes</a>";
		print($a);
		EndHTML();
		exit;
}
if ($_REQUEST['add'] && $_REQUEST['val'] && $_REQUEST['id_new']) {
		$sql= "INSERT INTO CRMlanguages(LANGID,TEXTID,TEXT) VALUES ('" . mres($_REQUEST['add']) . "','" . mres($_REQUEST['id_new']) . "','" . mres($_REQUEST['val']) . "')";
		mcq($sql);
		print "Entry added";
}
if ($_REQUEST['add']) {
		print "<form id='addlan' method='post' action=''><div class='showinline'>";
		print "<table class='form-table'>";
		print "<tr><td colspan='2'><strong>Add a language entry for language " . $_REQUEST['add'] . "</strong></td></tr>";
		print "<tr><td>Identifier</td><td><input type='text' name='id_new' size='20'></td></tr>";
		print "<tr><td>" . $_REQUEST['add'] . "</td><td><input type='text' name='val' size='100'><input type='hidden' name='add' value='" . $_REQUEST['add'] . "'></td></tr>";
		print "<tr><td colspan='2'><input type='submit' value='add'></td></tr>";
		print "<tr><td colspan='2'><a class='topnav' href='dictedit.php'>back</a></td></tr>";
		print "</table>";
		print "</div></form>";
		EndHTML();
		exit;
}
if ($_REQUEST['newlang']) {
				$sql= "SELECT DISTINCT LANGID FROM CRMlanguages";
				$tmparr = array();
				$p = 0;
				$outp = "";
					foreach (db_GetArray($sql) as $resarr) {
						$tmparr[$p] = $resarr[LANGID];	// All LANGID's in array
						$p++;
					}
					if (in_array($_REQUEST['newlang'],$tmparr)) {
							$outp.="You already have a language pack " . $_REQUEST['newlang'] . " installed. It will not be added again.";
							print($outp);

					} else {

							$sql= "INSERT INTO CRMlanguages(LANGID) VALUES('" . mres($_REQUEST['newlang']) . "')";
							mcq($sql);

							print("Your language entry has been added....");
					}
				$_REQUEST['newlan'] = "";
}
if ($_REQUEST['languagecomplete']) {
				print "<br><br>";
				if ($_REQUEST['val']) {
						if (!$_REQUEST['val']=="") {
								$outp = "Added your text to pack " . $_REQUEST['languagecomplete'] . ", TEXTID " . $_REQUEST['TEXTID'] . "<br><br>";
								$sql= "INSERT INTO CRMlanguages(LANGID,TEXTID,TEXT) VALUES('" . mres($_REQUEST['languagecomplete']) . "','" . mres($_REQUEST['TEXTID']) . "','" . mres($_REQUEST['val']) . "')";
								mcq($sql);
								print($outp);
								unset($outp);
						}
				}
				 $sql= "SELECT TEXTID FROM CRMlanguages WHERE LANGID='" . mres($_REQUEST['languagecomplete']) . "'";
					$t=1;
					$fc1 = array();
					$fc2 = array();
					foreach (db_GetArray($sql) as $resarr) {
						$fc2[$t] = $resarr[TEXTID];
						$fc1[$t] = $resarr[TEXT];
						$t++;
					}

				$default_lang_pack = db_GetValue("SELECT `TEXT` FROM CRMlanguages WHERE LANGID='GLOBAL' AND TEXTID='current-language'");

				$sql= "SELECT * FROM CRMlanguages WHERE LANGID='" . mres($default_lang_pack) . "'";
				foreach (db_GetArray($sql) as $resarr) {
							if (!in_array($resarr[TEXTID],$fc2)) {
								$outp = "";
								$outp .= "<form id='langform' method='post' action=''><div class='showinline'><input type='hidden' name='languagecomplete' value='" . $_REQUEST['languagecomplete'] . "'>";
								$outp .= "<table><tr><td><strong>TEXTID</strong></td><td class='nwrp'><strong>Value</strong></td><td><strong>" . $_REQUEST['languagecomplete'] . " value</strong></td></tr>";
								$outp .= "<tr><td>";
								$sql= "SELECT TEXT FROM CRMlanguages WHERE TEXTID='" . mres($resarr['TEXTID']) . "' AND LANGID='" . mres($default_lang_pack) . "'";

								$result1= db_GetRow($sql);

								$outp .= $resarr['TEXTID'] . "<input type='hidden' name='TEXTID' value='" . $resarr['TEXTID'] . "'></td><td>" . $result1['TEXT'] . "</td><td><input type='text' name='val' size='75'>";
								$outp .= "</td><td><input type='submit' value='next'></td></tr></table>";
								$outp .= "</div></form>";
								print($outp);
								?>
								<script type="text/javascript">
								<!--
									 document.forms['langform'].elements['val'].focus();
								//-->
								</script>
								<?php
								EndHTML();
								exit;
							}
			}
									?>
						<script type="text/javascript">
						<!--
						window.location.href='dictedit.php?end=all';
						//-->
						</script>
						<?php
		EndHTML();
		exit;
}
if ($_REQUEST['import']) {
			print "<form method='post' action='' enctype='multipart/form-data'><div class='showinline'><input type='hidden' name='max_file_size' value='52428800'>";
			print "<table>";
			print "<tr><td colspan='6'><input name='userfile' type='file'></td></tr>";
			print "<tr><td><input class='txt' type='submit' name='sb' value='Upload'></td></tr></table></div></form>";

			EndHTML();
			exit;
} elseif ($_REQUEST['at'] == 1) {
	
	list($number_of_records, $output) = make_list(array("table" => "languages"));
	print $output;

} elseif (!$_REQUEST['newlang']) {

	$default_lang_pack = db_GetValue("SELECT `TEXT` FROM CRMlanguages WHERE LANGID='GLOBAL' AND TEXTID='current-language'");

	$tmparr = array();
	$p=1;
	$sql= "SELECT DISTINCT LANGID FROM CRMlanguages";
	foreach (db_GetArray($sql) as $resarr) {
		if ($resarr['LANGID']<>"GLOBAL") {
			$tmparr[$p] = $resarr[LANGID];	 // All LANGID's in array
			$p++;
		}
	}

	print "<table class='crm'>";
	print '<thead><tr><th>Language</th><th>Number of entries</th><th>Status</th><th>Actions</th></tr></thead>';
	print '<tbody>';
	for ($c=0;$c<sizeof($tmparr)+1;$c++) {
			$fc2 = array();
			if ($tmparr[$c]<>"") {
				$sql= "SELECT TEXTID,TEXT FROM CRMlanguages WHERE LANGID='" . mres($tmparr[$c]) . "'";
				foreach (db_GetArray($sql) as $resarr) {
					$fc2[] = $resarr[TEXTID];
				}

			$sql= "SELECT TEXTID FROM CRMlanguages WHERE LANGID='" . mres($default_lang_pack) . "'";
			$missing = 0;
			foreach (db_GetArray($sql) as $resarr) {
						if (!in_array($resarr['TEXTID'],$fc2)) {
								$missing++;
						}
			}
			$num = db_GetValue("SELECT COUNT(*) FROM CRMlanguages WHERE LANGID='" . mres($tmparr[$c]) . "'");
			if (!$missing) {
				print "<tr><td>" . htme($tmparr[$c]) . "</td><td class=\"num\">" . $num . "</td><td class=\"okmsg\">complete</td><td><a href='dictedit.php?export=1&amp;pack_to_export=" . $tmparr[$c] . "'>export</a>&nbsp;&nbsp;<a href='dictedit.php?pack_to_delete=" . $tmparr[$c] . "'>delete</a>&nbsp;&nbsp;<a href='dictedit.php?add=" . $tmparr[$c] . "'>add an entry</a>&nbsp;&nbsp;<a href='lan_entries.php?edlan=" . $tmparr[$c] . "'>edit</a>";
			} else {
				print "<tr><td>" . htme($tmparr[$c]) . "</td><td class=\"num\">" . $num . "</td><td class=\"warnmsg\">missing " . $missing . " entries</td><td><a href='dictedit.php?export=1&amp;pack_to_export=" . $tmparr[$c] . "'>export</a>&nbsp;&nbsp;<a href='dictedit.php?pack_to_delete=" . $tmparr[$c] . "'>delete</a>&nbsp;&nbsp;<a href='dictedit.php?add=" . $tmparr[$c] . "'>add an entry</a>&nbsp;&nbsp;<a href='lan_entries.php?edlan=" . $tmparr[$c] . "'>edit</a>&nbsp;&nbsp;<a href='dictedit.php?languagecomplete=" . $tmparr[$c] . "'>complete</a>";
			}
			print "</td></tr>";
		 }
	}
	print "</tbody></table>";
	print "<br>Create new language <form id='new' method='post' action=''><div class='showinline'><input type='text' name='newlang'>&nbsp;&nbsp;<input type='submit' value='Submit'></div></form>";
}

function GetPacksFromProjectPage() {

	$t = "The following language packs are available at the project page. Click on a pack to install. <br>";
	foreach (json_decode(file_get_contents("http://download.interleave.nl/get_packs_new.php")) AS $packname => $packurl) {
		$t .= "<a href='dictedit.php?DLP=1&amp;packurl=" . htme(base64_encode($packurl)) . "'>" . htme($packname) . "</a><br>";
	}

	print $t;

}
EndHTML();
?>
