<?php
/* ********************************************************************
 * Interleave
 * Copyright (c) 2001-2016 Atomos Applications The Netherlands - www.atomos.nl - info@atomos.nl - www.interleave.nl - info@interleave.nl
 * Licensed under the GNU GPL. For full terms see the file COPYING.
 *
 * This file enables users to import into tables
 *
 * Check http://www.interleave.nl/ for more information
 *
 * BUILD / RELEASE :: 5.5.1.20120916
 *
 **********************************************************************
 */

require "initiate.php";

ShowHeaders();
if (is_administrator()) {
	require_once "adminfunctions.php";
	AdminTabs();
}
//DA($mem);
//DA($_SERVER);
print "<form id=\"importForm\" method=\"post\" action=\"\">";

if (!$_REQUEST['Worker'] && !$_REQUEST['tableId']) { // No session exists, create one and ask some questions

	$worker = PushStashValue(array("table" => "unknown"));


	if (is_administrator()) {
		$ft = GetFlextableDefinitions();

		foreach ($ft AS $f) {
			$tables[$f['recordid']] = $f['tablename'];
		}
		$tables['users'] = "Users";
		$set = true;
	} else {
		$tables = array();
		$set = false;
		foreach (GetFlextableDefinitions() AS $ft) {
			$configname = "AllowedToImportFT" . $ft['recordid'];
			if (CheckFunctionAccess($configname) == "ok") {
				$tables[$ft['recordid']] = $ft['tablename'];
				$set = true;
			}
		}
		if (CheckFunctionAccess("AllowedToImportUsers") == "ok") {
			$tables['users'] = "Users";
			$set = true;
		}

	}

	if ($set) {
		if (count($tables) > 0) {
			print "Choose table to update or to import into: ";
			print "<select name=\"tableId\" id=\"JS_table\">";
			foreach ($tables AS $table => $name) {
				print "<option value=\"" . $table . "\">" . htme($name) . "</option>";
			}
			print "</select>";
		} else {

		}
	} else {
		PrintAD("You're not allowed to use this functionality");
		$error = true;
	}
} else {
	if ($_REQUEST['tableId'] && !$_REQUEST['Worker']) {
		$worker = PushStashValue(array("table" => $_REQUEST['Table']));
		// print "Created worker $worker";
	} else {
		$worker = $_REQUEST['Worker'];
	}

	$mem = PopStashValue($worker);

	if ($mem['table'] && $mem['table'] != "unknown" && !CheckIfUserIsAllowedToImportInTable($mem['table'])) {

		PrintAD("You're not allowed to use this functionality");
		$error = true;

	} else {

		if ($_REQUEST['tableId'] && !$_POST['importBody'] && !isset($_POST['Matched'])) {
			$mem['table'] = $_REQUEST['tableId'];
			if ($mem['table'] && !CheckIfUserIsAllowedToImportInTable($mem['table'])) {
				PrintAD("You're not allowed to use this functionality");
				$error = true;
			} else {
				if ($mem['table'] == "users" && GetSetting("UserImportTableHTML") != "" && GetSetting("UserImportTableHTML") != "{{none}}") {
					print GetSetting("UserImportTableHTML");
				} else {
					print "Paste values from excel or writer: (tab-delimited):<br>";
					print "<p>A few rules:</p>";
					print "<ul><li>Cell data should not contain a TAB-character</li>";
					print "<li>When cell data contains newline characters (enter), you should quote it's value</li>";
					print "</ul>";
				}
				print "<textarea name=\"importBody\" id=\"JS_importBody\" cols=\"100\" rows=\"4\"></textarea><br>";
			}
		} elseif ($_POST['importBody']) {

			$mem['rawData'] = $_POST['importBody'];
			$mem['arrayData'] = array();
			/*if (strstr($mem['rawData'], "[[LASTCELL]]")) {
				$delim = "\t[[LASTCELL]]";
			} else {
				$delim = "\n";
			}
			//foreach (explode($delim, $mem['rawData']) AS $row) {
			foreach (split_with_quotes($mem['rawData'], "\n", "\"", "\\") as $line)
				$result = explode("\t", $row);
				array_walk($result, 'trim');
				$mem['arrayData'][] = $result;
			}
			*/
			$mem['arrayData'] = ExcelSplit($mem['rawData']);
			//print_r($mem['arrayData']);
			//exit;
			$mem['rawData'] = "";
			$mem['headerData'] = $mem['arrayData'][0];




			if (is_numeric($mem['table'])) {
				$fields = array("none" => "none/ignore");
				$tab = GetFlextableDefinitions($mem['table']);
				$tab = $tab[0];
				$fields = array("none" => "none/ignore", "updateFlexRecord" => "Map to current record-id, update instead of import");

				$extrafields = db_GetArray("SELECT CONCAT('EFID', id) AS id, name FROM CRMextrafields WHERE (fieldtype IN ('textbox', 'drop-down', 'numeric', 'mail', 'text area', 'text area (rich text)', 'hyperlink', 'date', 'date (iso)', 'checkbox', 'diary', 'date/time', 'Reference to FlexTable',  'Reference to FlexTable (multiselect)') OR fieldtype LIKE 'User-%' OR fieldtype LIKE 'List of all active%') AND deleted='n' AND tabletype='" . $mem['table'] . "'  ORDER BY ordering");
				//AND SUBSTR(options, 1, 18) != '%POPULATE_BY_CODE%'

				//DA($extrafields);
				foreach ($extrafields AS $row) {
					$fields[$row['id']] = $row['name'];
				}
				foreach ($extrafields AS $row) {
					$fields["updateFlexRecord-" . $row['id']] = "Map to " . $row['name'] . ", update instead of import";
				}
				$mem['SQLtable'] = "CRMflextable" . $mem['table'];

			} elseif ($mem['table'] == "users") {
				$fields = array("none" => "none/ignore", "name" => "Account name", "FULLNAME" => "Full name", "PASSWORD" => "Password", "PROFILE" => "Group ID", "EMAIL" => "E-mail address");

				$mem['SQLtable'] = "CRMloginusers";
			}

			if (count($mem['arrayData']) > 1) {
				print "Received a sheet with " . (count($mem['arrayData']) - 1) . " rows. The first line will be interpreted as header line and thus be ignored while importing!" . $textadd . "<br><br>";



				$_POST['importBody'] = "";


				print "<table class=\"crm\"><thead><tr><th>Column from import</th><th>Matches field</th><th>Search</th><th>Sheet validates?</th></tr></thead>";
				$headerId = 0;
				$js_add = "";
				foreach ($mem['headerData'] AS $headerCell) {
					$id = 'JS_' . randomstring(16);
					$matchArray = "<select name=\"matchArray" . $headerId . "\" id=\"JS_matchArray" . $headerId . "\" onchange=\"";
					$matchArray .= "refresh_contents_of_div('" . $id . "', 'assist.php', 'Function=ValidateInput&Run=1&Worker=" . $worker . "&Header=" . ($headerId) . "&Table=" . $mem['table'] . "&SelectedField=' + document.getElementById('JS_matchArray" . $headerId . "').options[document.getElementById('JS_matchArray" . $headerId . "').selectedIndex].value, true, 'POST', '', false);\" ";

					foreach ($fields AS $fieldname => $desc) {
						$ins = "";
						if (trim(strtolower($headerCell)) == trim(strtolower($desc))) {
							$ins = " selected";

							$js_add .= "refresh_contents_of_div('" . $id . "', 'assist.php', 'Function=ValidateInput&Run=1&Worker=" . $worker . "&Header=" . ($headerId) . "&Table=" . $mem['table'] . "&SelectedField=' + document.getElementById('JS_matchArray" . $headerId . "').options[document.getElementById('JS_matchArray" . $headerId . "').selectedIndex].value, true, 'POST', '', false);";
						}
						$matchArray .= "<option " . $ins . " value=\"" . $fieldname . "\">" . htme($desc) . "</option>";
					}
					$matchArray .= "</select></td><td>" . ReturnDropDownSearchField("JS_matchArray" . $headerId . "");

					print "<tr><td>" . htme($headerCell) . "</td><td>" . $matchArray . "</td><td>";


					print '<div id="' . $id . '"></div>';
						print "</td></tr>";
					$headerId++;
				}
				print "</table><p>";
				print "<p id=\"kick_recalc\"><input type=\"checkbox\" name=\"kick_recalculate\" value=\"true\" checked> Immediately recalculate after add or update (when appliccable)</p>";
				print "<p id=\"kick_update\"><input type=\"checkbox\" name=\"kick_trigger\" value=\"true\" checked> Kick record_update and/or record_add trigger.</p>";
				print "<br><br>When you click \"go\" you will actually import or update. Use with care!<br><br>";
				print "<input type=\"hidden\" name=\"Matched\" value=\"true\"></p>";
			} else {
				print "<p>Only one row found. Since the first row must be the header row, this sheet effectively contains zero rows. Quitting.</p>";
				$error = true;
			}

		} elseif ($_POST['Matched'] == "true") {
			$counter =0;
			foreach ($mem['headerData'] AS $headerCell) {
				// print "Match: " . $headerCell . " to " . $_POST['matchArray' . $counter] . "<br>";
				$mem['headerMatchArray'][trim($headerCell)] = trim($_POST['matchArray' . $counter]);

				$counter++;
				$name = trim($headerCell);
				if (substr($mem['headerMatchArray'][$name],0,16) == "updateFlexRecord") {
					$upd=true;
				}
			}

			$error = false;
			$errors = "";

			if (is_numeric($mem['table'])) {
				 if (!$upd) {
					$tab = GetFlextableDefinitions($mem['table']);
					$tab = $tab[0];

				}
			}


			// Double-field check
			$done = array();
			foreach ($mem['headerMatchArray'] AS $header => $destination) {
				if (in_array($destination, $done) && $destination != "none") {
					$error = true;
					$errors .= "<span class=\"errmsg\">Field \"" . htme($header) . "\" was mapped to field \"" . htme(GetExtraFieldName(str_replace("EFID", "", $destination))) . "\" but another field was already mapped to this destination.</span><br><br>";
				}
				$done[] = $destination;
			}

			$mem['sql'] = array();

			if (!$error) {
				$errors = "<table class=\"crm\"><thead><tr><th>Field</th><th>Destination</th><th>Type</th><th>Input value</th><th>Row</th><th>Cell</th><th>Remarks</th></tr></thead>";

				$rowcounter = 1;

				foreach ($mem['arrayData'] AS $row) {



					if (count($row) == count($mem['headerMatchArray']) && $row != $mem['headerData']) {



						$tmpsql = "INSERT INTO " . $mem['SQLtable'] . "(";
						$tmpsql_update_front = "UPDATE " . $mem['SQLtable'] . " SET ";
						$tmpsql_update_args = array();

						$nf = false;
						foreach ($mem['headerMatchArray'] AS $header => $destination) {
							if ($destination != "none") {
								if ($nf) $tmpsql .= ",";
								$tmpsql .= $destination;
								$nf = true;
								if (substr($destination,0,16) == "updateFlexRecord") {
									$update_row = true;
								}
							}
						}

						$tmpsql .= ") VALUES(";
						$nf = false;
						$cnt = 0;
						foreach ($row AS $origdata) {
							$name = trim($mem['headerData'][$cnt]);

							$field = str_replace("EFID", "", $mem['headerMatchArray'][$name]);
							$cnt++;
							if ($mem['headerMatchArray'][$name] != "none") {


								list ($res, $msg, $ret) = ValidateFieldInput($field, trim($origdata), $mem['table']);

								if ($res == "ok") {
									// all ok
									$data = trim($ret);
								} else {
									$data = "";
								}


								if (GetExtraFieldType($field) == "diary") {
									$tmp = explode("\n", $data);
									$data = array();
									foreach ($tmp AS $el) {
										if (trim($el) != "") {
											$data[] = array(date('U'), $GLOBALS['USERID'], $el);
										}
									}
									$data = serialize($data);

								} elseif (GetExtraFieldType($field) == "date/time") {
								} elseif (GetExtraFieldType($field) == "date (iso)") {
									$data = NLDate2INTLDate(FormattedDateToNLDate($data));
								} elseif (strstr(GetExtraFieldType($field), "multiselect")) {
									// Explode on comma, base64 encode each element, and serialize it
									$data = serialize(array_map("base64_encode", explode(",", $data)));
								}
								if (substr($data,0,10) != "{{{nok}}}}") {
									if ($nf) $tmpsql .= ",";
									$tmpsql .= "'" . mres($data) . "'";

									if ($update_row) {
										if (substr($mem['headerMatchArray'][$name],0,16) == "updateFlexRecord") {

											if ($mem['headerMatchArray'][$name] == "updateFlexRecord") {

												$tmpsql_update_back = " WHERE CRMflextable" . $mem['table'] . ".recordid = '" . mres($data) . "'";

											} else {
												$to_field = str_replace("updateFlexRecord-", "", $mem['headerMatchArray'][$name]);
												$tmpsql_update_back = " WHERE CRMflextable" . $mem['table'] . "." . $to_field . " = '" . mres($data) . "'";

											}

										} else {
											if (trim($data) != "") {
												$tmpsql_update_args[] = $mem['headerMatchArray'][$name] . " = '" . mres($data) . "'";
											}
										}
									}
									$nf = true;
								} else {
									$error = true;
									$displayfield = $field;
									$type = GetExtraFieldType($field);
									$errors .= "<tr><td>" . $name . "</td><td>" . GetExtraFieldName($displayfield) . "</td><td>" . $type . "</td><td>\"" . htme(trim($origdata)) .  "\" </td><td>" . $rowcounter . "</td><td>" . $cnt . "</td><td>";
									if (GetExtraFieldType($field) == "drop-down") {
										$errors .= " Valid values for this field are: ";
										foreach (GetExtraFieldOptions($field) AS $option) {
											$errors .= htme($option) . " ";
										}
									} elseif (GetExtraFieldType($field) == "numeric") {
										$errors .= "Field must be numeric";
									} elseif (GetExtraFieldType($field) == "mail") {
										$errors .= "Field must contain a valid email address";
									} elseif (GetExtraFieldType($field) == "date") {
										$errors .= "Field must contain a valid date in format: " . $GLOBALS['UC']['DateFormat'];
									} else {
										$errors .= "unknown error.";
									}
									$errors .= "</td></tr>";
								}
							} else {
								 print "skip";
							}

						}
												$tmpsql .= ")";
						$nnf = false;
						if ($update_row) {
							$tmp = $tmpsql_update_front;
							foreach ($tmpsql_update_args AS $ar) {
								if ($nnf) $tmp .= ",";
								$tmp .= $ar;
								$nnf = true;
							}
							$tmp .= $tmpsql_update_back;
							if ($nnf) {
								$mem['sql'][] = $tmp;
							}
						} else {
							$mem['sql'][] = $tmpsql;
						}

					} else {
						// skip!
						print "skip";
						print "Incorrect row element length: " . count($row) . " != " . count($mem['headerMatchArray']) . "<br>";
						//$errors .= "<tr><td colspan='7'>Incorrect row element length: " . count($row) . " != " . count($mem['headerMatchArray']) . "</td><td>";
						//$error = true;
					}
					$rowcounter++;
				}
				$errors .= "</table>";
			}

			if ($error) {
				print "This data cannot be imported because errors were encountered:<br><br>" . $errors;
			} else {
				$GLOBALS['CRON_RUNNING'] = true;
				print "Number of generated queries: " . count($mem['sql']) . "<br>";
				foreach ($mem['sql'] AS $sql) {
					mcq($sql);
					//print $sql . "<br>";
					$new_id = db_GetInsertId();

					$dstable = $mem['table'];

					if (ipi($dstable)) {
						$dstable = "t" . $dstable;
					}

					add_default_values_for_fields($dstable, $new_id, array());


					// Create default fields and kick triggers


				}
				if ($update_row) {
					print "Done; records updated.";
				} else {
					print "Done; records imported.";
				}
				$error = true;
			}
		}


	}
}
UpdateStashvalue($worker, $mem);
print "<input type=\"hidden\" name=\"Worker\" value=\"" . $worker . "\">";
if (!$error) {
	print "<input type=\"submit\" name=\"submitButton\" value=\"" . $lang['go'] . "\">";
}
print "</form>";
if ($js_add != "") {
	print "<script type=\"text/javascript\">\n";
	print "<!--\n";
	print "var t = setTimeout('StartInit()', 1500);\n";
	print "function StartInit() {\n";
	print "alert('This procedure will now try to validate each auto-matched field.');\n";
	print $js_add;
	print "}\n";
	print "//-->\n";
	print "</script>\n";
}
EndHTML();

function CheckIfUserIsAllowedToImportInTable($tableid) {
	if (is_administrator()) {
		return true;
	} elseif ($tableid == "users" && CheckFunctionAccess("AllowedToImportUsers") == "ok") {
		return true;
	} elseif (is_numeric($tableid) &&CheckFunctionAccess("AllowedToImportFT" . $tableid) == "ok") {
		return true;
	} else {
		return false;
	}
}
?>
