<?php
/* ********************************************************************
 * Interleave
 * Copyright (c) 2001-2016 Atomos Applications The Netherlands - www.atomos.nl - info@atomos.nl - www.interleave.nl - info@interleave.nl
 * Licensed under the GNU GPL. For full terms see the file COPYING.
 *
 * listlayout.php
 *
 * Check http://www.interleave.nl/ for more information
 *
 * BUILD / RELEASE :: 6.2.0.20151223
 *
 **********************************************************************
 */

require "initiate.php";

ShowHeaders();

$table = $_GET['table'];

if ($table != "")
{
	if (!is_array($GLOBALS['UC']['PersonalDataStructure'][$table]))
	{
		$errortext = "Table \"" . $table . "\" does not exist or no access";
		PrintAD($errortext);
		log_msg("WARNING: " . $errortext);
	}
/*	else if (!$GLOBALS['UC']['PersonalDataStructure'][$table]["MaySelectColumns"])
	{
		$errortext = "Column selection not allowed for \"" . $table . "\"";
		PrintAD($errortext);
		log_msg("WARNING: " . $errortext);
	}*/
	else
	{
		//deze array is gedupliceerd in listlayout.php en in make_list in listfunctions.php dat is slordig
		$list_outputtypes_download = array("tsv", "xml", "excel");

		$download = "";
		if (in_array($_GET['download'], $list_outputtypes_download))
		{
			$download = $_GET['download'];
		}

		$listtype = "system";
		$entity = 1;
		$listname_without_listtype = "";

		//listname bevat een combi van listtype + naam
		if ($_GET['listname'] != "")
		{
			if (preg_match("/^(system|user)-(.*)$/", $_GET['listname'], $match))
			{
				$listtype = $match[1];
				$listname_without_listtype = $match[2];
			}
		}
		//listtype + naam is los opgeslagen
		else if ($_GET['listtype'] != "")
		{
			if (preg_match("/^(system|user)$/", $_GET['listtype'], $match))
			{
				$listtype = $match[1];
				$listname_without_listtype = $_GET['listname_without_listtype'];
			}
		}

		if ($listtype == "user")
		{
			$entity = $GLOBALS['USERID'];
			//een admin mag ook de lists van een andere user aanpassen
			if ((is_administrator()) && ($_GET['userid'] > 0))
			{
				$entity = $_GET['userid'];
			}
		}

		$attribute = "List-layout-" . $table . "-" . $listname_without_listtype;

//		$listname = $listtype . "-" . $listname_without_listtype;

		$listlayout = array();

		$showform = true;

		if ($_GET['NewListLayout'] == 1)
		{
			$save_as_listtype = $listtype;
			$save_as_entity = $entity;

			if (!is_administrator())
			{
				//een aangepaste system list wordt voor een normale user als een USER list opgeslagen
				$save_as_listtype = "user";
				$save_as_entity = $GLOBALS['USERID'];
			}

			$save_as_listname = $save_as_listtype . "-" . $listname_without_listtype;

			if ($_GET['commalist'] != "")
			{
				$listlayout = explode(",", $_GET['commalist']);
			}

			SetAttribute($save_as_listtype, $attribute, $listlayout, $save_as_entity);
			$showform = false;
			if ($_GET['listid'] != '')
			{
				$goto_listname = $save_as_listname;
				if (count($listlayout) == 0)
				{
					$goto_listname = "system-";
				}
				print '<script type="text/javascript">';

				if ($download == "")
				{
					print 'WhosMyDaddy().ListSetListname(\'' . jsencode($_GET['listid']) . '\',\'' . jsencode($goto_listname) . '\');';
				}
				else
				{
					print 'WhosMyDaddy().ListSetOutputtypeDownload(\'' . jsencode($_GET['listid']) . '\',\'' . jsencode($download) . '\',\'' . jsencode($goto_listname) . '\');';
				}

				print 'CloseMe();';
				print '</script>';
			}
			else
			{
				print 'List saved, <a href="?">back</a>';
			}
		}
		else
		{
			$listlayout = GetAttribute($listtype, $attribute, $entity);
		}

		if ($showform)
		{
			$listname_this_display = $lang["listlayout-" . $listtype] . " ";
			if ($listname_without_listtype != "")
			{
				$listname_this_display .= $listname_without_listtype;
			}
			else
			{
				$listname_this_display .= $lang["listlayout-default"];
			}
			print '<h1>' . htme($GLOBALS['UC']['PersonalDataStructure'][$table]["plural"] . ' ' . $listname_this_display) . '</h1>';

			print '<form method="get" action="listlayout.php" onsubmit="ListLayoutMakeCommaList()">';

			if (is_administrator())
			{
				foreach (array("system", "user") as $type)
				{
					print '<div><input type="radio" name="listtype" value="' . $type . '" id="listtype' . $type . '"';
//2016-04-04 op verzoek Hidde standaard naar user list ipv system
//					if ($type == $listtype)
					if ($type == "user")
					{
						print ' checked';
					}
					print '> <label for="listtype' . $type . '"';
					if ($type == "system")
					{
						print ' class="warnmsg"';
					}
					print '>' . $type . '</label>';
					print '</div>';
				}
				print 'userid <input type="text" name="userid" value="' . htme($_GET['userid']) . '">';
			}
			else
			{
				print '<input type="hidden" name="listtype" value="' . htme($listtype) . '">';
			}


			print '<input type="hidden" name="table" value="' . htme($table) . '">';
			print '<input type="hidden" name="nonavbar" value="' . htme($_GET['nonavbar']) . '">';
			print '<input type="hidden" name="listid" value="' . htme($_GET['listid']) . '">';
			print '<input type="hidden" name="commalist" id="commalist" value="">';
			print '<input type="hidden" name="download" value="' . htme($download) . '">';

			print '<input type="hidden" name="NewListLayout" value="1">';
			if ($download == "")
			{
				print '<div>' . htme($lang['listlayout-name']) . ' <input type="text" name="listname_without_listtype" value="' . htme($listname_without_listtype) . '"></div>';
			}
			else
			{
				print '<input type="hidden" name="listname_without_listtype" value="' . htme($listname_without_listtype) . '">';
			}

			print '<table><tr><td colspan="2">';
			print '<h2><span id="number_of_availablecolumns"></span> ' . htme($lang['listlayout-available']) . '</h2>';
			print '</td><td colspan="2">';
			print '<h2><span id="number_of_selectedcolumns"></span> ' . htme($lang['listlayout-visible']) . '</h2>';
			print '</tr></tr>';

			print '<tr><td>';

			print '<select name="availablecolumns" id="availablecolumns" multiple size="15" ondblclick="ListLayoutAddColumns()">';
			foreach ($GLOBALS['UC']['PersonalDataStructure'][$table]['allfields'] as $key)
			{
				$table_parts = explode("-", $key);
				$LL_field = $table_parts[count($table_parts)-1];
				$LL_table = $table_parts[count($table_parts)-2];
				if (!$GLOBALS['UC']['PersonalDataStructure'][$LL_table]["fields"][$LL_field]["hide_from_list"])
				{
					print '<option value="' . htme($key) . '">' . htme(fieldalias_to_fullname($key, false));
					//2e conditie is nodig om niet dezelfde naam tussen haken weer te geven -> wanneer een displaylistname gebruikt wordt om het volle pad te onderdrukken in child tabellen
					if (($GLOBALS['UC']['PersonalDataStructure'][$LL_table]["fields"][$LL_field]["displaylistname"] != "") && ($GLOBALS['UC']['PersonalDataStructure'][$LL_table]["fields"][$LL_field]["displaylistname"] != $GLOBALS['UC']['PersonalDataStructure'][$LL_table]["fields"][$LL_field]["name"]))
					{
						print ' (' . htme($GLOBALS['UC']['PersonalDataStructure'][$LL_table]["fields"][$LL_field]["displaylistname"]) . ')';
					}
					print '</option>';
				}
			}

			print '</select>';
			print ReturnDropDownSearchField("availablecolumns");


/*
			print '<script type="text/javascript">
function ListLayoutAddColumn(value, text)
{
var selectedcolumns = document.getElementById(\'selectedcolumns\');
selectedcolumns.options[selectedcolumns.length] = new Option(value, value);
ListLayoutCountColumns();
}
</script>';

			print '<div style="font-size: 125%; height: 280px; overflow: auto; padding: 5px; background-color: #fff; border: 1px solid #333;">';
			print ascend_to_parents($table);
			print '</div>';

// style="height: 280px; background-color: #fff; border: 1px solid #333;"
*/

			print '</td><td>';
			print '<a onclick="ListLayoutRemoveColumns()"><span class="fa fa-arrow-left"></span></a> ';
			print '<a onclick="ListLayoutAddColumns()"><span class="fa fa-arrow-right"></span></a>';
			print '</td>';

			print '<td>';
			print '<select name="selectedcolumns[]" id="selectedcolumns" multiple size="15" ondblclick="ListLayoutRemoveColumns()">';
			foreach ($listlayout as $key)
			{
				$table_parts = explode("-", $key);
				$LL_field = $table_parts[count($table_parts)-1];
				$LL_table = $table_parts[count($table_parts)-2];
				//om velden te verbergen die inmiddels bijvoorbeeld verwijderd zijn, of waartoe geen toegang meer is
				if (is_array($GLOBALS['UC']['PersonalDataStructure'][$LL_table]["fields"][$LL_field]))
				{
					print '<option value="' . htme($key) . '">' . htme(fieldalias_to_fullname($key, false));
					//2e conditie is nodig om niet dezelfde naam tussen haken weer te geven -> wanneer een displaylistname gebruikt wordt om het volle pad te onderdrukken in child tabellen
					if (($GLOBALS['UC']['PersonalDataStructure'][$LL_table]["fields"][$LL_field]["displaylistname"] != "") && ($GLOBALS['UC']['PersonalDataStructure'][$LL_table]["fields"][$LL_field]["displaylistname"] != $GLOBALS['UC']['PersonalDataStructure'][$LL_table]["fields"][$LL_field]["name"]))
					{
						print ' (' . htme($GLOBALS['UC']['PersonalDataStructure'][$LL_table]["fields"][$LL_field]["displaylistname"]) . ')';
					}
					print '</option>';
				}
			}
			print '</select>';
			print '</td>';

			print '<td>';
			print '<div><a onclick="ListLayoutMoveUp()"><span class="fa fa-arrow-up"></span></a></div>';
			print '<div><a onclick="ListLayoutMoveDown()"><span class="fa fa-arrow-down"></span></a></div>';
			print '</td>';
			print '</tr></table>';

			print '<input type="submit" value="';
			if ($download == "")
			{
				print htme($lang['save']);
			}
			else
			{
				print htme($lang['downloadexport'] . ' ' . $lang[$download]);
			}
			print '">';

			print '</form>';


			print '
			<script type="text/javascript">
			ListLayoutCountColumns();
			</script>
			';
		}
	}
}
else
{
	PrintAD("Not enough information for column selector");
}

EndHTML();

?>
