<?php
/*********************************************************************
 * Interleave
 * Copyright (c) 2001-2016 Atomos Applications The Netherlands - www.atomos.nl - info@atomos.nl - www.interleave.nl - info@interleave.nl
 * Licensed under the GNU GPL. For full terms see http://www.gnu.org/
 *
 * This script allows editing of any record (or so it should be)
 *
 * Check http://www.interleave.nl/ for more information
 *
 * BUILD / RELEASE :: 7.0.20161227
 *
 **********************************************************************
*/

require ("initiate.php");
$passthru = array();
$passthru['table'] = "";
$passthru['record'] = "";
$no_form = false;
$reload_record = false;

$passthru['BYAJAX'] = false;
if ($_GET['BYAJAX'] == 1) {
    $passthru['BYAJAX'] = true;
}

$show_navigation_decisions = false;

if ($GLOBALS['SesMem']['ShowReasons']) {
    $show_navigation_decisions = true;
}

if ($_GET['humantable'] != "") {
    $passthru['table'] = human_readable_tablename_to_ds_tablename($_REQUEST['humantable']);
    $passthru["table"] = $passthru['table'];
} else {
    $passthru["table"] = $_GET["table"];
}

/* put all stuff from GET in an array (by reference). the array is passed through to get_parsed_template */

$passthru["record"] = & $_GET["record"];
$passthru["dqs"] = & $_GET["dqs"];
$passthru["fromlist"] = & $_GET["fromlist"];
$passthru["nonavbar"] = & $_GET["nonavbar"];
$passthru["ParentAjaxHandler"] = & $_GET["ParentAjaxHandler"];
$passthru["put_id_in_child"] = & $_GET["put_id_in_child"];

/* hardcoded hotfixes for A65, see also below! */
$passthru['AutoCallCompany'] = $_GET['AutoCallCompany'];
$passthru['telefid'] = $_GET['telefid'];


$passthru["listid"] = & $_GET["listid"];
$passthru["duplicate"] = & $_GET["duplicate"];
$passthru["template_to_use"] = & $_GET["template_to_use"];
$passthru["mass_del"] = & $_GET["mass_del"];
$passthru["no_deletes"] = & $_GET["no_deletes"];
$passthru["AddInPopup"] = & $_GET["AddInPopup"];
$passthru["starttable"] = & $_GET["starttable"];
$passthru["startrecordid"] = & $_GET["startrecordid"];

/* raw edit mode. displays a record in an autoform instead of it's own or any other given form (overrules all) */
$edit_raw = false;
if (is_administrator() && isset($_GET['raw'])) {
	$edit_raw = true;
}

if (isset($_GET["SkipMainNavigation"])) {
    $passthru["SkipMainNavigation"] = 1;
}

$passthru["hash"] = & $_POST["hash"];
$passthru['e_button'] = & $_POST['e_button'];
$passthru["delete_confirmed"] = & $_POST["delete_confirmed"];

$passthru["deleting_myself"] = & $_GET["deleting_myself"];
$passthru["delete"] = & $_GET["delete"];

$redirect_on_add = false;

$surely_posted = false;
if (ipi($_POST['concerningrecord'])) {
    $surely_posted = true;
}

//DA($passthru);
$submitted = false;
if ($_POST['form_submitted'] == 1) {
    $submitted = true;
}

/* no fetching from _POST, _GET, _COOKIE or _REQUEST below this line */

/* check which form to use */
$template = $GLOBALS['UC']['PersonalDataStructure'][$passthru['table']]['form-template-id'];

if (ipi($passthru['template_to_use'])) {

    $template = $passthru['template_to_use'];

}
$template_type = "";

if (!ipi($template)) {
    /* it's a default template */
    $template_type = "TEMPLATE_HTML";
} else {
    $template_type = GetTemplateType($template);
}

if ($passthru['BYAJAX']) {

    /* do nothing */
    //print "Ik doe niks aan headers, want BYAJAX";

} elseif (($template_type == "TEMPLATE_XML" || $template_type == "TEMPLATE_REPORT_PDF" || $template_type == "TEMPLATE_PLAIN")) {

    if (ipi($passthru["record"])) {

        $filename = get_parsed_template_with_given_template($passthru["table"], $passthru["record"], array(), array(), false, "", GetTemplateSubject($passthru["template_to_use"]), 'TEMPLATE_PLAIN', false);

        if ($template_type == "TEMPLATE_XML") {

            header("Content-Type: text/xml; charset=UTF-8");

            if (strtolower(substr($filename, strlen($filename) - 4, 4)) != ".xml") $filename.= ".xml";
            header("Content-Disposition: attachment; filename=\"" . clean_filename($filename) . "\"");

        } elseif ($template_type == "TEMPLATE_REPORT_PDF") {

            header("Content-Type: application/pdf; charset=UTF-8");

            /* generate the report */

            $pdf = GetPDFReport($passthru['template_to_use'], $passthru['table'], $passthru['record']);
            header("Content-Disposition: attachment; filename=\"" . clean_filename($pdf['filename']) . "\"");
            print $pdf['pdf'];

        } else {

            header("Content-Type: application/unknown; charset=UTF-8");
            header("Content-Disposition: attachment; filename=\"" . clean_filename($filename) . "\"");
        }

    } else {
        PrintAD("Download template without recordid impossible");
    }

} elseif (!$GLOBALS['UC']['PersonalDataStructure'][$passthru['table']]["datatable"] && $passthru['table'] != "files") {

    $GLOBALS["InAdminSection"] = true;
    // slordig
    if (!$passthru['ParentAjaxHandler']) {
        $_GET['SkipMainNavigation'] = true;
    }
    ShowHeaders();
    AdminTabs();
    MustBeAdmin();
} else {
    ShowHeaders();
}

$access = "nok";
$locked = false;
$lockedby = false;
$add = false;
$update = false;
$delete = false;
$error = false;
$success = false;
$formid = 0;

$stayhere = false;

$current_record = array();

/* constants for getrecord */
$selectallfields = false;
$bypass_record_access_by_sql = false;

/* create fields_to_fetch array. it contais all fields of the current table, no parents */
$fields_to_fetch = array();

if (!ipi($passthru['record']) && $passthru['table'] != "" && $GLOBALS['UC']['PersonalDataStructure'][$passthru['table']]["allowed_to_add"]) {

    $access = "ok";

} elseif (ipi($passthru['record']) && is_array($GLOBALS['UC']['PersonalDataStructure'][$passthru['table']])) {

    foreach (array_keys($GLOBALS['UC']['PersonalDataStructure'][$passthru['table']]["fields"]) AS $field) {
        $fields_to_fetch[] = $passthru['table'] . "-" . $field;
    }

    // load the current_record variable
    $current_record = getrecord($passthru['table'], $passthru['record'], $selectallfields, $bypass_record_access_by_sql, $fields_to_fetch);

    if ($current_record['type_of_access'] == "ok") {

        /* nothing special, access granted, all fine */
        $access = "ok";

        /* insert a lock in the lock table */
        $sql = "INSERT INTO CRMentitylocks(lockby, lockon, locktable, timestamp_last_change) VALUES (" . $GLOBALS['USERID'] . ",'" . mres($passthru['record']) . "','" . mres($passthru['table']) . "', NOW()) ON DUPLICATE KEY UPDATE timestamp_last_change=NOW()";

        mcq($sql);

    } elseif ($current_record['type_of_access'] == "readonly") {

        /* read-only, various reasons */
        $access = "readonly";

        /* check if it's locked */
        if (ipi($current_record['record_locked_by'])) {

            /* yep, it's locked */
            $locked = true;
            $lockedby = $current_record['record_locked_by'];
        }
    }
} else {
    //	DA();
    PrintAD("Unclear what to do.");
}


if ($access != "nok") {
    if (ipi($passthru['record'])) {

        // load the current_record variable
        //		$current_record = getrecord($passthru['table'], $passthru['record'], $selectallfields, $bypass_record_access_by_sql, $fields_to_fetch);
        /* gebeurt al bocven */

    } elseif ($passthru['delete'] == "" && !ipi($passthru["mass_del"]) && $access == "ok") {

        // we're creating a new record
        // insert-record-on-add check (flextables only)
        if (GetAttribute("flextable", "CreateEmptyRecordOnAdd", str_replace("t", "", $passthru['table'])) == "Yes") {

            /* data array to hold values for process_record_save */

            /* set TLSC to 1970 to be able to recognize this record as added, but never "touched" */
            $data = array($passthru['table'] . "-timestamp_last_change-_new_" => "1970-01-02 00:00:00");

            foreach ($GLOBALS['UC']['PersonalDataStructure'][$passthru['table']]["fields"] AS $fieldname => $fieldproperties) {

                /* skip timestamp_last_change */
                if ($fieldname != 'timestamp_last_change') {

                    $fieldnum = str_replace("f", "", $fieldname);
                    $fqn = $passthru['table'] . "-" . $fieldname;
                    $fqn = $passthru['table'] . "-" . $fieldname;
                    $posted_value = "";

                    if (isset($_REQUEST['EFID' . $fieldnum]) != "") {
                        $posted_value = trim($_REQUEST['EFID' . $fieldnum]);
                    } elseif ($_REQUEST[$passthru['table'] . "-" . $fieldname] != "") {
                        $posted_value = trim($_REQUEST[$passthru['table'] . "-" . $fieldname]);
                    } elseif ($_REQUEST[$passthru['table'] . "-" . $fieldname . '-_new_'] != "") {
                        $posted_value = trim($_REQUEST[$passthru['table'] . "-" . $fieldname . '-_new_']);
                    }

                    if ($posted_value != "") {
                        $data[$passthru['table'] . "-" . $fieldname . '-_new_'] = $posted_value;
                    }
                }
            }

            list($success, $passthru['record'], $messages) = process_record_save($passthru['table'], 0, $data, array(), "ok");

            if ($success) {

                $passthru['starttable'] = $passthru['table'];
                $passthru['startrecordid'] = $passthru['record'];

                // Re-fetch the record
                $current_record = getrecord($passthru['table'], $passthru['record'], false, false, array());
                $add = true;
                $redirect_on_add = true;
                // If a parent is known, refresh it immediately
                if ($passthru['ParentAjaxHandler'] != "") {
                    print JS("
                        reload_lists_and_calculations_in_all_parents('" . htme($_REQUEST['ParentAjaxHandler']) . "');
                        //WhosMyDaddy().ReloadAjaxElement('" . jsencode($passthru['ParentAjaxHandler']) . "');
                    ");
                }
            } else {
                print '<span class="errmsg">' . htme($messages) . '</span>';
            }

        }

    }

    /* determine the type of event */
    if (!ipi($passthru['record']) && $submitted && $access == "ok") {

        /* adding a new record */
        $add = true;

        /* check for double adds - only when NOT in development. in development it's handy to be able to hit refresh */
        if ($passthru['hash'] != "" && GetSetting("DevelopmentOrProduction") != "Development") {

            /* check the cache table the same hash */
            $recentlyadded = db_GetValue("SELECT COUNT(*) FROM CRMcache WHERE value='" . mres($passthru['hash']) . "'");

            if (ipi($recentlyadded)) {

                /* log a message. do we need this? */
                log_msg("WARNING: A user tried to post an add-record form twice. Ignoring this post and warning the user and quitting.");

                /* show a message */
                PrintAD("Avoided adding the same record twice. Try not to hit refresh after submitting a form; you will be submitting it twice.");

                /* deny access */
                $add = false;

                $update = true;
                $submitted = false;

            } else {

                /* save the hash to check later */
                PushStashValue($passthru['hash']);
            }

        }

    } elseif ($passthru['delete'] != "" || ipi($passthru["mass_del"]) && $access == "ok") {

        /* delete or mass-delete */
        $delete = true;

    } elseif ($submitted == 1 && $access == "ok") {

        /* generic update */
        $update = true;


    } else {
        /* don't know. error. following conditions will make sure nothing happens. */

    }
    if (($delete || ipi($passthru["mass_del"])) && $access == "ok") {

        $list_of_records = array();

        /* check for mass delete */
        if (ipi($passthru["mass_del"])) {

            /* get list of records from stash */
            $list_of_records_sql = PopStashValue($passthru["mass_del"]);

            /* run given query for list of records */
            if ($list_of_records_sql != "") {
                $list_of_records = db_GetFlatArray($list_of_records_sql);
            } else {
                /* failsafe */
                $list_of_records = array();
            }
        } else {

            /* if not, put single record in array as only element and simulate mass delete with only 1 given record */
            $list_of_records = array($passthru['record']);
        }

        $s = '';

        /* example of a record which only has itself to delete */
        /*
        Array
        (
        [t8] => Array
        (
        [ok] => 1
        [nok] => 0
        )

        )
        */
        $list_to_delete = delete_record_including_childs($passthru['table'], $list_of_records, true);

        $onlyone = false;
        if (count($list_to_delete) == 1 && $list_to_delete[$passthru['table']]['ok'] == 1 && $list_to_delete[$passthru['table']]['nok'] == 0) {
            /* do nothing */
            $onlyone = true;
        }
        if (count($list_to_delete) == 1 && $list_to_delete[$passthru['table']]['ok'] == 0 && $list_to_delete[$passthru['table']]['nok'] == 1) {
            $onlyone = true;
        }

        $s.= '<ul>';

        foreach ($list_to_delete AS $item => $count) {

            /* set error if the record cannot be deleted */
            if ($count['nok'] > 0) {
                $error = true;
            }

            /* get plural name from ds */
            $name = $GLOBALS['UC']['PersonalDataStructure'][$item]['plural'];

            /* if none, overrule with language tag */
            if ($name == "") $name = $lang[$item];

            $s.= '<li>' . htme($name) . ': ' . FormatNumber($count['ok'], 0, false, true);

            if ($count['nok'] > 0) $s.= ' ' . $lang['allowed'] . ', <span class="errmsg">' . FormatNumber($count['nok'], 0, false, true) . '</span>  ' . $lang['notallowed'];

            if ($count['files'] > 0) {
                /* add number of files to delete */

                $s.= ', ';

                if ($count['files'] > 1 || $count['files'] == 0) {
                    /* plural */
                    $s.= $lang['files'];
                } else {
                    $s.= $lang['file'];
                }
                $s.= ': ' . FormatNumber($count['files'], 0, false, true);

            }
            $s.= '.</li>';

        }
        $s.= '</ul>';

        /* done loading, hide the wait image div which was chown by the delete button */
        print JS("WhosMyDaddy().HWID('MainContent');");

        if (!$error) {

            if ($passthru["delete_confirmed"] == 1) {

			    // delete_record_including_childs handles todo's / triggers / rules / files etc including security
                delete_record_including_childs($passthru['table'], $list_of_records, false);

            } else {

                /* determine message text */

                if (GetAttribute("flextable", "DeleteConfirmationMessage", str_replace("t", "", $passthru['table'])) != "") {
                    print '<h2>' . GetAttribute("flextable", "DeleteConfirmationMessage", str_replace("t", "", $passthru['table'])) . '</h2>';
                } else {
                    print '<h2>' . htme($lang['areyousure']) . '</h2>';
                }
                if (!$onlyone) print '<p>' . htme($lang['explaindescendingdeletes']) . '</p>';

                print '<form autocomplete="off" method="post" action="" id="JS_delete_confirm_form" onsubmit="$(\'#JS_delete_confirm\').prop(\'disabled\', true);SWID();">';
                print '<input type="hidden" name="delete_confirmed" value="1">';
                print '<input type="submit" value="' . $lang['go'] . '" id="JS_delete_confirm">&nbsp;';
                print '<input type="button" onclick="CloseMe();" value="' . $lang['cancel'] . '" id="JS_cancel">';
                print '</form>';
                print $s;
                /* input for the navigation section below; prevent the record template from being printed */
                $no_form = true;

            }

        } else {
            print $s;
            print '<br>' . $lang['dependenciespreventtheremovalofthisrecord'];

            $no_form = true;
        }

    } elseif ($submitted && $access == "ok") {

        /* the main record-add-and-save handler */


        list($success, $record, $messages) = process_record_save($passthru['table'], $passthru['record'], $_POST, $current_record, $access);

        if (!$success) {

            $update = false;
            $add = false;

        } else {

            $passthru['record'] = $record;
			$reload_record = true;

        }

        foreach ($messages AS $msg) {
            print '<div class="errmsg">' . htme($msg) . '</div>';
        }

    }

    if (($success || $surely_posted) && $access == "ok") {

        /* save any attached files */
        /*
         *
         * THIS SHOULD BE MOVED TO process_record_save ?
         *
        */

        $message = SaveFiles($_FILES['file_upload'], $passthru['record'], $passthru['table'], $_POST['hiddenfilter']['files-folder'][0], $_POST['file_NewOrNewVersionOf'], $_POST['newfolder']);

        /* we're not using the output */
        unset($message);
    }

    /* always process buttons, even if nothing was changed */
    if ($passthru['e_button'] && $access == "ok") {

        $x = GetAllButtons($passthru['e_button']);

        if ($x[0]['fieldtype'] == "Button") {

            if (is_array($GLOBALS['UC']['PersonalDataStructure'][$passthru['table']]['fields']['f' . $passthru['e_button']])) {

                // So, a button was pressed (and the user has the rights to press it)
                qlog(INFO, "An field button was pressed. Processing triggers.");
                Processrules($passthru['table'], $passthru['record'], "f" . $passthru['e_button'], "pressed", "");

                journal($passthru['record'], "User pressed button " . $x[0]['id'] . "::" . $x[0]['name'], ds_tablename_to_journal_tabletype($passthru['table']));

				        $reload_record = true;

                // Since a button was pressed, we don't go back to the list but stay here by default
                $stayhere = true;
                $tmp = GetAttribute("extrafield", "BackToListAfterSave", $x[0]['id']);

                if ($tmp == "Yes") {

                    $stayhere = false;
                    if ($show_navigation_decisions) print Alert('Stayhere NOT set, a non-default save button was pressed, but BackToListAfterSave is Yes');

                } elseif ($tmp == "No") {

                    $stayhere = true;
                    if ($show_navigation_decisions) print Alert('Stayhere set, a non-default save button was pressed');

                } else {

                    if ($show_navigation_decisions) print Alert('Stayhere set, a non-default save button was pressed');
                }

                $js = GetAttribute("extrafield", "JavascriptActionAfterSubmit", $x[0]['id']);
                if (trim($js) != "") {
                    if ($show_navigation_decisions) print Alert('Excute arbitrary javascript code after a form submit ' . inline_jsencode($js));
                    //					$GLOBALS['JavascriptToPrintAtEndOfPage_OnlyJS'][] = $js;
                    print '<script type="text/javascript">
					<!--
						' . $js . '
					//-->
					</script>';
                }

                $update = true;
            } else {
                log_msg("ERROR: Somebody pressed a button, which he/she has no access to or the button is not for this table (" . $passthru['e_button'] . ")");
            }
        } else {
            qlog(INFO, "form_submitted button field is not a button, not triggering! (" . $passthru['e_button'] . ")");
        }
    } else {
        qlog(INFO, "No buttons in submit, not triggering for buttons!");
    }

    /* always process todo's because even if there's noting done, values could still have been changed using autosave */
    if (ipi($passthru['record'])) {
        process_open_todos($passthru['table'], $passthru['record']);
    }

    $redirect_on_add = true;

    /* DIRTY / TODO: check $GLOBALS['JavascriptToPrintAtEndOfPage_OnlyJS'] to see if there are doc.loc settings in there. If so, don't redir on add */
    foreach ($GLOBALS['JavascriptToPrintAtEndOfPage_OnlyJS'] AS $line) {
        if (strpos($line, "window.location.href") !== false || (strpos($line, "document.location") !== false)) {
            $redirect_on_add = false;
            $no_form = true;
            //print 'OVERRIDE';
            //DA($GLOBALS['JavascriptToPrintAtEndOfPage_OnlyJS'], false);
            continue;
        }
    }

    /* check if this table has a setting forcing forms to return instead of going back to the list */
    if ($GLOBALS['UC']['PersonalDataStructure'][$passthru['table']]['stayinform']) {
        $stayhere = true;
        if ($show_navigation_decisions) print Alert('Stayhere set, table prop stayinform is true');

    }

    /* NO CHANGES TO $stayhere BELOW THIS POINT */

    /* put id in parent when applicable */
    if ($submitted && $access == "ok") {
        if ($passthru["put_id_in_child"] != "") {

	//we zijn bezig met het aflopen van een selectvia path; en moet nu een nieuwe lijst inladen om de volgende stap te zetten
	//dit is geen fraaie oplossing want in put_id_in_child staat het woord "selectvia" gevolgd door de base64 gecodeerde volgende url waar alleen nog het net toegevoegde recordid achter gezet moet worden
          if (preg_match("/^selectvia(.*)$/", $passthru["put_id_in_child"], $match))
          {
            $next_selectvia_url = base64_decode($match[1]) . $passthru['record'];
            $passthru['fromlist'] = base64_encode($next_selectvia_url);
          }
          else
          {
            print JS("put_id_in_child('" . $passthru["put_id_in_child"] . "', '" . $passthru['record'] . "', '" . jsencode(get_refer_layout_for_record($passthru['table'], $passthru['record'])) . "');");
          }

        }
    }

    /* compose open link */
    $my_openlink = $GLOBALS['UC']['PersonalDataStructure'][$passthru['table']]['openlink'] . $passthru['record'];

    $my_openlink_addons = "";

    if (ipi($passthru['dqs'])) 					$my_openlink_addons.= '&dqs=' . $passthru['dqs'];

    if (!$add) {
        if (ipi($passthru['startrecordid'])) 	$my_openlink_addons.= '&startrecordid=' . $passthru['startrecordid'];
        if ($passthru['starttable'] != "") 		$my_openlink_addons.= '&starttable=' . $passthru['starttable'];
    }
    if ($passthru['fromlist'] != "") 			$my_openlink_addons.= '&fromlist=' . $passthru['fromlist'];
    if ($passthru['ParentAjaxHandler'] != "") 	$my_openlink_addons.= '&ParentAjaxHandler=' . $passthru['ParentAjaxHandler'];
    if ($passthru['nonavbar'] != "") 			$my_openlink_addons.= '&nonavbar=' . $passthru['nonavbar'];
    if ($passthru['listid'] != "") 				$my_openlink_addons.= '&listid=' . $passthru['listid'];
    if ($passthru['SkipMainNavigation']) 		$my_openlink_addons.= '&SkipMainNavigation';

    /* hardcoded hotfixes for A65 */
    if ($passthru['AutoCallCompany'] != "") 	$my_openlink_addons.= '&AutoCallCompany=' . $passthru['AutoCallCompany'];
    if ($passthru['telefid'] != "") 			$my_openlink_addons.= '&telefid=' . $passthru['telefid'];

    if ($my_openlink_addons != "") {
	if (!strstr($my_openlink, "?")) {

            /*
            UseURLBeautification links end like /Equipment/12123 so we need to add a ?
            as all my_openlink_addons start with &, we can safely strip the first char of the string
            */
            $my_openlink.= "?" . substr($my_openlink_addons, 1, strlen($my_openlink_addons) - 1);

        } else {

            /* normal links end like ?table=t12%record= so just add &... &.... */
            $my_openlink .= $my_openlink_addons;

        }
    }

    if ($submitted && !$stayhere) { // the form was form_submitted and something was changed, determine what to do unless $stayhere is already set

        if ($passthru['ParentAjaxHandler'] != "") {
            $no_form = true;
            // A normal form submit in a popup
            if ($show_navigation_decisions)
            {
                print Alert('Normal submit. Reload all parents ' . $_REQUEST['ParentAjaxHandler'] . ' and close this window.');
            } else {
                $GLOBALS['JavascriptToPrintAtEndOfPage_OnlyJS'][] = "

				reload_lists_and_calculations_in_all_parents('" . htme($_REQUEST['ParentAjaxHandler']) . "');

				CloseMe();

			";
            }
        } elseif ($passthru['AddInPopup'] == 1) {
            if ($show_navigation_decisions) {
                print Alert('Add-in-popup. Close this window.');
            } else {
                $GLOBALS['JavascriptToPrintAtEndOfPage_OnlyJS'][] = "CloseMe();";
            }
        } elseif ($passthru['fromlist'] != "") {
            if ($show_navigation_decisions) {
                print Alert('Normal submit. Reload nothing, show no form, go back to list: ' . $passthru['fromlist']);
            } else {
                $no_form = true;

                // A normal form submit, go back to the list
                $GLOBALS['JavascriptToPrintAtEndOfPage_OnlyJS'][] = "
    				window.location.href = '" . jsencode(base64_decode($passthru['fromlist'])) . "';
    			";
            }
        } else {
            // Could not find any navigation instructions.
            if ($add && $redirect_on_add) {
                //header('Location: record.php?table=' . $passthru['table'] . '&record=' . $passthru['record']);
                if ($show_navigation_decisions) {
                    print Alert('Add-action. Redirect to default open-link in current window.');
                } else {
                    $GLOBALS['JavascriptToPrintAtEndOfPage_OnlyJS'][] = '
						window.location.href = getbase() + "' . $my_openlink . '";
				        ';
                }

                $no_form = true;
            }
        }
    } else if ($delete && $passthru["delete_confirmed"] == 1 && $passthru["fromlist"] == "" && $passthru['ParentAjaxHandler'] == "") {

        // no navigation information. close myself, en try to close the parent. will work if it's a popup, but this is a guess


		print $lang['wasdeleted'];
        $no_form = true;
        if ($show_navigation_decisions) {
            print Alert('Delete-action. Close current window, place message in MainContent div of parent');
        } else {
            $GLOBALS['JavascriptToPrintAtEndOfPage_OnlyJS'][] = "
    				WhosMyDaddy().$('#MainContent').html('Record " . $passthru['record'] . " " . jsencode($lang['wasdeleted']) . "');

    			";
    		$GLOBALS['JavascriptToPrintAtEndOfPage_OnlyJS'][] = "CloseMe();";
        }
    } else if ($passthru['ParentAjaxHandler'] != "" && $delete && $passthru["delete_confirmed"]) {


        // a record was deleted, and it was in a popup (hence ParentAjexHandler) in a popup (yes, twice)
        $no_form = true;

        if ($show_navigation_decisions) {
            print Alert('Delete-action. Reload all parents ' . $_REQUEST['ParentAjaxHandler'] . ' and close this window if 1== ' . $passthru['deleting_myself']);
        } else {
            if ($passthru['deleting_myself'] == 1) {
                $GLOBALS['JavascriptToPrintAtEndOfPage_OnlyJS'][] = ' WhosMyDaddy().reload_lists_and_calculations_in_all_parents("' . htme($_REQUEST['ParentAjaxHandler']) . '");';
            } else {
                $GLOBALS['JavascriptToPrintAtEndOfPage_OnlyJS'][] =  ' reload_lists_and_calculations_in_all_parents("' . htme($_REQUEST['ParentAjaxHandler']) . '");';
            }
            if ($passthru['deleting_myself'] == 1) {
                $GLOBALS['JavascriptToPrintAtEndOfPage_OnlyJS'][] = ' WhosMyDaddy().CloseMe();';
            }
            $GLOBALS['JavascriptToPrintAtEndOfPage_OnlyJS'][] =  'CloseMe();';
        }

    } else if ($delete && $passthru["delete_confirmed"] == 1 && $passthru["fromlist"] != "") {

        $no_form = true;
        // a record was deleted, and the URL where user was before is known. we are in NOT a popup

        if ($show_navigation_decisions) {
            print Alert('Delete-action. Redirect parent to ' . $passthru['fromlist'] . ' if 1== ' . $passthru['deleting_myself']);
        } else {

            if ($passthru['deleting_myself'] == 1) {
                //print JS("CloseMe();");
                $GLOBALS['JavascriptToPrintAtEndOfPage_OnlyJS'][] = "
    				WhosMyDaddy().window.location.href = '" . jsencode(base64_decode($passthru['fromlist'])) . "';
    			";
            }

        }
    } else if ($submitted && $stayhere && $passthru['ParentAjaxHandler'] != "") {

        // In this case a record was saved, and something told us to stay here. Nevertheless the parent list needs to be reloaded.
        if ($show_navigation_decisions) {

            $GLOBALS['JavascriptToPrintAtEndOfPage_OnlyJS'][] = " alert('Some save action, but stayhere is true. ParentAjaxHandler exists: " . $_REQUEST['ParentAjaxHandler'] . ", which is used for reloading all parents. If 1==" . $redirect_on_add . " and 1==" . $add . " the current window will be redirected to the default openlink " . $my_openlink . "');";

        } else {

            $GLOBALS['JavascriptToPrintAtEndOfPage_OnlyJS'][] = '
    					reload_lists_and_calculations_in_all_parents("' . htme($_REQUEST['ParentAjaxHandler']) . '");
    			';
            if ($add && $redirect_on_add) {
                $GLOBALS['JavascriptToPrintAtEndOfPage_OnlyJS'][] = '

    							window.location.href = getbase() + "' . $my_openlink . '";
    					';
            }
        }
    } else {
        if ($add && $redirect_on_add) {

            if ($show_navigation_decisions) {
                print Alert('Add-action. The current window will be redirected to the default openlink ' . $my_openlink);
            } else {

                //header('Location: record.php?table=' . $passthru['table'] . '&record=' . $passthru['record']);
                /* hack; avoid using JavascriptToPrintAtEndOfPage_OnlyJS because that won't work in webapp */
                print '<script>window.location.href = getbase() + "' . $my_openlink . '";</script>';
                $no_form = true;
            }
        }
    }

    if (!$no_form) {

		if ($reload_record) {

			/* reload current record and re-check access because access can be changed */
			$current_record = getrecord($passthru['table'], $passthru['record'], $selectallfields, $bypass_record_access_by_sql, $fields_to_fetch);

			/* default */
			$access = "nok";

			if ($current_record['type_of_access'] == "ok") {

				/* nothing special, access granted, all fine */
				$access = "ok";

			} elseif ($current_record['type_of_access'] == "readonly") {

				/* read-only, various reasons */
				$access = "readonly";
			}

			//print "Record reloaded, access is now " . $access . " : table " . $passthru['table'] . ", record " . $passthru['record'];
			//DA($current_record, false);
		}

        if (is_array($GLOBALS['UC']['PersonalDataStructure'][$passthru['table']])) {

            /* log this view-event */
            journal($passthru['record'], "Record viewed", ds_tablename_to_journal_tabletype($passthru['table']));

            /* if anything fails, we use the autoform by default */
            $force_autoform = true;

            /* check DS if this table has a form template id set DANGEROUS: we're assuming here that this is a form request, unless template_to_use is set which overrules all */
            if ((ipi($GLOBALS['UC']['PersonalDataStructure'][$passthru['table']]['form-template-id']) || ipi($passthru['template_to_use'])) && !$edit_raw) {
                $force_autoform = false;
            }

            if ($template_type == "TEMPLATE_REPORT_PDF") {

                /* don't output anything here, already done */

            } else {

                /* get_parsed_template does some checking on the templates too */
                $output = get_parsed_template($passthru['table'], $passthru['record'], $passthru, $current_record, $force_autoform, $access);

                /* a more or less normal or unknown template type, just yank it through */
                print $output;

            }

        } else {

            PrintAD("Error: table " . $passthru['table'] . " does not exist or no access (1)");
        }

    }
} else { // end if access != "nok"
    //DA($_REQUEST, false);
    PrintAD("Record access denied or record does not exist : " . $access);
}

if ($template_type == "TEMPLATE_XML" || $passthru['BYAJAX'] || $template_type == "TEMPLATE_REPORT_PDF" || $template_type == "TEMPLATE_PLAIN") {

    EndHTML(false);
} else {

    EndHTML();
}

?>
