<?php
/* ********************************************************************
 * Interleave
 * Copyright (c) 2001-2016 Atomos Applications The Netherlands - www.atomos.nl - info@atomos.nl - www.interleave.nl - info@interleave.nl
 * Licensed under the GNU GPL. For full terms see the file COPYING.
 *
 * This script can show defined calendars on screen
 *
 * Check http://www.interleave.nl/ for more information
 *
 * BUILD / RELEASE :: 7.0.20161227
 *
 **********************************************************************
 */

function ShowCalendar($listid = "", $view = "", $startdate = "", $listid_div_exists = false, $cals_to_show = "")
{
	global $lang;

	$today = date("Y-m-d");
	$today_num = str_replace("-", "", $today);

	if (!is_valid_iso_date($startdate))
	{
		$startdate = $today;
	}
	//voor selectcal's staat de startdate in de url; dit is de huidig geslecteerde datum (en tijd) van het selectfield. niet zo fraai dit
	if ($_GET['startdate'] != "")
	{
		list($date, $time) = explode(" ", $_GET['startdate']);
		if (is_valid_iso_date($date))
		{
			$startdate = $date;
		}
	}

	$cal_minhour = GetSetting('CAL_MINHOUR');
	$cal_maxhour = GetSetting('CAL_MAXHOUR');

	$html = '';

	if (!preg_match("/^[a-zA-Z][a-zA-Z0-9]+$/", $listid))
	{
		//default listid for calendar
		$listid = "cal";
		$listid_div_exists = false;
	}

	$lastsettings = GetAttribute("user", "LastCalendarSettings-" . $listid, $GLOBALS['USERID']);
	if ($view == "")
	{
		$view = $lastsettings["view"];
	}

	//deze kan niet als functie argument worden meegegeven want calendar staat vaak op index.php en index.php?sameresultandpage=1 moet het ook doen wanneer die via ParseTemplateGeneric binnen komt. niet ideaal dit.
	if ($_GET['sameresultandpage'] == "1")
	{
		$startdate = $lastsettings["startdate"];
	}

	$available_views = explode(",", GetAttribute("calendar", "AvailableViews", 1));
	if (count($available_views) == 0)
	{
		$available_views[] = "week";
		$available_views[] = "month";
	}

	$selectcal = "";
	$selectcal_fqn = "";
	$selectcal_table_ds = "";
	$selectcal_field = 0;
	$selectcal_field_ds = "";
	$selectcal_record = "";

	if (ipi($_GET['selectField']))
	{
		$selectcal_field = $_GET['selectField'];
		$selectcal_field_ds = "f" . $selectcal_field;
		$selectcal_table_ds = get_ds_tablename_for_field($_GET['selectField']);
		$selectcal_record = $_GET['recordnum'];
		$selectcal_fqn = "JS_" . $selectcal_table_ds . "-" . $selectcal_field_ds . "-" . $selectcal_record;

		if (is_array($GLOBALS['UC']['PersonalDataStructure'][$selectcal_table_ds]["fields"][$selectcal_field_ds]))
		{
			if ($_GET['calObjId'] == "selectOnly")
			{
				$selectcal = "date";
				$view = strtolower(GetAttribute("extrafield", "UsePlanningCalendarView", $_GET['selectField']));
			}
			elseif ($_GET['calObjId'] == "selectOnlyTimeslot")
			{
				$selectcal = "datetime";
				$view = "week";
			}
		}
	}

	if (!in_array($view, $available_views))
	{
		$view = $available_views[0];
	}

	$calendars = GetAccessibleCalendars();

	if (isset($_GET['debug']) && is_administrator()) DA($calendars);

	if (($_GET['toggle'] != "") && (is_array($calendars[$_GET['toggle']])))
	{
		$val = GetAttribute("user", "HideCalendar-" . $_GET['toggle'], $GLOBALS['USERID']);
		if ($val == "Yes")
		{
			$val = "No";
		}
		else
		{
			$val = "Yes";
		}
		SetAttribute("user", "HideCalendar-" . $_GET['toggle'], $val, $GLOBALS['USERID']);
	}

	$events = array();

	$numdays = 0;
	$number_of_days_before_first_monday_this_month = 0;
	$showhour = false;

	$prev = "";
	$next = "";
	if ($view == "day")
	{
		$numdays = 1;
		$prev = db_GetValue("SELECT DATE_SUB('" . $startdate . "', INTERVAL 1 DAY)");
		$next = db_GetValue("SELECT DATE_ADD('" . $startdate . "', INTERVAL 1 DAY)");
		$showhour = true;
	}
	else if ($view == "week")
	{
		$thisweekday = db_GetValue("SELECT WEEKDAY('" . $startdate . "')");
		if ($thisweekday != 0)
		{
			$startdate = db_GetValue("SELECT DATE_SUB('" . $startdate . "', INTERVAL " . $thisweekday . " DAY)");
		}
		$numdays = 7;
		$prev = db_GetValue("SELECT DATE_SUB('" . $startdate . "', INTERVAL 7 DAY)");
		$next = db_GetValue("SELECT DATE_ADD('" . $startdate . "', INTERVAL 7 DAY)");
		$showhour = true;
	}
	else if ($view == "multiweek")
	{
		$thisweekday = db_GetValue("SELECT WEEKDAY('" . $startdate . "')");
		if ($thisweekday != 0)
		{
			$startdate = db_GetValue("SELECT DATE_SUB('" . $startdate . "', INTERVAL " . $thisweekday . " DAY)");
		}
		$numdays = 28;
		$prev = db_GetValue("SELECT DATE_SUB('" . $startdate . "', INTERVAL 7 DAY)");
		$next = db_GetValue("SELECT DATE_ADD('" . $startdate . "', INTERVAL 7 DAY)");
	}
	else if ($view == "month")
	{
		list($year, $month, $day) = explode("-", $startdate);

		$startdate = $year . "-" . $month . "-01";
		$numdays = date('t', strtotime($startdate)); //28|29|30|31

		$number_of_days_before_first_monday_this_month = db_GetValue("SELECT WEEKDAY('" . $startdate . "')");

		$prevyear = $year;
		$prevmonth = $month - 1;
		if ($prevmonth == 0)
		{
			$prevmonth = 12;
			$prevyear--;
		}
		$prev = sprintf("%04d-%02d-01", $prevyear, $prevmonth);

		$nextyear = $year;
		$nextmonth = $month + 1;
		if ($nextmonth == 13)
		{
			$nextmonth = 1;
			$nextyear++;
		}
		$next = sprintf("%04d-%02d-01", $nextyear, $nextmonth);
	}

	//minus EEN want het is INCLUSIEF
	$numdays--;
	$enddate = date("Y-m-d", strtotime($startdate . " +" . $numdays . " days"));

	$newsettings = array();
	$newsettings['startdate'] = $startdate;
	$newsettings['view'] = $view;
	if ($newsettings != $lastsettings)
	{
		SetAttribute("user", "LastCalendarSettings-" . $listid, $newsettings, $GLOBALS['USERID']);
	}

	//voor snelheid; om slechts 1x ReturnClassnameForTextColorBasedOnBackgroundColor per kalender te callen ipv per event
	$colors_css = array();
	$popups = array();
	$plus_links = array();

	$cals_to_show_arr = array();
	if ($cals_to_show != "")
	{
		$cals_to_show_arr = explode(",", $cals_to_show);
	}

	$UsePlanningCalendarTitleText = "";
	if ($selectcal == "")
	{
		foreach ($calendars as $id => $cal)
		{
			$show_this_cal = false;
			if (count($cals_to_show_arr) > 0)
			{
				if (in_array($id, $cals_to_show_arr))
				{
					$show_this_cal = true;
				}
			}
			else if (GetAttribute("user", "HideCalendar-" . $id, $GLOBALS['USERID']) != "Yes")
			{
				$show_this_cal = true;
			}

			if ($show_this_cal)
			{
				foreach (GetCalendarEvents($id, "html", $startdate, $enddate) as $event)
				{
					$events[] = $event;
				}

				if ($cal['calendar_color'] != "")
				{
					$colors_css[$id] = "background-color:" . $cal['calendar_color'] . ";";
					if (ReturnClassnameForTextColorBasedOnBackgroundColor($cal['calendar_color']) == "white")
					{
						$colors_css[$id] .= "color:#fff;";
					}
				}

				$table = get_ds_tablename_for_field(str_replace("EFID", "", $cal['duefield']));

				$popups[$id] = -1;
				if ($cal['appointment_click_action'] == "Open record in current window")
				{
					$popups[$id] = 0;
				}
				else if ($cal['appointment_click_action'] == "Open record in popup")
				{
					$popups[$id] = $GLOBALS['UC']['PersonalDataStructure'][$table]["open_records_in_popup_mainlist"];
					//de table zelf opent niet in een popup...
					if ($popups[$id] == 0)
					{
						//...dan medium size
						$popups[$id] = 3;
					}
				}

				if ($cal['show_add_option'] == 'Yes')
				{
					$prefills = $cal['listoptions'];
					//slordig, maar het werkt
					$prefills = str_replace("hiddenfilter_", "", $prefills);
					$prefills = str_replace("filter_", "", $prefills);
					$prefills = str_replace("|", "&", $prefills);
					if ($prefills != "")
					{
						$prefills = "&" . $prefills;
					}
					if ($cal['add_option_url_extras'] != '')
					{
						$prefills .= "&" . $cal['add_option_url_extras'];
					}
					//beautification fixen
					$plus_link = $GLOBALS['UC']['PersonalDataStructure'][$table]["addlink"] . "&" . $table . "-f" . str_replace("EFID", "", $cal['duefield']) . "=@CHOSENDATE@" . $prefills;
					$plus_link = str_replace("@USERID@", $GLOBALS['USERID'], $plus_link);
					$plus_links[$id] = $plus_link;
				}
			}
		}
	}
	else
	{
		$listoptions = array();

		$listoptions['table'] = $selectcal_table_ds;
		$listoptions['listlayoutcolumns'] = $selectcal_table_ds . "-" . $GLOBALS['UC']['PersonalDataStructure'][$selectcal_table_ds]['primary'] . "," . $selectcal_table_ds . "-" . $selectcal_field_ds;
		$listoptions['internallistcall'] = true;
		
		$listoptions['outputtype'] = "array";
		$listoptions["hiddenfilter"] = array();
		$listoptions['ignorelastview'] = true;

		$UsePlanningCalendarMatchOnFields = GetAttribute("extrafield", "UsePlanningCalendarMatchOnFields", $selectcal_field);
		$UsePlanningCalendarDescription = GetAttribute("extrafield", "UsePlanningCalendarDescription", $selectcal_field);
		$UsePlanningCalendarTitleText = GetAttribute("extrafield", "UsePlanningCalendarTitleText", $selectcal_field);
		$UsePlanningCalendarColor = GetAttribute("extrafield", "UsePlanningCalendarColor", $selectcal_field);

		if ($UsePlanningCalendarTitleText != "")
		{
			if (ipi($selectcal_record))
			{
				$UsePlanningCalendarTitleText = StripNewOnlyTags($UsePlanningCalendarTitleText);
			}
			else
			{
				$UsePlanningCalendarTitleText = StripExistingOnlyTags($UsePlanningCalendarTitleText);
			}
		}

		if ($UsePlanningCalendarColor != "")
		{
			$colors_css['selectcal'] = "background-color:" . $UsePlanningCalendarColor . ";";
			if (ReturnClassnameForTextColorBasedOnBackgroundColor($UsePlanningCalendarColor) == "white")
			{
				$colors_css['selectcal'] .= "color:#fff;";
			}
		}

		if ($UsePlanningCalendarDescription == "")
		{
			$UsePlanningCalendarDescription = "@RECORDID@ -- No UsePlanningCalendarDescription attribute set!";
		}

		if ($UsePlanningCalendarMatchOnFields != "")
		{
			foreach (explode(",", $UsePlanningCalendarMatchOnFields) as $cond)
			{
				$val_cur = "";
				if ((ipi($cond)) && (ipi($selectcal_record)))
				{
					//TODO dit is nog niet secure
					$val_cur = db_GetValue("SELECT `EFID" . $cond . "` FROM `CRM" . $GLOBALS['UC']['PersonalDataStructure'][$selectcal_table_ds]["name_in_database"] . "` WHERE `" . $GLOBALS['UC']['PersonalDataStructure'][$selectcal_table_ds]["primary"] . "`=" . $selectcal_record);
				}
				elseif (isset($_GET[$selectcal_table_ds . '-f' . $cond . '-' . $selectcal_record]))
				{
					/* if we're new, the value to select might be in de GET */
					$val_cur = $_GET[$selectcal_table_ds . '-f' . $cond . '-' . $selectcal_record];
				}
				if ($val_cur != "")
				{
					$listoptions["hiddenfilter"][$selectcal_table_ds . "-f" . $cond][] = $val_cur;
					$listoptions['listlayoutcolumns'] .= "," . $selectcal_table_ds . "-f" . $cond;
				}
			}
		}

		$listoptions["hiddenfilter"][$selectcal_table_ds . "-" . $selectcal_field_ds]["from"] = $startdate;
		$listoptions["hiddenfilter"][$selectcal_table_ds . "-" . $selectcal_field_ds]["to"] = $enddate;

		foreach (make_list($listoptions) as $row)
		{
			$event = array();
			$event["id"] = "selectcal";
			$event["recordid"] = $row[$selectcal_table_ds . '-' . $GLOBALS['UC']['PersonalDataStructure'][$selectcal_table_ds]['primary']];
			$event["summary"] = unescape_interleave_characters(ParseTemplateRecordData($UsePlanningCalendarDescription, $selectcal_table_ds, $row[$selectcal_table_ds . '-' . $GLOBALS['UC']['PersonalDataStructure'][$selectcal_table_ds]['primary']]));
			$event["iso_start"] = $row[$selectcal_table_ds . '-' . $selectcal_field_ds];
			$event["iso_end"] = $row[$selectcal_table_ds . '-' . $selectcal_field_ds];
			$events[] = $event;
		}
	}

/*
[recordid] => 447
[openlink] => record.php?table=t22&record=447
[table] => t22
[iso_start] => 2016-03-13 19:00:00
[iso_end] => 2016-03-18 16:00:00
[summary] => groningen
[resource] => 
[comment] => 
[location] => 
[user] => 
[calendarname] => Agenda Jeroen
[reminder] => 
[id] => pyP5wGYW
*/


	foreach ($events as $key => $event)
	{
		//omzetten van enkele datum/tijd velden
		$events[$key]["start_date_num"] = str_replace("-", "", substr($event["iso_start"], 0, 10));
		$events[$key]["start_time"] = substr($event["iso_start"], 11, 5);

		if (($event["iso_start"] != $event["iso_end"]) && (substr($event["iso_end"], 11, 8) == "00:00:00"))
		{
			//eigenlijk zijn alle events met een DUUR (dus een einddatum ongelijk aan de startdatum), afgelopen 1 seconde voor de einddatum. De einddatum is NIET inclusief.
			//we doen deze correctie alleen voor einddatum op middernacht om te voorkomen dat het event nog op de nieuwe dag getoond wordt.
			//het gevolg hiervan is dat de einddatum op de vorige dag wordt weergegeven als 23:59 in de kalendar
			$event["iso_end"] = db_GetValue("SELECT DATE_SUB('" . $event["iso_end"] . "', INTERVAL 1 SECOND)");
		}

		$events[$key]["end_date_num"] = str_replace("-", "", substr($event["iso_end"], 0, 10));
		$events[$key]["end_time"] = substr($event["iso_end"], 11, 5);
	}

	usort($events, function($a, $b) {
		//eerst sorteren op start datum tijd...
		$x = strcmp($a['iso_start'], $b['iso_start']);
		if ($x == 0)
		{
			//dan op eind datum tijd...
			$x = strcmp($a['iso_end'], $b['iso_end']);
			if ($x == 0)
			{
				//dan op id van de kalender...
				$x = strcmp($a['id'], $b['id']);
				if ($x == 0)
				{
					//dan op recordid van de table waar de kalender aan hangt; deze is altijd verschillend voor $a en $b
					if ($a['recordid'] > $b['recordid'])
					{
						$x = 1;
					}
					else
					{
						$x = -1;
					}
				}
			}
		}
		return $x;
	});

	$daynames = array($lang['monday'], $lang['tuesday'], $lang['wednesday'], $lang['thursday'], $lang['friday'], $lang['saturday'], $lang['sunday']);
	$daynames_short = array($lang['monday_short'], $lang['tuesday_short'], $lang['wednesday_short'], $lang['thursday_short'], $lang['friday_short'], $lang['saturday_short'], $lang['sunday_short']);

	if (!$listid_div_exists)
	{
		$html .= $UsePlanningCalendarTitleText;
		$html .= '<div id="' . $listid . '" class="cal calcompress">';
	}

	$html .= '<div class="cal' . $view . '">';
	$html .= '<div class="calnav">';

	$html .= '<input type="hidden" id="' . $listid . 'startdate" value="' . $startdate . '">';
	$html .= '<input type="hidden" id="' . $listid . 'prev" value="' . $prev . '">';
	$html .= '<input type="hidden" id="' . $listid . 'next" value="' . $next . '">';
	$html .= '<input type="hidden" id="' . $listid . 'view" value="' . $view . '">';
	$html .= '<input type="hidden" id="' . $listid . 'cals_to_show" value="' . htme($cals_to_show) . '">';

	$html .= '<a class="prev" onclick="reloadcal(\'' . $listid . '\',\'' . $view . '\',\'' . $prev . '\',\'\',\'' . inline_jsencode($cals_to_show) . '\')"><span class="fa fa-arrow-left"></span></a> ';
	$html .= '<input type="button" onclick="reloadcal(\'' . $listid . '\',\'' . $view . '\',\'\',\'\',\'' . inline_jsencode($cals_to_show) . '\')" value="' . htme($lang['today']) . '"> '; //geen datum meegeven; today == default
	$html .= '<a class="next" onclick="reloadcal(\'' . $listid . '\',\'' . $view . '\',\'' . $next . '\',\'\',\'' . inline_jsencode($cals_to_show) . '\')"><span class="fa fa-arrow-right"></span></a> ';
	$html .= '<a class="expandlink" onclick="$(\'#' . $listid . '\').removeClass(\'calcompress\')"><span class="fa fa-expand"></span></a><a class="compresslink" onclick="$(\'#' . $listid . '\').addClass(\'calcompress\')"><span class="fa fa-compress"></span></a>';
	$html .= '</div>';

	$title_long = '';
	$title_short = '';
	//todo lang tag voor week_short; die is nu fixed "W"

	$title_start_date = from_iso_datetime($startdate);
	$title_start_yearweek = db_GetValue("SELECT LEFT(YEARWEEK('" . $startdate . "', 3),4)");
	$title_end_yearweek = db_GetValue("SELECT LEFT(YEARWEEK('" . $enddate . "', 3),4)");
	$title_start_week = db_GetValue("SELECT WEEK('" . $startdate . "', 3)");
	$title_end_week = db_GetValue("SELECT WEEK('" . $enddate . "', 3)");

	if ($view == "day")
	{
		$title_long = $title_start_date . ' (' . $lang['week'] . ' ' . $title_start_week . ')';
		$title_short = $title_start_date . ' (W' . $title_start_week . ')';
	}
	else if ($view == "week")
	{
		$title_long = $title_start_yearweek . ' ' . $lang['week'] . ' ' . $title_start_week;
		$title_short = $title_start_yearweek . 'W' . $title_start_week;
	}
	else if ($view == "multiweek")
	{
		$title_long = $title_start_yearweek . ' ' . $lang['week'] . ' ' . $title_start_week . ' - ';
		$title_short = $title_start_yearweek . 'W' . $title_start_week . '-';
		if ($title_end_yearweek != $title_start_yearweek)
		{
			$title_long .= $title_end_yearweek . ' ' . $lang['week'] . ' ';
			$title_short .= $title_end_yearweek . 'W';
		}
		$title_long .= $title_end_week;
		$title_short .= $title_end_week;
	}
	else if ($view == "month")
	{
		list($thisyear, $thismonth, $thisday) = explode("-", $startdate);
		$thismonth *= 1;

		$title_long = $lang['month' . $thismonth] . ' ' . $thisyear . ' (' . $lang['week'] . ' ' . $title_start_week . ' - ' . $title_end_week . ')';
		$title_short = $lang['month' . $thismonth . '_short'] . ' ' . $thisyear . ' (W' . $title_start_week . '-' . $title_end_week . ')';
	}
	//de long title is de eerste h1 dus die wordt de page title
	$html .= '<div class="caltitle"><h1 class="long">' . htme($title_long) . '</h1><h1 class="short">' . htme($title_short) . '</h1></div>';

	if ($selectcal == "")
	{
		//we link to the first day in the current view...
		$startdate_for_other_view = $startdate;
		//...unless today lies within the current view, THEN we link to the other view where today will be visible
		if ((str_replace("-", "", $startdate) <= $today_num) && (str_replace("-", "", $enddate) >= $today_num))
		{
			$startdate_for_other_view = $today;
		}
		//...otherwise we link to the first visible monday, so switching between month -> week -> month keeps the focus on the same month
		else if ($number_of_days_before_first_monday_this_month > 0)
		{
			$startdate_for_other_view = db_GetValue("SELECT DATE_ADD('" . $startdate_for_other_view . "', INTERVAL " . (7 - $number_of_days_before_first_monday_this_month) . " DAY)");
		}

		$select = '<select onchange="reloadcal(\'' . $listid . '\',this.value,\'' . $startdate_for_other_view . '\',\'\',\'' . inline_jsencode($cals_to_show) . '\')">';
		$buttons = '';
		foreach (array("day", "week", "multiweek", "month") as $other_view)
		{
			if (in_array($other_view, $available_views))
			{
				$text = $lang[$other_view];
				//in case language tag does not exist
				if ($text == "")
				{
					$text = $other_view;
				}

				$select .= '<option value="' . $other_view . '"';
				$buttons .= '<input type="button" value="' . htme($text) . '" onclick="reloadcal(\'' . $listid . '\',\'' . $other_view . '\',\'' . $startdate_for_other_view . '\',\'\',\'' . inline_jsencode($cals_to_show) . '\')"';
				if ($view == $other_view)
				{
					$select .= ' selected';
					$buttons .= ' class="activebutton"';
				}
				$select .= '>' . htme($text) . '</option>';
				$buttons .= '> ';
			}
		}
		$select .= '</select>';

		$html .= '<div class="calviewsselect">' . $select . '</div>';
		$html .= '<div class="calviewsbuttons">' . $buttons . '</div>';
	}

	$html .= '<div class="calcontainer">';

	$html .= '<div class="daynames">';
	if ($view == "day")
	{
		$day = db_GetValue("SELECT WEEKDAY('" . $startdate . "')");
		$html .= '<div class="day day' . $day . '"><div class="dayinner">';
		$html .= '<h2><span class="long">' . htme($daynames[$day]) . '</span><span class="short">' . htme($daynames_short[$day]) . '</span></h2>';
		$html .= '</div></div>';
	}
	else
	{
		for ($day = 0; $day < 7; $day++)
		{
			$html .= '<div class="day day' . $day . '"><div class="dayinner">';
			$html .= '<h2><span class="long">' . htme($daynames[$day]) . '</span><span class="short">' . htme($daynames_short[$day]) . '</span></h2>';
			$html .= '</div></div>';
		}
	}
	$html .= '</div>';

	for ($day = 0; $day < $number_of_days_before_first_monday_this_month; $day++)
	{
		//geen dayinner; geen day0, day1 ..
		$html .= '<div class="day"></div>';
	}

	for ($day = 0; $day <= $numdays; $day++)
	{
		//todo; inefficient veel calls db_GetValue()
		$thisdate = db_GetValue("SELECT DATE_ADD('" . $startdate . "', INTERVAL " . $day . " DAY)");

		$thisdate_num = str_replace("-", "", $thisdate);

		$html .= '<div class="day day' . $day . ' ';
		if ($thisdate_num < $today_num)
		{
			$html .= "past";
		}
		else if ($thisdate_num == $today_num)
		{
			$html .= "present";
		}
		//geen future; kan aangezet worden als we deze class ooit nodig hebben
		$html .= '">';
		$html .= '<div class="dayinner">';

		list($thisyear, $thismonth, $thisday) = explode("-", $thisdate);
		$thisday *= 1;
		$thismonth *= 1;

		$tmp = '<div class="calevents">';
		$numevents = 0;
		$lasthour = -1;
		foreach ($events as $event)
		{
			if ($event["start_date_num"] > $thisdate_num)
			{
				//om wat tijd te besparen; niet ideaal; zou met een geindexeerde $events array beter gaan
				continue;						
			}

			if (($event["start_date_num"] <= $thisdate_num) && ($event["end_date_num"] >= $thisdate_num))
			{
				$numevents++;

				$start_time_this_day = $event["start_time"];
				$end_time_this_day = $event["end_time"];

				if (($start_time_this_day == "") || ($event["start_date_num"] < $thisdate_num))
				{
					$start_time_this_day = "00:00";
				}
				if (($end_time_this_day == "") || ($event["end_date_num"] > $thisdate_num))
				{
					$end_time_this_day = "23:59";
				}

				if ($showhour)
				{
					$thishour = substr($start_time_this_day, 0, 2);
					for ($hour = $lasthour + 1; $hour <= $thishour; $hour++)
					{
						if (($hour >= $cal_minhour) && ($hour <= $cal_maxhour))
						{
							$time = sprintf("%02d:00", $hour);
							$tmp .= '<div class="calevent hour"';
							if ($selectcal == "datetime")
							{
								//TODO NL DATE
								$tmp .= ' onclick="PutSelectedDateInParentForm(\'' . htme($selectcal_fqn) . '\',\'' . $thisday . '-' . $thismonth . '-' . $thisyear . ' ' . $time . '\',' . $selectcal_field . ')" style="cursor: pointer;"';
							}
							$tmp .= '>' . $time . '</div>';
						}
					}
					$lasthour = $thishour;
				}

				$tmp .= '<div class="calevent" style="' . $colors_css[$event["id"]] . '"';
				$ical_data = '';
				foreach (array("comment", "user", "resource", "location") as $ical_field)
				{
					if ($event[$ical_field] != "")
					{
						$ical_data .= '<div>' . $event[$ical_field] . '</div>';
					}
				}
				if ($ical_data != '')
				{
					$tmp .= ' ' .  PrintToolTipCode($ical_data);
				}
				$tmp .= '>';

				//voor selectcal's is de openlink leeg
				$closelink = false;
				if (($popups[$event["id"]] >= 0) && ($event['openlink'] != ""))
				{
					$tmp .= '<a href="' . htme($event['openlink']) . '" onclick="ilor(this.href,' . $popups[$event["id"]] . ',\'' . $listid . '\');return false;">';
					$closelink = true;
				}

				$time = '';
				//een Interleave kalender heeft verplicht een einddatum maar niet een startdatum. indien de startdatum leeg is dan wordt deze gezet met de einddatum in GetCalendarEvents()
				if (($event["start_date_num"] == $thisdate_num) && ($event["start_time"] != ''))
				{
					$time = $event["start_time"] . ' ';
				}
				if ($event["iso_start"] != $event["iso_end"])
				{
//					$time .= '- ';
					if (($event["end_date_num"] == $thisdate_num) && ($event["end_time"] != ''))
					{
						$time .= '<span class="fa fa-long-arrow-right"></span> ';
						$time .= $event["end_time"] . ' ';
					}
					else if ($time != "")
					{
						$time .= '<span class="fa fa-long-arrow-right"></span> ';
					}
					else
					{
						//event is op een dag in het verleden begonnen en eindigt op een dag in de toekomst <->
						$time .= '<span class="fa fa-arrows-h"></span> ';
					}
				}
				$tmp .= $time . $event["summary"];
				if ($closelink)
				{
					$tmp .= '</a>';
				}
				$tmp .= '</div>';
			}
		}
		if ($showhour)
		{
			for ($hour = $lasthour + 1; $hour <= $cal_maxhour; $hour++)
			{
				if (($hour >= $cal_minhour) && ($hour <= $cal_maxhour))
				{
					$time = sprintf("%02d:00", $hour);
					$tmp .= '<div class="calevent hour"';
					if ($selectcal == "datetime")
					{
						//TODO NL DATE
						$tmp .= ' onclick="PutSelectedDateInParentForm(\'' . htme($selectcal_fqn) . '\',\'' . $thisday . '-' . $thismonth . '-' . $thisyear . ' ' . $time . '\',' . $selectcal_field . ')" style="cursor: pointer;"';
					}
					$tmp .= '>' . $time . '</div>';
				}
			}
		}
		$tmp .= '</div>'; //calevents

		//weergeven van Maand niet nodig in maand view, maar nu is die wel consistent
		$html .= '<h2';
		if ($selectcal == "date")
		{
			//TODO NL DATE
			$html .= ' onclick="PutSelectedDateInParentForm(\'' . htme($selectcal_fqn) . '\',\'' . $thisday . '-' . $thismonth . '-' . $thisyear . '\',' . $selectcal_field . ')" style="cursor: pointer;"';
		}
		$html .= '>' . $thisday . ' <span class="long">' . htme($lang['month' . $thismonth]) . '</span><span class="short">' . htme($lang['month' . $thismonth . '_short']) . '</span>';
		foreach ($calendars as $id => $cal)
		{
			$plus_link = $plus_links[$id];
			if ($plus_link != "")
			{
				$plus_link = str_replace("@CHOSENDATE@", $thisdate, $plus_link);

				$html .= ' <a href="' . htme($plus_link) . '" onclick="ilor(this.href,' . $popups[$id] . ',\'' . inline_jsencode($listid) . '\');return false;"';
				if ($cal['calendar_color'] != "")
				{
					$html .= ' style="color:' . $cal['calendar_color'] . '"';
				}
				$html .= ' title="' . htme($cal['description']) . '"><span class="fa fa-plus"></span></a>';
			}
		}
		$html .= '</h2>';
		$html .= '<div class="calnumevents">' . $numevents . '</div>';

		$html .= $tmp;

		$html .= '</div>'; //dayinner
		$html .= '</div>'; //day
	}

	$html .= '</div>'; //calcontainer

	if (($selectcal == "") && (count($cals_to_show_arr) == 0))
	{
		$html .= '<ul class="callegend">';
		foreach ($calendars as $id => $cal)
		{
			if ($cal['show_calendar_in_legend'] != 'No')
			{
				$html .= '<li';
				$checked = false;
				if (GetAttribute("user", "HideCalendar-" . $id, $GLOBALS['USERID']) != "Yes")
				{
					$html .= ' style="' . $colors_css[$id] . '"';
					$checked = true;
				}
				//cals_to_show is altijd leeg
				$html .= '><input type="checkbox" id="' . $listid . 'showcal' . $id . '" value="Yes" onchange="reloadcal(\'' . $listid . '\',\'' . $view . '\',\'' . $startdate . '\',\'' . $id . '\',\'' . inline_jsencode($cals_to_show) . '\')"';
				if ($checked)
				{
					$html .= ' checked';
				}
				$html .= '> <label for="' . $listid . 'showcal' . $id . '">' . htme($cal['description']) . '</label></li>';
			}
		}
		$html .= '</ul>';
	}
	$html .= '</div>'; //calday, calweek, calmultiweek, calmonth

	if (!$listid_div_exists)
	{
		$html .= '</div>'; //listid
	}

	return $html;
}

?>
