<?php
/* *****************************************************************
 * Interleave
 * Copyright (c) 2001-2016 Atomos Applications The Netherlands - www.atomos.nl - info@atomos.nl - www.interleave.nl - info@interleave.nl
 * Licensed under the GNU GPL. For full terms see the file COPYING.
 *
 * This file contains only the last function to call after execution.
 * It's isolated in this file for a reason; when incuded in functions.php,
 * a parse error in functions.php will cause this function not to be called.
 *
 * Check http://www.interleave.nl/ for more information
 *
 * BUILD / RELEASE :: 7.0.20161227
 *
 **********************************************************************
 */

function last_function_called_on_every_execution() {

	$error = error_get_last();

	if( $error !== NULL) {

		$errfile = "unknown file";
		$errstr  = "shutdown";
		$errno   = E_CORE_ERROR;
		$errline = 0;

		$errno   = $error["type"];
		$errfile = $error["file"];
		$errline = $error["line"];
		$errstr  = $error["message"];

		if ($errno == 1 || $errno == 4) { // fatal or parse
			
			$type = "FATAL";
			if ($errno == 4) {
				$type = "PARSE";
			}
			
			$addr = "root@localhost";
		
			mail($addr, "PHP " . $type . " error", "Errno " . $errno . "\nMessage " . $errstr . "\nFile " . $errfile . ":" . $errline .  "\nHost: " . $_SERVER['HTTP_HOST'] . "\nURI: " . $_SERVER['REQUEST_URI'] . "\nBT:" . $backtrace);
		}
	}
}
?>