<?php
/* ********************************************************************
 * Interleave
 * Copyright (c) 2001-2016 Atomos Applications The Netherlands - www.atomos.nl - info@atomos.nl - www.interleave.nl - info@interleave.nl
 * Licensed under the GNU GPL. For full terms see http://www.gnu.org/
 *
 * This file contains all administrative functions
 *
 * Check http://www.interleave.nl/ for more information
 *
 * BUILD / RELEASE :: 7.0.20161227
 *
 **********************************************************************
 */

function check_database_fields() {
	print '<a href="dbupgrade.php?CorrectTablesAndFields&SkipMainNavigation">Go here to fix the field types</a><br>';
	print '<textarea cols=120 rows=40>';
	print "Result\tTable\tField\tCorrect type\tCurrent type\n";
	$method = "mysql";
	$in_query = "";

	$ds_tablename = "";
	$il_tablename = "";
	$sql = array();
	foreach (db_GetArray("SELECT * FROM CRMextrafields WHERE deleted!='y' " . $in_query) AS $ef) {

		if (ipi($ef['tabletype'])) {
			$ds_tablename = "t" . $ef['tabletype'];
			$il_tablename = "CRMflextable" . $ef['tabletype'];
		} else {
			$ds_tablename = $ef['tabletype'];
			if ($ef['tabletype'] == "user") {
				$il_tablename = "CRMloginusers";
			} elseif ($ef['tabletype'] == "group") {
				$il_tablename = "CRMuserprofiles";
			} elseif ($ef['tabletype'] == "files") {
				$il_tablename = "CRMbinfiles";
			} else {
				$il_tablename = "CRM" . $ef['tabletype'];
			}

		}
		if (GetAlterQueryBasedOnFieldType("f" . $ef['id'], $ds_tablename, $ef['fieldtype'], "change", $method, $ef['name']) != "") {
			$sql[$il_tablename][] = str_replace("ALTER TABLE " . $il_tablename, "", GetAlterQueryBasedOnFieldType("f" . $ef['id'], $ds_tablename, $ef['fieldtype'], "change", $method, $ef['name']));
		}

	}

	foreach ($sql AS $table => $list_of_changes) {
		foreach ($list_of_changes AS $change) {


			// ok nu wordt het vies
			/*
				 CHANGE `EFID688` `EFID688` LONGTEXT NOT NULL DEFAULT '' COMMENT 'Opmerkingen sprint'
			*/
			$x = explode("`", $change);
			$field = $x[1];
			$y = explode(" COMMENT", trim($x[4]));
			$type = $y[0];

			list($result, $curtype) = TableHasField2($table, $field, $type, db_GetValue("SELECT defaultval FROM CRMextrafields WHERE id='" . str_replace("f", "", $field) . "'"));

			if ($result == "no" || $result == "wrongtype") {
				print $result . "\t" . $table . "\t" . $field . "\t" . $type . "\t" . $curtype . "\n";
			}
		}

	}
	print '</textarea>';
}
function TableHasField2($table, $field, $type, $defaultvalue='') {
	// Smerige hack, niet schadelijk



	$type = trim(str_replace("PRIMARY KEY", "", $type));
	$type = trim(str_replace("FIRST", "", $type));

	if (substr($table, 0, 3) != "CRM") $table = "CRM" . $table;
	$ar = db_GetArray("SHOW CREATE TABLE " . $table);
	$key = "`" . $field . "`";
	$ar = explode("\n" , $ar[0][1]);
	$found = "no";
	foreach ($ar AS $cr) {
		$cr = trim($cr);
		if (substr($cr,0,strlen($key)) == $key) {
			$tmp = explode(" COMMENT", $cr);
			$cr = $tmp[0];
		//	print 'CMP "' . $cr . '" to "' . $type . '"<br>' . "\n";
			if ($type == false || stristr($cr, $type) && (stristr($cr, "'" . $defaultvalue . "'") || !strstr($cr, 'DEFAULT'))) {
				return array("yes", $cr);
			} else {
				return array("wrongtype", $cr);
			}
		}
	}
	return array($found, "NONEXISTENT");
}

/*
	This function should run daily (it's called from duedate-notify-cron)
*/
function create_indices() {
	//return true;
	// Indices in this array will be created only if they don't exist already.

	$indices = array(
			array("journal", array("type", "eid")),
			array("entitylocks", array("lockon", "lockby", "locktable"), "PRIMARY"),
			array("entitylocks", array("timestamp_last_change")),
			array("datajournal", array("table", "record", "field"))
	);

	foreach(db_GetArray("SELECT tabletype, fieldtype, id FROM CRMextrafields WHERE deleted='n' AND (fieldtype IN ('Reference to FlexTable','User-list of all CRM-CTT users','User-list of administrative CRM-CTT users', 'List of all groups', 'date/time', 'date (iso)') OR fieldtype LIKE 'Users of profile %')") AS $field) {

		if (is_numeric($field['tabletype'])) $field['tabletype'] = "flextable" . $field['tabletype'];
		if ($field['tabletype'] == "user") $field['tabletype'] = "loginusers";
		if ($field['tabletype'] == "group") $field['tabletype'] = "userprofiles";
		if ($field['tabletype'] == "files") $field['tabletype'] = "binfiles";

			if (substr($field['tabletype'],0,9) == "flextable") { // flextable
				$indices[] = array($field['tabletype'], array("deleted" , "EFID" . $field['id']));
			} else {
				$indices[] = array($field['tabletype'], array("EFID" . $field['id']));
			}
	}

	foreach ($indices AS $index) {
		if (!TableHasIndex($index[0], $index[1])) {
			$sql = "";
			if ($index[2] == "PRIMARY") {
				$sql = "ALTER TABLE CRM" . $index[0] . " ADD " . $index[2] . " KEY (`" . implode($index[1], "`,`") . "`)";
			} else {
				$sql = "ALTER TABLE CRM" . $index[0] . " ADD " . $index[2] . " INDEX " . implode($index[1], "_") . "(`" . implode($index[1], "`,`") . "`)";
			}
			mcq($sql);
			if (is_administrator()) print date('r') . ": " . $sql . "<br>\n";
		} else {
			if (is_administrator()) print date('r') . ": Table/index " . $index[0] . "/" . implode('_', $index[1]) . " already exists.<br>\n";
		}
	}
}
function CalendarAdmin() {
	print "<p>With iCal you can publish calendar information to any iCal compatible calendar application. iCal calendars can be used from any application or device compatible with the iCal standard. In this section you can create iCal views on your Interleave database.</p>";

	$tmp = GetAttribute("calendar", "AvailableViews", 1);
	if ($tmp == "") {
		SetAttribute("calendar", "AvailableViews", "month,week", 1, array("month,week,day","month,week,day,multiweek", "month,week", "month,week,multiweek","month,day", "month,day,multiweek", "week,day","week,day,multiweek", "month", "week", "day", "multiweek"));
	}
	$tmp = GetAttribute("calendar", "ShowWeekendsInWeekView", 1);
	if ($tmp == "") {
		SetAttribute("calendar", "ShowWeekendsInWeekView", "Yes", 1, array("Yes", "No"));
	}
	print "Available views: " . AttributeAjaxEditElement("calendar", "AvailableViews", 1);
	print "<br>Show weekend days in week view: " . AttributeAjaxEditElement("calendar", "ShowWeekendsInWeekView", 1);

	list($number_of_records, $output) = make_list(array("table" => "calendars"));
	print $output;

    print '<h1>Calendar statistics</h1>';
    print '<table class="crm"><thead><tr><td>Calendar object</td><td>#Requests using ical.php</td></thead></tr>';
    foreach (db_GetFlatArray("SELECT calendar_object FROM CRMcalendars WHERE deleted='n'") AS $calObj) {
        print '<tr><td>' . $calObj . '</td><td class="num">' . FormatNumberNew(db_GetValue("SELECT COUNT(*) FROM CRMuselog WHERE qs='iCal calendar requested using ical.php. Object " . mres($calObj) . "'")) . '</td></tr>';
    }
    print '</table>';
}
function checkundeclaredvariables($code, $additional_globals = array(), $debug = false)
{
	$return = "";
/*

ISSUES
	vars declared to high in a level

	vars later overwritten

	foreach ($row AS $fieldname => $value) {
		print $value
		vlaue unused??

	unset ook behandelen

	geen heredoc support in code analyser

	item1/2 unused?
		usort($items, function($item1, $item2) {
		$measure1 = $item1['iso_start'];
		$measure2 = $item2['iso_start'];
		if ($measure1 == '') {
		$measure1 = $item1['iso_end'];
		$measure2 = $item2['iso_end'];
		}
		if (strtotime($measure1) == strtotime($measure2)) return 0;
		return strtotime($measure1) < strtotime($measure2) ? -1 : 1;
		});

	The "one-line" comment styles only comment to the end of the line or the current block of PHP code, whichever comes first. This means that HTML code after // ... ?> or # ... ?> WILL be printed: ?> breaks out of PHP mode and returns to HTML mode, and // or # cannot influence that. If the asp_tags configuration directive is enabled, it behaves the same with // %> and # %>. However, the </script> tag doesn't break out of PHP mode in a one-line comment.
		<h1>This is an <?php # echo 'simple';?> example</h1>


//UNUSED
{
    $a = 1;
    $a = 2;
}

DIT IS OOK EEN BLOCK
if (true) $a = 2;



{
    $a = 1;
    {
        $a = 2;
    }
    {
        print $a;
        $a = 2;
    }
    {
        $a = 2;
        {
            $a = 3;
        }
    }
}






//FOUT
{
	print $a;
}

//FOUT
{
	print $a;
	$a = 1;
}

//FOUT
{
	{
		$a = 1;
	}
	print $a;
}

//GOED
{
	$a = 1;
	print $a;
}

//GOED
{
	$a = 1;
	{
		print $a;
	}
}

//OK
{
	$a = 1;
	print $a;
}

//UNUSED
{
	$a = 1;
}

//UNUSED
{
	$a = 1;
	$a = 2;
}



ISSUES
{ en } tussen quotes

VAR DECLARATIES

$a = 1;

$a => 12;

foreach ($b as $a)

list($a,$b) = func();

preg_match("//", $b, $a);

function jeroen($a)

global $a;

*/

	if ($debug)
	{
		$return .= "ORIGINAL CODE\n";
		$return .= "------------------------------------------------------------\n";
		$return .= $code;
		$return .= "------------------------------------------------------------\n";
		$return .= "\n";
	}

	//tabs naar spaties
	$code = str_replace("\t", " ", $code);
	//meerdere spaties collapsen naar 1 spatie
	$code = preg_replace("/ +/", " ", $code);

	//global $a, $b;
	//global($a, $b); -> maakt volgende replaces makkelijker
	//$code = preg_replace("/global\s+(.*)\;/i", "global(\\1);", $code);
	$code = preg_replace("/global (.*)\;/i", "global(\\1);", $code);
	$code = preg_replace("/static (.*)\;/i", "static(\\1);", $code);

	//whitespace voorafgaand aan = teken eruit
	//$code = preg_replace("/\s+\=/", "=", $code);
	$code = preg_replace("/ \=/", "=", $code);

	//foreach ($b as $a => $c)
	//foreach ($b as $a=1 => $c=1)
	//$code = preg_replace("/\s+as\s+\\$(\w+)\s*\=\>\s*\\$(\w+)/i", " as \$\\1=1 => \$\\2=1", $code);
	//$code = preg_replace("/ as \\$(\w+) ?\=\> ?\\$(\w+)/i", " as \$\\1=1 => \$\\2=1", $code);
        //omdat $a en $c in de lus eronder hoort en niet er buiten
        //foreach ($b as $a => $c) {    -->  foreach ($b as){$a=1 => $c)
        $code = preg_replace("/ as \\$(\w+) ?\=\> ?\\$(\w+)\s*\)(\s*)\{/i", " as){\$\\1=1 => \$\\2=1\\3", $code);

	//foreach ($b as $a)
	//foreach ($b as $a=1)
	//$code = preg_replace("/\s+as\s+\\$(\w+)/i", " as \$\\1=1", $code);
	//$code = preg_replace("/ as \\$(\w+)/i", " as \$\\1=1", $code);
        //omdat $a in de lus eronder hoort en niet er buiten
        //foreach ($b as $a) {    -->  foreach ($b as){$a=1)
        $code = preg_replace("/ as \\$(\w+)\s*\)(\s*)\{/i", " as){\$\\1=1\\2", $code);


        //) -> ,) makkelijker matchen voor functies en list replaces later
        $code = preg_replace("/\)/", ",)", $code);

        //whitespace voorafgaand aan komma eruit
        //$code = preg_replace("/\s+\,/", ",", $code);
        $code = preg_replace("/ \,/", ",", $code);

	//==
	//||
	$code = str_replace("==", "||", $code);

	//global($a);
	//global($a=1);
	//$code = preg_replace("/(global\s+\\$)(\w+)/i", "\\1\\2=1", $code);
	$code = preg_replace("/(global \\$)(\w+)/i", "\\1\\2=1", $code);
	$count = 1;
	while ($count > 0)
	{
		//global($a, $b);
		//global($a=1, $b=1);
		$code = preg_replace("/(global\(.*?)\\$(\w+),(.*?\))/i", "\\1\\$\\2=1,\\3", $code, -1, $count);
	}

	$code = preg_replace("/(static \\$)(\w+)/i", "\\1\\2=1", $code);
	$count = 1;
	while ($count > 0)
	{
		//global($a, $b);
		//global($a=1, $b=1);
		$code = preg_replace("/(static\(.*?)\\$(\w+),(.*?\))/i", "\\1\\$\\2=1,\\3", $code, -1, $count);
	}

	//preg_match("//", $b, $a)
	//preg_match("//", $b, $a=1)
	//$code = preg_replace("/(preg_match(_all)?\s*\(\"\/.*?\/\"\s*\,\s*.*?\s*\,\s*\\$)(\w+)\,\)/i", "\\1\\3=1)", $code);
	//$code = preg_replace("/(preg_match(_all)?\s*\(\'\/.*?\/\'\s*\,\s*.*?\s*\,\s*\\$)(\w+)\,\)/i", "\\1\\3=1)", $code);
	$code = preg_replace("/(preg_match(_all)? ?\(\"\/.*?\/\" ?\, ?.*? ?\, ?\\$)(\w+)\,\)/i", "\\1\\3=1)", $code);
	$code = preg_replace("/(preg_match(_all)? ?\(\'\/.*?\/\' ?\, ?.*? ?\, ?\\$)(\w+)\,\)/i", "\\1\\3=1)", $code);

	//preg_replace("//", $b, $a, $count)
	//preg_replace("//", $b, $a, $count=1)
	//$code = preg_replace("/(preg_replace?\s*\(\"\/.*?\/\"\s*\,\s*.*?\s*\,\s*.*?\s*\,\s*\\$)(\w+)\,\)/i", "\\1\\2=1)", $code);
	//$code = preg_replace("/(preg_replace?\s*\(\'\/.*?\/\'\s*\,\s*.*?\s*\,\s*.*?\s*\,\s*\\$)(\w+)\,\)/i", "\\1\\2=1)", $code);
	$code = preg_replace("/(preg_replace? ?\(\"\/.*?\/\" ?\, ?.*? ?\, ?.*? ?\, ?\\$)(\w+)\,\)/i", "\\1\\2=1)", $code);
	$code = preg_replace("/(preg_replace? ?\(\'\/.*?\/\' ?\, ?.*? ?\, ?.*? ?\, ?\\$)(\w+)\,\)/i", "\\1\\2=1)", $code);

	//function jeroen($a,$b,)
	//function jeroen($a=1,$b=1,)
	$count = 1;
	while ($count > 0)
	{
	//	$code = preg_replace("/(function\s+\w+\s*\(.*?)\\$(\w+),(.*?\))/i", "\\1\\$\\2=1,\\3", $code, -1, $count);
		$code = preg_replace("/(function \w+ ?\(.*?)\\$(\w+),(.*?\))/i", "\\1\\$\\2=1,\\3", $code, -1, $count);
	}

        //want $a is intern
        //function jeroen($a) {    -->   function jeroen { ($a)
        $code = preg_replace("/function (\w+) ?\((.*)\)(\s*)\{/i", "function \\1 { \\2 \\3", $code);

	//list($a,$b,)
	//list($a=1,$b=1,)
	$count = 1;
	while ($count > 0)
	{
	//	$code = preg_replace("/(list\s*\(.*?)\\$(\w+),(.*?\)\s*=)/i", "\\1\\$\\2=1,\\3", $code, -1, $count);
		$code = preg_replace("/(list ?\(.*?)\\$(\w+),(.*?\) ?=)/i", "\\1\\$\\2=1,\\3", $code, -1, $count);
	}

	if ($debug)
	{
		$return .= "CORRECTED CODE\n";
		$return .= "------------------------------------------------------------\n";
		$return .= $code;
		$return .= "------------------------------------------------------------\n";
		$return .= "\n";
	}


	$declared_vars = 0;
	$undeclared_vars = 0;
	$unused_vars = 0;
	$vars_inside_strings = 0;
	$level = 0;
	$maxlevel = 0;
	$lines_of_code = 1;
	$deepest_code = "";
	$vars_per_level_declared = array();
	$vars_per_level_used = array();

	$inside_variable = false;
	$inside_string = false;
	$close_tag = "";
	$next_char_is_escaped = false;

	$current_variable = "";
	$inside_code = false;
	$inside_comment = false;

	$globals = array("GLOBALS", "_SERVER", "_REQUEST", "_GET", "_POST", "_COOKIE", "_FILES", "_SESSION", "_ENV", "php_errormsg", "HTTP_RAW_POST_DATA", "http_response_header", "argc", "argv");
	foreach ($additional_globals as $additional_global)
	{
		$globals[] = $additional_global;
	}

	if ($debug)
	{
		$return .= "linenumber\tcharnumber\tlevel\tcharorig\tcharcorrected\tinside_code\tinside_string\tinside_comment\tclose_tag\tnext_char_is_escaped\tinside_variable\tcurrent_variable\n";
	}

	$x = 0;
	while ($x < strlen($code))
	{
		$char = substr($code,$x,1);

		// voor // en /* en */ en \<\? en \?\>
		$next2char = substr($code,$x,2);

		if ($level == $maxlevel)
		{
			$deepest_code .= $char;
		}

		if ($char == "\n")
		{
			$lines_of_code++;
		}

		$charorig = $char;

		//\<\?php doet het dus ook
		if ($next2char == '<?')
		{
			$inside_code = true;
			$x++;
		}


		if ($inside_code)
		{
			if ($inside_comment)
			{
				//einde van // is een enter; dat is 1 char
				if ($char == $close_tag)
				{
					$inside_comment = false;
					$close_tag = "";
				}
				//comments bestaan meestal uit 2 karakters; de stukken buiten de php code tags behadelen we ook als comments
				else if ($next2char == $close_tag)
				{
					$inside_comment = false;
					$close_tag = "";
					$x++;
				}
			}
			else
			{
				//dit is lomp omdat ander "$a" niet als inside string wordt gevonden, "$a " wel
				$outside_string_at_end_of_loop = false;
				if ($inside_string)
				{
					if ($next_char_is_escaped)
					{
						$next_char_is_escaped = false;
						//dit is een " ' of bv $ we behandelen die niet als een bijzonder char
						$char = " ";
					}
					else if ($char == "\\")
					{
						$next_char_is_escaped = true;
					}
					else if (($char == "{") || ($char == "}"))
					{
						//anders gaan we levels hiervan maken
						$char = " ";
					}
					else if ($char == $close_tag)
					{
						//$inside_string = false;
						$outside_string_at_end_of_loop = true;
						$close_tag = "";
					}
				}
				else
				{
					if (($char == "\"") || ($char == "'"))
					{
						$inside_string = true;
						$close_tag = $char;
					}

					// The "one-line" comment styles only comment to the end of the line or the current block of PHP code, whichever comes first. -> NOG GEEN SUPPORT
					else if ($next2char == "//")
					{
						$inside_comment = true;
						$close_tag = "\n";
						$x++;
					}
					else if ($char == "#")
					{
						$inside_comment = true;
						$close_tag = "\n";
					}
					else if ($next2char == "/*")
					{
						$inside_comment = true;
						$close_tag = "*/";
						$x++;
					}
					else if ($next2char == '?>')
					{
						$inside_code = false;
						$x++;
					}
				}

				//ook al zitten we in een string dan zoeken we nog steeds naar variabelen want dat kan in php
				if ($char == "\$")
				{
					$inside_variable = true;
				}
				else
				{
					if ($inside_variable)
					{
						if (preg_match("/^\w$/", $char))
						{
							$current_variable .= $char;
						}
						else
						{
							//numerieke waardes zoals in regular expression backreferences $1 -> deze staan altijd in strings, dus negeren we
							if (($current_variable != "") && (!is_numeric($current_variable)))
							{
								if ($inside_string)
								{
									$vars_inside_strings++;
									$return .= sprintf("% 8d   %s   $%s\n", $lines_of_code, "inside string", $current_variable);
								}

								if (!in_array($current_variable, $globals))
								{
									//variabelen kunnen niet in een string gedeclareerd worden, ze worden dus ALTIJD gebruikt in string context;
									//$y = "jero";
									//print "$y=16\n";
									//output -> jero=16
									if (($char == "=") && (!$inside_string))
									{
										$var_already_declared = false;
										for ($y = 0; $y <= $level; $y++)
										{
											if ($vars_per_level_declared[$y][$current_variable])
											{
												$var_already_declared = true;
												break;
											}
										}

										if (!$var_already_declared)
										{
											$declared_vars++;
											$vars_per_level_declared[$level][$current_variable] = $lines_of_code;
										}
									}
									else
									{
										$was_this_var_declared = false;
										for ($y = 0; $y <= $level; $y++)
										{
											if ($vars_per_level_declared[$y][$current_variable])
											{
												$vars_per_level_used[$y][$current_variable] = $lines_of_code;
												$was_this_var_declared = true;
												break;
											}
										}
										if (!$was_this_var_declared)
										{
											$undeclared_vars++;
											$return .= sprintf("% 8d   %s   $%s\n", $lines_of_code, "undeclared   ", $current_variable);
										}
									}
								}
							}
							$current_variable = "";
							$inside_variable = false;
						}
					}

					if ($char == "{")
					{
						$level++;
						if ($level > $maxlevel)
						{
							$maxlevel = $level;
							$deepest_code = "";
						}
					}
					else if ($char == "}")
					{
						//sluiten van een blok
						if (count($vars_per_level_declared[$level]) > 0)
						{
							foreach (array_keys($vars_per_level_declared[$level]) as $var)
							{
								if ($vars_per_level_used[$level][$var] == 0)
								{
									$unused_vars++;
									$return .= sprintf("% 8d   %s   $%s\n", $vars_per_level_declared[$level][$var], "unused       ", $var);
								}
							}
						}
						$vars_per_level_declared[$level] = array();
						$vars_per_level_used[$level] = array();
						$level--;
					}
				}


				if ($outside_string_at_end_of_loop)
				{
					$inside_string = false;
				}
			}
		}

		if ($debug)
		{
			$charorigprint = $charorig;
			if ($charorigprint == "\n")
			{
				$charorigprint = "\\n";
			}
			$charprint = $char;
			if ($charprint == "\n")
			{
				$charprint = "\\n";
			}
			$close_tagprint = $close_tag;
			if ($close_tagprint == "\n")
			{
				$close_tagprint = "\\n";
			}
			$return .= $lines_of_code . "\t" . $x . "\t" . $level . "\t" . $charorigprint . "\t" . $charprint . "\t" . $inside_code . "\t" . $inside_string . "\t" . $inside_comment . "\t" . $close_tagprint . "\t" . $next_char_is_escaped . "\t" . $inside_variable . "\t" . $current_variable . "\n";
		}

		$x++;
	}

	if ($level != 0)
	{
		$return .= "\n\nERROR MISSING { OR } IN CODE OR ERROR IN THIS SCRIPT!! level: " . $level . "\n";
	}

	if (($undeclared_vars > 0) || ($unused_vars > 0) || ($vars_inside_strings > 0))
	{
		$return .= "\n\n";

		$return .= "lines_of_code: " . $lines_of_code . "\n";

		$return .= "declared_vars: " . $declared_vars . "\n";
		$return .= "undeclared_vars: " . $undeclared_vars . "\n";
		$return .= "unused_vars: " . $unused_vars . "\n";
		$return .= "vars_inside_strings: " . $vars_inside_strings . "\n";
		$return .= "max_code_depth: " . $maxlevel . "\n";
		if ($debug)
		{
			$return .= "deepest_code: " . $deepest_code . "\n";
		}
	}
	return $return;
}

function ShowModuleEditScreen() {

	if ($_REQUEST['Save']) {

		SetAttribute("module", "SaveComments " . date('Y-m-d H:i:s') . " " . GetUserName($GLOBALS['USERID']), $_REQUEST['saveComments'], $_REQUEST['mid']);

//		mcq("INSERT INTO CRMmodules (for_table, module_add_by, module_add_date, module_code, module_description, module_last_run_date, module_last_run_result, module_list_html, module_name, version_belonging_to) SELECT for_table, module_add_by, module_add_date, module_code, module_description, module_last_run_date, module_last_run_result, module_list_html, module_name, version_belonging_to FROM CRMmodules WHERE mid='" . $_REQUEST['mid'] . "'");
//		$new = db_GetInsertId();
//		mcq("UPDATE CRMmodules SET version_belonging_to = '" . $_REQUEST['mid'] . "' WHERE mid='" . $new . "'");

		mcq("UPDATE CRMmodules SET module_code='" . mres($_REQUEST['code']) . "', module_name='" . mres($_REQUEST['module_name']) . "', module_description='" . mres($_REQUEST['module_description']) . "', module_list_html='" . mres($_REQUEST['module_list_html']) . "' , for_table='" . mres($_REQUEST['for_table']) . "' WHERE mid='" . mres($_REQUEST['mid']) . "'");

		//if ($_REQUEST['fromlist']) print JS("window.location.href='" . base64_decode($_REQUEST['fromlist']) . "';");
	}


	$ls = new SaferScript("<?php ?>" . db_GetValue("SELECT module_code FROM CRMmodules WHERE mid='" . mres($_REQUEST['mid']) . "'") . "<?php ?>");

	$ls->allowHarmlessCalls();

	$ar = FlattenArray($ls->parse());

	if (count($ar) > 0) {
		print '<h2>Illegal function calls</h2>';
		print implode(', ', $ar);
	}
	$additional_globals	= array("recordid", "lang", "flextablerecord", "flextableid");
	$debug = false;

	$codecheck = checkundeclaredvariables(db_GetValue("SELECT module_code FROM CRMmodules WHERE mid='" . mres($_REQUEST['mid']) . "'"), $additional_globals, $debug);
	if ($codecheck != "")
	{
		print '<h2>Code check</h2>';
		print '<div class="errmsg">' . nl2br(htme($codecheck)) . '</div>';
	}

	print "<form id='edit_module_code' method='post' action=''>";
	print '<input type="hidden" name="starttable" value="' . htme($_REQUEST['starttable']) . '">';
	print '<input type="hidden" name="startrecordid" value="' . htme($_REQUEST['startrecordid']) . '">';
	print "<input type='hidden' name='fromlist' value='" . htme($_REQUEST['fromlist']) . "'>";

	print "<input type='hidden' name='plain' value='" . htme($_REQUEST['plain']) . "'>";
	print "<div class='showinline'>";
	print "<table class='form-table'><tr><td colspan='4'>";

	$RunAsUser = GetAttribute("module", "RunAsUser", $_REQUEST['mid']);
	if ($RunAsUser == "") {
		SetAttribute("module", "RunAsUser", "{{current user}}", $_REQUEST['mid']);
	} elseif (is_numeric($RunAsUser)) {
		print "<span class=\"warnmsg\">This module will always be ran as user " . GetUserName($RunAsUser) . ", regardless the context!</span><br>";
	}
	$ajax = GetAttribute("module", "RunInAjax", $_REQUEST['mid']);
	if ($ajax == "") {
		SetAttribute("module", "RunInAjax", "No", $_REQUEST['mid'], array("Yes", "No"));
	}
	$ShowHeaders = GetAttribute("module", "ShowHeaders", $_REQUEST['mid']);
	if ($ShowHeaders == "") {
		SetAttribute("module", "ShowHeaders", "Yes", $_REQUEST['mid'], array("Yes", "No"));
	}




	$DontFetchDQS = GetAttribute("module", "DontFetchDQS", $_REQUEST['mid']);
	if ($DontFetchDQS == "") {
		SetAttribute("module", "DontFetchDQS", "No", $_REQUEST['mid'], array("No", "Yes"));
	}
	$MassUpdatePopup = GetAttribute("module", "MassUpdatePopup", $_REQUEST['mid']);
	if ($MassUpdatePopup == "") {
		SetAttribute("module", "MassUpdatePopup", "Full screen (no popup)", $_REQUEST['mid'], array("Small", "Medium", "Large", "Extra large", "Full screen (no popup)"));
	}

	$UnauthenticatedAccess = GetAttribute("module", "UnauthenticatedAccess", $_REQUEST['mid']);
	if ($UnauthenticatedAccess == "") {
		SetAttribute("module", "UnauthenticatedAccess", "No", $_REQUEST['mid'], array("No", "Yes"));
	}

	$DontBufferOutput = GetAttribute("module", "DontBufferOutput", $_REQUEST['mid']);
	if ($DontBufferOutput == "") {
		SetAttribute("module", "DontBufferOutput", "No", $_REQUEST['mid'], array("No", "Yes"));
	}

	$module = db_GetRow("SELECT mid, module_code, module_name, module_description,module_list_html,for_table FROM CRMmodules WHERE mid='" . mres($_REQUEST['mid']) . "'");

	print "<input type='submit' name='Save' value='Save'> <a href='modules.php?action=run&amp;mid=" . $_REQUEST['mid'] . "' class=\"likebutton\">Run in this window</a> <a onclick=\"window.open('modules.php?action=run&amp;mid=" . $_REQUEST['mid'] . "', 'ModuleRunWindow');\" class=\"likebutton\">Run in new window</a> " . AttributeLink("module", $_REQUEST['mid'], "Attributes", "", true) . " <a href='javascript:PopRightsChooserModules(" . $module['mid'] . ");' class=\"likebutton\">Access restrictions</a>";

	print "</td></tr>";

	print "<tr><td>Name</td><td><input type='text' name='module_name' size='50' value='" . htme($module['module_name']) . "'></td>";
	print "<td>List HTML</td><td><input type='text' name='module_list_html' size='50' value='" . htme($module['module_list_html']) . "'></td></tr>";

	print "<tr><td>Description</td><td><input type='text' name='module_description' size='50' value='" . htme($module['module_description']) . "'></td>";
	print "<td>For table</td><td>";
	print "<select name='for_table'>";
	print "<option value='none'>None/don't</option>";
	$ins = "";

	$ins = "";
	if ($module['for_table'] == "MU-users") $ins = "selected";
	print "<option value='MU-users' " . $ins . ">Mass-update: users</option>";

	$ins = "";
	if ($module['for_table'] == "MU-groups") $ins = "selected";
	print "<option value='MU-groups' " . $ins . ">Mass-update: groups</option>";

	foreach (GetFlextableDefinitions() AS $ft) {
		$ins = "";
		if ($module['for_table'] == "flextable" . $ft['recordid']) $ins = "selected";
		print "<option value='flextable" . $ft['recordid'] . "' " . $ins . ">" . htme("Top-right icon: " . $ft['tablename']) . "</option>";

		$ins = "";
		if ($module['for_table'] == "MU-t" . $ft['recordid']) $ins = "selected";
		print "<option value='MU-t" . $ft['recordid'] . "' " . $ins . ">" . htme("Mass-update: " . $ft['tablename']) . "</option>";

	}
	print "</td></tr>";
	print "<tr><td>Comments/changes</td><td colspan=\"1\"><input type=\"text\" name=\"saveComments\" id=\"JS_saveComments\" size=\"50\"><td>Sanity check</td><td>" . ValidatePHPSyntax($module['module_code']);
	print "</td></tr>";
	print "</table>";

	if (!$_REQUEST['plain']) {
	?>
	<script type="text/javascript" src="lib/editarea/edit_area/edit_area_full.js"></script>
	<script type="text/javascript">
	editAreaLoader.init({
		id : "code-editor"			// textarea id
		,start_highlight: true	// if start with highlight
		,allow_resize: "both"
		,syntax_selection_allow: "css,html,js,php"
		,word_wrap: true
		,allow_toggle: true
		,language: "en"
		,syntax: "php"
		,font_size: "9"
		,font_family: "monospace"

	});
	</script>
	<?php
	}
	print "<table>";
	print "<tr><td colspan='2'><textarea id='code-editor' rows='35' cols='140' name='code'>" . htme($module['module_code']) . "</textarea>";
	print "<input type='hidden' name='mid' value='" . $_REQUEST['mid'] . "'>";
	print "</td></tr>";

	print "<tr><td colspan='2'>";
	print "<input type='submit' name='Save' value='Save'>";
	print "</td></tr>";
	print "<tr><td>";

	print "<tr><td colspan=\"2\">Change log:<pre>";
			foreach (db_GetArray("SELECT * FROM CRMattributes WHERE identifier='module' AND entity='" . mres($_REQUEST['mid']) . "' AND attribute LIKE 'SaveComments%' ORDER BY STR_TO_DATE(SUBSTRING(attribute,14,19), '%Y-%m-%d %H:%i:%s') DESC") AS $row) {
				print str_replace("SaveComments ", "", $row['attribute']) . " :: " . $row['value'] . "\n";
			}
			print "</pre></td></tr>";
	print "</table></div></form>";
	print 'make_list example:<br><textarea rows="15" cols="80">$listoptions = array();
$listoptions["table"] = "t3";
$listoptions["hide_selections"] = 1;
$listoptions["hide_filters"] = 1;
$listoptions["hide_header"] = 1;
$listoptions["hiddenfilter"]["t3-f84"]["from"] = $date;

$listoptions["hiddenfilter"]["t3-f99"][] = "Voorzitter";
$listoptions["hiddenfilter"]["t3-f99"][] = "Penningmeester";
$listoptions["hiddenfilter"]["t3-f99"][] = "Secretaris";
$listoptions["hiddenfiltertype"]["t3-f99"] = "NOT";

list($number_of_records, $output) = make_list($listoptions);

print $output;</textarea>';
}
function TableHasProperty($table, $literal_property) {

	if (substr($table, 0, 3) != "CRM") $table = "CRM" . $table;

	$ar = db_GetArray("SHOW CREATE TABLE " . $table);
	$ar = explode("\n" , $ar[0][1]);
	$cr = $ar[count($ar)-1];
	if (stristr($cr, $literal_property)) {
		return true;
	} else {
		return false;
	}
}
function TableHasIndex($table, $fields) {
	if (substr($table, 0, 3) != "CRM") $table = "CRM" . $table;

	$ar = db_GetArray("SHOW CREATE TABLE " . $table);
	$key = "(`" . implode($fields, "`,`") . "`)";
	$ar = explode("\n" , $ar[0][1]);
	$found = false;
	$key = "(`" . implode($fields, "`,`") . "`)";
	foreach ($ar AS $cr) {
		$cr = trim($cr);
		if ((substr($cr, 0, 3) == "KEY" || substr($cr, 0, 10) == "UNIQUE KEY" || substr($cr, 0, 11) == "PRIMARY KEY") && (substr($cr, strlen($cr) - strlen($key), strlen($key)) == $key || substr($cr, strlen($cr) - strlen($key) -1, strlen($key)) == $key)) {
			$found = true;
			break;
		}
	}


	if ($found) return $found;
	$key = "(`" . implode($fields, "`,`") . "`(64))";
	foreach ($ar AS $cr) {
		$cr = trim($cr);
		if ((substr($cr, 0, 3) == "KEY" || substr($cr, 0, 10) == "UNIQUE KEY" || substr($cr, 0, 11) == "PRIMARY KEY") && (substr($cr, strlen($cr) - strlen($key), strlen($key)) == $key || substr($cr, strlen($cr) - strlen($key) -1, strlen($key)) == $key)) {
			$found = true;
			break;
		}
	}


	return $found;
}

function TableHasIndexByName($table, $keyname) {
	if (substr($table, 0, 3) != "CRM") $table = "CRM" . $table;
	$found = false;
	foreach (db_GetArray("SHOW INDEXES FROM " . $table) as $index) {
		if ($index['Key_name'] == $keyname) {
			$found = true;
		}
	}
	return $found;
}

function FieldHasProperty($table, $field, $property) {
	if (substr($table, 0, 3) != "CRM") $table = "CRM" . $table;

	$ar = db_GetArray("SHOW CREATE TABLE " . $table);
	$key = "`" . $field . "`";
	$ar = explode("\n" , $ar[0][1]);
	$found = "no";
	foreach ($ar AS $cr) {
		$cr = trim($cr);
		if (substr($cr,0,strlen($key)) == $key) {
			if (stristr($cr, $property)) {
				if (substr($cr, strlen($cr)-1,1) == ",") {
					$cr = substr($cr, 0, strlen($cr)-1);
				}
				return $cr;
			} else {
				return false;
			}
		}
	}
	return $found;
}

function TableHasField($table, $field, $type, $defaultvalue='') {
	// Smerige hack, niet schadelijk
	$type = trim(str_replace("PRIMARY KEY", "", $type));
	$type = trim(str_replace("FIRST", "", $type));

	if (substr($table, 0, 3) != "CRM") $table = "CRM" . $table;
	$ar = db_GetArray("SHOW CREATE TABLE " . $table);
	$key = "`" . $field . "`";
	$ar = explode("\n" , $ar[0][1]);
	$found = "no";
	foreach ($ar AS $cr) {
		$cr = trim($cr);
		if (substr($cr,0,strlen($key)) == $key) {
			//print 'CMP look for "' . $type . '" in "' . $cr . '"<br>';
			if ($type == false || stristr($cr, $type)) {
				if (($defaultvalue !='' && stristr($cr, $defaultvalue)) || $defaultvalue == '') {
					return "yes";
				} else {
					return("wrongtype");
				}
			} else {
				return "wrongtype";
			}
		}
	}
	return $found;
}
function SchemaHasTable($table) {
	$cnt = db_GetArray("SHOW TABLES LIKE '".$table."'");
	if (count($cnt) > 0) {
		return true;
	}
	return false;
}
function DeleteExpiredTempFiles() {

	//$dir = ini_get("session.save_path") . "/";
	$dir = GetSetting("TMP_FILE_PATH");
	if ($dir=="/") {
		qlog(ERROR, "ERROR fetching temporary file space. Temp files left behind cannot be deleted.");
		log_msg("DeleteExpiredTempFiles::Error fetching temporary file space. Temp files left behind cannot be deleted. This will also cause problems when using exports and such. Check if your php.ini variable 'session.save_path' is set to a proper location.");
	} else {


		if($dir[(strlen($dir)-1)]!= "/") $dir .= "/"; //check for trailing slash


		$date = date(U);
		if ($d = @dir($dir)) {
			while($f = $d->read()){
				$date2 = @fileMtime($dir.$f); //change to A C or M
				if(($date - $date2) > 120) { // 120 seconds

					if (strstr($f,"CRM_TMP_") && $f != ".") {
						if(@unlink($dir . $f)) {
							qlog(INFO, "Deleted expired temp file " . $dir . $f);
							log_msg("DeleteExpiredTempFiles::Deleted expired temporary file " . $dir . $f);
						} else {
							qlog(INFO, "NOT Deleted expired temp file " . $dir . $f . " - unknown error - probably no access");
							log_msg("DeleteExpiredTempFiles::NOT Deleted expired temp file " . $dir . $f . " - unknown error - probably no access");
						}
					}
				}
			}
			$d->close();
		} else {
			qlog(ERROR, "ERROR - Unable to access " . $dir);
			log_msg("DeleteExpiredTempFiles::ERROR - Unable to access " . $dir . " (is your TMP_FILE_PATH setting correct?)");
		}
	}

}
function DeleteExpiredCacheRecords() {
	// Now delete expired temp records from the cache table:

	$sql = "DELETE FROM CRMcache WHERE timestamp_last_change< DATE(DATE_SUB(NOW(), INTERVAL 1 day))";
	mcq($sql);
}
function check_config() {
	$fixed = false;

	$p = array();
	$t = 0;
	foreach (db_GetArray( "SELECT * FROM CRMsettings") AS $resarr) {
		if (in_array($resarr['setting'],$p)) {
			print fillout(GetSetting("title"),60) . ": Double config entry for " . $resarr['setting'] . " found - fixed by deleting the last one.\n";
			$sql = "DELETE FROM CRMsettings WHERE settingid='" . mres($resarr['settingid']) . "'";
			mcq($sql);
			$fixed = true;
		}
		$p[$t] = $resarr['setting'];
		$t++;
	}
	if (!$fixed) {
		print(fillout(GetSetting("title"),60) . ": the configuration is consistant, no double entries found.\n");
	}
}
/**
 * Handles editing a sysvar
 */
function EditSysVar($id) {
	global $lang;

	$data = $_REQUEST['data'];
	$udated = $_REQUEST['udated'];
	$setting = $_REQUEST['setting'];
	$plain = $_REQUEST['plain'];
	$stdtext = $_REQUEST['stdtext'];

	if ($udated) {
			DataJournal($id, GetSetting($setting), $data, "settings");
			$sql = "UPDATE CRMsettings SET value='" . mres($data) . "' WHERE settingid='" . mres($id) . "'";
			mcq($sql);

			AdminChangesDropCache();

			?>
			<script type="text/javascript">
				window.location.href='admin.php?sysval=1';
			</script>
			<?php

	}

	$result1 = db_GetRow("SELECT * FROM CRMsettings WHERE settingid='" . mres($id) . "'");
	if ($result1['setting'] == "DBVERSION") {
		print "<span class='warnmsg'>This value cannot be edited.</span>";
		print "<br><a href='javascript:history.back(-1)'>back</a>";
		EndHTML();
		exit;
	}

	print "<form id='composeform' method='post' action=''>";
	print "<table class='form-table'>";
	print "<tr><td colspan=\"3\">Editing global variable " . $id . ": " . $result1['setting'] . "</td></tr>";
	print "<tr><td colspan=\"3\"><strong>Description:</strong><br><br>" . $result1['discription'] . "</td></tr>";
	print "<tr><td><strong>";
	print "Values:";
	print "</strong><input type='hidden' name='EditSysVar' value='" . $id . "'><input type='hidden' name='OldVar' value='" . htme($result1['value']) . "'><input type='hidden' name='setting' value='" . htme($result1['setting']) . "'>";

	if ($result1['setting']=="SYSWIDECSS") {
			print "&nbsp;&nbsp;&nbsp;<select name='data'><option value=''>None</option>";
			foreach (db_GetArray("SELECT templateid,templatename,templatetype FROM CRMtemplates WHERE templatetype='TEMPLATE_CSS' AND version_belonging_to='0'") AS $row) {
				$ins = "";
				if ($result1['value'] == $row['templateid']) {
					$ins = 'selected';
				}
				print "<option " . $ins . " value='" . $row['templateid'] . "'>" . $row['templatename'] . "</option>";
			}
			print "</select></td></tr>";

	} elseif ($result1['setting']=="EXCELFILEFORMAT") {
		print "&nbsp;&nbsp;&nbsp;<select name='data'>";
			$ins = "";
			if (GetSetting("EXCELFILEFORMAT") == "2003") {
				$ins = 'selected';
			}
			print "<option " . $ins . " value='2003'>2003 (.XLS) File format</option>";
			$ins = "";
			if (GetSetting("EXCELFILEFORMAT") == "2007") {
				$ins = 'selected';
			}
			print "<option " . $ins . " value='2007'>2007 (.XLSX) File format (true color, date support)</option>";
			print "</select></td></tr>";
	} elseif ($result1['setting']=="MINIMUMPASSWORDSTRENGTH") {
		print "&nbsp;&nbsp;&nbsp;<select name='data'>";
			print "<option value='1'>Weak (unsafe)</option>";
			$ins = "";
			if (GetSetting("MINIMUMPASSWORDSTRENGTH") == "2") {
				$ins = 'selected';
			}
			print "<option " . $ins . " value='2'>Medium</option>";
			$ins = "";
			if (GetSetting("MINIMUMPASSWORDSTRENGTH") == "3") {
				$ins = 'selected';
			}
			print "<option " . $ins . " value='3'>Strong</option>";
			print "</select>";
			print '<ul>';
			print '<li>Weak = 6 or more chars</li>';
			print '<li>Medium = 7 or more chars (lowercase letter + number OR uppercase letter + number OR lowercase letter + uppercase letter)</li>';
			print '<li>Strong = 8 or more chars (lowercase letter + uppercase letter + number + other digit)</li>';
			print '</ul>';
			print "</td></tr>";

	} elseif ($result1['setting']=="FILECOMPRESSIONLEVEL") {
			print "&nbsp;&nbsp;&nbsp;<select name='data'>";
			$ins = "";
			if (GetSetting("FILECOMPRESSIONLEVEL") == "A") {
				$ins = 'selected';
			}
			print "<option " . $ins . " value='A'>Don't compress at all (except old versions of files)</option>";
			$ins = "";
			if (GetSetting("FILECOMPRESSIONLEVEL") == "B1") {
				$ins = 'selected';
			}
			print "<option " . $ins . " value='B1'>Compress files older than 1 year</option>";
			$ins = "";
			if (GetSetting("FILECOMPRESSIONLEVEL") == "B2") {
				$ins = 'selected';
			}
			print "<option " . $ins . " value='B2'>Compress files older than 1 year and only if the entity is deleted</option>";
			$ins = "";
			if (GetSetting("FILECOMPRESSIONLEVEL") == "C1") {
				$ins = 'selected';
			}
			print "<option " . $ins . " value='C1'>Compress files older than 6 months</option>";
			$ins = "";
			if (GetSetting("FILECOMPRESSIONLEVEL") == "C2") {
				$ins = 'selected';
			}
			print "<option " . $ins . " value='C2'>Compress files older than 6 months and only if the entity is deleted</option>";
			$ins = "";
			if (GetSetting("FILECOMPRESSIONLEVEL") == "D") {
				$ins = 'selected';
			}
			print "<option " . $ins . " value='D'>Compress all files</option>";
			print "</select>";
			print "</td></tr><tr><td></td><td colspan='2'>Compression will be done by nightly cron job, or you can do it yourself by using the<br>";
			print "command-line interface (cmd.php) and issue 'exec db compress'. <br></td></tr>";
			$t1 = db_GetRow("SELECT COUNT(*) FROM CRMblobs");
			$t2 = db_GetRow("SELECT COUNT(*) FROM CRMblobs WHERE gz='y'");
			print "<tr><td></td><td>Current number of files: " . $t1[0] . "</td></tr>";
			$pc1 = $t1[0] / 100;
			$pc = $t2[0] / $pc1;
			print "<tr><td></td><td>Current number of compressed files: " . $t2[0] . " (~" . round($pc) . "%)</td></tr>";
	} elseif ($result1['setting']=="DASHBOARDTEMPLATE") {
			print "&nbsp;&nbsp;&nbsp;</td><td><br><select name='data'><option value='Default'>Default (hard-coded) dashboard</option>";
			foreach (db_GetArray("SELECT templateid,templatename,templatetype FROM CRMtemplates WHERE templatetype = 'TEMPLATE_DASHBOARD'") AS $row) {
				$ins = "";
				if ($result1['value'] == $row['fileid']) {
					$ins = 'selected';
				}
				print "<option " . $ins . " value='" . $row['templateid'] . "'>" . $row['templatename'] . "</option>";
			}
			print "</select></td></tr>";

	} elseif (substr($result1[setting],0,4) == "BODY") {
		if ($plain) {
			print "<textarea name='data' rows='18' cols='100'>" . htme($result1['value']) . "</textarea>";
		} else {
				print "<textarea id='editor' rows='70' cols='140' name='data'>" . htme($result1['value']) . "</textarea>";
				print make_html_editor("editor", true);
		}
		print "</td></tr>";
		print "<tr><td colspan='3'><input type='hidden' name='udated' value='1'><input type='submit' name='Send.x' value='" . $lang['save'] . "'>&nbsp;&nbsp;<input type='button' name='do' value='" . $lang['cancel'] . "' onclick=\"window.location.href='admin.php?sysval=1'\">&nbsp;";
		if (!$plain) {
			print "<input type='button' onclick=\"window.location.href='admin.php?EditSysVar=" . $id . "&amp;plain=1';\" value='Javascript not working?'>";
		}
		AvailableTags();
		print "</td></tr>";

	} else {
		if (stristr($result1['setting'],"show") || $result1['setting']=='UseMailQueue' || stristr($result1['setting'],"enable") || stristr($result1['setting'],"auto") || stristr($result1['setting'],"onemailpertrigger") || stristr($result1['setting'],"DISABLE")) {
			$yes = "";
			$admin = "";
			$no = "";
			if (strtoupper($result1[value])=="YES") {
				$yes = 'selected';
			} elseif (strtoupper($result1[value])=="ADMIN") {
				$admin = 'selected';
			} else {
				$no = 'selected';
			}
			print "</td><td><br><select name='data'><option " . $yes . ">Yes</option><option " . $no . ">No</option></select></td></tr>";

		} elseif (stristr($result1['setting'],"dateformat")) {
			$yes = "";
			$no = "";
			$maybe = "";
			if (strtoupper($result1['value'])=="DD-MM-YYYY") {
				$yes = 'selected';
			} elseif ( strtoupper($result1['value'])=="MM-DD-YYYY"){
				$no = 'selected';
			} else {
				$maybe = 'selected';
			}
			print "</td><td><br><select name='data'><option " . $yes . ">dd-mm-yyyy</option><option " . $no . ">mm-dd-yyyy</option><option " . $maybe . ">yyyy-mm-dd</option></select></td></tr>";
		} else {
			print "</td><td><br><input type='text' size='70' name='data' value=\"" . $result1['value'] . "\"></td></tr>";
		}
	}
	print "<tr><td colspan='3'><br><input type='hidden' name='udated' value='1'><input type='submit' name='bt' value='" . $lang['save'] . "'>&nbsp;&nbsp;<input type='button' name='do' value='" . $lang['cancel'] . "' onclick=\"window.location.href='admin.php?sysval=1'\"></td></tr>";
	print "</table></form>";
	EndHTML();
	exit;
}
function ExportSettings() {
	MustBeAdmin();

	qlog(INFO, "Exporting settings");
	$outp = "";
	foreach (db_GetArray("SELECT setting,value,discription FROM CRMsettings") AS $row) {
		$outp .= base64_encode($row['setting']) . "," . base64_encode($row['value']) . "," . base64_encode($row['discription']) . "\n";
	}

	$filename = "Exported_settings_" . $GLOBALS['PRODUCT'] . "_" . rawurlencode(GetSetting("title")) . "-" . date("Fj-Y-Hi") . ".crm";
	header("Content-Type: CSV");
	header("Content-Disposition: attachment; filename=" . $filename);
	header("Content-Description: " . $GLOBALS['PRODUCT'] . " Generated Data" );
	header("Window-target: _top");
	print $outp;
}
function ImportSettings() {
	MustBeAdmin();

	qlog(INFO, "Importing users");
	$sarr = array();
	if ($_FILES['userfile']['tmp_name'] && $_FILES['userfile']['name']) {
		$fp=fopen($_FILES['userfile']['tmp_name'] ,"rb");
		$filecontent=fread($fp,filesize($_FILES['userfile']['tmp_name'] ));
		fclose($fp);
		$arr = explode("\n",$filecontent);
		foreach ($arr AS $line) {
			$element_count=0;
			$set_row = explode(",",$line);

			$sql = "INSERT INTO CRMsettings(setting,value,discription) VALUES (";
			foreach ($set_row AS $element) {
				$sql .= "'" . mres(base64_decode($element)) . "',";
				$element_count++;
			}
			$sql .= ")";
			$sql = str_replace(",)",")",$sql);
			if ($element_count==3) {
				// 1st element is the account name, and it may not already exist.
					array_push($sarr,$sql);

			} else {

				qlog(INFO, "Ignoring record with " . $element_count . " instead of 3 elements");
			}
		}

		if (sizeof($sarr)==0) {
				qlog(INFO, "No valid accounts to import found");
				print "No valid setting records to import found in this file.<br><br>";
		} else {
				qlog(INFO, "Importing " . sizeof($sarr) . " setting records");
				mcq("TRUNCATE TABLE CRMsettings");
				foreach ($sarr AS $query) {
					mcq($query);
				}
				print sizeof($sarr) . " setting records imported.";
				log_msg(sizeof($sarr) . " setting records imported.");
		}

	} else {
		print "<h2>Import global settings (ALL CURRENT GLOBAL SETTNGS WILL BE REMOVED!)</h2>";
		print "Select file for upload:";
		print "<form enctype='multipart/form-data' id='IU' method='post' action=''><div class='showinline'><input name='userfile' type='file'>";
		print " <input type='submit' value='Upload'>";
		print "</div></form>";
	}
}
function CheckIfShell() {
	// This should NOT be run via the web!
	if ($_SERVER['REQUEST_URI']) {
			?>
			<script type="text/javascript">
				alert('You tried to access a shell (command-line) script through the web. Redirecting.');
				window.location.href='index.php';
			</script>
			<?php
			EndHTML();
			exit;
	}
}
function AvailableTags() {
	print '<div>';
	print '<h2>Awesome fonts</h2>';
	foreach (array("envelope", "mobile", "desktop", "file-pdf-o", "file-excel-o", "times", "search", "lock", "files-o", "exclamation-triangle", "check", "external-link", "plus", "list-alt", "edit", "calendar", "bars", "phone", "info-circle", "user", "tachometer", "cog", "power-off", "book", "line-chart", "arrow-left", "arrow-right", "plus-square-o", "minus-square-o", "credit-card ") as $awesome)
	{
		$html = '<span class="fa fa-' . $awesome . '">&nbsp;</span>';
		print '<div>' . $html . ' ' . htme($html) . '</div>';
	}
	print '</div>';

	print "<a onclick=\"document.getElementById('generictags').style.display='block';\">List of available tags</a>";
	print "<div id='generictags' style='display: none;'>";
	?>
	<table class="crm">
	<tr><td colspan='2'>Generic tags</td></tr>
	<tr><td>@BASEURL@</td><td>Tag to the BASEURL , like http://www.interleave.nl</td></tr>
	<tr><td>@REPOSNUM@</td><td>Current working repository number</td></tr>
	<tr><td>@WEBHOST@</td><td>The hostname of this system</td></tr>
	<tr><td>@TITLE@</td><td>The title of this repository</td></tr>
	<tr><td>@ADMEMAIL@</td><td>The administrators e-mail address</td></tr>
	<tr><td>@ADMINEMAIL@</td><td>The current configured adminemail</td></tr>
	<tr><td>@DATE@</td><td>The date at the moment of processing</td></tr>
	<tr><td>@UNFORMATTED_DATE@</td><td>The date at the moment of processing (unformatted - dd-mm-yyyy)</td></tr>
	<tr><td>@ISODATE@</td><td>The date at the moment of processing (ISO format: yyyy-mm-dd)</td></tr>
	<tr><td>@ISODATETIME@</td><td>The date and time at the moment of processing (ISO format: yyyy-mm-dd HH:mm:ss)</td></tr>
	<tr><td>@TODAY@ </td><td>The current date(dd-mm-yyyy)</td></tr>
	<tr><td>@TODAYISO@</td><td>The current date in ISO format(yyyy-mm-dd)</td></tr>
	<tr><td>@NOW@</td><td>The current date in ISO format + time (yyyy-mm-dd hh:mm:ss)</td></tr>
	<tr><td>@TODAY_UNFORMATTED@</td><td>The date at the moment of proccessing (unformatted - dd-mm-yyyy)</td></tr>
	<tr><td>@NOW_FORMATTED@</td><td>The current date formatted (formatted dd-mm-yyyy hh:mm:ss)</td></tr>
	<tr><td>@NOW_UNFORMATTED@</td><td>The date at the moment of proccessing (yyyy-mm-dd hh:mm:ss)</td></tr>
	<tr><td>@EPOCH@</td><td>Seconds since the Unix Epoch (January 1 1970 00:00:00 GMT)</td></tr>
	<tr><td>@YESTERDAY@</td><td>The current yesterday(dd-mm-yyyy)</td></tr>
	<tr><td>@TOMORROW@</td><td>The current tomorrow(dd-mm-yyyy)</td></tr>
	<tr><td>@YESTERDAY_UNFORMATTED@</td><td>The yesterday of the moment of proccessing(dd-mm-yyyy)</td></tr>
	<tr><td>@TOMORROW_UNFORMATTED@</td><td> The tomorrow of the momeent of processing(dd-mm-yyyy)</td></tr>
	<tr><td>@YESTERDAYISO@</td><td>The yesterday in ISO format(yyyy-mm-dd)</td></tr>
	<tr><td>@TOMORROWISO@</td><td>The tomorrow in ISO format(yyyy-mm-dd)</td></tr>
	<tr><td>@USERID@</td><td>ID of the current user</td></tr>
	<tr><td>@TIME@</td><td> The time at the moment of processing (24 format hh:mm:ss)</td></tr>
	<tr><td>@USER@</td><td>The current user's full name</td></tr>
	<tr><td>%PAGEBREAK%</td><td>Page break (only for RTF and PDF templates)</td></tr>
	<tr><td colspan='2'>&nbsp;</td></tr>
	<tr><td colspan='2'>Language tags</td></tr>
	<tr><td>[[anytag]]</td><td>The value of language tag "anytag" in the current language</td></tr>
	<tr><td colspan='2'>Dashboard tags</td></tr>
	<tr><td>#MESSAGES#</td><td>Internal messages</td></tr>
	<tr><td>#CALENDAR#</td><td>Calendar</td></tr>
	<tr><td>#CLOCK#</td><td>Javascript Clock</td></tr>

	<tr><td colspan='2'>&nbsp;</td></tr>
<?php

	print "</td></tr>";
	print "</table></div>";
}
function ProcessMailQueue() {
	// This function processes the mail queue. This is done by updating it first to set a hash value as identification.
	// After that, the row having the hash will be processed and send.

	// Set the maximum number of rows to process per function run
	$max = 200;
	$curuser = $GLOBALS['USERID'];

	$worker_hash = md5(rand() . rand() . date('U') . $GLOBALS['USERNAME'] . $GLOBALS['USERID']) . md5(rand());
	mcq("UPDATE CRMmailqueue SET worker_hash ='" . $worker_hash . "' WHERE worker_hash ='' AND `status` = 'unsent' LIMIT " . $max);
	$qtp = db_GetFlatArray("SELECT queueid FROM CRMmailqueue WHERE worker_hash = '" . $worker_hash . "' ORDER BY RAND()");

	$lastuser = 0;
	$error = "";
	foreach ($qtp AS $qe) {

		$row = db_GetRow("SELECT * FROM CRMmailqueue WHERE queueid = '" . $qe . "'");

		// Load user context (important!)
		if ($lastuser != $row['user']) {
			$GLOBALS['USERID'] = $row['user'];
			$GLOBALS['NO_MSG'] = true;
			InitUser($row['user']);
		}

		// Actually send the e-mail here
		if ($row['template'] != "" && $row['to'] != '') {
			$parse = true;
			if ($row['parse'] == "n") {
				$parse = false;

			}
			print date('r') . ": Process mail to " . $row['to'] . " subject " . $row['subject'] . ": " . $parse . " table " . $row['table'] . "<br>\n";
			if (ipi($row['entity']) && !ipi($row['flextablerecord'])) {
                /* transitioning RealRealMail to only use $flextablerecord (later to be renamed) and $dstable */
                $row['flextablerecord'] = $row['entity'];
            }
			// Pass e-mail to e-mail function, this will actually deliver it to the mail server
			$adj = RealRealMail($row['template'],0,$row['customer'],$row['from'],$row['fromname'],$row['to'],$row['PDF'],$row['subject'],$row['attach_to_dossier'],$row['attach_as_filename'],$row['report_attach'], $row['flextableid'], $row['flextablerecord'], $parse, unserialize($row['files_to_attach']), $row['table']);

			if ($adj[1] == true) {

				// Mark the e-mail as sent
				mcq("UPDATE CRMmailqueue SET worker_hash='n/a', status='sent', date_sent=NOW() WHERE queueid=" . $qe);
				log_msg("Sending email from " . $row['from'] . " to " . $row['to'] . " subject " . str_replace("WARNING", "WARN", str_replace("ERROR", "ERR", $row['subject'])));
			} else {
				// Mark the e-mail as error
				mcq("UPDATE CRMmailqueue SET worker_hash='" . mres($adj[0]) . "', status='error' WHERE queueid=" . $qe);
				log_msg("ERROR: " . $adj[0] . " queue id " . $qe);
			}

			//print ("Sending email from " . $row['from'] . " to " . $row['to'] . " subject " . $row['subject']);
		} else {
			log_msg("ERROR: template, to or from not set in msg id " . $qe);
			$error = "template, to or from not set in msg id " . $qe;
		}

		$lastuser = $row['user'];
	}
	// Set all remaining messages to "error"
	mcq("UPDATE CRMmailqueue SET worker_hash='" . mres($error) . "', status='error' WHERE worker_hash = '" . $worker_hash . "'");

	if (is_numeric($curuser)) {
		$GLOBALS['USERID'] = $curuser;
		$GLOBALS['NO_MSG'] = false;
		InitUser();
	}
}
function RealRealMail($template_id,$entity,$customer,$From,$Fromname,$To,$PDF,$Subject="",$attach_to_dossier,$attach_as_filename,$report_attach, $flextableid, $flextablerecord, $parse=true, $files_to_attach=array(), $dstablename="") {



	require_once $GLOBALS['PATHTOINTERLEAVE'] . "lib/class.phpmailer.php";
	require_once $GLOBALS['PATHTOINTERLEAVE'] . "lib/class.smtp.php";

	$To = trim($To);
	$add_to_journal = "";
	$stylesheet = "";
	$template = "";
	//$Subject = "";


	if ($GLOBALS['DISABLEMAIL']) return array("DISABLED", true); // deze kan alleen in email_in.php gezet worden voor testdoeleinden, heeft verder geen functie

	/* convert to data structure type stuff */
	$recordid = 0;
	if ($dstablename == "") {
		if (ipi($flextableid)) {
			$dstablename = "t" . $flextableid;
			$recordid = $flextablerecord;
		} else {
			$recordid = "";
			$dstablename = "";
			$flextablerecord = "";
			$flextableid = "";
		}
	} else {
		$recordid = $flextablerecord;
	}

	if (ipi($template_id)) {

		/* normal template from templates table */
		$template = GetTemplate($template_id);
		$Subject = GetTemplateSubject($template_id);

	} else {

		/* a given html template inside $template_id. not pretty but supported */
		$template = $template_id;

	}

	$force_autoform = false;

	if ($parse) {
		/* get_parsed_template_with_given_template supports being called with an empty $table var  */
		$template = get_parsed_template_with_given_template($dstablename, $recordid, array(), array(), $force_autoform, "", $template, 'TEMPLATE_HTML');
		$Subject = html2plaintext(get_parsed_template_with_given_template($dstablename, $recordid, array(), array(), $force_autoform, "", $Subject, 'TEMPLATE_PLAIN'));
	}

	if (ipi($template_id)) {
		if (ReturnTemplateStyleSheet($template_id) == "") {
			$stylesheet = ReturnStyleSheet(GetSetting("SYSWIDECSS"));
		} else {
			$stylesheet = ReturnTemplateStyleSheet($template_id);
		}
		// The stylesheet will be included in the header later on
	}



	$also_attach_generated_reports = false;
	if (strstr($report_attach, "+2")) {
		$also_attach_generated_reports = true;
		$report_attach = str_replace("+2", "", $report_attach);
		qlog(INFO, "Also attaching generated report to the record");
	}

	$do_attach_all_files = false;
	if (strstr($report_attach, "+all")) {
		$do_attach_all_files = true;
		$report_attach = str_replace("+all", "", $report_attach);
		qlog(INFO, "Also attaching all record attachments");
	}
	if (strstr($report_attach, "ALL_ATTM") && $report_attach != "ALL_ATTM") {
		$do_attach_all_files = true;
		$report_attach = str_replace("ALL_ATTM", "", $report_attach);
	}



	if (is_numeric($report_attach)) {

		$tname = GetTemplateName($report_attach);
		$extension1 = explode("." , $tname);
		$extension = $extension1[count($extension1)-1];

		if ($extension == "xml" || $extension == "csv" || $extension == "xls" || $extension == "txt" ) {
			$GLOBALS['DONTFORMATNUMBERS'] = true;
		}
	}

	if (!is_array($GLOBALS['email_send_to'])) {
		$GLOBALS['email_send_to'] = array();
	}



	if (strstr($To, "<") && strstr($To, ">")) {
		$tmp = explode("<", $To);
		$tmp = str_replace(">","",$tmp[1]);
		$To = trim($tmp);
		qlog(INFO, "Email address fixed");
	} else {
		qlog(INFO, "Email addess is ok (" . $To . ")");
	}

	/* catch for development */
	if (GetSetting("DevelopmentOrProduction") == "Development") {
		$Subject .= " [" . $To . "]";
		$To = GetSetting("AddressToSendAllMailsToWhenInDevelopmentMode");
		$From = GetSetting("AddressToSendAllMailsToWhenInDevelopmentMode");
	}

	if (ValidateEmail($To)) {

		if ($template != "") {

			$mail = new PHPMailer();
			$mail->CharSet = "UTF-8";

			if ($From != "") {
				$mail->From     = $From;
			} else {
				$mail->From     = GetSetting('admemail');
			}

			if (trim($Fromname) != "") {
				$mail->FromName = $Fromname;
			} else {
				$mail->FromName = $GLOBALS['PRODUCT'] . " Notification Manager";
			}

			if (strstr(GetSetting('UNIFIED_FROMADDRESS'),"@") && GetSetting("DevelopmentOrProduction") != "Development") {
				$ar = ParseFormattedEmailAddress(GetSetting('UNIFIED_FROMADDRESS'));
				$mail->From     = $ar["fromemail"];
				$mail->FromName = $ar["fromname"];
			}
			if (ValidateEmail(GetSetting("BCCAllOutgoingQueuedMailToAddr"))) {
				$mail->AddBCC(GetSetting("BCCAllOutgoingQueuedMailToAddr"));
			}
			if (ValidateEmail(GetSetting("CCAllOutgoingQueuedMailToAddr"))) {
				$mail->AddCC(GetSetting("CCAllOutgoingQueuedMailToAddr"));
			}

			if (($report_attach == "ALL_ATTM" || $do_attach_all_files) && ($entity || $flextablerecord)) {

				$select_ins = " AND version_belonging_to='0' ";

				if ($flextableid > 0) {
					$fids = db_GetArray("SELECT fileid FROM CRMbinfiles WHERE koppelid='" . mres($flextablerecord) . "' AND type='flextable" . $flextableid . "' " . $select_ins);
					foreach ($fids AS $file) {
						$templateXX = GetFileContent($file['fileid']);
						$mail->AddStringAttachment($templateXX, GetFileName($file['fileid']));
						qlog(INFO, "Attached file " . GetFileName($file['fileid']));
					}
				} else {
					$fids = db_GetArray("SELECT fileid FROM CRMbinfiles WHERE koppelid='" . mres($entity) . "' AND type='entity' " . $select_ins);
					foreach ($fids AS $file) {
						$templateXX = GetFileContent($file['fileid']);
						$mail->AddStringAttachment($templateXX, GetFileName($file['fileid']));
						qlog(INFO, "Attached file " . GetFileName($file['fileid']));
					}
				}
			}

			foreach ($files_to_attach AS $file) {
				if (CheckTableRecordAccess("files", $file) != "nok") {
					$templateXX = GetFileContent($file);
					$mail->AddStringAttachment($templateXX, GetFileName($file));
					qlog(INFO, "Attached file " . GetFileName($file));
				}
			}
			if ($attach_to_dossier != "") {
				$ins = "";
				if (!ValidateEmail($To)) {
					$ins = "<span class='errmsg'>E-mail NOT sent! E-mail address is not a valid internet email address!</span><br>";
				}
				$total = $GLOBALS['PRODUCT'] . " E-mail merge " . date("Fj-Y-Hi") . "<br>" . $ins;
				$total .= "To: " . $To . "<br>";
				$total .= "Subject: " . $Subject . "<br><br>" . $template;
				$filename = "";
				if (!$attach_as_filename) {
					$filename = $GLOBALS['PRODUCT'] . "-HTML_file-" . date("Fj-Y-Hi") . "h.HTML";
				} else {
					$filename = $attach_as_filename;
				}

				if ($attach_to_dossier != "") {
					$attachment = AttachFile($recordid,$filename,$total,ds_tablename_to_binfiles_table($dstablename) ,"HTML", false, true, false, false, true);
					$add_to_journal .= "\nAttached file " . $attachment . " to record " . $recordid . " table " . $dstablename;
				}


			}

			if (ipi($report_attach)) {


				$filename = "";
				$report_template = "";

                $template_type = GetTemplateType($report_attach);
				if ($template_type == "TEMPLATE_REPORT" || $template_type == "TEMPLATE_PLAIN" || $template_type == "TEMPLATE_XML") {

					/* get filename, parse it, clean it */
                    $filename = clean_filename(html2plaintext(get_parsed_template_with_given_template($dstablename, $recordid, array(), array(), false, "", GetTemplateSubject($report_attach), 'TEMPLATE_PLAIN')));

                    /* cut off extension */
    				$tmp_fn = explode(".", $filename);
					$ext = "." . strtolower($tmp_fn[(count($tmp_fn) -1)]);
                    unset($tmp_fn);

					if ($ext == ".xlsx" || $ext == ".xlsm" || $ext == ".docx" || $ext == ".odt" || $ext == ".ods") {

                            /* zipped template. we need to unzip it, parse the content rather smart, and zip it again */

							$report_template = ParseZippedContent($report_attach, false, false, $flextableid, $flextablerecord);

					} else {

                            /* plain template, could be anything actually */
                            $passthru = array();
                            $passthru['template_to_use'] = $report_attach;

							$report_template = get_parsed_template($dstablename, $recordid, $passthru, $recordid, false, "ok");

					}


				} elseif (GetTemplateType($report_attach) == "TEMPLATE_REPORT_PDF") {

					$tmp = GetPDFReport($report_attach, $dstablename, $recordid);
					$filename = $tmp['filename'];
					$report_template = $tmp['pdf'];
				}

				if (trim($report_template) == "") {
					/* file is empty, can't be good */
					log_msg("ERROR: We're attaching a report to an e-mail but the generated report (" . $filename . ") is empty. Table " . $dstablename . " record " . $recordid . ".");
				}
				$mail->AddStringAttachment($report_template, $filename);

				if ($also_attach_generated_reports) {

					/* attach generated report to record */
					$attachment = AttachFile($recordid,$filename,$report_template,ds_tablename_to_binfiles_table($dstablename) ,"", false, true, false, false, true);
					$add_to_journal .= "\nAttached file " . $attachment . " to record " . $recordid . " table " . $dstablename;
				}
			}

			$mail->Host     = GetSetting('SMTPserver');
			$mail->Mailer   = GetSetting('MailMethod');
			if (GetSetting('MailUser') != "" && GetSetting('MailPass') != "") {
				$mail->Username = GetSetting('MailUser');
				$mail->Password = GetSetting('MailPass');
			}
			$mail->IsHTML(true);

			$nt = '<!DOCTYPE html><html>';
			$nt .= "<head>\n";
			$nt .= "<meta charset=\"UTF-8\">";
			$nt .= "<title>" . $Subject . "</title>\n";
			if ($stylesheet != "")
			{
				// The stylesheet already has script header & footer
				$nt .= $stylesheet . "\n";
			}
			$nt .= "</head>\n<body>\n" . $template . "\n</body>\n</html>\n";

			$mail->Body    = $nt;
			$mail->AltBody = html2plaintext($template);
			$sto = "";
			$rec = 0;

			if (is_array($To)) {
				foreach ($To AS $recipient) {
					if (ValidateEmail($recipient)) {
						if ((!in_array($To,$GLOBALS['email_send_to'])) || GetSetting("ONEMAILPERTRIGGER") == "No") {
							$mail->AddAddress($recipient,$recipient);
							$sto .= "," . $recipient;
							$rec++;
							array_push($GLOBALS['email_send_to'],$recipient);
							$add_to_journal .= "\nEmail sent to " . $recipient;
							log_msg("Triggered e-mail send to " . $recipient);
						} elseif (GetSetting("ONEMAILPERTRIGGER") == "Yes") {
							qlog(INFO, "Skipping " . $recipient . ", already send this guy something");
							log_msg("Skipping " . $recipient . ", already send this guy something");
							$add_to_journal .= "\nSkipping " . $recipient . ", already send this guy something";
						} else {
							log_msg("ERROR: Don't know what to do with this triggered e-mail (1)");
							qlog(ERROR, "ERROR: Don't know what to do with this triggered e-mail (1)");
						}
					} else {
						qlog(INFO, "Skipping " . $recipient . ", this email address is not a valid internet email address.");
						log_msg("Skipping " . $recipient . ", this email address is not a valid internet email address.");
						$add_to_journal .= "\nSkipping " . $recipient . ", this email address is not a valid internet email address.";
					}
				}
			} else {

				if (ValidateEmail($To)) {
					if ((!in_array($To,$GLOBALS['email_send_to'])) || GetSetting("ONEMAILPERTRIGGER") == "No") {
						$mail->AddAddress($To,$To);
						$sto = $To;
						array_push($GLOBALS['email_send_to'],$To);
						$rec++;
						$add_to_journal .= "\nEmail sent to " . $To;
					} elseif (GetSetting("ONEMAILPERTRIGGER") == "Yes") {
						qlog(INFO, "Skipping " . $To . ", already send this guy something");
						log_msg("Skipping " . $To . ", already send this guy something");
						$add_to_journal .= "\nSkipping " . $To . ", already send this guy something";
					} else {
						log_msg("ERROR: Don't know what to do with this triggered e-mail (2)");
						qlog(ERROR, "ERROR: Don't know what to do with this triggered e-mail (2)");
					}

				} else {
					qlog(INFO, "Skipping " . $To . ", this email address is not a valid internet email address.");
					log_msg("Skipping " . $To . ", this email address is not a valid internet email address.");
					$add_to_journal .= "\nSkipping " . $To . ", this email address is not a valid internet email address.";
				}
			}

			$mail->Subject = $Subject;
			$mail->XMailer = ' ';
			if ($rec>0) {
				if(!$mail->Send()) {
					echo "<span class='errmsg'>There has been a mail error sending to " . $sto . ": " . $mail->ErrorInfo . ". Please contact your system administrator.</span><br>";
					log_msg("ERROR: Sending e-mail to " . $sto . " failed:" . $mail->ErrorInfo);
					$add_to_journal .= "\nSending e-mail to " . $sto . " failed:" . $mail->ErrorInfo;

					return array($mail->ErrorInfo, false);

				} else {
					log_msg("Notification e-mail sent to " . $sto);
					//if ($entity) journal($entity, "E-mail was successfully delivered to mail server: " . $To . "(trigger " . $event[6] . ")");
					qlog(INFO, "An e-mail was sent.");
				}
			}

			$mail->ClearAddresses();
			$mail->ClearAttachments();
		} else {
			log_msg("ERROR: No template received! Not Mailing.");

			//journal($entity, "WARNING: Tried to mail but template is incorrect or empty! " . $To);
			return array("No template received. Quitting.", false);
		}
	} else {
		log_msg("ERROR: Tried to mail but e-mail address is incorrect or empty! " . $To);

		//journal($entity, "WARNING: Tried to mail but e-mail address is incorrect or empty! " . $To);
	}

	return array($add_to_journal, true);
}
function CountTotalNumOfRecords() {
	$enum = 0;
	foreach ($GLOBALS['UC']['PersonalDataStructure'] AS $table => $props) {
		$enum += db_GetValue("SELECT COUNT(*) FROM `CRM" . $props['name_in_database'] . "`");
	}
	return $enum;
}
function AdminTabs() {
	if (is_administrator() && !$_REQUEST['nonavbar']) {
		PlainNav(get_admin_nav_items());
	}
}
function CheckDatabaseSettings() {
	$ret = "";
	if (GetSetting('EnableMailMergeAndInvoicing') == "Yes") {
		//print "Mail merging and invoicing is enabled\n";
	}

	if (GetSetting("cronpassword") == "*NONE*" || GetSetting("cronpassword") == "") {
		$ret .= "WARNING : The cron password is not set!\n";
	}
	if ($GLOBALS['logtext'] == true) {
		$ret .="WARNING : LOGTEXT is enabled. This slows " . $GLOBALS['PRODUCT'] . " down by 25%!\n";
	}
	if ($GLOBALS['logqueries'] == true) {
		$ret .= "WARNING : LOGQUERIES is enabled. This slows stuff down.\n";
	}
	$fp = @fopen("qlist.txt","r");
	if ($fp) {
		$ret .= "WARNING : SECURITY HAZARD: Your qlist.txt file is world-readable.\n";
		fclose($fp);
	}

	if (ini_get("magic_quotes_gpc") == 1) {
			$ret .= "ERROR   : Magic quotes is on! Should be off!\n";
	} else {
			//$ret .= "ERROR   : Magic quotes is off!\n";
	}

	if (GetSetting("TimestampLastDuedateCron") < (date('U') - 86400)) {
			$ret .= "ERROR   : It's more than a day ago since the duedate notifier script ran! (last run: " . date('Y-m-d H:i:s', GetSetting("TimestampLastDuedateCron")) . ")\n";
	}
	if (GetSetting("TimestampLastHousekeeping") < (date('U') - 3600)) {
			$ret .= "ERROR   : It's more than an hour ago since the housekeeping script ran! (last run: " . date('Y-m-d H:i:s', GetSetting("TimestampLastHousekeeping")) . ")\n";
	}

	if ($ret) {
		return $ret . "\n";
	} else {
		return "No messages\n\n";
	}
}
function DeleteProfile($prof_num) {
	$members = GetProfileMembers($prof_num);
	if (sizeof($members) > 0) {
		print "This group cannot be deleted because the following user(s) still inherit it:<br>";
		foreach ($members AS $user) {
			print "<br>" . GetUserName($user);
		}
		print "<br><br>";
	} elseif ($prof_num != 0) {
		$GLOBALS['JavascriptToPrintAtEndOfPage_OnlyJS'][] = "window.location.href = 'record.php?table=groups&record=" . $prof_num . "&delete=1';";
	}
}

function CheckDB($run_db_upgrade = true, $web=false) {
	global $short, $serr, $auto;
	unset($serr);

	$deldoubles = array();
	if ($_REQUEST['input']) {
		// OK two arrays of to-delete data were submitted.
		// Namely:
		// file_td	:	files to delete

		$file_td =		unserialize(base64_decode($_REQUEST['file_td']));

		$deldoubles =	unserialize(base64_decode($_REQUEST['deldoubles']));

		$queries = array();

		foreach ($file_td as $file) {
			array_push($queries,"DELETE FROM CRMbinfiles WHERE fileid='" . mres($file) . "'");
			array_push($queries,"DELETE FROM CRMblobs WHERE fileid='" . mres($file) . "'");
		}

		//print_r($queries);

		$queries = array_merge($queries, $deldoubles);

		foreach($queries as $sql) {
			mcq($sql);
		}

		print "<pre>" . sizeof($queries) . " database queries executed.\n</pre>";

	} else {
		AdminChangesDropCache();
		if ($run_db_upgrade) {
			IntermediateDatabaseUpgrade();
		}
		if ($web) {
		    print "<pre>";
		}
		// Check required ref-to-flex fields
		/*
		foreach (array_keys($GLOBALS['UC']['PersonalDataStructure']) as $table) {
			foreach (array_keys($GLOBALS['UC']['PersonalDataStructure'][$table]["fields"]) as $field) {
				if (($GLOBALS['UC']['PersonalDataStructure'][$table]["fields"][$field]["required"]) && ($GLOBALS['UC']['PersonalDataStructure'][$table]["fields"][$field]["relation_to"] != "")) {
					//do check
				}
			}
		}
		*/
/*
		$list = db_GetArray("SELECT id, name, options, tabletype FROM CRMextrafields WHERE fieldtype ='Reference to FlexTable' AND forcing ='y' AND deleted='n'");
		foreach ($list AS $row) {
			if (is_numeric($row['tabletype'])) {
				$table = "CRMflextable" . $row['tabletype'];
			} elseif ($row['tabletype'] == "user") {
				$table = "CRMloginusers";
			} elseif ($row['tabletype'] == "group") {
				$table = "CRMuserprofiles";
			} elseif ($row['tabletype'] == "files"){
				$table = "CRMbinfiles";
			} else {
				$table = "CRM" . $row['tabletype'];
			}
			$cnt = db_GetValue("SELECT COUNT(*) FROM " . $table . " WHERE EFID" . $row['id'] . "=0");

			if ($cnt > 0) {
				print "BIG WARNING: Field " . $row['id'] . " (" . htme($row['name']) . ") is required, ref-to-flex but found " . $cnt . " empty records!";
				if ($web) {
					print "<br>";
				} else {
					print "\n";
				}
			}
		}
		$mr = FindMissingReferences();
		if ($web) {
			print $mr;
		} else {
			print strip_tags($mr);
		}
*/
		$ftd = array();

		if (!isset($_REQUEST['CheckColumnsOnly'])) {

			$tit = GetSetting("title");
			print "\nStarting recursive reference check - repository \"" . $tit . "\".\n";

			$blobids = array();
			$binids = array();
			if (!$short) print "\nChecking binary large object references (blobs table)...\n";
			$binids = db_GetFlatArray("SELECT fileid FROM CRMbinfiles");
			$blobids = db_GetFlatArray("SELECT fileid FROM CRMblobs");
			$xc = 0;
			foreach ($blobids AS $id) {
				$xc++;
				if (!$web) {
					if (!$short) print "\015" . $xc . "/" . sizeof($blobids);
				}
				if (!in_array($id,$binids)) {
					if (!$short) print "\nFile ID " . $id . " exists in BLOB table, but it doesn't exist in BIN table (binary content will be deleted)\n";
					array_push($ftd,$id);
					$serr=1;
				}
			}
			if (!$short) print "\nChecking binary large object references (binfiles table)...\n";
			$xxc = 0;
			foreach ($binids AS $id) {
				$xxc++;
				if (!$web) {
					if (!$short) print "\015" . $xxc . "/" . sizeof($blobids);
				}
				if (!in_array($id,$blobids)) {
					if (!$short) print "\nFile ID " . $id . " exists in BIN table, but it doesn't exist in BLOB table (file will be empty)\n";
				}
			}
			if (!$short) print "\n";

			if (!$short) print "Checking for double language tags....";


			$deldoubles = array();
			foreach (db_GetArray("SELECT DISTINCT(CONCAT(LANGID,';',TEXTID)) AS ErrorneousValues FROM CRMlanguages GROUP BY ErrorneousValues HAVING COUNT(CONCAT(LANGID,TEXTID)) > 1") AS $res2) {
				$item = explode(";", $res2[0]);
				$delnums = array();
				print "Language " . $item[0] . ", tag " . $item[1] . " - double entry. Oldest must be deleted.\n";
					if ($item[0]) {
						$delnums = db_GetFlatArray("SELECT id FROM CRMlanguages WHERE LANGID='" . mres($item[0]) . "' AND TEXTID='" . mres($item[1]) . "'");
					}
				@sort($delnums);

				array_push($deldoubles,"DELETE FROM CRMlanguages WHERE LANGID='" . mres($item[0]) . "' AND TEXTID='" . mres($item[1]) . "' AND id<" . $delnums[sizeof($delnums)-1] . " AND id!=" . $delnums[sizeof($delnums)-1]);
				$serr = 1;
			}

			if (!$short) print "\n" . sizeof($deldoubles) . " double entries found. Oldest values will be deleted.\n";

			qlog(INFO, "Checking database");
		}

		// Check if all fields are represented all flextables

		$list = GetFlexTableDefinitions();

		foreach ($list AS $flextable) {
			print "Checking extra flextable " . $flextable['recordid'] . " field columns...\n";
			$efs = GetExtraFlextableFields($flextable['recordid']);

			$tmp = db_GetArray("SHOW FIELDS FROM CRMflextable"  . $flextable['recordid']);
			foreach ($efs AS $ef) {
				$found = false;
				foreach ($tmp AS $row) {
					if ($row['Field'] == "EFID" . $ef['id']) {
						$found = true;
					}
				}
				if (!$found) {
					$ft = "";
                    $add = "";
					if ($ef['fieldtype'] == "date/time") {
						$ft = "DATETIME";
                       $add = " DEFAULT '0000-00-00 00:00:00'";

					} else {
						$ft = "LONGTEXT";
					}
					mcq("ALTER TABLE CRMflextable" . $flextable['recordid'] . " ADD EFID" . $ef['id'] . " " . $ft . " NOT NULL" . $add);
					print "Fixed missing column in flextable " . $flextable['recordid'] . " for field EFID" . $ef['id'] . "\n";
				}
			}
			print "OK.\n";
		}

		if (!isset($_REQUEST['CheckColumnsOnly'])) {
			print "\n\nFiles which can be deleted: " . sizeof($ftd) . "\n";
			print "Unused language tags which will be deleted: " . sizeof($deldoubles) . "\n";


			if (!$web && !$serr) {
				print "\nNothing to do. Bye!\n\n";
				return "exit";
			}

			if ($web) {
				print "</pre>";

				if ($serr) {
					print "<form id='cont' method='post' action=''><div class='showinline'>";
					print "<input name='file_td' type='hidden' value='" . base64_encode(serialize($ftd)) . "'>";

					print "<input name='deldoubles' type='hidden' value='" . base64_encode(serialize($deldoubles)) . "'>";

					print "<input name='input' type='hidden' value='1'>";
					print "<input name='checkdb' type='hidden' value='1'>";
					print "<input type='submit' value='Delete excess data (back-up first)'></div></form>";
				} else {
					print "No errors found which can be fixed automatically.<br><br>";

				}
			} else {
				if (!$auto) {
					print "Return status: " . $serr . "\n";
					print "\nDo you want to delete these (obviously unreachable) records? [y|n]\n" . $GLOBALS['PRODUCT'] . " > ";
					$a = readln();
					if (strtoupper($a)!='Y') {
						print "\nOK\n";
						return "exit";
					}
					unset($serr);
				}

				$queries = array();

				foreach ($ftd as $file) {
					array_push($queries,"DELETE FROM CRMbinfiles WHERE fileid='" . mres($file) . "'");
					array_push($queries,"DELETE FROM CRMblobs WHERE fileid='" . mres($file) . "'");
				}
				$queries = array_merge($queries, $deldoubles);
				//print_r($queries);
				$sqlc = 0;
				foreach($queries as $sql) {
					mcq($sql);
					//print $sql . "\n\n";
					$sqlc++;
					if (!$web) print "Executing queries, please be patient. (" . $sqlc . "/" . sizeof($queries) . ")\015";
				}
				print "\n" . sizeof($queries) . " database queries executed.\n";

				unset($queries);
				$x = 0;
				foreach ($GLOBALS['UC']['PersonalDataStructure'] AS $table => $props) {

					if (!$web) print "\015Optimizing tables..(" . $x . "/" . sizeof($GLOBALS['UC']['PersonalDataStructure']) . ")";
					$sql = "OPTIMIZE TABLE `CRM" . $props['name_in_database'] . "`";
					mcq($sql);
				}
				$x++;
				print " ... done\n\n";
				log_msg("Database checked. " . sizeof($queries) . " delete statements executed");
				qlog(INFO, "Database checked. " . sizeof($queries) . " delete statements executed");

			}
		}
	} // End if not submitted
	print '<pre>';
	PerformDatabaseMaintenance(true);
	print '</pre>';

} //end function CheckDB
function GetCurrentDBTotalSize() {
	$size = 0;
	foreach (db_GetArray("SHOW TABLE STATUS") AS $stat) {

		$size += $stat["Data_length"];
		$size += $stat["Index_length"];
	}
	return ceil(($size/1024)/1024);
}
function AdminChangesDropCache() {
	global $lang;

	DropPersonalDataStructure(0);
	unset($GLOBALS['UC']['PersonalDataStructure']);
	$lang = do_language();
	CheckAndCreateSystemDataStructure();
	InitUser();
}
function ProcessArchiving() {
	// File compression level
	// A  - Don't compress at all (except for old versions)
	// B1 - Compress files older than 1 year
	// B2 - Compress files older than 1 year and only if the entity is deleted
	// C1 - Compress files older than 6 months
	// C2 - Compress files older than 6 months and only if the entity is deleted
	// D  - Compress all files

	$now = date('U');
	$halfyearago = $now - 15811200;
	$yearago = $now - 31536000;

	//GetSetting("FILECOMPRESSIONLEVEL") = "C2";

	$sql = "";
	switch (GetSetting("FILECOMPRESSIONLEVEL")) {
		case "A":
			qlog(INFO, "Not compressing any files.");
			return true;
			break;
		case "B1":
			$sql = "SELECT CRMbinfiles.fileid FROM CRMbinfiles, CRMblobs WHERE CRMbinfiles.fileid=CRMblobs.fileid AND UNIX_TIMESTAMP(CRMbinfiles.timestamp_last_change) < '" . $yearago . "' AND gz!='y' AND CRMbinfiles.fileid!=0";
			break;
		case "C1":
			$sql = "SELECT CRMbinfiles.fileid FROM CRMbinfiles, CRMblobs WHERE CRMbinfiles.fileid=CRMblobs.fileid AND UNIX_TIMESTAMP(CRMbinfiles.timestamp_last_change) < '" . $halfyearago . "' AND gz!='y' AND CRMbinfiles.fileid!=0";
			break;
		case "D":
			$sql = "SELECT CRMbinfiles.fileid FROM CRMbinfiles, CRMblobs WHERE CRMbinfiles.fileid=CRMblobs.fileid AND gz!='y' AND CRMbinfiles.fileid!=0";
			break;
		default:
			log_msg("ERROR: Not able to determine compression level. Quitting. -> " . GetSetting("FILECOMPRESSIONLEVEL"));
			print("ERROR: Not able to determine compression level. Quitting. -> " . GetSetting("FILECOMPRESSIONLEVEL"));
			return true;
			break;
	}
		$list = db_GetArray($sql);

		foreach($list AS $file) {
			print "\015Compressing file " . $file['fileid'] . "   ";
			CompressFile($file['fileid']);
		}

		$sql = "SELECT CRMbinfiles.fileid FROM CRMbinfiles, CRMblobs WHERE CRMbinfiles.fileid=CRMblobs.fileid AND version_no > 1 AND gz!='y' AND CRMbinfiles.fileid!=0";
		$list = db_GetArray($sql);
		foreach($list AS $file) {
			CompressFile($file['fileid']);
			print "\015Compressing file " . $file['fileid'] . " (old version)   ";
		}
		print "\n";
		mcq("OPTIMIZE TABLE CRMblobs");

		print "Done.\n";
}
function DropUnusedFieldsFromDatabase() {
	MustBeAdmin();

	// Array to hold the result
	$q = array();
	$ql = array();
	$qs = array();
	$add_last = "";
	$totalsize = 0;
	$views = array();

	// What it should be
	$efs = array();
	foreach (db_GetArray("SELECT tabletype, CONCAT('EFID', id) FROM CRMextrafields WHERE deleted='n'") AS $row) {
		if (is_numeric($row['tabletype'])) {
				$row['tabletype'] = "flextable" . $row['tabletype'];
		}
		if ($row['tabletype'] == "user") $row['tabletype'] = "loginusers";
		if ($row['tabletype'] == "group") $row['tabletype'] = "userprofiles";
		if ($row['tabletype'] == "files") $row['tabletype'] = "binfiles";

		$row['tabletype'] = "CRM" . $row['tabletype'];
		$efs[$row['tabletype']][] = $row[1];
	}
	$fts = db_GetFlatArray("SELECT CONCAT('CRMflextable', recordid) FROM CRMflextabledefs");
		$fts[] = "CRMloginusers";
	$fts[] = "CRMuserprofiles";
	$fts[] = "CRMbinfiles";

	// What it is
	$ftz = array();
	$efst = db_GetFlatArray("SHOW TABLES");
	foreach ($efst AS $tab) {
		if (substr($tab, 0, 12) == "CRMflextable" && $tab != "CRMflextabledefs") {
			$ftz[] = $tab;
			if (!in_array($tab, $fts)) {
				$tmp = db_GetArray("SHOW TABLE STATUS LIKE '" . $tab . "'");

				$totalsize += ($tmp[0]['Index_length'] + $tmp[0]['Data_length']);

				$q[] = array("table" => $tab, "size" => number_format(($tmp[0]['Index_length'] + $tmp[0]['Data_length'])/1024/1024, 2) . " M", "rows" => $tmp[0]['Rows']);

				$qs[] = "DROP TABLE " . $tab;
				$qs[] = "DELETE FROM CRMstats WHERE item='flextable" . str_replace("CRMflextable", "", $tab) . "'";
				}
		}
	}

	$ftz[] = "CRMloginusers";
	$ftz[] = "CRMuserprofiles";
	$ftz[] = "CRMbinfiles";

	foreach ($fts AS $table) {
		if (!in_array($table, $views)) {
			$sql = "SHOW FIELDS FROM " . mres($table) . " WHERE Field LIKE 'EFID%'";

			$ef = db_GetFlatArray($sql);
			foreach ($ef AS $field) {
				if (!in_array($field, $efs[$table])) {
					$size = db_GetRow("SELECT SUM(LENGTH(" . $field . ")), COUNT(*) FROM " . $table . " WHERE " . $field . " != ''");
					$totalsize += $size[0];
					$q[] = array("table" => $table, "field" => $field, "size" => number_format($size[0]) . " Bytes", "rows" => $size[1], "name" => db_GetValue("SELECT name FROM CRMextrafields WHERE id='" . str_replace("EFID", "", $field) . "'"), "type" => db_GetValue("SELECT fieldtype FROM CRMextrafields WHERE id='" . str_replace("EFID", "", $field) . "'"));
					$ql[$table][] = $field;
				}
			}
		}
	}
	print "Total size on disk to gain: " . FormatNumber($totalsize/1024/1024) . "MB. <a onclick=\"toggleLayer('queries');\">Show/hide queries</a>";
	print "<div id=\"queries\" style=\"display: none;\">";
	print "<textarea cols=100 rows=10>";
	foreach ($qs AS $qbla) {
		print $qbla . ";\n";
	}
	foreach ($ql AS $table => $fields) {
		print "ALTER TABLE " . $table . "";
		$nf = false;
		foreach ($fields AS $field) {
			if ($nf) print ", ";
			print " DROP `" . $field . "`";
			$nf = true;
		}
		print ";\n";
	}
	print $add_last;

	print "</textarea>";
	print "</div>";
	print "<table class=\"crm sortable\"><thead><tr><th>Table</th><th>Field</th><th>Name</th><th>Size on disk</th><th>Rows</th><th>Type</th><th>Times found</th></tr></thead>";
	foreach ($q AS $row) {
		print "<tr>";
		foreach (array("table", "field", "name", "size", "rows", "type") AS $el) {
				print "<td>" . mres($row[$el]) . "</td>";
		}
		print '<td>';
		print db_GetValue("SELECT (CONCAT('Templates: ', (SELECT GROUP_CONCAT(CRMtemplates.templateid) FROM CRMtemplates WHERE (CRMtemplates.content LIKE '%" . str_replace("CRMflextable", "t", $row['table']) .  "-f" . str_replace("EFID", "", $row['field']) . "%' OR CRMtemplates.content LIKE '%" . $row['field'] . "%') AND version_belonging_to =0), ' Modules: ', (SELECT GROUP_CONCAT(CRMmodules.mid) FROM CRMmodules WHERE (CRMmodules.module_code LIKE '%" . str_replace("CRMflextable", "t", $row['table']) .  "-f" . str_replace("EFID", "", $row['field']) . "%' OR CRMmodules.module_code LIKE '%" . $row['field'] . "%') AND version_belonging_to =0)))");
		print '</td>';
		print "</tr>";
	}

	print "</table>";
}
function ValidatePHPSyntax($code) {
	$fn = tempnam("", "INTLV_MODPARSE");
	$fp = fopen($fn, "w");
	if (substr($code, 0, 5) != "<?php") {
		$code = "<?php\n" . $code . "\n?>";
	}
	fputs($fp, $code);
	ob_start();
	system("php -d display_errors=1 -l " . $fn);
	unlink($fn);

	$resultPHPcheck = ob_get_contents();
	ob_end_clean();

	$resultPHPcheck = str_replace("\nParse error", "Parse error", $resultPHPcheck);
	$resultPHPcheck = str_replace("in " . $fn, "", $resultPHPcheck);

	return $resultPHPcheck;
}
function MailQueueManager() {

	MustBeAdmin();
	$tabbs = array();
	$tabbs[] = array("admin.php?MailQueueManager","Waiting");
	$tabbs[] = array("admin.php?MailQueueManager&amp;Sent","Sent");
	$tabbs[] = array("admin.php?MailQueueManager&amp;Failed" , "Failed");
	$tabbs[] = array("admin.php?MailQueueManager&amp;All","All");
	$tabbs_actions = array();
	$tabbs_actions[] = array("admin.php?MailQueueManager&amp;Failed&amp;SkipMainNavigation&amp;DropFailed", "Delete all failed messages");
	$tabbs_actions[] = array("admin.php?MailQueueManager&amp;ProcessMailQueue", "Process mail queue now");
	$tabbs_actions[] = array("admin.php?MailQueueManager&amp;DeleteUnsentMailQueue","Delete waiting mails from queue");

	$tabbs[] = array("#","Actions", $tabbs_actions);

	if (isset($_REQUEST['DropBodies'])) {
		$sql = "UPDATE CRMmailqueue SET template='' WHERE status='sent' AND LENGTH(template) > 10";
		mcq($sql);

	} elseif (isset($_REQUEST['DropTheRest'])) {
		$sql = "DELETE FROM CRMmailqueue WHERE status='sent'";
		mcq($sql);
/*
} elseif ($_REQUEST['DeleteQueueItem']) {
		$sql = "DELETE FROM CRMmailqueue WHERE queueid='" . mres($_REQUEST['DeleteQueueItem']) . "'";
		mcq($sql);
*/
	}

	if ($_REQUEST['dropmailto']) {
		print "Deleting all mail sent to address " . htme($_REQUEST['dropmailto']);
		$sql = "DELETE FROM CRMmailqueue WHERE `to`='" . mres($_REQUEST['dropmailto']) . "'";
		mcq($sql);
	}

	PlainNav($tabbs);

	$customheader = "";
	$lo = array("table" => "mailqueue");

	if (isset($_REQUEST['Failed'])) {
		if (isset($_REQUEST['DropFailed'])) {
			if (isset($_REQUEST['Sure'])) {
				mcq("DELETE FROM CRMmailqueue WHERE status='error'");
			} else {

				print "<p><a class='warnmsg' href='admin.php?MailQueueManager&amp;Failed&amp;SkipMainNavigation&amp;DropFailed&amp;Sure'>Are you sure? " . FormatNumber(db_GetValue("SELECT COUNT(*) FROM CRMmailqueue WHERE status='error'"), 0) . " messages will be permanently deleted.</a></p>";
			}
		}
		$customheader = "E-mails which were not sent";
		$lo["hiddenfilter"]["mailqueue-status"] = array("error");
	} elseif (isset($_REQUEST['All'])) {

	} elseif (isset($_REQUEST['Sent'])) {
		$customheader = "Sent e-mails";


		$lo["hiddenfilter"]["mailqueue-status"] = array("sent");

		//$sumofsend = db_GetValue("SELECT COUNT(*) FROM CRMmailqueue WHERE status='sent'");
		//print "Total number of sent mails : " . FormatNumber($sumofsend,0) . "";

		print "<br>";

		$sumofsend_bodies = db_GetValue("SELECT SUM(LENGTH(template)) FROM CRMmailqueue WHERE status='sent' AND LENGTH(template) > 10");
		print "Total megabytes in mailbodies: " . round(ceil($sumofsend_bodies/1024/1024),2) . " [<a href=\"admin.php?MailQueueManager&amp;Sent&amp;DropBodies\">drop mailbodies but keep the rest</a>]<br>";

		$sumofsend_bodies = db_GetValue("SELECT SUM(LENGTH(CONCAT(template,user,entity,customer,`from`,fromname,`to`,PDF,subject,attach_to_dossier,attach_as_filename,report_attach,flextableid,flextablerecord,date_sent,status,worker_hash,date_queued))) FROM CRMmailqueue WHERE status='sent' AND LENGTH(template) > 10");
		print "Total megabytes overall : " . round(ceil($sumofsend_bodies/1024/1024),2) . " [<a href=\"admin.php?MailQueueManager&amp;Sent&amp;DropTheRest\">drop all sent mail</a>]<br>";

		print "Drop all mail sent to address: <form id='mailqform' method='post' action='admin.php?MailQueueManager&amp;Sent'><input type='text' size='50' name='dropmailto' id='JS_dropmailto'> <input type='submit' id='JS_mailqform_submit' value='Ok'></form>";

	} else {
		if (isset($_REQUEST['ProcessMailQueue'])) {
			ProcessMailQueue();
			print "Mail queue processed<br>";
		} elseif (isset($_REQUEST['DeleteUnsentMailQueue'])) {
			mcq("UPDATE CRMmailqueue SET worker_hash='Deleted from queue by admin', status='error' WHERE status='unsent' and worker_hash = ''");
			print '<div class="okmsg">Unsent mail queue emptied</div>';
		}

		$lo["hiddenfilter"]["mailqueue-status"] = array("unsent");
		$customheader = "E-mails waiting to be sent";
		print "<h2>Messages which are in the queue for more than 2 hours will be moved to the error queue, regardless the reason.</h2>";

	}

	$lo["customheader"] = $customheader;

	print "BCC All outgoing mail to (queued mail only) : " . AttributeAjaxEditElement("system", "BCCAllOutgoingQueuedMailToAddr", 2);
	print " | Currently using smtp: " . GetSetting("SMTPServer");
	if (GetSetting("DevelopmentOrProduction") == "Development") {

			print '<br><span class="warnmsg">This repository is in Development mode, when processing the queue all mails will be redirected to ' . AttributeAjaxEditElement("system", "AddressToSendAllMailsToWhenInDevelopmentMode", 2) . '</span>';
	}


	list($number_of_records, $output) = make_list($lo);
	print $output;
}
function LogStats($print=false) {

	// This functions aims to log stats about the whole database

	/*
	+-----------------------+---------------+------+-----+-------------------+-------+
	| Field                 | Type          | Null | Key | Default           | Extra |
	+-----------------------+---------------+------+-----+-------------------+-------+
	| item                  | varchar(20)   | NO   |     | NULL              |       |
	| value                 | varchar(1024) | NO   |     | NULL              |       |
	| count                 | int(11)       | NO   |     | NULL              |       |
	| sum                   | int(11)       | NO   |     | NULL              |       |
	| avg                   | int(11)       | NO   |     | NULL              |       |
	| timestamp_last_change | timestamp     | NO   |     | CURRENT_TIMESTAMP |       |
	+-----------------------+---------------+------+-----+-------------------+-------+
	*/



	$stats = array();
	mcq("DELETE FROM CRMstats WHERE DATE(timestamp_last_change) = '" . date('Y-m-d') . "'");

	$stats[] = array("users", "", db_GetValue("SELECT COUNT(*) FROM CRMloginusers WHERE name NOT LIKE 'deleted%'"), "", "");
	$stats[] = array("groups", "", db_GetValue("SELECT COUNT(*) FROM CRMuserprofiles"), "", "");


	$yesterday = date('U') - (3600 * 24);
	$ystd = date('Y-m-d', $yesterday);


	$stats[] = array("datajournal_inserts", "", db_GetValue("SELECT COUNT(*) FROM CRMdatajournal WHERE DATE(timestamp_last_change) = '" .$ystd . "'"), "", "");
	$stats[] = array("journal_inserts", "", db_GetValue("SELECT COUNT(*) FROM CRMjournal WHERE DATE(timestamp_last_change) = '" .$ystd . "'"), "", "");
	$stats[] = array("logins", "", db_GetValue("SELECT COUNT(*) FROM CRMuselog WHERE UNIX_TIMESTAMP(timestamp_last_change) > '" . $yesterday . "' AND qs LIKE 'Login%'"), "", "");
	$stats[] = array("file_downloads", "", db_GetValue("SELECT COUNT(*) FROM CRMuselog WHERE UNIX_TIMESTAMP(timestamp_last_change) > '" . $yesterday . "' AND qs LIKE 'downloaded%'"), "", "");

	foreach (GetFlextableDefinitions() AS $table) {
			$stats[] = array("flextable" . $table['recordid'], "", db_GetValue("SELECT COUNT(*) FROM CRMflextable" . $table['recordid'] . " WHERE deleted='n'"), "","");
	}
	$sql = "INSERT INTO CRMstats(item,value,count,sum, avg) VALUES ";
	$nnf = false;
	foreach ($stats AS $line) {
		if ($nnf) $sql .= ",";
		$sql .= "(";
		$nf = false;
		foreach ($line AS $row) {
			if ($nf) $sql .= ",";
			$sql .= "'" . mres($row) . "'";
			$nf = true;
		}
		$sql .= ")";
		$nnf = true;
	}

	mcq($sql);

	$ef = db_GetArray("SELECT id,fieldtype, tabletype FROM CRMextrafields WHERE deleted='n' AND log_stats='y'");

	//AND (fieldtype IN ('numeric', 'drop-down', 'Reference to FlexTable') OR fieldtype LIKE 'User%')");

	foreach ($ef AS $field) {
		$table = "";
		if ($field['tabletype'] == "user") {
			$table = "CRMloginusers";
		} elseif ($field['tabletype'] == "group") {
			$table = "CRMuserprofiles";
		} else {
			$table = "CRMflextable" . $field['tabletype'];
		}

		mcq("INSERT INTO CRMstats(item, value, count, sum, avg) SELECT '" . $field['id'] . "',EFID" . $field['id'] . ", COUNT(*), SUM(EFID" . $field['id'] . "), AVG(EFID" . $field['id'] . ") FROM " . $table . " GROUP BY EFID" . $field['id']);

	}

	if ($print) {
		PHT("SELECT name, tabletype, fieldtype, item,value,count,sum,avg,CRMstats.timestamp_last_change FROM CRMstats LEFT OUTER JOIN CRMextrafields ON (item=id OR id IS NULL)");
	}
}

function OffloadFilesToDisk() {

	$now = date('U');
	$yearago =			$now - 31536000;
	$halfyearago =		$now - 15811200;
	$threemonthsago =	$now -  7948800;
	$onemonthago =		$now -  2635200;
	$oneweekago =		$now -  604800;
	$onedayago =		$now -  86400;

	$localpath = GetSetting("OffloadLocalPath");

	if ($localpath == "") {
		return false;
	} else {

		$sql = "";
		switch (GetSetting("OffloadFilesPolicy")) {
			case "Don't offload files to disk":
				qlog(INFO, "Not offloading any files.");
				return true;
				break;
			case "After a year":
				$sql = "SELECT CRMbinfiles.fileid FROM CRMbinfiles WHERE UNIX_TIMESTAMP(CRMbinfiles.timestamp_last_change) < '" . $yearago . "' AND CRMbinfiles.offloaded='n' AND CRMbinfiles.fileid!=0";
				break;
			case "After 6 months":
				$sql = "SELECT CRMbinfiles.fileid FROM CRMbinfiles WHERE UNIX_TIMESTAMP(CRMbinfiles.timestamp_last_change) < '" . $halfyearago . "' AND CRMbinfiles.offloaded='n' AND CRMbinfiles.fileid!=0";
				break;
			case "After 3 months":
				$sql = "SELECT CRMbinfiles.fileid FROM CRMbinfiles WHERE UNIX_TIMESTAMP(CRMbinfiles.timestamp_last_change) < '" . $threemonthsago . "' AND CRMbinfiles.offloaded='n' AND CRMbinfiles.fileid!=0";
			case "After 1 month":
				$sql = "SELECT CRMbinfiles.fileid FROM CRMbinfiles WHERE UNIX_TIMESTAMP(CRMbinfiles.timestamp_last_change) < '" . $onemonthago . "' AND CRMbinfiles.offloaded='n' AND CRMbinfiles.fileid!=0";
				break;
			case "After 1 week":
				$sql = "SELECT CRMbinfiles.fileid FROM CRMbinfiles WHERE UNIX_TIMESTAMP(CRMbinfiles.timestamp_last_change) < '" . $oneweekago . "' AND CRMbinfiles.offloaded='n' AND CRMbinfiles.fileid!=0";
				break;
			case "After 1 day":
				$sql = "SELECT CRMbinfiles.fileid FROM CRMbinfiles WHERE UNIX_TIMESTAMP(CRMbinfiles.timestamp_last_change) < '" . $onedayago . "' AND CRMbinfiles.offloaded='n' AND CRMbinfiles.fileid!=0";
				break;
			default:
				return true;
			break;

		}

		$sql .= "  AND CRMbinfiles.type NOT IN ('system', 'generalpurpose', 'public')";

		$hash = GetSetting("OffLoadedFilesDirectoryHash");
		$key = GetSetting("OffLoadedFilesSSLKey");


		if ($hash == "") {
			$hash = md5(GetSetting("title") . date('U'));
			SetAttribute("system", "OffLoadedFilesDirectoryHash", $hash, 2);
		}

		if (!is_dir($localpath . "/" . $hash)) {
			mkdir($localpath . "/" . $hash);
			print "\015" . date('r') . ": Created directory " .$localpath . "/" . $hash . "\n";
		}
		$list = db_GetArray($sql);

		foreach($list AS $file) {

			$filename = $localpath . "/" . $hash . "/" . $file['fileid'];
			$efilename = $localpath . "/" . $hash . "/e" . $file['fileid'];

			$filecontent = db_GetValue("SELECT content FROM CRMblobs WHERE fileid=" . $file['fileid']);

			file_put_contents($filename, $filecontent);
			$check = "";

			if ($key != "") { // file is, or must be, encrypted
				print  date('r') . ": Offloading and encrypting file " . $file['fileid'] . " in " . $efilename . " \n ";

				system("cat " . $filename . " | openssl aes-256-cbc -k " . $key . " > " . $efilename);

				$check = `cat $efilename | openssl aes-256-cbc -d -k $key`;

				unlink($filename);

			} else {
				print date('r') . ": Offloading file " . $file['fileid'] . " in " . $filename . "  ";

				$check = file_get_contents($filename);
			}

			if ($check == $filecontent) {
				print " (validated, all ok)\n";

				mcq("UPDATE CRMblobs SET CRMblobs.content='', CRMblobs.timestamp_last_change=CRMblobs.timestamp_last_change WHERE CRMblobs.fileid=" . $file['fileid'] );

				mcq("UPDATE CRMbinfiles SET offloaded='y', timestamp_last_change=timestamp_last_change WHERE fileid='" . $file['fileid'] . "'");

			} else {
				print " (validation failed, rollback)\n";
			}

		}

		mcq("UPDATE CRMblobs, CRMbinfiles SET offloaded='n', CRMbinfiles.timestamp_last_change=CRMbinfiles.timestamp_last_change, CRMblobs.timestamp_last_change=CRMblobs.timestamp_last_change where CRMbinfiles.fileid=CRMblobs.fileid AND CRMblobs.content!='' AND offloaded='y'");

		//print "Done.\n";
	}
}
function LoadOffloadedFilesBackIntoDB() {
	$hash = GetSetting("OffLoadedFilesDirectoryHash");

	if ($hash == "") {
		print "\015" . date('r') . ": Error: hash not found!\n";
	} else {

		$sql = "SELECT CRMblobs.fileid FROM CRMblobs,CRMbinfiles WHERE CRMblobs.fileid=CRMbinfiles.fileid AND CRMbinfiles.offloaded='y' AND CRMblobs.fileid!=0 AND CRMblobs.content = ''";

		//$localpath = GetSetting("OffloadLocalPath");
		$localpath = GetSetting("OffloadFilesURL");
		$key = GetSetting("OffLoadedFilesSSLKey");


		foreach(db_GetFlatArray($sql) AS $fileid) {
			$filename_on_disk = $localpath . "/" . $hash . "/" . $fileid;
			$efilename_on_disk = $localpath . "/" . $hash . "/e" . $fileid;

			$fc = "";
			if ($key != "") {
				print "\015" . date('r') . ": Fetching, decrypting and inserting " . $efilename_on_disk . "...\n";
				$fc = `cat $efilename_on_disk | openssl aes-256-cbc -d -k $key`;

			} else {
				print "\015" . date('r') . ": Fetching and inserting " . $filename_on_disk . "...\n";
				$fc = file_get_contents($filename_on_disk);
			}

			if ($fc != "") {
				mcq("UPDATE CRMblobs, CRMbinfiles SET content='" . mres($fc) . "',CRMbinfiles.offloaded='n', CRMbinfiles.timestamp_last_change=CRMbinfiles.timestamp_last_change, CRMblobs.timestamp_last_change=CRMblobs.timestamp_last_change WHERE CRMblobs.fileid=" . $fileid);

			} else {
				print "\015" . date('r') . ": Error: File " . $fileid . " not found in offload storage location!\n";
			}
		}
	}
	print "\015" . date('r') . ": Files on disk are untouched. Delete them manually if required.\n";
}
function ArchiveLog($log, $date_from) {
	mcq("UPDATE CRMuselog SET qs='{{deleted}}', timestamp_last_change=timestamp_last_change WHERE LENGTH(qs) > 2097152");
	mcq("UPDATE CRMjournal SET message='{{deleted}}', timestamp_last_change=timestamp_last_change WHERE LENGTH(message) > 2097152");
	mcq("UPDATE CRMdatajournal SET from_val='{{deleted}}', timestamp_last_change=timestamp_last_change WHERE LENGTH(from_val) > 2097152");
	mcq("UPDATE CRMdatajournal SET to_val='{{deleted}}', timestamp_last_change=timestamp_last_change WHERE LENGTH(to_val) > 2097152");
	mcq("UPDATE CRMmailqueue SET template='{{deleted}}', timestamp_last_change=timestamp_last_change WHERE LENGTH(template) > 2097152");

	if ($log == "") {

		print "<h1>Archive rows</h1>";
		print "<p>This function will put rows into a file (SQL), zip that file and attach it as a system file to save space. After the file is zipped this procedure will unzip the file and make 100% sure it is uploaded correctly before actually purging a table (physical deletes; not logical). Needless to say this is a tricky function. The system-files page offers the option to re-import these files.</p>";
		print "<table class=\"crm filtertable\">";
		print "<thead><tr><th>Table</th><th>DB Name</th><th class='num'>Rows</th><th class='num'>Size (M)</th><th>Oldest record</th><th>Archive before date</th></tr></thead>";

		/*
		print "<tr><td>Uselog</td><td>" . FormatNumber(GetTableRows("CRMuselog"), 0) . "</td><td>" . FormatNumber(GetTableSize("CRMuselog") / 1024 / 1024) . "</td><td>" . db_GetValue("SELECT timestamp_last_change FROM CRMuselog LIMIT 1") . "</td><td><form id='uselog' method='post' action='admin.php?ArchiveLog'><input type='hidden' name='log' value='CRMuselog'><input type='text' class='datepicker' name='date_from' id='JS_date_from1'> <input type='submit' name='go' value='go'></form></td></tr>";

		print "<tr><td>Mail queue</td><td>" . FormatNumber(GetTableRows("CRMmailqueue"), 0) . "</td><td>" . FormatNumber(GetTableSize("CRMmailqueue") / 1024 / 1024) . "</td><td>" . db_GetValue("SELECT timestamp_last_change FROM CRMmailqueue LIMIT 1") . "</td><td><form id='uselog' method='post' action='admin.php?ArchiveLog'><input type='hidden' name='log' value='CRMmailqueue'><input type='text' class='datepicker' name='date_from' id='JS_date_from2'> <input type='submit' name='go' value='go'></form></td></tr>";

		print "<tr><td>Journal</td><td>" . FormatNumber(GetTableRows("CRMjournal"), 0) . "</td><td>" . FormatNumber(GetTableSize("CRMjournal") / 1024 / 1024) . "</td><td>" . db_GetValue("SELECT timestamp_last_change FROM CRMjournal LIMIT 1") . "</td><td><form id='uselog' method='post' action='admin.php?ArchiveLog'><input type='hidden' name='log' value='CRMjournal'><input type='text' class='datepicker' name='date_from' id='JS_date_from3'> <input type='submit' name='go' value='go'></form></td></tr>";

		print "<tr><td>Data journal</td><td>" . FormatNumber(GetTableRows("CRMdatajournal"), 0) . "</td><td>" . FormatNumber(GetTableSize("CRMdatajournal") / 1024 / 1024) . "</td><td>" . db_GetValue("SELECT timestamp_last_change FROM CRMdatajournal LIMIT 1") . "</td><td><form id='uselog' method='post' action='admin.php?ArchiveLog'><input type='hidden' name='log' value='CRMdatajournal'><input type='text' class='datepicker' name='date_from4' id='JS_date_from'> <input type='submit' name='go' value='go'></form></td></tr>";

		print "<tr><td>Statistics</td><td>" . FormatNumber(GetTableRows("CRMstats"), 0) . "</td><td>" . FormatNumber(GetTableSize("CRMstats") / 1024 / 1024) . "</td><td>" . db_GetValue("SELECT timestamp_last_change FROM CRMstats LIMIT 1") . "</td><td><form id='uselog' method='post' action='admin.php?ArchiveLog'><input type='hidden' name='log' value='CRMstats'><input type='text' class='datepicker' name='date_from' id='JS_date_from5'> <input type='submit' name='go' value='go'></form></td></tr>";
		*/
		foreach ($GLOBALS['UC']['PersonalDataStructure'] AS $table => $props) {
			$dbname = $table;
			if ($props['name_in_database'] != '') {
				$dbname = $props['name_in_database'];
			}
			print "<tr><td>" . htme($props['plural']) . "</td><td>CRM" . $dbname . "</td><td class='num'>" . FormatNumber(GetTableRows("CRM" . $dbname), 0) . "</td><td class='num'>" . FormatNumber(GetTableSize("CRM" . $dbname) / 1024 / 1024) . "</td><td>" . db_GetValue("SELECT timestamp_last_change FROM CRM" . $dbname . " LIMIT 1") . "</td><td><form id='uselog' method='post' action='admin.php?ArchiveLog'><input type='hidden' name='log' value='CRM" . $dbname . "'><input type='text' class='datepicker' name='date_from' id='JS_date_from5'> <input type='submit' name='go' value='go'></form></td></tr>";
		}

		print "</table>";
	} else {

		if ($date_from == "") {
			PrintAD("Log received but no date. Quitting.");

		} else {

			$date = NLDate2INTLDate(FormattedDateToNLDate($date_from));
			print "<h1>Archive all from " . $log . " logged before " . $date . "</h1>";
//			exit;
			$file = tempnam("","log_archive_");
			print "Writing to temp file " . $file . "<br>";
			$filetowriteto = fopen($file, "w");


			$fields = array();
			$sql = "EXPLAIN " . $log;
			$qu = "";
			$first_done = false;
			foreach (db_GetArray($sql) AS $row2) {
				if (!$first_done) {
					$first_done = true;
				} else {
					$qu .= ",";
				}
				$qu .= "`" . $row2['Field'] . "`";
				array_push($fields, $row2['Field']);
			}

			$first_done = false;
			$sql = "SELECT * FROM " . mres($log) . " WHERE DATE(timestamp_last_change) < '" . mres($date) . "'";
			$res = mcq($sql);
			$num = 0;
			/* use mysqli_fetch_array, not db_GetArray, to save memory (will crash) */
			while ($row = mysqli_fetch_array($res)) {
				$num++;
				$str = "INSERT INTO " . $log . "(" . $qu . ") VALUES (";
				foreach($fields AS $field) {
					if (!$first_done) {
						$first_done = true;
					} else {
						$str .= ", ";
					}
					$str .= "'" . mres($row[$field]) . "'";
				}

				$str .= ")";
				fwrite($filetowriteto, $str . ";\n");
				//print $str;
				unset($str);
			}

			fclose($filetowriteto);

			$file2 = tempnam("","log_archive_compressed_");

			scmd("tar -cvzf " . $file2 . " " . $file);

			$fileid = AttachFile(0, $log . "_archive_b4_" . $date . ".tgz",$file2,"system","application/x-tar","", true, true, false, true);

			$file4 = CopyFileToDisk($fileid);


			if (md5_file($file2) == md5_file($file4)) {
				print "<br>Exported file from database, extracted, compaired, all ok. (" . $file2 . " = " . $file4 . ")<br>";
				$sql = "DELETE FROM " . mres($log) . " WHERE DATE(timestamp_last_change) < '" . mres($date) . "'";
				mcq($sql);
				print "<br>Log cleaned, archiving done.";

			} else {
				print "<br>" . $file2 . " is not equal to " . $file4 . ". Not taking any changes. Files on disk deleted, no database changes made.<br>";
			}
			scmd("rm " . $file);
			scmd("rm " . $file2);
			scmd("rm " . $file4);
			print "<p><a href=\"admin.php?ArchiveLog\">Back to log archive page</a></p>";
		}
	}
}
function CreateNewTableTemplateForAllTablesNotHavingOne() {

	foreach (db_GetArray("SELECT recordid, tablename FROM CRMflextabledefs WHERE (listtemplate='' OR listtemplate=0)") AS $ftdef) {

		mcq("INSERT INTO CRMtemplates (templatename, templatetype, template_subject, content, show_on_add_list) VALUES('" . mres($ftdef['tablename'] . "-list") . "','" . mres("TEMPLATE_HTML") . "','" . mres($ftdef['tablename'] . "-list") . "','" . mres("<div>#LIST|table=t" . $ftdef['recordid'] . "#</div>") . "','n')");
		$templateid = db_GetInsertId();
		mcq("UPDATE CRMflextabledefs SET listtemplate='" . $templateid . "' WHERE recordid='" . $ftdef['recordid'] . "'");

		print "Template created for " .$GLOBALS['UC']['PersonalDataStructure']['t' . $ftdef['recordid']]["plural"] . "<br>";
	}
}
function ShowTableTags($table) {
	/* called checks if user is admin. even is he isn't, this function uses personal DS so it's secure */

	print '<h2>Tags for table ';
	print "<select onchange=\"window.location.href='flextable.php?nonavbar=1&amp;showtags=' + this.value;\" id=\"kiestable\">";
	if ($table == "") {
		print "<option value=''>Select table</option>";
	}

	foreach ($GLOBALS['UC']['PersonalDataStructure'] AS $pds => $props) {
		if (ipi(str_replace("t", "", $pds))) {

			print "<option value=\"" . htme($pds) . "\"";
			if ($table == $pds) print " selected";
			print ">" . $pds . ": " . $props['plural'] . " (" . count($GLOBALS['UC']['PersonalDataStructure'][$pds]['allfields']) . ")</option>";
		}
	}
	print "</select>";
	print ReturnDropDownSearchField("kiestable");
	print '</h2>';

	if ($table != "") {
		print "<table class=\"crm filtertable noclick\">";
		print "<thead><tr><th>Full tag</th><th>Path</th></tr></thead>";
		foreach ($GLOBALS['UC']['PersonalDataStructure'][$table]['allfields'] AS $f) {
			$tp = "<tr><td><input onclick=\"this.select();\" type=\"text\" value=\"" . htme($f) . "\"></td><td>";
			$el = explode("-", $f);
			for ($x=0;$x<count($el);$x+=2) {

				if (ipi(str_replace("t", "", $el[$x]))) { // it's a flextable
					$el[$x] = GetFlextableName(str_replace("t", "", $el[$x])) . " [" . $el[$x] . "]";
				}
				$el[$x] = "<strong>" . $el[$x] . "</strong>";
				if (ipi(str_replace("f", "", $el[$x+1]))) { // it's an field
					$eft = GetExtraFieldType(str_replace("f", "", $el[$x+1]));
					$eft = str_replace("Reference to FlexTable", "REF", $eft);
					$eft = str_replace("User-list of all CRM-CTT users", "REF", $eft);


					$el[$x+1] = GetExtraFieldName(str_replace("f", "", $el[$x+1])) . " [" . $el[$x+1] . "] [" . $eft . "]";
				}
				$tp .= " &raquo; " . $el[$x] . " &raquo; " . $el[$x+1] . "";

			}
			$tp .= "</td></tr>";

			print $tp;
		}

		print "</table>";
	}
}

function GetAlterQueryBasedOnFieldType($ds_fieldname, $ds_tablename, $type, $resulttype="auto", $syntax="mysql", $name = "") {

	if ($syntax != "percona") {
		$syntax = "mysql";
	}

	$table = "";
	if (preg_match("/^t(\d+)$/", $ds_tablename, $match)){
		//	ft nummer zit nu in match[1]
		$table = "CRMflextable" . $match[1];
	} else {
		if ($ds_tablename == "users" || $ds_tablename == "user") {
			$table = "CRMloginusers";
		} elseif ($ds_tablename == "groups" || $ds_tablename == "group") {
			$table = "CRMuserprofiles";
		} elseif ($ds_tablename == "files") {
			$table = "CRMbinfiles";
		} else {
			$table = "CRM" . $ds_tablename;
		}
	}

	$fieldnum = 0;
	if (preg_match("/^f(\d+)$/", $ds_fieldname, $match)){
		//	f nummer zit nu in match[1]
		$fieldnum = $match[1];
	}

	if (ipi($fieldnum) && in_array($type, GetFieldTypes())) {

		$dbto = "";

		$fieldprops = db_GetRow("SELECT * FROM CRMextrafields WHERE id='" . $fieldnum . "'");
		// Strip any interleave-related tags
		$fieldprops['defaultval'] = preg_replace("/(@|#|\$)([A-Za-z0-9\_\-\|]+)\\1/", "", $fieldprops['defaultval']);
		if (strstr($fieldprops['defaultval'], "<?")) {
			$fieldprops['defaultval'] = "";
		}
		switch($type) {
			case "Button":
				$dbto = "BIT(1) NOT NULL DEFAULT b'0'";
				SetAttribute("extrafield", "MaximumLength", "", $fieldnum);
			break;
			case "date (iso)":
				if ($fieldprops['defaultval'] == "")
				$dbto = "DATE NOT NULL";
				if ($fieldprops['defaultval'] != "") {
					$dbto .= " DEFAULT '" . mres($fieldprops['defaultval']) . "'";
				} else {
					$dbto .= " DEFAULT '0000-00-00'";
				}

			break;
			case "comment":
				$dbto = "BIT(1) NOT NULL DEFAULT b'0'";
				SetAttribute("extrafield", "MaximumLength", "", $fieldnum);
			break;
			case "date":
				$dbto = "VARCHAR(10) NOT NULL";
				$dbto .= " DEFAULT '" . mres($fieldprops['defaultval']) . "'";
				SetAttribute("extrafield", "MaximumLength", "", $fieldnum);
			break;
			case "numeric":


				$dbformat = "varchar(21)";
				SetAttribute("extrafield", "MaximumLength", "", $fieldnum);
				$add_to_default = "";
				if (GetAttribute("extrafield", "NumericDatabaseField", $fieldnum) == "Yes") {


					$decimals = 0;
					if ((preg_match("/^currency/", $fieldprops["number_format"])) || ($fieldprops["number_format"] == "normal")) {
						$decimals = 2;
					} elseif (preg_match("/^(\d+) decimal/", $fieldprops["number_format"], $match))  {
						$decimals = $match[1];
					}

					if ($decimals == 0) {

						//afhankelijk van het attribuut MaximumValue zouden we TINYINT, SMALLINT, MEDIUMINT of BIGINT moeten gebruiken
						$dbformat = "int(11)";

					} else {

						$LengthNatural = GetAttribute("extrafield", "LengthNatural", $fieldnum);
						$natlen = 10;
						if (ipi($LengthNatural)) {
							$natlen = $LengthNatural;
						}
						/* mysql DECIMAL(x,y) : x=TOTAL LENGTH (incuding decimals), y=DECIMAL LENGTH */
						$natlen += $decimals;

						//afhankelijk van het attribuut MaximumValue zouden we het DECIMAL formaat groter of kleiner moeten maken
						$dbformat = "decimal(" . $natlen . "," . $decimals . ")";
						$add_to_default = "." . str_repeat("0", $decimals);

					}

					//$dbformat .= " SIGNED";
				}
				$dbto = $dbformat . " NOT NULL";
				if ($fieldprops['defaultval']) {
					$dbto .= " DEFAULT '" . mres($fieldprops['defaultval']) . "'";
				} else {
					if (GetAttribute("extrafield", "NumericDatabaseField", $fieldnum) == "Yes") {
						$dbto .= " DEFAULT '0" . $add_to_default . "'";
					} else {
						$dbto .= " DEFAULT ''";
					}

				}
			break;
			case "Reference to FlexTable":

				$dbto = "int(11) NOT NULL";
				if (is_positive_integer_or_zero($fieldprops['defaultval'])) {
					$dbto .= " DEFAULT '" . mres($fieldprops['defaultval']) . "'";
				} else {
					$dbto .= " DEFAULT '0'";
				}
				SetAttribute("extrafield", "MaximumLength", "", $fieldnum);
			break;
			case "date/time":

				$dbto = "datetime NOT NULL";
				if ($fieldprops['defaultval'] != "") {
					$dbto .= " DEFAULT '" . mres($fieldprops['defaultval']) . "'";
				} else {
					$dbto .= " DEFAULT '0000-00-00 00:00:00'";
				}
				SetAttribute("extrafield", "MaximumLength", "", $fieldnum);
			break;
			case ($type == "User-list of all CRM-CTT users" || substr($type, 0, 16) == "Users of profile"):
				$dbto = "int(11) NOT NULL";
				if (is_positive_integer_or_zero($fieldprops['defaultval'])) {
					$dbto .= " DEFAULT '" . mres($fieldprops['defaultval']) . "'";
				} else {
					$dbto .= " DEFAULT '0'";
				}
				SetAttribute("extrafield", "MaximumLength", "", $fieldnum);
			break;

			case "List of all groups":
				$dbto = "int(11) NOT NULL";
				if (is_positive_integer_or_zero($fieldprops['defaultval'])) {
					$dbto .= " DEFAULT '" . mres($fieldprops['defaultval']) . "'";
				} else {
					$dbto .= " DEFAULT '0'";
				}
				SetAttribute("extrafield", "MaximumLength", "", $fieldnum);
			break;
			case "checkbox":
				$options = array();
				$options[] = $fieldprops['options'];
				$options[] = $fieldprops['defaultval'];

				if (TableHasField($table, "EFID" . $fieldnum, false, $fieldprops['defaultval']) != "no") {
					$extra = db_GetFlatArray("SELECT EFID" . $fieldnum . " FROM " . $table . " GROUP BY EFID" . $fieldnum);
					foreach ($extra AS $value) {
						if (!in_array($value, $options)) {
							$options[] = $value;
						}
					}
				}
				//array_walk($options, 'mres');
				$mressedoptions = array();
				foreach ($options AS $walk) {
					$mressedoptions[] = mres($walk);
				}
				$dbto = "enum('" . implode("','", $mressedoptions) . "') NOT NULL";
				if (GetAttribute("extrafield", "CheckBoxCheckedByDefault", $fieldnum) == "Yes") {
					$dbto .= " DEFAULT '" . mres($fieldprops['options']) . "'";
				} else {
					$dbto .= " DEFAULT '" . mres($fieldprops['defaultval']) . "'";
				}
				SetAttribute("extrafield", "MaximumLength", "", $fieldnum);

			break;
			case "drop-down":
				if (substr($fieldprops['options'], 0, 18) == "%POPULATE_BY_CODE%") {
					// LONGTEXT velden mogen geen default hebben
					$dbto = "longtext NOT NULL";
				} else {

					$options = unserialize($fieldprops['options']);
					for ($i=0;$i<count($options);$i++) {
						$options[$i] = mres($options[$i]);
					}
					/* add "" to beginning of array */
					array_unshift($options, "");

					// Check if field already exists, and if so, fetch distinct values
					if (TableHasField($table, "EFID" . $fieldnum, false, $fieldprops['defaultval']) != "no") {
						$extra = db_GetFlatArray("SELECT EFID" . $fieldnum . " FROM " . $table . " GROUP BY EFID" . $fieldnum);
						foreach ($extra AS $value) {
							if (!in_array($value, $options)) {
								$options[] = mres($value);
							}
						}
					}

					//array_walk($options, 'mres');
					$dbto = "enum('" . implode("','", $options) . "') NOT NULL";

					$dbto .= " DEFAULT '" . mres($fieldprops['defaultval']) . "'";
				}
				SetAttribute("extrafield", "MaximumLength", "", $fieldnum);


			break;
			default:
				if ($type == "textbox" || $type == "mail" || $type == "hyperlink" || $type == "phone number") {
					$MaximumLength = GetAttribute("extrafield", "MaximumLength", $fieldnum);
					$CurrentMaximum = 0;
					if ($MaximumLength == "") {
						if (TableHasField($table, "EFID" . $fieldnum, false, $fieldprops['defaultval']) != "no") { // Field exists already
							//print "SELECT MAX(LENGTH(EFID" . $fieldnum . ")) FROM " . $table;
							$CurrentMaximum = db_GetValue("SELECT MAX(LENGTH(EFID" . $fieldnum . ")) FROM " . $table);
						}
						if ($CurrentMaximum > 200) {
							$dbto = "longtext NOT NULL";
							SetAttribute("extrafield", "MaximumLength", "{{none}}", $fieldnum);
						} else {
							SetAttribute("extrafield", "MaximumLength", "255", $fieldnum);
							$MaximumLength = 255;
							$dbto = "varchar(" . $MaximumLength . ") NOT NULL";
							$dbto .= " DEFAULT '" . mres($fieldprops['defaultval']) . "'";
						}
					} else {
						if ((TableHasField($table, "EFID" . $fieldnum, $dbto, $fieldprops['defaultval']) == "wrongtype" && $resulttype == "auto") || $resulttype == "change") {
							$CurrentMaximum = db_GetValue("SELECT MAX(LENGTH(EFID" . $fieldnum . ")) FROM " . $table);
						}
						if ($CurrentMaximum > $MaximumLength) $MaximumLength = $CurrentMaximum;
						$dbto = "varchar(" . $MaximumLength . ") NOT NULL";
						$dbto .= " DEFAULT '" . mres($fieldprops['defaultval']) . "'";
					}
				} else {
					if ($type == 'text area') {
						SetAttribute("extrafield", "MaximumLength", "{{none}}", $fieldnum);
					} else {
						SetAttribute("extrafield", "MaximumLength", "", $fieldnum);
					}
					// LONGTEXT velden mogen geen default hebben
					$dbto = "longtext NOT NULL";

					if ($syntax == "percona") {
						/*
						workaround for percona pt-online-schema-change needing a default even on types which don't accept one

						[10/03/16 11:35:44] Hidde .: https://www.percona.com/blog/2012/06/21/pt-online-schema-change-and-default-values/
						[10/03/16 11:44:23] Hidde .: OK dit is weird. pt-o-s-c geeft een fout als je een longtext aanmaakt en GEEN default meegeeft. MySQL geeft een fout als je het WEL doet:

						alter table CRMflextable1 ADD EFID367 longtext NOT NULL DEFAULT 'hidde test';
						ERROR 1101 (42000): BLOB/TEXT column 'EFID367' can't have a default value

						geef je echter DEFAULT '' mee:

						alter table CRMflextable1 ADD EFID367 longtext NOT NULL DEFAULT '';
						Query OK, 0 rows affected, 1 warning (49.92 sec)
						Records: 0  Duplicates: 0  Warnings: 1

						Warning (Code 1101): BLOB/TEXT column 'EFID367' can't have a default value

						� dan krijg je dus (terecht) een warning. Gaat dus op beide manieren mis. Maar die error 1364 is OOK een warning. Op 1364 crasht pt-o-s-c, maar op 1101 dus blijkbaar niet (want zo deden we het altijd al). Ik heb dus alle LONGTEXT alters nu een DEFAULT '' gegeven, ook al is dat NIET goed.

						*/

						$dbto .= " DEFAULT ''";
					}

				}
			break;
		}
		if ($fieldprops['calculation_type'] == 'calculated on display' && $fieldprops['calculation'] != '') {
			$dbto = "BIT(1) NOT NULL DEFAULT b'0'";
		}
		$sql = "";
		if (TableHasField($table, "EFID" . $fieldnum, $dbto, $fieldprops['defaultval']) == "yes" && $resulttype == "auto") {
			if ($syntax == "mysql") {
				$sql = "SELECT 1+1";
			} elseif ($syntax == "percona") {
				$sql = "";
			}
		} elseif ((TableHasField($table, "EFID" . $fieldnum, $dbto, $fieldprops['defaultval']) == "wrongtype" && $resulttype == "auto") || $resulttype == "change") {
			if ($syntax == "mysql") {
				$sql = "ALTER TABLE " . $table . " CHANGE `EFID" . $fieldnum . "` `EFID" . $fieldnum . "` " . $dbto;
				if ($name != "") {
					$sql .= " COMMENT '" . mres($name) . "'";
				}
			} elseif ($syntax == "percona") {
				$sql = "PTONLINESCHEMACHANGE " . base64_encode("CHANGE EFID" . $fieldnum . " EFID" . $fieldnum . " " . ($dbto) . " --execute D=QQQTARGET_DBQQQQ,t=" . $table);

			}

		} else {
			if ($syntax == "mysql") {
				$sql = "ALTER TABLE " . $table . " ADD `EFID" . $fieldnum . "` " . $dbto;
				if ($name != "") {
					$sql .= " COMMENT '" . mres($name) . "'";
				}
			} elseif ($syntax == "percona") {
				$sql = "PTONLINESCHEMACHANGE " . base64_encode("ADD EFID" . $fieldnum . " " . ($dbto) . " --execute D=QQQTARGET_DBQQQQ,t=" . $table);
			}
		}
		return $sql;

	} else {
		print "# GetAlterQueryBasedOnFieldType only for EF's (" . $fieldnum . ") OR type (" . $type . ") wrong";
	}
}
function NormalizeField($field, $action="") {
	print '<h1>Normalize field</h1>';
	if ($action == "") {
		print '<form name="normalizeform" id="JS_normalizeform" method="POST" action="admin.php">';
		print '<p><input type="hidden" name="normalize" id="JS_normalize" value="' . htme($field) . '"><input type="hidden" name="nonavbar" id="JS_nonavbar" value="1">';
		print '<select name="action" id="JS_action">';
		print '<option value="info">Info only</option><option value="new_table">Create a completely new flextable</option>';
		foreach (db_GetArray("SELECT * FROM CRMextrafields") AS $ef) {
			// Check of het een FT veld is
			if (ipi($ef['tabletype'])) {
				print '<option value="t' . $ef['tabletype'] . '-f' . $ef['id'] . '">Map to field ' . $ef['id'] . ' (' . htme($ef['name']) . ') in table ' . $ef['tabletype'] . ' (' . GetFlextableName($ef['tabletype']) . ')</option>';
			}
		}
		print '</select>';
		print ReturnDropDownSearchField("JS_action");
		print '&nbsp;<input type="submit" name="submit" id="JS_submit" value="Ok"><br><br>When mapping to an existing field, non-existing values will be added to the table!';
		print '</p></form>';

	} else {
		$ef = db_GetRow("SELECT * FROM CRMextrafields WHERE id='" . $field . "'");
		print '<h2>Field ' . htme($ef['name']) . ' of table ' . $ef['tabletype'] . '</h2>';
		$tablename = "";
		$table_id = 0;
		if (ipi($ef['tabletype'])) {
			$tablename = "CRMflextable" . $ef['tabletype'];
		} else {
			$tablename = "CRM" . $ef['tabletype'];
		}

		$sql = "SELECT EFID" . $ef['id'] . " FROM " . $tablename . " GROUP BY EFID" . $ef['id'];
		$options_in_db = db_GetFlatArray($sql);
		$options_in_def = unserialize($ef['options']);
		$options = array_unique(array_merge($options_in_def, $options_in_db));
		print '<h1>Options</h1><ul>';
		$maxsize = 0;
		foreach ($options AS $opt) {
			if (strlen($opt) > $maxsize) $maxsize = strlen($opt);
			print '<li>' . htme($opt);
			if ($opt == "") print '"" (empty)';
			if (!in_array($opt, $options_in_def)) {
				print ' <span class="errmsg">only found in database, not in field definition!</span>';
			}
			print '</li>';
		}
		print '</ul>';
		// Check if field is required. If it is, also create an empty record when needed. If not, set these to 0.

		$required_field = false;
		if ($ef['forcing'] == "y") { // Field IS required
			$required_field = true;
		}

		$map = array();
		$qb4nd = array();

		if ($action == "info") {

		} elseif ($action == "new_table") {
			$qb4nd = GetAttribute("system", "QueriesBeforeNextDeploy", 1);
			if (($ef['fieldtype'] == "drop-down" || $ef['fieldtype'] == "checkbox") && ipi($maxsize)) {
				$qb4nd[] = "ALTER TABLE " . $tablename . " CHANGE `EFID" . $ef['id'] . "` `EFID" . $ef['id'] . "` VARCHAR(" . $maxsize . ") NOT NULL;";
			}

			// Create flextable definition
			mcq("INSERT INTO `CRMflextabledefs` (`tablename`, `formid`, `refer_field_layout`, `comment`, `maxrowsperpage`, `headerhtml`, `addlinktext`, `sumnumrows`, `add_in_popup`, `sort_on`, `sort_direction`, `tableheaderrepeat`, `stayinformaftersave`, `timestamp_last_change`, `listtemplate`) VALUES('" . mres($ef['name']) . "', 0, '@RECORDID@', '', 100, '<h1>\r\n" . mres($ef['name']) . "</h1>\r\n', 'Add " . mres($ef['name']) . "', 'n', 'y', 284, 'Ascending', 0,'', NOW(), 0);");
			$table_id = db_GetInsertId();

			// Create physical table
			mcq("CREATE TABLE CRMflextable" . $table_id . " (recordid INT(11) NOT NULL auto_increment, deleted ENUM('n','y') NOT NULL DEFAULT 'n', timestamp_last_change TIMESTAMP ON UPDATE CURRENT_TIMESTAMP NOT NULL DEFAULT CURRENT_TIMESTAMP, PRIMARY KEY (recordid)) ENGINE=InnoDB DEFAULT CHARSET=UTF8");

			// Create field to hold values
			$sql = "INSERT INTO CRMextrafields(options,name,ordering,fieldtype,hidden,tabletype,forcing,defaultval,sort,storetype,size,showsearchbox,limitddtowidth,allowuserstoaddoptions,excludefromfilters,number_format) VALUES ('','" . mres(trim($ef['name'])) . "','10','textbox','n'," . $table_id . ",'n','','n','default','','n','','n','y', 'don\'t format')";
			mcq($sql);
			$created_field = db_GetInsertId();

			// Alter table to create field
			mcq("ALTER TABLE CRMflextable" . $table_id . " ADD `EFID" . $created_field . "` LONGTEXT NOT NULL");

			mcq("UPDATE CRMflextabledefs SET refer_field_layout='@EFID" . $created_field . "@' WHERE recordid=" . $table_id);

			// Insert unique values into new flextable

			foreach ($options AS $option) {
				if (trim($option) != "" || $required_field) {
					mcq("INSERT INTO CRMflextable" . $table_id . "(EFID" . $created_field . ") VALUES('" . mres($option) . "')");
					$map[$option] = db_GetInsertId();
				}
			}
			if (!$required_field) {
				$map[""] = 0;
			}
		} else {
			$qb4nd = GetAttribute("system", "QueriesBeforeNextDeploy", 1);
			if (($ef['fieldtype'] == "drop-down" || $ef['fieldtype'] == "checkbox") && ipi($maxsize)) {
				$qb4nd[] = "ALTER TABLE " . $tablename . " CHANGE `EFID" . $ef['id'] . "` `EFID" . $ef['id'] . "` VARCHAR(" . $maxsize . ") NOT NULL;";
			}

			$t = explode("-", $action);
			$newtablename = "CRMflextable" . str_replace("t", "", $t[0]);
			$table_id = str_replace("t", "", $t[0]);

			$fieldname = "EFID" . str_replace("f", "", $t[1]);
			foreach ($options AS $option) {
				$num = db_GetValue("SELECT recordid FROM " . $newtablename . " WHERE " . $fieldname . " ='" . mres($option) . "' AND deleted='n'");
				if (!ipi($num) && (trim($option) != "" || $required_field)) {
					// Bestaat niet in die table, toevoegen dus
					mcq("INSERT INTO " . $newtablename . "(" . $fieldname . ") VALUES('" . mres($option) . "')");
					$map[$option] = db_GetInsertId();
					print 'Added option ' . htme($option) . ' to table ' . $newtablename . '<br>';
				} else {
					print 'Found option ' . htme($option) . ' in table ' . $newtablename . ' : ' . $num . '<br>';
					$map[$option] = $num;
				}
			}
			if (!$required_field) {
				$map[""] = 0;
			}
		}

		if ($action != "info") {
			print '<h1>Mapping table</h1>';
			DA($map);

			$qfnd = GetAttribute("system", "QueriesForNextDeploy", 1);

			// Update the values in the old field to the corresponding index number DIT MOET IN DE BEFORE!!
			foreach ($map AS $oldoption => $newnumber) {
				$sql = "UPDATE " . $tablename . " SET timestamp_last_change=timestamp_last_change, EFID" . $ef['id'] . " ='" . $newnumber . "' WHERE EFID" . $ef['id'] . " = '" . htme($oldoption) . "';";
				mcq($sql);
				$qb4nd[] = $sql;
			}

			SetAttribute("system", "QueriesForNextDeploy", $qfnd, 1);
			SetAttribute("system", "QueriesBeforeNextDeploy", $qb4nd, 1);

			// Change the data type of the field we started with
			mcq("UPDATE CRMextrafields SET fieldtype='Reference to FlexTable', options='" . $table_id . "' WHERE id='" . $ef['id'] . "'");

			// Change the actual data type

			$sql = "ALTER TABLE " . $tablename . " CHANGE `EFID" . $ef['id'] . "` `EFID" . $ef['id'] . "` INT(11) NOT NULL DEFAULT '0'";
			mcq($sql);

			// Mark the table as part of the configuration set
			SetAttribute("flextable", "TableIsPartOfConfiguration", "Yes", $table_id, array("No", "Yes"));

			// Make sure write access is not inherited
			SetAttribute("flextable", "ChildsInheritWriteRecordAccess", "No", $table_id, array("No", "Yes"));

			// Generally, these tables don't need file attachments
			SetAttribute("flextable", "HasFileAttachments", "No", $table_id, array("No", "Yes"));

			// Drop datastructure
			AdminChangesDropCache();

			print "Done";
		}
	}
}
function find_and_delete_orphaned_files_in_db_and_on_disk($do=false) {
	MustBeAdmin();
	ini_set('display_errors', 1);
	if (!$do) {
		print '<p><a href="admin.php?checkfiles=1&amp;do_deletes=1">actually delete these files</a></p>';
	}
	$totalsize = 0;
	$ds =& $GLOBALS['UC']['PersonalDataStructure'];
	$to_delete = array();
	foreach ($ds AS $name => $table) {
		$sql = "SELECT `CRMbinfiles`.`fileid` FROM `CRMbinfiles` WHERE `CRMbinfiles`.`type`='" . ds_tablename_to_binfiles_table($name) . "' AND `CRMbinfiles`.`koppelid` NOT IN (SELECT `CRM" . $table['name_in_database'] . "`.`" . $table['primary'] . "` FROM `CRM" . $table['name_in_database'] . "`";
		if ($table['logical_delete']) {
			$sql .= " WHERE `CRM" . $table['name_in_database'] . "`.`deleted` ='n'";
		}
		$sql .= ")";
		//print $sql . '<br>';
		$orphaned_files = db_GetFlatArray($sql);
		if (ipi(count($orphaned_files))) {
			print 'Table ' . $name . ' has ' . count($orphaned_files) . ' orphaned files. Deleting them.<br>';
			foreach ($orphaned_files AS $f) {
				$to_delete[] = $f;
				$totalsize += db_GetValue("SELECT filesize FROM CRMbinfiles WHERE fileid='" . $f . "'");
			}
		}
	}

	if (ipi(count($to_delete))) {
		$sql = "DELETE FROM CRMbinfiles WHERE fileid IN (" . implode(",", $to_delete) . ")";
		if ($do) mcq($sql);
		print $sql . '<br>';
		$sql = "DELETE FROM CRMblobs WHERE fileid IN (" . implode(",", $to_delete) . ")";
		if ($do) mcq($sql);
		print $sql . '<br>';
		print '<br>';
	}

	/* loop through offloaded disk files. if deleted from the database, delete them from disk */

	$localpath = GetSetting("OffloadLocalPath");
	$hash = GetSetting("OffLoadedFilesDirectoryHash");
	if ($hash != "") {
		trace($hash);
		$prep = array();
		$path = $localpath . "/" . $hash . "/";
		$list = scandir($path);
		foreach ($list AS $possible_fileid) {
			if (ipi($possible_fileid)) {
				$prep[] = $possible_fileid;
			}
		}

		$list_of_valid_files = db_GetFlatArray("SELECT `CRMbinfiles`.`fileid` FROM `CRMbinfiles`");
		foreach ($prep AS $diskfileid) {
			if (!in_array($diskfileid, $list_of_valid_files)) {
				print 'rm ' . $path . $diskfileid . '<br>';
				$totalsize += filesize($path . $diskfileid);
				if ($do) unlink($path . $diskfileid);
			}
		}
	}

	print "Total " . round($totalsize/1024/1024,2) . "MB <br>";


}

function create_access_rules_for_fields_in_table($table, $posted_values) {

	/*
	+-----------------------+------------------------------+------+-----+-------------------+-----------------------------+
	| Field                 | Type                         | Null | Key | Default           | Extra                       |
	+-----------------------+------------------------------+------+-----+-------------------+-----------------------------+
	| id                    | int(11)                      | NO   | PRI | NULL              | auto_increment              |
	| groupid               | int(11)                      | NO   |     | NULL              |                             |
	| field                 | int(11)                      | NO   |     | NULL              |                             |
	| value                 | varchar(300)                 | NO   |     | NULL              |                             |
	| rule                  | enum('readonly','invisible') | NO   |     | invisible         |                             |
	| operand               | enum('IS','IS NOT')          | NO   |     | IS                |                             |
	| timestamp_last_change | timestamp                    | NO   |     | CURRENT_TIMESTAMP | on update CURRENT_TIMESTAMP |
	| only_apply_for_field  | int(11)                      | NO   |     | 0                 |                             |
	+-----------------------+------------------------------+------+-----+-------------------+-----------------------------+
	*/
	if (is_array($posted_values['group'])) {
		$ran = 0;
		$arr = $posted_values['field'];
		if (count($arr) == 0) $arr[] = "";
		foreach ($arr AS $only_apply_for_field) {
			$only_apply_for_field = str_replace("f", "", $only_apply_for_field);
			foreach ($posted_values['group'] AS $group) {
				if ($posted_values['rulefield'] == "RECORD") {
					/* a plain field access rule field */
					$read = 0;
					$write = 0;
					if ($posted_values['rule'] == "readonly") {
						$read = 1;
					}

					$sql = "DELETE FROM `CRMfieldaccessrules` WHERE `group` = '" . mres($group) . "' AND `field`='" . mres($only_apply_for_field) . "'";
					mcq($sql);

					$sql = "INSERT INTO `CRMfieldaccessrules` (`group`, `field`, `read`, `write`) VALUES ('" . mres($group) . "','" . mres($only_apply_for_field) . "','" . $read . "','" . $write . "')";

					mcq($sql);
					$ran++;

					$list = db_GetFlatArray("SELECT id FROM CRMuserprofiles WHERE id !='" . mres($group) . "'");
					foreach ($list AS $gtd) {
						$cnt = db_GetValue("SELECT COUNT(*) FROM CRMfieldaccessrules WHERE `group` ='" . $gtd . "' AND `field` = '" . mres($only_apply_for_field) . "'");
						if ($cnt == 0) {
							$sql = "INSERT INTO `CRMfieldaccessrules` (`group`, `field`, `read`, `write`) VALUES ('" . mres($gtd) . "','" . mres($only_apply_for_field) . "','1','1')";

							mcq($sql);
							$ran++;

						}
					}

				} else {
					$sql = "INSERT INTO `CRMextendedprivsgroup` (groupid,field,value,rule,operand,only_apply_for_field) VALUES ('" . mres($group) . "','" . mres(str_replace("f", "", $posted_values['rulefield'])) . "','" . mres($posted_values['value']) . "','" . mres($posted_values['rule']) . "','" . mres($posted_values['operand']) . "','" . mres($only_apply_for_field) . "')";
	//				print $sql . '<br>';
					mcq($sql);
					$ran++;
				}

			}
		}
		print '<h1>' . htme($ran) . ' rules created</h1>';

	} else {
		print '<h1>Insert set of access rules</h1>';
		print '<h2>Check groups  [<a href="#" onclick="invert_all_boxes_with_class(\'groupboxes\');">invert</a>]</h2>';
		print '<form name="createrules" method="post" action="">';
		foreach (GetGroups() AS $group) {
			print '<input type="checkbox" class="groupboxes" name="group[]" id="group' . $group['id'] . '" value="' . $group['id'] . '"><label for="group' . $group['id'] . '">' . htme($group['name']) . '</label><br>';
		}
		print '<h2>Check fields to apply rule to [<a href="#" onclick="invert_all_boxes_with_class(\'fieldboxes\');">invert</a>]</h2>';
		print '<div id="fieldboxesdiv">';
		foreach ($GLOBALS['UC']['PersonalDataStructure'][$table]["fields"] AS $field => $props) {
			if (substr($field, 0, 1) == "f") {
				print '<input type="checkbox" class="fieldboxes" name="field[]" id="field' . $field . '" value="' . $field . '"><label for="field' . $field . '">' . $field . " " . htme($props["name"]) . '</label><br>';
			}
		}
		print '</div>';
		print '<h2>Field to base rule on</h2><select name="rulefield" id="JS_rulefield">';
		print '<option value="RECORD">Complete record: plain access rule for all selected fields</option>';
		foreach ($GLOBALS['UC']['PersonalDataStructure'][$table]["fields"] AS $field => $props) {
			if (substr($field, 0, 1) == "f") {
				print '<option value="' . $field . '">' . $field . " " . $props["name"] . '</option>';
			}
		}
		print '</select> ' . ReturnDropDownSearchField("JS_rulefield");
		print '<h2>Operand</h2><select name="operand"><option>IS</option><option>IS NOT</option></select>';
		print '<h2>Value</h2>';
		print '<input type="text" size="20" name="value">';
		print '<h2>Rule</h2><select name="rule"><option>readonly</option><option>invisible</option></select>';
		print '<br><br><input type="submit" name="subm" value="Create rules">';
		print '</form>';
	}
}

function convert_diary_to_flextable($efid) {
	global $lang;
	/*
		deze functie moet een willekeurige diary field kunnen omzetten naar een flextable met alles er op en er aan.
	*/
	$ef = db_GetRow("SELECT * FROM CRMextrafields WHERE id='" . $efid . "'");

	// Create flextable definition
	$sql = "INSERT INTO `CRMflextabledefs` (`tablename`, `formid`, `refer_field_layout`, `comment`, `maxrowsperpage`, `headerhtml`, `addlinktext`, `sumnumrows`, `add_in_popup`, `sort_on`, `sort_direction`, `tableheaderrepeat`, `stayinformaftersave`, `timestamp_last_change`, `listtemplate`) VALUES('" . mres($ef['name']) . "', 0, '@RECORDID@', '', 100, '<h1>\r\n" . mres($ef['name']) . "</h1>\r\n', 'Add " . mres($ef['name']) . "', 'n', 'y', '', 'Ascending', 0,'', NOW(), 0)";
	mcq($sql);
	print $sql . "<br>";
	$table_id = db_GetInsertId();

	// Create physical table
	$sql = "CREATE TABLE CRMflextable" . $table_id . " (recordid INT(11) NOT NULL auto_increment, deleted ENUM('n','y') NOT NULL DEFAULT 'n', timestamp_last_change TIMESTAMP ON UPDATE CURRENT_TIMESTAMP NOT NULL DEFAULT CURRENT_TIMESTAMP, PRIMARY KEY (recordid)) ENGINE=InnoDB DEFAULT CHARSET=UTF8";
	print $sql . "<br>";
	mcq($sql);

	// Create fields to hold values
	$sql = "INSERT INTO CRMextrafields(options,name,ordering,fieldtype,hidden,tabletype,forcing,defaultval,sort,storetype,size,showsearchbox,limitddtowidth,allowuserstoaddoptions,excludefromfilters,number_format) VALUES ('" . $ef['tabletype'] . "','" . mres($GLOBALS['UC']['PersonalDataStructure'][ef_tabletype_to_ds_tablename($ef["tabletype"])]["plural"]) . "','10','Reference to FlexTable','n'," . $table_id . ",'n','','n','default','','n','','n','y', 'don\'t format')";
	print $sql . "<br>";
	mcq($sql);
	$ref = db_GetInsertId();

	// Create fields to hold values
	$sql = "INSERT INTO CRMextrafields(options,name,ordering,fieldtype,hidden,tabletype,forcing,defaultval,sort,storetype,size,showsearchbox,limitddtowidth,allowuserstoaddoptions,excludefromfilters,number_format) VALUES ('','" . mres($lang['user']) . "','10','User-list of all CRM-CTT users','n'," . $table_id . ",'n','@USERID@','n','default','','n','','n','y', 'don\'t format')";
	print $sql . "<br>";
	mcq($sql);
	$user = db_GetInsertId();
	foreach (GetGroups() AS $g) {
		if ($g['id'] > 0) {
			$sql = "INSERT INTO CRMfieldaccessrules(`enabled`, `field`, `description`, `group`, `read`, `write`) VALUES('Yes', '" . $user . "', 'Auto-convert diary field', '" . $g['id'] . "', '1', '0')";
			print $sql . '<br>';
			mcq($sql);
		}
	}


	$sql = "INSERT INTO CRMextrafields(options,name,ordering,fieldtype,hidden,tabletype,forcing,defaultval,sort,storetype,size,showsearchbox,limitddtowidth,allowuserstoaddoptions,excludefromfilters,number_format) VALUES ('','" . mres($lang['date']) . "','10','date/time','n'," . $table_id . ",'n','','n','default','','n','','n','y', 'don\'t format')";
	print $sql . "<br>";
	mcq($sql);
	$timestamp = db_GetInsertId();

	$calculation = "IF ((CRMflextable" . $table_id . ".EFID" . $timestamp . " = '0000-00-00 00:00:00' OR CRMflextable" . $table_id . ".EFID" . $timestamp . " = ''), NOW(), CRMflextable" . $table_id . ".EFID" . $timestamp . ")";

	$sql = "UPDATE CRMextrafields SET calculation = '" . mres($calculation) . "' WHERE id='" . $timestamp . "'";
	print $sql . "<br>";
	mcq($sql);

	/* recreate triggers */
	$triggers = return_mysql_trigger_queries();
	foreach ($triggers AS $sql) {
		mcq($sql);
	}

	$sql = "INSERT INTO CRMextrafields(options,name,ordering,fieldtype,hidden,tabletype,forcing,defaultval,sort,storetype,size,showsearchbox,limitddtowidth,allowuserstoaddoptions,excludefromfilters,number_format) VALUES ('60:4:n','" . mres($lang['remarks']) . "','10','text area','n'," . $table_id . ",'n','','n','default','','n','','n','y', 'don\'t format')";
	print $sql . "<br>";
	mcq($sql);
	$comments = db_GetInsertId();

	// Alter table to create field
	mcq("ALTER TABLE CRMflextable" . $table_id . " ADD `EFID" . $ref . "` INT(11) NOT NULL DEFAULT '0'");
	mcq("ALTER TABLE CRMflextable" . $table_id . " ADD `EFID" . $user . "` INT(11) NOT NULL DEFAULT '0'");
	mcq("ALTER TABLE CRMflextable" . $table_id . " ADD `EFID" . $timestamp . "` datetime NOT NULL DEFAULT '0000-00-00 00:00:00'");
	mcq("ALTER TABLE CRMflextable" . $table_id . " ADD `EFID" . $comments . "` LONGTEXT NOT NULL DEFAULT ''");
	mcq("UPDATE CRMflextabledefs SET refer_field_layout='@EFID" . $timestamp . "@' WHERE recordid='" . $table_id . "'");

	SetAttribute("flextable", "IncludeInSystemWideSearches", "Yes", $table_id, array("Yes", "No"));
	SetAttribute("flextable", "HasFileAttachments", "No", $table_id, array("Yes", "No"));

	/* insert values */
	$table = "flextable" . $ef['tabletype'];

	$res = mcq("SELECT " . mres($GLOBALS['UC']['PersonalDataStructure'][ef_tabletype_to_ds_tablename($ef["tabletype"])]["primary"]) . ", EFID" . $efid . " FROM CRM" . $table . " WHERE deleted='n'");
	while ($a = mysqli_fetch_array($res)) {
		$b = unserialize($a['EFID' . $efid]);
		foreach ($b AS $row) {
			$sql = "INSERT INTO CRMflextable" . $table_id . " (EFID" . $ref . ",EFID" . $user . ",EFID" . $timestamp . ",EFID" . $comments . ") VALUES('" . $a[$GLOBALS['UC']['PersonalDataStructure'][ef_tabletype_to_ds_tablename($ef["tabletype"])]["primary"]] . "','" . mres($row[1]) . "','" . mres(date('Y-m-d H:i:s', $row[0])) . "','" . mres($row[2]) . "')";
			mcq($sql);
			print $sql . "<br>";
		}
	}

	/* compose list tag */
	$tag = "#LIST|table=t" . $table_id . "|type_of_list=sublist|hiddenfilter_t" . $table_id . "-f" . $ref . "=@RECORDID@|hide_all=1|sortby=t" . $table_id . "-recordid|sortdirection=desc|perpage=10|hide_addrow=0|listlayoutcolumns=t" . $table_id . "-f" . $timestamp . ",t" . $table_id . "-f" . $user . ",t" . $table_id . "-f" . $comments . "#";

	$sql = "UPDATE CRMtemplates SET content = REPLACE(content, '#EFID" . $efid . "#', '" . mres($tag) . "')";
	print $sql . "<br>";
	mcq($sql);

	$sql = "UPDATE CRMtemplates SET content = REPLACE(content, '#" . ef_tabletype_to_ds_tablename($ef["tabletype"]) . "-f" . $efid . "#', '" . mres($tag) . "')";
	print $sql . "<br>";
	mcq($sql);

	AdminChangesDropCache();

	print '<h1>' . $tag . '</h1>';
}
function CheckAndSetAttributes($eftable_fieldnum, $eftable_fieldtype, $is_new = false) {
	if ($eftable_fieldtype == "Button") {

		$ButtonClickConfirmMessage = GetAttribute("extrafield", "ButtonClickConfirmMessage", $eftable_fieldnum);
		if ($ButtonClickConfirmMessage == "") {
			SetAttribute("extrafield", "ButtonClickConfirmMessage", "{{none}}", $eftable_fieldnum);
		}
		$BackToListAfterSave = GetAttribute("extrafield", "BackToListAfterSave", $eftable_fieldnum);
		if ($BackToListAfterSave == "") {
			SetAttribute("extrafield", "BackToListAfterSave", "{{default}}", $eftable_fieldnum, array("{{default}}", "No", "Yes"));
		}
		$FieldsOnFormWhichMustHaveAValueCSV = GetAttribute("extrafield", "FieldsOnFormWhichMustHaveAValueCSV", $eftable_fieldnum);
		if ($FieldsOnFormWhichMustHaveAValueCSV == "") {
			SetAttribute("extrafield", "FieldsOnFormWhichMustHaveAValueCSV", "{{none}}", $eftable_fieldnum);
		}
		$NotAllRequiredFieldsAreEnteredMessage = GetAttribute("extrafield", "NotAllRequiredFieldsAreEnteredMessage", $eftable_fieldnum);
		if ($NotAllRequiredFieldsAreEnteredMessage == "") {
			SetAttribute("extrafield", "NotAllRequiredFieldsAreEnteredMessage", "To use this button you must enter the highlighted fields.", $eftable_fieldnum);
		}
		$JavascriptActionAfterSubmit = GetAttribute("extrafield", "JavascriptActionAfterSubmit", $eftable_fieldnum);
		if ($JavascriptActionAfterSubmit == "") {
			SetAttribute("extrafield", "JavascriptActionAfterSubmit", "{{none}}", $eftable_fieldnum);
		}


	} else {
		SetAttribute("extrafield", "ButtonClickConfirmMessage", "", $eftable_fieldnum);
	}
	$ChangeAlertMessage = GetAttribute("extrafield", "ChangeAlertMessage", $eftable_fieldnum);
	if ($ChangeAlertMessage == "") {
		SetAttribute("extrafield", "ChangeAlertMessage", "{{none}}", $eftable_fieldnum);
	}

	if ($eftable_fieldtype == "date" || $eftable_fieldtype == "date/time") {
		$UsePlanningCalendar = GetAttribute("extrafield", "UsePlanningCalendar", $eftable_fieldnum);
		if ($UsePlanningCalendar == "") {
			SetAttribute("extrafield", "UsePlanningCalendar", "No", $eftable_fieldnum, array("No", "Yes"));
		}
		$UsePlanningCalendarMatchOnFields = GetAttribute("extrafield", "UsePlanningCalendarMatchOnFields", $eftable_fieldnum);
		if ($UsePlanningCalendarMatchOnFields == "") {
			SetAttribute("extrafield", "UsePlanningCalendarMatchOnFields", "{{none}}", $eftable_fieldnum);
		}
		$UsePlanningCalendarColor = GetAttribute("extrafield", "UsePlanningCalendarColor", $eftable_fieldnum);
		if ($UsePlanningCalendarColor == "") {
			SetAttribute("extrafield", "UsePlanningCalendarColor", "{{none}}", $eftable_fieldnum);
		}
		$UsePlanningCalendarDescription = GetAttribute("extrafield", "UsePlanningCalendarDescription", $eftable_fieldnum);
		if ($UsePlanningCalendarDescription == "") {
			SetAttribute("extrafield", "UsePlanningCalendarDescription", "@RECORDID@ -- No UsePlanningCalendarDescription attribute set!", $eftable_fieldnum);
		}
		$UsePlanningCalendarView = GetAttribute("extrafield", "UsePlanningCalendarView", $eftable_fieldnum);
		if ($UsePlanningCalendarView == "") {
			SetAttribute("extrafield", "UsePlanningCalendarView", "Month", $eftable_fieldnum, array("Month", "Week"));
		}
		$UsePlanningCalendarTitleText = GetAttribute("extrafield", "UsePlanningCalendarTitleText", $eftable_fieldnum);
		if ($UsePlanningCalendarTitleText == "") {
			SetAttribute("extrafield", "UsePlanningCalendarTitleText", "{{none}}", $eftable_fieldnum);
		}
		$StrToTimeCompatStartDateString = GetAttribute("extrafield", "StrToTimeCompatStartDateString", $eftable_fieldnum);
		if ($StrToTimeCompatStartDateString == "") {
			SetAttribute("extrafield", "StrToTimeCompatStartDateString", "{{none}}", $eftable_fieldnum);
		}
	}
	if ($eftable_fieldtype == "date" || $eftable_fieldtype == "date/time") {
		$ShowFromToFieldsInListFilters = GetAttribute("extrafield", "ShowFromToFieldsInListFilters", $eftable_fieldnum);
		if ($ShowFromToFieldsInListFilters == "") {
			SetAttribute("extrafield", "ShowFromToFieldsInListFilters", "No", $eftable_fieldnum, array('No', 'Yes'));
		}
	}
	if ($eftable_fieldtype == "textbox" || $eftable_fieldtype == "numeric" || $eftable_fieldtype == "mail" || $eftable_fieldtype == "hyperlink" || $eftable_fieldtype == "checkbox" || $eftable_fieldtype == "date"  || $eftable_fieldtype == "date/time") {

		$Placeholder = GetAttribute("extrafield", "Placeholder", $eftable_fieldnum);

		if ($Placeholder == "") {
			SetAttribute("extrafield", "Placeholder", "{{none}}", $eftable_fieldnum);
		}
	}
	if ($_REQUEST['newtype'] == "drop-down (populate by code)") {
		$RepopulateByAjax = GetAttribute("extrafield", "RepopulateByAjax", $eftable_fieldnum);
		if ($RepopulateByAjax == "") {
			SetAttribute("extrafield", "RepopulateByAjax", "Yes", $eftable_fieldnum, array("Yes", "No"));
		}

	}
	if ($_REQUEST['newtype'] == "checkbox") {
		$CheckBoxCheckedByDefault = GetAttribute("extrafield", "CheckBoxCheckedByDefault", $eftable_fieldnum);
		if ($CheckBoxCheckedByDefault == "") {
			SetAttribute("extrafield", "CheckBoxCheckedByDefault", "No", $eftable_fieldnum, array("No", "Yes"));
		}

	}
	//if ($_REQUEST['newtype'] == "comment") {
		$RefreshByAjaxOnChangeOfField = GetAttribute("extrafield", "RefreshByAjaxOnChangeOfField", $eftable_fieldnum);
		if ($RefreshByAjaxOnChangeOfField == "") {
			SetAttribute("extrafield", "RefreshByAjaxOnChangeOfField", "No", $eftable_fieldnum);
		}
	//}

	if ($_REQUEST['newtype'] == "diary") {
		$AutoUpdateDiaryField = GetAttribute("extrafield", "AutoUpdateDiaryField", $eftable_fieldnum);
		if ($AutoUpdateDiaryField == "") {
			SetAttribute("extrafield", "AutoUpdateDiaryField", "Yes", $eftable_fieldnum, array("Yes", "No"));
		}
	}

	if ($eftable_fieldtype == "numeric") {

		$MaximumValue = GetAttribute("extrafield", "MaximumValue", $eftable_fieldnum);
		if ($MaximumValue == "") {
			SetAttribute("extrafield", "MaximumValue", "{{none}}", $eftable_fieldnum);
		}

		$MinimumValue = GetAttribute("extrafield", "MinimumValue", $eftable_fieldnum);
		if ($MinimumValue == "") {
			SetAttribute("extrafield", "MinimumValue", "{{none}}", $eftable_fieldnum);
		}
		$LengthNatural = GetAttribute("extrafield", "LengthNatural", $eftable_fieldnum);
		if ($LengthNatural == "") {
			SetAttribute("extrafield", "LengthNatural", "10", $eftable_fieldnum);
		}
		$NumericDatabaseField = GetAttribute("extrafield", "NumericDatabaseField", $eftable_fieldnum);
		if ($NumericDatabaseField == "") {
			if ($is_new) {
				SetAttribute("extrafield", "NumericDatabaseField", "Yes", $eftable_fieldnum, array("Yes", "No"));
			} else {
				SetAttribute("extrafield", "NumericDatabaseField", "No", $eftable_fieldnum, array("Yes", "No"));
			}
		}

	}
	$ShowFieldHistory = GetAttribute("extrafield", "ShowFieldHistory", $eftable_fieldnum);
	if ($ShowFieldHistory == "") {
		SetAttribute("extrafield", "ShowFieldHistory", "No", $eftable_fieldnum, array("No", "Yes"));
	}


	$CustomValidationFunctionPHP = GetAttribute("extrafield", "CustomValidationFunctionPHP", $eftable_fieldnum);
	if ($CustomValidationFunctionPHP == "") {
		SetAttribute("extrafield", "CustomValidationFunctionPHP", "{{none}}", $eftable_fieldnum);
	}

	$IgnoreCellClick = GetAttribute("extrafield", "IgnoreCellClick", $eftable_fieldnum);
	if ($IgnoreCellClick == "") {
		SetAttribute("extrafield", "IgnoreCellClick", "No", $eftable_fieldnum, array("No", "Yes"));
	}

	$Interactive = GetAttribute("extrafield", "Interactive", $eftable_fieldnum);
	if ($Interactive == "") {
		SetAttribute("extrafield", "Interactive", "No", $eftable_fieldnum, array("No", "Yes"));
	}
	$InteractiveAlwaysInline = GetAttribute("extrafield", "InteractiveAlwaysInline", $eftable_fieldnum);
	if ($InteractiveAlwaysInline == "") {
		SetAttribute("extrafield", "InteractiveAlwaysInline", "No", $eftable_fieldnum, array("No", "Yes"));
	}
	$InteractiveDontReloadListOnChange = GetAttribute("extrafield", "InteractiveDontReloadListOnChange", $eftable_fieldnum);
	if ($InteractiveDontReloadListOnChange == "") {
		SetAttribute("extrafield", "InteractiveDontReloadListOnChange", "No", $eftable_fieldnum, array("Yes", "No"));
	}
	$FormComment = GetAttribute("extrafield", "FormComment", $eftable_fieldnum);
	if ($FormComment == "") {
		SetAttribute("extrafield", "FormComment", "{{none}}", $eftable_fieldnum);
	}

	$AddIdentifierClass = GetAttribute("extrafield", "AddIdentifierClass", $eftable_fieldnum);
	if ($AddIdentifierClass == "") {
		SetAttribute("extrafield", "AddIdentifierClass", "{{none}}", $eftable_fieldnum, array("No", "Yes"));
	}
	$DisableAutoSave = GetAttribute("extrafield", "DisableAutoSave", $eftable_fieldnum);
	if ($DisableAutoSave == "") {
		SetAttribute("extrafield", "DisableAutoSave", "No", $eftable_fieldnum, array("No", "Yes"));
	}
	$AutoSizeOnInput = GetAttribute("extrafield", "AutoSizeOnInput", $eftable_fieldnum);
	if ($AutoSizeOnInput == "") {
		SetAttribute("extrafield", "AutoSizeOnInput", "No", $eftable_fieldnum, array("No", "Yes"));
	}

	$AlwaysRecalculateWhenNightlyCronIsRan = GetAttribute("extrafield", "AlwaysRecalculateWhenNightlyCronIsRan", $eftable_fieldnum);
	if ($AlwaysRecalculateWhenNightlyCronIsRan == "") {
		SetAttribute("extrafield", "AlwaysRecalculateWhenNightlyCronIsRan", "No", $eftable_fieldnum, array('No','Yes'));
		$AlwaysRecalculateWhenNightlyCronIsRan = "No";
	}

	$ExcludeFromSearches = GetAttribute("extrafield", "ExcludeFromSearches", $eftable_fieldnum);
	if ($ExcludeFromSearches == "") {
		SetAttribute("extrafield", "ExcludeFromSearches", "No", $eftable_fieldnum, array("No", "Yes"));
	}

	$PerFieldSearchEnable = GetAttribute("extrafield", "PerFieldSearchEnable", $eftable_fieldnum);
	if ($PerFieldSearchEnable == "") {
		SetAttribute("extrafield", "PerFieldSearchEnable", "No", $eftable_fieldnum, array('No', 'Yes'));
	}

	$allowed_to_change_once_set = GetAttribute("extrafield", "allowed_to_change_once_set", $eftable_fieldnum);
	if ($allowed_to_change_once_set == "") {
		SetAttribute("extrafield", "allowed_to_change_once_set", "Yes", $eftable_fieldnum, array('Yes', 'No'));
	}

	if ($eftable_fieldtype == "Reference to FlexTable" || $eftable_fieldtype == "Reference to FlexTable (multiselect)" || $eftable_fieldtype == "User-list of all CRM-CTT users" || substr($eftable_fieldtype,0,8) == "Users of" ) {

		if ($eftable_fieldtype == "Reference to FlexTable" || $eftable_fieldtype == "Reference to FlexTable (multiselect)") {
			$UseThisFieldForAccessRestriction = GetAttribute("extrafield", "UseThisFieldForAccessRestriction", $eftable_fieldnum);
			if ($UseThisFieldForAccessRestriction == "") {
				SetAttribute("extrafield", "UseThisFieldForAccessRestriction", "No", $eftable_fieldnum, array("No", "Read access", "Write access"));
			}
		}

		$ExtraSelectCondition = GetAttribute("extrafield", "ExtraSelectCondition", $eftable_fieldnum);
		if ($ExtraSelectCondition == "") {
			SetAttribute("extrafield", "ExtraSelectCondition", "{{none}}", $eftable_fieldnum);
		}

		$ListOptionsForChildTable = GetAttribute("extrafield", "ListOptionsForChildTable", $eftable_fieldnum);
		if ($ListOptionsForChildTable == "") {
			SetAttribute("extrafield", "ListOptionsForChildTable", "{{none}}", $eftable_fieldnum);
		}

		if ($eftable_fieldtype == "Reference to FlexTable" || $eftable_fieldtype == "Reference to FlexTable (multiselect)") {
			$InlineAddIconURLExtras = GetAttribute("extrafield", "InlineAddIconURLExtras", $eftable_fieldnum);
			if ($InlineAddIconURLExtras == "") {
				SetAttribute("extrafield", "InlineAddIconURLExtras", "{{none}}", $eftable_fieldnum);
			}
			$BlindReferenceFieldLayout = GetAttribute("extrafield", "BlindReferenceFieldLayout", $eftable_fieldnum);
			if ($BlindReferenceFieldLayout == "") {
				SetAttribute("extrafield", "BlindReferenceFieldLayout", "-- set blind reference field layout in extra field attributes --", $eftable_fieldnum);
			}
		}
	}
}
function FQNhasNewName($rulesmap)
{
//use this function if you have moved a field (to another table) and you want to keep all set filters and selections users have made

/*
	EXAMPLE
	$rulesmap = array();
	$rulesmap["t1-f3"] = "t1-f90";
*/


//                print '<h1>translate list layouts...</h1>';
  foreach (db_GetArray("select * from CRMattributes WHERE attribute like 'List-layout-%'") as $attribute)
		{
			$fold = unserialize($attribute['value']);
                        $fnew = array();
                        foreach ($fold as $f)
			{
                                foreach ($rulesmap AS $old => $new)
				{
                                        $f = preg_replace("/\b$old\b/", $new, $f);
                                }
                                $fnew[] = $f;
                        }
			if ($fnew != $fold)
			{
			    print '<h2>old</h2>';
			    pre($fold);
			    print '<h2>new</h2>';
			    pre($fnew);
                            SetAttribute($attribute['identifier'], $attribute['attribute'], $fnew, $attribute['entity']);
			}
                }


//		print '<h1>translate last views...</h1>';
                foreach (db_GetArray("select * from CRMattributes WHERE attribute like 'List-lastview-%'") as $attribute) {
                        $fold = unserialize($attribute['value']);
			$fnew = $fold;
                        foreach (array("searchperfield", "filter", "filtertype") as $field)
                        {
                            $newvars = array();
                            foreach ($fnew[$field] as $key => $val)
                            {
                                foreach ($rulesmap AS $old => $new)
				{
                                    $key = preg_replace("/\b$old\b/", $new, $key);
                                }
                                $newvars[$key] = $val;
                            }
                            $fnew[$field] = $newvars;
                        }
                        foreach ($rulesmap AS $old => $new)
			{
                                $fnew["sortby"] = preg_replace("/\b$old\b/", $new, $fnew["sortby"]);
                        }
			if ($fnew != $fold)
			{
/*			    print '<h2>old</h2>';
        	            pre($fold);
                            print '<h2>new</h2>';
                            pre($fnew);*/
				SetAttribute($attribute['identifier'], $attribute['attribute'], $fnew, $attribute['entity']);
			}
                }

//	print '<h1>translate selections...</h1>';
	foreach (db_GetArray("select * from CRMattributes WHERE attribute like 'SelectionNew%'") as $attribute) {
		$fold = unserialize($attribute['value']);
		$fnew = $fold;
		foreach ($fnew as $name => $vars)
		{
		    foreach (array("searchperfield", "filter", "filtertype") as $field)
		    {
			$newvars = array();
			foreach ($vars[$field] as $key => $val)
			{
				foreach ($rulesmap AS $old => $new)
				{
					$key = preg_replace("/\b$old\b/", $new, $key);
				}
				$newvars[$key] = $val;
			}
			$fnew[$name][$field] = $newvars;
		    }
		}
		if ($fnew != $fold)
		{
/*			print '<h2>old</h2>';
			pre($fold);
                        print '<h2>new</h2>';
                        pre($fnew);*/
			SetAttribute($attribute['identifier'], $attribute['attribute'], $fnew, $attribute['entity']);
		}
	}
}

function FieldHasNewValue($field_to_translate, $translate)
{
	//use this function when a field has a new value and you want to keep filters and saved selections of users available
	//especially useful when a dropdown is normalized

/*
	EXAMPLE
	$field_to_translate = "f123";
	$translate = array();
	$translate["Open"] = 1;
	$translate["In progress"] = 4;
	$translate["Closed"] = 7;
*/

	print '<h1>last view</h1>';
	foreach (db_GetArray("select * from CRMattributes WHERE attribute like 'List-lastview-%'") as $attribute)
	{
		$fold = unserialize($attribute['value']);
		$fnew = $fold;
		foreach (array("searchperfield", "filter") as $field)
		{
			$newvars = array();
			foreach ($fnew[$field] as $key => $val)
			{
				if (preg_match("/\-" . $field_to_translate . "$/", $key))
				{
					foreach ($val as $item)
					{
						if ($translate[$item] != "")
						{
							print "translate " . $field . " FROM " . $item . " TO " . $translate[$item] . "<br>";
							$item = $translate[$item];
						}
						$newvars[$key][] = $item;
					}
				}
				else
				{
					$newvars[$key] = $val;
				}
			}
			$fnew[$field] = $newvars;
		}
		if ($fnew != $fold)
		{
/*						print '<h2>old</h2>';
			pre($fold);
			print '<h2>new</h2>';
			pre($fnew);*/
			SetAttribute($attribute['identifier'], $attribute['attribute'], $fnew, $attribute['entity']);
		}
	}

	print '<h1>selection</h1>';
	foreach (db_GetArray("select * from CRMattributes WHERE attribute like 'SelectionNew%'") as $attribute)
	{
		$fold = unserialize($attribute['value']);
		$fnew = $fold;
		foreach ($fnew as $name => $vars)
		{
			foreach (array("searchperfield", "filter") as $field)
			{
				$newvars = array();
				foreach ($vars[$field] as $key => $val)
				{
					if (preg_match("/\-" . $field_to_translate . "$/", $key))
					{
						foreach ($val as $item)
						{
							if ($translate[$item] != "")
							{
								print "translate " . $field . " FROM " . $item . " TO " . $translate[$item] . "<br>";
								$item = $translate[$item];
							}
							$newvars[$key][] = $item;
						}
					}
					else
					{
						$newvars[$key] = $val;
					}
				}
				$fnew[$name][$field] = $newvars;
			}
		}
		if ($fnew != $fold)
		{
/*						print '<h2>old</h2>';
			pre($fold);
			print '<h2>new</h2>';
			pre($fnew);*/
			SetAttribute($attribute['identifier'], $attribute['attribute'], $fnew, $attribute['entity']);
		}
	}
}

function FindMissingReferences()
{
        //we werken met de SystemDataStructure
        $SystemDataStructure = GetSystemDataStructure();

        $total_missing_references = 0;

        $ret = '';

        foreach (array_keys($SystemDataStructure) as $table)
        {
                foreach (array_keys($SystemDataStructure[$table]["parents"]) as $parent_table)
                {
                        foreach ($SystemDataStructure[$table]["parents"][$parent_table] as $field)
                        {
                                $table_db = $SystemDataStructure[$table]["name_in_database"];
                                $field_db = $SystemDataStructure[$table]["fields"][$field]["name_in_database"];

                                $parent_table_db = $SystemDataStructure[$parent_table]["name_in_database"];
                                $parent_field = $SystemDataStructure[$parent_table]["primary"];
                                $parent_field_db = $SystemDataStructure[$parent_table]["fields"][$parent_field]["name_in_database"];

                                $primary_field = $SystemDataStructure[$table]["primary"];
                                //niet nodig; deze is altijd gelijk aan primary_field; geen andere name in database
                                $primary_field_db = $SystemDataStructure[$table]["fields"][$primary_field]["name_in_database"];

                                $selects = array();
                                $wheres = array();
                                $ors = array();

                                $selects[] = "`child`.`" . $primary_field_db . "`";
                                $selects[] = "`child`.`" . $field_db . "`";

                                //niet gezette referenties zijn toegestaan; VOOR STRIKTERE CHECK DEZE CONDITIE WEGHALEN
                                //velden die niet verplicht zijn mogen 0 zijn
                                //TODO geen ondersteuning voor conditional requirement
                                if (!$SystemDataStructure[$table]["fields"][$field]["required"])
                                {
                                        $wheres[] = "`child`.`" . $field_db . "`>0";
                                }

                                //we negeren deleted flextable records; eigenlijk zouden de referenties van deze records net zo goed moeten kloppen; VOOR STRIKTERE CHECK DEZE CONDITIE WEGHALEN
                                if (preg_match("/^t\d+$/", $table))
                                {
                                        $wheres[] = "`child`.`deleted`='n'";
                                }

                                $ors[] = "`parent`.`" . $parent_field_db . "` IS NULL";
                                if (preg_match("/^t\d+$/", $parent_table))
                                {
                                        //als dit record verwijst naar een logisch gedelete parent record dan melden we het ook alszijnde een missende referentie (uit applicatie oogpunt IS dat namelijk ook zo)
                                        $selects[] = "`parent`.`deleted`";
                                        $ors[] = "`parent`.`deleted`='y'";
                                }

                                $wheres[] = "(" . implode(" OR ", $ors) . ")";

                                $query = "SELECT " . implode(", ", $selects) . " FROM `CRM" . $table_db . "` `child` LEFT JOIN `CRM" . $parent_table_db . "` `parent` ON `parent`.`" . $parent_field_db . "`=`child`.`" . $field_db . "`";
                                if (count($wheres) > 0)
                                {
                                        $query .= " WHERE " . implode(" AND ", $wheres);
                                }
                                $query .= " ORDER BY `child`.`" . $primary_field_db . "`";

                                $records = db_GetArray($query);
                                $total_missing_references += count($records);
                                if (count($records) > 0)
                                {
                                        $ret .= '<h1>Missing references from child ' . htme($SystemDataStructure[$table]["singular"]) . ' (' . $table . ') to parent ' . htme($SystemDataStructure[$parent_table]["singular"]) . ' (' . $parent_table . ') via field ' . htme($SystemDataStructure[$table]["fields"][$field]["name"]) . ' (' . $field_db . ')</h1>' . "\n";
                                        $ret .= '<pre>' . $query . '</pre>' . "\n";
                                        $ret .= '<ol>';
                                        $ids = array();
                                        foreach ($records as $record)
                                        {
                                                $ret .= '<li>' . $record[$primary_field_db] . ' - ';
                                                if ($record[$field_db] == 0)
                                                {
                                                        $ret .= 'empty required field';
                                                        $ids["empty required field"][] = $record[$primary_field_db];
                                                }
                                                else if ($record["deleted"] == "y")
                                                {
                                                        $ret .= '<span class="errmsg">parent ' . $record[$field_db] . ' is logically deleted</span>';
                                                        $ids["logically deleted"][] = $record[$primary_field_db];
                                                }
                                                else
                                                {
                                                        $ret .= '<span class="errmsg">parent ' . $record[$field_db] . ' does not exist</span>';
                                                        $ids["does not exist"][] = $record[$primary_field_db];
                                                }
                                                $ret .= '</li>' . "\n";
                                        }
                                        $ret .= '</ol>';

                                        foreach (array_keys($ids) as $key)
                                        {
                                                $fixquery = "UPDATE `CRM" . $table_db . "` SET `timestamp_last_change`=`timestamp_last_change`, `" . $field_db . "`=[FILL IN VALUE] WHERE `" . $primary_field_db . "` IN (" . join(", ", $ids[$key]) . ");";
                                                $ret .= '<div><strong>sql fix for ' . $key . ' BE CAREFUL:</strong></div><div>' . htme($fixquery) . '</div>' . "\n";
                                        }
                                }
                        }
                }
        }

        $ret .= '<h1>Total missing references: ' . $total_missing_references . '</h1>';

        return $ret;
}

function search_all_admin_tables($search, $whole_word_only = false)
{
        $hits = array();
        if ($search != "")
        {
                foreach (db_GetFlatArray("SHOW TABLES") as $table)
                {
                        //MOET met CRM beginnen om custom tabellen (zoals postcodeafstand) te excluden
                        if ((preg_match("/^CRM/", $table)) && (!preg_match("/^CRMflextable\d+/", $table)) && ($table != "CRMbinfiles") && ($table != "CRMblobs") && ($table != "CRMcache") && ($table != "CRMjournal") && ($table != "CRMdatajournal") && ($table != "CRMuselog") && ($table != "CRMinternalmessages") && ($table != "CRMdatastructures") && ($table != "CRMmailqueue") && ($table != "CRMstats") && ($table != "CRMsessions") && ($table != "CRMtodo"))
                        {
                                $primary = ""; //gemakshalve gaan we er vanuit dat dit de primary key is. dat hoeft niet; zeker niet bij compound primary keys
                                foreach (db_GetArray("SHOW FIELDS FROM `" . $table . "`") as $fieldrow)
                                {
                                        $field = $fieldrow['Field'];
                                        if ($primary == "")
                                        {
                                                $primary = $field;
                                        }

                                        $sql = "SELECT `" . $primary . "`, `" . $field . "`";
                                        if ($table == "CRMattributes")
                                        {
                                                $sql .= ", `identifier`, `attribute`, `value`";
                                        }
                                        $sql .= " FROM `" . $table . "` WHERE `" . $field . "` ";
                                        if ($whole_word_only)
                                        {
                                                //TODO hier moet ook nog geescaped worden
                                                $sql .= "REGEXP '[[:<:]]" . mres($search) . "[[:>:]]'";
                                        }
                                        else
                                        {
                                                //escapen want deze karakters zijn operator in de Mysql LIKE functie
                                                $searchpart_escaped = $search;
                                                $searchpart_escaped = str_replace("%", "\\%", $searchpart_escaped);
                                                $searchpart_escaped = str_replace("_", "\\_", $searchpart_escaped);
                                                $sql .= "LIKE '%" . mres($searchpart_escaped) . "%'";
                                        }
                                        if (($table == "CRMmodules") || ($table == "CRMtemplates"))
                                        {
                                                $sql .= " AND `version_belonging_to`=0";
                                        }
                                        else if ($table == "CRMextrafields")
                                        {
                                                $sql .= " AND `deleted`='n'";
                                        }
                                        else if ($table == "CRMattributes")
                                        {
                                                $sql .= " AND attribute NOT IN ('TriggerQueriesForDeploy', 'DataStructureAccessReasons')";
//                                              $sql .= " AND identifier!='user'";
                                        }
//                                      $hits[] = $sql;
                                        foreach (db_GetArray($sql) as $row)
                                        {
                                                $str = $table . ' ' . $primary . '=' . $row[$primary];
                                                if ($table == "CRMattributes")
                                                {
                                                        $str .= ', identifier=' . $row['identifier'] . ', attribute=' . $row['attribute'] . ', value=' . $row["value"];
                                                }
                                                else
                                                {
                                                        $str .= ', ' . $field . '=' . $row[$field];
                                                }
                                                $hits[] = $str;
                                        }
                                }
                        }
                }
        }
        return $hits;
}
function get_table_depth($table, $already_joined = array())
{
        //een tabel die direct naar zichtzelf joint (t1 -> t1) telt als depth = 0
        //een circular die t1 -> t2 -> t1 doet telt voor zowel t1 als t2 als depth = 1
        $already_joined[$table] = true;
        $depth = 0;
        foreach (array_keys($GLOBALS['UC']['PersonalDataStructure'][$table]["fields"]) as $field)
        {
                $relation_to = $GLOBALS['UC']['PersonalDataStructure'][$table]["fields"][$field]["relation_to"];
                if (($relation_to != "") && (!$already_joined[$relation_to]))
                {
                        $thisdepth = get_table_depth($relation_to, $already_joined) + 1;
                        if ($thisdepth > $depth)
                        {
                                $depth = $thisdepth;
                        }
                }
        }
        return $depth;
}

function table_is_part_of_circular_join($table, $firsttable = "", $already_joined = array())
{
        if ($firsttable == "")
        {
                $firsttable = $table;
        }
        $already_joined[$table] = true;
        $table_is_part_of_circular_join = false;
        foreach (array_keys($GLOBALS['UC']['PersonalDataStructure'][$table]["fields"]) as $field)
        {
                $relation_to = $GLOBALS['UC']['PersonalDataStructure'][$table]["fields"][$field]["relation_to"];
                if ($relation_to != "")
                {
                        if ($already_joined[$relation_to])
                        {
                                if ($relation_to == $firsttable)
                                {
                                        $table_is_part_of_circular_join = true;
                                }
                        }
                        else if (table_is_part_of_circular_join($relation_to, $firsttable, $already_joined))
                        {
                                $table_is_part_of_circular_join = true;
                        }
                }
        }
        return $table_is_part_of_circular_join;
}

function circular_join_in_parents($table, $already_joined = array())
{
        $already_joined[$table] = true;
        $circular_join_in_parents = false;
        foreach (array_keys($GLOBALS['UC']['PersonalDataStructure'][$table]["fields"]) as $field)
        {
                $relation_to = $GLOBALS['UC']['PersonalDataStructure'][$table]["fields"][$field]["relation_to"];
                if ($relation_to != "")
                {
                        if ($already_joined[$relation_to])
                        {
                                $circular_join_in_parents = true;
                        }
                        else if (circular_join_in_parents($relation_to, $already_joined))
                        {
                                $circular_join_in_parents = true;
                        }
                }
        }
        return $circular_join_in_parents;
}

function recalc_calculations($which_field = "", $print = false, $all_fields = false)
{
        //MOET runnen als administrator
        //als which_field == "" doet hij alle recalcs via cron; anders alleen die ene efid, bijvoorbeeld "f12"

        disable_mysql_triggers();

        //deze lus is nogal lomp wanneer er wel een which_field is opgegeven
        //TODO: als all_fields aan staat zou eigenlijk op basis van table depth de ds doorlopen moeten worden. ZIE ook graphic data structure. BOVENDIEN zouden we als drop_and_recreate_triggers aan staat; de trigger per tabel moeten droppen, hercalcueren en dan er weer op zetten om de kans op gemiste hercalcs te voorkomen
        foreach (array_keys($GLOBALS['UC']['PersonalDataStructure']) as $table)
        {
                $parts = array();
                foreach (array_keys($GLOBALS['UC']['PersonalDataStructure'][$table]["fields"]) as $field)
                {
                        //hierin staat bijvoorbeeld EFID3*EFID4
                        //of: SELECT COUNT(*) FROM CRMflextable2 WHERE CRMflextable2.deleted='n' AND CRMflextable2.EFID2=CRMflextable1.recordid
                        if (($GLOBALS['UC']['PersonalDataStructure'][$table]["fields"][$field]["calculation"] != "") && ($GLOBALS['UC']['PersonalDataStructure'][$table]["fields"][$field]["calculation_type"] == "database trigger"))
                        {
                                $add = false;
                                if ($all_fields)
                                {
                                        $add = true;
                                }
                                else if (($which_field == "") && ($GLOBALS['UC']['PersonalDataStructure'][$table]["fields"][$field]["RecalculateDaily"]))
                                {
                                        $add = true;
                                }
                                else if ($which_field == $field)
                                {
                                        $add = true;
                                }

                                if ($add)
                                {
                                        $this_calculation = $GLOBALS['UC']['PersonalDataStructure'][$table]["fields"][$field]["calculation"];
                                        $this_calculation = str_replace("@table_alias@", "CRM" . $GLOBALS['UC']['PersonalDataStructure'][$table]["name_in_database"], $this_calculation);
                                        $parts[] = "`" . $GLOBALS['UC']['PersonalDataStructure'][$table]["fields"][$field]["name_in_database"] . "`=(" . $this_calculation . ")";
                                }
                        }
                }

                if (count($parts) > 0)
                {
                        $parts[] = "`timestamp_last_change`=`timestamp_last_change`";

                        $query = "UPDATE `CRM" . $GLOBALS['UC']['PersonalDataStructure'][$table]["name_in_database"] . "` SET " . implode(", ", $parts);
                        if (preg_match("/^t\d+$/", $table))
                        {
                                $query .= " WHERE `deleted`='n'";
                        }

                        if ($print)
                        {
                                print date('r') . ": recalc: " . $table . "...\n";
                        }
                        mcq($query);
                        if ($print)
                        {
                                print date('r') . ": recalc: " . $table . " DONE\n";
                        }
                }
        }

        enable_mysql_triggers();
}
function directed_graph_data_schema($show_datatables = true, $show_usertable = true, $show_grouptable = false, $show_admintables = false)
{
        //deze code is een zooitje, dit kan veel netter
        $str = '
<script src="js/d3.v3.js"></script>
<script src="js/graphlib-dot.js"></script>
<script src="js/dagre-d3.js"></script>

<style>
svg {
border: 1px solid #999;
overflow: hidden;
}

.node {
white-space: nowrap;
}

.node rect,
.node circle,
.node ellipse {
stroke: #333;
fill: #fff;
stroke-width: 1.5px;
}

.cluster rect {
stroke: #333;
fill: #000;
fill-opacity: 0.1;
stroke-width: 1.5px;
}

.edgePath path.path {
stroke: #333;
stroke-width: 1.5px;
fill: none;
}
</style>

<textarea id="inputGraph" style="display: none">
/* Example */
digraph {
';

        foreach (array_keys($GLOBALS['UC']['PersonalDataStructure']) as $table)
        {
                $show_this_table = false;
                if (($GLOBALS['UC']['PersonalDataStructure'][$table]["datatable"]) && ($show_datatables))
                {
                        $show_this_table = true;
                }
                if ((!$GLOBALS['UC']['PersonalDataStructure'][$table]["datatable"]) && ($show_admintables))
                {
                        $show_this_table = true;
                }
                if (($table == "users") && ($show_usertable))
                {
                        $show_this_table = true;
                }
                if (($table == "groups") && ($show_grouptable))
                {
                        $show_this_table = true;
                }

                if ($show_this_table)
                {
                        $str .= $table . " [labelType=\"html\" label=\"<a href=list.php?table=" . $table . ">" . $GLOBALS['UC']['PersonalDataStructure'][$table]["plural"] . "</a>\"];\n";
                        foreach (array_keys($GLOBALS['UC']['PersonalDataStructure'][$table]["childs"]) as $child_table)
                        {
                                $show_this_table = false;
                                if (($GLOBALS['UC']['PersonalDataStructure'][$child_table]["datatable"]) && ($show_datatables))
                                {
                                        $show_this_table = true;
                                }
                                if ((!$GLOBALS['UC']['PersonalDataStructure'][$child_table]["datatable"]) && ($show_admintables))
                                {
                                        $show_this_table = true;
                                }
                                if (($child_table == "users") && ($show_usertable))
                                {
                                        $show_this_table = true;
                                }
                                if (($child_table == "groups") && ($show_grouptable))
                                {
                                        $show_this_table = true;
                                }

                                if ($show_this_table)
                                {
                                        foreach ($GLOBALS['UC']['PersonalDataStructure'][$table]["childs"][$child_table] as $child_field)
                                        {
                                                $str .= $table . "->" . $child_table;
                                                if (count($GLOBALS['UC']['PersonalDataStructure'][$table]["childs"][$child_table]) > 1)
                                                {
                                                        $str .= " [label=\"" . $GLOBALS['UC']['PersonalDataStructure'][$child_table]["fields"][$child_field]["name"] . "\"]";
                                                }
                                                $str .= "\n";
                                        }
                                }
                        }
                }

        }

$str .= '
}
</textarea>

<svg width="100%" height=800>
<g/>
</svg>

<script>
// Input related code goes here

function graphToURL() {
var elems = [window.location.protocol, \'//\',
window.location.host,
window.location.pathname,
\'?\'];

var queryParams = [];
if (debugAlignment) {
queryParams.push(\'alignment=\' + debugAlignment);
}
queryParams.push(\'graph=\' + encodeURIComponent(inputGraph.value));
elems.push(queryParams.join(\'&\'));

return elems.join(\'\');
}

var inputGraph = document.querySelector("#inputGraph");

var graphLink = d3.select("#graphLink");

var oldInputGraphValue;

var graphRE = /[?&]graph=([^&]+)/;
var graphMatch = window.location.search.match(graphRE);
if (graphMatch) {
inputGraph.value = decodeURIComponent(graphMatch[1]);
}
var debugAlignmentRE = /[?&]alignment=([^&]+)/;
var debugAlignmentMatch = window.location.search.match(debugAlignmentRE);
var debugAlignment;
if (debugAlignmentMatch) debugAlignment = debugAlignmentMatch[1];

// Set up zoom support
var svg = d3.select("svg"),
inner = d3.select("svg g"),
zoom = d3.behavior.zoom().on("zoom", function() {
inner.attr("transform", "translate(" + d3.event.translate + ")" +
"scale(" + d3.event.scale + ")");
});
svg.call(zoom);

// Create and configure the renderer
var render = dagreD3.render();

function tryDraw() {
var g;
if (oldInputGraphValue !== inputGraph.value) {
inputGraph.setAttribute("class", "");
oldInputGraphValue = inputGraph.value;
try {
g = graphlibDot.read(inputGraph.value);
} catch (e) {
inputGraph.setAttribute("class", "error");
throw e;
}

// Save link to new graph
graphLink.attr("href", graphToURL());

// Set margins, if not present
if (!g.graph().hasOwnProperty("marginx") &&
!g.graph().hasOwnProperty("marginy")) {
g.graph().marginx = 20;
g.graph().marginy = 20;
}

g.graph().transition = function(selection) {
return selection.transition().duration(500);
};

// Render the graph into svg g
d3.select("svg g").call(render, g);
}
}

tryDraw();
</script>';

        return $str;
}
function return_mysql_trigger_queries($use_delimiter = false, $return_droptrigger = true, $return_createtrigger = true)
{
        //MOET runnen als administrator

        /*
        - triggers kunnen alleen parents updaten met (geaggregeerde) data uit childs, niet childs met data uit parents
        - Circulaire referenties (alsmede triggers die childs updates) zijn niet mogelijk vanwege: Can't update table 'CRMflextable25' in stored function/trigger because it is already used by statement which invoked this stored function/trigger.
        - ALLE calculations runnen in 1x voor een record, terwijl die lang niet altijd nodig zal zijn (omdat we weten dat de uitkomst gelijk is). om dit te ondersteunen moet er veel meer logica in die triggers ziten en dat is nu niet zo. jammer dan; dit runt toch snel genoeg (voorlopig)
        - EFID1 kan een calculations zijn, EFID2 kan een andere calculations zijn met waarde "EFID1*2" -> dit werkt zolang de ordering van velden juist is (EFID2 moet NA EFID1 staan)
        - worden gebruikt voor berekeningen, bijvoorbeeld totaal = prijs_per_stuk * aantal
        - resultaat wordt *niet* gejournaled
        - calculations worden ook in parents herberekend bij een update op de child (wanneer er een factuur wordt toegevoegd in de child, kan bijvoorbeeld de totaalsom van alle facturen in de klanten tabel (parent) herberekend worden. een update op een grandchild herbekerend ook de grandparent WANNEER de parent ook herberekend wordt (omdat er in die parent in calculations gerefereed wordt aan de grandchild. als dat niet zo is, dan wordt de grandparent ook niet herberekend). Stel Klant -> Project -> Facturen; maak in dat geval niet ALLEEN een totaaltelling van facturen op klantnivo; maar maar een totaaltelling van facturen PER project en SUM die weer bij de Klant. dan calct alles door
        - calculations herberkenen NIET de childs van een record. dit lijkt ook niet waarschijnlijk te zijn dat je dat wilt. Om dat wel te doen zou je een eindeloze recursie hebben
        - calculation velden zijn altijd readonly, ook voor admin
        - calcs CRMbinfiles en hun parents worden ook ondersteund
        - de binfiles calcs kunen efficienter; op een update van een bestand wordt de parent 2x herberekend omdat type en koppelid nooit zullen wijzigen (in de Interleave) interface). Dit zou efficienter kunnen (door NEW met OLD te vergelijken) maar dat maakt de triger logica complexer
                IF OLD.`type`='flextable23' THEN
                UPDATE `CRMflextable23` SET `CRMflextable23`.`timestamp_last_change`=`CRMflextable23`.`timestamp_last_change` WHERE `CRMflextable23`.`recordid`=OLD.`koppelid`;
                END IF;
                IF NEW.`type`='flextable23' THEN
                UPDATE `CRMflextable23` SET `CRMflextable23`.`timestamp_last_change`=`CRMflextable23`.`timestamp_last_change` WHERE `CRMflextable23`.`recordid`=NEW.`koppelid`;
                END IF;
        - efficientere triggers door NEW met OLD te vergelijken en alleen te runnen op een verschil
        */

        $queries_to_run = array();

        $delimiter = ";";
        //is nodig voor als de queries over de commandline runnen via een deploy
        if ($use_delimiter)
        {
                $delimiter = "//";
                $queries_to_run[] = "delimiter " . $delimiter;
        }

        if ($return_droptrigger)
        {
                //deze heeft geen data structure nodig
                foreach (db_GetArray("SHOW TRIGGERS") as $row)
                {
                        $query = "DROP TRIGGER `" . $row["Trigger"] . "`" . $delimiter;
                        $queries_to_run[] = $query;
                }
        }

        if ($return_createtrigger)
        {
                foreach (@array_keys($GLOBALS['UC']['PersonalDataStructure']) as $table)
                {
                        //alleen in deze tabellen kunnen efids zitten; alleen efids kunnen calculations bevatten
                        if (($GLOBALS['UC']['PersonalDataStructure'][$table]["datatable"]) || ($table == "files") || ($table == "users") || ($table == "groups"))
                        {
                                foreach (array("BEFORE", "AFTER") as $timing)
                                {
                                        foreach (array("INSERT", "UPDATE", "DELETE") as $event)
                                        {
                                                $types = array();
                                                if (($event == "DELETE") || ($event == "UPDATE"))
                                                {
                                                        $types[] = "OLD";
                                                }
                                                if (($event == "INSERT") || ($event == "UPDATE"))
                                                {
                                                        $types[] = "NEW";
                                                }

                                        //TODO: als er in acc een trigger zat op een veld wat gedropt is, dan wordt die niet mee gedeployed naar prod waardoor die oude trigger blijft bestaan
/*                                      if ($return_droptrigger)
                                        {
                                                $query = "DROP TRIGGER IF EXISTS `" . $table . "_" . $event . "_" . $timing . "`" . $delimiter;
                                                $queries_to_run[] = $query;
                                        }*/

//                                      if ($return_createtrigger)
//                                      {
                                                $query = "";

                                                if ($timing == "BEFORE")
                                                {
                                                        //we doen niks; we verwijderen het record immers dus we hoeven geen update op de eigen tabel meer te doen, nog WEL op bovenliggende tabellen
                                                        if ($event != "DELETE")
                                                        {
                                                                $parts = array();
                                                                foreach (array_keys($GLOBALS['UC']['PersonalDataStructure'][$table]["fields"]) as $field)
                                                                {
                                                                        //hierin staat bijvoorbeeld EFID3*EFID4
                                                                        //of: SELECT COUNT(*) FROM CRMflextable2 WHERE CRMflextable2.deleted='n' AND CRMflextable2.EFID2=CRMflextable1.recordid
                                                                        if (($GLOBALS['UC']['PersonalDataStructure'][$table]["fields"][$field]["calculation"] != "") && ($GLOBALS['UC']['PersonalDataStructure'][$table]["fields"][$field]["calculation_type"] == "database trigger"))
                                                                        {
                                                                                //replace want je mag niet de eigen tabel updaten in deze context; door de NEW. te zetten wordt ie in 1x goed geinsert/update
                                                                                $this_calculation = $GLOBALS['UC']['PersonalDataStructure'][$table]["fields"][$field]["calculation"];

//TODO: @table_alias@ kan direct door NEW vervangen worden zodra alle bestaande calculations zijn omgezet
                                                                                $this_calculation = str_replace("@table_alias@", "CRM" . $GLOBALS['UC']['PersonalDataStructure'][$table]["name_in_database"], $this_calculation);

                                                                                //zodat CRMflextable1.EFID2 wordt vertaald met NEW.EFID2
                                                                                $this_calculation = preg_replace("/\bCRM" . $GLOBALS['UC']['PersonalDataStructure'][$table]["name_in_database"] . "\b/", "NEW", $this_calculation);

                                                                                $parts[] = "NEW.`" . $GLOBALS['UC']['PersonalDataStructure'][$table]["fields"][$field]["name_in_database"] . "`=(" . $this_calculation . ")";
                                                                        }
                                                                }
                                                                if (count($parts) > 0)
                                                                {
                                                                        //dit is de daadwerkelijke trigger; deze maakt data changes; alle andere logica in deze functie is er alleen maar voor om andere tabellen te triggeren onderstaande queries uit te voeren
                                                                        $query .= "SET " . implode(", ", $parts) . ";\n";
                                                                }
                                                        }
                                                }
                                                //IN DE AFTER DOEN WE DE BOVENLIGGENDE TABELLEN
                                                else
                                                {
                                                        //de files table wijst op een afwijkende manier naar zijn parents
                                                        if ($table == "files")
                                                        {
                                                                foreach (array_keys($GLOBALS['UC']['PersonalDataStructure']) as $parent_table)
                                                                {
                                                                        if ($GLOBALS['UC']['PersonalDataStructure'][$parent_table]["HasFileAttachments"])
                                                                        {
                                                                                //code duplicatie: 2x in deze functie
                                                                                $do_parent_recalc = false;
                                                                                foreach (array_keys($GLOBALS['UC']['PersonalDataStructure'][$parent_table]["fields"]) as $parent_field)
                                                                                {
                                                                                        //in de parent calculation wordt de tabel genoemd waarin we nu zitten; we moeten de parent dus recalcen
                                                                                        //we hoeven hier geen @table_alias@ te replacen want we kijken niet naar DIE tabelnaam
                                                                                        if ((preg_match("/\bCRM" . $GLOBALS['UC']['PersonalDataStructure'][$table]["name_in_database"] . "\b/", $GLOBALS['UC']['PersonalDataStructure'][$parent_table]["fields"][$parent_field]["calculation"])) && ($GLOBALS['UC']['PersonalDataStructure'][$parent_table]["fields"][$parent_field]["calculation_type"] == "database trigger"))
                                                                                        {
                                                                                                $do_parent_recalc = true;
                                                                                                break;
                                                                                        }
                                                                                }
                                                                                //code duplicatie: 2x in deze functie

                                                                                if ($do_parent_recalc)
                                                                                {
                                                                                        foreach ($types as $type)
                                                                                        {
                                                                                                $query .= "IF " . $type . ".`type`='" . $GLOBALS['UC']['PersonalDataStructure'][$parent_table]["name_in_database"] . "' THEN\n";

                                                                                                //we TOUCHEN hier alleen het parent record zodat die zijn eigen triggers runt voor updates in zijn eigen tabel
                                                                                                //met een update van t_l_c naar NOW() zouden de parent een bijgewerkte timestamp kunnen krijgen
                                                                                                $query .= "UPDATE `CRM" . $GLOBALS['UC']['PersonalDataStructure'][$parent_table]["name_in_database"] . "` SET `CRM" . $GLOBALS['UC']['PersonalDataStructure'][$parent_table]["name_in_database"] . "`.`timestamp_last_change`=`CRM" . $GLOBALS['UC']['PersonalDataStructure'][$parent_table]["name_in_database"] . "`.`timestamp_last_change` WHERE `CRM" . $GLOBALS['UC']['PersonalDataStructure'][$parent_table]["name_in_database"] . "`.`" . $GLOBALS['UC']['PersonalDataStructure'][$parent_table]["primary"] . "`=" . $type . ".`koppelid`;\n";

                                                                                                $query .= "END IF;\n";
                                                                                        }
                                                                                }
                                                                        }
                                                                }
                                                        }
                                                        else
                                                        {
                                                                foreach (array_keys($GLOBALS['UC']['PersonalDataStructure'][$table]["parents"]) as $parent_table)
                                                                {
                                                                        //code duplicatie: 2x in deze functie
                                                                        $do_parent_recalc = false;
                                                                        foreach (array_keys($GLOBALS['UC']['PersonalDataStructure'][$parent_table]["fields"]) as $parent_field)
                                                                        {
                                                                                if (preg_match("/\bCRM" . $GLOBALS['UC']['PersonalDataStructure'][$table]["name_in_database"] . "\b/", $GLOBALS['UC']['PersonalDataStructure'][$parent_table]["fields"][$parent_field]["calculation"]))
                                                                                {
                                                                                        //in de parent calculation wordt de tabel genoemd waarin we nu zitten; we moeten de parent dus recalcen
                                                                                        $do_parent_recalc = true;
                                                                                        break;
                                                                                }
                                                                        }
                                                                        //code duplicatie: 2x in deze functie

                                                                        if ($do_parent_recalc)
                                                                        {
                                                                                //er kunnen meerdere links zijn naar deze parent
                                                                                $parent_records_to_update = array();
                                                                                foreach ($GLOBALS['UC']['PersonalDataStructure'][$table]["parents"][$parent_table] as $field)
                                                                                {
                                                                                        foreach ($types as $type)
                                                                                        {
                                                                                                $parent_records_to_update[] = $type . ".`" . $GLOBALS['UC']['PersonalDataStructure'][$table]["fields"][$field]["name_in_database"] . "`";
                                                                                        }
                                                                                }
                                                                                //parent_records_to_update bevat nu bijvoorbeeld OLD.EFID2, NEW.EFID2, OLD.EFID17, NEW.EFID17 -> indien er 2 links naar deze parent bestaand vanuit deze child
                                                                                //als hier 4x hetzelfde id in staat (omdat ie niet is gewijzigd) dan zou mysql die update maar 1x moeten draaien (ontdubbeling in de IN() - denk ik)
                                                                                //we TOUCHEN hier alleen het parent record zodat die zijn eigen triggers runt voor updates in zijn eigen tabel
                                                                                //met een update van t_l_c naar NOW() zouden alle parents een bijgewerkte timestamp kunnen krijgen (waarschijnlijk onwenselijk)
                                                                                $query .= "UPDATE `CRM" . $GLOBALS['UC']['PersonalDataStructure'][$parent_table]["name_in_database"] . "` SET `CRM" . $GLOBALS['UC']['PersonalDataStructure'][$parent_table]["name_in_database"] . "`.`timestamp_last_change`=`CRM" . $GLOBALS['UC']['PersonalDataStructure'][$parent_table]["name_in_database"] . "`.`timestamp_last_change` WHERE `CRM" . $GLOBALS['UC']['PersonalDataStructure'][$parent_table]["name_in_database"] . "`.`" . $GLOBALS['UC']['PersonalDataStructure'][$parent_table]["primary"] . "` IN (" . join(", ", $parent_records_to_update) . ");\n";
                                                                        }
                                                                }
                                                        }
                                                }

                                                if ($query != "")
                                                {
                                                        $trigger_query = "CREATE TRIGGER `" . $table . "_" . $event . "_" . $timing . "` " . $timing . " " . $event . " ON `CRM" . $GLOBALS['UC']['PersonalDataStructure'][$table]["name_in_database"] . "` FOR EACH ROW\n";
                                                        $trigger_query .= "BEGIN\n";
                                                        $trigger_query .= "IF @interleave_disable_trigger IS NULL THEN\n";
                                                        $trigger_query .= $query;
                                                        $trigger_query .= "END IF;\n";
                                                        $trigger_query .= "END" . $delimiter;

                                                        $queries_to_run[] = $trigger_query;
                                                }
//                                      }
                                        }
                                }
                        }
                }
        }

        if ($use_delimiter)
        {
                $delimiter = ";";
                $queries_to_run[] = "delimiter " . $delimiter;
        }

        return $queries_to_run;
}

?>
