<?php
/* *****************************************************************
 * Interleave
 * Copyright (c) 2001-2016 Atomos Applications The Netherlands - www.atomos.nl - info@atomos.nl - www.interleave.nl - info@interleave.nl
 * Licensed under the GNU GPL. For full terms see the file COPYING.
 *
 * This file is the core of Interleave. It is always needed. It contains only functions and includes some other files.
 *
 * Check http://www.interleave.nl/ for more information
 *
 * BUILD / RELEASE :: 7.0.20161227
 *
 **********************************************************************
*/
if (empty($GLOBALS['CONFIGFILE'])) {
    $GLOBALS['CONFIGFILE'] = $GLOBALS['PATHTOINTERLEAVE'].'config/config.inc.php';
}
/*
 * functies/files te verwijderen
 *
 *	assist.php			wacht op ajaxbox (en dan nog checken)
 *	AjaxBox()
 *	egrep -n "AjaxBox\(" * 2>/dev/null

        V functions.php:1377:		if (strstr($template, "#MESSAGES#")) $template = str_replace("#MESSAGES#",AjaxBox("ShowMessagesList", true, false, false, "MessagesList"), $template);
        functions.php:7921:	return(AjaxBox("attrib-assist", false, "&identifier=" . $identifier . "&entity=" . $entity . "&attribute=" . $attribute, false, false, 0, "showinlineblock"));
        import.php:237:					print AjaxBox("ValidateInput", true, "&Worker=" . $worker . "&Header=" . ($headerId) . "&Table=" . $mem['table'], false, "AjaxDivHeader" . $headerId);
        modules.php:164:					print AjaxBox("RunModule", false, "&ExecInsModule=" . $_REQUEST['mid']);
 *
 *	populate.php
 *
 *
*/

// Version and author information (do not change)

// This version number is automatically a adjusted by the build routine. DO NOT ALTER IT BY HAND unless you know what you're doing.
// At least make sure it always ends with 8 characters representing the last build date (YYYY-MM-DD).
// NEVER (I MEAN *NEVER*) CHANGE THE DATE IN THIS VERSION BY HAND. FOR RELEASE TEST PURPOSES CHANGE SOMETHING ELSE BUT THE
// RELEASE DATE MUST ALWAYS BE 100% THE SAME AS THE RELEASE VERSION DATE MENTIONED IN EVERY FILE HEADER.
$GLOBALS['VERSION'] = '7.0.20161227'; // The main version
if (!isset($GLOBALS['PRODUCT'])) {
    $GLOBALS['PRODUCT'] = '';
}

// Some concats
$GLOBALS['CRM_VERSION'] = $GLOBALS['PRODUCT'].' '.$GLOBALS['VERSION'].' (c) 2001-2016';

require_once 'dbfunctions-mysqli.php';
require_once 'listfunctions.php';
require_once 'rules-functions.php';
require_once 'record-functions.php';
require_once 'form-functions.php';
require_once 'show_calendar.php';

function IntermediateDatabaseUpgrade()
{
    require_once 'dbupgrade.php';
    // Function moved to separate file
    IntermediateDatabaseUpgrade2();
}

function FlattenArray($arr)
{
    $flattened = array();
    foreach ($arr as $element) {
        if ($element) {
            array_push($flattened, $element);
        }
    }

    return $flattened;
}

/* MySQL error handling function (only for failed database queries) */
function handle_error($mysqlerror, $mysqlerrorno, $sql)
{

    /*
    Per 20160212 this function will always lead to an exit; the first MySQL query which crashes
    crashes the whole page load. There's zero tolerance. Future will tell if will work out.

    */

    /* handle_error should only run once */

    static $handle_error_is_running = false;

    /* compose message about error */
    $errmsg = '';
    $errmsg .= 'MySQL Error: '.$mysqlerror."\n";
    $errmsg .= 'MySQL Error id: '.$mysqlerrorno."\n";
    $errmsg .= "Query:\n".$sql."\n";

    /* if this status is already set */
    if ($handle_error_is_running) {

        /* if a query resulted in a second error there's probably something wrong with the database */
        $errmsg .= "\n";
        $errmsg .= 'User id: '.$GLOBALS['USERID']."\n";
        $errmsg .= 'User name: '.$GLOBALS['USERNAME']."\n";
        $errmsg .= 'Date/time: '.date('Y-m-d H:i:s')."\n";
        $errmsg .= "\n";
        $errmsg .= "GET\n";
        $errmsg .= print_r($_GET, true);
        $errmsg .= "\n";
        $errmsg .= "POST\n";
        $errmsg .= print_r($_POST, true);
        $errmsg .= "\n";
        $errmsg .= "COOKIE\n";
        $errmsg .= print_r($_COOKIE, true);
        $errmsg .= "\n";
        $errmsg .= "SERVER\n";
        $errmsg .= print_r($_SERVER, true);
        $errmsg .= "\n";
        $errmsg .= "BACKTRACE\n";
        $errmsg .= GetBackTrace();
        $errmsg .= "\n";

        mail('root@localhost', 'SQL error '.$_SERVER['HTTP_HOST'], $errmsg);

        if ($GLOBALS['Installer']) {

            /* show more technical details, only if admin or in development mode */
            echo '<pre style="background-color: #eee; padding: 5px; font-size: 90%;">'.htme($errmsg).'</pre>';

            /* HF20160804 backtrace added, only a a query error is practically useless */
            echo '<pre style="background-color: #eee; padding: 5px; font-size: 90%;">'.htme(GetBackTrace(true)).'</pre>';
        }

        exit;
    } else {
        $handle_error_is_running = true;
    }

    /* print an error message informing the user about what just happened */
    //"faileddatabasequery" is here for ProcessMessageReply()
    echo '<!-- faileddatabasequery --><div class="errmsg" style="font-size: 200%;"><span class="fa fa-exclamation-triangle"></span> We\'re sorry. Something went wrong. Your administrator has been notified.</div>';

    /* log the message. this could lead to a second query error, in which case the handle_error_is_running flag will cause the script to exit */
    log_msg("ERROR: A user encountered an SQL error\n".$errmsg);

    /* ShowMinimalErrorMessages should be Yes on production systems. this check could lead to a second query error, in which case the handle_error_is_running flag will cause the script to exit */

    if (GetSetting('ShowMinimalErrorMessages') != 'Yes' || is_administrator() || $GLOBALS['Installer']) {

        /* show more technical details, only if admin or in development mode */
        echo '<pre style="background-color: #eee; padding: 5px; font-size: 90%;">'.htme($errmsg).'</pre>';

        /* HF20160804 backtrace added, only a a query error is practically useless */
        echo '<pre style="background-color: #eee; padding: 5px; font-size: 90%;">'.htme(GetBackTrace(true)).'</pre>';
    }

    /* bye bye */
    exit;
}

function htme($x)
{
    return htmlspecialchars($x, ENT_QUOTES, 'UTF-8');
}
function array_size($a)
{
    $size = 0;
    while (list($k, $v) = each($a)) {
        $size += is_array($v) ? array_size($v) : strlen($v);
    }

    return $size;
}
function string_r($array /*indent*/
) {
    $tabsize = '    ';
    $arg = func_get_args();
    $indent = $arg[1];
    if (func_num_args() == 1) {
        $indent = $tabsize;
    }
    $contentString = '';
    foreach ($array as $name => $value) {
        if (is_array($value)) {
            $contentString .= $indent.'['.$name.'] => Array'."\n".$indent.$tabsize."(\n";
            $contentString .= string_r($value, $indent.$tabsize.$tabsize);
            $contentString .= $indent.$tabsize.")\n\n";
        } else {
            $contentString .= $indent.'['.$name.']'.'  =>  '.$value."\n";
        }
    }
    if (func_num_args() == 1) {
        $contentString = "Array\n(\n".$contentString.")\n";
    }

    return $contentString;
}

function GetUserLoginNameByID($id)
{
    if ($id != '') {
        return db_GetValue("SELECT name FROM CRMloginusers WHERE id='".mres($id)."'");
    }
}
function GetUserID($username)
{
    if ($username != '') {
        return db_GetValue("SELECT id FROM CRMloginusers WHERE name='".mres($username)."'");
    }
}
function GetUsersOfGroup($groupid)
{
    $row = '';
    if ($groupid == 0 || $groupid == '0' || $groupid == 'admin') {
        $row = db_GetFlatArray("SELECT id FROM CRMloginusers WHERE administrator='yes' AND name NOT LIKE 'deleted_user%'");
    } elseif ($groupid > 0) {
        $row = db_GetFlatArray("SELECT id FROM CRMloginusers WHERE PROFILE='".mres($groupid)."' AND name NOT LIKE 'deleted_user%'");
    }

    return $row;
}
function GetGroups()
{
    $list = db_GetArray('SELECT name, id FROM CRMuserprofiles ORDER BY name');
    $list[] = array('name' => 'Administrators', 'id' => '0');

    return $list;
}
function GetGroup($userid)
{
    if ($userid != '') {
        return db_GetValue("SELECT PROFILE FROM CRMloginusers WHERE id='".mres($userid)."'");
    }
}
function GetGroupName($groupid)
{
    if ($groupid == 0) {
        return 'Administrators';
    } elseif ($groupid != '') {
        return db_GetValue("SELECT name FROM CRMuserprofiles WHERE id='".mres($groupid)."'");
    }
}
function GetUserAccountName($userid)
{
    if (is_numeric($userid)) {
        return db_GetValue("SELECT name FROM CRMloginusers WHERE id='".mres($userid)."'");
    }
}
function GetUserName($userid)
{
    $username = '';
    //als HideUserNames aan staat mag je alleen je eigen username zien; deze logica zit zowel in de het opbouwen van de DS als ook in GetUserName()
    if (($GLOBALS['USERID'] == $userid) || (CheckFunctionAccess('HideUserNames') != 'ok')) {
        $username = db_GetValue("SELECT FULLNAME FROM CRMloginusers WHERE id='".mres($userid)."'");
    }

    return $username;
//dit werkt niet want dit kan tot eindeloze recursie leiden bij opbouwen van DS (2016-12-15: is dat ngo steeds zo of zou het nu wel werken?)
//    return get_refer_layout_for_record("users", $userid);
}
function GetUserProfiles($specific_id = false)
{
    $profs = array();
    $res = db_GetArray("SELECT id, name FROM CRMuserprofiles WHERE active='yes' ORDER BY name");

    foreach ($res as $row) {
        array_push($profs, array($row['id'], $row['name']));
        if ($specific_id == $row['id']) {
            return $row['name'];
        }
    }
    array_push($profs, array('0', 'Administrators'));

    return $profs;
}
function GetProfiles()
{
    $row = db_GetArray("SELECT * FROM CRMuserprofiles WHERE active='yes'");
    $row[] = array('id' => '0', 'name' => 'Administrators', 'administrator' => 'yes');

    return $row;
}
function GetProfileArray($prof_num)
{
    return db_GetRow("SELECT * FROM CRMuserprofiles WHERE id='".mres($prof_num)."' AND active='yes'");
}
function GetUserEmail($userid)
{
    return db_GetValue("SELECT EMAIL FROM CRMloginusers WHERE id='".mres($userid)."'");
}
function GetFileName($fileid)
{
    if (is_positive_integer($fileid)) {
        return db_GetValue('SELECT filename FROM CRMbinfiles WHERE fileid='.$fileid);
    } else {
        return false;
    }
}
function GetTemplateByPageId($template_page_id)
{
    if ($template_page_id != '') {
        $templateid = db_GetValue("SELECT templateid FROM CRMtemplates WHERE page_id='".mres($template_page_id)."' AND templatetype='TEMPLATE_HTML' AND version_belonging_to=0");
        if (CheckTemplateAccess($templateid) == 'ok') {
            return $templateid;
        } else {
            return false;
        }
    } else {
        return false;
    }
}
function GetTemplateName($templateid)
{
    if (CheckTemplateAccess($templateid) == 'ok') {
        return db_GetValue('SELECT templatename FROM CRMtemplates WHERE templateid='.$templateid);
    } else {
        return false;
    }
}
function GetTemplateType($templateid)
{
    if (CheckTemplateAccess($templateid) == 'ok') {
        return db_GetValue('SELECT templatetype FROM CRMtemplates WHERE templateid='.$templateid);
    } else {
        return false;
    }
}
function CheckTemplateAccess($templateid)
{
    $access = 'nok';
    if (ipi($templateid)) {
        $templateid2 = db_GetValue('SELECT `templateid` FROM `CRMtemplates` WHERE `templateid`='.$templateid.' AND `version_belonging_to`=0');
        if (ipi($templateid2)) {
            if (is_administrator()) {
                $access = 'ok';
            } elseif ((db_GetValue('SELECT COUNT(*) FROM `CRMtemplateaccessrules` WHERE `template`='.$templateid2) == 0) || (db_GetValue('SELECT COUNT(*) FROM `CRMtemplateaccessrules` WHERE `template`='.$templateid2." AND `group`='".$GLOBALS['GROUPID']."' AND `read`='1'") > 0)) {
                $access = 'ok';
            }
        }
    }

    return $access;
}
function GetFileType($fileid)
{
    if (is_positive_integer($fileid)) {
        return db_GetValue('SELECT filetype FROM CRMbinfiles WHERE fileid='.$fileid);
    } else {
        return false;
    }
}
function SetFileContent($fileid, $content)
{
    if (is_positive_integer($fileid)) {
        mcq("UPDATE CRMblobs, CRMbinfiles SET CRMblobs.content='".mres($content)."',CRMblobs.gz='n',CRMbinfiles.filesize='".strlen($content)."' WHERE CRMblobs.fileid=CRMbinfiles.fileid AND CRMblobs.fileid=".$fileid);

        return true;
    } else {
        log_msg('ERROR: SetFileContent called with non-numeric file id.');

        return false;
    }
}
function GetTemplate($templateid)
{
    if (CheckTemplateAccess($templateid) == 'ok') {
        $selfield = '';
        if (GetTemplateType($templateid) == 'TEMPLATE_PLAIN') {
            $selfield = 'binary_content';
        } else {
            $selfield = 'content';
        }
        /*
        $cnt = GetAttribute("template", "TemplateUseCount", $templateid);
        if (!is_numeric($cnt)) {
        $cnt = 1;
        } else {
        $cnt++;
        }
        SetAttribute("template", "TemplateUseCount", $cnt, $templateid);
        */
        //2016-03-01: AND version_belonging_to=0
        $template = db_GetValue('SELECT '.$selfield.' FROM CRMtemplates WHERE templateid='.$templateid);

        if ($template == '') {
            log_msg('ERROR: GetTemplate searched for template "'.$templateid.'" but it returned empty!');
        }

        return $template;
    } else {
        return false;
    }
}
function GetBlobLastModificationDate($fileid)
{
    return db_GetValue("SELECT `CRMblobs`.`timestamp_last_change` FROM `CRMblobs` WHERE `CRMblobs`.`fileid` = '".mres($fileid)."'");
}
function GetTemplateLastModificationDate($templateid)
{
    return db_GetValue("SELECT `CRMtemplates`.`timestamp_last_change` FROM `CRMtemplates` WHERE `CRMtemplates`.`templateid` = '".mres($templateid)."'");
}
function GetFileContent($fileid)
{
    if (ipi($fileid)) {
        $row = db_GetRow('SELECT * FROM CRMblobs, CRMbinfiles WHERE CRMblobs.fileid=CRMbinfiles.fileid AND CRMblobs.fileid='.$fileid);
        if ($row['fileid'] == 0) {
            log_msg('WARNING: GetFileContent Searched for file '.$fileid.' but got zero rows!');
        } elseif ($row['offloaded'] == 'y') { // This file is offloaded to secondary storage
            $hash = GetSetting('OffLoadedFilesDirectoryHash');
            $localpath = GetSetting('OffloadFilesURL');
            if ($localpath == '') {
                $localpath = GetSetting('OffloadLocalPath');
            }
            $path = $localpath.'/'.$hash.'/'.$fileid;
            $epath = $localpath.'/'.$hash.'/e'.$fileid;

            $key = GetSetting('OffLoadedFilesSSLKey');

            if ($key != '') { // file is, or must be, encrypted
                if (is_file($epath)) {

                    // File is encrypted and available
                    $row['content'] = `cat $epath | openssl aes-256-cbc -d -k $key`;

                    // Delete any unencrypted versions of the same file
                    if (is_file($path)) {
                        unlink($path);
                    }
                } elseif (is_file($path)) {
                    $row['content'] = file_get_contents($path);
                }
            } else {
                if ($GLOBALS['CMDLINE']) {
                    echo date('r').': GetFileContent Requested file is offloaded, fetching from '.$path."\n";
                }
                $row['content'] = file_get_contents($path);
            }
            if ($row['gz'] == 'y') {
                $b = strlen($row['content']);
                $row['content'] = gzinflate($row['content']);
                $a = strlen($row['content']);
            }

            if ($row['content'] == '' && GetSetting('DevelopmentOrProduction') != 'Development') {
                log_msg('ERROR: Searched for offloaded file '.$path." but couldn't find it or it was empty");
            }
        } elseif ($row['gz'] == 'y') {
            qlog(INFO, 'GetFileContent Requested file is compressed, uncompressing');
            $b = strlen($row['content']);
            $row['content'] = gzinflate($row['content']);
            $a = strlen($row['content']);
            qlog(INFO, 'GetFileContent Filesize was '.$b.', is now '.$a);
        }

        qlog(INFO, 'Returning file of '.strlen($row['content']).' bytes');

        return $row['content'];
    } else {
        return false;
    }
}
function GetTemplateSubject($templateid)
{
    if (CheckTemplateAccess($templateid) == 'ok') {
        return db_GetValue('SELECT template_subject FROM CRMtemplates WHERE templateid='.$templateid);
    } else {
        return false;
    }
}
function GetClearanceLevel($userid = false, $group = false)
{
    if (!$userid) {
        $userid = $GLOBALS['USERID'];
    }
    $ret = '';

    if ($userid > 0 || $group > 0) {
        $acr = '';
        $bcr = '';
        if (!$group > 0) {
            $row = db_GetRow("SELECT * FROM CRMloginusers WHERE id='".mres($userid)."'");
            $acr = unserialize($row['CLLEVEL']);
            $bcr = $row['PROFILE'];
        } else {
            $bcr = $group;
        }

        if (is_numeric($bcr)) {
            $row = GetProfileArray($bcr);

            $ccr = unserialize($row['CLLEVEL']);
            qlog(INFO, 'Clearance level override by profile in effect. ('.$userid.': '.$acr.', profile: '.$bcr.')');
            if (is_administrator($acr)) {
                qlog(INFO, 'This is an administrator with a profile! (regarding group setting)');
            } else {
                $acr = $ccr;
            }
            $ret = $acr;
        } else {
            qlog(INFO, 'No profile override...');
            $ret = $acr;
        }

        if (!$group) {
            $GLOBALS['PageCache']['CLLEVELS'][$userid] = $acr;

            //	print "SET CACHE";
        }
        qlog(INFO, 'GetClearanceLevel '.$userid.' '.$acr.' '.$GLOBALS['PageCache']['CLLEVELS'][$userid]);
    } else {
        $ret = '[unknown]';
        qlog(INFO, 'Function called with empty userid param!');
    }

    return $ret;
}
function is_administrator($userid = false)
{
    $response = false;

    if (!$userid) {
        $userid = $GLOBALS['USERID'];
    }

    if (isset($GLOBALS['PageCache']['ADMINARRAY'][$userid])) {
        $response = $GLOBALS['PageCache']['ADMINARRAY'][$userid];
    } else {

        // Caching all users makes no sense here, it's hardly ever queried
        $weigh = db_GetRow("SELECT administrator, CLLEVEL FROM CRMloginusers WHERE id='".mres($userid)."'");

        $cllevel = unserialize($weigh['CLLEVEL']);

        if ($weigh['administrator'] == 'yes') {
            $response = true;
        }

        if (@in_array('OnlyDevelopmentAdmin', $cllevel)) {
            if (GetSetting('DevelopmentOrProduction') != 'Development') {
                $response = false;
            } else {
                $response = true;
            }
        }

        $GLOBALS['PageCache']['ADMINARRAY'][$userid] = $response;
    }

    return $response;
}
function EndSession()
{
    if (!$GLOBALS['SesMemDontCommit']) {
        $cur = unserialize(db_GetValue("SELECT sessioncache FROM CRMsessions WHERE temp='".mres($GLOBALS['sessionid'])."'"));
        if ($cur != $GLOBALS['SesMem']) {
            mcq("UPDATE CRMsessions SET sessioncache='".mres(serialize($GLOBALS['SesMem']))."' WHERE temp='".mres($GLOBALS['sessionid'])."'");
        }
    }
}
function EndHTML($print = true)
{
    global $lang;
    static $ItHasEnded;

    if (GetSetting('DevelopmentOrProduction') != 'Production' || is_administrator()) {
        if ($print && $GLOBALS['SesMem']['ShowReasons'] && ($GLOBALS['AccessDeniedReason'] != '' || count($GLOBALS['DECISIONTRACE']) > 0)) {
            echo "<pre>Reasons:\n\n";
            echo $GLOBALS['AccessDeniedReason']."\n\n";
            foreach ($GLOBALS['DECISIONTRACE'] as $line) {
                echo '---&gt; '.$line."\n";
            }
            echo '</pre>';
        }
    }

    if ($ItHasEnded) {
        if ($print) {
            echo '<h1>Warning: EndHTML called twice!</h1>';
        }

        return false;
    }

    $ItHasEnded = true;

    if ($print && $GLOBALS['sessionid'] != '') {
        ProcessOldTodos();
    }

    if ($print) {
        EndSession();
    }

    if ($GLOBALS['logrequests']) {
        @$fp = fopen('querylog.txt', 'a');
        @fputs($fp, $GLOBALS['USERNAME'].':'.$_SERVER['SCRIPT_NAME'].' '.$_SERVER['QUERY_STRING'].' id: '.$GLOBALS['page_id']." DONE\n");
        @fclose($fp);
    }

    if ($print) {
        if (!$GLOBALS['webapp']) {
            echo '</div>'; //  <!-- close MainContent -->'; // Close MainContent div
        }

        if (is_array($GLOBALS['JavascriptToPrintAtEndOfPage'])) {
            foreach ($GLOBALS['JavascriptToPrintAtEndOfPage'] as $ajaxBoxElement) {
                echo $ajaxBoxElement;
            }
        }
    //    print 'jaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa';
        //DA($GLOBALS['JavascriptToPrintAtEndOfPage_OnlyJS'], false);

    if (is_array($GLOBALS['JavascriptToPrintAtEndOfPage_OnlyJS'])) {
        echo '<script type="text/javascript">';
        echo '$(document).ready(function() {';
        foreach ($GLOBALS['JavascriptToPrintAtEndOfPage_OnlyJS'] as $ajaxBoxElement) {
            echo $ajaxBoxElement;
        }
        echo '});';
        echo '</script>';
    }

        if ((is_positive_integer_or_zero($_REQUEST['toX'])) && (is_positive_integer_or_zero($_REQUEST['toY']))) {
            echo JS('window.scrollTo('.$_REQUEST['toX'].','.$_REQUEST['toY'].')');
        }

        //		print "<!-- This is the end of the page. -->\n";
    }

    if (is_array($GLOBALS['DECISIONTRACE']) && $GLOBALS['logtext'] && $print) {
        foreach ($GLOBALS['DECISIONTRACE'] as $line) {
            echo '<!-- '.$line." -->\n";
        }
    }

    LogPageInfo();

    if (is_administrator() && $GLOBALS['USERID'] && $print && strtolower(GetAttribute('user', 'PageLog', $GLOBALS['USERID'])) == 'yes') {
        if (trim($GLOBALS['tracelog']) != '') {
            $logstasher = PushStashValue($GLOBALS['tracelog']); ?>
					<script type="text/javascript">
						poplittleLogwindowWithBars('admin.php?qlog=1&logstash=<?php
            echo $logstasher; ?>');
					</script>
				<?php

        }
    } else {
        //print "nl: " .  GetAttribute("user", "PageLog", $GLOBALS['USERID']);
    }

    if ($GLOBALS['LogoutOnPageEnd']) {
        SetAttribute('user', 'LastLogout', date('U'), $GLOBALS['USERID']);
        //jh 2015-12-02 sessionid cookie is niet te unsetten want er is al output gestuurd
        log_msg('Logoff '.$GLOBALS['USERNAME']);
        $sql = "DELETE FROM CRMsessions WHERE temp='".mres($GLOBALS['sessionid'])."'";
        mcq($sql);
    }
    if ($GLOBALS['starttime'] && ((is_administrator()) && (GetAttribute('user', 'OnlineEditMode-ShowInlineLinks', $GLOBALS['USERID']) == 'Yes')) && $print) {
        $time_in_seconds = microtime_float() - $GLOBALS['starttime'];
        echo 'Serve time: '.$time_in_seconds.' s';
    }

    if ($print) {
        if ($GLOBALS['qlog_onscreen'] && is_administrator()) {
            echo '<pre>'.htme($GLOBALS['tracelog']).'</pre>';
        }
        echo '</body></html>';
    }
    /* journal messages are stored in memory and inserted in 1 go */
    commit_journal();
    db_CloseConnection();
}
function CheckFunctionAccess($privilege, $userid = '')
{
    if ($userid == '') {
        $userid = $GLOBALS['USERID'];
    }
    if (is_administrator() && $privilege != 'requiretpa') {
        return 'admin';
    }
    $cl = GetClearanceLevel($userid);
    $ret = '';
    if (in_array($privilege, $cl)) {
        $ret = 'ok';
    } else {
        $ret = 'nok';
    }
    qlog(INFO, 'Access to privilege '.$privilege.': '.$ret);

    return $ret;
}

function RealExcel($excel, $CSVseparator, $filename = '')
{
    // HANDLES CSV OUTPUT SEPARATED BY @@@REALEXCEL@@@@ ASSUMES FIRST LINE IS LEGEND
    // $WrappedCellsEachLine must contain array with horiz. fields list (numbers) of cells
    // that must be wrapped
    if (GetSetting('EXCELFILEFORMAT') != '2003') {
        qlog(INFO, 'Going to 2007 mode..');
        require 'excel2007.php';
        //require ("phpspreadsheet.php");
        RealExcel2007($excel, $CSVseparator, 'xlsx', '', $filename);
    } else {
        require_once 'lib/excel2003/Writer.php';
        //print($GLOBALS['PATHTOINTERLEAVE'] . 'lib/Writer.php');
        $filename = str_replace(' ', '_', GetSetting('title')).'-'.$GLOBALS['PRODUCT'].'-export-'.date('m-j-Y-Hi').'h.xls';
        $summ = $GLOBALS['PRODUCT'].'-export';
        // Creating a workbook
        $workbook = new Spreadsheet_Excel_Writer();
        // sending HTTP headers
        $workbook->send($filename);
        // Creating a worksheet
        $worksheet = &$workbook->addWorksheet($summ);
        $worksheet->setLandscape();
        $worksheet->setHeader($summ);
        $format_normal = &$workbook->addFormat();
        $format_normal->setSize(9);
        //s	$format_normal -> setBorder(1);
        $format_bold = &$workbook->addFormat();
        $format_bold->setBold();
        $format_bold->setColor('white');
        $format_bold->setPattern(1);
        $format_bold->setFgColor('blue');
        $format_bold->setSize(9);
        //	$format_bold -> setBorder(1);
        $format_wrapped = &$workbook->addFormat();
        $format_wrapped->setTextWrap();
        $format_wrapped->setSize(9);
        //	$format_wrapped -> setBorder(1);
        $format_rowheader = &$workbook->addFormat();
        $format_rowheader->setBold();
        $format_rowheader->setFgColor('gray');
        $format_rowheader->setSize(9);
        //	$format_rowheader -> setBorder(1);
        $line = 0;
        $max_col_width = array();
        // Create header in format_bold
        $header = array();
        if ($CSVseparator != 'array') {
            $header = explode($CSVseparator, $excel[0]);
        } else {
            $header = $excel[0];
        }
        for ($i = 0; $i < sizeof($header); ++$i) {
            $worksheet->write(0, $i, $header[$i], $format_bold);
            $max_col_width[$i] = strlen($header[$i]);
        }
        $linecount = 1;
        for ($i = 1; $i < sizeof($excel); ++$i) {
            if ($CSVseparator != 'array') {
                $line = explode($CSVseparator, $excel[$i]); // get current line and array' it
            } else {
                $line = $excel[$i];
                $line[] = '';
            }

            for ($u = 0; $u < sizeof($line); ++$u) {
                if ($line[$u]) {
                    if ($u == 0) {
                        if (is_numeric($line[$u])) {
                            $worksheet->writeNumber($linecount, $u, $line[$u], $format_rowheader);
                            // qlog(INFO, "CHOOSE 1NUM for val " . $line[$u]);
                        } else {
                            $worksheet->writeString($linecount, $u, $line[$u], $format_rowheader);
                            // qlog(INFO, "CHOOSE 1STR for val " . $line[$u]);
                        }
                    } elseif (stristr($line[$u], '@@@@WRAPPED@@@@')) {
                        $line[$u] = str_replace('@@@@WRAPPED@@@@', '', $line[$u]);
                        if (substr($line[$u], 0, 1) == '@') {
                            $line[$u] = "'".$line[$u];
                        }

                        if (is_numeric($line[$u])) {
                            $worksheet->writeNumber($linecount, $u, $line[$u], $format_wrapped);
                            // qlog(INFO, "CHOOSE 2NUM for val " . $line[$u]);
                        } else {
                            $worksheet->writeString($linecount, $u, $line[$u], $format_wrapped);
                            // qlog(INFO, "CHOOSE 2STR for val " . $line[$u]);
                        }
                    } elseif (stristr($line[$u], '@@@@HEXCOLOR')) {
                        $tmp = explode('@@@@HEXCOLOR', $line[$u]);

                        $hex = ltrim($tmp[1], '#');
                        $tmpvar = 'format_'.$hex;

                        if (!$$tmpvar) {
                            $$tmpvar = &$workbook->addFormat();
                        }
                        $ExcelColor = GetExcelColorName($hex);
                        $$tmpvar->setSize(9);
                        $$tmpvar->setBorder(1);
                        $$tmpvar->setFgColor($ExcelColor);
                        if (substr($line[$u], 0, 1) == '@') {
                            $line[$u] = "'".$line[$u];
                        }
                        if (is_numeric($tmp[2])) {
                            $worksheet->writeNumber($linecount, $u, $tmp[2], $$tmpvar);
                            // qlog(INFO, "CHOOSE 3NUM for val " . $tmp[2]);
                        } else {
                            $worksheet->writeString($linecount, $u, $tmp[2], $$tmpvar);
                            // qlog(INFO, "CHOOSE 3STR for val " . $tmp[2]);
                        }
                    } else {
                        if (substr($line[$u], 0, 1) == '@') {
                            $line[$u] = "'".$line[$u];
                        }
                        if (is_numeric($line[$u])) {
                            $worksheet->writeNumber($linecount, $u, $line[$u], $format_normal);
                            // qlog(INFO, "CHOOSE 4NUM for val " . $line[$u]);
                        } else {
                            $worksheet->writeString($linecount, $u, $line[$u], $format_normal);
                            // qlog(INFO, "CHOOSE 4STR for val " . $line[$u]);
                        }
                    }
                    if ($max_col_width[$u] < strlen($header[$u])) {
                        $max_col_width[$u] = strlen($header[$u]);
                    }
                }
            }
            ++$linecount;
        }

        // Now adjust the cell width
        for ($i = 0; $i < sizeof($max_col_width); ++$i) {
            if ($max_col_width[$i]) {
                $worksheet->setColumn($i, $i, ($max_col_width[$i] * 2));
            }
        }
        // Let's send the file
        $workbook->close();
    }
}
function GetExcelColorName($hex)
{
    // array met excel kleuren
    $color = array();
    array_push($color, array('00', '00', '00', 8)); // 8
    array_push($color, array('ff', 'ff', 'ff', 9)); // 9
    array_push($color, array('ff', '00', '00', 10)); // 10
    array_push($color, array('00', 'ff', '00', 11)); // 11
    array_push($color, array('00', '00', 'ff', 12)); // 12
    array_push($color, array('ff', 'ff', '00', 13)); // 13
    array_push($color, array('ff', '00', 'ff', 14)); // 14
    array_push($color, array('00', 'ff', 'ff', 15)); // 15
    array_push($color, array('80', '00', '00', 16)); // 16
    array_push($color, array('00', '80', '00', 17)); // 17
    array_push($color, array('00', '00', '80', 18)); // 18
    array_push($color, array('80', '80', '00', 19)); // 19
    array_push($color, array('80', '00', '80', 20)); // 20
    array_push($color, array('00', '80', '80', 21)); // 21
    array_push($color, array('c0', 'c0', 'c0', 22)); // 22
    array_push($color, array('80', '80', '80', 23)); // 23
    array_push($color, array('99', '99', 'ff', 24)); // 24
    array_push($color, array('99', '33', '66', 25)); // 25
    array_push($color, array('ff', 'ff', 'cc', 26)); // 26
    array_push($color, array('cc', 'ff', 'ff', 27)); // 27
    array_push($color, array('66', '00', '66', 28)); // 28
    array_push($color, array('ff', '80', '80', 29)); // 29
    array_push($color, array('00', '66', 'cc', 30)); // 30
    array_push($color, array('cc', 'cc', 'ff', 31)); // 31
    array_push($color, array('00', '00', '80', 32)); // 32
    array_push($color, array('ff', '00', 'ff', 33)); // 33
    array_push($color, array('ff', 'ff', '00', 34)); // 34
    array_push($color, array('00', 'ff', 'ff', 35)); // 35
    array_push($color, array('80', '00', '80', 36)); // 36
    array_push($color, array('80', '00', '00', 37)); // 37
    array_push($color, array('00', '80', '80', 38)); // 38
    array_push($color, array('00', '00', 'ff', 39)); // 39
    array_push($color, array('00', 'cc', 'ff', 40)); // 40
    array_push($color, array('cc', 'ff', 'ff', 41)); // 41
    array_push($color, array('cc', 'ff', 'cc', 42)); // 42
    array_push($color, array('ff', 'ff', '99', 43)); // 43
    array_push($color, array('99', 'cc', 'ff', 44)); // 44
    array_push($color, array('ff', '99', 'cc', 45)); // 45
    array_push($color, array('cc', '99', 'ff', 46)); // 46
    array_push($color, array('ff', 'cc', '99', 47)); // 47
    array_push($color, array('33', '66', 'ff', 48)); // 48
    array_push($color, array('33', 'cc', 'cc', 49)); // 49
    array_push($color, array('99', 'cc', '00', 50)); // 50
    array_push($color, array('ff', 'cc', '00', 51)); // 51
    array_push($color, array('ff', '99', '00', 52)); // 52
    array_push($color, array('ff', '66', '00', 53)); // 53
    array_push($color, array('66', '66', '99', 54)); // 54
    array_push($color, array('96', '96', '96', 55)); // 55
    array_push($color, array('00', '33', '66', 56)); // 56
    array_push($color, array('33', '99', '66', 57)); // 57
    array_push($color, array('00', '33', '00', 58)); // 58
    array_push($color, array('33', '33', '00', 59)); // 59
    array_push($color, array('99', '33', '00', 60)); // 60
    array_push($color, array('99', '33', '66', 61)); // 61
    array_push($color, array('33', '33', '99', 62)); // 62
    array_push($color, array('33', '33', '33', 63)); // 63
    $ir = hexdec(substr($hex, 0, 2));
    $ig = hexdec(substr($hex, 2, 2));
    $ib = hexdec(substr($hex, 4, 2));
    $currnaast = 255 * 255 * 255; // max wat naast is
    $currkleurnaam = 'fout!';
    for ($i = 0; $i < sizeof($color); ++$i) {
        $r = $color[$i][0];
        $g = $color[$i][1];
        $b = $color[$i][2];
        $kleurnaam = $color[$i][3];
        $tmpnaast = (abs($ir - hexdec($r)) + abs($ig - hexdec($g)) + abs($ib - hexdec($b)));
        if ($tmpnaast < $currnaast) {
            $currkleurnaam = $kleurnaam;
            $currnaast = $tmpnaast;
        }
    }

    return $currkleurnaam;
}
function MustBeAdmin()
{
    if (!is_administrator($GLOBALS['USERID'])) {
        PrintAdminError();
        EndHTML();
        exit;
        // Yes, i know this is dirty.
    }
}
function PrintAdminError()
{
    PrintAD('You do not have the required clearance level to access this page/function.');
}
function fillout($var, $len, $nofill = false)
{
    if (strlen($var) >= $len) {
        return substr($var, 0, ($len - 3)).'...';
    } elseif (!$nofill) {
        return str_pad($var, $len, ' ');
    } else {
        return $var;
    }
}
function FormattedDateToNLDate($date)
{
    if (strlen($date) == 10) {
        $dates = explode('-', $date);
        $d = '';
        $m = '';
        $y = '';
        if ($GLOBALS['UC']['DateFormat'] == 'dd-mm-yyyy') {
            $d = $dates[0];
            $m = $dates[1];
            $y = $dates[2];
        } elseif ($GLOBALS['UC']['DateFormat'] == 'mm-dd-yyyy') {
            $d = $dates[1];
            $m = $dates[0];
            $y = $dates[2];
        } elseif ($GLOBALS['UC']['DateFormat'] == 'yyyy-mm-dd') {
            $d = $dates[2];
            $m = $dates[1];
            $y = $dates[0];
        }

        return $d.'-'.$m.'-'.$y;
    }
}
function StrDateTime2IsoDateTime($strdatetime)
{
    $strdatetime = trim($strdatetime);
    //meerdere spaties naar 1 spatie
    $strdatetime = preg_replace('/  +/', ' ', $strdatetime);

    $parts = explode(' ', $strdatetime);
    $strdate = '';
    $strtime = '';
    //zodat "10 5 14 23:55" ingevoegd kan worden; de spatie is ook een datum separator
    if (count($parts) == 4) {
        $strtime = array_pop($parts);
        $strdate = implode(' ', $parts);
    } else {
        $strdate = $parts[0];
        $strtime = $parts[1];
    }

    $isodate = StrDate2IsoDate($strdate);
    $isotime = '';

    //een lege tijd wordt geaccepteerd
    if ($strtime == '') {
        $isotime = '00:00:00';
    }
    //er kan alleen een 24 uur klok worden ingevoerd; geen support voor am/pm
    //support voor : als separator, of niks ""
    //er kan worden ingevoerd MET secondes of ZONDER secondes
    //2:03 -> 02:03:00
    //1:05:00 -> 01:05:00
    //24:0 -> "" FOUT
    //930 -> 09:30:00
    //000002:000000000:00000000019 -> "" FOUT
    elseif (preg_match("/^(\d{1,2})\:?(\d{2})(\:?(\d{2}))?$/", $strtime, $matches)) {
        $hour = $matches[1];
        $minute = $matches[2];
        $second = $matches[4];

        //seconde moet eigenlijk <= 60 zijn ivm mogelijke schrikkelsecondes
        if (($hour <= 23) && ($minute <= 59) && ($second <= 59)) {
            $isotime = sprintf('%02d:%02d:%02d', $hour, $minute, $second);
        }
    }

    $isodatetime = '';
    if (($isodate != '') && ($isotime != '')) {
        $isodatetime .= $isodate.' '.$isotime;
    }

    return $isodatetime;
}
function StrDate2IsoDate($strdate)
{
    $strdate = trim($strdate);
    $accept_2_digit_year = true;

    $dateparts = array();

    $dateformat = array();
    if ($GLOBALS['UC']['DateFormat'] == 'yyyy-mm-dd') {
        $dateformat = array('y', 'm', 'd');
    } elseif ($GLOBALS['UC']['DateFormat'] == 'mm-dd-yyyy') {
        $dateformat = array('m', 'd', 'y');
    } else {
        //dd-mm-yyyy
        $dateformat = array('d', 'm', 'y');
    }

    /*
    01-05-2014 = 2014-05-01
    01052014   = 2014-05-01
    1-5-2014   = 2014-05-01
    010514     = 2014-05-01
    1/5/14     = 2014-05-01
    1.5.2014   = 2014-05-01
    28/07/1949 = 1949-07-28
    1214       = 2014-02-01
    01022014   = 2014-02-01
    010214     = 2014-02-01
    4 8 21     = 1921-08-04
    9 12 20    = 2020-12-09
    */

    foreach (array('-', '/', '.', ' ', '') as $separator) {
        $regexp = '/^';
        $partcounter = 0;
        foreach ($dateformat as $dateformatpart) {
            if ($partcounter > 0) {
                $regexp .= preg_quote($separator, '/');
            }
            if ($dateformatpart == 'y') {
                //jaar: 2 of 4 cijfers
                if ($accept_2_digit_year) {
                    $regexp .= "(\d{2}(\d{2})?)";
                } else {
                    $regexp .= "(\d{4})";
                }
            } else {
                //dag of maand; 1 of 2 cijfers
                $regexp .= "(\d{1,2})";
            }
            ++$partcounter;
        }
        $regexp .= '$/';

        if (preg_match($regexp, $strdate, $match)) {
            $partcounter = 0;
            foreach ($dateformat as $dateformatpart) {
                ++$partcounter;
                $dateparts[$dateformatpart] = $match[$partcounter];
                if (($accept_2_digit_year) && ($dateformatpart == 'y')) {
                    //because of extra nested ( ) condition in regexp
                    ++$partcounter;
                    //2 digit year
                    if ($dateparts[$dateformatpart] < 100) {
                        //Y2K bug fix; assuming 1921 to 2020
                        if ($dateparts[$dateformatpart] > 20) {
                            $dateparts[$dateformatpart] += 1900;
                        } else {
                            $dateparts[$dateformatpart] += 2000;
                        }
                    }
                }
            }
            break;
        }
    }

    $isodate = '';
    if (checkdate($dateparts['m'], $dateparts['d'], $dateparts['y'])) {
        $isodate = sprintf('%04d-%02d-%02d', $dateparts['y'], $dateparts['m'], $dateparts['d']);
    }

    return $isodate;
}
function SQLDateTimeToFormattedDateTime($datetime)
{
    $ret = '';
    if ($datetime != '') {
        $valAr = array();
        $valAr[0] = substr($datetime, 0, 10);
        $valAr[1] = substr($datetime, 11, 5);

        $valAr[0] = TransformDate(INTLDate2NLDate($valAr[0]));
        $valAr[1] = TransformTime($valAr[1]);

        $ret = $valAr[0].' '.$valAr[1];
    }

    return $ret;
}
function IsFormattedDate($date = false)
{
    // $date is in format dd-mm-yyyy
    if (strlen($date) != 10) {
        return false;
    }

    $dates = explode('-', $date);
    $d = '';
    $m = '';
    $y = '';

    if ($GLOBALS['UC']['DateFormat'] == 'dd-mm-yyyy') {
        $d = $dates[0];
        $m = $dates[1];
        $y = $dates[2];
    } elseif ($GLOBALS['UC']['DateFormat'] == 'mm-dd-yyyy') {
        $d = $dates[1];
        $m = $dates[0];
        $y = $dates[2];
    } elseif ($GLOBALS['UC']['DateFormat'] == 'yyyy-mm-dd') {
        $d = $dates[2];
        $m = $dates[1];
        $y = $dates[0];
    }
    // bool checkdate ( int month, int day, int year)
    if (@checkdate($m, $d, $y)) {
        return true;
    } else {
        return false;
    }
}
function randomstring($length, $humanreadable = false)
{
    $randomstring = '';
    $randomchars = array();
    if ($humanreadable) {
        //geen cijfers
        //$randomchars = array("a", "b", "c", "d", "e", "f", "g", "h", "i", "j", "k", "l", "m", "n", "o", "p", "q", "r", "s", "t", "u", "v", "w", "x", "y", "z", "A", "B", "C", "D", "E", "F", "G", "H", "I", "J", "K", "L", "M", "N", "O", "P", "Q", "R", "S", "T", "U", "V", "W", "X", "Y", "Z");

        //zonder "0", "1", "2", "a", "e", "i", "l", "o", "u", "y", "z" -> die chars kunnen verwarring geven OF kunnen woorden vormen (alle klinkers zijn eruit)
        //specifiek bedoeld voor het maken van wachtwoorden
        $randomchars = array('3', '4', '5', '6', '7', '8', '9', 'b', 'c', 'd', 'f', 'g', 'h', 'j', 'k', 'm', 'n', 'p', 'q', 'r', 's', 't', 'v', 'w', 'x', 'B', 'C', 'D', 'F', 'G', 'H', 'J', 'K', 'M', 'N', 'P', 'Q', 'R', 'S', 'T', 'V', 'W', 'X');
    } else {
        // volledige alfabet (zowel upper als lowercase); 62 karakters
        $randomchars = array('0', '1', '2', '3', '4', '5', '6', '7', '8', '9', 'a', 'b', 'c', 'd', 'e', 'f', 'g', 'h', 'i', 'j', 'k', 'l', 'm', 'n', 'o', 'p', 'q', 'r', 's', 't', 'u', 'v', 'w', 'x', 'y', 'z', 'A', 'B', 'C', 'D', 'E', 'F', 'G', 'H', 'I', 'J', 'K', 'L', 'M', 'N', 'O', 'P', 'Q', 'R', 'S', 'T', 'U', 'V', 'W', 'X', 'Y', 'Z');
    }
    // alleen hexadecimale karakters; slechts 16 karakters en dus een stuk minder goed beveiligd
    // $randomchars = array("0", "1", "2", "3", "4", "5", "6", "7", "8", "9", "a", "b", "c", "d", "e", "f");
    $maxpos = count($randomchars) - 1;
    for ($x = 0; $x < $length; ++$x) {
        $randomstring .= $randomchars[mt_rand(0, $maxpos) ];
    }

    return $randomstring;
}
function readln()
{
    // 4092 max on win32 fopen
    //$fp=fopen("php://stdin", "r");
    //$in=fgets($fp,4094);
    //fclose($fp);
    $in = fgets(STDIN);

    // strip newline
    (PHP_OS == 'WINNT') ? ($read = str_replace("\r\n", '', $in)) : ($read = str_replace("\n", '', $in));

    return $read;
}
function Author()
{
    require_once $GLOBALS['PATHTOINTERLEAVE'].'ath.php';
    exit;
}
function PushStashValue($value)
{
    // This function puts a stash (cache) value into the database and returns the reference number
    qlog(INFO, 'Start pushing stash value '.$id);
    if (is_array($value)) {
        $value = serialize($value);
    }

    if (strlen($value) > 0) {
        $epoch = date('U');
        $sql = "INSERT INTO CRMcache(value,epoch,session) VALUES('".mres($value)."','".mres($epoch)."', '".mres($GLOBALS['sessionid'])."')";
        mcq($sql);
        $id = db_GetInsertId();
        qlog(INFO, 'Pushed stash value '.$id);
    } else {
        qlog(ERROR, 'ERROR - cannot push empty variable!');
        $id = '';
    }

    return $id;
}
function PopStashValue($stashid)
{
    // This function retreives a stash (cache) value from the database and returns the contents of the record
    $val = db_GetValue("SELECT value FROM CRMcache WHERE stashid='".mres($stashid)."' AND session='".mres($GLOBALS['sessionid'])."'");

    qlog(INFO, 'Popped stash value '.$stashid);
    $ar = unserialize($val);
    if (is_array($ar)) {
        $val = $ar;
    }

    return $val;
}

function UpdateStashValue($stashid, $value)
{
    // This function deletes a stash (cache) value from the database
    if (is_array($value)) {
        $value = serialize($value);
    }
    $epoch = date('U');
    $sql = "UPDATE CRMcache SET value='".mres($value)."',epoch='".$epoch."' WHERE stashid='".mres($stashid)."' AND session='".mres($GLOBALS['sessionid'])."'";
    mcq($sql);
    qlog(INFO, 'Updated stash value '.$stashid);

    return true;
}
function GetBackTrace($args = true)
{
    ob_start();
    if ($args) {
        debug_print_backtrace();
    } else {
        debug_print_backtrace(DEBUG_BACKTRACE_IGNORE_ARGS);
    }
    $ret = ob_get_contents();
    ob_end_clean();
    //2016-02-11
    //return "\n\n" . $ret;
    return $ret;
}
function pdf($imp)
{
    //jh 2016-05-27 deze kan 80% zeker weg
    // LEAVE IN PLACE
//deze warning erin gezet op 2016-12-21; als we 2017-01-31 nog geen warnings hebben gehad dan kan de functie weg
log_msg('ERROR: function pdf() called! remove this call');

    return $imp;
}
function plain($imp)
{
    //jh 2016-05-27 deze kan 99% zeker weg
    // LEAVE IN PLACE
//deze warning erin gezet op 2016-12-21; als we 2017-01-31 nog geen warnings hebben gehad dan kan de functie weg
log_msg('ERROR: function plain() called! remove this call');

    return $imp;
}

function ParseInlineAddFormTags($template)
{
    // Fetch all tags from template
    // Syntax: #INLINEADD|table=tX|template=Y|t12-f56=XX|reload_on_submit=|open_after_add=1|0#
    preg_match_all('/\#INLINEADD(.*?)\#/', $template, $matches);
    foreach ($matches[0] as $listoptions_string) {
        $table_id = '';
        $template_id = '';
        $submitbuttontext = '';
        $listtoreloadaftersubmit = '';
        $open_after_add = '';

        // Strip tag open name
        $clean = str_replace('#INLINEADD', '', $listoptions_string);

        // Stip closing #
        $clean = substr($clean, 0, strlen($clean) - 1);

        // Tag directives are seperated by |'s
        $ar = explode('|', $clean);

        $tagvals = array();

        foreach ($ar as $argument) {

            // Key/value pairs are seperated by ='s
            list($key, $val) = explode('=', $argument);

            if ($key == 'table') {
                $table_id = $val;
            } elseif ($key == 'template') {
                $template_id = $val;
            } elseif ($key == 'submitbuttontext') {
                $submitbuttontext = $val;
            } elseif ($key == 'reload_on_submit') {
                $listtoreloadaftersubmit = $val;
            } elseif ($key == 'open_after_add') {
                $open_after_add = $val;
            }

            $tagvals[$key] = $val;
        }
        //$outerdiv = "rnd" . randomstring(8);
        $tagvals['outerdiv'] = $table_id.'-_new_';

        $template = str_replace($listoptions_string, '<div id="'.$tagvals['outerdiv'].'">'.escape_interleave_characters(InlineSimpleAddForm($table_id, $template_id, $submitbuttontext, $tagvals, $listtoreloadaftersubmit, '', $open_after_add)).'</div>', $template);
    }

    return $template;
}
function get_list_options_and_descriptions()
{
    return array(

    'outputtype' => array('Description' => 'The output type', 'Valid' => array('table', 'tile'), 'Default' => 'table'),

    'RemoveExtraSelectCondition' => array('Description' => 'When set removes the Extra Select Condition', 'Valid' => array(true, false), 'Default' => false),

    'disable_click_record_to_open' => array('Description' => 'When set, clicking a row in the table will do nothing', 'Valid' => array(true, false), 'Default' => false),

    'filter' => array('Description' => 'Filters to set', 'Valid' => '', 'Example' => 'filter_t12-f34=Yes', 'Default' => ''),

    'filtertype' => array('Description' => 'The type of the filter', 'Valid' => array('IS', 'NOT'), 'Default' => ''),

    'hiddenfilter' => array('Description' => 'Hidden filters to set. Hidden filters cannot be disabled by users.', 'Valid' => '', 'Example' => 'hiddenfilter_t12-f34=Yes', 'Default' => ''),

    'hiddenfiltertype' => array('Description' => 'The hidden filter type', 'Valid' => array('IS', 'NOT'), 'Default' => ''),

    'hide_add_up_total' => array('Description' => 'When true, the column add-up will not be shown.', 'Valid' => array(true, false), 'Default' => false),

    'hide_addlink' => array('Description' => 'When true, the add-a-record link will not be shown', 'Valid' => array(true, false), 'Default' => false),

    'hide_addrow' => array('Description' => 'When false, the first row of a table will be a form to add a record', 'Valid' => array(true, false), 'Default' => true),

    'hide_all' => array('Description' => 'When set, hides everything there is to hide except the table itself', 'Valid' => array(true, false), 'Default' => false),

    'hide_bottom_pagination' => array('Description' => 'When set, the bottom prev/next arrow and page selector will not be shown', 'Valid' => array(true, false), 'Default' => false),

    'hide_filters' => array('Description' => 'When set, column filters will not be shown', 'Valid' => array(true, false), 'Default' => false),

    'hide_header' => array('Description' => 'When set, the table title header and html as set on the table preference page will not be shown', 'Valid' => array(true, false), 'Default' => false),

    'customheader' => array('Description' => 'Overrules default header', 'Valid' => '', 'Default' => ''),

    'hide_human_readable_filter' => array('Description' => 'When set, the human-readable filters will not be shown', 'Valid' => array(true, false), 'Default' => false),

    'hide_id_input' => array('Description' => 'When set, the input field used to open a record by entering its id will not be shown', 'Valid' => array(true, false), 'Default' => false),

    'id_input_in_search' => array('Description' => 'Uses search box for recordid input, when 123 is a valid record, it is opened, otherwise it is searched for. to search for a literal number, use quotes; "123"', 'Valid' => array(true, false), 'Default' => false),

    'hide_listlayout' => array('Description' => 'When set, select-columns icon will not be shown', 'Valid' => array(true, false), 'Default' => false),

    'hide_listlayoutselector' => array('Description' => 'When set, the list-layout-selector will not be shown', 'Valid' => array(true, false), 'Default' => false),

    'hide_modules' => array('Description' => 'When set, icons to run modules will not be shown', 'Valid' => array(true, false), 'Default' => false),

    'hide_must_be_must_not_be_filter' => array('Description' => "When set, users won't have the options MUST BE and MUST NOT BE in the filters", 'Valid' => array(true, false), 'Default' => false),

    'hide_outputtype_excel' => array('Description' => 'When set, the excel-download icon will not be shown', 'Valid' => array(true, false), 'Default' => false),

    'hide_outputtype_table' => array('Description' => 'When set, the table view link will not be shown', 'Valid' => array(true, false), 'Default' => true),

    'hide_outputtype_tile' => array('Description' => 'When set, the tile view link will not be shown', 'Valid' => array(true, false), 'Default' => true),

    'hide_outputtype_tsv' => array('Description' => 'When set, the TSV-download icon will not be shown', 'Valid' => array(true, false), 'Default' => false),

    'hide_outputtype_xml' => array('Description' => 'When set, the XML-download icon will not be shown', 'Valid' => array(true, false), 'Default' => ''),

    'hide_pagination_if_only_1_page' => array('Description' => 'When set, page navigation elements will not be shown if the results fit on one page', 'Valid' => array(true, false), 'Default' => false),

    'hide_perpage' => array('Description' => 'When set, the number-of-results-to-show-per-page box will not be shown', 'Valid' => array(true, false), 'Default' => false),

    'hide_recent' => array('Description' => 'When set, the option to show the most recently accessed records will not be shown', 'Valid' => array(true, false), 'Default' => true),

    'hide_recordcounter' => array('Description' => 'When set, the total sum of found records and current page window count will not be shown', 'Valid' => array(true, false), 'Default' => false),

    'hide_search' => array('Description' => 'When set, the search-box will not be shown', 'Valid' => array(true, false), 'Default' => false),

    'hide_selections' => array('Description' => 'When set, the selections drop-down and create-selections items will not be shown', 'Valid' => array(true, false), 'Default' => false),

    'hide_sortby' => array('Description' => 'When set, sorting will not be possible (icons will be hidden and column name will not sort that column)', 'Valid' => array(true, false), 'Default' => false),

    'hide_inlinedelete' => array('Description' => 'Hides the in-list delete-me link', 'Valid' => array(true, false), 'Default' => false),

    'hide_inlineduplicate' => array('Description' => 'Hides the in-list duplicate-me link', 'Valid' => array(true, false), 'Default' => false),

    'listid' => array('Description' => 'The DOM id of the list (leave empty)', 'Valid' => '', 'Default' => ''),

    'listlayoutcolumns' => array('Description' => 'When given, these columns will be shown, any list layout will be ignored', 'Valid' => '', 'Example' => 't1-f12,t23-f34', 'Default' => ''),

    'listname' => array('Description' => 'The identifier for this list, mainly used for fetching the layout', 'Valid' => '', 'Example' => 'Any name', 'Default' => ''),

    'perpage' => array('Description' => 'The number of rows to show per page', 'Valid' => explode(',', GetSetting('PAGINATEOPTIONSLIST')), 'Default' => ''),

    'recent' => array('Description' => 'The number of recently opened records to show', 'Valid' => '', 'Example' => '50 (any number above zero)', 'Default' => ''),

    'sameresultandpage' => array('Description' => 'When set, the user will be brought back to EXACT the same place as last shown', 'Valid' => array(true, false), 'Default' => false),

    'search' => array('Description' => 'A search query', 'Valid' => '', 'Default' => ''),

    'search_highlight_only' => array('Description' => 'When set, all records will be shown, but records which match [search] will be highlighted (first column)', 'Valid' => array(true, false), 'Default' > false),

    'hiddensearch' => array('Description' => 'A search query (hidden)', 'Valid' => '', 'Default' => ''),

    'search_childs' => array('Description' => 'Whether or not to also descend to childs when searching', 'Valid' => array(true, false), 'Default' => true),

    'search_files' => array('Description' => 'Whether or not to also descend to attachments when searching', 'Valid' => array(true, false), 'Default' => true),

    'search_parents' => array('Description' => 'Whether or not to also ascend to parents when searching', 'Valid' => array(true, false), 'Default' => true),

    'searchperfield' => array('Description' => 'An array containing the searches per field', 'Valid' => '', 'Example' => 'searchperfield[t1-f2]=test', 'Default' => ''),

    'hiddensearchperfield' => array('Description' => 'An array containing the searches per field (hidden)', 'Valid' => '', 'Example' => 'hiddensearchperfield[t1-f2]=test', 'Default' => ''),

    'selectionnew' => array('Description' => 'The selection to load (visible)', 'Valid' => '', 'Example' => 'Any valid selection name', 'Default' => ''),

    'sortby' => array('Description' => 'The column to sort by', 'Valid' => '', 'Example' => 't12-f23', 'Default' => ''),

    'sortdirection' => array('Description' => 'The sort direction', 'Valid' => array('asc', 'desc'), 'Default' => 'asc'),

    'table' => array('Description' => 'The table to show', 'Valid' => '', 'Required' => true, 'Example' => 't12', 'Default' => ''),

    'tabletype' => array('Description' => 'Select-table or normal table', 'Valid' => array('normal', 'select', 'plain'), 'Default' => 'normal'),

    'start' => array('Description' => 'The record to start with', 'Valid' => '', 'Default' => ''),

    'type_of_list' => array('Description' => 'The list type', 'Valid' => array('mainlist', 'sublist'), 'Default' => 'mainlist'),

    'use_adaptive_filters' => array('Description' => 'When set, filter result counts will show the remaining number of matches and filters will only show values left in the current result set', 'Valid' => array(true, false), 'Default' => true),

    'ignorelastview' => array('Description' => 'When set, ignores last set filters, selection, search, etc.', 'Valid' => array(true, false), 'Default' => true),

    'BYAJAX' => array('Description' => 'When set, the first list will be loaded using ajax', 'Valid' => array(false, true), 'Default' => false),

    'hidetableheaderwhennoresults' => array('Description' => 'When set, the table column header will not be displayed when the result set contains 0 rows', 'Valid' => array(false, true), 'Default' => false),

    'hidetableheader' => array('Description' => 'When set, the table column header will not be displayed at all', 'Valid' => array(false, true), 'Default' => false),

    'hide_tablewhennoresults' => array('Description' => 'When set and if the record set contains zero records, the table will not be shown, the file browse box or add link will however still be shown', 'Valid' => array(false, true), 'Default' => false),

    'hide_massupdate' => array('Description' => 'When set, the massupdate checkboxes will not be shown', 'Valid' => array(false, true), 'Default' => false),

    'countonly' => array('Description' => 'When set, the function will only return a count', 'Valid' => array(false, true), 'Default' => false),

    'add_class_to_each_cell' => array('Description' => 'Adds class="fXXX" to each td, dt or dd. Useful for css styling of particular columns. Does cause quite a lot of extra html data.', 'Valid' => array(false, true), 'Default' => false),

    'disable_mobile_tile_view' => array('Description' => 'Disables the auto-swith to tile view', 'Valid' => array(false, true), 'Default' => false),

    'group' => array('Description' => 'Return multiple lists grouped by this field tX-fY', 'Valid' => '', 'Default' => ''),

    'hide_groupedcolumn' => array('Description' => 'Hides the grouped column', 'Valid' => array(false, true), 'Default' => true),

    'hide_empty_cells' => array('Description' => 'Hide empty <td></td>, default true for tile <dd></dd>. Sets hidetableheader to true. Do not use in conjunction with add_up_total. It is much better to use td:empty{display: none;} instead of this setting, however, this kind of css is not supported in the current version of mpdf', 'Valid' => array(false, true), 'Default' => false),

    'continuous_scroll' => array('Description' => 'Use continuous scrolling (=infinite scrolling) instead of pagination', 'Valid' => array(false, true), 'Default' => false),

    'template_id' => array('Description' => 'Template id to be used as parsed list output, only in combination with outputtype=template', 'Valid' => '', 'Default' => 0),

    'selectvia' => array('Description' => 'example: selectvia: t3-f33-f2-f22-t1-recordid t1 = companies, t2 = contactpersons, t3 = invoice. an invoice is linked to a contactperson of a company. With this selectvia we select a company first and then drilldown to choose a contactperson who works at the selected company', 'Valid' => '', 'Default' => ''),

    'selectviafilter' => array('Description' => 'selectvia filters; these are created automatically; no need to fill them manually', 'Valid' => '', 'Default' => ''),

    'childrecordid' => array('Description' => 'child record id only for selectvia lists', 'Valid' => '', 'Default' => 0),

    );
}
function ConvertTagOptionsToListOptions($listoptions_string)
{

    /* html encoded entities could exist in this template */
    $listoptions_string = html_entity_decode($listoptions_string);

    // Fetch possible list options
    $possible_list_options = get_list_options_and_descriptions();

    // Array to hold the assoc array as input for make_list
    $listoptions = array();

    // Tag directives are seperated by |'s
    $ar = explode('|', $listoptions_string);

    foreach ($ar as $argument) {

        // Key/value pairs are seperated by ='s
        list($key, $val) = explode('=', $argument);

        if (substr($key, 0, 7) == 'filter_') {
            $key = substr($key, 7, strlen($key) - 7);
            $elementname = '';
            if (strstr($key, '_from')) {
                $elementname = 'from';
                $key = str_replace('_from', '', $key);
            } elseif (strstr($key, '_to') && substr($key, strlen($key) - 20, 20) != 'version_belonging_to') {
                $elementname = 'to';
                $key = str_replace('_to', '', $key);
            }
            if ($elementname != '') {
                $listoptions['filter'][$key][$elementname] = $val;
            } else {
                $listoptions['filter'][$key][] = $val;
            }
        } elseif (substr($key, 0, 11) == 'filtertype_') {
            $key = substr($key, 11, strlen($key) - 11);
            $listoptions['filtertype'][$key] = $val;
        } elseif (substr($key, 0, 13) == 'hiddenfilter_') {
            $key = substr($key, 13, strlen($key) - 13);
            if (strstr($key, '_from')) {
                $key = str_replace('_from', '', $key);
                $listoptions['hiddenfilter'][$key]['from'] = $val;
            } elseif (strstr($key, '_to') && substr($key, strlen($key) - 20, 20) != 'version_belonging_to') {
                $key = str_replace('_to', '', $key);
                $listoptions['hiddenfilter'][$key]['to'] = $val;
            } else {
                $listoptions['hiddenfilter'][$key][] = $val;
            }
        } elseif (substr($key, 0, 17) == 'hiddenfiltertype_') {
            $key = substr($key, 17, strlen($key) - 17);
            $listoptions['hiddenfiltertype'][$key] = $val;
        } elseif ($key == 'countonly' && $val == '1') {
            // This means the function should return a count only, not an actual list
            $listoptions[$key] = $val;
        } elseif ($key == 'reporttype') {
            // This an option for the #REPORT tag
            if ($val == 'excel') {
                $listoptions[$key] = $val;
            } elseif ($val == 'pdf') {
                $listoptions[$key] = $val;
            } elseif ($val == 'html') {
                $listoptions[$key] = $val;
            } else {
                echo Alert('Invalid value of key reporttype: '.$val);
            }
        } elseif ($key == 'filename') {
            // This an option for the #REPORT tag
            $listoptions[$key] = $val;
        } elseif ($key == 'linktext') {
            // This an option for the #REPORT tag
            $listoptions[$key] = $val;
        } elseif ($key == 'table') {
            // This an option for the #REPORT tag
            $listoptions[$key] = $val;
        } elseif ($key != '') {
            if (!is_array($possible_list_options[$key]) && $val != '') {
                echo Alert('Parse error in LIST tag: '.$key.' having value '.$val.' : option unknown');
            }
            // It's a regular key/value pair
            $listoptions[$key] = $val;
        }
    }

    return $listoptions;
}
function ParseTemplateListTags($template)
{
    // Example: #LIST|table=t1|filter_t1-f3=@RECORDID@#
    // Fetch all tags from template
    preg_match_all('/#LIST(.*?)#/', $template, $matches);

    // Loop through tags
    foreach ($matches[1] as $listoptions_string) {
        $listoptions = array();
        $return_count = false;

        $listoptions = ConvertTagOptionsToListOptions($listoptions_string);

        // Check if it's a count
        if ($listoptions['countonly'] == 1) {
            $return_count = true;
        }

        // Flag as internal
        $listoptions['internallistcall'] = true;

        if (!isset($listoptions['sameresultandpage'])) {
            $listoptions['sameresultandpage'] = $_GET['sameresultandpage'];
        }
        $listoptions['hl'] = $_GET['hl'];

        $html = '';
        if ($listoptions['BYAJAX'] == 1) {
            $url = 'list.php?';
            //			$listoptions['BYAJAX'] = 1;
            //dit is een heel lelijk stuk code maar ik weet niet hoe het anders kan; de listoptions array bestaat uit maximaal 3 dimensies
            foreach (array_keys($listoptions) as $key) {
                if (is_array($listoptions[$key])) {
                    foreach (array_keys($listoptions[$key]) as $key2) {
                        if (is_array($listoptions[$key][$key2])) {
                            foreach ($listoptions[$key][$key2] as $val) {
                                $url .= rawurlencode($key).'['.rawurlencode($key2).'][]='.rawurlencode($val).'&';
                            }
                        } else {
                            $url .= rawurlencode($key).'['.rawurlencode($key2).']='.rawurlencode($listoptions[$key][$key2]).'&';
                        }
                    }
                } else {
                    $url .= rawurlencode($key).'='.rawurlencode($listoptions[$key]).'&';
                }
            }
            $html = AjaxBoxSimple($url);
        } else {
            if ($listoptions['outputtype'] == 'array') {
                //JH 2016-09-04 om de data kommagescheiden eruit te krijgen; dit is handig wanneer je een veld in een ft wilt selecteren op basis van een USERID
                //#LIST|table=t1|hiddenfilter_t1-f255=@USERID@|listlayoutcolumns=t1-recordid|outputtype=array#
                $array = make_list($listoptions);
                $tel = 0;
                foreach ($array as $record) {
                    foreach ($record as $key => $value) {
                        if ($tel > 0) {
                            $html .= ',';
                        }
                        $html .= htme($value);
                        ++$tel;
                    }
                }
            } else {
                list($number_of_records, $output) = make_list($listoptions);

                if ($return_count) {
                    $html = FormatNumber($number_of_records, 0);
                } else {
                    $html = $output;
                }
            }
        }
        /* TODO: hier excluden dat een sublist zonder geldig hiddenfilter niet kan? */
        $template = str_replace('#LIST'.$listoptions_string.'#', escape_interleave_characters($html), $template);
    }

    return $template;
}

function AjaxBoxSimple($url)
{
    $str = '';
    $id = 'A'.randomstring(8);
    $str .= '<div id="'.$id.'"></div>';
    $str .= '<script type="text/javascript">'."\n";
    $str .= 'refresh_contents_of_div(\''.$id.'\', \''.jsencode($url).'\', \'\', false, \'GET\');'."\n";
    $str .= '</script>'."\n";

    return $str;
}

function ParseTemplateGeneric($template)
{

    /*
    *
    * Handles:
    *
    * Mobile / desktop switcher
    * Time, user, userid, group, groupid tags
    * Calendar tags
    * Info tags
    * Inline add form tags
    * Default value tags
    * Template inclusions
    * Default Report Tags
    * STATIMG tags
    * User and group fieldsyes
    * Absolutely addressedd ifields
    *
    */
    if (strlen($template) == 0) {
        return '';
    }

    $template = str_replace('@XDEBUG@', 'XDEBUG ENABLED: <input size="2" type="text" name="XDEBUG_PROFILE" value="1">', $template);

    //this used to be ParseTemplateInclusions()
    $lus = 0;
    $count = 1;
    while (($count > 0) && ($lus < 5)) {
        //to prevent endless recursion
        ++$lus;
        /* HF20160721 /e param gedropped in php7 */
        //$template = preg_replace('/\@TEMPLATE([0-9]+)\@/e', "GetTemplate('\\1')", $template, $count);
        //$template = preg_replace_callback('/\@TEMPLATE([0-9]+)\@/', "GetTemplate('\\1')", $template, $count);
        $template = preg_replace_callback("/\@TEMPLATE([0-9]+)\@/", function ($matches) {
            return GetTemplate($matches[1]);
        }, $template);
    }
    //this used to be ParseTemplateInclusions()

    /*
    HIER GEEN MODULES PARSEN! ECHT NIET!
    */

    //this used to be ParseDefaultValueTags()
    $template = str_replace('@BASEURL@', escape_interleave_characters(htme(GetSetting('BASEURL'))), $template);
    $template = str_replace('@REPOSNUM@', escape_interleave_characters(htme($GLOBALS['repository'])), $template);
    $template = str_replace('@ADMINEMAIL@', escape_interleave_characters(htme(GetSetting('admemail'))), $template);
    $template = str_replace('@ADMEMAIL@', escape_interleave_characters(htme(GetSetting('admemail'))), $template);
    $template = str_replace('@WEBHOST@', escape_interleave_characters(htme(getenv('HOSTNAME'))), $template);
    $template = str_replace('@TITLE@', escape_interleave_characters(htme(GetSetting('title'))), $template);

    $template = str_replace('@DATE@', TransformDate(date('d-m-Y')), $template);
    $template = str_replace('@UNFORMATTED_DATE@', date('d-m-Y'), $template);
    $template = str_replace('@TODAY@', TransformDate(date('d-m-Y')), $template);
    $template = str_replace('@TODAYISO@', date('Y-m-d'), $template);
    $template = str_replace('@ISODATE@', date('Y-m-d'), $template);
    $template = str_replace('@NOW@', date('Y-m-d').' '.date('H:i:s'), $template);
    $template = str_replace('@ISODATETIME@', date('Y-m-d').' '.date('H:i:s'), $template);
    $template = str_replace('@TODAY_UNFORMATTED@', date('d-m-Y'), $template);
    $template = str_replace('@NOW_FORMATTED@', TransformDate(date('d-m-Y')).' '.date('H:i:s'), $template);
    $template = str_replace('@NOW_UNFORMATTED@', date('Y-m-d').' '.date('H:i:s'), $template);
    $template = str_replace('@EPOCH@', date('U'), $template);
    $template = str_replace('@YESTERDAY@', TransformDate(date('d-m-Y', (date('U') - 86400))), $template);
    $template = str_replace('@TOMORROW@', TransformDate(date('d-m-Y', (date('U') + 86400))), $template);
    $template = str_replace('@YESTERDAY_UNFORMATTED@', date('d-m-Y', (date('U') - 86400)), $template);
    $template = str_replace('@TOMORROW_UNFORMATTED@', date('d-m-Y', (date('U') + 86400)), $template);
    $template = str_replace('@YESTERDAYISO@', date('Y-m-d', (date('U') - 86400)), $template);
    $template = str_replace('@TOMORROWISO@', date('Y-m-d', (date('U') + 86400)), $template);
    $template = str_replace('@TIME@', date('H:i:s'), $template);

    $template = str_replace('@USERID@', $GLOBALS['USERID'], $template);
    $template = str_replace('@CURUSER@', $GLOBALS['USERID'], $template);
    $template = str_replace('@USER@', escape_interleave_characters(htme(GetUserName($GLOBALS['USERID']))), $template);
    $template = str_replace('@USERNAME@', escape_interleave_characters(htme(GetUserName($GLOBALS['USERID']))), $template);
    $template = str_replace('@USER_EMAIL@', escape_interleave_characters(htme(GetUserEmail($GLOBALS['USERID']))), $template);
    $template = str_replace('@GROUPID@', $GLOBALS['GROUPID'], $template);
    $template = str_replace('@GROUP@', escape_interleave_characters(htme(GetGroupName($GLOBALS['GROUPID']))), $template);
    //this used to be ParseDefaultValueTags()

    if (strstr($template, '@SWITCHIF@')) {
        $template = str_replace('@SWITCHIF@', escape_interleave_characters(desktopmobileswitcher()), $template);
    }

    preg_match_all('/#CALENDAR(.*?)#/', $template, $matches);
    foreach ($matches[1] as $calendaroptions_string) {
        $calendaroptions = array();
        foreach (explode('|', html_entity_decode($calendaroptions_string)) as $argument) {
            list($key, $val) = explode('=', $argument);
            $calendaroptions[$key] = $val;
        }

        $listid_div_exists = false;
        $template = str_replace('#CALENDAR'.$calendaroptions_string.'#', escape_interleave_characters(ShowCalendar($calendaroptions['listid'], $calendaroptions['view'], $calendaroptions['startdate'], $listid_div_exists, $calendaroptions['cals_to_show'])), $template);
    }

    $template = str_replace('@INFO@', '<div class="formcomment-tooltip" title="', $template);
    $template = str_replace('@ENDINFO@', '"><span class="fa fa-info-circle"></span></div>', $template);

    // Default report tags
    $template = ParseTemplateCreateDefaultReportTags($template);

    // Parse user and group fields
    $template = ParseTemplateUserAndGroupFields($template);

    // Parse absolutely addressed ifields
    preg_match_all('/#.*#/', $template, $matches);

    foreach ($matches[0] as $el => $tag) {
        list($table, $field, $record) = explode('-', str_replace('#', '', $tag));

        if (is_array($GLOBALS['UC']['PersonalDataStructure'][$table]['fields'][$field]) && ipi($record)) {
            $localrecord = getrecord($table, $record, false, false, array($table.'-'.$field));

            if ($localrecord['*'.$table.'-'.$field] == 1) {
                $value = return_ifield($table.'-'.$field, $record, $localrecord[$table.'-'.$field], '', false, false);
            } else {
                $value = $localrecord[$table.'-'.$field];
                if (!$GLOBALS['UC']['PersonalDataStructure'][$table]['fields'][$field]['interactive-alwaysinline']) {
                    if ($GLOBALS['UC']['PersonalDataStructure'][$table]['fields'][$field]['relation_to'] != '') {
                        $value = get_refer_layout_for_record($GLOBALS['UC']['PersonalDataStructure'][$table]['fields'][$field]['relation_to'], $value);
                    } else {
                        /* get the textual human readable value. it will be htme encoded when we get it back */
                        $value = formatvalue($value, $table.'-'.$field);
                    }
                }
            }

            $template = str_replace($tag, $value, $template);
        }
    }

    return $template;
}
function StripLanguageOnlyTags($template)
{
    /* strips all text enclosed in @LANGxxxONLY@ .. @ENDLANGxxxONLY@ tags, when xxx != current user language */
    return preg_replace_callback("/\@LANG([A-Z]+)ONLY\@(.*?)\@ENDLANG\\1ONLY\@/s", function ($matches) {
        if ($matches[1] == $GLOBALS['LANGUAGE']) {
            return $matches[2];
        } else {
            return '';
        }
    }, $template);
}
function StripGroupOnlyTags($template)
{
    $groups = GetGroups();

    if (!is_administrator()) {
        foreach ($groups as $group) {
            if ($group['id'] != $GLOBALS['GROUPID']) {
                $template = preg_replace('/@GROUP'.$group['id'].'ONLY@(.*?)@ENDGROUP'.$group['id'].'ONLY@/s', '', $template);
            } else {
                $template = preg_replace('/@GROUP'.$group['id'].'NOT@(.*?)@ENDGROUP'.$group['id'].'NOT@/s', '', $template);
            }
        }
        $template = preg_replace('/@GROUPADMINONLY@(.*?)@ENDGROUPADMINONLY@/s', '', $template);
    } else {
        $template = preg_replace('/@GROUPADMINNOT@(.*?)@ENDGROUPADMINNOT@/s', '', $template);
    }
    // Important! Clean up matching rows.
    foreach ($groups as $group) {
        $template = str_replace('@GROUP'.$group['id'].'ONLY@', '', $template);
        $template = str_replace('@ENDGROUP'.$group['id'].'ONLY@', '', $template);
        $template = str_replace('@GROUP'.$group['id'].'NOT@', '', $template);
        $template = str_replace('@ENDGROUP'.$group['id'].'NOT@', '', $template);
    }
    $template = str_replace('@GROUPADMINONLY@', '', $template);
    $template = str_replace('@ENDGROUPADMINONLY@', '', $template);
    $template = str_replace('@GROUPADMINNOT@', '', $template);
    $template = str_replace('@ENDGROUPADMINNOT@', '', $template);

    return $template;
}

function StripExistingOnlyTags($template)
{
    qlog(INFO, 'Tags only for existing records stripped from template');
    $template = preg_replace('/@XONLY@(.*?)@ENDXONLY@/s', '', $template);
    $template = str_replace('@XONLY@', '', $template);
    $template = str_replace('@ENDXONLY@', '', $template);
    $template = str_replace('@NEWONLY@', '', $template);
    $template = str_replace('@ENDNEWONLY@', '', $template);

    return $template;
}
function StripNewOnlyTags($template)
{
    qlog(INFO, 'Tags only for new records stripped from template');
    $template = preg_replace('/@NEWONLY@(.*?)@ENDNEWONLY@/s', '', $template);
    $template = str_replace('@NEWONLY@', '', $template);
    $template = str_replace('@ENDNEWONLY@', '', $template);
    $template = str_replace('@XONLY@', '', $template);
    $template = str_replace('@ENDXONLY@', '', $template);

    return $template;
}
function StripRWOnlyTags($template)
{
    qlog(INFO, 'Tags only for read-write records stripped from template');
    $template = preg_replace('/@RWONLY@(.*?)@ENDRWONLY@/s', '', $template);
    $template = str_replace('@RWONLY@', '', $template);
    $template = str_replace('@ENDRWONLY@', '', $template);
    $template = str_replace('@ROONLY@', '', $template);
    $template = str_replace('@ENDROONLY@', '', $template);

    return $template;
}
function StripROOnlyTags($template)
{
    qlog(INFO, 'Tags only for read-only records stripped from template');
    $template = preg_replace('/@ROONLY@(.*?)@ENDROONLY@/s', '', $template);
    $template = str_replace('@ROONLY@', '', $template);
    $template = str_replace('@ENDROONLY@', '', $template);
    $template = str_replace('@RWONLY@', '', $template);
    $template = str_replace('@ENDRWONLY@', '', $template);

    return $template;
}
function StripLockedOnlyTags($template)
{
    qlog(INFO, 'Tags only for read-only records stripped from template');
    $template = preg_replace('/@LOCKEDONLY@(.*?)@ENDLOCKEDONLY@/s', '', $template);
    $template = str_replace('@LOCKEDONLY@', '', $template);
    $template = str_replace('@ENDLOCKEDONLY@', '', $template);

    return $template;
}

function ParseTemplateLanguageTags($template)
{
    global $lang;
//    qlog(INFO, "Start replace language tags in template");

    // Find all tags
    preg_match_all('/\[\[[A-Za-z0-9_\-]+\]\]/', $template, $matches);
    $list_of_tags = $matches[0];

    foreach ($list_of_tags as $name) {
        $tag = $lang[str_replace('[[', '', str_replace(']]', '', $name)) ];

        if ((substr($name, 0, 6) == '[[EFID' && CheckExtraFieldAccess(str_replace('EFID', '', str_replace('[[', '', str_replace(']]', '', $name)))) != 'nok') || substr($name, 0, 6) != '[[EFID') {
            $template = str_replace($name, escape_interleave_characters(htme($tag)), $template);
        } else {
            $template = str_replace($name, '', $template);
        }
    }
//    qlog(INFO, "Done replace language tags in template");
    return $template;
}
function GetStyleSheets($id = false)
{
    //this is a admin function, so no check on CheckTemplateAccess
    if (ipi($id)) {
        return db_GetArray("SELECT templateid, templatename, template_subject FROM CRMtemplates WHERE templatetype='TEMPLATE_CSS' AND version_belonging_to=0 AND templateid=".$id);
    } else {
        return db_GetArray("SELECT templateid, templatename, template_subject FROM CRMtemplates WHERE templatetype='TEMPLATE_CSS' AND version_belonging_to=0");
    }
}
function GetAllButtons($id = false)
{
    if ($id) {
        return db_GetArray("SELECT * FROM CRMextrafields WHERE fieldtype='Button' AND deleted='n' AND id='".mres($id)."'");
    } else {
        return db_GetArray("SELECT * FROM CRMextrafields WHERE fieldtype='Button' AND deleted='n'");
    }
}
function CheckModuleAccess($module_id)
{
    $acc = 'nok';

    $val = db_GetValue("SELECT version_belonging_to FROM CRMmodules WHERE mid='".mres($module_id)."'");
    if (ipi($val)) { // not main version
    } elseif (is_administrator($GLOBALS['USERID'])) {
        $acc = 'ok';
    } else {
        $rules = db_GetArray("SELECT `group`, `execute` FROM `CRMmoduleaccessrules` WHERE `CRMmoduleaccessrules`.`module`='".mres($module_id)."'");
        if (count($rules) == 0) {
            /* no rules means everybody has access */
        $acc = 'ok';
        } else {
            foreach ($rules as $rule) {
                if ($rule['group'] == $GLOBALS['GROUPID'] && $rule['execute'] == 1) {
                    /* a rule exists, and excute rights are granted */
            $acc = 'ok';
                }
            }
        }
        //print 'No specific rules found, but rules DO exist, denied. Checking group ' . $GLOBALS['GROUPID'] . " for user " . $GLOBALS['USERID'] . "\n";
        //DA($rules);
    }

    return $acc;
}

function pre($txt)
{
    echo '<pre>';
    if (is_array($txt)) {
        echo htme(print_r($txt, true));
    } else {
        echo htme($txt);
    }
    echo '</pre>';
}
function GetExtraFlexTableFields($flextable_nr, $efid = false, $include_buttons = false, $no_cache = false)
{
    global $lang;
    $no_cache = true;

    if ($no_cache) {
        unset($GLOBALS['PageCache']['ExtraFlexTableFields']);
    }

    $sql_ins = '';
    if ((!stristr($_SERVER['SCRIPT_NAME'], 'flextable.php')) && (!stristr($_SERVER['SCRIPT_NAME'], 'admin.php')) && !$include_buttons) {
        $sql_ins .= " AND fieldtype!='Button'  AND underwaterfield!='y'";

        qlog(INFO, 'Buttons are excluded (this page != flextable.php)');
    }
    $ret = array();

    foreach (db_GetArray("SELECT * FROM CRMextrafields WHERE tabletype='".$flextable_nr."' ".$sql_ins." AND deleted='n' ORDER BY ordering") as $row) {
        $row['name'] = strip_tags(br2nl($row['name']));
        if (CheckExtraFieldAccess($row['id']) == 'ok' || CheckExtraFieldAccess($row['id']) == 'readonly') {
            $row['name'] = $lang['EFID'.$row['id']];
            $row['displaylistname'] = $lang['EFID'.$row['id'].'DLN'];
            $ret[$row['id']] = $row;
        } else {
            //$ret[$row['id']] = "ACCESS DENIED";
        }
    }

    qlog(INFO, 'fields for table '.$flextable_nr.' returned ('.sizeof($ret).' fields)');

    $GLOBALS['PageCache']['ExtraFlexTableFields'][$flextable_nr] = $ret;

    if ($efid) {
        $return = array();
        if (!is_array($ret[$efid])) {
            $ret[$efid] = array('Field '.$efid.' not found!');
        }
        $return[0] = $ret[$efid];

        return $return;
    }

    return $ret;
}
function GetExtraUserFields()
{
    global $lang;
    $ret = array();
    foreach (db_GetArray("SELECT * FROM CRMextrafields WHERE tabletype='user' AND deleted='n' ORDER BY ordering") as $row) {
        $row['name'] = $lang['EFID'.$row['id']];
        $row['displaylistname'] = $lang['EFID'.$row['id'].'DLN'];
        array_push($ret, $row);
    }

    return $ret;
}
function GetExtraFilesFields($efid = false)
{
    global $lang;
    $ret = array();
    foreach (db_GetArray("SELECT * FROM CRMextrafields WHERE tabletype='files' AND deleted='n' ORDER BY ordering") as $row) {
        $row['name'] = $lang['EFID'.$row['id']];
        $row['displaylistname'] = $lang['EFID'.$row['id'].'DLN'];
        array_push($ret, $row);
    }

    return $ret;
}
// Returns a timestamp from a string.  Assumes en_GB format where ambiguous.
function NLDateToTimestamp($value, $add = false)
{
    // If it looks like a UK date dd/mm/yy, reformat to US date mm/dd/yy so strtotime can parse it.
    $reformatted = preg_replace("/^\s*([0-9]{1,2})[\/\. -]+([0-9]{1,2})[\/\. -]+([0-9]{1,4})/", '\\2/\\1/\\3', $value);

    return strtotime($reformatted.$add);
}
/**
 * Function TransformTime.
 *
 * Transforms a given time to the american format
 * if the date format is set to mm-dd-yyyy (global setting)
 *
 * @param	date_to_print	The european-formatted date in dd-mm-yyyy format
 */
function TransformTime($time_to_print)
{
    if ($time_to_print == '' || strstr($time_to_print, 'none')) {
        return '';
    } else {
        $h = substr($time_to_print, 0, 2);
        $m = substr($time_to_print, 3, 2);
        $Return = '';

        if ($GLOBALS['UC']['DateFormat'] == 'mm-dd-yyyy') {
            if (strlen($time_to_print) != 5) {
                $Return = $time_to_print;
            } else {
                if ($h > 12) {
                    $h = ($h - 12);

                    $m .= ' pm';
                } elseif ($h == 12) {
                    $m .= ' pm';
                } else {
                    $m .= ' am';
                }
                if (strlen($h) == 1) {
                    $h = '0'.$h;
                }
                $Return = $h.':'.$m;
            }
        } else {
            $Return = $h.':'.$m;
        }
        qlog(INFO, 'Return: '.$Return);

        return $Return;
    }
}
/**
 * Function TransformDate.
 *
 * Transforms a given date to the american format
 * if the date format is set to mm-dd-yyyy (global setting)
 *
 * @param	date_to_print	The european-formatted date in dd-mm-yyyy format
 */
function TransformDate($date_to_print)
{
    $date_to_print = substr($date_to_print, 0, 10);
    if (substr($date_to_print, 0, 10) == '00-00-0000') {
        return '';
    } elseif (!is_valid_nl_date($date_to_print)) {
        return $date_to_print;
    } elseif ($date_to_print == '' || strstr($date_to_print, 'none')) {
        return '';
    } else {
        $Return = '';
        if ($GLOBALS['UC']['DateFormat'] == 'mm-dd-yyyy') {
            if (strlen($date_to_print) != 10) {
                $Return = $date_to_print;
            } else {
                $d = substr($date_to_print, 0, 2);
                $m = substr($date_to_print, 3, 2);
                $y = substr($date_to_print, 6, 4);
                $Return = $m.'-'.$d.'-'.$y;
            }
        } elseif ($GLOBALS['UC']['DateFormat'] == 'yyyy-mm-dd') {
            if (strlen($date_to_print) != 10) {
                qlog(ERROR, 'ERROR parsing date: '.$date_to_print);
                $Return = $date_to_print;
            } else {
                $d = substr($date_to_print, 0, 2);
                $m = substr($date_to_print, 3, 2);
                $y = substr($date_to_print, 6, 4);
                $Return = $y.'-'.$m.'-'.$d;
            }
        } else {
            $Return = $date_to_print;
        }
      //  qlog(INFO, "Return: " . $Return);
        return $Return;
    }
}
function NLDate2Epoch($date)
{
    if ($date == '' || strlen($date) != 10) {
        return false;
    } else {
        $tmp = explode('-', $date);
        if (is_array($tmp)) {
            return mktime(0, 0, 0, $tmp[1], $tmp[0], $tmp[2]);
        } else {
            return false;
        }
    }
}
function NLDate2INTLDate($date)
{
    if ($date == '') {
        return '';
    }

    $d = substr($date, 0, 2);
    $m = substr($date, 3, 2);

    $y = substr($date, 6, 4);

    return $y.'-'.$m.'-'.$d;
}
function INTLDate2NLDate($date)
{
    if ($date == '') {
        return '';
    }

    $d = substr($date, 8, 2);
    $m = substr($date, 5, 2);
    $y = substr($date, 0, 4);

    return $d.'-'.$m.'-'.$y;
}
function ParseFormattedEmailAddress($str)
{
    $return = array();

    $tmp = explode('<', str_replace('>', '', $str));

    if (ValidateEmail(trim($tmp[1]))) {

        // This probably is in format Firstname Lastname <e@mail.com>
        $return['fromemail'] = trim($tmp[1]);

        $name = trim($tmp[0]);
        if ($name == '') {
            $return['fromname'] = $return['fromemail'];
        } else {
            $return['fromname'] = $name;
        }
    } else {
        $return['fromname'] = $str;
        $return['fromemail'] = $str;
    }

    return $return;
}
function microtime_float()
{
    list($usec, $sec) = explode(' ', microtime());

    return (float) $usec + (float) $sec;
}
// The supporting qlog function to log custom text to qlist.txt
function qlog($loglevel, $msg)
{
    if (!$GLOBALS['logtext'] && !$GLOBALS['qlog_onscreen']) {
        return true;
    }

    global $eid;
    $rule = '';
    if (isset($GLOBALS['DISABLE_DECISIONS'])) {
        $GLOBALS['DECISIONTRACE'] = array();
    }
    $do_log = false;

    if (is_numeric($GLOBALS['logtext'])) {
        if (($loglevel >= $GLOBALS['logtext']) && ($loglevel != DEBUG)) {
            $do_log = true;
        } elseif (($GLOBALS['logtext'] == DEBUG) && (($loglevel == DEBUG) || ($loglevel == ERROR) || ($loglevel == WARNING))) {
            $do_log = true;
        }
        if (($loglevel == ERROR) && ($GLOBALS['logtext'] == DEBUG)) {
            $msg .= "\n\n".GetBackTrace()."\n";
        }
    } else {
        if (($GLOBALS['logtext'] == true) || ($GLOBALS['ShowTraceLink'] == true) || ($GLOBALS['UC']['PERSONALTRACE'] == 'On') || $GLOBALS['qlog_onscreen']) {
            $do_log = true;
        }
    }

    if ($do_log) {
        if (is_numeric($eid)) {
            $msg = ''.$eid.'::'.$msg;
        }
        if (is_array($msg)) {
            $msg2 = "Array:\n";
            $msg2 .= string_r($msg);
            $msg = $msg2;
        }

        if (strstr($msg, 'ACCESS DECISION')) {
            if (!is_array($GLOBALS['DECISIONTRACE'])) {
                $GLOBALS['DECISIONTRACE'] = array();
            }
            array_push($GLOBALS['DECISIONTRACE'], $msg);
        }
        if ($GLOBALS['ShowFunctionTrace']) {
            ob_start();
            debug_print_backtrace();
            $t = ob_get_contents();
            ob_end_clean();
            $msg .= "\n###################################################################################################################\nBacktrace of this message:\n-------------------------------------------------------------------------------------------------------------------\n".$t."\n\n###################################################################################################################";
        }
        $name = '';
        if ($GLOBALS['USERNAME']) {
            $name = $GLOBALS['USERNAME'];
        } else {
            $name = 'NOUSER';
        }
        if ($GLOBALS['tracelogused'] == '') {
            $GLOBALS['tracelogused'] = true;
            qlog(INFO, $GLOBALS['PRODUCT'].' '.$GLOBALS['VERSION'].' on '.$_SERVER['SERVER_NAME'].' chatting with '.$_SERVER['REMOTE_ADDR']);
        }
        $bla = debug_backtrace();

        $file = $bla[1]['file'];
        // Strip path from filename (UNIX)
        $file = explode('/', $file);
        $file = $file[sizeof($file) - 1];
        // Strip path from filename (Windows)
        $file = explode('\\', $file);
        $file = $file[sizeof($file) - 1];
        $func = fillout($file.':'.$bla[0]['line'], 35).'   '.$bla[1]['function'];
        if ($file != '' && $bla[1]['function'] != 'require_once') {
        } else {
            $file = $bla[0]['file'];

            // Strip path from filename (UNIX)
            $file = explode('/', $file);
            $file = $file[sizeof($file) - 1];
            // Strip path from filename (Windows)
            $file = explode('\\', $file);
            $file = $file[sizeof($file) - 1];
            $func = fillout($file.':'.$bla[0]['line'], 35).'  '.$bla[0]['function'];
        }
        $curmem = round(memory_get_usage() / 1024 / 1024, 2);
        if ($curmem > 100) {
            $curmem = 'WARN:'.$curmem;
        }
        $rule .= date('Ymd H:i:s').' '.fillout(microtime_float(), 16).' MEM:'.fillout($curmem, 15).' '.fillout($name, 8).' '.$func.'::'.$msg."\n";

        if (!strstr($msg, 'CACHE ')) {
            $GLOBALS['tracelog'] .= $rule;
        }

        $fp = @fopen('qlist.txt', 'a');
        @fputs($fp, strip_tags($rule));
        @fclose($fp);

        if ($GLOBALS['UC']['PERSONALTRACE'] == 'On') {
            mcq("INSERT INTO CRMcache(value,epoch) VALUES('TRACE".mres($GLOBALS['repository'].$GLOBALS['USERID']).': '.mres($rule)."','".date('U')."')");
        }
    }

    return 0;
}
function RealMail($template, $entity, $customer, $From, $Fromname, $To, $PDF, $Subject, $attach_to_dossier = false, $attach_as_filename = false, $report_attach = false, $flextableid = false, $flextablerecord = false, $parse = true, $files_to_attach = array(), $dstablename = '')
{
    if (GetSetting('UseMailQueue') == 'Yes') {
        $parse_flag = 'y';
        if (!$parse) {
            $parse_flag = 'n';
        }

        $tmp = '';
        // Double entry check
        $dcheck = "SELECT queueid FROM CRMmailqueue WHERE status='unsent' AND `template` = '".mres($template)."' AND `user`  = '".mres($GLOBALS['USERID'])."' AND `entity`  = '".mres($entity)."' AND `customer` = '".mres($customer)."' AND `from`  = '".mres($From)."' AND `fromname` = '".mres($Fromname)."' AND `to`  = '".mres($To)."' AND `subject`  = '".mres($Subject)."' AND `attach_to_dossier`  = '".mres($attach_to_dossier)."' AND `attach_as_filename`  = '".mres($attach_as_filename)."' AND `report_attach` = '".mres($report_attach)."' AND `flextableid`  = '".mres($flextableid)."' AND `flextablerecord` = '".mres($flextablerecord)."' AND `files_to_attach` = '".mres(serialize($files_to_attach))."' AND `table`='".mres($dstablename)."'";

        $tmp = db_GetValue($dcheck);

        if (!is_numeric($tmp)) {
            $sql = "INSERT INTO CRMmailqueue(`template`,`user`,`entity`,`customer`,`from`,`fromname`,`to`,`PDF`,`subject`,`attach_to_dossier`,`attach_as_filename`,`report_attach`,`flextableid`,`flextablerecord`, `date_queued`, `status`, `parse`, `files_to_attach`, `table`) VALUES('".mres($template)."','".$GLOBALS['USERID']."','".mres($entity)."','".mres($customer)."','".mres($From)."','".mres($Fromname)."','".mres($To)."','".mres($PDF)."','".mres($Subject)."','".mres($attach_to_dossier)."','".mres($attach_as_filename)."','".mres($report_attach)."','".mres($flextableid)."','".mres($flextablerecord)."',NOW(),'unsent', '".$parse_flag."','".mres(serialize($files_to_attach))."','".mres($dstablename)."')";
            mcq($sql);
        } else {
            qlog(INFO, 'Double message added to mailqueue. Skipped.');
        }
    } else {
        require_once 'adminfunctions.php';
        $adj = RealRealMail($template, $entity, $customer, $From, $Fromname, $To, $PDF, $Subject, $attach_to_dossier, $attach_as_filename, $report_attach, $flextableid, $flextablerecord, $parse, $files_to_attach);

        if ($adj[1] == true) {
            log_msg('Sending email from '.$From.' to '.$To.' subject '.str_replace('WARNING', 'WARN', str_replace('ERROR', 'ERR', $Subject)));
        } else {
            log_msg('ERROR: '.$adj[0].' Sending email from '.$From.' to '.$To.' subject '.str_replace('WARNING', 'WARN', str_replace('ERROR', 'ERR', $Subject)));
        }
    }
}

function SimpleMail($from, $to, $subject, $body, $file_attachment_array)
{
    require_once $GLOBALS['PATHTOINTERLEAVE'].'lib/class.phpmailer.php';
    require_once $GLOBALS['PATHTOINTERLEAVE'].'lib/class.smtp.php';

    qlog(INFO, 'MXR Called to send a mail to '.$to.' with subject '.$subject);
    $mail = new PHPMailer();
    $mail->CharSet = 'UTF-8';
    $mail->XMailer = ' ';
    qlog(INFO, 'MXR Ok 1');
    $UNIFIED_FROMADDRESS = GetSetting('UNIFIED_FROMADDRESS');
    if (strstr($UNIFIED_FROMADDRESS, '@')) {
        $ar = ParseFormattedEmailAddress($UNIFIED_FROMADDRESS);

        $mail->From = $ar['fromemail'];
        $mail->FromName = $ar['fromname'];
    } else {
        $mail->From = $from;
        $mail->FromName = $from;
    }
    qlog(INFO, 'MXR Ok 2');
    $mail->Subject = $subject;
    $mail->Host = GetSetting('SMTPserver');
    $mail->Mailer = GetSetting('MailMethod');
    if (GetSetting('MailUser') != '' && GetSetting('MailPass') != '') {
        $mail->Username = GetSetting('MailUser');
        $mail->Password = GetSetting('MailPass');
    }
    qlog(INFO, 'MXR Ok 3');
    $mail->IsHTML(true);
    $mail->Body = $body;
    $mail->AltBody = html2plaintext($body);
    qlog(INFO, 'MXR Ok 4');
    if (is_array($to)) {
        foreach ($to as $too) {
            if ($too != '') {
                $mail->AddAddress($too, $too);
            }
        }
    } else {
        $mail->AddAddress($to, $to);
    }
    qlog(INFO, 'MXR Ok 5');
    if (is_array($file_attachment_array)) {
        foreach ($file_attachment_array as $file) {
            if (CheckTableRecordAccess('files', $file) != 'nok') {
                $mail->AddStringAttachment(GetFileContent($file), GetFileName($file));
            }
        }
    }
    qlog(INFO, 'MXR Ok 6');
    if (!$mail->Send()) {
        log_msg('WARNING: Sending e-mail to '.$to.' failed:'.$mail->ErrorInfo);
        qlog(INFO, 'E-mail NOT sent.. ERROR: '.$mail->ErrorInfo);
    } else {
        log_msg('Notification e-mail sent to '.$to);
        qlog(INFO, 'An e-mail was sent.');
    }
}
function log_msg($comment)
{
    if ($GLOBALS['NO_INSERTS_TO_LOG']) {
        return true;
    } elseif (strlen($comment) > 524288) {
        // This is dangerous, the uselog table could fill up
        return false;
    }

    $ip = '';
    if (getenv(HTTP_X_FORWARDED_FOR)) {
        $ip = getenv(HTTP_X_FORWARDED_FOR);
    } else {
        $ip = getenv(REMOTE_ADDR);
    }

    $url = $_SERVER['REQUEST_URI'];

    $query = "INSERT INTO CRMuselog (ip, url, useragent, qs, user) VALUES ('".mres($ip)."', '".mres($url)."', '".mres($_SERVER['HTTP_USER_AGENT'])."' , '".mres($comment)."','".mres($GLOBALS['USERID'].' -- '.GetUserName($GLOBALS['USERID']))."')";

    mcq($query);

    if (strstr($comment, 'NOTICE') || strstr($comment, 'WARNING') || strstr($comment, 'ERROR')) {
        $txt_to_email = '';
        $txt_to_email .= 'IP-address: '.$ip."\n";
        $txt_to_email .= 'Repository: '.GetSetting('title')."\n";
        $txt_to_email .= 'Time: '.date('Y-m-d H:i:s')."\n";
        $txt_to_email .= 'User: '.$GLOBALS['USERNAME']."\n";
        $txt_to_email .= "Message:\n".$comment."\n";

        $tmp = '';
        $no_trace = false;

        if (isset($_REQUEST['password'])) {
            $tmp = $_REQUEST['password'];
            $_REQUEST['password'] = '(deleted)';
            $no_trace = true;
        }

        if (!$no_trace) {
            $txt_to_email .= "BACKTRACE:\n".string_r(debug_backtrace(DEBUG_BACKTRACE_IGNORE_ARGS))."\n";
        }

        $txt_to_email .= 'Request'.string_r($_REQUEST)."\n";
        $txt_to_email .= "Server relevants:\n";
        $txt_to_email .= 'REMOTE_ADDR '.$_SERVER['REMOTE_ADDR']."\n";
        $txt_to_email .= 'SERVER_NAME '.$_SERVER['SERVER_NAME']."\n";
        $txt_to_email .= 'SCRIPT_FILENAME '.$_SERVER['SCRIPT_FILENAME']."\n";
        $txt_to_email .= 'HTTP_REFERER '.$_SERVER['HTTP_REFERER']."\n";
        $txt_to_email .= 'REQUEST_URI '.$_SERVER['REQUEST_URI']."\n";
        $txt_to_email .= 'DATABASE_NAME '.db_GetValue('SELECT DATABASE()')."\n";

        if ($tmp) {
            $_REQUEST['password'] = $tmp;
        }

        $subj = $comment;
        if (strlen($subj) > 203) {
            $subj = substr($comment, 0, 200).'...';
        }

        $rules = array();
        $type = '';
        if (strstr($comment, 'NOTICE')) {
            AddMessage('admin', $GLOBALS['USERID'], $subj, $txt_to_email);
        } elseif (strstr($comment, 'WARNING')) {
            $comment = str_replace('WARNING: ', '', $comment);
            AddMessage('admin', $GLOBALS['USERID'], $subj, $txt_to_email);
            $type = 'A warning was issued: '.GetSetting('title');
            $rules = db_GetFlatArray("SELECT `CRMruleactions`.`value` FROM `CRMruleactions`, `CRMrules`, `CRMruleconditions` WHERE `CRMruleactions`.`rule` = `CRMrules`.`id` AND `CRMruleconditions`.`rule` = `CRMrules`.`id` AND `CRMruleconditions`.`condition` = 'system generates warning'");
            if (GetSetting('DevelopmentOrProduction') == 'Development') {
                $GLOBALS['JavascriptToPrintAtEndOfPage_OnlyJS'][] = 'alert("An error occurred. See messages.");';
            }
        } elseif (strstr($comment, 'ERROR') && !stristr($comment, 'added to entity')) {
            $comment = str_replace('ERROR: ', '', $comment);
            AddMessage('admin', $GLOBALS['USERID'], $subj, $txt_to_email);
            $type = 'An error occured: '.GetSetting('title');
            $rules = db_GetFlatArray("SELECT `CRMruleactions`.`value` FROM `CRMruleactions`, `CRMrules`, `CRMruleconditions` WHERE `CRMruleactions`.`rule` = `CRMrules`.`id` AND `CRMruleconditions`.`rule` = `CRMrules`.`id` AND `CRMruleconditions`.`condition` = 'system generates error'");

            if (GetSetting('DevelopmentOrProduction') == 'Development') {
                $GLOBALS['JavascriptToPrintAtEndOfPage_OnlyJS'][] = 'alert("An error occurred. See messages.");';
            }
        }

        foreach ($rules as $email) {
            $email = unescape_interleave_characters(ParseTemplateGeneric($email));
            qlog(INFO, 'Mail to '.$email.' because error or warning occured');

            /* 2016-02-20 RealMail uses html, so we have to encode $txt_to_email with htme() */
            RealMail('<pre>'.htme($txt_to_email).'</pre>', 0, 0, GetSetting('admemail'), 'INTERLEAVE', $email, false, $type, false, false, false, false, false, false);
        }
    }
}
function PrintExtraFieldForceJavascript()
{

    // This function prints the javascript needed to check for missing values.
    $output = '';

    foreach ($GLOBALS['UC']['PersonalDataStructure'] as $dstable => $prop) {
        foreach ($prop['fields'] as $dsfield => $field) {
            $fieldnum = str_replace('f', '', $dsfield);

            if ($field['fieldtype_in_extrafields_table'] == 'Button') {
                $fs = explode(',', $field['FieldsOnFormWhichMustHaveAValueCSV']);

                $output .= "\nfunction ValidateButtonClick".$fieldnum."() {\n";

                if (is_numeric($fs[0])) {
                    $output .= "	var ok = true;\n";
                    foreach ($fs as $checkfield) {
                        if (ipi($checkfield)) {
                            $output .= ' /* add rule for field '.htme($checkfield)." */\n";

                            $output .= "if (
											$('#JS_" .$dstable.'-f'.$checkfield."-' + $('#JS_concerningrecord').length)
											&&
											$('#JS_" .$dstable.'-f'.$checkfield."-' + $('#JS_concerningrecord').val()).val()==''

											) {\n";

                            $output .= "		set_error('".$dstable.'-f'.$checkfield."-' + $('#JS_concerningrecord').val());\n";

                            $output .= "		ok = false;\n";
                            $output .= "}\n\n";
                            $output .= "

											else {
												/* alert($('#JS_" .$dstable.'-f'.$checkfield."-' + $('#JS_concerningrecord').val()).val()); */
											}


								";
                        }
                    }

                    $output .= "	if (ok === true) {\n";
                    $output .= "		return(true);\n";
                    $output .= "	} else {\n";

                    $output .= "		alert('".EscapeSQ(html2plaintext(unescape_interleave_characters(ParseTemplateLanguageTags(GetAttribute('extrafield', 'NotAllRequiredFieldsAreEnteredMessage', $fieldnum)))))."');\n";

                    $output .= " 	$(\"#JS_e_button\").val('');\n";
                    $output .= "		return(false);\n";

                    $output .= "	}\n";
                } else {
                    $output .= "	return(true);\n";
                }
                $output .= '}';
            }
        }
    }

    $output .= generate_hideandshow_javascript();

    //require_once "lib/Minifier.php";
    //return \JShrink\Minifier::minify($output);
    return $output;
    //return str_replace("\n", "", str_replace("\t", "", $output));
}
function ValidateEmail($email)
{
    return filter_var($email, FILTER_VALIDATE_EMAIL);
}
function RemoveExpiredLocks()
{
    mcq('DELETE FROM CRMentitylocks WHERE timestamp_last_change<DATE_ADD(NOW(), INTERVAL -20 SECOND)');
}
function GetCustomCSS($in_admin = false, $authenticated = true, $rawcontent = false, $returnarray = false)
{
    /*
    deze functie wordt op 5 mogelijke manieren gebruikt;
    1. DisplayCSS authenticated
    2. DisplayCSS unauthenticated
    3. dav.php rawcontent
    4. make_html_editor() in_admin = false en returnarray = true
    5. vanuit install.php met in_admin = true
    */
    $cssfiles = array();
    $skin = '';
    if (!$in_admin && !$GLOBALS['Installer']) {
        $skin = GetSetting('UseSkinCSS');
    }
    $return = '';

    if ($in_admin) {
        //		$cssfiles[] = "css/crm_dft.css";
        //		$cssfiles[] = "css/skincrm.css";
        //		$cssfiles[] = "css/admin.css";
        $cssfiles[] = 'css/blackandblue.css';
    } elseif ($skin == 'Apple') {
        $cssfiles[] = 'css/crm_dft.css';
        $cssfiles[] = 'css/apple.css';
    } elseif ($skin == 'Black and blue') {
        $cssfiles[] = 'css/blackandblue.css';
    } elseif ($skin == 'Dark') {
        $cssfiles[] = 'css/dark.css';
    } elseif ($skin == 'Yes') {
        $cssfiles[] = 'css/crm_dft.css';
        $cssfiles[] = 'css/skincrm.css';
    } elseif ($skin == 'No') {
        $cssfiles[] = 'css/crm_dft.css';
    }

    //alleen in gebruik bij dav.php
    if ($rawcontent) {
        foreach ($cssfiles as $cssfile) {
            $return .= '<style type="text/css">'.file_get_contents($cssfile).'</style>';
        }
    } else {
        foreach ($cssfiles as $cssfile) {
            $return .= '<link rel="stylesheet" href="'.$cssfile.'?'.filemtime($cssfile).'" type="text/css">';
        }
    }

    //we laden de SYSWIDECSS niet in de admin sectie
    if (!$in_admin && !$GLOBALS['Installer']) {
        $swc = GetSetting('SYSWIDECSS');
        if (ipi($swc)) {
            //voor op de login en forgotpassword pagina (unauthenticaed), en voor in dav.php
            if ((!$authenticated) || ($rawcontent)) {
                //2016-03-01 GetTemplate is now secured; SYSWIDECSS is readable for everyone, even unauthenticated users
                $return .= '<style type="text/css">'.db_GetValue('SELECT content FROM CRMtemplates WHERE templateid='.$swc.' AND version_belonging_to=0').'</style>';
            } else {
                $cssfile = 'csv.php?GetCSS=default&amp;'.strtotime(GetTemplateLastModificationDate($swc));
                $return .= '<link rel="stylesheet" href="'.$cssfile.'" type="text/css">';
                $cssfiles[] = $cssfile;
            }
        }
    }

    //alleen in gebruik in make_html_editor()
    if ($returnarray) {
        return $cssfiles;
    } else {
        return $return;
    }
}

function DisplayCSS($return = false, $authenticated = true)
{
    //load_syswidecss staat op false wanneer die via login forgotpasswd e.d. wordt ingeladen want dan is er geen db verbinding
    $str = '<link rel="stylesheet" type="text/css" href="js/jquery-ui/jquery-ui-1.10.4/css/smoothness/jquery-ui.css">';
    $str .= '<link rel="stylesheet" type="text/css" href="js/jquery-ui-timepicker-addon.css">';
    $str .= '<link rel="stylesheet" type="text/css" href="js/jquery-fancybox/source/jquery.fancybox.css?1">';
    //http://fortawesome.github.io/Font-Awesome/
    $str .= '<link rel="stylesheet" href="font-awesome/css/font-awesome.min.css">';

    $in_admin = false;
    //SkipMainNavigation kan gezet zijn in de niet-admin; dat klopt niet
    if (isset($_GET['SkipMainNavigation']) || $GLOBALS['InAdminSection']) {
        $in_admin = true;
        /* not the right location to do this */
        require_once 'adminfunctions.php';
    }

    $str .= GetCustomCSS($in_admin, $authenticated);

    if ($return) {
        return $str;
    } else {
        echo $str;
    }
}
function admin_inpage_nav($navs, $pagetitle)
{
    $html = '';
    $html .= '<h1>'.$pagetitle.'</h1>';
    $html .= '<ul class="multicol admininpagenav">';
    foreach ($navs as $nav) {
        $html .= '<li><a href="'.$nav[0].'">'.$nav[1].'</a></li>';
    }
    $html .= '</ul>';

    return $html;
}
function PlainNav($navs, $dontskipnav = false, $nested = false)
{
    if (!$nested) {
        echo '<nav>';
    }
    echo '<ul class="twocolumns submenu">';
    foreach ($navs as $nav) {
        echo '<li>';
        $url = $nav[0];
        $text = $nav[1];

        if ($url == '') {
            $url = '#';
        }

        echo '<a href="'.$url.'">'.$text.'</a>';

        if (is_array($nav[2])) {
            PlainNav($nav[2], false, true);
        }
        echo '</li>';
    }
    echo '</ul>';
    if (!$nested) {
        echo '</nav>';
    }
}
function CreateFolder($koppelid, $type, $folder_name, $parent_folder)
{
    $ac = '';
    $ft = str_replace('flextable', '', $type);
    $ac = CheckTableRecordAccess('t'.$ft, false);

    if (is_administrator()) {
        $ac = 'ok';
    }
    if ($ac == 'ok') {
        $sql = 'INSERT INTO CRMbinfiles(koppelid,filename,filetype,type,folder) VALUES('.mres($koppelid).",'".mres($folder_name)."','{{{folder}}}','".mres($type)."','".$parent_folder."')";
        mcq($sql);

        return db_GetInsertId();
    } else {
        PrintAD('Access denied');

        return false;
    }
}
function CheckIfAttachingIsAllowed($recordid, $tabletype)
{
    $ac = '';
    if ($recordid == '_new_') {
        $ac = 'ok';
    } elseif (substr($tabletype, 0, 1) == 't' && (ipi($recordid) || $recordid == '_new_')) {
        $ac = CheckTableRecordAccess($tabletype, $recordid);
    } elseif (($tabletype == 'system' || $tabletype == 'generalpurpose' || $tabletype == 'public') && is_administrator()) {
        $ac = 'ok';
    }
    if ($ac == 'ok') {
        return true;
    } else {
        return false;
    }
}
function AttachFile($recordid, $filename, $content, $type, $filetype = 'Unknown', $subj = '', $no_triggers = false, $is_path = false, $folder = false, $skip_security = false)
{
    $ac = false;
    if ($skip_security) {
        $ac = true;
    } else {
        // Checking UPLOAD ACCESS, not read access. Result MUST be "ok".
        $t = str_replace('flextable', '', $type);
        if (ipi($t)) {
            $t = 't'.$t;
        }
        $ac = CheckIfAttachingIsAllowed($recordid, $t);
    }

    if (GetFileType($folder) != '{{{folder}}}') {
        $folder = '';
    }

    if (!$ac) {
        log_msg('ERROR: Tried to attach file '.$filename.' to record '.$recordid.' of table '.$type.' but access is denied');

        return false;
    } else {
        $filesize = 0;
        if ($is_path) {
            $filesize = filesize($content);
        } else {
            $filesize = strlen($content);
        }

        qlog(INFO, 'Saving file '.$filename);
        $sql = "INSERT INTO CRMbinfiles(koppelid,filename,filesize,filetype,username,type,file_subject, version_belonging_to, timestamp_last_change, folder, offloaded) VALUES ('".mres($recordid)."','".mres($filename)."','".$filesize."','".mres($filetype)."','".mres($GLOBALS['USERID'])."','".mres($type)."','".mres($subj)."',0, NOW(),'".$folder."','n')";
        mcq($sql);

        $a = db_GetInsertId();
        if ($is_path) {
            mcq('INSERT INTO CRMblobs(fileid,content) VALUES('.$a.",'".mres(file_get_contents($content))."')");
        } else {
            mcq('INSERT INTO CRMblobs(fileid,content) VALUES('.$a.",'".mres($content)."')");
            unset($content);
        }

        if (!$GLOBALS['Installer']) {
            journal($recordid, 'File id '.$a.' ['.$filename.'] added', $type);
            log_msg('File  '.$_FILES['userfile']['name'].' added to entity '.$recordid.' (type '.$type.')');
        }
        ExtractIndexData($a);
        IndexGPSCoordinates($a);

        SetMimeType($a);
        if ($folder > 0) {
            foreach (db_GetArray('SELECT folder, SUM(filesize) FROM CRMbinfiles WHERE folder>0 AND filesize > 0 GROUP BY folder ORDER BY folder DESC') as $fol) {
                mcq("UPDATE CRMbinfiles SET filesize='".$fol[1]."' WHERE fileid='".$fol[0]."' AND filetype='{{{folder}}}'");
            }
        }

        return $a;
    }
}

function CheckIfRecordCanBeDeleted($recordid, $flextableid)
{
    $Dstable = 't'.$flextableid;

    if ($recordid == '_new_') {
        return 'This record cannot be deleted because you cannot delete non-existing records';
    } elseif (CheckTableRecordAccess($Dstable, $recordid) != 'ok') {
        return "This record cannot be deleted because access to this record didn't work out (non-existing record or table, or no access: ".CheckTableRecordAccess($Dstable, $recordid).')';
    } elseif (CheckIfRecordHasChilds('t'.$flextableid, $recordid)) {
        return 'This record cannot be deleted because there are still other records referring to it.';
    } else {
        return '';
    }
}
function DeleteFlexTableRow($recordid, $flextableid, $descend = false, $return_list_only = false, $list_of_records = array())
{
    qlog(INFO, 'DeleteFlexTableRow('.$recordid.', '.$flextableid.', '.$descend.', '.$return_list_only.')');

    // Single or array? Single overrules array.
    $records = array();
    if (ipi($recordid)) {
        $records = array($recordid);
    } else {
        $records = $list_of_records;
    }

    $ds_tablename = '';
    $db_tablename = '';
    $jr_tablename = '';
    $dj_tablename = '';

    if (ipi($flextableid)) {
        $ds_tablename = 't'.$flextableid;
        $db_tablename = 'CRMflextable'.$flextableid;
        $jr_tablename = 'flextable'.$flextableid;
        $dj_tablename = $flextableid;
    } else {
        $ds_tablename = $flextableid;
        $db_tablename = 'CRM'.$flextableid;
        $jr_tablename = $flextableid;
        $dj_tablename = $flextableid;
    }

    if ($return_list_only) {
        $list = array();
        $list[$ds_tablename]['ok'] = 0;
        $list[$ds_tablename]['nok'] = 0;
        foreach ($records as $recordid) {
            if (CheckTableRecordAccess($ds_tablename, $recordid) == 'ok') {
                ++$list[$ds_tablename]['ok'];
                $list[$ds_tablename]['files'] += db_GetValue("SELECT COUNT(*) FROM CRMbinfiles WHERE type='".$jr_tablename."' AND koppelid='".$recordid."'");
            } else {
                ++$list[$ds_tablename]['nok'];
            }
        }
    }
    $list = array();
    $returntrue = false;
    foreach ($records as $recordid) {
        if (CheckIfRecordCanBeDeleted($recordid, $flextableid) == '' || $descend) {
            if ($descend) {
                if (!is_array($GLOBALS['SystemDataStructure'])) {
                    $GLOBALS['SystemDataStructure'] = GetSystemDataStructure();
                }

                // Get all fields referring to this field
                foreach ($GLOBALS['SystemDataStructure'][$ds_tablename]['childs'] as $table => $ct) {
                    $fieldname = str_replace('f', 'EFID', $ct[0]);
                    if ($GLOBALS['SystemDataStructure'][$table]['name_in_database'] != 'loginusers' && $GLOBALS['SystemDataStructure'][$table]['name_in_database'] != 'userprofiles') {
                        $deleted_part = " deleted='n' AND";

                        $recordlist = db_GetFlatArray('SELECT '.$GLOBALS['SystemDataStructure'][$table]['primary'].' FROM CRM'.$GLOBALS['SystemDataStructure'][$table]['name_in_database'].' WHERE '.$deleted_part.' '.$fieldname.'='.$recordid);

                        foreach ($recordlist as $child_to_delete) {
                            $t = '';
                            if (ipi(str_replace('flextable', '', $GLOBALS['SystemDataStructure'][$table]['name_in_database']))) {
                                $t = str_replace('flextable', '', $GLOBALS['SystemDataStructure'][$table]['name_in_database']);
                            }
                            if ($return_list_only) {
                                foreach (DeleteFlexTableRow($child_to_delete, $t, true, true) as $ret_table => $count) {
                                    $list[$ret_table]['ok'] += $count['ok'];
                                    $list[$ret_table]['nok'] += $count['nok'];
                                    $list[$ret_table]['files'] += $count['files'];
                                    //print "Add count " . $count . " to table $ret_table <br>";
                                }
                            } else {
                                if (CheckTableRecordAccess($table, $child_to_delete) == 'ok') {
                                    ///print "SHOULD DELETE 1";
                                    DeleteFlexTableRow($child_to_delete, $t, true, false);
                                }
                            }
                        }
                    }
                }
            } elseif ($descend && count($GLOBALS['SystemDataStructure']['t'.$flextableid]['parents']) > 0) {
                return false;
            }
            if (!$return_list_only) {
                if (ipi($flextableid)) {
                    $sql = 'UPDATE '.$db_tablename." SET deleted='y' WHERE recordid='".mres($recordid)."'";
                    mcq($sql);

                    qlog(INFO, $sql);
                    AddToDo('FlexTable'.$flextableid.'-AnyUpdate', '', $recordid);
                    AddToDo('FlexTable'.$flextableid.'-Delete', '', $recordid);
                    AddToDo('FlexTable'.$flextableid.'-Change', '', $recordid);
                    log_msg('DELETE UNDO: UPDATE '.$db_tablename." SET deleted='n' WHERE recordid='".mres($recordid)."'");
                }
                $returntrue = true;
            }
        } else {
            log_msg('WARNING: A user tried to delete a record, but action failed: rec '.$recordid.' ft '.$flextableid);
        }
    }
    if ($return_list_only) {
        return $list;
    } elseif ($returntrue) {
        return true;
    } else {
        return false;
    }
}
function GetFlexTableRow($recordid, $flextableid)
{
    if ($recordid != '_new_') {
        return db_GetRow('SELECT * FROM CRMflextable'.$flextableid." WHERE recordid='".mres($recordid)."' AND deleted='n'");
    }

    return false;
}
function IsValidFlexTableRecord($recordid, $flextableid)
{
    if ($recordid > 0 && $flextableid > 0) {
        $check = db_GetValue('SELECT recordid FROM CRMflextable'.mres($flextableid)." WHERE recordid='".mres($recordid)."' AND deleted='n'");

        if ($check == $recordid) {
            return true;
        } else {
            return false;
        }
    }
}
function GetTemplateStyleSheet($templateid)
{
    if (CheckTemplateAccess($templateid) == 'ok') {
        return db_GetValue('SELECT stylesheet FROM CRMtemplates WHERE templateid='.$templateid);
    } else {
        return false;
    }
}
function ReturnStyleSheet($stylesheet_id)
{
    qlog(INFO, 'Fetching CSS id '.$stylesheet_id);
    if ($stylesheet_id != 0) {
        $css = GetTemplate($stylesheet_id);
        if ($css != '' && $css != '0') {
            // This CSS must be printed inline (for now) because it can also be e-mailed!
            $sheet = '<style type="text/css">'."\n";
            $sheet .= $css."\n";
            $sheet .= '</style>'."\n";

            return $sheet;
        } else {
            qlog(INFO, "Couldn't find any CSS template");

            return false;
        }
    } else {
        qlog(INFO, "Couldn't find any CSS template");

        return false;
    }
}
function ReturnTemplateStyleSheet($templateid)
{
    qlog(INFO, 'Fetching CSS for template '.$templateid);

    if (CheckTemplateAccess($templateid) == 'ok') {
        $id = GetTemplateStyleSheet($templateid);
        if (($id == 2147483647) || ($id == 0)) { // Means no CSS at all, also no <style> tags etc
            return ' ';
        } else {
            $css = GetTemplate($id);
            if ($css != '' && $css != '0' && $css != 'NO_CSS') {
                // This CSS must be printed inline (for now) because it can also be e-mailed!
                $sheet = '<style type="text/css">'."\n";
                $sheet .= $css."\n";
                $sheet .= '</style>'."\n";

                return $sheet;
            } elseif ($css == 'NO_CSS') {
                return ' ';
            } else {
                qlog(INFO, "Couldn't find any CSS template");

                return false;
            }
        }
    } else {
        qlog(INFO, "Couldn't find any CSS template");

        return false;
    }
}
function ParseTemplateUserAndGroupFields($template)
{
    //user/group fields are never formatted but displayed plain text; regardless of %EFID1% or @EFID1@
    //support for @EFID1@ and @f1@
    //it is probably faster to match known fields from the extrafields table against the template than vice versa, because we usually have many fields in an template and few fields in the user and groups table
    //todo user fields that are mentioned twice in the same template are parsed twice; we should consolidate first
    //this function is data structure unaware; which is good, because it can be called to make sql security parts INSIDE the data structure

    foreach (db_GetFlatArray("SELECT `id` FROM `CRMextrafields` WHERE `deleted`='n' AND `tabletype`='user'") as $efid) {
        if (preg_match('/(\@|\%)(EFID|f)'.$efid.'\\1/', $template)) {
            $value = db_GetValue('SELECT `EFID'.$efid.'` FROM `CRMloginusers` WHERE `id`='.$GLOBALS['USERID']);
            $template = preg_replace('/(\@|\%)(EFID|f)'.$efid.'\\1/', escape_interleave_characters(htme($value)), $template);
        }
    }

    //2016-10-13 AA doesn't use any group fields
    foreach (db_GetFlatArray("SELECT `id` FROM `CRMextrafields` WHERE `deleted`='n' AND `tabletype`='group'") as $efid) {
        if (preg_match('/(\@|\%)(EFID|f)'.$efid.'\\1/', $template)) {
            $value = db_GetValue('SELECT `EFID'.$efid.'` FROM `CRMuserprofiles` WHERE `id`='.$GLOBALS['GROUPID']);
            $template = preg_replace('/(\@|\%)(EFID|f)'.$efid.'\\1/', escape_interleave_characters(htme($value)), $template);
        }
    }

    return $template;
}
function GetProfileMembers($prof_num)
{
    $prof_members = array();
    $sql = '';
    if ($prof_num == 0) {
        $sql = "SELECT id FROM CRMloginusers WHERE administrator='yes' AND name NOT LIKE 'deleted_user_%' ORDER BY FULLNAME";
    } else {
        $sql = "SELECT id FROM CRMloginusers WHERE PROFILE='".mres($prof_num)."' AND name NOT LIKE 'deleted_user_%' ORDER BY FULLNAME";
    }
    foreach (db_GetArray($sql) as $row) {
        array_push($prof_members, $row['id']);
    }

    return $prof_members;
}
function PrintToolTipCode($txt, $ovrw = false, $widepx = false)
{
    $ret = '';
    if ($txt != '') {
        $ret = ' tttext="'.htme($txt).'"';
    }

    return $ret;
}
function PrintAD($numORmsg)
{
    $tmp = debug_backtrace();
    qlog(INFO, "TRACE:\n\n".GetBackTrace());

    $line = $tmp[0]['line'];

    qlog(WARNING, 'PrintAD called with message "'.$numORmsg.'"');
    log_msg('WARNING: PrintAD called with message "'.$numORmsg.$GLOBALS['AccessDeniedReason']."\"\n".string_r($tmp));
    if (GetSetting('BODY_ADMIN_ERRORMSG') == '') {
        echo '<div id="msgContainer">';
        echo "<div id='msgFormId'>";
        echo '<div id="baseMessage">';
        echo '<div class="errormsg">'.htme($numORmsg)."</div><div style=\"float: right;\" class=\"showinline\"><a href=\"#\" onclick=\"toggleLayer('msgContainer');\">close</a></div>";

        if ($GLOBALS['AccessDeniedReason']) {
            if (GetSetting('ShowMinimalErrorMessages') == 'No') {
                echo '<br>'.nl2br(htme($GLOBALS['AccessDeniedReason'])).'<br>';
            }
        }

        echo '<br><br>';
        echo "[<a onclick=\"hideLayer('baseMessage');showLayer('reportForm');\">Notify system administrator</a>]";
        echo '</div>';

        echo "<div id='reportForm' style='display: none;'>";
        echo '<div>By submitting this form you will report this event to your '.htme($GLOBALS['PRODUCT'])." administrator.</div><div style=\"float: right;\" class=\"showinline\"><a href=\"#\" onclick=\"toggleLayer('msgContainer');\">close</a></div><br><br>"; ?>
					You can add comments below. Technical details about what caused this message will be included automatically.<br><br>
					<form id='req_adm_act' method='post' action='message.php'>
						<table>
						<tr><td>From:</td><td><input type='text' style="width: 400px;" name='from_user' readonly value='<?php
        echo htme($GLOBALS['USERID']).': '.htme(GetUserName($GLOBALS['USERID'])); ?>'></td></tr>
						<tr><td>Repository:</td><td><input type='text' style="width: 400px;" readonly name='from_repos' value='<?php
        echo htme(GetSetting('title')); ?>'></td></tr>
						<tr><td>Location:</td><td><input type='text' style="width: 400px;" name='url' readonly value='<?php
        echo htme($_SERVER['REQUEST_URI']).':'.$line; ?>'>

						<?php
        $exmsg = "\n\nDescision trace: (if found)\n\n";
        if (is_array($GLOBALS['DECISIONTRACE'])) {
            foreach ($GLOBALS['DECISIONTRACE'] as $line) {
                $exmsg .= $line."\n";
            }
        }

        echo "<input type='hidden' name='trace' value=''>";

        if (GetSetting('ShowMinimalErrorMessages') == 'No') {
            $GLOBALS['ShowTraceLink'] = true;
        }

        if ($_REQUEST['nonavbar']) {
            ?>
							<input type='hidden' name='nonavbar' value='<?php
            echo htme($_REQUEST['nonavbar']); ?> '></td></tr>
						<?php

        } ?>

						<tr><td>Message:</td><td><input type='text' style="width: 400px;" name='message' readonly value='<?php
        echo htme($numORmsg); ?>'></td></tr>
						<tr><td>Action request:</td><td>
						<textarea name='content' style="width: 400px; height: 200px;"><?php
        echo htme("Hi,\n\nI just received the following message from ".$GLOBALS['PRODUCT'].":\n\n\"".$numORmsg."\"\n\nIs there anything you can do about that?\n\nRegards,\n".GetUserName($GLOBALS['USERID'])."\n".GetUserEmail($GLOBALS['USERID'])); ?></textarea></td></tr>
						<tr><td colspan='2'><input type='submit' value='Request administrative action'><input type='hidden' name='req_adm_act' value='1'></td></tr>

						</table>
					</form>
					<?php
        echo '</div>';
        echo '</div>';
    } else {
        echo str_replace('@ERRORMSG@', $numORmsg, GetSetting('BODY_ADMIN_ERRORMSG'));
    }
}
function AddMessage($to, $from, $subject, $body)
{
    // Adds a message to the message table
    // Returns message number
    if (strlen($body) > 0) {
        if ($to == 'admin') {
            $to = 0;
        }
        if ($from == '') {
            $from = '0';
        }

        $subbody = substr($body, 0, 500);

        $res = db_GetRow("SELECT id FROM CRMinternalmessages WHERE CRMinternalmessages.to='".mres($to)."' AND `from`='".mres($from)."' AND `subject`='".mres($subject)."' AND LEFT(body, 500) = '".mres($subbody)."'");

        if ($res['id'] > 0) {
            mcq("UPDATE CRMinternalmessages SET dub_count = (dub_count+1), `read`='n' WHERE id=".$res['id'].'');
        } else {
            mcq('INSERT INTO CRMinternalmessages(`to`, `from`, `subject`, `body`, `read`) VALUES ('.mres($to).','.mres($from).",'".mres($subject)."','".mres($body)."','n')");
        }
        $msgnum = db_GetInsertId();

        return $msgnum;
    }
}
function GetMessage($user, $id = 'all', $direction = 'to', $max = 99999999)
{
    // returns all or 1 messages in an array
    $sql_ins = '';
    if ($direction == 'from') {
        $sql_ins = " WHERE `from=`'".mres($user)."' ";
    } else {
        if (is_administrator()) {
            $sql_ins = ' WHERE 1=1 ';
        } else {
            $sql_ins = " WHERE `to`='".mres($user)."' ";
        }
    }
    if ($id == 'all') {
        if ($user == 'admin') {
            $user = 0;
        }

        $retarray = db_GetArray("SELECT *, date_format(timestamp_last_change, '%a %M %e, %Y %H:%i') AS time_formatted FROM CRMinternalmessages ".$sql_ins.' ORDER BY id DESC LIMIT '.$max.' ');

        return $retarray;
    } elseif (is_numeric($id)) {
        // returns 1 message row in an array
        return db_GetRow("SELECT *, date_format(timestamp_last_change, '%a %M %e, %Y %H:%i') AS time_formatted FROM CRMinternalmessages ".$sql_ins." AND id='".mres($id)."' ORDER BY id DESC");
    }
}
function DeleteMessage($id, $user, $direction, $readorall)
{
    if ($user == 'admin') {
        $user = '0';
    }
    qlog(INFO, 'Deleting internal message '.$id.' of user '.$user);
    if ($id == 'all') {
        if ($readorall == 'read') {
            if ($direction == 'from') {
                mcq("DELETE FROM CRMinternalmessages WHERE CRMinternalmessages.from='".mres($user)."' AND `read`='y'");
            } elseif ($direction == 'to') {
                mcq("DELETE FROM CRMinternalmessages WHERE CRMinternalmessages.to='".mres($user)."' AND `read`='y'");
            }
        } elseif ($readorall == 'all') {
            if ($direction == 'from') {
                mcq("DELETE FROM CRMinternalmessages WHERE CRMinternalmessages.from='".mres($user)."'");
            } elseif ($direction == 'to') {
                mcq("DELETE FROM CRMinternalmessages WHERE CRMinternalmessages.to='".mres($user)."'");
            }
        }
    } elseif (is_numeric($id) || $id == '0') {
        mcq("DELETE FROM CRMinternalmessages WHERE CRMinternalmessages.to='".mres($user)."' AND id='".mres($id)."'");
        if (is_administrator()) {
            mcq("DELETE FROM CRMinternalmessages WHERE CRMinternalmessages.to='0' AND id='".mres($id)."'");
        }
    }
}
function MarkMessageRead($id)
{
    if ($id == 'all') {
        mcq("UPDATE CRMinternalmessages SET `read`='y', `timestamp_last_change`=`timestamp_last_change` WHERE CRMinternalmessages.to='".mres($user)."' AND `read`='n'");
    } elseif ($id > 0) {
        mcq("UPDATE CRMinternalmessages SET `read`='y', `timestamp_last_change`=`timestamp_last_change` WHERE id='".mres($id)."'");
    }
}
function UserMessage()
{
    /* switched off, only for administrators, because we were giving away usernames */
    if (is_administrator()) {
        global $lang;

        echo '<div id="usermessages">';

        if ($_REQUEST['UserMessageBody'] && $_REQUEST['UserMessageTo']) {

            /*
            $cl = GetClearanceLevel($GLOBALS['USERID']);
            if (in_array("SendMessagesToAllUsers", $cl)) {
            print "<option value='all_users'>- all users -</option>";
            foreach (GetGroups() AS $group) {
            print "<option value='group_" . $group['id'] . "'>- all users in group " . mres($group['name']) ." -</option>";
            }
            }
            */
            $msg_id = '';

            if ($_REQUEST['UserMessageTo'] == 'all_users' || substr($_REQUEST['UserMessageTo'], 0, 6) == 'group_') {
                $group_ins = '';
                if (substr($_REQUEST['UserMessageTo'], 0, 6) == 'group_') {
                    $group_ins = " AND PROFILE='".str_replace('group_', '', $_REQUEST['UserMessageTo'])."'";
                }
                $cl = GetClearanceLevel($GLOBALS['USERID']);
                if (in_array('SendMessagesToAllUsers', $cl) || is_administrator()) {
                    $sndcnt = 0;
                    foreach (db_GetFlatArray("SELECT * FROM CRMloginusers WHERE name NOT LIKE 'deleted_user%' ".$group_ins) as $user) {
                        AddMessage($user, $GLOBALS['USERID'], $_REQUEST['UserMessageSubject'], $_REQUEST['UserMessageBody']);
                        ++$sndcnt;
                    }
                    $msg_id = '('.$sndcnt.' messages send)';
                } else {
                    PrintAD("You're not allowed to send messages to multiple recipients.");
                    EndHTML();
                    exit;
                }
            } else {
                $msg_id = AddMessage($_REQUEST['UserMessageTo'], $GLOBALS['USERID'], $_REQUEST['UserMessageSubject'], $_REQUEST['UserMessageBody']);
            }
            echo '<h2>'.$lang['yourmessagewassend'].' '.$msg_id.'</h2>';
            $_REQUEST['ReadInternalMessage'] = '';
            $_REQUEST['ComposeNewMessage'] = '';
            if ($_REQUEST['nonavbar'] != '') {
                echo JS("CloseMe();WhosMyDaddy().window.location.href='index.php?UserMessage';");
            }
        }
        if ($_REQUEST['PurgeMessages'] == 'readtome') {
            //		DeleteMessage("all", $GLOBALS['USERID'], "from", "read");
        } elseif ($_REQUEST['PurgeMessages'] == 'readfromme') {
            DeleteMessage('all', $GLOBALS['USERID'], 'to', 'read');
            if (is_administrator()) {
                DeleteMessage('all', 'admin', 'to', 'read');
            }
        } elseif ($_REQUEST['PurgeMessages'] == 'allfromme') {
            DeleteMessage('all', $GLOBALS['USERID'], 'to', 'all');
            if (is_administrator()) {
                DeleteMessage('all', 'admin', 'to', 'all');
            }
        } elseif (is_numeric($_REQUEST['PurgeMessages'])) {
            DeleteMessage($_REQUEST['PurgeMessages'], $GLOBALS['USERID'], 0, 0);
            if ($_REQUEST['nonavbar'] != '') {
                echo JS("CloseMe();WhosMyDaddy().window.location.href='index.php?UserMessage';");
            }
        } elseif (isset($_REQUEST['MarkAllRead'])) {
            MarkMessageRead('all', $GLOBALS['USERID'], 0, 0);
            if ($_REQUEST['nonavbar'] != '') {
                echo JS("CloseMe();WhosMyDaddy().window.location.href='index.php?UserMessage';");
            }
        }
        if (is_numeric($_REQUEST['ReadInternalMessage'])) {
            $msg = GetMessage($GLOBALS['USERID'], $_REQUEST['ReadInternalMessage'], 'to');
            if (!is_array($msg) && is_administrator()) {
                $msg = GetMessage('admin', $_REQUEST['ReadInternalMessage'], 'to');
            }
            echo '<div id="messageform">';

            echo '<h1>'.htme(($msg['subject'])).'</h1>';
            echo '<p>';
            if ($_REQUEST['nonavbar'] == '') {
                echo "[<a href='index.php?UserMessage'>".$lang['messageinbox'].'</a>] &nbsp;';
            }
            echo "[<a href=\"#\" onclick=\"toggleLayer('messagediv');toggleLayer('replyform');\">reply</a>] [<a href='index.php?UserMessage&amp;PurgeMessages=".$msg['id'].'&amp;nonavbar='.$_REQUEST['nonavbar']."'>".htme($lang['delete']).'</a>] &nbsp; ';

            echo 'From: '.htme(GetUserName($msg['from'])).'';
            if ($msg['to'] > 0) {
                echo ', to: '.htme(GetUserName($msg['to'])).'';
            } else {
                echo ', to admin';
            }
            echo ', on: '.htme($msg['time_formatted']).'';
            if ($msg['to'] == 0) {
                echo ', times received: '.htme($msg['dub_count']).'';
            }
            echo '</p>';
            if ($msg['from'] != 0) {
                echo '<div id="replyform" style="display: none;">';
                echo '<h2>Reply</h2>';
                echo '<table class="crm5">';

                echo "<tr><td colspan='2'><form id='UserMessageForm' method='post' action=''><div class='showinline'><input type='hidden' name='UserMessage' value='Yes'>";
                echo "<input type='hidden' name='UserMessageTo' value='".htme($msg['from'])."'>";
                echo '<tr><td>To:</td><td>'.htme(GetUserName($msg['from'])).'</td></tr>';
                echo "<tr><td>Subject:</td><td><input type='text' name='UserMessageSubject' size='50' value='RE: ".htme(($msg['subject']))."'></td>";
                echo "<tr><td colspan='2'>Message:<br><textarea rows='10' cols='100' name='UserMessageBody'>\n\n\n-------------------\n".htme($msg['body']).'</textarea>';
                echo "<tr><td></td><td class=\"rightalign\"><input type='submit' value='".$lang['sendmessage']."'></td></tr></table>";
                echo '</div>';
            }
            echo '<div id="messagediv">';
            echo '<h2>Message</h2>';

            echo '<table class="crm5">';
            echo "<tr><td colspan='2'><pre>".htme(($msg['body'])).'</pre></td></tr>';
            echo '</table>';
            echo '</div>';
            echo '</div>';
            qlog(INFO, 'Reading message '.$msg['id'].' - marking it as read');
            MarkMessageRead($msg['id']);
        } elseif ($_REQUEST['ComposeNewMessage']) {
            echo '<div id="messageform">';
            echo "<form id='UserMessageForm' method='post' action=''><div class='showinline'><input type='hidden' name='UserMessage' value='Yes'>";
            echo '<table><tr><td>To</td><td>';
            $result = select_refer_field_options('messages', 'to', 0);

            echo "<select name='UserMessageTo' id='JS_UserMessageTo'>";

            echo "<option value='admin'>- any administrator -</option>";
            $cl = GetClearanceLevel($GLOBALS['USERID']);
            if (in_array('SendMessagesToAllUsers', $cl) || is_administrator()) {
                echo "<option value='all_users'>- all users -</option>";
                foreach (GetGroups() as $group) {
                    echo "<option value='group_".$group['id']."'>- all users in group ".mres($group['name']).' -</option>';
                }
            }
            foreach ($result as $value => $text) {
                if ($text != '') {
                    echo "<option value='".$value."'>".htme($text).'</option>';
                }
            }
            echo '</select>&nbsp;'.ReturnDropDownSearchField('JS_UserMessageTo').'</td></tr>';
            echo "<tr><td>Subject</td><td><input type='text' name='UserMessageSubject' size='80'><input type='hidden' name='nonavbar' value='1'></td>";
            echo "<tr><td class=\"topalign\">Message</td><td><textarea cols='80' rows='15' name='UserMessageBody'></textarea></td></tr>";
            echo "<tr><td></td><td class=\"rightalign\"><input type='submit' value='".$lang['go']."'></td></tr>";
            echo '</div></form></table>';
            echo '</div>';
        } else {
            echo "[<a href='index.php?UserMessage'>".$lang['messageinbox'].'</a>] &nbsp;';
            echo "[<a href='index.php?UserMessage&amp;PurgeMessages=allfromme'>".$lang['deleteallfrominbox'].'</a>]&nbsp;';
            echo '<div id="messageslist">';

            list($number_of_records, $output) = make_list(array('table' => 'messages'));
            echo $output;

            echo '</div>';
        }
        echo '</div>';
    }
}
function do_language()
{
    global $lang;

    $system_language = db_GetValue("SELECT TEXT FROM CRMlanguages WHERE TEXTID='current-language' AND LANGID='GLOBAL'");
    $user_language = '';

    if (ipi($GLOBALS['USERID'])) {
        $user_language = GetAttribute('user', 'LanguagePack', $GLOBALS['USERID']);
        if ($user_language == '') {
            SetAttribute('user', 'LanguagePack', '{{system}}', $GLOBALS['USERID']);
        }
    }

    $ltl = '';

    if ($user_language != '{{system}}' && $user_language != '') {
        $ltl = $user_language;
    } else {
        //jh 2015-10-07 als een user geen eigen lang voorkeur heeft opgegegeven in Interleave dan geven we voorrang aan de ingestelde browser language (mits die beschikbaar is in interleave), zo niet, dan nemen we de system language
        //hierdoor is de login page in de geprefereerde taal van de bezoeker
        $preferred_browser_lang = '';
        if (GetSetting('UseBrowserPreferredLanguage') == 'Yes') {
            $preferred_browser_lang = get_preferred_browser_lang();
        }
        if ($preferred_browser_lang != '') {
            $ltl = $preferred_browser_lang;
        } elseif ($system_language != '') {
            $ltl = $system_language;
        } else {
            //kan beter de eerst beschikbare language selecteren ipv engels
            $ltl = 'ENGLISH';
        }
    }

    if ($GLOBALS['LANGUAGE'] == $ltl) {
        /* already loaded */
        return $lang;
    }

    $GLOBALS['LANGUAGE'] = $ltl;

    //deze codes zouden in de languages tabel opgeslagen moeten zijn; let op; deze array staat 2x in functions.php
    $interleave_language_to_2_letter_codes = array('ENGLISH' => 'en', 'NEDERLANDS' => 'nl', 'FRANCAIS' => 'fr', 'DEUTSCH' => 'de', 'ESPANOL' => 'es');

    if ($interleave_language_to_2_letter_codes[$ltl] != '') {
        $GLOBALS['LANGUAGE_2_LETTER_CODE'] = $interleave_language_to_2_letter_codes[$ltl];
    }

    $lang = array();

    // TODO; Dit is qua security niet netjes. Tabel- en veldnamen kunnen worden exposed
    foreach (db_GetArray('SELECT recordid, tablename FROM CRMflextabledefs') as $ft) {
        $lang['flextable'.$ft['recordid'].'plural'] = $ft['tablename'];
    }
    foreach (db_GetArray("SELECT id, name, displaylistname FROM CRMextrafields WHERE deleted='n'") as $extrafield) {
        $lang['EFID'.$extrafield['id']] = $extrafield['name'];
        $lang['EFID'.$extrafield['id'].'DLN'] = $extrafield['name'];
        if ($extrafield['displaylistname'] != '') {
            $lang['EFID'.$extrafield['id'].'DLN'] = $extrafield['displaylistname'];
        }
    }
    foreach (db_GetArray("SELECT TEXTID, TEXT FROM CRMlanguages WHERE LANGID='".mres($ltl)."' ORDER BY TEXTID") as $row) {
        $lang[$row['TEXTID']] = $row['TEXT'];
        //om ook de display list name te overschrijven; we hebben georderd by TEXTID, dus we overschrijven hier alleen de DLN van de standaard language
        if (preg_match("/^EFID\d+$/", $row['TEXTID'])) {
            $lang[$row['TEXTID'].'DLN'] = $row['TEXT'];
        }
        //			$tel++;
    }
    //	qlog(INFO, "Loaded language " . $ltl . " (" . $tel . " tags)");
    /*
    if (($mtl != "") && ($mtl != "-") && ($mtl != $ltl)) {
    $tel = 0;

    foreach (db_GetArray("SELECT TEXTID, TEXT FROM CRMlanguages WHERE LANGID='" . mres($mtl) . "'") AS $row) {
    $lang[$row['TEXTID']] = $row['TEXT'];
    $tel++;
    }
    qlog(INFO, "Loaded language mask " . $mtl . " (" . $tel . " tags)");
    }
    */

    /*
    foreach (array_keys($GLOBALS['UC']['PersonalDataStructure']) as $table)
    {
    foreach (array_keys($GLOBALS['UC']['PersonalDataStructure'][$table]["fields"]) as $field)
    {
    if (preg_match("/^f(\d+)$/", $last_field, $efidmatch))
    {
    $lang["EFID" . $efidmatch[1]] = $GLOBALS['UC']['PersonalDataStructure'][$table]["fields"][$field]["name"];
    }
    }
    }
    */

    return $lang;
}

function get_preferred_browser_lang()
{
    //code from http://www.thefutureoftheweb.com/blog/use-accept-language-header
    $langs = array();

    if (isset($_SERVER['HTTP_ACCEPT_LANGUAGE'])) {
        // break up string into pieces (languages and q factors)
        preg_match_all('/([a-z]{1,8}(-[a-z]{1,8})?)\s*(;\s*q\s*=\s*(1|0\.[0-9]+))?/i', $_SERVER['HTTP_ACCEPT_LANGUAGE'], $lang_parse);

        if (count($lang_parse[1])) {
            // create a list like "en" => 0.8
            $langs = array_combine($lang_parse[1], $lang_parse[4]);

            // set default to 1 for any without q factor
            foreach ($langs as $lang => $val) {
                if ($val === '') {
                    $langs[$lang] = 1;
                }
            }

            // sort list based on value
            arsort($langs, SORT_NUMERIC);
        }
    }

    //deze codes zouden in de languages tabel opgeslagen moeten zijn; let op; deze array staat 2x in functions.php
    $interleave_language_to_2_letter_codes = array('ENGLISH' => 'en', 'NEDERLANDS' => 'nl', 'FRANCAIS' => 'fr', 'DEUTSCH' => 'de', 'ESPANOL' => 'es');

    $available_interleave_languages = array();

    foreach (db_GetFlatArray("SELECT DISTINCT(LANGID) FROM CRMlanguages WHERE LANGID!='GLOBAL'") as $lang) {
        if ($interleave_language_to_2_letter_codes[$lang] != '') {
            $available_interleave_languages[$interleave_language_to_2_letter_codes[$lang]] = $lang;
        }
    }

    // look through sorted list and use first one that matches our languages
    foreach ($langs as $lang => $val) {
        list($part1, $part2) = explode('-', $lang);
        if ($available_interleave_languages[$part1] != '') {
            return $available_interleave_languages[$part1];
        }
    }

    return '';
}

// FIX FOR: "Unknown function: memory_get_usage()"
// FIX -BEGIN-
if (!function_exists('memory_get_usage')) {
    function memory_get_usage()
    {
        return false;
    }
}
// FIX -END-
// MODULE INCLUDE EXTRA CODE
function GetModules()
{
    return db_GetArray('SELECT * FROM CRMmodules WHERE version_belonging_to=0');
}

function RunModule($mid, $eid = false, $return = false, $flextablerecord = false, $flextableid = false, $customerid = false, $dqs = '', $ds_table = '')
{
    global $lang, $secure_modules;

    if ($secure_modules[$GLOBALS['repository']] == 'yes') {
        /* deze kan weg eigenlijk */
        if (GetSetting('DevelopmentOrProduction') == 'Development') {
            $ls = new SaferScript('<?php ?>'.db_GetValue("SELECT module_code FROM CRMmodules WHERE mid='".mres($mid)."'").'<?php ?>');
            $ls->allowHarmlessCalls();
            $res = $ls->parse();
            if (count($res) > 0) {
                // illegal function calls found
                if ($return) {
                    return 'illegal function calls - not executing module: '.string_r($res);
                } else {
                    echo 'illegal function calls - not executing module: ';
                    DA($res);
                }
            }
        }
    }
    /*
    Disabled for performance

    $cnt = GetAttribute("module", "ModuleRunCount", $mid);
    if (!is_numeric($cnt)) {
    $cnt = 1;
    } else {
    $cnt++;
    }
    SetAttribute("module", "ModuleRunCount", $cnt, $mid);
    */
    $dbname1 = db_GetValue('SELECT DATABASE()');

    $recordid = 0;
    if ($ds_table == '') {
        if (ipi($flextablerecord)) {
            $ds_table = 't'.$flextableid;
            $recordid = $flextablerecord;
        }
    } else {
        $recordid = $flextablerecord;
        $eid = 0;
        $cid = 0;
    }
    /*



    print "Recordid $recordid<br>";
    print "flextablerecord $flextablerecord<br>";
    */

    $DontFetchDQS = GetAttribute('module', 'DontFetchDQS', $mid);
    $DontBufferOutput = GetAttribute('module', 'DontBufferOutput', $mid);

    //	if (is_numeric($_REQUEST['dqs'])) {
    if ($dqs > 0 && $DontFetchDQS != 'Yes') {
        $q = PopStashValue($dqs);
        //print "Query: " . $q;
        if (trim($q) != '') {
            $list_of_records = db_GetFlatArray($q);

            $GLOBALS['eids'] = array();
            $GLOBALS['ftids'] = array();
            $GLOBALS['recordids'] = array();
            foreach ($list_of_records as $row) {
                $GLOBALS['eids'][] = $row;
                $GLOBALS['recordids'][] = $row;
            }
        } else {
            log_msg('WARNING: A dqs record was given, though returned empty. This affects the users functionality.');
        }
    }

    $tmp = CheckModuleAccess($mid);
    if ($tmp == 'ok') {
        if (!$mid) {
            qlog(ERROR, 'ERROR : No module ID received');
            log_msg('ERROR : No module ID received');
            $return = false;
        } else {
            qlog(INFO, 'Running module '.$mid);

            $cur_user = 0;
            $revert_user = false;
            $RunAsUser = GetAttribute('module', 'RunAsUser', $mid);
            if (is_numeric($RunAsUser) && $RunAsUser != $GLOBALS['USERID']) {
                // This module needs to be ran using the credentials of another user
                $cur_user = $GLOBALS['USERID'];
                $GLOBALS['USERID'] = $RunAsUser;
                InitUser();
                $revert_user = true;
            }

            $module = db_GetRow("SELECT module_code,module_name,mid FROM CRMmodules WHERE mid='".mres($mid)."'");

            if (ipi($module['version_belonging_to'])) {
                /* this means it's an old version of a module. not allowed */
                log_msg('ERROR: This module ('.$mid.') is an old version of another module. Not allowed to run directly.');

                return '';
            }

            $code = $module['module_code'];

            $unique_command_id = 'user_'.$GLOBALS['USERID'].'_module_'.$mid;
            if (!max_one_concurrent_load_start($unique_command_id)) {
                return '<div class="errmsg">This module is already loading. Please be patient.</div>';
            }
            if ($DontBufferOutput != 'Yes') {
                ob_start();
            } else {
                echo date('r').': Disabled output buffering'."\n";
            }

            eval('?>'.$code);

            if ($DontBufferOutput != 'Yes') {
                $output = ob_get_contents();
            }

            if ($DontBufferOutput != 'Yes') {
                ob_end_clean();
            }
            if (!$return) {
                if ($DontBufferOutput != 'Yes') {
                    echo $output;
                }
            }

            qlog(INFO, 'Done running module');
            $dbname2 = db_GetValue('SELECT DATABASE()');

            // If current database != initinal database
            if ($dbname1 != $dbname2) {
                // Restore privileges to avoid hacking.
                include $GLOBALS['CONFIGFILE'];

                SwitchToRepos($GLOBALS['repository']);
            } else {
                //$output .= "no-STR";
            }

            if ($revert_user) {
                $GLOBALS['USERID'] = $cur_user;
                InitUser();
            }

            $lr = date('U');
            if (stristr($output, "eval()'d code")) {
                mcq("UPDATE CRMmodules SET module_last_run_date='".$lr."', timestamp_last_change = timestamp_last_change, module_last_run_result='ERROR' WHERE mid='".mres($module['mid'])."'");
            } else {
                //		print "No errors detected while running this module";
                mcq("UPDATE CRMmodules SET module_last_run_date='".$lr."', timestamp_last_change = timestamp_last_change, module_last_run_result='OK' WHERE mid='".mres($module['mid'])."'");
            }

            max_one_concurrent_load_finish($unique_command_id);

            if ($return) {
                return $output;
            }
        }
    } else {
        qlog(INFO, 'Running module '.$mid.' denied because of insufficient access rights');
        log_msg('Running module '.$mid.' denied because of insufficient access rights');
        if (!$return) {
            PrintAD("You don't have access to this module (".$mid.')');
        } else {
            return '<!-- No access -->';
        }
    }
}

function ReturnReposList()
{
    include $GLOBALS['CONFIGFILE'];
    $a = '';
    $a .= " MM = Maintenance mode Yes/No. F/O = Fail-over database configured Yes/No\n";
    $a .= "--------------------------------------------------------------------------------------------------------------------------\n";
    $a .= " Num |  Version         | Database name        | # Ent. | MM   | F/O | Size   | Repository                               |\n";
    $a .= "--------------------------------------------------------------------------------------------------------------------------\n";
    for ($t = 0; $t < 64; ++$t) {
        if (DB_Connect($t) && $host[$t]) {
            $database[$t] = trim($database[$t]);

            $title = GetSetting('title');
            $version = GetSetting('DBVERSION');
            $mm = GetSetting('MAINTENANCE_MODE');
            if ($version == '') {
                $version = 'Prior to 1.9.0.';
            }

            $fo = 'N/A';

            $size = GetCurrentDBTotalSize();
            //											ver dbnam ent mm
            $a .= ' '.fillout($t, 3).' |  '.fillout($version, 15).' | '.fillout($database[$t], 20).' | '.fillout($enum, 6).' | '.fillout($mm, 4).' | '.$fo.' | '.fillout($size, 5).'M | '.fillout($title, 40)." |\n";
        }
    }
    $a .= "--------------------------------------------------------------------------------------------------------------------------\n";

    return $a;
}
function SwitchToRepos($repository_nr)
{
    include $GLOBALS['CONFIGFILE'];
    global $lang;

    if ($host[$repository_nr]) {
        qlog(INFO, 'Trying to connect to repository '.$repository_nr);
        if (DB_Connect($repository_nr)) {
            qlog(INFO, 'Using mysql://'.$user[$repository_nr].'@'.$host[$repository_nr].':'.$database[$repository_nr].'/CRM*');
            $GLOBALS['repository'] = $repository_nr;
        } else {
            qlog(INFO, 'Connection error');

            return false;
        }

        qlog(INFO, 'Connection succeeded');

        if (is_numeric($GLOBALS['USERID'])) {
            $lang = do_language();
            InitUser();
        }

        return true;
    } else {
        //		print "Help! Called without repository number. I'm clueless! [$repository_nr]";
        return false;
    }
}
function GetFileEarlierVersions($fileid)
{
    return db_GetArray("SELECT * FROM CRMbinfiles WHERE version_belonging_to='".mres($fileid)."' ORDER BY timestamp_last_change DESC, fileid DESC");
}
function GetSetting($setting)
{
    if (!is_array($GLOBALS['settings'])) {
        $GLOBALS['settings'] = array();
        foreach (db_GetArray("SELECT attribute, value FROM CRMattributes WHERE entity=2 AND identifier='system'") as $row) {
            //code duplicatie uit GetAttribute()
            $t = $row['value'];
            $t2 = unserialize($t);
            if ($t2) {
            } elseif (strtolower($t) == 'a:0:{}') {
                //is dit wel nodig?
                $t2 = array();
            } elseif (strtolower($t) == '{{none}}') {
                $t2 = false;
            } else {
                $t2 = $t;
            }
            $GLOBALS['settings'][strtolower($row['attribute'])] = $t2;
        }
        foreach (db_GetArray('SELECT setting, value FROM CRMsettings') as $row) {
            $GLOBALS['settings'][strtolower($row['setting'])] = $row['value'];
        }
    }

    return $GLOBALS['settings'][strtolower($setting)];
}
function UpdateSetting($setting, $value)
{
    $val = db_GetFlatArray("SELECT value FROM CRMsettings WHERE setting='".$setting."'");
    if (count($val) == 0) {
        mcq("INSERT INTO CRMsettings(setting) VALUES('".$setting."')");
    }

    mcq("UPDATE CRMsettings SET value='".mres($value)."' WHERE setting='".mres($setting)."'");
}
function ShowClock()
{
    return "<span id=\"js_clock\"> <script type=\"text/javascript\"> function js_clock(){ var clock_time = new Date(); var clock_hours = clock_time.getHours(); var clock_minutes = clock_time.getMinutes(); var clock_seconds = clock_time.getSeconds(); var clock_suffix = \"\"; if (clock_hours > 11){ clock_suffix = \"\"; clock_hours = clock_hours; } if (clock_hours < 10){ clock_hours = \"0\" + clock_hours; } if (clock_minutes < 10){ clock_minutes = \"0\" + clock_minutes; } if (clock_seconds < 10){ clock_seconds = \"0\" + clock_seconds; } var clock_div = document.getElementById('js_clock'); clock_div.innerHTML = '".TransformDate(date('d-m-Y'))." ' + clock_hours + \":\" + clock_minutes + \":\" + clock_seconds + \" \" + clock_suffix; setTimeout(\"js_clock()\", 1000); } js_clock(); </script> </span> ";
}
function ShowMessagesList()
{
    global $lang;
    $outp = '<div id="messageslist">';
    $outp .= "<a href='index.php?UserMessage'>".$lang['messageinbox'].'</a>';
    $outp .= "<table class='crm'>";
    $outp .= '<thead><tr><th><strong>From</strong></th><th><strong>Subject</strong></th><th><strong>Date/time</strong></th></tr></thead>';
    $msglist = GetMessage($GLOBALS['USERID'], 'all', 'to', 8);
    $x = 0;
    foreach ($msglist as $msg) {
        $font_ins1 = '';
        $font_ins2 = '';
        if ($msg['read'] == 'n') {
            $font_ins1 = "<span style='color: #3300FF;'>";
            $font_ins2 = '</span>';
        }
        $outp .= "<tr onclick=\"window.location.href='index.php?UserMessage&amp;ReadInternalMessage=".$msg['id']."'\" class='pointer' onmouseover=\"style.background='#cccccc';\"  onmouseout=\"style.background='#ffffff';\"><td>".$font_ins1.GetUserName($msg['from']).$font_ins2.'</td><td>'.$font_ins1.$msg['subject'].$font_ins2.'</td><td>'.$font_ins1.$msg['time_formatted'].$font_ins2.'</td></tr>';
        ++$x;
    }
    if (is_administrator()) {
        $msglist = GetMessage('admin', 'all', 'to', 8);
        foreach ($msglist as $msg) {
            $font_ins1 = '';
            $font_ins2 = '';
            if ($msg['read'] == 'n') {
                $font_ins1 = "<span style='color: #3300FF;'>";
                $font_ins2 = '</span>';
            }
            $outp .= "<tr onclick=\"window.location.href='index.php?UserMessage&amp;ReadInternalMessage=".$msg['id']."'\" class='pointer' onmouseover=\"style.background='#cccccc';\"  onmouseout=\"style.background='#ffffff';\"><td>".$font_ins1.GetUserName($msg['from']).$font_ins2.'</td><td>'.$font_ins1.$msg['subject'].$font_ins2.'</td><td>'.$font_ins1.$msg['time_formatted'].$font_ins2.'</td></tr>';
            ++$x;
        }
    }
    $outp .= '</table></div>';
    if ($x > 0) {
        return $outp;
    } else {
        return "<a href='index.php?UserMessage'>".$lang['messageinbox'].'</a><br><br>'.$lang['nomessages'];
    }
}

function GenerateImageThumbnails($eid = 'all', $print = false, $fileid = '')
{
    if (GetSetting('ENABLEIMAGETHUMBNAILS') == 'Yes') {
        $sql = '';
        if (ipi($fileid)) {
            qlog(INFO, 'Generating thumbnail by file id...');
            $sql = "SELECT CRMblobs.content, CRMblobs.fileid,CRMbinfiles.filetype FROM CRMblobs, CRMbinfiles WHERE CRMbinfiles.filetype IN ('image/jpeg','image/gif','image/png') AND CRMbinfiles.fileid=CRMblobs.fileid AND CRMbinfiles.fileid=".$fileid;
        } elseif ($eid == 'all') {
            qlog(INFO, 'Generating all thumbnails (new only)...');
            $sql = "SELECT CRMblobs.content, CRMblobs.fileid,CRMbinfiles.filetype FROM CRMblobs, CRMbinfiles WHERE CRMbinfiles.filetype IN ('image/jpeg','image/gif','image/png') AND CRMblobs.thumbnail='' AND CRMbinfiles.fileid=CRMblobs.fileid";
        } else {
            qlog(INFO, 'Generating all thumbnails (new only, only eid '.$eid.')...');
            $sql = "SELECT CRMblobs.content, CRMblobs.fileid, CRMbinfiles.filetype FROM CRMblobs, CRMbinfiles WHERE CRMbinfiles.filetype IN ('image/jpeg','image/gif','image/png') AND CRMblobs.thumbnail='' AND CRMbinfiles.koppelid='".mres($eid)."' AND CRMbinfiles.fileid=CRMblobs.fileid";
        }
        $res = mcq($sql);
        $ret = '';
        while ($row = mysqli_fetch_array($res)) {
            $file = tempnam(GetSetting('TMP_FILE_PATH'), 'CRM_TMP_RESBIN_');
            $fp = fopen($file, 'w');

            fputs($fp, $row['content']);
            fclose($fp);
            $tn = CreateImageThumbnail($file, $row['filetype']);
            unlink($file);
            if (strlen($tn) > 1) {
                mcq("UPDATE CRMblobs SET thumbnail='".mres($tn)."' WHERE fileid=".$row['fileid']." AND thumbnail=''");
                if (is_positive_integer($fileid)) {
                    $ret = $tn;
                    qlog(INFO, 'Returning thumbnail ...');
                }
                if ($print) {
                    echo "\015Thumbnail created for file ".$row['fileid'].' '.GetSetting('title').' '.$row['filetype'].'';
                }
            } else {
                if ($print) {
                    echo "\015FAILED to create a thumbnail for file ".$row['fileid'].' '.GetSetting('title').'';
                }
                if (is_positive_integer($fileid)) {
                    $ret = $tn;
                    qlog(INFO, 'NOT Returning thumbnail (failed!)');
                }
            }
            unset($tn);
        }
        if ($print) {
            echo "\015Done.                                                                                                          \n";
        }
        qlog(INFO, 'Finished thumbing...');

        return $ret;
    } else {
        qlog(INFO, 'Image thumbnailing is disabled');

        return false;
    }
}
function GetImageThumbnail($fileid)
{
    if (GetSetting('ENABLEIMAGETHUMBNAILS') == 'Yes') {
        $row = db_GetRow("SELECT thumbnail FROM CRMblobs WHERE fileid='".mres($fileid)."' AND thumbnail!=''");
        if ($row['thumbnail'] != '') {
            qlog(INFO, 'Fetched thumbnail '.$fileid.'from database');

            return $row['thumbnail'];
        } else {
            qlog(INFO, 'Generating thumbnail '.$fileid.' on the fly');

            return GenerateImageThumbnails('', false, $fileid);
        }
    } else {
        qlog(INFO, 'Image thumbnailing is disabled');

        return false;
    }
}
function GetMiniThumbnail($fileid)
{
    if (is_positive_integer($fileid)) {
        $row = db_GetRow('SELECT minithumbnail FROM CRMblobs WHERE fileid='.$fileid." AND minithumbnail!=''");
        if ($row['minithumbnail'] != '') {
            qlog(INFO, 'Fetched minithumbnail '.$fileid.'from database');

            return $row['minithumbnail'];
        } else {
            qlog(INFO, 'Generating minithumbnail '.$fileid.' on the fly');
            $fileondisk = CopyFileToDisk($fileid);
            $img = CreateImageThumbnail($fileondisk, GetFileType($fileid), 26);
            unlink($fileondisk);
            mcq("UPDATE CRMblobs SET minithumbnail='".mres($img)."' WHERE fileid=".$fileid);

            return $img;
        }
    } else {
        return false;
    }
}
function CreateImageThumbnail($img_path, $format, $fixedwidth = 240)
{
    if (GetSetting('ENABLEIMAGETHUMBNAILS') == 'Yes') {
        if (!ipi($fixedwidth)) {
            $fixedwidth = 240;
        }
        $copyrightmsg = GetSetting('ImageThumbailCopyrightMessage');
        $autorotate = true;

        return ResizeImage(file_get_contents($img_path), $fixedwidth, 'aspect', '255,255,255', '104,104,104', $copyrightmsg, $autorotate);
    } else {
        qlog(INFO, 'Image thumbnailing is disabled');

        return false;
    }
}
function SetMimeType($fileid)
{
    mcq("UPDATE CRMbinfiles SET filetype='".mres(GetMimeType($fileid))."' WHERE fileid='".mres($fileid)."'");

    return true;
}
function GetMimeType($fileid)
{
    $fn = CopyFileToDisk($fileid);
    $finfo = finfo_open(FILEINFO_MIME_TYPE);
    $mime = finfo_file($finfo, $fn);
    finfo_close($finfo);
    unlink($fn);

    return $mime;
}
function DeleteOldVersions()
{
    PrintAD('This feature is not (yet) implemented');
}
function DropPersonalDataStructure($userid)
{
    global $lang;

    if ($userid > 0) {
        mcq("DELETE FROM CRMdatastructures WHERE userid='".mres($userid)."'");
    } else {
        mcq('TRUNCATE TABLE CRMdatastructures');
        $lang = do_language();
        CreateSystemDataStructure();
        mcq('INSERT INTO CRMdatastructures(userid, datastructure) VALUES ('.$GLOBALS['USERID'].",'".mres(serialize(get_data_structure()))."') ON DUPLICATE KEY UPDATE userid=userid");
    }
}
function DropAllUserCache($user)
{
    foreach (db_GetFlatArray("SELECT temp FROM CRMsessions WHERE name='".mres(GetUserLoginNameByID($user))."'") as $sess) {
        mcq("DELETE FROM CRMcache WHERE session='".mres($sess)."'");
    }
    DropPersonalDataStructure($user);
}
function DropAllCache()
{
    mcq('TRUNCATE TABLE CRMcache');
    mcq("UPDATE CRMsessions SET sessioncache=''");
    DropPersonalDataStructure(0);
    DeleteExpiredTempFiles();
    AdminChangesDropCache();
}
function GetExtraFieldType($fieldname)
{
    $fieldname = str_replace('EFID', '', $fieldname);

    if ($GLOBALS['PageCache']['ExtraFieldTypes'][$fieldname] != '') {
        return $GLOBALS['PageCache']['ExtraFieldTypes'][$fieldname];
    } else {
        qlog(INFO, 'Fetch fields from db...');

        foreach (db_GetArray("SELECT * FROM CRMextrafields WHERE deleted='n'") as $f) {
            $GLOBALS['PageCache']['ExtraFieldTypes'][$f['id']] = $f['fieldtype'];
        }

        return $GLOBALS['PageCache']['ExtraFieldTypes'][$fieldname];
    }
}
function GetExtraFieldOptions($fieldname)
{
    $ret = '';
    if (is_numeric($fieldname)) {
        $t = db_GetRow("SELECT options,fieldtype FROM CRMextrafields WHERE id='".mres($fieldname)."'");
        if ($tmp = unserialize($t[0])) {
            $ret = $tmp;
        } else {
            $ret = $t[0];
        }
    }

    return $ret;
}
function GetExtraFieldTableType($fieldname)
{ // returns "34" or "userprofiles", or "loginusers", or "files"
    $fieldname = str_replace('EFID', '', $fieldname);
    $fieldname = str_replace('JS_', '', $fieldname);

    if (is_numeric($fieldname)) {
        $t = db_GetRow("SELECT tabletype FROM CRMextrafields WHERE id='".mres(str_replace('EFID', '', $fieldname))."'");
        if ($t[0] == 'user') {
            $t[0] = 'loginusers';
        }
        if ($t[0] == 'group') {
            $t[0] = 'userprofiles';
        }

        return $t[0];
    } else {
        return false;
    }
}
function GetExtraFieldName($fieldid, $flextable = false)
{
    global $lang;
    if (is_numeric($fieldid)) {
        return $lang['EFID'.$fieldid];
    } else {
        return $fieldid;
    }
}

function GetFlextableFieldValue($rid, $fid, $tid, $raw = false, $html = true, $pregiven_value = false, $pregiven_value_given = false)
{
    // This function is here for compaitbility only.
    return GetExtraFieldValue($rid, $fid, $html, $raw, $pregiven_value, $pregiven_value_given);
}

function GetExtraFieldValue($eid, $fid, $html = true, $raw = false, $pregiven_value = '', $pregiven_value_given = false)
{
    qlog(INFO, GetBackTrace(false));
    if ($eid == '' || $eid == '_new_') {
        return '';
    } else {
        $field = db_GetRow("SELECT * FROM CRMextrafields WHERE deleted='n' AND id='".mres($fid)."'");

        $table = $field['tabletype'];

        if ($table == 'user') {
            $table = 'loginusers';
        }
        if ($table == 'group') {
            $table = 'userprofiles';
        }
        $id = '';

        if ($table == 'loginusers') {
            $id = 'id';
        } elseif ($table == 'userprofiles') {
            $id = 'id';
        } elseif ($table == 'files') {
            $id = 'fileid';
            $table = 'binfiles';
        } elseif (is_numeric($table)) {
            $id = 'recordid';
            $flextableid = $table;
            $table = 'flextable'.$table;
        } else {
            log_msg("ERROR: GetExtraFieldValue couldn't determine table type of field ".$fid.' of recordid '.$eid);

            return false;
        }
        $dontformatnumbers = false;
        if ($raw == 'dontformatnumbers' && strlen($raw) == 17) {
            unset($raw);
            $dontformatnumbers = true;
        } elseif ($raw) {
            //	$raw = true;
            qlog(INFO, 'Processing RAW');
        }

        if ($eid == 'new') {
            if ($field['defaultval']) {
                return EvaluateTemplatePHP($field['defaultval']);
            } else {
                return '';
            }
        }
        $val = '';
        if ($pregiven_value_given) {
            $val = trim($pregiven_value);
            qlog(INFO, 'Using pre-given value, not fetching from database');
        } else {
            $sql = 'SELECT EFID'.$fid.' FROM CRM'.$table.' WHERE '.$id.'='.$eid;
            $val = db_GetValue($sql);
            //print "FETCH. SHOULD NOT FETCH. UNHAPPY! Rec $eid, table $table, field . " . $field['id'] . "<br>";
        }

        if ($field['fieldtype'] == 'text area') {
        } elseif ($field['fieldtype'] == 'Reference to FlexTable') {
            if ($val == 0) {
                $val = '';
            }
            if (!$raw) {
                $table = $field['options'];
                $y = GetFlexTableDefinitions($table);
                $layout = $y[0]['refer_field_layout'];

                $tmp = GetAttribute('extrafield', 'BlindReferenceFieldLayout', $fid);
                if ($tmp != '' && $tmp != '-- set blind reference field layout in extra field attributes --') {
                    $layout = $tmp;
                }

                //if (trim($val) != "") {
                if ($val > 0) {
                    if (IsValidFlexTableRecord($val, $table)) {
                        $val = unescape_interleave_characters(ParseTemplateRecordData($layout, 't'.$table, $val));
                        if (!$html) {
                            $val = html2plaintext($val);
                        }
                    } else {
                        $val = '[unknown] ('.$val.' '.$table.')';
                        //$val = "";
                    }
                } else {
                    $val = '';
                }
            } else {
                $val = $val;
                qlog(INFO, 'Returning RAW flexref value');
            }
        } elseif ($field['fieldtype'] == 'Reference to FlexTable (multiselect)') {
            $table = $field['options'];
            $y = GetFlexTableDefinitions($table);
            $layout = $y[0]['refer_field_layout'];

            $tmp = GetAttribute('extrafield', 'BlindReferenceFieldLayout', $fid);
            if ($tmp != '' && $tmp != '-- set blind reference field layout in extra field attributes --') {
                $layout = $tmp;
            }

            $tmp = unserialize($val);
            unset($val);

            $vals = array();

            foreach ($tmp as $element) {
                if (!$raw) {
                    if (IsValidFlexTableRecord(base64_decode($element), $table)) {
                        $val = unescape_interleave_characters(ParseTemplateRecordData($layout, 't'.$table, base64_decode($element)));
                        if (!$html) {
                            $val = html2plaintext($val);
                        }
                        $vals[] = $val;
                    }
                } else {
                    $vals[] = ($element);
                }
            }
            if (!$raw) {
                $val = implode(', ', $vals);
            } elseif ($raw) {
                $val = implode(';', $vals);
            }
        } elseif ($field['fieldtype'] == 'List of all groups' && !$raw) {
            $val = GetGroupName($val);
        } elseif (substr($field['fieldtype'], 0, 16) == 'Users of profile' && !$raw) {
            $val = GetUserName($val);
        } elseif ($field['fieldtype'] == 'drop-down (multiselect)' || $field['fieldtype'] == 'SQL Query (multiselect)') {
            $tmp = unserialize($val);
            unset($val);
            if ($raw) {
                $val = array();
            }

            $first = false;
            foreach ($tmp as $element) {
                if ($raw) {
                    if (base64_decode($element) != '{{{null}}}') {
                        $val[] = base64_decode($element);
                        //print "add to ar " . base64_decode($element) . "<br>";
                    }
                } else {
                    if (base64_decode($element) != '{{{null}}}') {
                        if ($first) {
                            $val .= ', ';
                        }
                        $val .= base64_decode($element);
                        $first = true;
                    }
                }
            }
        } elseif ($field['fieldtype'] == 'date' && !$raw) {
            $val = TransformDate($val);
        } elseif ($field['fieldtype'] == 'date/time') {
            if ($val == '0000-00-00 00:00:00') {
                $val = '';
            } else {
                if (!$raw) {
                    $val = SQLDateTimeToFormattedDateTime($val);
                }
            }
        } elseif ((strstr($field['fieldtype'], 'User-list') || substr($field['fieldtype'], 0, 16) == 'Users of profile') && !$raw) {
            $val = GetUserName($val);
        } elseif ($field['fieldtype'] == 'List of values') {
            $val = string_r(unserialize($val));
        } elseif ($field['fieldtype'] == 'diary' && !$raw) {
            $val2 = unserialize($val);
            if (!is_array($val2)) {
                $val2 = array();
            }
            $opt = array_reverse($val2);
            $val = '';
            if ($html) {
                $val = '<div class="diarycontainer">';
                $val .= '<table class="diarytable">';
                $grey = false;
                if (count($opt) % 2) { //not even
                    $grey = true;
                }
                foreach ($opt as $diary_remark) {
                    $ins = '';
                    if ($grey) {
                        $ins = " style='background: #E0E0E0'";
                        $grey = false;
                    } else {
                        $grey = true;
                    }
                    if ($diary_remark[2] != '') {
                        $val .= '<tr'.$ins.'><td class="diarycell">'.TransformDate(date('d-m-Y', $diary_remark[0])).' '.date('H:i', $diary_remark[0]).'h</td><td class="diarycell">'.GetUserName($diary_remark[1]).'</td><td class="diarycellcontent">'.nl2br(htme($diary_remark[2])).'</td></tr>';
                    }
                }
                $val .= '</table>';
                $val .= '</div>';
            } else {
                foreach ($opt as $diary_remark) {
                    $val .= TransformDate(date('d-m-Y', $diary_remark[0])).' '.date('H:i', $diary_remark[0]).'h : '.GetUserName($diary_remark[1]).' : '.$diary_remark[2]."\n";
                }
            }
        } elseif (!$raw && is_numeric($val) && $field['number_format'] != "don't format" && $field['number_format'] != '' && !$dontformatnumbers && $field['fieldtype'] == 'numeric') {
            $val = FormatNumber($val, 2, $field['id']);
        } else {
            $val = $val;
        }

        return $val;
    } // end if !access
}
function FormatNumber($num, $decimals = 2, $field_id = false, $returnZero = false, $dummy = false, $dummy2 = false)
{
    if ($num == '' && !$returnZero) {
        return '';
    } elseif ($num == '') {
        $num = '0';
    } elseif (!is_numeric($num)) {
        return $num;
    }

    if (!$GLOBALS['DONTFORMATNUMBERS']) {
        $tmp = '';
        if ($field_id) {
            if ($GLOBALS['PageCache']['NumberFormats'][$field_id] == '') {
                $tmp = db_GetArray('SELECT id, number_format FROM CRMextrafields');
                foreach ($tmp as $row) {
                    $GLOBALS['PageCache']['NumberFormats'][$row['id']] = $row['number_format'];
                }
                $tmp = $GLOBALS['PageCache']['NumberFormats'][$field_id];
            } else {
                $tmp = $GLOBALS['PageCache']['NumberFormats'][$field_id];
            }
            if ($tmp == "don't format") {
                return $num;
            } elseif ($tmp == 'no decimals') {
                $decimals = 0;
            } elseif ($tmp == '1 decimal') {
                $decimals = 1;
            } elseif ($tmp == '3 decimals') {
                $decimals = 3;
            } elseif ($tmp == '4 decimals') {
                $decimals = 4;
            } elseif ($tmp == '5 decimals') {
                $decimals = 5;
            } elseif (substr($tmp, 0, 8) == 'currency') {
                $decimals = 2;
            }
            /*
            "normal"		=> "Normal",
            "don't format"	=> "Don't format",
            "currency"		=> "Currency (without sign)",
            "currency EUR"	=> "Currency &euro;",
            "currency DOL"	=> "Currency $",
            "currency BRP"	=> "Currency &pound;",
            "currency YEN"	=> "Currency &yen;",
            "no decimals"	=> "No decimals",
            "1 decimal"		=> "1 decimal",
            "3 decimals"		=> "3 decimals",
            "4 decimals"		=> "4 decimals",
            "5 decimals"		=> "5 decimals",
            */
        }
        if ($GLOBALS['UC']['DateFormat'] == 'dd-mm-yyyy') {
            $num = number_format($num, $decimals, ',', '.');
        } else {
            $num = number_format($num, $decimals, '.', ',');
        }

        if ($tmp == 'currency EUR' && $num != '') {
            $num = '€ '.$num;
        } elseif ($tmp == 'currency DOL' && $num != '') {
            $num = '$ '.$num;
        } elseif ($tmp == 'currency BRP' && $num != '') {
            $num = '£ '.$num;
        } elseif ($tmp == 'currency YEN' && $num != '') {
            $num = '¥ '.$num;
        }
    }

    return $num;
}
function GetFlexTableDefinitions($tableid = false, $orientation = false, $no_cache = false, $type = 'both')
{
    if ($tableid) {
        $tableid = str_replace('flextable', '', $tableid); // just to be sure
    }

    if (is_array($GLOBALS['PageCache']['FlextableDefinitions'][$tableid]) && is_numeric($tableid) && !$no_cache) {
        qlog(INFO, 'CACHE Called with table '.$tableid);

        return $GLOBALS['PageCache']['FlextableDefinitions'][$tableid];
    } elseif (is_array($GLOBALS['PageCache']['FlextableDefinitions-'.$orientation]) && !$no_cache) {
        qlog(INFO, 'CACHE Called with table '.$tableid);

        return $GLOBALS['PageCache']['FlextableDefinitions-'.$orientation];
    } elseif (is_array($GLOBALS['PageCache']['FlextableDefinitionsAll']) && !$no_cache && !$tableid && !$orientation) {
        qlog(INFO, 'CACHE All tables');

        return $GLOBALS['PageCache']['FlextableDefinitionsAll'];
    } else {
        //		qlog(INFO, "No cache, determine");
        $sqladd = '';
        if (is_numeric($tableid)) {
            $sqladd = " WHERE recordid='".mres($tableid)."'";
        }

        $sql = 'SELECT * FROM CRMflextabledefs '.$sqladd;
        $sql .= ' ORDER BY `ordering`, `recordid`';

        $t = db_GetArray($sql);

        if ($tableid) {
            qlog(INFO, 'Returned flextable definitions for table '.$tableid);
        } else {
            qlog(INFO, 'Returned flextable definitions for all tables');
        }
        if ($tableid) {
            $GLOBALS['PageCache']['FlextableDefinitions'][$tableid] = $t;
        } else {
            $GLOBALS['PageCache']['FlextableDefinitionsAll'] = $t;
        }

        return $t;
    }
}
function GetFlexTableName($tableid)
{
    global $lang;
    if (is_numeric($tableid)) {
        $tmp = GetFlexTableNames($tableid);

        return $tmp[0];
    } else {
        return false;
    }
}
function GetFlexTableNames($tableid = false)
{
    $sqladd = '';
    if (is_numeric($tableid)) {
        $sqladd = " WHERE recordid='".mres($tableid)."'";
    }

    return db_GetFlatArray('SELECT tablename FROM CRMflextabledefs'.$sqladd);
}
if (!function_exists('debug_print_backtrace')) {
    function debug_print_backtrace()
    {
        return 'Your PHP version is too old. It cannot print backtraces.';
    }
}
function CheckIfPasswordMustBeChanged()
{
    $max_exp = GetSetting('PASSWORDEXPIRE') * 86400; // Days, in seconds
    if ($max_exp > 10 && is_numeric($GLOBALS['USERID'])) {
        $lastchange = db_GetRow("SELECT UNIX_TIMESTAMP(LASTPASSCHANGE), FORCEPASSCHANGE FROM CRMloginusers WHERE id='".mres($GLOBALS['USERID'])."'");
        if ((($lastchange[0] + $max_exp) < date('U')) || $lastchange['FORCEPASSCHANGE'] == 'y') {
            qlog(INFO, 'Password is expired and must be renewed.');
            if (GetAttribute('user', 'PasswordNeverExpires', $GLOBALS['USERID']) != 'True') {
                return true;
            } else {
                // Password is expired but no problem
                return false;
            }
        } else {
            qlog(INFO, 'Password is NOT expired.');

            return false;
        }
    }
}
function ReturnDropDownSearchField($ElementID)
{
    global $lang;

    return "&nbsp;<span class=\"fa fa-search search_img\"></span><input type='search' class='search_input search_input_small' onkeydown=\"JSearch('".$ElementID."',this.value);\" onkeyup=\"JSearch('".$ElementID."',this.value);\" onblur=\"if (typeof document.getElementById('".$ElementID."').onchange == 'function') { document.getElementById('".$ElementID."').onchange(); } \" placeholder=\"".htme($lang['search']).'">';
}
function ClearAllRunningCache()
{
    unset($GLOBALS['PageCache']);
    unset($GLOBALS['settings']);
}
function UnCompressFile($fileid)
{
    $result1 = db_GetRow("SELECT * FROM CRMblobs, CRMbinfiles WHERE CRMblobs.fileid='".mres($fileid)."' AND CRMblobs.fileid=CRMbinfiles.fileid");

    if ($result1['gz'] == 'y' && $result1['offloaded'] == 'n') {
        qlog(INFO, 'Requested file is compressed, uncompressing');
        $b = strlen($result1['content']);
        $blob = gzinflate($result1['content']);
        $a = strlen($blob);
        qlog(INFO, 'Filesize was '.$b.', is now '.$a);
        $sql = "UPDATE CRMblobs SET content='".mres($blob)."', gz='n' WHERE fileid='".mres($fileid)."'";
        mcq($sql);
    } elseif ($result1['offloaded'] == 'y') {
        echo "Can't uncompress, file is offloaded";
    }
}
function UnCompressAllFiles()
{
    $t = db_GetArray("SELECT fileid FROM CRMblobs WHERE gz='y'");
    foreach ($t as $file) {
        UnCompressFile($file['fileid']);
        echo "\015Uncompressing file ".$file['fileid'].'   ';
    }
    mcq('OPTIMIZE TABLE CRMblobs');
    echo "\n";
}

function CompressFile($fileid)
{
    if (is_positive_integer($fileid)) {
        $blob = GetFileContent($fileid);
        qlog(INFO, 'File size before compression: '.strlen($blob));
        if ($gzblob = gzdeflate($blob, 9)) {
            qlog(INFO, 'File compression looks successful '.strlen($gzblob));
        } else {
            qlog(INFO, 'File compression looks NOT successful');
        }

        mcq("UPDATE CRMblobs SET content='".mres($gzblob)."', gz='y' WHERE fileid=".$fileid);

        $blobgz = GetFileContent($fileid); // GetFileContent decompresses it automatically!
        if ($blob == $blobgz) {
            // Values are the same
            $a = strlen($blob);
            $b = strlen($gzblob);
            qlog(INFO, 'Successfully compressed file '.$fileid.'. Was: '.$a.' bytes, is now '.$b.' bytes.');
        } else {
            // Decode test didn't match; re-set to old values
            $a = strlen($blob);
            $b = strlen($blobgz);
            qlog(WARNING, 'WARNING: Compressing file '.$fileid.' failed! (restored) '.$a.' '.$b);
            mcq("UPDATE CRMblobs SET content='".mres($blob)."', gz='n' WHERE fileid=".$fileid);
        }
    } else {
        log_msg('ERROR: CompressFile called with non-numeric file id!');
    }
}

function GetExtrafieldRequiredConditions($efid)
{
    return db_GetArray("SELECT * FROM CRMextrafieldrequiredconditions WHERE efid='".mres($efid)."'");
}
function CheckExtrafieldRequiredConditions($eid, $extrafieldid, $tabletype = 'entity')
{
    $conditions = GetExtrafieldRequiredConditions($extrafieldid);
    $passed = true;
    $not_to_pass = false;
    if (sizeof($conditions) > 0) {
        foreach ($conditions as $condition) {
            if ($passed) {
                $passedAR = EvaluateCondition($condition, $eid, $tabletype);
                $passed = $passedAR['passed'];
            }
        }
        if ($not_to_pass) {
            $passed = false;
            qlog(INFO, 'Field '.$extrafieldid.' not valid - it has (any) condition but the recordid ('.$eid.') is not valid');
        }
    } else {
        qlog(INFO, 'field '.$extrafieldid.' (eid: '.$eid.', table: '.$tabletype.') does not have any conditions');
        $passed = true;
    }
    if ($passed) {
        qlog(INFO, 'field '.$extrafieldid.' (eid: '.$eid.', table: '.$tabletype.') passed its conditions (it must be required)');
    } else {
        qlog(INFO, 'field '.$extrafieldid.' (eid: '.$eid.', table: '.$tabletype.') DID NOT pass its conditions (it will not be required for '.$eid.')');
    }
    //journal($eid, "An field was evaluated for being required: $passed " . $text);
    return $passed;
}
function ProcessOldTodos()
{
    // Add locking
    $worker_hash = randomstring(64);
    $sql = "UPDATE CRMtodo SET worker_hash='".mres($worker_hash)."' WHERE worker_hash='' AND UNIX_TIMESTAMP(timestamp_last_change) < (UNIX_TIMESTAMP(NOW()) - 300)";
    mcq($sql);

    $Todo = db_GetArray("SELECT todoid, onchange, to_value, eid, user, UNIX_TIMESTAMP(timestamp_last_change) AS tp FROM CRMtodo WHERE worker_hash='".mres($worker_hash)."'");

    $changed_already_done = array();

    foreach ($Todo as $do) {
        mcq("DELETE FROM CRMtodo WHERE todoid='".mres($do['todoid'])."'");
        $current_user = $GLOBALS['USERID'];
        qlog(INFO, 'Todo: switching to user credentials of user '.$do['user']);

        $GLOBALS['USERID'] = $do['user'];
        $GLOBALS['NO_MSG'] = true;
        InitUser($do['user']);
        $ft = false;
        if (ipi(GetExtraFieldTableType($do['onchange']))) {
            $ft = GetExtraFieldTableType($do['onchange']);
        } elseif (strstr($do['onchange'], '-Change')) {
            $ft = str_replace('FlexTable', '', str_replace('-Change', '', $do['onchange']));
        } elseif (strstr($do['onchange'], '-Add')) {
            $ft = str_replace('FlexTable', '', str_replace('-Add', '', $do['onchange']));
        } elseif (strstr($do['onchange'], '-Delete')) {
            $ft = str_replace('FlexTable', '', str_replace('-Delete', '', $do['onchange']));
        } elseif (strstr($do['onchange'], '-AnyUpdate')) {
            $ft = str_replace('FlexTable', '', str_replace('-AnyUpdate', '', $do['onchange']));
        } elseif (strstr($do['onchange'], '-added')) {
            $ft = str_replace('-added', '', str_replace('t', '', $do['onchange']));
        } elseif (strstr($do['onchange'], '-changed')) {
            $ft = str_replace('-changed', '', str_replace('-t', '', $do['onchange']));
        }

        if ($do['eid']) {
            $dsname = '';

            if (!ipi($ft)) {
                $dsname = $ft;
            } else {
                $dsname = 'f'.$ft;
            }

            if ($do['onchange'] == 'FlexTable'.$ft.'-Change' || $do['onchange'] == 'FlexTable'.$ft.'-AnyUpdate' || $do['onchange'] == $dsname.'-changed') {
                if (!$changed_already_done[$ft.'='.$do['eid']]) {
                    Processrules($dsname, $do['eid'], '', 'changed', $do['to_value']);
                    $changed_already_done[$ft.'='.$do['eid']] = true;
                }
            } elseif ($do['onchange'] == 'FlexTable'.$ft.'-Add' || $do['onchange'] == $dsname.'-added') {
                Processrules($dsname, $do['eid'], '', 'added', $do['to_value']);
            } elseif ($do['onchange'] == 'FlexTable'.$ft.'-Delete' || $do['onchange'] == $dsname.'-deleted') {
                Processrules($dsname, $do['eid'], '', 'deleted', $do['to_value']);
            } else {
                Processrules($dsname, $do['eid'], 'f'.str_replace('EFID', '', $do['onchange']), 'changed', $do['to_value']);
            }
        } else {
            log_msg('ERROR: Todo item found without EID: '.$do['onchange'].' value '.$do['to_value'].' eid '.$do['eid']);
        }

        qlog(INFO, 'Todo: switching back user credentials of user '.$current_user);
        $GLOBALS['USERID'] = $current_user;
        InitUser($current_user);

        $GLOBALS['NO_MSG'] = false;
    }
}
function DropTodos($eid, $onchange = false)
{
    $sqlins = '';
    if (is_numeric($eid)) {
        $sqlins = "eid='".$eid."' AND ";
    }
    if ($onchange) {
        $sqlins = "onchange='".mres($onchange)."' AND ";
    }

    $ar = db_GetArray('SELECT * FROM CRMtodo WHERE '.$sqlins."user='".mres($GLOBALS['USERID'])."'");
    $ret = array();
    foreach ($ar as $row) {
        array_push($ret, $row);
    }
    foreach ($ret as $row) {
        mcq("DELETE FROM CRMtodo WHERE todoid='".mres($row['todoid'])."'");
    }

    return true;
}
function GetTodos($eid)
{
    $sqlins = '';
    if (is_numeric($eid)) {
        $sqlins = "eid='".$eid."' AND ";
    }
    $sql = 'SELECT * FROM CRMtodo WHERE '.$sqlins."user='".mres($GLOBALS['USERID'])."'";

    $ar = db_GetArray($sql);
    $ret = array();
    foreach ($ar as $row) {
        array_push($ret, $row);
    }

    return $ret;
}
function AddToDo($onchange, $to_value, $eid, $from_value)
{
    if ($eid == 0 || $eid == '') {
        log_msg('ERROR: A ToDo was just logged with an empty EID! _REQ: '.string_r($_REQUEST));

        return true;
    } else {
        qlog(INFO, 'AddToDo : Add to-do On_cha '.$onchange.' To_val '.$to_value.' Eid '.$eid.' From_val '.$from_value);
    }
    //elseif ($to_value == $from_value) {
    //	return false;
    //}
    $t = db_GetRow("SELECT * FROM CRMtodo WHERE eid='".mres($eid)."' AND onchange='".mres($onchange)."' AND user='".mres($GLOBALS['USERID'])."' AND from_value='".mres($to_value)."'");

    if ($t['eid'] && (!strstr($onchange, '-Change') && !strstr($onchange, '-AnyUpdate') && !strstr($onchange, '-changed') && !strstr($onchange, '-added') && !strstr($onchange, '-deleted'))) {
        qlog(INFO, "Todo's cancel each other out!");
        $sql = "DELETE FROM CRMtodo WHERE eid='".mres($eid)."' AND onchange='".mres($onchange)."' AND user='".mres($GLOBALS['USERID'])."'";
        mcq($sql);
        // Check if there are more than 1 actions waiting. If it's only "xxx_change", delete that one too
        $t = db_GetArray("SELECT * FROM CRMtodo WHERE eid='".mres($eid)."'");
        $something_else = false;
        foreach ($t as $todo) {
            if (!strstr($todo['onchange'], '-Change')) {
                $something_else = true;
            }
        }
        if (!$something_else) {
            if (strstr($todo['onchange'], '-Change')) {
                // Concerns flextable
                mcq("DELETE FROM CRMtodo WHERE eid='".mres($eid)."' AND onchange LIKE '%-Change' AND user='".mres($GLOBALS['USERID'])."'");
            }
        }
    } else {
        mcq("DELETE FROM CRMtodo WHERE eid='".mres($eid)."' AND onchange='".mres($onchange)."' AND user='".mres($GLOBALS['USERID'])."'");
        $sql = "INSERT INTO CRMtodo(eid, onchange, to_value, from_value, user, timestamp_last_change) VALUES('".mres($eid)."', '".mres($onchange)."','".mres($to_value)."','".mres($from_value)."','".mres($GLOBALS['USERID'])."',NOW())";

        mcq($sql);
    }
}

function GetFileTableType($file_id)
{
    return db_GetValue("SELECT type FROM CRMbinfiles WHERE fileid='".mres($file_id)."'");
}
function RevertToFile($fileid)
{
    $row = db_GetRow("SELECT * FROM CRMbinfiles, CRMblobs WHERE CRMbinfiles.fileid=CRMblobs.fileid AND CRMbinfiles.fileid='".mres($fileid)."' AND version_belonging_to != '0'"); // file to revert to MUST be an "older" version
    $acc = CheckTableRecordAccess('files', $row['version_belonging_to']);

    if (ipi($row['version_belonging_to']) && $acc == 'ok') {

        // Add old file as most recent version
        $new_file = AttachFile($row['koppelid'], $row['filename'], $row['content'], $row['type'], $row['filetype'], '', true, false, false, false);

        foreach (array_keys($GLOBALS['UC']['PersonalDataStructure']['files']['fields']) as $field) {
            //alleen EFID tags
            if (preg_match("/^f\d+$/", $field)) {
                $sql = 'UPDATE CRMbinfiles SET '.$GLOBALS['UC']['PersonalDataStructure']['files']['fields'][$field]['name_in_database']."='".mres(db_GetValue('SELECT '.$GLOBALS['UC']['PersonalDataStructure']['files']['fields'][$field]['name_in_database']." FROM CRMbinfiles WHERE fileid='".mres($fileid)."'"))."' WHERE fileid='".mres($new_file)."'";

                mcq($sql);
            }
        }

        $t = db_GetRow("SELECT version_no FROM CRMbinfiles WHERE fileid='".mres($row['version_belonging_to'])."'");
        $newversion = $t[0] + 1;
        mcq("UPDATE CRMbinfiles SET version_belonging_to='".$new_file."', timestamp_last_change=timestamp_last_change WHERE version_belonging_to='".mres($row['version_belonging_to'])."'");
        mcq("UPDATE CRMbinfiles SET version_belonging_to='".$new_file."', timestamp_last_change=timestamp_last_change WHERE fileid='".mres($row['version_belonging_to'])."'");
        mcq("UPDATE CRMbinfiles SET version_no='".$newversion."', version_belonging_to=0, timestamp_last_change=timestamp_last_change WHERE fileid=".$new_file);

        list($tt, $record) = db_GetRow("SELECT type, koppelid FROM CRMbinfiles WHERE fileid='".$row['version_belonging_to']."'");

        if (substr($tt, 0, 9) == 'flextable') {
            journal($record, 'Reverted to file id '.$fileid.' ['.$row['filename'].']', $tt);
        }

        return $new_file;
    } else {
        echo 'error '.$acc.' parent '.$row['version_belonging_to'];

        return false;
    }
}
function DeleteFile($file_id, $skip_security = false, $skip_revert = false)
{
    if (!is_numeric($file_id)) {
        exit;
    } // SQL injection prevention (sort of)

    $type = GetFileTableType($file_id);
    $pass = false;
    if ($skip_security || CheckTableRecordAccess('files', $file_id) == 'ok') {
        $pass = true;
    }

    if (GetFileType($file_id) == '{{{folder}}}') {
        $count = db_GetValue("SELECT COUNT(*) FROM CRMbinfiles WHERE folder='".$file_id."'");
        if ($count > 0) {
            echo '<span class="errmsg">Error: folder not empty. Not deleted.</span><br>';
            $pass = false;
        }
    }

    if ($pass) {
        journal(db_GetValue("SELECT koppelid FROM CRMbinfiles WHERE fileid='".mres($file_id)."'"), 'File id '.$file_id.' ['.GetFilename($file_id).'] deleted', GetFileTableType($file_id));
        GetFileTableType($file_id);

        $sql = "DELETE FROM CRMbinfiles WHERE fileid='".mres($file_id)."'";
        mcq($sql);
        $sql = "DELETE FROM CRMblobs WHERE fileid='".mres($file_id)."'";
        mcq($sql);

        // Fetch least-old version, if appliccable
        $t = db_GetRow("SELECT * FROM CRMbinfiles WHERE version_belonging_to='".mres($file_id)."' ORDER BY timestamp_last_change DESC");

        if ($t && !$skip_revert) {
            mcq('UPDATE CRMbinfiles SET version_belonging_to=0,timestamp_last_change=timestamp_last_change WHERE fileid='.$t['fileid']);
            mcq("UPDATE CRMbinfiles SET version_belonging_to='".$t['fileid']."',timestamp_last_change=timestamp_last_change WHERE version_belonging_to='".mres($file_id)."'");
            journal(db_GetValue("SELECT koppelid FROM CRMbinfiles WHERE fileid='".mres($file_id)."'"), 'Reverted to file id '.$t['fileid'].' ['.GetFileName($t['fileid']).']', $type);
        }
    } else {
        qlog(INFO, 'User tried to delete file '.$file_id.' but access was denied');
    }
}
function UpdateDiaryField($eid, $fieldname, $dummy, $value, $commenthash)
{
    if ($value != '') {
        $tabletype = GetExtraFieldTableType($fieldname);
        $id = '';
        $journaltype = '';
        $ft = '';
        $accesstype = '';

        if (is_numeric($tabletype)) {
            $id = 'recordid';
            $ft = $tabletype;
            $tabletype = 'flextable'.$tabletype;
            $journaltype = $tabletype;
        } elseif ($tabletype == 'loginusers') {
            if (CheckFunctionAccess('UserAdmin') != 'ok' && !is_administrator()) {
                $accesstype = 'nok';
            } else {
                $accesstype = 'ok';
            }
            $id = 'id';
            $journaltype = 'user';
        } elseif ($tabletype == 'userprofiles') {
            if (CheckFunctionAccess('UserAdmin') != 'ok' && !is_administrator()) {
                $accesstype = 'nok';
            } else {
                $accesstype = 'ok';
            }

            $id = 'id';
            $journaltype = 'group';
        }

        $ef_array = array();
        if (is_numeric($eid)) {
            $ef_array = db_GetRow('SELECT EFID'.$fieldname.' AS value FROM CRM'.$tabletype.' WHERE '.$id."='".mres($eid)."'");
        }
        $val = $ef_array['value'];
        $val_ar = unserialize($val);
        $add_ar = array(date('U'), $GLOBALS['USERID'], $value);
        $what = '';
        if ($commenthash == '') {
            $val_ar[] = $add_ar;
            $what = 'added';
        } elseif ((CheckFunctionAccess('AllowedToAlterDiaryContents') == 'ok') || (is_administrator())) {
            for ($lus = 0; $lus < count($val_ar); ++$lus) {
                $commenthash_this_row = md5($val_ar[$lus][0].$val_ar[$lus][1].$val_ar[$lus][2]);
                if ($commenthash == $commenthash_this_row) {
                    $val_ar[$lus][2] = $value;
                    $what = 'updated';
                    break;
                }
            }
        }
        $to = serialize($val_ar);
        $test = unserialize($to);

        if (count($test) > 0) {
            $sql = 'UPDATE CRM'.$tabletype.' SET EFID'.$fieldname."='".mres($to)."' WHERE ".$id."='".mres($eid)."'";
            mcq($sql);

            journal($eid, 'A record was '.$what.' to diary field '.$fieldname.'. Text: '.mres($value), $journaltype);
            DataJournal($eid, '{{add}} ', $value, $fieldname);

            $cl = GetClearanceLevel();

            // puinhoop
            if ($ft > 0) {
                AddToDo('t'.$ft.'-changed', '', $eid, '');
                AddToDo('t'.$ft.'-f'.$fieldname, $value, $eid, '');
            }
        } else {
            log_msg('ERROR: A diary field was undecodable after unserializing. Not saved. Serialized value is '.$to.', input was '.string_r($val_ar));
        }
    }
}
function PrintHeaderJavascript()
{
    echo '<script type="text/javascript" src="js/jquery.js?1"></script>';
    echo '<script type="text/javascript" src="js/jquery-ui/jquery-ui-1.10.4/js/jquery-ui-1.10.4.custom.min.js"></script>';
    echo '<script type="text/javascript" src="js/jquery-ui-timepicker-addon.js"></script>';
    echo '<script type="text/javascript" src="js/jquery-fancybox/source/jquery.fancybox.pack.js?1"></script>';
    echo '<script type="text/javascript" src="js/sorttable.js"></script>';
    echo '<script type="text/javascript" src="js/highcharts/js/highcharts.js?1"></script>';

    //	print '<script type="text/javascript" src="js/highcharts/js/modules/exporting.js?1"></script>';
    echo '<script type="text/javascript" src="js/functions.js?'.filemtime('js/functions.js').'"></script>';
    echo '<script type="text/javascript" src="js/functions_record.js?'.filemtime('js/functions_record.js').'"></script>';
    $jstemplate = GetSetting('TemplateNoOfJavascriptFileToIncludeInEveryPage');
    if (ipi($jstemplate)) {
        echo '<script type="text/javascript" src="csv.php?getcustomjs=1&amp;'.strtotime(GetTemplateLastModificationDate($jstemplate)).'"></script>';
    }
    echo '<script type="text/javascript" src="js/jquery.autosize.input.js"></script>';

    //print '<script type="text/javascript" src="csv.php?GetJS&amp;' . date('U') . '"></script>';
    echo '<script type="text/javascript">';
    echo ReturnStandardJavascript();

    echo '</script>';
}
function PrintUnauthenticatedHeaderJavascript()
{
    DisplayCSS(false, false);
    echo '<script type="text/javascript" src="js/jquery.js?1"></script>';
    echo '<script type="text/javascript" src="js/jquery-ui/jquery-ui-1.10.4/js/jquery-ui-1.10.4.custom.min.js"></script>';
    echo '<script type="text/javascript" src="js/sorttable.js"></script>';
    echo '<script type="text/javascript" src="js/jquery-fancybox/source/jquery.fancybox.pack.js"></script>';
    echo '<script type="text/javascript" src="js/jquery-ui/jquery-ui-1.10.4/js/jquery-ui-1.10.4.custom.min.js"></script>';
    echo '<script type="text/javascript" src="js/jquery-ui-timepicker-addon.js"></script>';
    echo '<script type="text/javascript" src="js/highcharts/js/highcharts.js?1"></script>';
    //	print '<script type="text/javascript" src="js/highcharts/js/modules/exporting.js?1"></script>';
    echo '<script type="text/javascript" src="js/functions.js?'.filemtime('js/functions.js').'"></script>';
    echo '<script type="text/javascript" src="js/functions_record.js?'.filemtime('js/functions_record.js').'"></script>';
    echo '<script type="text/javascript" src="js/jquery.autosize.input.js"></script>';
}
function ReturnStandardJavascript()
{
    global $lang;

    $sec = GetSetting('ENTITYLOCKTIMEOUT');
    if ($sec == '' || $sec < 10 || $sec > 3600) {
        $sec = 3600;
    }
    // 60
    $sec = $sec / 15; // Update runs every 15 seconds
    $ret = "

	var my_rep_hash = '" .md5(db_GetValue('SELECT DATABASE()'))."';
	function UpdateRecordLock() {
		if (LockCounter > " .$sec.")
		{
			document.getElementById('lostlockmsg').style.display = 'block';
		} else {
			$.ajax({
				type: 'POST',
				url: 'assist.php?UpdateRecordLock',
				data: 'UpdateRecordLock=1&record=' + LockRecord + '&table=' + LockTable,
				success: ProcessMessageReply
			});
			setTimeout('UpdateRecordLock()', LockInterval);
			LockCounter = LockCounter + 1;
		}
	}
	";

    $ret .= "var mytitle ='".jsencode(GetSetting('title')).' :: '.jsencode($GLOBALS['PRODUCT'])."';";

    $ret .= 'var interval = 20000;setTimeout("CheckMessages(interval)", interval);';
    $ret .= ' var messages = '.json_encode(get_user_messages(false)).";\n";
    $ret .= ' $(document).ready(function() { ProcessMessageReply(JSON.stringify(messages)); }); ';

    $df = str_replace('yyyy', 'yy', $GLOBALS['UC']['DateFormat']);

    $ret .= " function InitDatePicker() {
		$(\".datepicker\").datepicker({
			dateFormat:		'" .$df."',
			constrainInput: false,
			dayNames:		['" .$lang['sunday']."', '".$lang['monday']."', '".$lang['tuesday']."', '".$lang['wednesday']."', '".$lang['thursday']."', '".$lang['friday']."', '".$lang['saturday']."'],
			dayNamesMin:	['" .$lang['sunday_short']."', '".$lang['monday_short']."', '".$lang['tuesday_short']."', '".$lang['wednesday_short']."', '".$lang['thursday_short']."', '".$lang['friday_short']."', '".$lang['saturday_short']."'],
			dayNamesShort:	['" .$lang['sunday_short']."', '".$lang['monday_short']."', '".$lang['tuesday_short']."', '".$lang['wednesday_short']."', '".$lang['thursday_short']."', '".$lang['friday_short']."', '".$lang['saturday_short']."'],
			monthNames:		['" .$lang['month1']."','".$lang['month2']."','".$lang['month3']."','".$lang['month4']."','".$lang['month5']."','".$lang['month6']."','".$lang['month7']."','".$lang['month8']."','".$lang['month9']."','".$lang['month10']."','".$lang['month11']."','".$lang['month12']."' ],
			monthNamesShort:	['" .$lang['month1_short']."','".$lang['month2_short']."','".$lang['month3_short']."','".$lang['month4_short']."','".$lang['month5_short']."','".$lang['month6_short']."','".$lang['month7_short']."','".$lang['month8_short']."','".$lang['month9_short']."','".$lang['month10_short']."','".$lang['month11_short']."','".$lang['month12_short']."' ],
			firstDay:               1,
			autoSize:		false,
			showWeek:		true,
			changeMonth:	true,
			changeYear:		true,

			});
		$(\".datetimepicker\").datetimepicker({
			dateFormat:		'" .$df."',
			dayNames:		['" .$lang['sunday']."', '".$lang['monday']."', '".$lang['tuesday']."', '".$lang['wednesday']."', '".$lang['thursday']."', '".$lang['friday']."', '".$lang['saturday']."'],
			dayNamesMin:	['" .$lang['sunday_short']."', '".$lang['monday_short']."', '".$lang['tuesday_short']."', '".$lang['wednesday_short']."', '".$lang['thursday_short']."', '".$lang['friday_short']."', '".$lang['saturday_short']."'],
			dayNamesShort:	['" .$lang['sunday_short']."', '".$lang['monday_short']."', '".$lang['tuesday_short']."', '".$lang['wednesday_short']."', '".$lang['thursday_short']."', '".$lang['friday_short']."', '".$lang['saturday_short']."'],
			monthNames:		['" .$lang['month1']."','".$lang['month2']."','".$lang['month3']."','".$lang['month4']."','".$lang['month5']."','".$lang['month6']."','".$lang['month7']."','".$lang['month8']."','".$lang['month9']."','".$lang['month10']."','".$lang['month11']."','".$lang['month12']."' ],
			monthNamesShort:	['" .$lang['month1_short']."','".$lang['month2_short']."','".$lang['month3_short']."','".$lang['month4_short']."','".$lang['month5_short']."','".$lang['month6_short']."','".$lang['month7_short']."','".$lang['month8_short']."','".$lang['month9_short']."','".$lang['month10_short']."','".$lang['month11_short']."','".$lang['month12_short']."' ],
			firstDay:1,
			autoSize:false,
			showWeek:true,
			changeMonth:true,
			timeFormat: 'HH:mm',
			hour:12,
			";

    if ($GLOBALS['UC']['DateFormat'] == 'mm-dd-yyyy') {
        $ret .= 'ampm: true,';
    }
    $ret .= "
			changeYear:		true,
			autoClose: true,
			showSecond: 0,
			showMillisec: 0,
			showMicrosec: 0,
			showTimezone: 0,
			controlType: 'select'
	});
}";

    $ret .= '$(document).ready(function() {
					InitDatePicker();
				});';

    return $ret;
    //require_once "lib/Minifier.php";
    //return \JShrink\Minifier::minify($ret);
    //return str_replace("\n", "", str_replace("\t", "", $ret));
}
function PrintHTMLHeader()
{
    header('Content-Type: text/html; charset=UTF-8');
    echo '<!DOCTYPE html>';
    echo '<html';
    if ($GLOBALS['LANGUAGE_2_LETTER_CODE'] != '') {
        echo ' lang="'.$GLOBALS['LANGUAGE_2_LETTER_CODE'].'"';
    }
    echo '>';
    echo '<head>';
    if ($GLOBALS['BASE'] != '') {
        echo '<base href="'.$GLOBALS['BASE'].'">';
    }
    echo '<meta charset="UTF-8">';
    echo "\n<!--
* Interleave Business Process Automation
* Copyright (c) 2001-2016 Atomos Applications The Netherlands - www.atomos.nl - info@atomos.nl - www.interleave.nl - info@interleave.nl
* Licensed under the GNU GPL. For full terms see http://www.gnu.org/
*
* Check http://www.interleave.nl/ for more information about Interleave or
* visit Atomos Applications (http://atomos.nl) for support and/or consultancy.
*
* Looking for support or just haven't found the *perfect* solution for your
* business administration needs yet? With Interleave you can automate any
* process currently relying on spreadsheets, e-mails, and the knowledge of that
* one special colleague who happens to be on holiday just when you need him ;-)
*
* Interleave is open-source software. However, this implementation may contain copyrighted,
* non-free and/or non-open (closed) material made by Interleave for a customer or made by
* a customer or Interleave user him/herself. In other words; don't take anything for granted
* but check first before you copy.
*
* Anyway, thanks for checking out the source!
-->\n";
}
function PDFDownloadLink($htmltoconvert, $linktext, $orientation, $discon1, $discon2 = false, $discon3 = false, $discon4 = false, $filename = false, $discon5 = 'helvetica', $discon6 = '8', $discon7 = false, $showimg = true, $discon8 = false, $discon9 = 'tcpdf')
{
    // Call this function with any HTML - a link to download it in PDF format will be returned  (valid for 10 minutes)
    $obj = array();

    $obj['html'] = $htmltoconvert;
    $obj['filename'] = $filename;

    $num = PushStashValue($obj);
    $img = '';
    if ($showimg) {
        $img = '<span class="fa fa-file-pdf-o"></span>';
    }

    return "<a href='csv.php?cpdf=".$num."' onclick='window.open(this.href);return false;'>".$img.' '.htme($linktext).'</a>';
}
function ExcelDownloadLink($sheetarray, $linktext, $filename = '', $format = 'xlsx')
{
    // Call this function with any 2D-array  - a link to download it in MS Excel format will be returned (valid for 10 minutes)
    // Format can be xlsx, xls, or pdf
    $num = PushStashValue(array('sheet' => $sheetarray, 'filename' => $filename));
    $fn = 'fa-file-excel-o';

    return "<a href='csv.php?cxlsx=".$num."'><span class=\"fa ".$fn.'">&nbsp;</span> '.$linktext.'</a>';
}
function ExcelRows()
{
    $bla = explode(' ', 'A B C D E F G H I J K L M N O P Q R S T U V W X Y Z');
    $rows = array();
    foreach ($bla as $a) {
        array_push($rows, $a);
    }
    foreach ($bla as $a) {
        foreach ($bla as $b) {
            array_push($rows, $a.$b);
        }
    }

    return $rows;
}
function HTML2PDF($html)
{
    require_once 'lib/mpdf/mpdf.php';

    $mpdf = new mPDF('');
    $mpdf->SetDisplayMode('fullpage');
    $mpdf->WriteHTML($html);

    return $mpdf->Output('document.pdf', 'S');
}
function ParseTemplateMenu($template_id)
{
    global $lang;
    $menu = GetTemplate($template_id);

    //fix jeroen 2011-04-20
    if (strstr($menu, '@SEARCH@') || strstr($menu, '@R@') || strstr($menu, '@SEARCHWILD@') || strstr($menu, '@SEARCHEID@')) {
        $searcheid = '';
        $searchwild = '
        <form action="list.php" method="get">
        <input type="hidden" name="searchalltables" value="1">
        <input type="hidden" name="search_parents" value="0">
        <input type="hidden" name="search_childs" value="0">
        <input type="hidden" name="search_files" value="1">
        <input type="search" class="search_input" name="search" id="JS_search" onchange="this.form.submit()"></form>';

        $sf = $searcheid.'&nbsp;'.$searchwild;

        $menu = str_replace('@SEARCH@', escape_interleave_characters($sf), $menu);
        $menu = str_replace('@SEARCHEID@', escape_interleave_characters($searcheid), $menu);
        $menu = str_replace('@SEARCHWILD@', escape_interleave_characters($searchwild), $menu);
        if (strstr($menu, '@R@')) {
            $menu = str_replace('@R@', escape_interleave_characters(CreateReposSwitcher()), $menu);
        }
    }

    if ($GLOBALS['SesMem']['InlineEditMode_InlineLinks'] == 'On') {
        $menu = '<div class="showinline" style="position: relative"><div class="showinline InlineEditModeDiv" style="position: absolute;z-index:100000;"><a href="admin.php?templates=1&amp;editHTMLtemplate='.$template_id.' &amp;fromlist='.base64_encode($_SERVER['REQUEST_URI']).'"><span class="fa fa-edit"></span></a></div></div>'.$menu;
    }

    /* must go last, this function unescapes */
    $menu = get_parsed_template_with_given_template('', '', array(), '', false, '', $menu, 'TEMPLATE_PLAIN');

    //jeroen 2015-06-07 dit is tricky maar hiermee wordt whitespace tussen li's voorkomen, die zichtbaar is wanneer ze als inline-block worden weergegeven
    //alle whitespace om ul of li elementen weg
    $menu = preg_replace("/\s+(\<(li|ul))/", '\\1', $menu);
    $menu = preg_replace("/(\<\/(li|ul)>)\s+/", '\\1', $menu);

    return $menu;
}
function CreateReposSwitcher()
{
    $html = '';
    include $GLOBALS['CONFIGFILE'];

    if (count($host) > 0) {
        $curpassword = db_GetValue("SELECT password FROM CRMloginusers WHERE name='".mres($GLOBALS['USERNAME'])."'");

        $html .= '<div id="reposswitcher"><span class="fa fa-database"></span><div id="reposswitchercontent"><ul>';
        for ($x = 0; $x < count($host); ++$x) {
            if (DB_Connect($x)) {
                $foreignpassword = db_GetValue("SELECT password FROM CRMloginusers WHERE name='".mres($GLOBALS['USERNAME'])."'");
                if ($curpassword == $foreignpassword) {
                    //er zou ook GetSetting('title') gebruikt kunnen worden, maar dat is trager want die laadt alle settings in; db_connect gooit alle settings bij iedere connect eerst leeg
                    $html .= '<li><a href="index.php?switchtorepos='.$x.'">'.htme(db_GetValue("SELECT value FROM CRMsettings WHERE setting='title'")).'</a></li>';
                }
                db_CloseConnection();
            }
        }
        $html .= '</ul></div></div>';
        SwitchToRepos($GLOBALS['repository']);
    }

    return $html;
}
function GetImageFileTypeIcon($fileid)
{
    $filename = strtolower(GetFileName($fileid));
    $filetype = GetFileType($fileid);

    $tmp_fn = explode('.', $filename);
    $ext = '.'.strtolower($tmp_fn[(count($tmp_fn) - 1) ]);

    if ($filetype == 'image/jpg' || $filetype == 'image/jpeg' || $filetype == 'image/gif') {
        return "<img src='csv.php?minitn=".$fileid."' alt=''>";
    } elseif ($filetype == '{{{folder}}}') {
        return '<span class="fa fa-folder-o"></span>';
    } else {
        switch ($ext) {
        case '.pdf':
            return '<a href="viewpdf.php?fileid='.$fileid.'><span class="fa fa-file-pdf-o"></span></a>';
        case '.doc':
            return '<span class="fa fa-file-word-o"></span>';
        case '.docx':
            return '<span class="fa fa-file-word-o"></span>';
        case '.xls':
            return '<span class="fa fa-file-excel-o"></span>';
        case '.xlsx':
            return '<span class="fa fa-file-excel-o"></span>';
        case '.xlsm':
            return '<span class="fa fa-file-excel-o"></span>';
        case '.jpg':
            return '<span class="fa fa-file-image-o"></span>';
        case '.jpeg':
            return '<span class="fa fa-file-image-o"></span>';
        case '.gif':
            return '<span class="fa fa-file-image-o"></span>';
        case '.png':
            return '<span class="fa fa-file-image-o"></span>';
        case '.tif':
            return '<span class="fa fa-file-image-o"></span>';
        case '.txt':
            return '<span class="fa fa-file-text-o"></span>';
        case '.zip':
            return '<span class="fa fa-file-archive-o"></span>';
        case '.tar.gz':
            return '<span class="fa fa-file-archive-o"></span>';
        case '.tgz':
            return '<span class="fa fa-file-archive-o"></span>';
        case '.arj':
            return '<span class="fa fa-file-archive-o"></span>';
        case '.7z':
            return '<span class="fa fa-file-archive-o"></span>';
        case '.tar':
            return '<span class="fa fa-file-archive-o"></span>';
        case '.wav':
            return '<span class="fa fa-file-audio-o"></span>';
        case '.mp3':
            return '<audio controls="" preload="none" src="csv.php?fileid='.htme($fileid).'">&nbsp;</audio>';
        case '.txt':
            return '<span class="fa fa-file-text-o"></span>';
        case '.asc':
            return '<span class="fa fa-file-text-o"></span>';
        case '.xml':
            return '<span class="fa fa-file-code-o"></span>';
        case '.ppt':
            return '<span class="fa fa-file-powerpoint-o"></span>';
        case '.pptx':
            return '<span class="fa fa-file-powerpoint-o"></span>';
        default:
            return '<span class="fa fa-file-o"></span>';
        }
    }
}
function CalculateNumberOfWorkingDaysBetweenDates($StartTime, $EndTime)
{
    $WorkingDays = 0;
    while ($StartTime <= $EndTime) {
        if (date('D', $StartTime) == 'Sat' || date('D', $StartTime) == 'Sun') {
            //$IgnorDays++;
        } else {
            ++$WorkingDays;
        }
        $StartTime = $StartTime + 86400;
    }

    return $WorkingDays;
}
function EvaluateTemplatePHP($code, $eid = false, $flextable = false, $flextablerecord = false)
{
    global $secure_modules;
    $recordid = $flextablerecord;
    $table = $flextable;
    $flextable = str_replace('t', '', $flextable);
    $flextableid = str_replace('t', '', $flextable);

    if (ipi(str_replace('t', '', $flextable))) {
        $flextable = str_replace('t', '', $flextable);
    }

        //require $GLOBALS['PATHTOINTERLEAVE'] . "config/config.inc.php";
        //print 'secure_modules : ' . $secure_modules[$GLOBALS['repository']];
        if ($secure_modules[$GLOBALS['repository']] == 'yes') {
            /* deze kan weg eigenlijk */
            if (GetSetting('DevelopmentOrProduction') == 'Development') {
                $ls = new SaferScript('<?php ?>'.$code.'<?php ?>');
                $ls->allowHarmlessCalls();
                $res = $ls->parse();
                if (count($res) > 0) {
                    // illegal function calls found
                    return 'illegal function calls - not executing code: '.string_r($res);
                }
            }
        }

    qlog(INFO, 'Evaluating this template ... ');

    ob_start();

    eval('?>'.$code);

    $ret = ob_get_contents();
    ob_end_clean();

    if ($ret == '') {
        // Something went horribly wrong
            return $code;
    } else {
        return $ret;
    }
}
function GetArrayKeyName(array $a, $pos)
{
    $temp = array_slice($a, $pos, 1, true);

    return key($temp);
}
function br2nl($text)
{
    return preg_replace("/\<br( )?(\/)?\>/i", "\n", $text);
}
function journal($eid, $msg, $type = 'entity')
{
    if (strlen($msg) > 524288) {
        // This is dangerous, the journal table could fill up
        return false;
    }

    if (trim($msg) == '') {
        $msg = GetBackTrace();
    }
    if (!is_array($GLOBALS['AddToJournal'])) {
        $GLOBALS['AddToJournal'] = array();
    }

    $tmp = array();
    $tmp['record'] = $eid;
    $tmp['user'] = $GLOBALS['USERID'];
    $tmp['message'] = $msg;
    $tmp['type'] = $type;
    $tmp['isodatetime'] = date('Y-m-d H:i:s');

    $GLOBALS['AddToJournal'][] = $tmp;

    return true;
}
function commit_journal()
{
    if (count($GLOBALS['AddToJournal']) > 0) {
        $sql = 'INSERT INTO CRMjournal(eid,user,message,type,timestamp_last_change) VALUES ';
        $nf = false;
        foreach ($GLOBALS['AddToJournal'] as $row) {
            if ($nf) {
                $sql .= ', ';
            }
            $sql .= " ('".mres($row['record'])."','".mres($row['user'])."','".mres($row['message'])."','".mres($row['type'])."','".mres($row['isodatetime'])."')";
            $nf = true;
        }
        mcq($sql);
        //  DA($sql);
        unset($GLOBALS['AddToJournal']);
    }
}
function year_weeknumber_to_mondaydate($year, $weeknumber)
{
    //een jaar begint altijd op 1 januari
    //een week begint altijd op maandag
    //week 1 van een jaar is de week "with more than 3 days this year" ISO 8601; wanneer 1 januari op een donderdag valt dan is DAT week 1, valt 1 januari op een vrijdag dan hoort 1 januari in W52 (of 53) van het afgelopen jaar
    //week 1 van 2013 kan in 2012 beginnen
    $jan1 = $year.'-01-01';

    //1 (for Monday) through 7 (for Sunday)
    $weekday_of_jan1 = date('N', strtotime($jan1));

    $days_to_first_monday = 0;

    //1 jan = maandag: week 1 begint op maandag 1 januari
    if ($weekday_of_jan1 == 1) {
        $days_to_first_monday = 0;
    }
    //1 jan = dinsdag: week 1 begint op maandag 31 december van het afgelopen jaar
    elseif ($weekday_of_jan1 == 2) {
        $days_to_first_monday = -1;
    }
    //1 jan = woensdag: week 1 begint op maandag 30 december van het afgelopen jaar
    elseif ($weekday_of_jan1 == 3) {
        $days_to_first_monday = -2;
    }
    //1 jan = donderdag: week 1 begint op maandag 29 december van het afgelopen jaar
    elseif ($weekday_of_jan1 == 4) {
        $days_to_first_monday = -3;
    }
    //1 jan = vrijdag: week 1 begint op maandag 4 januari (1, 2 en 3 januari vallen in de laatste week (52 of 53) van het afgelopen jaar)
    elseif ($weekday_of_jan1 == 5) {
        $days_to_first_monday = 3;
    }
    //1 jan = zaterdag: week 1 begint op maandag 3 januari (1 en 2 januari vallen in de laatste week (52 of 53) van het afgelopen jaar)
    elseif ($weekday_of_jan1 == 6) {
        $days_to_first_monday = 2;
    }
    //1 jan = zondag: week 1 begint op maandag 2 januari (1 januari valt in de laatste week (52 of 53) van het afgelopen jaar)
    elseif ($weekday_of_jan1 == 7) {
        $days_to_first_monday = 1;
    }

    $mondaydate_of_week1 = date('Y-m-d', strtotime($jan1.' +'.$days_to_first_monday.' day'));

    $mondaydate_of_requested_week = date('Y-m-d', strtotime($mondaydate_of_week1.' +'.($weeknumber - 1) * 7 .' day'));

    return $mondaydate_of_requested_week;
}
function CopyFileToDisk($fileid)
{
    //$fc = db_GetValue("SELECT content FROM CRMblobs WHERE fileid='" . mres($fileid) . "'");
    $fc = GetFileContent($fileid);
    $fn = tempnam(GetSetting('TMP_FILE_PATH'), 'INTLV_FILEINDEX_');
    $fp = fopen($fn, 'w');
    fputs($fp, $fc);
    fclose($fp);

    return $fn;
}
function CopyTemplateToDisk($fileid)
{
    $fc = GetTemplate($fileid);
    $fn = tempnam(GetSetting('TMP_FILE_PATH'), 'INTLV_FILEINDEX_');
    $fp = fopen($fn, 'w');
    fputs($fp, $fc);
    fclose($fp);

    return $fn;
}
function CleanupExtractedAscii($out)
{
    if ($out == '{0}') {
        return $out;
    }

    $out = strtolower($out);
    $out = preg_replace("/\W/", ' ', $out);
    $out = str_replace('_', ' ', $out);
    $out = preg_replace("/\s+/", ' ', $out);
    $out = implode(' ', array_unique(explode(' ', $out)));

    return $out;
}
function SetExtractedAsciiData($fileid, $data)
{
    $data = CleanupExtractedAscii($data);

    if (is_positive_integer($fileid) && trim($data) != '') {
        mcq("UPDATE CRMbinfiles SET extractedascii='".mres($data)."',timestamp_last_change=timestamp_last_change WHERE fileid=".$fileid);
    }
}
function ProcessZipArchive($diskfile)
{
    $ascii = '';
    $zip = zip_open($diskfile);
    while ($zip_entry = zip_read($zip)) {
        $entry_name = zip_entry_name($zip_entry);
        qlog(INFO, 'CASH Processing '.$entry_name);
        $tmp_fn = explode('.', $entry_name);
        $entry_ext = '.'.strtolower($tmp_fn[(count($tmp_fn) - 1) ]);

        $entry_content = zip_entry_read($zip_entry, zip_entry_filesize($zip_entry));
        $fn = tempnam(GetSetting('TMP_FILE_PATH'), 'INTLV_FILEINDEX_');
        $fp = fopen($fn, 'w');
        fputs($fp, $entry_content);
        fclose($fp);

        if ($entry_ext == '.zip') {
            $ascii .= ProcessZipArchive($fn);
        } else {
            if ($GLOBALS['CMDLINE']) {
                //                print "Updated info of file " . $diskfile . " : " . fillout(strlen($ret['ascii']), 7) . " bytes of ascii data extracted from ZIP-archive.\n";
        echo 'Processing '.$entry_name." from zip file\n";
            }
            $ret = GetIndexData($fn, $entry_name);
            $ascii .= $entry_name.' '.$ret['ascii'];
        }

        unlink($fn);
    }
    zip_close($zip);

    return $ascii;
}
function ExtractIndexData($fileid = false, $updateonly = false)
{
    $to_process = array();

    if ($fileid == false && $updateonly) {
        $to_process = db_GetFlatArray("SELECT fileid FROM CRMbinfiles WHERE extractedascii='' AND koppelid>0 ORDER BY fileid");
    } elseif ($fileid == false) {
        $to_process = db_GetFlatArray('SELECT fileid FROM CRMbinfiles WHERE koppelid>0 ORDER BY fileid');
    } elseif (is_positive_integer($fileid)) {
        array_push($to_process, $fileid);
    }
    foreach ($to_process as $filenum) {
        $fn = GetFileName($filenum);

        if ($GLOBALS['CMDLINE']) {
            echo date('r').': Extract ascii fileid '.$filenum.' ('.$fn.') (MB: '.round(memory_get_usage() / 1024 / 1024, 2).")\n";
        }

    // Catch compressed archives here
    $tmp_fn = explode('.', $fn);
        $ext = strtolower($tmp_fn[(count($tmp_fn) - 1) ]);

    //LockFileForAsciiExtraction($filenum);
    mcq("UPDATE CRMbinfiles SET extractedascii='{0}',timestamp_last_change=timestamp_last_change WHERE fileid=".$filenum);

        $diskfile = CopyFileToDisk($filenum);
        if (filesize($diskfile) > 0) {
            $ascii = '';

            if ($ext == 'zip') {
                $ascii = ProcessZipArchive($diskfile);
            } else {
                $ret = GetIndexData($diskfile, $fn);
                $ascii = $ret['ascii'];
            }

            if ($ascii != '') {
                SetExtractedAsciiData($filenum, $ascii);
            }

        /* try to find GPS coordinates -> KAN DIT NIET BETER IN 2 STAPPEN? */
        mcq("UPDATE `CRMbinfiles` SET `CRMbinfiles`.`coordinates` = '".mres(GetGPSCoordinates($diskfile))."', `CRMbinfiles`.`timestamp_last_change`=`CRMbinfiles`.`timestamp_last_change` WHERE `CRMbinfiles`.`fileid`=".$filenum);
        }

        unlink($diskfile);
    }
}
function GetIndexData($file_to_pass, $fn)
{
    $ascii = '';
    $type = '';

    $tmp_fn = explode('.', $fn);
    $ext = '.'.strtolower($tmp_fn[(count($tmp_fn) - 1) ]);

    qlog(INFO, 'Working on '.$filename);
    switch ($ext) {
    case '.xlsx':
        $ascii = ExtractExcelAscii($file_to_pass);
        $type = $ext.': MS Excel 2007+';
        break;
    case '.xlsm':
        $ascii = ExtractExcelAscii($file_to_pass);
        $type = $ext.': MS Excel 2007+';
        break;
    case '.pptx':
        $ascii = ExtractPowerpointAscii($file_to_pass);
        $type = $ext.': MS Powerpoint 2007+';
        break;
    case '.docx':
        $ascii = ExtractWordAscii($file_to_pass);
        $type = $ext.': MS Word 2007+';
        break;
    case '.pdf':
        $ascii = ExtractPDFAscii($file_to_pass);
        $type = $ext.': Portable Document Format';
        break;
    case $ext == '.odf' || $ext == '.ods' || $ext == '.odp' || $ext == '.odt':
        $ascii = ExtractOOAscii($file_to_pass);
        $type = $ext.': OpenOffice OpenDocument';
        break;
    case '.rtf':
        $ascii = ExtractRTFAscii($file_to_pass);
        $type = $ext.': Rich Text Format';
        break;
    case '.exe':
        $type = $ext.": we don't index executables";
    break;
    case '.jpg':
        $type = $ext.": we don't index images";
    break;
    case '.jpeg':
        $type = $ext.": we don't index images";
    break;
    case '.gif':
        $type = $ext.": we don't index images";
    break;
    case '.bmp':
        $type = $ext.": we don't index images";
    break;
    case '.png':
    $type = $ext.": we don't index images";
    break;
    case '.tiff':
        $type = $ext.": we don't index images";
        break;
    case '.tif':
    $type = $ext.": we don't index images";
    break;
    case $ext == '.gz' || $ext == '.arj' || $ext == '.7z' || $ext == '.bzip2' || $ext == '.tgz':
        $ascii = '';
        $type = $ext.': unsupported compressed file';
        break;
    case $ext == '.html' || $ext == '.htm' || $ext == '.xml':
    $ascii = html2plaintext(file_get_contents($file_to_pass));
    $type = $ext.': html/xml';
    break;
    case $ext == '.txt' || $ext == '.asc' || $ext == '.csv' || $ext == '.xslt' || $ext == '.sql' || $ext == '.ini' || $ext == '.php' || $ext == '.asp' || $ext == '.pl' || $ext == '.css' || $ext == '.msg' || $ext == '.eml':
        $ascii = file_get_contents($file_to_pass);
        $type = $ext.': plain text';
        break;
    default:
        $ascii = ExtractBinAscii($file_to_pass);
        $type = $ext.': no parser for this file extension, treating as binary file';
        break;
    }

    $ret = array();
    $ret['ascii'] = $ascii;
    $ret['type'] = $type;

    return $ret;
}
function ExtractPowerpointAscii($file)
{
    $extracted_content = '';
    $zip = zip_open($file);
    while ($zip_entry = zip_read($zip)) {
        if (substr(zip_entry_name($zip_entry), 0, 16) == 'ppt/slides/slide') {
            $xml = zip_entry_read($zip_entry, zip_entry_filesize($zip_entry));
            $extracted_content .= ' '.strip_tags_to_space($xml);
        }
    }
    zip_close($zip);

    return $extracted_content;
}
function ExtractExcelAscii($file)
{
    $extracted_content = '';
    $zip = zip_open($file);
    while ($zip_entry = zip_read($zip)) {
        if (zip_entry_name($zip_entry) == 'xl/sharedStrings.xml') {
            $xml = zip_entry_read($zip_entry, zip_entry_filesize($zip_entry));
            $extracted_content .= ' '.strip_tags_to_space($xml);
        }
    }
    zip_close($zip);

    return $extracted_content;
}
function ExtractWordAscii($file)
{
    $extracted_content = '';
    $zip = zip_open($file);
    while ($zip_entry = zip_read($zip)) {
        if (zip_entry_name($zip_entry) == 'word/document.xml') {
            $xml = zip_entry_read($zip_entry, zip_entry_filesize($zip_entry));
            $extracted_content .= ' '.strip_tags_to_space($xml);
        }
    }
    zip_close($zip);

    return $extracted_content;
}
function ExtractOOAscii($file)
{
    $extracted_content = '';
    $zip = zip_open($file);
    while ($zip_entry = zip_read($zip)) {
        if (zip_entry_name($zip_entry) == 'content.xml') {
            $xml = zip_entry_read($zip_entry, zip_entry_filesize($zip_entry));
//            $xml = str_replace("</text:p>", " </text:p>", $xml);
            $extracted_content .= ' '.strip_tags_to_space($xml);
        }
    }
    zip_close($zip);

    return $extracted_content;
}
function ExtractRTFAscii($file)
{
    require_once 'lib/parsertf.class.php';
    $r = new rtf(file_get_contents($file));
    $r->output('html');
    $r->parse();
    $ascii = '';
    //jh 2016-11-11 er komt soms een hoop data mee als er afbeeldingen in rtf's staan; daarom gooien we hier alles weg wat langer is dan 24 karakters
    foreach (explode(' ', html2plaintext($r->out)) as $word) {
        if (strlen($word) <= 24) {
            $ascii .= $word.' ';
        }
    }

    return $ascii;
    /*
    $extracted_content = "";
    $extracted_content = file_get_contents($file);
    print "RTF SIZE: " . strlen($extracted_content) ."\n";
    $extracted_content = str_replace("({\\)(.+?)(})|(\\)(.+?)(\b)", "", $extracted_content);
    print "RTF SIZE: " . strlen($extracted_content). " (after)\n";
    return $extracted_content;
    */
}
function command_exist($cmd)
{
    $returnVal = shell_exec('which '.$cmd);

    return empty($returnVal) ? false : true;
}
function ExtractPDFAscii($file)
{
    $ascii = '';
    /* check if pdftotext is installed on this system. if so, use it, it's better */
    if (command_exist('pdftotext')) {

        /* create target filename (pdftotext limitation) */
        $target = tempnam(GetSetting('TMP_FILE_PATH'), 'INTLV_FILEINDEXP2T_');

        /* execute command, output goes to $target */
        $cmd = 'pdftotext -nopgbrk -q '.$file.' '.$target;
        system($cmd);

        /* fetch result in 1 go (should we check for too large files here?) */
        $ascii = file_get_contents($target);

        //print date('r') . ": Extracted " . strlen($result) . " bytes of ascii\n";
        //print date('r') . ": Extracted " . substr($result,0,10) . " \n";
        /* delete temporary file */
        unlink($target);
    } else {
        include 'lib/pdfparser/include.php';
        //print "Work $file";
        // Parse pdf file and build necessary objects.
//		$result = array();
        try {
            $parser = new \Smalot\PdfParser\Parser();
            $pdf = $parser->parseFile($file);
            // De parse pdf code is aangepast zodat deze geen exceptions meer throw'd maar een false returned. Vandaar deze check. Slordig,
            // maar parse pdf klapt er anders helemaal uit wat bij batchverwerking duedate_notify_cron de nek omdraait.
            if (is_object($pdf)) {
                $ascii = $pdf->getText();
/*
                $ar = explode(" ", $text);
                $text = "";
                $result = array();
                foreach ($ar AS $word) {
                    if (strlen($word) > 3 && !in_array($word, $result)) {
                        $result[] = $word;
                    }
                }
*/
                // Retrieve all details from the pdf file.
                $details = $pdf->getDetails();

                // Loop over each property to extract values (string or array).
                foreach ($details as $property => $value) {
                    /*					if (is_array($value)) {
                        $value = implode(', ', $value);
                    }
                    $result[] = $value;*/
                    $ascii .= ' '.$value;
                }
            }
        } catch (Exception $e) {
            // don't do anything
        }

        return implode(' ', $result);
    }

    return $ascii;
}
function ExtractBinAscii($file)
{
    $total_record = '';
    $record_buffer = '';

    $fp = fopen($file, 'r');
    while (!feof($fp)) {
        $line = fgets($fp, 108096);
        $len = strlen($line);
        for ($x = 1; $x < $len; ++$x) {
            $char = $line[$x];
            $asc = ord($char);
//spatie, 0-9 A-Z a-z
//            if ($asc == 32 || ($asc > 47 && $asc < 58) || ($asc > 64 && $asc < 91) || ($asc > 96 && $asc < 123)) { // ASCII Default character found, start recording
        if (($asc > 47 && $asc < 58) || ($asc > 64 && $asc < 91) || ($asc > 96 && $asc < 123)) { // ASCII Default character found, start recording
                $record_buffer .= $char;
        } else {
            if ((strlen($record_buffer) >= 4) && (strlen($record_buffer) <= 24)) {
                $total_record .= ' '.$record_buffer;
            }
            $record_buffer = '';
        }
//JH 2016-11-10 uitgezet; deze draait VOOR IEDERE BYTE in het te parsen bestand. veel te duur. en met 128mb memory limit is dat sowieso voldoende
/*            if ((memory_get_usage() / 1024 / 1024) > 32) {
                return $total_record;
            }*/
        }
    }
    fclose($fp);

    return $total_record;
}
function strip_tags_to_space($str)
{
    //jh deze doet het beter dan een preg_replace wanneer er nog < > in de tags zelf staan
    return strip_tags(str_replace('<', ' <', $str));
}
function getDataArray($data, $start_word, $end_word)
{
    $start = 0;
    $end = 0;
    $a_result = array();

    while ($start !== false && $end !== false) {
        $start = strpos($data, $start_word, $end);
        if ($start !== false) {
            $end = strpos($data, $end_word, $start);
            if ($end !== false) {
                // data is between start and end
                $a_result[] = substr($data, $start, $end - $start + strlen($end_word));
            }
        }
    }

    return $a_result;
}
function ParseZippedContent($fileid, $eid, $cid, $flextable, $flextablerecord, $extraparsefunc = false, $raw = false)
{
    $fn = GetTemplateName($fileid);
    $tmp_fn = explode('.', $fn);
    $ext = '.'.strtolower($tmp_fn[(count($tmp_fn) - 1) ]);

    $ftp = array(); // Files in archive to run through parser
    switch ($ext) {
    case '.xlsx':
        $ftp[] = '/xl/sharedStrings.xml';
        for ($x = 0; $x < 64; ++$x) {
            $ftp[] = '/xl/worksheets/sheet'.$x.'.xml';
        }
        $raw = 'dontformatnumbers';
        break;

    case '.xlsm':
        $ftp[] = '/xl/sharedStrings.xml';
        for ($x = 0; $x < 64; ++$x) {
            $ftp[] = '/xl/worksheets/sheet'.$x.'.xml';
        }
        $raw = 'dontformatnumbers';
        break;

    case '.docx':
        $ftp[] = '/word/document.xml';
        break;

    case '.odt':
        $ftp[] = '/content.xml';
        break;

    case '.ods':
        $ftp[] = '/content.xml';
        $raw = 'dontformatnumbers';
        break;

    }
    if (GetTemplateType($fileid) == 'TEMPLATE_REPORT_PDF' || GetTemplateType($fileid) == 'TEMPLATE_PLAIN') {
        $fn = GetAttribute('template', 'FormatNumbers', $fileid);
        if ($fn == 'Yes') {
            $raw = false;
        }
    }

    return ParseZipFile($fileid, $ftp, $eid, $cid, $flextable, $flextablerecord, $extraparsefunc, $raw);
}
function RmRFDir($path)
{
    if (is_dir($path) === true) {
        $files = array_diff(scandir($path), array('.', '..'));
        foreach ($files as $file) {
            RmRFDir(realpath($path).'/'.$file);
        }

        return rmdir($path);
    } elseif (is_file($path) === true) {
        return unlink($path);
    }

    return false;
}
function ParseZipFile($fileid, $Array_files_in_zip_to_parse, $eid, $cid, $flextable, $flextablerecord, $extraparsefunc = false, $raw = false)
{
    $diskfile = CopyTemplateToDisk($fileid);
    $GLOBALS['logtext'] = false; // IMPORTANT! If qlogging is enabled, the qlist.txt file will be zipped in the archive and we don't want that
    $name = md5($diskfile).date('U');
    mkdir(GetSetting('TMP_FILE_PATH').'/'.$name);
    copy($diskfile, GetSetting('TMP_FILE_PATH').'/'.$name.'/'.$name.'.INTLV');
    $newdiskfile = GetSetting('TMP_FILE_PATH').'/'.$name.'/'.$name.'.INTLV';
    chdir(GetSetting('TMP_FILE_PATH').'/'.$name.'/');
    UnZip($newdiskfile, GetSetting('TMP_FILE_PATH').'/'.$name.'/');

    unlink($newdiskfile);
    unlink($diskfile);

    foreach ($Array_files_in_zip_to_parse as $pFile) {
        $fContent = file_get_contents('.'.$pFile);

        if ($fContent != '') {
            if (function_exists($extraparsefunc)) {
                $fContent = $extraparsefunc($fContent);
            }
            $fContent = ParseTemplateLanguageTags($fContent);

            //2015-06-01 waarom staat dit er?
            //2016-12-07 HF Uitgezet. Als 't mis gaat bij Carel weer aanzetten. Mag weg na 2017-02-01.
            //$fContent = str_replace("#@", "@", $fContent);

            if (is_numeric($flextable) && IsValidFlexTableRecord($flextablerecord, $flextable)) {
                $fContent = ParseTemplateRecordData($fContent, 't'.$flextable, $flextablerecord);
            }

            $fContent = unescape_interleave_characters(ParseTemplateGeneric($fContent));
        }

        $fp = fopen('.'.$pFile, 'w');
        fputs($fp, $fContent);
        fclose($fp);
    }
    $t = Zip(GetSetting('TMP_FILE_PATH').'/'.$name.'.done', GetSetting('TMP_FILE_PATH').'/'.$name.'/');
    RmRFDir(GetSetting('TMP_FILE_PATH').'/'.$name.'/');

    return $t;
}
function Zip($filename, $path)
{

    // create object
    $zip = new ZipArchive();

    // open archive
    if ($zip->open($filename, ZIPARCHIVE::CREATE) !== true) {
        die('Could not open archive');
    }

    chdir($path);
    // initialize an iterator
    // pass it the directory to be processed

    $iterator = new RecursiveIteratorIterator(new RecursiveDirectoryIterator('.'));

    // iterate over the directory
    // add each file found to the archive
    foreach ($iterator as $key => $value) {
        if (substr($key, strlen($key) - 3, 3) != '/..' && substr($key, strlen($key) - 2, 2) != '/.') {
            $zip->addFile(realpath($key), str_replace('./', '', $key)) or die('ERROR: Could not add file: '.$key);
        }
        //		print "Add file " . realpath($key) . " == " . str_replace("./", "", $key) . "\n\n";
    }

    // close and save archive
    $zip->close();

    $zipfile = file_get_contents($filename);
    unlink($filename);

    return $zipfile;
}
function UnZip($zipFile, $to_dir)
{
    define(DIRECTORY_SEPARATOR, '/');

    $zipDir = $to_dir;
    $zip = zip_open($zipFile);
    $dirFromZip = '';
    if ($zip) {
        while ($zip_entry = zip_read($zip)) {
            $completePath = $zipDir.dirname(zip_entry_name($zip_entry));
            $completeName = $zipDir.zip_entry_name($zip_entry);

            // Walk through path to create non existing directories
            // This won't apply to empty directories ! They are created further below
            if (!file_exists($completePath) && preg_match('#^'.$dirFromZip.'.*#', dirname(zip_entry_name($zip_entry)))) {
                $tmp = '';
                foreach (explode('/', $completePath) as $k) {
                    $tmp .= $k.'/';
                    if (!file_exists($tmp)) {
                        @mkdir($tmp, 0777);
                    }
                }
            }

            if (zip_entry_open($zip, $zip_entry, 'r')) {
                if (preg_match('#^'.$dirFromZip.'.*#', dirname(zip_entry_name($zip_entry)))) {
                    if ($fd = @fopen($completeName, 'w+')) {
                        fwrite($fd, zip_entry_read($zip_entry, zip_entry_filesize($zip_entry)));
                        fclose($fd);
                    } else {
                        // We think this was an empty directory
                        mkdir($completeName, 0777);
                    }
                    zip_entry_close($zip_entry);
                }
            }
        }
        zip_close($zip);
    }

    return true;
}
function make_html_editor($id, $protectedSource, $templatecss, $enter_is_div, $height = '500', $width = '100%', $table = '', $record = '')
{
    static $included;

    $str = '';
    $str .= "<script>var CKEDITOR_BASEPATH = '".$GLOBALS['BASE']."lib/ckeditor/';</script>";
    if (!$included) {
        $str .= '<script type="text/javascript" src="'.$GLOBALS['BASE'].'lib/ckeditor/ckeditor.js?'.filemtime($GLOBALS['BASE'].'js/ckeditor/ckeditor.js').'"></script>';
    }
    $included = true;

    $str .= '<script type="text/javascript">';
    $str .= '$(document).ready(function() {';

    $str .= "CKEDITOR.config.docType = '<!DOCTYPE html>';\n";
    $str .= "CKEDITOR.config.contentsCss = [''";
    //2015-06-10 Jeroen: als een template een eigen css heeft dan is dat de ENIGE css die ingeclude wordt; dit zou alleen maar voor moeten komen bij emails; die dan ook alleen DIE css mee gestuurd krijgen
    if ($templatecss != '') {
        $str .= ",'".$templatecss."'";
    } else {
        foreach (GetCustomCSS(false, true, false, true) as $css) {
            $str .= ",'".$GLOBALS['BASE'].$css."'";
        }
    }
    $str .= ",'.cke_contents { background: none;background-image: none;}'];\n";

    $str .= "CKEDITOR.config.width = '".$width."';\n";
    $str .= "CKEDITOR.config.height = '".$height."';\n";
    $str .= "CKEDITOR.config.allowedContent = true;\n";
    $str .= "CKEDITOR.config.extraPlugins = 'colorbutton';\n";
    $str .= "CKEDITOR.config.extraPlugins = 'image';\n";
    if ($GLOBALS['UC']['PersonalDataStructure'][$table] && ipi($record)) {
        $str .= "CKEDITOR.config.filebrowserBrowseUrl = 'file.php?select=1&nonavbar=1&fqn=".$table.'-timestamp_last_change&recordid='.$record."';\n";
    }
    //$str.= "filebrowserUploadUrl: '/uploader/upload.php'
    //$str.= "CKEDITOR.config.simpleImageBrowserURL = 'record-ajax.php?method=get_images&fqn=' + $('#JS_concerningtable').val() + '-timestamp_last_change&recordid=' + $('#JS_concerningrecord').val();\n";

    if ($enter_is_div) {
        $str .= "CKEDITOR.config.enterMode = CKEDITOR.ENTER_DIV;\n";
    }

    $str .= "CKEDITOR.config.protectedSource.push( /<\?[\s\S]*?\?>/g );\n";

    $str .= "CKEDITOR.config.protectedSource.push( /@NEWONLY@/g );\n";
    $str .= "CKEDITOR.config.protectedSource.push( /@ENDNEWONLY@/g );\n";

    $str .= "CKEDITOR.config.protectedSource.push( /@XONLY@/g );\n";
    $str .= "CKEDITOR.config.protectedSource.push( /@ENDXONLY@/g );\n";

    $str .= "CKEDITOR.config.protectedSource.push( /@GROUP\d+ONLY@/g );\n";
    $str .= "CKEDITOR.config.protectedSource.push( /@ENDGROUP\d+ONLY@/g );\n";

    $str .= "CKEDITOR.config.protectedSource.push( /@GROUP\d+NOT@/g );\n";
    $str .= "CKEDITOR.config.protectedSource.push( /@ENDGROUP\d+NOT@/g );\n";

    $str .= "CKEDITOR.config.protectedSource.push( /@GROUPADMINONLY@/g );\n";
    $str .= "CKEDITOR.config.protectedSource.push( /@ENDGROUPADMINONLY@/g );\n";
    $str .= "CKEDITOR.config.protectedSource.push( /@GROUPADMINNOT@/g );\n";
    $str .= "CKEDITOR.config.protectedSource.push( /@ENDGROUPADMINNOT@/g );\n";

    $str .= "CKEDITOR.replace('".$id."');\n";

    $str .= 'CKEDITOR.config.toolbar =';
    $str .= '[';
    $str .= "['Source','-','Save','NewPage','Preview','-','Templates'],";
    $str .= "['Cut','Copy','Paste','PasteText','PasteFromWord','-','Print'],";
    $str .= "['Undo','Redo','-','Find','Replace','-','SelectAll','RemoveFormat'],";
    $str .= "['Bold','Italic','Underline','Strike','-','Subscript','Superscript'],";
    $str .= "['NumberedList','BulletedList','-','Outdent','Indent','Blockquote'],";
    $str .= "['JustifyLeft','JustifyCenter','JustifyRight','JustifyBlock'],";
    $str .= "['Link','Unlink','Anchor'],";
    $str .= "['Image','Table','HorizontalRule','Smiley','SpecialChar','PageBreak'],";
    $str .= "['Styles','Format','Font','FontSize'],";
    $str .= "['TextColor','BGColor'],";
    $str .= "['Maximize', 'ShowBlocks']";
    $str .= "];\n";

    $str .= "CKEDITOR.on( 'instanceReady', function( ev )
		{
		// The writing rules for the <p> tag.
		ev.editor.dataProcessor.writer.setRules( 'p',
			{
				// Indicates that this tag causes indentation on line breaks inside of it.
				indent : true,

				// Inserts a line break before the <p> opening tag.
				breakBeforeOpen : true,

				// Inserts a line break after the <p> opening tag.
				breakAfterOpen : true,

				// Inserts a line break before the </p> closing tag.
				breakBeforeClose : true,

				// Inserts a line break after the </p> closing tag.
				breakAfterClose : true
			});
		ev.editor.dataProcessor.writer.setRules( 'div',
			{
				// Indicates that this tag causes indentation on line breaks inside of it.
				indent : true,

				// Inserts a line break before the <p> opening tag.
				breakBeforeOpen : true,

				// Inserts a line break after the <p> opening tag.
				breakAfterOpen : true,

				// Inserts a line break before the </p> closing tag.
				breakBeforeClose : true,

				// Inserts a line break after the </p> closing tag.
				breakAfterClose : true
			});
		ev.editor.dataProcessor.writer.setRules( 'h1',
			{
				// Indicates that this tag causes indentation on line breaks inside of it.
				indent : true,

				// Inserts a line break before the <p> opening tag.
				breakBeforeOpen : true,

				// Inserts a line break after the <p> opening tag.
				breakAfterOpen : true,

				// Inserts a line break before the </p> closing tag.
				breakBeforeClose : true,

				// Inserts a line break after the </p> closing tag.
				breakAfterClose : true
			});
		ev.editor.dataProcessor.writer.setRules( 'h2',
			{
				// Indicates that this tag causes indentation on line breaks inside of it.
				indent : true,

				// Inserts a line break before the <p> opening tag.
				breakBeforeOpen : true,

				// Inserts a line break after the <p> opening tag.
				breakAfterOpen : true,

				// Inserts a line break before the </p> closing tag.
				breakBeforeClose : true,

				// Inserts a line break after the </p> closing tag.
				breakAfterClose : true
			});
		});";

    $str .= '});';
    $str .= '</script>';

    return $str;
}
function tail_file($file, $lines)
{
    //global $fsize;
    $handle = fopen($file, 'r');
    $linecounter = $lines;
    $pos = -2;
    $beginning = false;
    $text = array();
    while ($linecounter > 0) {
        $t = ' ';
        while ($t != "\n") {
            if (fseek($handle, $pos, SEEK_END) == -1) {
                $beginning = true;
                break;
            }
            $t = fgetc($handle);
            --$pos;
        }
        --$linecounter;
        if ($beginning) {
            rewind($handle);
        }
        $text[$lines - $linecounter - 1] = fgets($handle);
        if ($beginning) {
            break;
        }
    }
    fclose($handle);

    return array_reverse($text);
}
function KeyName(array $a, $pos)
{
    $temp = array_slice($a, $pos, 1, true);

    return key($temp);
}
function EvaluateCondition($condition, $eid, $originaltable)
{
    $passed = true;
    $selectfromtable = $originaltable;
    $dsname = '';
    $selectid = '';
    if (is_numeric($selectfromtable)) {
        $dsname = 't'.$selectfromtable;
        $selectfromtable = 'flextable'.$selectfromtable;
        $selectid = 'recordid';
    } elseif ($selectfromtable == 'loginusers') {
        $selectid = 'id';
        $dsname = 'users';
    } elseif ($selectfromtable == 'userprofiles') {
        $selectid = 'id';
        $dsname = 'groups';
    }
    $originaltable = str_replace('flextable', '', $originaltable);

    $value_it_is = '';
    $debug = '';
    $text = '';

    if (substr($condition['field'], 0, 4) == 'EFID') {
        $field = str_replace('EFID', '', $condition['field']);

        $debug .= ('<br>This trigger has a trigger field condition :: condition '.$condition.', recordid '.$eid.', table '.$originaltable);

        $fv = '';

        $tabletype = GetExtraFieldTableType($field);
        if ($eid == '_new_') {
            $fv = $_REQUEST['EFID'.$field];
            if (isset($_REQUEST[$dsname.'-f'.$field.'-'.$eid])) {
                $fv = $_REQUEST[$dsname.'-f'.$field.'-'.$eid];
            }
            /* DIRTY HACK */
            /*
            zie ook functions-ajax.php.
            */
            if (isset($GLOBALS['submitted_values'][$dsname.'-f'.$field])) {
                $fv = $GLOBALS['submitted_values'][$dsname.'-f'.$field];
            }
        } elseif ($tabletype == 'loginusers') {
            if ($originaltable == $tabletype) {
                /* we're editing in the user table itself. take the value of the record being edited */
                $fv = GetExtraFieldValue($eid, $field, false, false);
            } else {
                /* else, assume we want the value of the currently logged in user */
                $fv = GetExtraFieldValue($GLOBALS['USERID'], $field, false, false);
            }
            $debug .= ('<br>EvaluateCondition TTYPE user VAL: '.$fv.'');
        } elseif ($tabletype == 'userprofiles') {
            $fv = GetExtraFieldValue($GLOBALS['GROUPID'], $field, false, false);
            $debug .= ('<br>EvaluateCondition TTYPE group VAL: '.$fv.'');
        } elseif (is_numeric($tabletype) && is_numeric($originaltable) && ($originaltable == $tabletype)) {
            //$fv = GetFlextableFieldValue($eid, $field, $tabletype);
            $fv = GetExtraFieldValue($eid, $field, false, false, false);
            $debug .= ('<br>EvaluateCondition TTYPE plain flex VAL: '.$fv.'');
        } elseif (is_numeric($originaltable) && ($originaltable != GetExtraFieldTableType($field))) {
        } else {
            $fv = GetExtraFieldValue($eid, $field, false, false);
            $debug .= ('<br>EvaluateCondition TTYPE plain '.$tabletype.' VAL: '.$fv);
        }

        $matches = false;
        if (trim($condition['value']) == trim($fv)) {
            $debug .= ('<br>EvaluateCondition Condition OK: '.$condition['value'].' == '.$fv);
            $matches = true;
        } elseif ($condition['value'] == '_NOT_EMPTY_' && strlen(trim($fv)) > 0) {
            $matches = true;
            $debug .= ('<br>EvaluateCondition Condition passed; field has (some) value');
        } elseif ($condition['value'] == '_EMPTY_' && (strlen(trim($fv)) == 0 || $fv === 0)) {
            $matches = true;
            $debug .= ('<br>EvaluateCondition Condition passed; field has no value: '.$fv);
        } else {
            $debug .= ('<br>EvaluateCondition Condition failed: unknown: '.$condition['value'].' != '.$fv);
            $matches = false;
        }
        if ($matches && $condition['trueorfalse'] == 'false') {
            $passed = false;
        } elseif (!$matches && $condition['trueorfalse'] == 'true') {
            $passed = false;
        }

        $value_it_is = $fv;
    } elseif ($condition['field'] == 'group') {
        // Trigger condition is based on who is triggering this
        $matches = false;
        if ($condition['value'] == $GLOBALS['GROUPID']) {
            $matches = true;
        }
        if ($matches && $condition['trueorfalse'] == 'false') {
            $passed = false;
        } elseif (!$matches && $condition['trueorfalse'] == 'true') {
            $passed = false;
        } else {
            $passed = true;
        }
    } elseif (substr($condition['field'], 0, 7) == 'module ') {
        // Module outcome depends on a module
        $mid = str_replace('module ', '', $condition['field']);
        $text = "Trigger conditions evaluation by module\n";
        $ret = RunModule($mid, $eid, true, false, false);

        if ($selectid == 'recordid') {
            $ret = RunModule($mid, false, true, $eid, $originaltable);
        } else {
            $ret = RunModule($mid, $eid, true, false, false);
        }

        if (strtoupper($ret) == 'TRUE' && $condition['trueorfalse'] == 'false') {
            $passed = false;
            $text .= 'Module '.$mid.' returned '.$ret.' instead of false, condition failed';
        } elseif (strtoupper($ret) == 'TRUE' && $condition['trueorfalse'] == 'true') {
            $text .= 'Module '.$mid.' returned '.$ret.' which is interpreted as true, condition passed';
            //$passed = true;
        } elseif (strtoupper($ret) == 'FALSE' && $condition['trueorfalse'] == 'false') {
            $text .= 'Module '.$mid.' returned '.$ret.' which is interpreted as false, condition passed';
            //$passed = true;
        } elseif (strtoupper($ret) == 'FALSE' && $condition['trueorfalse'] == 'true') {
            $text .= 'Module '.$mid.' returned '.$ret.' instead of true, condition failed';
            $passed = false;
        } else {
            $passed = false;
            $text .= 'Module '.$mid.' returned '.$ret.' instead of '.$condition['trueorfalse'].' [unknown error], codition failed';
        }
    } elseif ($condition['field'] == 'CURDAY') {
        if ($condition['value'] == 'WORKINGDAY') {
            if (date('N') > 5) {
                $passed = false;
            }
        } elseif ($condition['value'] == 'WEEKENDDAY') {
            if (date('N') < 6) {
                $passed = false;
            }
        } elseif ($condition['value'] == 'MONDAY' && date('N') != 1) {
            $passed = false;
        } elseif ($condition['value'] == 'TUESDAY' && date('N') != 2) {
            $passed = false;
        } elseif ($condition['value'] == 'WEDNESDAY' && date('N') != 3) {
            $passed = false;
        } elseif ($condition['value'] == 'THURSDAY' && date('N') != 4) {
            $passed = false;
        } elseif ($condition['value'] == 'FRIDAY' && date('N') != 5) {
            $passed = false;
        } elseif ($condition['value'] == 'SATURDAY' && date('N') != 6) {
            $passed = false;
        } elseif ($condition['value'] == 'SUNDAY' && date('N') != 7) {
            $passed = false;
        }
    } elseif ($condition['field'] == 'editedusersgroup') {
        if (GetGroup($eid) == $condition['value'] && $condition['trueorfalse'] == 'true') {
            $passed = true;
        } elseif (GetGroup($eid) != $condition['value'] && $condition['trueorfalse'] == 'false') {
            $passed = true;
        } else {
            $passed = false;
        }
    } else {
        $row = db_GetRow('SELECT '.$condition['field'].' FROM CRM'.$selectfromtable.' WHERE '.$selectid."='".mres($eid)."'");

        $matches = false;
        if ($condition['value'] == $row[0]) {
            $matches = true;
        }
        if ($matches && $condition['trueorfalse'] == 'false') {
            $passed = false;
        } elseif (!$matches && $condition['trueorfalse'] == 'true') {
            $passed = false;
        }
        $value_it_is = $row[0];
    }
    if ($text) {
        qlog(INFO, 'EvaluateCondition '.$text);
        journal($eid, $text);
    }

    $passedAR = array();
    $passedAR['passed'] = $passed;
    $passedAR['value_it_is'] = $value_it_is;

    return $passedAR;
}
function ShowHeaders($popup = false)
{
    ob_start();

    PrintHTMLHeader();

    $title = GetSetting('title');
    $base = GetSetting('BASEURL'); //ook als beautify uit staat hebben we deze nodig

    if ($GLOBALS['webapp']) {
        $description = GetSetting('SUBTITLE');

        $filename144 = db_GetValue("SELECT filename FROM CRMbinfiles WHERE type='public' AND filename LIKE 'applogo144x144.png' AND filetype='image/png'");
        if ($filename144 != '') {
            $filename144 = 'publicfile.php?filename='.$filename144;
        } else {
            $filename144 = 'images/interleave144.png';
        }

        $filename192 = db_GetValue("SELECT filename FROM CRMbinfiles WHERE type='public' AND filename LIKE 'applogo192x192.png' AND filetype='image/png'");
        if ($filename192 != '') {
            $filename192 = 'publicfile.php?filename='.$filename192;
        } else {
            $filename192 = 'images/interleave192.png';
        }

        echo '<meta http-equiv="X-UA-Compatible" content="IE=edge">';
        echo '<meta name="description" content="'.htme($description).'">';
    //print '<meta name="viewport" content="width=device-width, initial-scale=1">';
    echo '<meta name="viewport" content="width=device-width, initial-scale=1, maximum-scale=1, user-scalable=no">';
        echo '<link rel="canonical" href="'.htme($base).'webapp.php">';
        echo '<title>'.htme($title).'</title>';
    //todo fix
    echo '<link rel="manifest" href="manifest.json?'.date('U').'">';
        echo '<meta name="mobile-web-app-capable" content="yes">';

        echo '<meta name="application-name" content="'.htme($title).'">';
        echo '<link rel="icon" sizes="192x192" href="'.$filename192.'">';
        echo '<meta name="apple-mobile-web-app-capable" content="yes">';
    //print '<meta name="apple-mobile-web-app-status-bar-style" content="black">';
    echo '<meta name="apple-mobile-web-app-status-bar-style" content="black-translucent">';

        echo '<meta name="apple-mobile-web-app-title" content="'.htme($title).'">';
        echo '<link rel="apple-touch-icon" href="'.$filename192.'">';
        echo '<meta name="msapplication-TileImage" content="'.$filename144.'">';

        $background_color = GetSetting('WebAppBackgroundColor');
        if ($background_color == '') {
            $background_color = '#ffffff';
        }

        echo '<meta name="msapplication-TileColor" content="'.$background_color.'">';
        $theme_color = GetSetting('WebAppThemeColor');
        if ($theme_color == '') {
            $theme_color = '#000000';
        }
        echo '<meta name="theme-color" content="'.$theme_color.'">';

        echo '<meta property="og:title" content="'.htme($title).'">';
        echo '<meta property="og:type" content="website">';
        echo '<meta property="og:image" content="'.$filename192.'">';
        echo '<meta property="og:url" content="'.htme($base).'webapp.php">';
        echo '<meta property="og:description" content="'.htme($description).'">';
    /*
    print '<meta name="twitter:card" content="summary">';
    print '<meta name="twitter:url" content="' . htme($base) . 'webapp.php">';
    print '<meta name="twitter:title" content="' . htme($title) . '">';
    print '<meta name="twitter:description" content="' . htme($description) . '">';
    print '<meta name="twitter:image" content="' . $filename192 . '">';
    print '<meta name="twitter:creator" content="">'; //interleave heeft geen twitter account
    */
    echo '<link rel="shortcut icon" href="favicon.ico">'; //mogelijkheid tot eigen icoon opnemen?
    //todo fix!
    echo '<link rel="stylesheet" href="font-awesome/css/font-awesome.min.css?'.date('U').'">';
        echo '<link rel="stylesheet" href="webapp.css?'.filemtime('webapp.css').'">';

    //PrintHeaderJavascript();
    //print '<script type="text/javascript" src="js/jquery-fancybox/source/jquery.fancybox.pack.js"></script>';

    echo '<script type="text/javascript" src="js/jquery.js"></script>';
        echo '<script type="text/javascript" src="js/jquery-ui/jquery-ui-1.10.4/js/jquery-ui-1.10.4.custom.min.js"></script>';
        echo '<script type="text/javascript" src="js/jquery-ui-timepicker-addon.js"></script>';
    //print '<script type="text/javascript" src="js/sorttable.js"></script>';
    echo '<script type="text/javascript" src="js/highcharts/js/highcharts.js"></script>';
        echo '<script type="text/javascript" src="js/functions.js?'.date('U').'"></script>';
        echo '<script type="text/javascript" src="js/functions_record.js?'.date('U').'"></script>';
    //print '<script type="text/javascript" src="js/jquery.autosize.input.js"></script>';
    echo '<script type="text/javascript" src="js/jquery.mobile.custom.min.js"></script>';

        echo '</head>';

        echo '<body>';

        echo '<div id="wait" class="hide_content"><span class="fa fa-circle-o-notch fa-spin"></span></div>';
    } else {
        $timeoutsec = GetSetting('timeout') * 60;

        //jh 2015-12-05 title wordt toch via js overschreven met de eerste h1, door getsetting weg te laten scheelt dit 1 query; echter niet alle pagina's hebben een h1, daarom uitgezet
        echo '<title>'.htme($title).' :: '.$GLOBALS['PRODUCT'].'</title>';
        //print '<meta http-equiv="refresh" content="' . $timeoutsec . '; url=' . $base . 'index.php">';
        echo '<link rel="shortcut icon" href="favicon.ico">';

        // Detect mobile
        $useragent = $_SERVER['HTTP_USER_AGENT'];
        $extrabodyclass = '';
        // http://detectmobilebrowsers.com/
        if ($GLOBALS['SesMem']['technicalmobile'] == '') {
            if (GetSetting('MobileInterfaceEnabled') == 'Yes' && preg_match('/(android|bb\d+|meego).+mobile|avantgo|bada\/|blackberry|blazer|compal|elaine|fennec|hiptop|iemobile|ip(hone|od)|iris|kindle|lge |maemo|midp|mmp|mobile.+firefox|netfront|opera m(ob|in)i|palm( os)?|phone|p(ixi|re)\/|plucker|pocket|psp|series(4|6)0|symbian|treo|up\.(browser|link)|vodafone|wap|windows (ce|phone)|xda|xiino/i', $useragent) || preg_match('/1207|6310|6590|3gso|4thp|50[1-6]i|770s|802s|a wa|abac|ac(er|oo|s\-)|ai(ko|rn)|al(av|ca|co)|amoi|an(ex|ny|yw)|aptu|ar(ch|go)|as(te|us)|attw|au(di|\-m|r |s )|avan|be(ck|ll|nq)|bi(lb|rd)|bl(ac|az)|br(e|v)w|bumb|bw\-(n|u)|c55\/|capi|ccwa|cdm\-|cell|chtm|cldc|cmd\-|co(mp|nd)|craw|da(it|ll|ng)|dbte|dc\-s|devi|dica|dmob|do(c|p)o|ds(12|\-d)|el(49|ai)|em(l2|ul)|er(ic|k0)|esl8|ez([4-7]0|os|wa|ze)|fetc|fly(\-|_)|g1 u|g560|gene|gf\-5|g\-mo|go(\.w|od)|gr(ad|un)|haie|hcit|hd\-(m|p|t)|hei\-|hi(pt|ta)|hp( i|ip)|hs\-c|ht(c(\-| |_|a|g|p|s|t)|tp)|hu(aw|tc)|i\-(20|go|ma)|i230|iac( |\-|\/)|ibro|idea|ig01|ikom|im1k|inno|ipaq|iris|ja(t|v)a|jbro|jemu|jigs|kddi|keji|kgt( |\/)|klon|kpt |kwc\-|kyo(c|k)|le(no|xi)|lg( g|\/(k|l|u)|50|54|\-[a-w])|libw|lynx|m1\-w|m3ga|m50\/|ma(te|ui|xo)|mc(01|21|ca)|m\-cr|me(rc|ri)|mi(o8|oa|ts)|mmef|mo(01|02|bi|de|do|t(\-| |o|v)|zz)|mt(50|p1|v )|mwbp|mywa|n10[0-2]|n20[2-3]|n30(0|2)|n50(0|2|5)|n7(0(0|1)|10)|ne((c|m)\-|on|tf|wf|wg|wt)|nok(6|i)|nzph|o2im|op(ti|wv)|oran|owg1|p800|pan(a|d|t)|pdxg|pg(13|\-([1-8]|c))|phil|pire|pl(ay|uc)|pn\-2|po(ck|rt|se)|prox|psio|pt\-g|qa\-a|qc(07|12|21|32|60|\-[2-7]|i\-)|qtek|r380|r600|raks|rim9|ro(ve|zo)|s55\/|sa(ge|ma|mm|ms|ny|va)|sc(01|h\-|oo|p\-)|sdk\/|se(c(\-|0|1)|47|mc|nd|ri)|sgh\-|shar|sie(\-|m)|sk\-0|sl(45|id)|sm(al|ar|b3|it|t5)|so(ft|ny)|sp(01|h\-|v\-|v )|sy(01|mb)|t2(18|50)|t6(00|10|18)|ta(gt|lk)|tcl\-|tdg\-|tel(i|m)|tim\-|t\-mo|to(pl|sh)|ts(70|m\-|m3|m5)|tx\-9|up(\.b|g1|si)|utst|v400|v750|veri|vi(rg|te)|vk(40|5[0-3]|\-v)|vm40|voda|vulc|vx(52|53|60|61|70|80|81|83|85|98)|w3c(\-| )|webc|whit|wi(g |nc|nw)|wmlb|wonu|x700|yas\-|your|zeto|zte\-/i', substr($useragent, 0, 4))) {
                $GLOBALS['SesMem']['mobile'] = true;
                $GLOBALS['SesMem']['technicalmobile'] = 'yes';
            } else {
                $GLOBALS['SesMem']['technicalmobile'] = 'no';
            }
        }
        if (GetSetting('MobileInterfaceEnabled') == 'Yes' && $_GET['interface'] == 'desktop') {
            $GLOBALS['SesMem']['mobile'] = false;
            EndSession();
        } elseif (GetSetting('MobileInterfaceEnabled') == 'Yes' && $_GET['interface'] == 'mobile') {
            $GLOBALS['SesMem']['mobile'] = true;
            EndSession();
        }

        //ook voor desktop
        echo '<meta name="viewport" content="width=device-width, initial-scale=1">';

        if ($GLOBALS['SesMem']['mobile'] && GetSetting('MobileInterfaceEnabled') == 'Yes') {
            echo '<script type="text/javascript">var mobile=true;var windowpopupmethod="newwindow";</script>';
            $extrabodyclass = ' mobile';
        } else {
            echo '<script type="text/javascript">var mobile=false;var windowpopupmethod="fancybox";</script>';
            $extrabodyclass = ' desktop';
        }

        PrintHeaderJavascript();

        DisplayCSS();
        echo '</head>';

        echo '<body id="ilbody"';
        if (!$_REQUEST['nonavbar'] && !$popup) {
            echo ' class="mainbody '.$extrabodyclass.'"';
        } else {
            echo ' class="subbody '.$extrabodyclass.'"';
        }
        echo '>';
        if (isset($_GET['SkipMainNavigation'])) {
            echo '<div id="minifiedmenu" class="hide_content">';
        }
        echo '<div id="navigation">';

        if (!$_REQUEST['nonavbar']) {
            echo create_menu();
        }
        echo '</div>'; // <!-- end DIV navigation //-->";
        if (isset($_GET['SkipMainNavigation'])) {
            echo '</div><script type="text/javascript">hideLayer(\'MainContent\');document.documentElement.style.backgroundImage=\'none\';document.body.style.backgroundColor=\'#ffffff\';</script><div id="adminmainnavdiv"';
            if (GetSetting('DevelopmentOrProduction') != 'Development') {
                echo ' class="adminmainnavdiv-production"';
            }
            echo ' onclick="hideLayer(\'adminmainnavdiv\');showLayer(\'minifiedmenu\');showLayer(\'MainContent\');">'.GetSetting('title').' :: User '.GetUserName($GLOBALS['USERID']);
            echo '<span class="dropds">[<a href="admin.php?dropds">drop datastructure</a>]</span> <span class="dropds">[<a href="http://www.atomos.nl">get help</a>]</span>';
            echo '</div>';
        }

        if (!$_REQUEST['nonavbar'] && $GLOBALS['BODY_URGENTMESSAGE'] != '') {
            echo '<div id="UrgentMessage">'.htme(unescape_interleave_characters(ParseTemplateGeneric($GLOBALS['BODY_URGENTMESSAGE']))).'</div>';
        }

        echo '<div id="wait" class="hide_content"><span class="fa fa-refresh fa-spin waitrefresh"></span><div class="WaitImageDiv"></div></div>';
        echo '<div id="MessagesDiv" class="hide_content"></div>';

        if ($GLOBALS['WRONGSERVERMESSAGE'] != '' && $base != '' && !$_REQUEST['nonavbar']) {
            $connected_url = $_SERVER['HTTP_HOST'];

            if (preg_match("/^http(s)?:\/\/$connected_url/", $base) == false) {
                echo "<div class='errmsg'>".$GLOBALS['WRONGSERVERMESSAGE'].'</div>';
                log_msg('ERROR: User '.$GLOBALS['USERID'].' ('.GetUserName($GLOBALS['USERID']).') is using '.$title.' by accessing '.$connected_url.' instead of '.$base);
            }
        }

        //print '<script type="text/javascript"></script>';

        echo '<div id="MainContent"';
        if ($_REQUEST['nonavbar']) {
            echo ' class="popupwindow"';
        }
        echo '>';
    }

    echo '<div id="connectionerror" class="errmsg hide_content">Connection lost, please check your settings</div>';
}
function ShowDashboard()
{
    $template = '';
    if (is_numeric($GLOBALS['UC']['DASHBOARDTEMPLATE'])) {
        $template = GetTemplate($GLOBALS['UC']['DASHBOARDTEMPLATE']);
        if ($GLOBALS['SesMem']['InlineEditMode_InlineLinks'] == 'On') {
            echo '<div class="showinline" style="position: relative"><div class="showinline InlineEditModeDiv" style="position: absolute;z-index:10;left:-8px;top:-5px;"><a href="admin.php?templates=1&amp;editHTMLtemplate='.$GLOBALS['UC']['DASHBOARDTEMPLATE'].' &amp;fromlist='.base64_encode($_SERVER['REQUEST_URI']).'"><span class="fa fa-edit"></span></a></div></div>';
        }
    } else {
        $template = '<h1>
			@TITLE@ #CLOCK#</h1>
		<h2>
			Click &quot;edit&quot; on the top-right corner of this page to add items to your dashboard</h2>
		<div>
			<div id="calendar">
				#CALENDAR#</div>
			<div id="InternalMessages">
				#MESSAGES#</div>
			<div>
				<a href="admin.php?templates=1&amp;nav=dashtemplates&amp;t1=dash">Edit this dashboard template</a></div>
		</div>';
    }

    return get_parsed_template_with_given_template('', '', array(), '', false, '', $template, 'TEMPLATE_DASHBOARD');
}
function SetAttribute($item, $attr, $val, $record, $allowedoptions = false)
{

    //print "SetAttribute($item, $attr, $val, $record, $allowedoptions=false)";
    if (is_array($val) && count($val) > 0) {
        $val = serialize($val);
    } elseif (is_array($val) && count($val) == 0) {
        $val = '';
    }
    $attr = trim($attr);
    $val = trim($val);

    if ((ipi($record) || $record === 0) && trim($val) != '' && trim($attr) != '') {
        $allowed_values = '';
        if (is_array($allowedoptions)) {
            $allowed_values = serialize($allowedoptions);
        } else {
            $allowed_values = serialize(GetAttributeAllowedOptions($item, $attr));
        }

        mcq("INSERT INTO CRMattributes (entity, identifier, attribute, value, allowed_values) VALUES('".$record."','".mres($item)."','".mres($attr)."','".mres($val)."','".mres($allowed_values)."') ON DUPLICATE KEY UPDATE value='".mres($val)."', allowed_values='".mres($allowed_values)."'");
    } elseif (is_numeric($record) && trim($val) == '') {
        mcq("DELETE FROM CRMattributes WHERE entity='".mres($record)."' AND identifier='".mres($item)."' AND attribute='".mres($attr)."'");
    }
}
function AttributeAjaxEditElement($identifier, $attribute, $entity, $reload = false)
{
    $printvalue = GetAttribute($identifier, $attribute, $entity);

    if ($printvalue == '') {
        $printvalue = '&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;';
    } else {
        $printvalue = htme($printvalue);
    }

    if (!$reload) {
        $ts = '<span class="interactive_cell" id="JS_attr_'.$identifier.'-'.$attribute.'-'.$entity.'">';
    }

    $ts .= '<a onclick="load_attribute_field(\''.$identifier.'\',\''.$attribute.'\',\''.$entity.'\');">'.$printvalue.'</a>';

    if (!$reload) {
        $ts .= '</span>';
    }

    return $ts;
}
function GetAttribute($item, $attr, $record)
{
    if ($attr == '%') {
        $ret = array();
        $t = db_GetArray("SELECT attribute, value FROM CRMattributes WHERE entity='".$record."' AND identifier='".mres($item)."'");
        foreach ($t as $u) {
            $ret[$u['attribute']] = $u['value'];
        }
        ksort($ret);

        return $ret;
    } else {
        $sql = "SELECT value FROM CRMattributes WHERE entity='".$record."' AND identifier='".mres($item)."' AND attribute='".mres($attr)."'";
        //print '<br>' . $sql;
        $t = db_GetValue($sql);
        $t2 = unserialize($t);

        //MaximumValue === null wanneer het attribuut niet in de db staat
        //MaximumValue === false wanneer het attribuut wel in de db staat maar {{none}} bevat
        //MaximumValue === "" wanneer het een lege waarde bevat in de db
        //we gebruiken is_numeric om alle situaties af te vangen, MaximumValue en MinimumValue kan ook gebroken getallen bevatten 12.78 of -1293.99
        if ($t2) {
            return $t2;
        } elseif (strtolower($t) == 'a:0:{}') {
            return array();
        } elseif (strtolower($t) == '{{none}}') {
            return false;
        } else {
            return $t;
        }
    }
}
function GetAttributeAllowedOptions($item, $attr)
{
    $sql = "SELECT allowed_values FROM CRMattributes WHERE attribute='".mres($attr)."' AND identifier='".mres($item)."' AND allowed_values!='' ORDER BY timestamp_last_change DESC, LENGTH(allowed_values) DESC";
    $t = db_GetValue($sql);
    $t2 = unserialize($t);
    if ($t2) {
        return $t2;
    } elseif (strtolower($t) == 'a:0:{}') {
        return false;
    } else {
        return false;
    }
}
function GetMissingAttributes($item, $record)
{
    $ret = db_GetFlatArray("SELECT DISTINCT(attribute) FROM CRMattributes WHERE identifier='".mres($item)."' AND entity!='".$record."' AND attribute NOT LIKE 'SaveComments%'");
    sort($ret);

    return $ret;
}
function AttributeLink($item, $record, $linktext = 'Attributes', $opendirect = '', $likebutton = false)
{
    $html = "<a onclick=\"PopEditAttributesWindow('".$item."', ".$record.",'".inline_jsencode($opendirect)."');\"";
    if ($likebutton) {
        $html .= ' class="likebutton"';
    }
    $html .= '>'.htme($linktext).'</a>';

    return $html;
}
function ValidateInputHelper($worker, $header_id, $selected_field, $flextable = false)
{
    $error = false;
    $selected_field = str_replace('EFID', '', $selected_field);
    if ($selected_field != '') {
        $mem = PopStashValue($worker);
        if (is_array($mem)) {
            $cnt = 0;
            $test = array();
            foreach ($mem['arrayData'] as $row) {
                if ($cnt > 0 && $selected_field != 'none') {
                    $test = ValidateFieldInput($selected_field, trim($row[$header_id]), $flextable);

                    if ($test[0] == 'nok') {
                        $error = true;
                        break;
                    }
                } else {
                    // skip header row
                }
                ++$cnt;
            }
            if ($error) {
                echo '<span class="errmsg">{{'.$selected_field.'}} Error on line '.($cnt + 1).', value ['.substr(trim($row[$header_id]), 0, 40).'] failed. Result message (if any) : '.$test[1].'</span>';
            } elseif ($selected_field == 'none') {
                echo 'n/a';
            } else {
                echo '<span class="fa fa-check"></span>';
            }
        } else {
            echo '?';
        }
    } else {
        echo 'n/a';
    }
}

function is_valid_number($number)
{
    $is_valid_number = false;

    $return_number = '';

    //we trimmen spaties eraf
    $number = trim($number);

    //een leeg nummer wordt geinterpreteerd als "0"
    //if ($number == "") {
    //	$number = 0;
    //}
    //een valide nummer:
    //1) MAG met een + of een - beginnen
    //2) MOET 1 of meerdere digits (0-9) hebben
    //3) MAG gevolgd worden door een punt of een komma waarachter 1 of meerdere digits MOETEN staan
    if (preg_match("/^([\+\-])?(\d+)([\,\.](\d+))?$/", $number, $matches)) {
        //		print_r($matches);
        /*
        $number = "1234,23";

        matches:
        Array
        (
        [0] => 1234,23
        [1] =>
        [2] => 1234
        [3] => ,23
        [4] => 23
        )
        */
        $is_valid_number = true;
        $sign = $matches[1];
        $integer_part = $matches[2];
        //we halen leading zeroes eraf
        $integer_part = preg_replace('/^0+/', '', $integer_part);
        //er blijft niks over, dus weer een 0 terug
        if ($integer_part == '') {
            $integer_part = 0;
        }

        $decimal_part = $matches[4];

        if ($sign == '-') {
            $return_number .= '-';
        }
        $return_number .= $integer_part;
        if ($decimal_part != '') {
            $return_number .= '.'.$decimal_part;
        }
    }

    return array($is_valid_number, $return_number);
}
function is_valid_nl_date($nldate)
{
    $valid = false;
    if (preg_match("/^(\d{1,2})\-(\d{1,2})\-(\d{4})$/", $nldate, $match)) {
        $valid = checkdate($match[2], $match[1], $match[3]);
    }

    return $valid;
}
function is_valid_iso_date($date)
{
    $valid = false;
    //2016-2-20 is not a valid date, 2016-02-20 *is*; this is inconsistent with is_valid_nl_date()
    if (preg_match("/^(\d{4})\-(\d{2})\-(\d{2})$/", $date, $match)) {
        $valid = checkdate($match[2], $match[3], $match[1]);
    }

    return $valid;
}
function ValidateFieldInputDataStructureOnly($field, $data, $check_for_required_fields = false, $recordid = false)
{

    /* temporary test */
    //if ($GLOBALS['DEVELOPMENT']) {

    //	return validate_field_input($field, $data, $recordid, $check_for_required_fields);
    //}
    list($table, $field) = explode('-', $field);

    $dsfield = $table.'-'.$field;

    $msg = '';
    $pass = 'ok';

    if (substr($field, 0, 1) == 'f' && ipi(str_replace('f', '', $field))) { // It's a regular field

        list($pass, $msg, $data) = ValidateFieldInput($dsfield, $data, false, $check_for_required_fields, $recordid);
    } else {
        $prop = $GLOBALS['UC']['PersonalDataStructure'][$table]['fields'][$field];

        if ($prop['required'] == true && $data == '') {
            $pass = 'nok';
            $msg = '';
        }
        if (is_array($prop['options']) && !in_array($data, $prop['options'])) {
            if (!$prop['required'] && $value == '') {
                $pass = 'ok';
            } else {
                $pass = 'nok';
                $msg = 'Value '.$data.' not found in options list';
            }
        }
        if ($prop['use_populator_function']) {
            if (!$prop['required'] && $value == '') {
                $pass = 'ok';
            } elseif (!array_key_exists($data, get_field_options($field, $table, $record, $value))) {
                // field has a custom populator call but the value isn't in the list
                $pass = 'nok';
                $msg = 'Value '.$data.' not found in result of populator function';
            }
        }
    }

    return array($pass, $msg, $data);
}
function ValidateFieldInput($field, $data, $flextable = false, $check_for_required_fields = false, $recordid = false)
{
    global $lang;
    $msg = '';
    $origdata = $data;
    $errortext = '';

    if (trim($field == '')) {
        return array('nok', false, $data);
    }

    $ds_tablename = '';
    $fieldnum = '';
    $table = '';
    if (strstr($field, '-')) { // Probably fully qualified DS field. But you never know these days.
        $f = explode('-', $field);
        if (preg_match("/^t(\d+)$/", $f[0], $match)) {
            //	ft nummer zit nu in match[1]
            $table = $match[1];
            $flextable = $match[1];
            if (ipi($match[1])) {
                $ds_tablename = 't'.$match[1];
            } else {
                $ds_tablename = $match[1];
            }
        } else {
            $table = $f[0];
            $ds_tablename = $f[0];
        }

        if (preg_match("/^f(\d+)$/", $f[1], $match)) {
            //	f nummer zit nu in match[1]
            $field = $match[1];
        } else {
            $field = $f[1];
        }

        $fieldnum = $field;
    } else {
        $type = GetExtraFieldTableType($field);
        $fieldnum = str_replace('EFID', '', $field);
        $fieldnum = str_replace('f', '', $field);
        if (ipi($type)) {
            $ds_tablename = 't'.$type;
        } elseif ($type == 'loginusers') {
            $ds_tablename = 'users';
        } elseif ($type == 'userprofiles') {
            $ds_tablename = 'groups';
        } elseif ($type == 'files') {
            $ds_tablename = 'files';
        } else {
            $ds_tablename = $type;
        }
    }
    $ds_fieldname = $field;
    if (ipi($field)) {
        $ds_fieldname = 'f'.$field;
    }

    /* don't check for required fields on the users and groups page, for admins. */
    if (($ds_tablename == 'users' || $ds_tablename == 'groups') && is_administrator()) {
        $check_for_required_fields = false;
    }

    // Als er niks gevonden is, check dan de DS om te kijken of het veld daar in voor komt
    // Zo ja, pass naar DS check function
    // ValidateFieldInputDataStructureOnly($field, $data, $check_for_required_fields=false, $recordid=false)

    if ($ds_tablename == '' && is_array($GLOBALS['UC']['PersonalDataStructure'][$table]['fields'][$field])) {
        return ValidateFieldInputDataStructureOnly($table.'-'.$field, $data, $check_for_required_fields, $recordid);
    } else {

         /* don't check for required fields on the users and groups page, for admins. */
        /*
         * 	we weten nog niet of dit beter is. nu weer ff uit.
         *
         *if (is_administrator()) {
            $check_for_required_fields = false;
        }
        */

        if (!ipi($flextable)) {
            $flextable = false;
        }
        if (ipi(GetExtraFieldType($field))) {
            $flextable = GetExtraFieldType($field);
        }

        $some_data = false;

        if (is_array($data)) {
            foreach ($data as $line) {
                if ($line != '{{{null}}}' && $line != '') {
                    $some_data = true;
                }
            }
        } elseif ($data != '') {
            $some_data = true;
            $data = trim($data);
        }

        if ($GLOBALS['UC']['PersonalDataStructure'][$ds_tablename]['fields'][$ds_fieldname]['relation_to'] != '' && ($data == '0' || $data == '')) {
            $some_data = false;
        }
        if (ipi($recordid) || $recordid == '_new_') {
            $code = '';
            $type = '';

            /// Start by checking for CustomValidationFunctionPHP
            if (ipi($fieldnum)) {
                $code = GetAttribute('extrafield', 'CustomValidationFunctionPHP', $fieldnum);
                $type = GetExtraFieldTableType($fieldnum);
            } else {
                log_msg('ERROR: THIS WILL POTENTIALLY MAKE FORMS UNUSEABLE - TAKE ACTION AEAF2 ValidateFieldInput called with unknown field: '.$field);

                return array('nok', false, $origdata);
            }

            if (trim($code) != '' && $code != '{{none}}') {
                $flextableid = 0;
                if (ipi($type)) {
                    $record = $recordid;
                    $flextable = $type;
                    $flextableid = $type;
                    $code = ParseTemplateRecordData($code, 't'.$flextable, $recordid);
                } elseif ($type == 'user') {
                    $code = ParseTemplateUserAndGroupFields($code);
                } elseif ($type == 'group') {
                    $code = ParseTemplateUserAndGroupFields($code);
                } elseif ($type == 'files') {
                } else {
                    log_msg('ERROR: ValidateFieldInput called with unknown field table type: '.$type);

                    return array('nok', '', $origdata);
                }
                $code = unescape_interleave_characters($code);

                $result = '';
                $res = '';
                $msg = '';
                $value = $data;
                @eval($code);

                if (is_array($result)) {
                    $res = $result[0];
                    $msg = $result[1];
                    if (isset($result[2])) {
                        $origdata = $result[2];
                    }
                } else {
                    $res = $result;
                    $msg = false;
                }

                qlog(INFO, 'Evaluating custom PHP validation for field '.$field.' result:'.$res);

                if ($res == 'ok') {

                    //return array("ok", $msg, $origdata);
                } else {
                    if ($res == '') {
                        $msg = 'Validaton returned no result. Defaulting to NOK.';
                    }

                    return array('nok', $msg, trim($origdata));
                }
            }
            /// End check CustomValidationFunctionPHP
        }

        if (!$some_data && $check_for_required_fields) {
            if (ipi($field) && CheckExtrafieldRequiredConditions($recordid, $field, GetExtraFieldTableType($field))) {
                // Check field definitions to see if this field is required since it's posted empty
                $tmp = db_GetValue("SELECT forcing FROM CRMextrafields WHERE id='".mres($field)."'");
                if ($tmp == 'y') {
                    // Field is required but not entered
                    return array('nok', false, $origdata);
                } else {
                    // Field is not required and NOT entered
                    return array('ok', false, $origdata);
                }
            } elseif (ipi($field) && !CheckExtrafieldRequiredConditions($recordid, $field, GetExtraFieldTableType($field))) {
                // Field is not required and NOT entered
                return array('ok', false, $origdata);
            }
        }

        switch ($field) {

        case 'PROFILE':
            $profid = db_GetValue("SELECT id FROM CRMuserprofiles WHERE (id='".mres($data)."' OR name='".mres($data)."')");
            if (ipi($profid)) {
                return array('ok', $msg, $profid);
            } else {
                //print "Group could not be found<br>";
            }
            break;

        case 'PASSWORD':
            return array('ok', $msg, $origdata);
            break;

        case 'name':
            $test = db_GetValue("SELECT name FROM CRMloginusers WHERE name='".mres($data)."'");
            if ($test != $data) {
                return array('ok', $msg, trim($origdata));
            } else {
                //print "Duplicate user name<br>";
            }
            break;

        case 'EMAIL':
            if (ValidateEmail(trim($origdata)) || $data == '') {
                return array('ok', $msg, trim($origdata));
            }
            // print $data ." not valid<br>";
            break;

        default:
            $type = GetExtraFieldType($fieldnum);
            if ($type == 'List of all groups') {
                $profid = db_GetValue("SELECT id FROM CRMuserprofiles WHERE (id='".mres($data)."' OR name='".mres($data)."')");
                if (ipi($profid)) {
                    return array('ok', $msg, $profid);
                } else {
                }
            } elseif ($type == 'color') {
                if (preg_match('/^#[a-f0-9]{6}$/i', $data)) { // hex color is valid
                    return array('ok', $msg, $origdata);
                }
            } elseif ($type == 'drop-down') {
                $tmp = db_GetValue("SELECT options FROM CRMextrafields WHERE id='".mres($field)."'");

                if (substr($tmp, 0, 18) == '%POPULATE_BY_CODE%') {
                    // Don't take any chances
                    return array('ok', $msg, $origdata);
                }

                $options = GetExtraFieldOptions($fieldnum);
                if (in_array(trim($data), $options)) {
                    return array('ok', $msg, $origdata);
                }
            } elseif ($type == 'User-list of all CRM-CTT users' || $type == 'assignee' || $type == 'owner') {
                if (ipi($data)) {
                    $val = db_GetValue("SELECT id FROM CRMloginusers WHERE id='".mres($data)."'");
                    if (ipi($val)) {
                        return array('ok', $msg, $origdata);
                    } else {
                        $errortext = ' not_numeric';
                    }
                } else {
                    $val = db_GetValue("SELECT id FROM CRMloginusers WHERE name='".mres($data)."'");
                    if (ipi($val)) {
                        return array('ok', $msg, $origdata);
                    } else {
                        $val = db_GetValue("SELECT id FROM CRMloginusers WHERE FULLNAME='".mres($data)."'");

                        if (ipi($val)) {
                            return array('ok', $msg, $origdata);
                        } else {
                            $errortext = ' not_numeric';
                        }
                    }
                }
            } elseif ($type == 'numeric') {
                $num = is_valid_number(trim($data));

                if ($num[0]) {
                    if ($GLOBALS['UC']['PersonalDataStructure'][$ds_tablename]['fields'][$ds_fieldname]['fieldtype'] == 'number') {

                        //return array("nok", "table = " . $table . " field = " . $field, "");
                        list($whole, $decimals) = explode('.', $num[1]);
                        if (strlen($decimals) > $GLOBALS['UC']['PersonalDataStructure'][$ds_tablename]['fields'][$ds_fieldname]['decimals']) {
                            return array('nok', $lang['too_many_decimals'], '');
                        } else {
                            $MaximumValue = GetAttribute('extrafield', 'MaximumValue', $fieldnum);
                            $MinimumValue = GetAttribute('extrafield', 'MinimumValue', $fieldnum);
                            //MaximumValue === null wanneer het attribuut niet in de db staat
                            //MaximumValue === false wanneer het attribuut wel in de db staat maar {{none}} bevat
                            //MaximumValue === "" wanneer het een lege waarde bevat in de db
                            //we gebruiken is_numeric om alle situaties af te vangen, MaximumValue en MinimumValue kan ook gebroken getallen bevatten 12.78 of -1293.99. Beiden kunnen ook "0" bevatten!
                            if (is_numeric($MaximumValue) && $num[1] > $MaximumValue) {
                                return array('nok', $lang['number_too_high'].' '.$MaximumValue.'.', '');
                            } elseif (is_numeric($MinimumValue) && $num[1] < $MinimumValue) {
                                return array('nok', $lang['number_too_low'].' '.$MinimumValue.'.', '');
                            } else {
                                return array('ok', $msg, $num[1]);
                            }
                        }
                    } else {
                        return array('ok', $msg, $num[1]);
                    }
                } else {
                    $errortext = ' not_numeric';
                    //$msg = " " . $origdata . " is not a valid number";
                }
            } elseif ($type == 'date' || $type == 'date (iso)' || $field == 'duedate') {
                // At this point, we're sure that IF the date is correct, it will be formatted correctly
                if (is_valid_nl_date($data) || $data == '') {
                    return array('ok', $msg, trim($data));
                }

                // TransformDate
            } elseif ($type == 'Reference to FlexTable') {
                if ($data == '') {
                    return array('ok', $msg, $origdata);
                } else {
                    if ($origdata == '0') {
                        // Zero means empty
                        return array('ok', $msg, trim($origdata));
                    } else {
                        $childtable = $ds_tablename;
                        $childfield = 'f'.$fieldnum;
                        $childrecordid = $recordid; //select_refer_field_options() voegt de huidige gekozen waarde toe aan de opties ook indien die momenteel niet meer gekozen mag worden
                        $check_if_exists_recordids = array($data);

                        $possible_values = select_refer_field_options($childtable, $childfield, $childrecordid, false, $check_if_exists_recordids);
                        //  mail("hidde@atomos.nl", "check", "select_refer_field_options($childtable, $childfield, $childrecordid, false, " . string_r($check_if_exists_recordids) . " possible value " . string_r($possible_values) . " REQUEST " . string_r($_REQUEST) . ");");

                        //print '<h1>xxx childtable=' . $childtable . ',childfield=' . $childfield . ',childrecordid=' . $childrecordid . ',check_if_exists=' . string_r($check_if_exists_recordids) . '</h1>';
                        //pre($possible_values);

                        //het is er maar 1 maar op deze manier is de code gelijk aan de multiselect check
                        foreach ($check_if_exists_recordids as $check_if_exists_recordid) {
                            if (!array_key_exists($check_if_exists_recordid, $possible_values)) {
                                log_msg('ERROR: A user selected a value in a reference field, the value is not in the list of options. (record '.$check_if_exists_recordid.' in table '.$GLOBALS['UC']['PersonalDataStructure'][$childtable]['fields'][$childfield]['relation_to'].' referenced by field '.$childfield.' in table '.$childtable.')');

                                return array('nok', '');
                            }
                        }
                        //data == check_if_exists_recordids[0]
                        return array('ok', '', $data);
                    }
                }
            } elseif ($type == 'mail') {
                if (ValidateEmail(trim($origdata)) || $data == '') {
                    return array('ok', $msg, trim($origdata));
                }
                $errortext = $data.' not valid';
            } elseif ($type == 'date/time') {
                $test = StrDateTime2IsoDateTime($data);

                if ($test != '') {
                    return array('ok', $msg, $test);
                }
            } elseif ($type == 'checkbox') {
                return array('ok', $msg, trim($origdata));
            } elseif (substr($type, 0, 17) == 'Users of profile ') {
                if (in_array($data, GetUsersOfGroup(str_replace('Users of profile ', '', $type)))) {
                    return array('ok', $msg, $data);
                } else {
                    $errortext = ' not a valid group member';
                }
            } elseif ($type == 'diary') {
                return array('ok', $msg, $origdata);
            } elseif ($type == 'Button') {
                return array('ok', $msg, $origdata);
            } elseif ($type == 'startdate' || $field == 'entity-startdate' || $field == 'startdate') {
                if (is_valid_nl_date($data)) {
                    return array('ok', $msg, trim($data));
                }
            } elseif ($type == 'content' || $field == 'content') {
                return array('ok', $msg, $origdata);
            } elseif ($type == 'deleted') {
                if ($data == 'n' || $data == 'y') {
                    return array('ok', $msg, trim($data));
                }
            } elseif ($type == 'drop-down (multiselect)') {
                if (!is_array($data)) {
                    return array('nok', 'Not_array (DDMS) '.$data, '');
                } else {
                    $extrafield = db_GetRow("SELECT * FROM CRMextrafields WHERE id='".mres($field)."'");

                    /* remove empty elements */
                    $data = FlattenArray($data);

                    if ($extrafield['forcing'] == 'y' && count($data) == 0) {
                        /* this field is required but no options are set. deny */
                        return array('nok', $msg, array());
                    } else {
                        $options = get_selectfield_options(ef_tabletype_to_ds_tablename($extrafield['tabletype']).'-'.'f'.str_replace('EFID', '', $field), $recordid);

                        foreach ($data as $selected_option) {
                            if (!array_key_exists($selected_option, $options[0])) {
                                log_msg('ERROR: A user selected a value in a drop-down multiselect field, the value is not in the list of options. (option '.$selected_option.' in field '.$field.')');

                                return array('nok', $msg, array());
                            }
                        }

                        return array('ok', $msg, $value);
                    }
                }
            } elseif ($type == 'Reference to FlexTable (multiselect)') {
                if (!is_array($data)) {
                    return array('nok', 'Not_array (F2FMS) '.$data, '');
                } else {
                    $extrafield = db_GetRow("SELECT * FROM CRMextrafields WHERE id='".mres($field)."'");

                    /* remove empty elements */
                    $data = FlattenArray($data);

                    if ($extrafield['forcing'] == 'y' && count($data) == 0) {
                        /* this field is required but no options are set. deny */
                        $msg = 'Field is required';

                        return array('nok', $msg, array());
                    } else {
                        $childtable = $ds_tablename;
                        $childfield = 'f'.$fieldnum;
                        $childrecordid = $recordid; //select_refer_field_options() voegt de huidige gekozen waarde toe aan de opties ook indien die momenteel niet meer gekozen mag worden
                        $check_if_exists_recordids = $data;
                        $possible_values = select_refer_field_options($childtable, $childfield, $childrecordid, false, $check_if_exists_recordids);

                        //print '<h1>xxx childtable=' . $childtable . ',childfield=' . $childfield . ',childrecordid=' . $childrecordid . ',check_if_exists=' . string_r($check_if_exists_recordids) . '</h1>';
                        //pre($possible_values);

                        //het is er maar 1 maar op deze manier is de code gelijk aan de multiselect check
                        foreach ($check_if_exists_recordids as $check_if_exists_recordid) {
                            if (!array_key_exists($check_if_exists_recordid, $possible_values)) {
                                log_msg('ERROR: A user selected a value in a reference field, the value is not in the list of options. (record '.$check_if_exists_recordid.' in table '.$GLOBALS['UC']['PersonalDataStructure'][$childtable]['fields'][$childfield]['relation_to'].' referenced by field '.$childfield.' in table '.$childtable.')');

                                return array('nok', '', array());
                            }
                        }
                        //data == check_if_exists_recordids[0]
                        return array('ok', '', $value);
                    }
                }
            } elseif ($type == 'textbox') {
                return array('ok', $msg, trim($origdata));
            } elseif ($type == 'phone number') {
                list($ok, $ret) = IsValidPhonenumber($origdata);
                if ($ok) {
                    return array('ok', $msg, $ret);
                } else {
                    return array('nok', $msg, trim($origdata));
                }
            } elseif ($type == 'SQL Query') {
                return array('ok', $msg, $origdata);
            } elseif ($type == 'hyperlink') {
                if (substr($data, 0, 7) != 'http://' && substr($data, 0, 8) != 'https://') {
                    $data = 'http://'.$data;
                    $origdata = 'http://'.$origdata;
                }
                if (IsValidURL($data)) {
                    return array('ok', $msg, trim($origdata));
                } else {
                    $errortext = " URL didn't validate";
                }
            } elseif ($type == 'text area' || $type == 'text area (rich text)') {
                return array('ok', $msg, trim($origdata));
            } else {
                log_msg("WARNING: Validation of field '".$field."' assumed OK; don't know how to validate field type '".$type."' : GEFT ".GetExtraFieldType($field).' fieldnum '.$fieldnum);

                return array('ok', $msg, trim($origdata));
            }
            break;
        }

        return array('nok', $msg, $origdata);
    } // end if field found / DS fallback
}
function IsValidURL($url)
{
    if (filter_var($url, FILTER_VALIDATE_URL)) {
        if (count(explode('.', $url)) > 1) {
            return true;
        }
    }

    return false;
}
function LogPageInfo()
{
    if ($GLOBALS['logtext'] == true || $GLOBALS['qlog_onscreen'] == true) {
        $time_in_seconds = 0;
        if ($GLOBALS['starttime']) {
            $time_in_seconds = microtime_float() - $GLOBALS['starttime'];
        }
        qlog(INFO, 'Page report');

        //		qlog(INFO, "\n\n" . CheckPageLoadTiming($GLOBALS['tracelog'])) . "\n\n";
        qlog(INFO, '------------------------------------------------------------------');
        qlog(INFO, 'QS                              : '.$_SERVER['SCRIPT_NAME'].' '.$_SERVER['QUERY_STRING']);
        qlog(INFO, 'Repository                      : '.GetSetting('title'));
        qlog(INFO, 'Username                        : '.$GLOBALS['USERNAME']);
        qlog(INFO, 'RAM allocated (current)         : '.number_format(memory_get_usage()).' bytes');
        qlog(INFO, 'RAM allocated (peak)            : '.number_format(memory_get_peak_usage()).' bytes');
        qlog(INFO, 'Total SQL queries on this page  : '.$GLOBALS['mysql_query_counter']);
        qlog(INFO, 'Total SQL connects on this page : '.$GLOBALS['TIMES_DB_CONNECTS']);
        qlog(INFO, 'End of this page                : '.$time_in_seconds.' seconds total processing time');
        qlog(INFO, '------------------------------------------------------------------');
    }
}

function ReturnClassnameForTextColorBasedOnBackgroundColor($backgroundColor, $threshold = 382)
{
    if ($backgroundColor == '') {
        return 'black';
    } else {
        $c = str_replace('#', '', $backgroundColor);
        $rgb = array();
        $rgb[0] = hexdec(substr($c, 0, 2));
        $rgb[1] = hexdec(substr($c, 2, 2));
        $rgb[2] = hexdec(substr($c, 4, 2));
        if ($rgb[0] + $rgb[1] + $rgb[2] < $threshold) {
            return 'white';
        } else {
            return 'black';
        }
    }
}
function CheckPageLoadTiming($log)
{
    $ar = explode("\n", $log);
    $Functions = array();

    $last_func = '';
    $last_mt = '';
    $starttime = '';
    $endtime = '';
    foreach ($ar as $line) {
        $line = explode('::', $line);
        $tmp = explode(' ', $line[0]);
        $mt = $tmp[2];
        $function = $tmp[sizeof($tmp) - 1];

        if ($function == $last_func) {
            // Keep counting
        } else {
            if (is_numeric($mt) && is_numeric($last_mt)) {
                $Functions[$function]['time'] += ($mt - $last_mt);
            }
            $last_mt = $tmp[2];
        }

        ++$Functions[$function]['count'];
        $last_func = $function;
        if ($starttime == '') {
            $starttime = $tmp[2];
        }
        if ($tmp[2] != '') {
            $endtime = $tmp[2];
        }
    }
    asort($Functions);
    $Functions = array_reverse($Functions);

    $time = 0;
    $ret = '';
    $ret .= "-------------------------------------------------------------------------\n";
    $ret .= " Function calling               | Log lines | Time consumed             |\n";
    $ret .= "-------------------------------------------------------------------------\n";
    foreach ($Functions as $name => $row) {
        if (function_exists(trim($name))) {
            $ret .= ' '.fillout($name, 30).' | '.fillout($row['count'], 9).' | '.fillout($row['time'], 25)." |\n";
            $time += $row['time'];
        }
    }
    $ret .= "-------------------------------------------------------------------------\n";

    $diff = ($endtime - $starttime);

    //	$ret .=  "Start time       : " . $starttime . "\n";
    //	$ret .=  "End time         : " . $endtime . "\n";
    $ret .= 'Time span        : '.$diff." seconds\n";
    $ret .= 'Time measured    : '.$time." seconds\n";
    $ret .= 'Time unaccounted : '.($diff - $time)." seconds\n";
    $ret .= 'Log lines parsed : '.sizeof($ar)."\n";

    return $ret;
}
function GetAccessibleCalendars()
{
    if (is_administrator()) {
        $sql = 'SELECT * FROM `CRMcalendars` ORDER BY `CRMcalendars`.`sortorder`';
    } else {
        $sql = "
				SELECT * FROM `CRMcalendars` WHERE
				id IN (
						SELECT `CRMcalendaraccessrules`.`calendar` FROM `CRMcalendaraccessrules` WHERE `CRMcalendaraccessrules`.`group` = '" .$GLOBALS['GROUPID']."' AND `CRMcalendaraccessrules`.`read` = '1') OR
				(SELECT COUNT(*) FROM `CRMcalendaraccessrules` WHERE `CRMcalendaraccessrules`.`calendar` = `CRMcalendars`.`id`) = 0 ORDER BY `CRMcalendars`.`sortorder`";
    }
    /* very dirty, but for now fall back to the old array format */
    /*
    [jCdfjDGY] => Array
        (
            [description] => Opdrachten
            [duefield] => EFID272
            [id] => jCdfjDGY
            [commentfield] =>
            [summaryfield] => @t10-f100-t6-f277@ @t10-f100-t6-f97-t8-f104-t7-f77@ @t10-f100-t6-f72@ @t10-f100-t6-f216@ @t10-f100-t6-f217@ @t10-f100-t6-f73@ @t10-f100-t6-f71@ @t10-f100-t6-f75@ @t10-f100-t6-f68@ @t10-f100-t6-f69@ @t10-f206@
            [startdatefield] => EFID271
            [starttimefield] => EFID271
            [duetimefield] => EFID272
            [userfield] =>
            [locationfield] =>
            [resourcefield] =>
            [available] => G:5
            [useselection] =>
            [show_popup] =>
            [calendar_color] => #d2d9f5
            [show_popup_before] => 30,5,0
        )
    */
    $cals = array();
    foreach (db_GetArray($sql) as $cal) {
        $defined_cal = array();
        list($endtable, $endfield) = explode('-', $cal['ref_end_date_time']);
        list($starttable, $startfield) = explode('-', $cal['ref_start_date_time']);
        list($usertable, $userfield) = explode('-', $cal['ref_organiser']);

        if ($starttable == '' && $startfield == '') {
            $starttable = $endtable;
            $startfield = $endfield;
        }
        $defined_cal['id'] = $cal['calendar_object'];
        if ($defined_cal['id'] == '') {
            $defined_cal['id'] = 'cal'.$cal['id'];
        }
        $defined_cal['description'] = $cal['description'];
        if (ipi(str_replace('f', '', $endfield))) {
            $defined_cal['duefield'] = 'EFID'.str_replace('f', '', $endfield);
            $defined_cal['duetimefield'] = 'EFID'.str_replace('f', '', $endfield);
        } else {
            $defined_cal['duefield'] = $endfield;
            $defined_cal['duetimefield'] = $endfield;
        }
        if (ipi(str_replace('f', '', $startfield))) {
            $defined_cal['startdatefield'] = 'EFID'.str_replace('f', '', $startfield);
            $defined_cal['starttimefield'] = 'EFID'.str_replace('f', '', $startfield);
        } else {
            $defined_cal['startdatefield'] = $startfield;
            $defined_cal['starttimefield'] = $startfield;
        }
        if (ipi(str_replace('f', '', $userfield))) {
            $defined_cal['userfield'] = 'EFID'.str_replace('f', '', $userfield);
        } else {
            $defined_cal['userfield'] = $userfield;
        }
        $defined_cal['locationfield'] = $cal['location'];
        $defined_cal['resourcefield'] = $cal['resource'];
        $defined_cal['show_popup'] = $cal['display_popup'];
        $defined_cal['calendar_color'] = $cal['color_in_legend'];
        $defined_cal['show_popup'] = $cal['minutes_before_csv'];
        $defined_cal['display_popup'] = $cal['display_popup'];
        $defined_cal['commentfield'] = $cal['comment'];
        $defined_cal['summaryfield'] = $cal['summary'];
        $defined_cal['listoptions'] = $cal['listoptions'];
        $defined_cal['appointment_click_action'] = $cal['appointment_click_action'];
        $defined_cal['show_calendar_in_legend'] = $cal['show_calendar_in_legend'];
        $defined_cal['show_add_option'] = $cal['show_add_option'];
        $defined_cal['add_option_url_extras'] = $cal['add_option_url_extras'];

        /* some added security; field must be visible */
        if ($GLOBALS['UC']['PersonalDataStructure'][$endtable]['fields'][$endfield]) {
            $cals[$defined_cal['id']] = $defined_cal;
        }
    }

    return $cals;
}
function DA($ar = false, $trace = true)
{
    if ($ar == '') {
        $ar = $_REQUEST;
    }
    echo '<pre>';
    if (is_array($ar)) {
        echo htme(print_r($ar, true));
    } else {
        echo '<h1>'.htme($ar).'</h1>';
    }
    if ($trace) {
        debug_print_backtrace();
    }
    echo '</pre>';
}
function trace($msg, $also_as_non_admin = false)
{
    if (!is_administrator() && !$also_as_non_admin) {
        return '';
    }

    if ($msg != '' && !is_array($msg)) {
        echo '<h2>'.htme($msg).'</h2>';
    } elseif (is_array($msg)) {
        echo '<pre>';
        print_r($msg);
        echo '</pre>';
    }
    echo '<pre>';
    debug_print_backtrace(DEBUG_BACKTRACE_IGNORE_ARGS);
    echo '</pre>';
}
function Alert($msg)
{
    return '<script type="text/javascript">alert("'.addslashes($msg).'");</script>';
}
function JS($msg)
{
    return '<script type="text/javascript">'.$msg.'</script>';
}
function CreateHighChartFromSQLNEW($title, $subtitle, $sqls, $type, $height = '', $width = '', $FillDateGaps = '', $chartid = '', $vertical = true)
{
    //FillDateGaps = vult gaten op uit een group by van mysql
    //year: (2012, 2014, 2015) -> voegt 2013 toe ("year" kan ook gebruikt worden om gaten in iedere reeks van integers op te vullen)
    //quarter: (2015Q2, 2015Q4) -> voegt 2015Q3 toe
    //month: (2014-12, 2015-03, 2015-04) -> voegt 2015-01 en 2015-02 toe
    //week: (2015W52, 2016W02) -> voegt 2015W53 en 2016W01 toe
    //day: (2016-02-28, 2016-03-01) -> voegt 2016-02-29 toe
    $series = array();
    if (!is_array($sqls)) {
        $sqls = array($sqls);
    }

    foreach ($sqls as $sql) {
        foreach (db_GetArray($sql) as $row) {
            //each column exists twice; once numeric and once textual; this is the way mysqli_query returns db values
            $columns = count($row);
            //if (($columns == 4) || ($type == "pie"))
            if ($type == 'pie') {
                //volgorde sql select: CATEGORIE, Y-AS
                //$series["Open"] = 23;
                //$series["Closed"] = 7;
                //$series["Canceled"] = 90;
                $series[$row[0]] = $row[1];
            } elseif (($columns == 6) && ($vertical)) {
                //volgorde sql select: CATEGORIE, X-AS, Y-AS
                //$series["Open"]["2016-01"] = 23;
                //$series["Open"]["2016-02"] = 17;
                //$series["Closed"]["2016-01"] = 7;
                //$series["Closed"]["2016-04"] = 2;
                //$series["Canceled"]["2016-01"] = 90;
                //$series["Canceled"]["2016-03"] = 101;
                $series[$row[0]][$row[1]] = $row[2];
            } else {
                //HORIZONTAL
                //volgorde sql select: X-AS, CATEGORIE-1, Y-AS-1, CATEGORIE-2, Y-AS-2, CATEGORIE-3, Y-AS-3, etc.
                $count = 0;
                $firstkey = '';
                foreach ($row as $key => $val) {
                    //1 om numerieke keys uit mysql te onderdrukken
                    //2 om de eerste kolom te onderdrukken
                    if (!is_numeric($key)) {
                        if ($count == 0) {
                            $firstkey = $val;
                        } else {
                            $series[$key][$firstkey] = $val;
                        }
                        ++$count;
                    }
                }
            }
        }
    }

    return CreateHighChartNEW($title, $subtitle, $series, $type, $height, $width, $FillDateGaps, $chartid);
}
function CreateHighChartNEW($title, $subtitle, $series, $type, $height = '', $width = '', $FillDateGaps = '', $chartid = '')
{
    /*

    //INPUT 1
    $series["Open"] = 23;
    $series["Closed"] = 7;
    $series["Canceled"] = 90;

    //OF
    $series["2016-W01"] = 23;
    $series["2016-W02"] = 7;
    $series["2016-W04"] = 90;

    //INPUT 2
    $series["Open"]["2016-01"] = 23;
    $series["Open"]["2016-02"] = 17;
    $series["Closed"]["2016-01"] = 7;
    $series["Closed"]["2016-04"] = 2;
    $series["Canceled"]["2016-01"] = 90;
    $series["Canceled"]["2016-03"] = 101;

    */

    $legend = false;
    $allowsubzero = false;

    //print '<h1>series</h1>';
    //pre($series);
    $second_keys = array();
    foreach ($series as $name => $values) {
        foreach ($values as $key => $val) {
            //	print "name:" . $name . " key:" . $key . " val:" . $val . "<br>";
            if ($val < 0) {
                $allowsubzero = true;
            }
            if (!in_array($key, $second_keys)) {
                $second_keys[] = $key;
            }
        }
    }

    if ($FillDateGaps != '') {
        sort($second_keys);
        $last_date_count = 0;
        $dates_added = false;
        foreach ($second_keys as $second_key) {
            $this_date_count = 0;
            $this_date_add = 1;
            if ($FillDateGaps == 'day') {
                $this_date_count = db_GetValue("SELECT TO_DAYS('".mres($second_key)."')");
            } elseif ($FillDateGaps == 'week') {
                //SELECT STR_TO_DATE("2015W53 Monday", "%xW%v %W");
                //2015-12-28
                $this_date_count = db_GetValue("SELECT TO_DAYS(STR_TO_DATE('".mres($second_key)." Monday', '%xW%v %W'))");
                $this_date_add = 7;
            } elseif ($FillDateGaps == 'month') {
                list($this_year, $this_month) = explode('-', $second_key);
                $this_date_count = $this_year * 12 + $this_month - 1;
            } elseif ($FillDateGaps == 'quarter') {
                list($this_year, $this_quarter) = explode('Q', $second_key);
                $this_date_count = $this_year * 4 + $this_quarter - 1;
            }
            //ook toepasbaar voor om gaten in integers op te vullen
            elseif ($FillDateGaps == 'year') {
                $this_date_count = $second_key;
            }

            if ($last_date_count > 0) {
                for ($x = $last_date_count + $this_date_add; $x < $this_date_count; $x += $this_date_add) {
                    $dates_added = true;
                    //we vullen hier de second_keys array terwijl we erover itereren, dat kan want foreach maakt een copy
                    if ($FillDateGaps == 'day') {
                        $second_keys[] = db_GetValue("SELECT FROM_DAYS('".mres($x)."')");
                    } elseif ($FillDateGaps == 'week') {
                        //$label = floor($x / 52) . "W" . sprintf("%02d", ($x % 52 + 1));
                        $second_keys[] = db_GetValue('SELECT CONCAT(LEFT(YEARWEEK(FROM_DAYS('.$x."), 3),4),'W',RIGHT(YEARWEEK(FROM_DAYS(".$x.'), 3),2))');
                    } elseif ($FillDateGaps == 'month') {
                        $second_keys[] = sprintf('%04d-%02d', floor($x / 12), $x % 12 + 1);
                    } elseif ($FillDateGaps == 'quarter') {
                        $second_keys[] = sprintf('%04dQ%d', floor($x / 4), $x % 4 + 1);
                    } elseif ($FillDateGaps == 'year') {
                        $second_keys[] = $x;
                    }
                }
            }
            $last_date_count = $this_date_count;
        }
        if ($dates_added) {
            sort($second_keys);
        }
    }

    $xAxisCategories = $second_keys;

    if (count($series) > 1) {
        $legend = true;
    }

    $stack = false;
    $stackarea = false;
    if ($type == '') {
        $type = 'line';
    } elseif ($type == 'stacked column') {
        $stack = true;
        $type = 'column';
    } elseif ($type == 'stacked area') {
        $type = 'area';
        $stackarea = true;
    }

    if ($chartid == '') {
        //	$chartid = preg_replace("/\W/", "", $title);
        $chartid = 'C'.randomstring(8);
    }

    $styles = '';
    if ($width != '') {
        $styles .= 'width: '.$width.';';
    }
    if ($height != '') {
        $styles .= 'height: '.$height.';';
    }

    $js = '<div id="'.$chartid.'" class="ILHC"';
    if ($styles != '') {
        $js .= ' style="'.$styles.'"';
    }
    $js .= '></div>';
    $js .= "<script type='text/javascript'>
var chart;
$(document).ready(function() {
    chart = new Highcharts.Chart({
	chart: {
	    renderTo: '" .$chartid."',
	    defaultSeriesType: '" .$type."',
	    zoomType: 'x',
	    backgroundColor: null
	},
	credits: {
	    enabled: false
	},
	title: {
	    text: '" .EscapeSQ($title)."'
	},";
    if ($subtitle != '') {
        $js .= "
	subtitle: {
	    text: '" .EscapeSQ($subtitle)."'
	},";
    }
    $js .= '
	xAxis: {
	    categories: [';
    $nf = false;
    foreach ($xAxisCategories as $xac) {
        $js .= $nf ? ',' : '';
        $nf = true;
        $js .= "'".EscapeSQ($xac)."'";
    }
    $js .= '],
	    labels: {
		rotation: -45
	    }
	},
	yAxis: {
	    title: {
		text: null
	    },
	    ';
    if ($allowsubzero == false) {
        $js .= 'min: 0,
		';
    }
    $js .= '},';
    if ($type == 'pie') {
        $js .= "tooltip: {
		    formatter: function() {
			return '<strong>' + this.point.name + '</strong>: ' + this.y + ' (' + Math.round(this.percentage,2) + '%)';
			}
		    },
		    plotOptions: {
			pie: {
			    allowPointSelect: true,
			    cursor: 'pointer',
			    dataLabels: {
				enabled: true,
				color: '#000000',
				connectorColor: '#000000',
				formatter: function() {
				    return '<strong>' + this.point.name + '</strong>: ' + Math.round(this.percentage,2) + '%';
			    }
                    }
                 }
                  },";
    } else {
        $js .= '
                                          tooltip: {';
        if ($stackarea) {
            $js .= "shared: true,
                                useHTML: true,
                                formatter: function() {
                var s = this.x + '<table>';
                sum = 0;
                $.each(this.points, function(i, point) {
                    s += '<tr><td>'+ point.series.name +'</td><td class=\"num\">'+
                        point.y + '</td></tr>';
                    sum += point.y;
                });
                s += '<tr><td></td><td class=\"num\">'+sum +'</td></tr></table>';
                return s;
            },
                                ";
        } else {
            $js .= "
                         formatter: function() {
                               return '<strong>' + this.series.name + '</strong><br>' + this.x + ': ' + this.y;
                         }";
        }
        $js .= '
                  },
                  ';
    }
    if ($stack) {
        $js .= "
                        plotOptions: {
                         column: {
                                stacking: 'normal',
                         }
                  },
                        ";
    } elseif ($stackarea) {
        $js .= "
                        plotOptions: {
                         area: {
                                stacking: 'normal',
                                lineWidth: 1,
                marker: {
                                        enabled: false
                }
                         }
                  },
                        ";
    }
    //                $js .= "},";
    if (!$legend) {
        $js .= '
                  legend: {
                        enabled: false
                  },';
    }
    $js .= '
                series: [';

    $ms = false;
    if (count($second_keys) == 0) {
        $js .= '{data:[';
        foreach ($series as $seriesName => $seriesData) {
            if ($ms) {
                $js .= ',';
            }
            $js .= "['".EscapeSQ($seriesName)."',".$seriesData.']';
            $ms = true;
        }
        $js .= ']}';
    } else {
        foreach ($series as $seriesName => $seriesData) {
            if ($ms) {
                $js .= ',';
            }
            $js .= "{name:'".EscapeSQ($seriesName)."',data:[";
            $nf = false;
            foreach ($second_keys as $second_key) {
                if ($nf) {
                    $js .= ',';
                }
                $value = $series[$seriesName][$second_key];
                if ($value == '') {
                    $value = 'null';
                }
                $js .= $value;
                $nf = true;
            }
            $js .= ']}';
            $ms = true;
        }
    }
    $js .= ']
});
});
</script>';

    return $js;
}
function DataJournal($record, $from, $to, $field, $table = false)
{
    if ($from != $to) {
        if (ipi(str_replace('f', '', $field))) {
            $field = str_replace('f', '', $field);
        }

        if (!$table) {
            $table = GetExtraFieldTableType($field);
        } else {
            $table = str_replace('flextable', '', $table);
        }

        mcq("INSERT INTO CRMdatajournal(record, from_val, to_val, by_user, field, timestamp_last_change, `table`) VALUES('".mres($record)."','".mres(trim($from))."','".mres(trim($to))."','".$GLOBALS['USERID']."','".mres($field)."', NOW(), '".mres($table)."')");
    }
}
function EscapeSQ($str)
{
    $str = str_replace('\\', '\\\\', $str);
    $str = str_replace('\'', '\\\'', $str);

    return $str;
}
function jsencode($str)
{
    $str = str_replace('\\', '\\\\', $str);
    $str = str_replace('\'', '\\\'', $str);
    $str = str_replace('"', '\\"', $str);

    return $str;
}
function split_with_quotes($string_to_split, $split_char = ',', $quote_char = '"', $escape_char = '\\')
{
    $parts = array();
    $partcounter = 0;
    $quote_open = false;
    $next_char_escaped = false;
    for ($x = 0; $x < strlen($string_to_split); ++$x) {
        $char = substr($string_to_split, $x, 1);
        if ($next_char_escaped) {
            $next_char_escaped = false;
            $parts[$partcounter] .= $char;
        } elseif (($quote_open) && ($char == $escape_char)) {
            $next_char_escaped = true;
        } elseif (($quote_open == false) && ($char == $split_char)) {
            ++$partcounter;
            $parts[$partcounter] = '';
        } elseif ($char == $quote_char) {
            $quote_open = !$quote_open;
        } else {
            $parts[$partcounter] .= $char;
        }
    }

    return $parts;
}

function ExcelSplit($excel, $fieldnames_in_first_row = false, $record_seperator_char = "\n", $field_seperator_char = "\t", $quote_char = '"')
{
    //copy paste vanuit Excel is tabgescheiden, record zijn gescheiden met een enter
    /*
    Een copy paste vanuit Excel gaat niet goed wanneer een cel begint met een quote char, als je dit letterlijk intypt en copy paste uit Excel dan komt het er zo uit:
    a	"b
    c	d"

    paste je deze tekst weer terug in Excel dan krijg je:
    a	b/cd

    Excel ZOU in eerste instantie dit moeten copy/pasten (de cellen waar quotes in staan moeten omringd worden door quotes, en de quotes IN de cellen moeten geescaped worden met een andere quote)
    a	"""b"
    c	"d"""

    Als je bovenstaande weer terugplakt in Excel dan gaat het goed, je krijgt dan weer dit te zien:
    a	"b
    c	d"

    We KUNNEN hier niet omheen werken; als een cel begint met een double quote en je copy paste dat uit Excel dan GAAT HET MIS bij het inlezen in Interleave, net zo goed als het ook mis gaat wanneer je dat terugleest in Excel
    */

    //RULE 1: record MOETEN worden gescheiden door record_seperator_char (\n)
    //RULE 2: fields MOETEN worden gescheiden door field_seperator_char (\t)
    //RULE 3: er MOGEN record_seperator_char (\n) en field_seperator_char (\t) in de data staan, maar dan MOETEN er quote_char (") OM de data staan, de quote_chars zijn geen onderdeel van de data
    //RULE 4: er MOGEN quote chars in de data staan maar dan moet de hele data omringd worden door quote chars, en moeten de quote chars IN de data voorafgegaan worden door nog een quote char
    //RULE 4 DOET EXCEL NIET GOED, excel zet er alleen quote chars omheen bij de situatie in rule 3, maar niet in rule 4; hierdoor kan het mis gaan wanneer een string in excel begint met een dubbel quote -> hier is niks aan te doen
    //fix jeroen 2014-11-14
    $excel = preg_replace("/\r\n/", "\n", $excel);

    $data = array();
    $record_counter = 0;
    $field_counter = 0;
    $num_chars = 0;
    $fieldnames = array();
    $fieldname = '';
    $num_chars = 0;
    $data_is_quoted = false;
    $quote_open = false;

    for ($x = 0; $x < strlen($excel); ++$x) {
        $char = substr($excel, $x, 1);

        $char_is_data = true;
        if ($char == $quote_char) {
            if (!$quote_open) {
                //de quote staat helemaal aan het begin, of dit is een dubbele quote in een string waarvan er ook een quote aan het begin stond: "bedrijf ""de reus"""\t"test"\t"eind"
                if (($num_chars == 0) || ($data_is_quoted)) {
                    $quote_open = true;
                    //zo niet dan is het een dubbele quote die letterlijk in de string gezet moet worden
                    if ($num_chars == 0) {
                        $char_is_data = false;
                    }
                    $data_is_quoted = true;
                }
            } else {
                $quote_open = false;
                $char_is_data = false;
            }
        }
        /*else
        {
        $next_quote_char_is_escaped = false;
        }*/

        if ($char_is_data) {
            if (!$quote_open) {
                if ($char == $field_seperator_char) {
                    ++$field_counter;
                    $char_is_data = false;
                    $num_chars = 0;
                    $data_is_quoted = false;
                } elseif ($char == $record_seperator_char) {
                    ++$record_counter;
                    $field_counter = 0;
                    $char_is_data = false;
                    $num_chars = 0;
                    $data_is_quoted = false;
                }
            }

            //laatste conditie is erg lomp maar die voorkomt dat er een nieuw array element wordt aangemaakt voor de laatste enter in de Excel copy-paste
            if (((!$char_is_data) || ($x == 0)) && ($x < strlen($excel) - 1)) {
                if (($record_counter == 0) && ($fieldnames_in_first_row)) {
                    $fieldnames[$field_counter] = '';
                } else {
                    $fieldname = $field_counter;
                    if ($fieldnames_in_first_row) {
                        $fieldname = $fieldnames[$field_counter];
                    }
                    $data[$record_counter][$fieldname] = '';
                }
            }

            if ($char_is_data) {
                if (($record_counter == 0) && ($fieldnames_in_first_row)) {
                    $fieldnames[$field_counter] .= $char;
                } else {
                    $data[$record_counter][$fieldname] .= $char;
                }
                ++$num_chars;
            }
        }
    }

    return $data;
}
function gps($coordinate, $hemisphere)
{
    for ($i = 0; $i < 3; ++$i) {
        $part = explode('/', $coordinate[$i]);
        if (count($part) == 1) {
            $coordinate[$i] = $part[0];
        } elseif (count($part) == 2) {
            $coordinate[$i] = floatval($part[0]) / floatval($part[1]);
        } else {
            $coordinate[$i] = 0;
        }
    }
    list($degrees, $minutes, $seconds) = $coordinate;
    $sign = ($hemisphere == 'W' || $hemisphere == 'S') ? -1 : 1;

    return $sign * ($degrees + $minutes / 60 + $seconds / 3600);
}
function IndexGPSCoordinates($fileid = false)
{
    $sql_ins = '';
    if (ipi($fileid)) {
        $sql_ins = " AND `CRMbinfiles`.`fileid`='".$fileid."'";
    }
    foreach (db_GetFlatArray("SELECT `CRMbinfiles`.`fileid` FROM `CRMbinfiles` WHERE `CRMbinfiles`.`coordinates` = '' AND `CRMbinfiles`.`filetype`='image/jpeg' ".$sql_ins) as $fileid) {
        $path = CopyFileToDisk($fileid);
        mcq("UPDATE `CRMbinfiles` SET `CRMbinfiles`.`coordinates` = '".mres(GetGPSCoordinates($path))."', `CRMbinfiles`.`timestamp_last_change`=`CRMbinfiles`.`timestamp_last_change` WHERE `CRMbinfiles`.`fileid` = '".$fileid."'");
        unlink($path);
    }
}
function GetGPSCoordinates($filepath)
{
    /*
     * tries to find GPS coordinates from a file already on disk (during ExtractIndexData process)
     */

    $exif = @exif_read_data($filepath);

    $latitude = gps($exif['GPSLatitude'], $exif['GPSLatitudeRef']);
    $longitude = gps($exif['GPSLongitude'], $exif['GPSLongitudeRef']);

    if ($latitude != '' && $longitude != '') {
        return $latitude.'+'.$longitude;
    } else {
        /* we store this in the database to mark the image as checked but no gps found */
        return '{0}';
    }
}
function GetFileGPSCoordinates($fileid)
{
    /* fetches the saved GPS coordinates */
    $gps = db_GetValue("SELECT `CRMbinfiles`.`coordinates` FROM `CRMbinfiles` WHERE `CRMbinfiles`.`fileid`='".mres($fileid)."'");
    if ($gps != '' && $gps != '{0}') {
        return $gps;
    } else {
        return '';
    }
}
function ResizeImage($imageBin, $horizontalPx, $verticalPx, $bgFillColor = '0,0,0', $fgFillColor = '104,104,104', $copyrightmsg = false, $autorotate = true)
{
    if ($imageBin == '') {
        return false;
    } else {
        $info = array(); //om undeclared warnings te voorkomen, getImageSize ZET deze var zelf ook
        // Save image to disk
        $imageurl = tempnam('', 'INTLV_IMGRESIZE');
        file_put_contents($imageurl, $imageBin);

        $font = 1;
        $tmp = '';

        // minimal & maximum zoom
        $minZoom = 1; // per cent related on orginal (!=0)
        $maxZoom = 200; // per cent related on orginal (!=0)

        // reading image
        $image = getimagesize($imageurl, $info); // $info, only to handle problems with earlier php versions...

        $func = '';

        if ($image[2] == 1) {
            $func = 'imageCreateFromGIF';
        } elseif ($image[2] == 2) {
            $func = 'imageCreateFromJPEG';
        } elseif ($image[2] == 3) {
            $func = 'imageCreateFromPNG';
        }

        if ($func == '') {
            return false;
        }
        if ($autorotate && function_exists('exif_read_data')) {
            $img = $func($imageurl);
            $exif = exif_read_data($imageurl);
            $ort = $exif['Orientation'];
            $info = '';
            switch ($ort) {

            case 3: // 180 rotate left
                $img = imagerotate($img, 180, 0);
                $infotext = 'Use func rotate 180 degrees';
                break;

            case 6: // 90 rotate right
                $img = imagerotate($img, -90, 0);
                $infotext = 'Use func rotate -90 degrees';
                break;

            case 8: // 90 rotate left
                $img = imagerotate($img, 90, 0);
                $infotext = 'Use func rotate 90 degrees';
                break;

            default:
                $infotext = 'Use func rotate NO ROTATE HOWEVER REQUESTED: ort is '.$ort;
                break;
            }

            $ifunc = '';
            if ($image[2] == 1) {
                $ifunc = 'imageGIF';
            } elseif ($image[2] == 2) {
                $ifunc = 'imageJPEG';
            } elseif ($image[2] == 3) {
                $ifunc = 'imagePNG';
            }

            $ifunc($img, $imageurl);
            $image = getimagesize($imageurl, $info); // $info, only to handle problems with earlier php versions...
        } else {
            $infotext = 'Use func rotate NOT PERFORMED ON REQUEST';
        }

        if (!is_numeric($horizontalPx) && !is_numeric($verticalPx)) {

            // standard height & weight if not given
            $horizontalPx = $image[1];
            $verticalPx = $image[0];
        } elseif (is_numeric($horizontalPx) && !is_numeric($verticalPx)) {

            /* only horizontal width given, calculate vertical */
            $ch = $image[1];
            $ratio = $horizontalPx / $ch;
            $verticalPx = $image[0] * $ratio;
        } elseif (!is_numeric($horizontalPx) && is_numeric($verticalPx)) {

            /* only vertical width given, calculate vertical */
            $cv = $image[0];
            $ratio = $verticalPx / $cv;
            $horizontalPx = $image[1] * $ratio;
        }

        /* check orientation */
        if ((($horizontalPx > $verticalPx) && ($image[0] < $image[1])) || (($horizontalPx < $verticalPx) && ($image[0] > $image[1]))) {
            /* result aspect is landscape but image is portrait or vice-versa*/
            $tmp = $horizontalPx;
            $horizontalPx = $verticalPx;
            $verticalPx = $tmp;
        }

        // standard height & weight if not given. should never happen
        if (!is_numeric($horizontalPx)) {
            $horizontalPx = 100;
        }
        if (!is_numeric($verticalPx)) {
            $verticalPx = 75;
        }

        $timg = $func($imageurl);

        // reading image sizes
        $imgX = $image[0];
        $imgY = $image[1];

        // Handle de aspect-size optie
        /*
        if ($horizontalPx == "aspect" && ipi($verticalPx)) { // vaste breedte
            $horizontalPx = ceil($imgX / ($imgY / $verticalPx));

        } elseif ($verticalPx == "aspect" && ipi($horizontalPx)) { // vaste hoogte
            $verticalPx = ceil($imgY / ($imgX / $horizontalPx));
        }
        */

        // calculation zoom factor
        $_X = $imgX / $horizontalPx * 100;
        $_Y = $imgY / $verticalPx * 100;

        // selecting correct zoom factor, so that the image always keeps in the given format
        // no matter if it is more higher than wider or the other way around
        if ((100 - $_X) < (100 - $_Y)) {
            $_K = $_X;
        } else {
            $_K = $_Y;
        }

        // zoom check to the original
        if ($_K > 10000 / $minZoom) {
            $_K = 10000 / $minZoom;
        }
        if ($_K < 10000 / $maxZoom) {
            $_K = 10000 / $maxZoom;
        }

        // calculate new image sizes
        $newX = $imgX / $_K * 100;
        $newY = $imgY / $_K * 100;

        // set start positoin of the image
        // always centered
        $posX = ($horizontalPx - $newX) / 2;
        $posY = ($verticalPx - $newY) / 2;

        // creating new image with given sizes
        $imgh = imagecreatetruecolor($horizontalPx, $verticalPx);

        // setting colours
        $cols = explode(',', $bgFillColor);
        $bgcol = imagecolorallocate($imgh, trim($cols[0]), trim($cols[1]), trim($cols[2]));

        $cols = explode(',', $fgFillColor);
        $fgcol = imagecolorallocate($imgh, trim($cols[0]), trim($cols[1]), trim($cols[2]));

        // fill background
        imagefill($imgh, 0, 0, $bgcol);

        // Make the background transparent
        //imagecolortransparent($imgh, imagecolorallocate($imgh, 0, 0, 0));
        // create small copy of the image
        imagecopyresampled($imgh, $timg, $posX, $posY, 0, 0, $newX, $newY, $image[0], $image[1]);

        // writing copyright note
        if ($copyrightmsg != '') {
            imagestringup($imgh, $font, $horizontalPx - 9, $verticalPx - 3, $copyrightmsg, $fgcol);
        }
        // output
        $func = '';
        //		qlog(INFO, "Use func $func imagetype " . $image[2]);
        ob_start();

        if ($image[2] == 1) {
            // GIF image
            imagegif($imgh);
        } elseif ($image[2] == 2) {
            // JPEG image
            imagejpeg($imgh, null, 95);
        } elseif ($image[2] == 3) {
            // PNG image
            imagepng($imgh);
        }

        $imagevariable = ob_get_contents();
        ob_end_clean();

        // cleaning cache
        imagedestroy($timg);
        imagedestroy($imgh);

        unlink($imageurl);

        return $imagevariable;
    }
}
function CustomerRFCiFrameAuthenticated($username, $password, $text = 'Open hulp- en wijzigingsverzoeken', $html = false)
{
    $ret = '<a href="#" onclick=\'window.open("https://admin.interleave.nl/index.php?username='.htme($username).'&amp;password='.htme($password).'&amp;curus='.base64_encode(GetUserName($GLOBALS['USERID'])).'&amp;curem='.base64_encode(GetUserEmail($GLOBALS['USERID'])).'");\'>';
    if (!$html) {
        $ret .= htme($text);
    } else {
        $ret .= $text;
    }
    $ret .= '</a>';

    return $ret;
}
function ReturnLockJavascript($record, $table)
{
    if (GetSetting('EnableEntityLocking') == 'Yes' && ipi($record)) {
        return '<script type="text/javascript">var LockInterval = 15000;var LockRecord='.htme($record).'; var LockCounter=1;var LockTable="'.htme($table).'";UpdateRecordLock();</script>';
    }
}
function PHT($query, $link = '', $idname = 'id', $class = 'crm sortable', $tablestyle = '', $print = true)
{
    $output = '';
    // sending query
    $result = db_GetArray($query);
    if (count($result) == 0) {
        return '';
    }

    //$fields_num = count($result[0]);
    if ($link == '') {
        $class .= ' noclick';
    }

    $output .= '<table';
    if ($class != '') {
        $output .= ' class="'.$class.'"';
    }
    if ($tablestyle != '') {
        $output .= ' style="'.$tablestyle.'"';
    }
    $output .= '>';
    $output .= '<thead><tr>';

    $fields = array();
    foreach ($result[0] as $field => $value) {
        if (!is_numeric($field)) {
            $output .= '<th>'.htme($field).'</th>';
            $fields[] = $field;
        }
    }
    $output .= '</tr></thead>';
    // $output .= ing table rows
    foreach ($result as $row) {
        $output .= '<tr';
        if ($link != '') {
            $output .= " onclick=\"window.location.href='".str_replace('@ID@', $row[$idname], $link)."';\"";
        }
        $output .= '>';

        foreach ($fields as $cell) {
            $output .= '<td';
            if (is_numeric($row[$cell])) {
                $output .= ' class="num"';
            }
            $output .= '>'.htme($row[$cell]).'</td>';
        }

        $output .= '</tr>';
    }
    $output .= '</table>';

    if ($print) {
        echo $output;
    } else {
        return $output;
    }
}
function GetTableSize($tablename)
{
    $res = db_GetArray("SHOW TABLE STATUS LIKE '".mres($tablename)."'");

    return $res[0]['Data_length'];
}
function GetTableRows($tablename)
{
    return db_GetValue('SELECT COUNT(*) FROM '.$tablename);
}
function scmd($s)
{
    echo '&nbsp;'.$s.'<br>';
    system($s);
}
function IsValidPhonenumber($phonenumber)
{
    //returns internation valid phonenumber. " 06 - 12 34  5 6 78 " is returned as "+31612345678"
    $is_valid_phonenumber = false;
    $is_international_phonenumber = false;

    //spaties (en tabs) weg
    $phonenumber = preg_replace("/\s/", '', $phonenumber);

    //streepjes weg
    $phonenumber = preg_replace("/\-/", '', $phonenumber);

    //(0) weg; voor +31 (0)6 12345678
    $phonenumber = preg_replace("/\(0\)/", '', $phonenumber);

    //leidende + weg
    $phonenumber = preg_replace("/^\+/", '', $phonenumber, -1, $count);
    if ($count > 0) {
        $is_international_phonenumber = true;
    }

    //2014-12-01 toegevoegd; alle niet nummers eruit
    $phonenumber = preg_replace("/\D/", '', $phonenumber);

    //leidende dubbele 0 weg
    $phonenumber = preg_replace('/^00/', '', $phonenumber, -1, $count);
    if ($count > 0) {
        $is_international_phonenumber = true;
    }

    //leidende enkele 0 weg
    $phonenumber = preg_replace('/^0/', '', $phonenumber);

    if ($is_international_phonenumber == false) {
        //defaulteren naar Nederland
        if ($GLOBALS['DefaultPhoneNumberCountryCode'] == '') {
            $GLOBALS['DefaultPhoneNumberCountryCode'] = '31';
        }

        $phonenumber = $GLOBALS['DefaultPhoneNumberCountryCode'].$phonenumber;
        //NU is het phonenumber WEL international
        $is_international_phonenumber = true;
    }

    //een valide telefonnummer bestaat minimaal uit 4 (?) en maximaal uit 15 cijfers
    $min_length = 4;
    $max_length = 15;
    //dit is een Nederlands nummer
    if (preg_match('/^31/', $phonenumber)) {
        //landcode gevolgd door 9 nummers
        $min_length = 11;
        $max_length = 11;
    }

    if (preg_match("/^\d{".$min_length.','.$max_length.'}$/', $phonenumber)) {
        $is_valid_phonenumber = true;
        $phonenumber = '+'.$phonenumber;
    }

    if (!$is_valid_phonenumber) {
        //niks retourneren in 2e element van array
        $phonenumber = '';
    }

    return array($is_valid_phonenumber, $phonenumber);
}

function GetSystemDataStructure()
{
    $sds = unserialize(db_GetValue('SELECT datastructure FROM CRMdatastructures WHERE userid=0'));
    if (count($sds) == 0) {
        CreateSystemDataStructure();
        $sds = unserialize(db_GetValue('SELECT datastructure FROM CRMdatastructures WHERE userid=0'));
    }

    return $sds;
}
function CheckAndCreateSystemDataStructure()
{
    if (db_GetValue("SELECT COUNT(*) FROM CRMdatastructures WHERE userid=0 AND datastructure != ''") != 1) {
        CreateSystemDataStructure();
    }
}
function CreateSystemDataStructure()
{
    $curuser = false;

    if (!is_administrator()) {
        $curuser = $GLOBALS['USERID'];

        // Sudo to first admin
        $tmp = db_GetRow("SELECT id FROM CRMloginusers WHERE administrator='yes' AND name NOT LIKE 'deleted_user%'");

        InitUser($tmp['id']);
    }

    mcq("INSERT INTO CRMdatastructures(userid, datastructure) VALUES (0,'".mres(serialize(get_data_structure()))."') ON DUPLICATE KEY UPDATE userid=userid");

    if ($curuser) {
        InitUser($curuser);
    }
}
function AddFieldnamesToTags($template)
{
    $template = preg_replace_callback("/\[\[EFID(\d+)\]\]/", function ($matches) {
        return '[[f'.$matches[1].' '.preg_replace('/\W/', '_', GetExtraFieldName($matches[1])).']]';
    }, $template);

    //dit is niet strikt nodig; en het is eigenlijk de verkeerde plek om te doen; maar we zetten hier eens en voor altijd @EFID12@ om naar @f12@
    $template = EFID_to_f($template);

    //let op de "f" op het eind van match[2]
    $template = preg_replace_callback("/(\@|\#|\%|\^)([a-zA-Z0-9\-\_]*f)(\d+)\\1/", function ($matches) {
        //in 1 staat het control karakter; @, #, % of %
    //in 2 staat de tag ZONDER het veldnummer; EFID, f of t2-f5-t10-f, etc
    //in 3 staat het veldnummer; 2, 17, 129, etc
    return $matches[1].$matches[2].$matches[3].' '.preg_replace('/\W/', '_', db_GetValue("SELECT name from CRMextrafields WHERE deleted='n' AND id=".$matches[3])).$matches[1];
    }, $template);

    return $template;
}
function RemoveFieldnamesFromTags($template)
{
    $template = preg_replace("/\[\[f(\d+)( \w+)?\]\]/", '[[EFID${1}]]', $template);
    /*
    $template = preg_replace("/\#f(\d+)( \w+)?\#/", '#EFID${1}#', $template);
    $template = preg_replace("/\@f(\d+)( \w+)?\@/", '@EFID${1}@', $template);
    $template = preg_replace("/\%f(\d+)( \w+)?\%/", '%EFID${1}%', $template);
    */

//    $template = preg_replace("/(\@|\#|\%|\^)f(\d+)( \w+)?\\1/", '${1}EFID${2}${1}', $template);

    //dit is niet strikt nodig; en het is eigenlijk de verkeerde plek om te doen; maar we zetten hier eens en voor altijd @EFID12@ om naar @f12@
    $template = EFID_to_f($template);

    $template = preg_replace("/(\@|\#|\%|\^)([a-zA-Z0-9\-\_]+)(\d+)( \w+)?\\1/", '${1}${2}${3}${1}', $template);

    return $template;
}
function EFID_to_f($template)
{
    return preg_replace("/(\@|\#|\%|\^)EFID(\d+)\\1/", '${1}f${2}${1}', $template);
}
function send_sms($from, $to, $message)
{
    // Atomos specific SMS queue table. If it doesn't exist, don't show SMS option
    $sql = "SELECT SCHEMA_NAME FROM INFORMATION_SCHEMA.SCHEMATA WHERE SCHEMA_NAME = 'sms'";
    if (db_GetValue($sql) == 'sms') {
        $sql = "SELECT TABLE_NAME FROM INFORMATION_SCHEMA.TABLES WHERE TABLE_SCHEMA = 'sms' AND TABLE_NAME = 'smsqueue' LIMIT 1";
        if (db_GetValue($sql) == 'smsqueue') {
            $sql = "INSERT INTO `sms`.`smsqueue` (`from`, `to_cell`, `ts_added`, `message`, `client`, `status`) VALUES('".mres($from)."','".$to."',NOW(),'".mres($message)."','".mres(db_GetValue('SELECT DATABASE()'))."','')";
            mcq($sql);

            return true;
        }
    }

    return false;
}
function InlineSimpleAddForm($table_id, $template_id, $submitbuttontext, $tagvals, $listtoreloadaftersubmit, $htmltemplate = '', $open_after_add = 0)
{
    if (!$GLOBALS['UC']['PersonalDataStructure'][$table_id]['allowed_to_add']) {
        return '<!-- not allowed '.$table_id.' //-->';
    } else {
        $template = '';
        if ($htmltemplate != '') {
            $template = $htmltemplate;
        } else {
            $template = GetTemplate($template_id);
        }

        $template = ParseTemplateLanguageTags($template);
        $elements = array();

        $tagvals['listtoreloadaftersubmit'] = $listtoreloadaftersubmit;

        preg_match_all('/#(.*?)#/', $template, $matches);

        foreach ($matches[1] as $field_name) {
            $field_id = '';
            if (substr($field_name, 0, 4) == 'EFID') {
                $field_id = 'f'.str_replace('EFID', '', $field_name);
            } elseif (substr($field_name, 0, 1) == 'f' && ipi(str_replace('f', '', $field_name))) {
                $field_id = $field_name;
            }
            if ($field_id != '') {
                $element = '<div class="formfieldcontainer" id="ffc-'.$table_id.'-'.$field_id.'">'.get_form_element($table_id.'-'.$field_id, '', '', array('enter2blur'), true).'</div>';
                $elements[] = $table_id.'-'.$field_id;
                $template = str_replace('#'.$field_name.'#', $element, $template);
            }
        }

        if ($submitbuttontext == '') {
            $submitbuttontext = 'No submit button text set in INLINE form tag';
        }

        //in ff ging dit mis wanneer het een <button></button> was ZONDER type="button", daarom omgezet naar een standaard input tag
        //$submitbutton = '<button type="button" onclick="SubmitInlineForm(document.getElementById(\'' . $tagvals['outerdiv'] . '\'), \'' . $listtoreloadaftersubmit . '\',\'_new\')">' . htme($submitbuttontext) . '</button>';
        $submitbutton = '<input id="inlineadd-'.$table_id.'" onclick="
				if (general_form_submit(\'' .$tagvals['outerdiv'].'\', \'_new_\')) {
					SubmitInlineForm(document.getElementById(\'' .$tagvals['outerdiv'].'\'), \''.$listtoreloadaftersubmit.'\',\'_new_\', \''.$open_after_add.'\', \''.$table_id.'\');
					}
		" type="button" value="' .htme($submitbuttontext).'">';

        $t = '';
        if ($htmltemplate == '') {
            $t = '<div class="inlineadddiv">';
        }
        $t .= $template;
        $extra = '';
        foreach ($tagvals as $name => $value) {
            if (!in_array($name, $elements) && $name != '') { // Don't put in hidden elements which were already shown in the template
                //id=\"JS_" . htme($name) . "\"
                list($loctable, $locfield) = explode('-', $name);

                /* test if it's in de ds */
                if ($GLOBALS['UC']['PersonalDataStructure'][$loctable]['fields'][$locfield]) {
                    if ($name == $loctable.'-'.$locfield) {
                        $name .= '-_new_';
                    }
                    /* place field in form, hidden */
                    $extra .= '<input type="hidden" name="'.htme($name).''.'" id="JS_'.htme($name).''.'"  value="'.htme($value).'">';

                    /* place default value in form, it will be given back to this function after submit */
                    $extra .= '<input type="hidden" name="default_'.htme($name).''.'" id="JS_default_'.htme($name).''.'"  value="'.htme($value).'">';
                } elseif ($name == 'listtoreloadaftersubmit' || $name == 'table' || $name == 'BYAJAX' || $name == 'submitbuttontext' || $name == 'template' || $name == 'outerdiv' || $name == 'reload_on_submit') {
                    /* standard fields in this context */
                    $extra .= '<input type="hidden" name="'.htme($name).''.'" id="JS_'.htme($name).''.'"  value="'.htme($value).'">';
                } else {
                    /* ignore the rest */
                    //print "SKIP $name<br>";
                }
            }
        }
        if ($open_after_add == 1) {
            $extra .= '<input type="hidden" name="open_after_add" id="JS_open_after_add"  value="1">';
        }
        $t = str_replace('#SAVEBUTTON#', $submitbutton.$extra, $t);
        if ($htmltemplate == '') {
            $t .= '</div>';
        }

        return $t;
    }
}
function ParseTemplateCreateDefaultReportTags($template)
{
    // Hack: isolate #REPORTICON#
    $template = str_replace('#REPORTICON#', '$$$$$$$$$$$$$$$$$$$$$$$$$$$REPRTICON$$$$$$$$$$$$$$$$$$$$$$$$$$$', $template);

    // Fetch all tags from template
    preg_match_all('/#REPORT(.*?)#/', $template, $matches);

    // Loop through tags
    foreach ($matches[1] as $listoptions_string) {
        $listoptions = ConvertTagOptionsToListOptions($listoptions_string);
        $template = str_replace('#REPORT'.$listoptions_string.'#', escape_interleave_characters(CreateDefaultReport($listoptions['table'], $listoptions['reporttype'], $listoptions['filename'], $listoptions['linktext'], $listoptions)), $template);
    }
    $template = str_replace('$$$$$$$$$$$$$$$$$$$$$$$$$$$REPRTICON$$$$$$$$$$$$$$$$$$$$$$$$$$$', '#REPORTICON#', $template);

    return $template;
}
function CreateDefaultReport($table, $outputtype = 'excel', $filename = 'download', $linktext = 'download report', $listoptions = array())
{
    if (is_array($GLOBALS['UC']['PersonalDataStructure'][$table])) {
        $listoptions['table'] = $table;
        $listoptions['outputtype'] = 'array';
        $listoptions['perpage'] = 0;
        // Flag as internal
        $listoptions['internallistcall'] = true;

        $base = make_list($listoptions);
        $sheet = array();

        foreach ($base as $row) {
            // Add fields
            $header = array();
            foreach ($base[0] as $f => $ig) {
                if ($outputtype == 'excel') {
                    $header[] = '[[border-bottom]][[bold]]'.$GLOBALS['UC']['PersonalDataStructure'][$table]['fields'][str_replace($table.'-', '', $f) ]['name'];
                } else {
                    $header[] = '<strong>'.$GLOBALS['UC']['PersonalDataStructure'][$table]['fields'][str_replace($table.'-', '', $f) ]['name'].'</strong>';
                }
            }
            $sheet[] = $header;

            $lrow = array();
            foreach ($row as $element) {
                if ($outputtype == 'excel') {
                    $lrow[] = '[[fontsize16]]'.$element;
                } elseif ($outputtype == 'pdf' || $outputtype == 'html') {
                    $lrow[] = '<h1>'.htme($element).'</h1>';
                }
            }
            $sheet[] = $lrow;

            foreach (array_keys($GLOBALS['UC']['PersonalDataStructure'][$table]['childs']) as $child_table) {
                foreach ($GLOBALS['UC']['PersonalDataStructure'][$table]['childs'][$child_table] as $child_field) {
                    $listoptionslocal = array();
                    $listoptionslocal['table'] = $child_table;
                    $listoptionslocal['outputtype'] = 'array';
                    $listoptionslocal['type_of_list'] = 'sublist';
                    $listoptionslocal['perpage'] = 0;
                    // Flag as internal
                    $listoptionslocal['internallistcall'] = true;
                    $listoptionslocal['hiddenfilter'][$child_table.'-'.$child_field][] = $row[$table.'-'.$GLOBALS['UC']['PersonalDataStructure'][$table]['primary']];

                    $locallist = make_list($listoptionslocal);

                    $sheet[] = array('');

                    if ($outputtype == 'excel') {
                        $sheet[] = array('', '[[bold]]'.$GLOBALS['UC']['PersonalDataStructure'][$child_table]['plural']);
                    } elseif ($outputtype == 'pdf' || $outputtype == 'html') {
                        $sheet[] = array('', '<strong>'.htme($GLOBALS['UC']['PersonalDataStructure'][$child_table]['plural']).'</strong>');
                    }

                    // Add fields
                    $header = array('');
                    foreach ($locallist[0] as $f => $ig) {
                        if ($outputtype == 'excel') {
                            $header[] = '[[italic]]'.$GLOBALS['UC']['PersonalDataStructure'][$child_table]['fields'][str_replace($child_table.'-', '', $f) ]['name'];
                        } else {
                            $header[] = '<strong>'.$GLOBALS['UC']['PersonalDataStructure'][$child_table]['fields'][str_replace($child_table.'-', '', $f) ]['name'].'</strong>';
                        }
                    }
                    $sheet[] = $header;

                    foreach ($locallist as $localrow) {
                        // Add emtpty first column
                        array_unshift($localrow, '');
                        if ($outputtype == 'pdf' || $outputtype == 'html') {
                            array_walk($localrow, 'htme');
                        }
                        $sheet[] = array_values($localrow);
                    }
                }
            }
            $sheet[] = array('');
        }
        //print '<pre>';
        //print_r($sheet);
        //print '</pre>';
        if ($outputtype == 'excel') {
            $sheet[] = array('[[fittowidth]]');

            return ExcelDownloadLink($sheet, $linktext, $filename, 'xlsx');
        } elseif ($outputtype == 'pdf' || $outputtype == 'html') {
            $html = '';
            $html = '<table class="crm">';

            foreach ($sheet as $line) {
                $html .= '<tr>';
                foreach ($line as $col) {
                    $html .= '<td>'.($col).'</td>';
                }
                $html .= '</tr>';
            }

            $html .= '</table>';
            if ($outputtype == 'pdf') {
                return PDFDownloadLink($html, $linktext, 'L', '', false, false, false, $filename, 'helvetica', '8', false, true, false, 'mpdf');
            } else {
                return $html;
            }
        } else {
            return 'Unknown output type';
        }
    }
}
function html2plaintext($str)
{
    return html_entity_decode(strip_tags_to_space(br2nl($str)), ENT_QUOTES);
}
function ps2txt($ps_data)
{
    $result = '';
    $a_data = getDataArray($ps_data, '[', ']');
    if (is_array($a_data)) {
        foreach ($a_data as $ps_text) {
            $a_text = getDataArray($ps_text, '(', ')');
            if (is_array($a_text)) {
                foreach ($a_text as $text) {
                    $result .= substr($text, 1, strlen($text) - 2);
                }
            }
        }
    } else {
        // the data may just be in raw format (outside of [] tags)
        $a_text = getDataArray($ps_data, '(', ')');
        if (is_array($a_text)) {
            foreach ($a_text as $text) {
                $result .= substr($text, 1, strlen($text) - 2);
            }
        }
    }

    return $result;
}
function GetFieldTypes()
{
    $ft = array('', 'diary', 'drop-down', 'drop-down (multiselect)', 'drop-down (populate by code)', 'drop-down (populate by code multiselect)', 'checkbox', 'textbox', 'text area', 'text area (rich text)', 'numeric', 'mail', 'hyperlink', 'comment', 'date', 'date (iso)', 'date/time', 'Button', 'SQL Query', 'SQL Query (multiselect)', 'Reference to FlexTable', 'Reference to FlexTable (multiselect)', 'User-list of all CRM-CTT users', 'List of all groups', 'color', 'phone number');

    foreach (GetProfiles() as $profile) {
        $ft[] = 'Users of profile '.$profile['id'];
    }

    return $ft;
}
function CheckExtraFieldAccess($field_id)
{
    $access = 'nok';

    if (ipi($field_id)) {
        $table = get_ds_tablename_for_field($field_id);
        $field = 'f'.$field_id;
    } else {
        $table = GetExtraFieldTableType($field_id);
        $field = $field_id;
    }
    if (is_array($GLOBALS['UC']['PersonalDataStructure'][$table]['fields'][$field])) {
        if ($GLOBALS['UC']['PersonalDataStructure'][$table]['fields'][$field]['allowed_to_write']) {
            $access = 'ok';
        } else {
            $access = 'readonly';
        }
    }

    return $access;
}
function desktopmobileswitcher()
{
    global $lang;

    $other_interface = 'mobile';
    if ($GLOBALS['SesMem']['mobile']) {
        $other_interface = 'desktop';
    }

    $url = preg_replace("/\&?interface=(mobile|desktop)/", '', $_SERVER['REQUEST_URI']);
    if (preg_match("/\?/", $url)) {
        $url .= '&';
    } else {
        $url .= '?';
    }
    $url .= 'interface='.$other_interface;

    return '<a href="'.htme($url).'" title="'.htme($lang[$other_interface]).'"><span class="fa fa-'.$other_interface.' fa-fw"></span></a>';
}
function normal_chars($string = '', $is_filename = true)
{
    // Replace all weird characters with dashes
    $string = preg_replace('/[^\w\-'.($is_filename ? '~_\.' : '').']+/u', '-', $string);

    $string = str_replace(':', '-', $string);
    // Only allow one dash separator at a time
    return preg_replace('/--+/u', '-', $string);
}
function ipi($i)
{
    return is_positive_integer($i);
}
function GetDownloadFileNameForTable($tablename)
{

    // Deze functie moet nog uitgebreid worden met nettere namen voor tabellen anders dan flextables
    // Default filename
    $default = str_replace(' ', '_', GetSetting('title')).'-'.$GLOBALS['PRODUCT'].'-export-'.date('m-j-Y-Hi').'h';

    if ($tablename == 'user') {
        return $default;
    } elseif ($tablename == 'group') {
        return $default;
    } else {
        $t = str_replace('t', '', $tablename);
        if (ipi($t)) { // flextable
            $at = GetAttribute('flextable', 'FilenameForDownloadsTemplate', $t);
            if ($at != '') {
                return unescape_interleave_characters(ParseTemplateGeneric(EvaluateTemplatePHP($at)));
            } else {
                return $default;
            }
        } else { // One of the other system tables
            return $default;
        }
    }
}
function DisplayFileList($record, $table)
{
    $dstable = '';
    if (ipi($table)) {
        $dstable = 't'.$table;
    } elseif (ipi(str_replace('t', '', $table))) { // ds-style table id
        $table = str_replace('t', '', $table);
        $dstable = 't'.$table;
    } elseif ($table == 'generalpurpose') {
        $dstable = 'generalpurpose';
    } elseif ($table == 'system') {
        $dstable = 'system';
    } else {
        return 'Unable to determine table type ('.htme($table).')';
    }

    $folder = 0;
    if (ipi($_REQUEST['folder'])) {
        $folder = $_REQUEST['folder'];
    }

    return list_filebox($dstable, $record, $folder);
}

function FileUploadBox($table, $record, $folder = 0)
{
    global $lang;

    $ds_tablename = '';
    $binfiles_tablename = '';
    if (ipi($table)) {
        $ds_tablename = 't'.$table;
        $binfiles_tablename = 'flextable'.$table;
    } elseif (ipi(str_replace('t', '', $table))) { // ds-style table id
        $table = str_replace('t', '', $table);
        $ds_tablename = 't'.$table;
        $binfiles_tablename = 'flextable'.$table;
    } elseif ($table == 'generalpurpose') {
        $ds_tablename = 'generalpurpose';
        $binfiles_tablename = $ds_tablename;
    } elseif ($table == 'public') {
        $ds_tablename = 'public';
        $binfiles_tablename = $ds_tablename;
    } elseif ($table == 'system') {
        $ds_tablename = 'system';
        $binfiles_tablename = $ds_tablename;
    } else {
        return 'Unable to determine table type ('.htme($table).')';
    }
    $suffix = '-'.$ds_tablename;

    // Return nothing if the user has no access to the record
    if (!CheckIfAttachingIsAllowed($record, $ds_tablename)) {
        return '';
    }
    $str = '<input type="file" name="file_upload[]" id="JS_file_upload'.$suffix.'" multiple="multiple"';
    $onchange = '';
    if (count(GetExtraFilesFields()) == 0) {
        if ($record !== '_new_') {
            $onchange .= ' upload_files("'.$suffix.'");';
        } else {
            //	print "err record $record";
        }
    } else {
        //	print "err count " . count(GetExtraFilesFields());
    }
    if ($onchange != '') {
        $str .= ' onchange=\''.$onchange.'\'';
    }
    $str .= '>';

    $str .= '<input type="hidden" name="file_VersionTypeChanged'.$suffix.'" id="JS_file_VersionTypeChanged" value="no">';
    $str .= '<input type="hidden" name="file_table" id="JS_file_table'.$suffix.'" value="'.htme($ds_tablename).'">';
    $str .= '<input type="hidden" name="file_record" id="JS_file_record'.$suffix.'" value="'.htme($record).'">';

    if (GetSetting('ENABLEFILEVERSIONING') == 'Yes' && $record != '_new_' && db_GetValue("SELECT COUNT(*) FROM CRMbinfiles WHERE type='".$binfiles_tablename."' AND koppelid='".$record."'") > 0) {
        $str .= " <select id='JS_file_NewOrNewVersionOf".$suffix."' name='file_NewOrNewVersionOf' onchange=\"document.forms['UploadFile'].elements['VersionTypeChanged'].value='yes'\"><option value='match' selected>Match by filename</option><option value='new_file'>New file</option>";

        $str .= '</select>';
    } else {
        $str .= ' ';
    }
    $str .= '<div id="upload_files_efids'.$suffix.'" class="showinline">';

    foreach ($GLOBALS['UC']['PersonalDataStructure']['files']['fields'] as $name => $field) {
        if ($field['fieldtype_in_extrafields_table'] != '' && $field['allowed_to_write'] == true) {
            $str .= get_form_element('files-'.$name, '', '_new_', array(), false, false, '');
        }
    }
    $str .= '</div>';

    if ($record === '_new_') {
    } else {
        if (count(GetExtraFilesFields()) > 0) {
            $str .= '<input type="button" class="uploadbutton" onclick="upload_files(\''.$suffix.'\');" value="'.htme($lang['go']).'">';
        }
        $str .= '<progress id="JS_uploadprogress'.$suffix.'" class="uploadprogress"></progress>';
    }

    $mic = '';
    $vid = '';

    if (ipi($record) && GetSetting('DevelopmentOrProduction') == 'Development') {

        /* dit werkt en is in principe klaar voor productie */
        $mic = '&nbsp;<a onclick="PopFancyBoxSmall(\'\', \'audio.php?table='.$ds_tablename.'&amp;record='.$record.'&amp;nonavbar=1\');"><span class="fa fa-microphone" aria-hidden="true"></span></a>';

        /* dit nog niet!! */
        $vid = '&nbsp;<a onclick="PopFancyBox(\'\', \'video.php?table='.$ds_tablename.'&amp;record='.$record.'&amp;nonavbar=1\');"><span class="fa fa-camera" aria-hidden="true"></span></a>';
    }

    return '<div class="uploadfiles" id="JS_uploadfiles'.$suffix.'">'.$str.$mic.$vid.'</div>';
}

function SaveFiles($files_array, $record, $table, $folder, $nv_type = 'match', $newfolder = '')
{
    /* HF20161120 Starting today this function is fed with a DS-tablename! */
    if (!ipi($folder)) {
        $folder = 0;
    }

    $binfiles_tablename = '';

    if (ipi(str_replace('t', '', $table))) {
        $binfiles_tablename = 'flextable'.str_replace('t', '', $table);
    } else {
        $binfiles_tablename = $table;
    }

    if ($newfolder != '') {
        // CreateFolder is secured, no need to check security here
        $num = CreateFolder($record, $binfiles_tablename, $newfolder, $folder);
        /*
        if (!is_positive_integer($folder)) {
        $folder = PushStashValue(array($num));
        } else {
        $path = PopStashValue($folder);
        $path[] = $num;
        UpdateStashValue($folder, $path);
        }
        */
        $folder = $num;
    }

    $num_of_files = count($files_array['name']);

    for ($y = 0; $y < $num_of_files; ++$y) {
        if (filesize($files_array['tmp_name'][$y]) > 0) {
            // New version of file id.
            $nv = 0;

            // nv_type can be "match" or "new_file", latter is ignored
            if ($nv_type == 'match') {
                // Reset file_NewOrNewVersionOf when count > 1 (useless)
                // or when access is not allowed for some reason (should be impossible at the moment)
                $nv = db_GetValue("SELECT fileid FROM CRMbinfiles WHERE filename='".mres($files_array['name'][$y])."' AND koppelid='".$record."' AND type='".$binfiles_tablename."' AND (version_belonging_to=0 OR version_belonging_to=fileid) AND folder='".$folder."'");
            }

            // AttachFile is authenticated, no need to do it here
            $skip_security = false;

            $x = AttachFile($record, $files_array['name'][$y], file_get_contents($files_array['tmp_name'][$y]), $binfiles_tablename, $files_array['type'][$y], '', false, false, $folder, $skip_security);

            if (ipi($x)) { // Attaching succesful
                // Check fields
                //foreach (GetExtraFilesFields() AS $files_arrayle_efid) {
                foreach ($GLOBALS['UC']['PersonalDataStructure']['files']['fields'] as $name => $field) {
                    if ($field['fieldtype_in_extrafields_table'] != '') {
                        $post_name = 'files-'.$name.'-_new_';
                        if (isset($_POST[$post_name])) {
                            $value = $_POST[$post_name];

                            if ($field['dateformat'] == 'dd-mm-yyyy' && $value != '') {
                                $value = FormattedDateToNLDate($value);
                            } elseif ($field['fieldtype_in_extrafields_table'] == 'date/time') {
                                if ($value == '') {
                                    $value = '0000-00-00 00:00:00';
                                }
                            }

                            $ar = ValidateFieldInputDataStructureOnly($name, $value, true, $x);
                            if ($ar[0] == 'nok') {
                                // input denied
                                // delete uploaded file
                                DeleteFile($x, true);
                                $x = false;

                                break;
                            } else {
                                if ($ar[2] != '') {
                                    $value = $ar[2];
                                }
                                /* WATCH OUT: call update_field_value with BYPASS-SECURITY=true
                                 * this because the file record is already saved by AttachFile so
                                 * access rules based on calculations could already apply causing
                                 * access to be redrawn already */
                                update_field_value('files-'.$name, $x, $value, true, false, '');
                            }
                        }
                    }
                }
                if (ipi($nv) && GetSetting('ENABLEFILEVERSIONING') == 'Yes') {
                    // This is not an ordinary new file, it's a new version of an existing file!
                    // The new file will have 'version_belonging_to' = 0, but the version must be set and all earlier
                    // files must be made child of this one.
                    $t = db_GetRow("SELECT version_no FROM CRMbinfiles WHERE fileid='".mres($nv)."'");
                    $newversion = $t[0] + 1;
                    mcq('UPDATE CRMbinfiles SET version_belonging_to='.$x.", timestamp_last_change=timestamp_last_change WHERE version_belonging_to='".mres($nv)."'");
                    mcq('UPDATE CRMbinfiles SET version_belonging_to='.$x.", timestamp_last_change=timestamp_last_change WHERE fileid='".mres($nv)."'");
                    mcq('UPDATE CRMbinfiles SET version_no='.$newversion.", version_belonging_to=0, timestamp_last_change=timestamp_last_change WHERE fileid='".$x."'");
                }
            } else {
                // Access denied
                //print "ACCESS DENIED";
            }
        }
    }

    return $folder;
}

function RecordStatusChart($ds_tablename, $record, $ds_fieldname, $exclude)
{
    $me = 'index.php?nonavbar=1&amp;FieldHistory&amp;table='.$ds_tablename.'&amp;record='.$record.'&amp;field='.$ds_fieldname;

    foreach ($exclude as $x) {
        $me .= '&amp;exclude[]='.htme($x);
    }
    $fieldid = 0;
    if (ipi(str_replace('f', '', $ds_fieldname))) {
        $fieldid = str_replace('f', '', $ds_fieldname);
    } else {
        $fieldid = $ds_fieldname;
        /* extreem goor allemaal */
        if (substr($fieldid, 0, 4) == 'EFID') {
            $ds_fieldname = 'f'.str_replace('EFID', '', $fieldid);
        }
    }
    if (CheckTableRecordAccess($ds_tablename, $record) != 'nok' && is_array($GLOBALS['UC']['PersonalDataStructure'][$ds_tablename]['fields'][$ds_fieldname])) {
        $dj_tablename = '';
        if ($ds_tablename == 'users') {
            $dj_tablename = 'user';
        } elseif (ipi(str_replace('t', '', $ds_tablename))) {
            $dj_tablename = str_replace('t', '', $ds_tablename);
        }
        $dj_fieldname = '';
        $text_fieldname = '';
        if (ipi(str_replace('f', '', $ds_fieldname))) {
            $dj_fieldname = str_replace('f', '', $ds_fieldname);
            $text_fieldname = GetExtraFieldName($dj_fieldname);
        } else {
            $dj_fieldname = $ds_fieldname;
            $text_fieldname = $ds_fieldname;
        }
        $sqle = $exclude;
        array_walk($sqle, 'mres');
        $sql_exclude = " AND CRMdatajournal.to_val NOT IN ('".implode("','", $sqle)."')";
        $sql_record = '';

        if (ipi($record)) {
            $sql_record = " AND record='".$record."'";
        } else {
            exit;
        }

        $sql = "
		        SELECT  to_val,
                    DATE(timestamp_last_change) AS next_change,
                    IFNULL(
                        (SELECT DATE(timestamp_last_change) FROM CRMdatajournal a WHERE `table`='" .$dj_tablename."' ".$sql_record." AND field='".$dj_fieldname."' AND a.id > CRMdatajournal.id ORDER BY a.id LIMIT 1 )
                        ,DATE(NOW())
                    ) AS date_change,
                    IFNULL(-1*DATEDIFF(timestamp_last_change, (SELECT timestamp_last_change FROM CRMdatajournal a WHERE `table`='" .$dj_tablename."' ".$sql_record." AND field='".$dj_fieldname."' AND a.id > CRMdatajournal.id ORDER BY a.id LIMIT 1 )),-1*(DATEDIFF( timestamp_last_change, NOW()))
        ) AS days_value_active FROM CRMdatajournal WHERE `table`='" .$dj_tablename."' ".$sql_record." AND field='".$dj_fieldname."'  ORDER BY id DESC
		      ";

        //	print $sql;
        $bak = db_GetArray($sql);
        echo '<table class="crm">';
        echo '<thead><tr><th>'.htme($text_fieldname).'</th><th>From</th><th>To</th><th class="num">Days</th><th>Hide</th></tr></thead>';
        foreach ($bak as $line) {
            echo '<tr>';
            echo '<td>'.$line[0].'</td>';
            echo '<td>'.$line[1].'</td>';
            echo '<td>'.$line[2].'</td>';
            echo '<td class="num">'.$line[3].'</td>';
            if (in_array($line[0], $exclude)) {
                echo '<td><a href="'.str_replace('&amp;exclude[]='.htme($line[0]), '', $me).'">show</a></td>';
            } else {
                echo '<td><a href="'.$me.'&amp;exclude[]='.htme($line[0]).'">hide</a></td>';
            }
        }

        $sql = "
		SELECT to_val, DATE(timestamp_last_change) AS next_change, IFNULL((SELECT DATE(timestamp_last_change) FROM CRMdatajournal a WHERE `table`='" .$dj_tablename."' ".$sql_record." AND field='".$dj_fieldname."' AND a.id > CRMdatajournal.id ORDER BY a.id LIMIT 1 ),DATE(NOW())) AS date_change, IFNULL(-1*DATEDIFF(timestamp_last_change, (SELECT timestamp_last_change FROM CRMdatajournal a WHERE `table`='".$dj_tablename."' ".$sql_record." AND field='".$dj_fieldname."' AND a.id > CRMdatajournal.id ORDER BY a.id LIMIT 1 )),-1*(DATEDIFF(
					timestamp_last_change, NOW()
				))) AS days_value_active FROM CRMdatajournal WHERE `table`='" .$dj_tablename."' ".$sql_record." AND field='".$dj_fieldname."'  ".$sql_exclude.' ORDER BY id DESC
		';
        $bak = db_GetArray($sql);

        $ret .= '</table>';

        $ret .= '<br><div id="fieldhistory" style="width: 800px; height: 400px;"></div><br>';
        $ret .= '<script type="text/javascript">';
        $ret .= "
		// THE CHART
		$('#fieldhistory').highcharts({
			chart: {
				type: 'xrange'
			},
			legend: {
					enabled: false
				},
			title: {
					 text: '" .EscapeSQ($text_fieldname)."',
					 x: -20
				  },
			 credits: {
					enabled: false
				},
			tooltip: {
				enabled: false
			},
			xAxis: {
				type: 'datetime',
			},
			yAxis: {
				categories: [";
        //		'Prototyping', 'Development', 'Testing'\
        $nf = false;
        $s = array();
        $sc = 0;
        foreach ($bak as $row) {
            if (!array_key_exists($row[0], $s)) {
                if ($nf) {
                    $ret .= ',';
                }
                $ret .= "'".$row[0]."'";
                $s[$row[0]] = $sc;
                ++$sc;
                $nf = true;
            }
        }
        $ret .= '],
				min: 0,
				max: ' .(count($s) - 1)."
			},
			series: [{
				borderRadius: 2,
				height: 0.25,

				name: '" .$text_fieldname."',
				data: [
				";
        $nf = false;
        foreach ($bak as $row) {
            if ($nf) {
                $ret .= ',';
            }
            $ret .= "{\n";
            $ret .= 'x: Date.UTC('.substr($row['next_change'], 0, 4).', '. 1 * substr($row['next_change'], 5, 2).', '. 1 * substr($row['next_change'], 8, 2)."),\n";

            if ($row['next_change'] == $row['date_change']) {
                $row['date_change'] = date('Y-m-d', strtotime($row['next_change'].' +1 day'));
            }
            $ret .= 'x2: Date.UTC('.substr($row['date_change'], 0, 4).', '. 1 * substr($row['date_change'], 5, 2).', '. 1 * substr($row['date_change'], 8, 2)."),\n";

            $ret .= 'y: '.$s[$row['to_val']]."\n";

            $ret .= '}';
            $nf = true;
        }
        $ret .= '
				]
			}]

		});
		</script>';

        $title = $text_fieldname;
        $subtitle = 'time spent';
        //$type = "stacked column";
        $type = 'pie';
        //$height = 400;
        //$width = 800;
        //$legend = true;
        //$allowsubzero = true;
        //$backgroundcolor='#ffffff';
        $height = '400px';
        $width = '800px';

        $sql = "
		SELECT to_val,
			SUM(IFNULL(
				-1*TIME_TO_SEC(TIMEDIFF(
					timestamp_last_change,
						(SELECT timestamp_last_change FROM CRMdatajournal a WHERE `table`='" .$dj_tablename."' ".$sql_record." AND field='".$dj_fieldname."' AND a.id > CRMdatajournal.id ORDER BY a.id LIMIT 1 )
				)),

				-1*TIME_TO_SEC(TIMEDIFF(
					timestamp_last_change, NOW()
				))

				)) AS days_value_active
				FROM CRMdatajournal WHERE `table`='" .$dj_tablename."' ".$sql_record." AND field='".$dj_fieldname."'
				" .$sql_exclude.'
				GROUP BY to_val
				ORDER BY days_value_active,to_val DESC
		';

        //return $ret . CreateHighChartFromSQL($title, $subtitle, $sql, $type, $height, $width, $legend, $allowsubzero, $backgroundcolor);
        return $ret.CreateHighChartFromSQLNEW($title, $subtitle, $sql, $type, $height, $width);
    } else {
        printAD('Access denied');
      //: field " . $ds_fieldname . " in table " . $ds_tablename . " is not accessible");
    }
}
function GetPDFReport($templateid, $table, $record)
{
    $template = '';
    $filename = '';
    if ($table != '' && ipi($record)) {
        $passthru = array();
        $passthru['template_to_use'] = $templateid;
        $template = get_parsed_template($table, $record, $passthru, false, false, 'ok');
        $filename = clean_filename(html2plaintext(get_parsed_template_with_given_template($table, $record, array(), array(), false, '', GetTemplateSubject($templateid), 'TEMPLATE_PLAIN')));
    } else {
        $filename = GetTemplateSubject($templateid);
        $filename = clean_filename(html2plaintext(get_parsed_template_with_given_template('', '', array(), '', false, '', $filename, 'TEMPLATE_PLAIN')));

        if ($template = GetTemplate($templateid)) {
        } else {
            $template = 'Template access denied or non-existent.';
        }
        $template = get_parsed_template_with_given_template('', '', array(), '', false, '', $template, 'TEMPLATE_PLAIN');
    }

    if (strtolower(substr($filename, strlen($filename) - 4, 4)) != '.pdf') {
        $filename .= '.pdf';
    }

    $stylesheet = ReturnTemplateStyleSheet($templateid);

    return get_pdf_report_with_given_template($template, $stylesheet, $filename);
}

function get_pdf_report_with_given_template($template, $stylesheet, $filename)
{
    $html = '';
    $html .= '<!DOCTYPE html><html><head><meta charset="UTF-8">';
    // The stylesheet already has script header & footer
    $html .= $stylesheet;
    $html .= "</head><body>\n".$template."\n</body>\n</html>\n";

    /* read the document and replace references to interleave files by a locally stored path */
    $doc = new DOMDocument();
    @$doc->loadHTML($html);
    $imgs = $doc->getElementsByTagname('img');
    $tmpfiles = array();

    foreach ($imgs as $img) {
        $src = $img->getAttribute('src');

        $name = explode('?', basename($src));

        if ($name[0] == 'csv.php') {
            /* this is a reference to csv.php, one of our own files in an image tag */
        $args = explode('=', $name[1]);
            if ($args[0] == 'fileid' && ipi($args[1])) {

            /* check security */
            if (CheckTableRecordAccess('files', $args[1]) != 'nok') {

                /* we now temporarily save this file to disk */
                $path = CopyFileToDisk($args[1]);
                $tmpfiles[] = $path;
                $img->setAttribute('src', $path);
            }
            }
        }
    }

    $html = $doc->saveHTML();
    require_once 'lib/mpdf/mpdf.php';

    $mpdf = new mPDF('');

    $mpdf->SetDisplayMode('fullpage');
    $mpdf->WriteHTML($html);

    $pdf = $mpdf->Output($filename, 'S');

    foreach ($tmpfiles as $ftd) {
        unlink($ftd);
    }

    return array('filename' => $filename, 'pdf' => $pdf);
}
function clean_filename($filename)
{
    $filename = mb_ereg_replace("([^\w\s\d\-_~,;\[\]\(\).])", '', $filename);
    // Remove any runs of periods (thanks falstro!)
    $filename = mb_ereg_replace("([\.]{2,})", '', $filename);

    return $filename;
}
class SaferScript
{
    public $source, $allowedCalls;

    public function SaferScript($scriptText)
    {
        $this->source = $scriptText;
        $this->allowedCalls = array();
    }

    public function allowHarmlessCalls()
    {
        $this->allowedCalls = array('php', 'print', 'CustomerRFCiFrameAuthenticated', 'date', 'GetGroup', 'db_GetValue', 'mres', 'echo', 'htme', 'GetGroupName', 'db_GetArray', 'explode', 'ksort', 'str_pad', 'STR_PAD_LEFT', 'krsort', 'break', 'error_reporting', 'E_ALL', 'exit', 'str_replace', 'strlen', 'trim', 'substr', 'array_keys', 'CreateHighChart', 'CreateHighChartNEW', 'Vereniging', 'print_r', 'mcq', 'db_GetFlatArray', 'db_GetRow', 'db_GetInsertId', 'is_numeric', 'base64_encode', 'htmlspecialchars', 'GetUserName', 'NLDate2INTLDate', 'TransformDate', 'CreateHighChartFromSQL', 'CreateHighChartFromSQLNEW', 'false', 'true', 'ReturnDropDownSearchField', 'strtoupper', 'DA', 'count', 'PrintAD', 'strstr', 'UpdateDiaryField', 'RealMail', 'ShowHeaders', 'implode', 'header', 'fillout', 'round', 'strtotime', 'disable_mysql_triggers', 'enable_mysql_triggers', 'in_array', 'GetAttribute', 'GetSetting', 'filesize', 'FormatNumber', 'function', 'UpdateFT7', 'return', 'is_positive_integer', 'ob_start', 'PHT', 'ob_get_contents', 'ob_end_clean', 'ipi', 'GetTemplate', 'unescape_interleave_characters', 'ParseTemplateGeneric', 'ParseTemplateRecordData', 'db_Getrow', 'ord', 'ucwords', 'ParseTemplateLanguageTags', 'ReturnTemplateStyleSheet', 'ParseTemplateListTags', 'GetTemplateSubject', 'AttachFile', 'unserialize', 'base64_decode', 'CheckTableRecordAccess', 'HTML2PDF', 'html2plaintext', 'clean_filename');
    }

    public function parse()
    {
        $this->parseErrors = array();
        $vcall = '';

        foreach ($tokens as $token) {
            if (is_array($token)) {
                $id = $token[0];
                switch ($id) {
                case T_VARIABLE:
                    {$vcall .= 'v';
                        break;
                    }
                case T_STRING: {
                        $vcall .= 's';
                    }
                case T_REQUIRE_ONCE:
                case T_REQUIRE:
                case T_NEW:
                case T_RETURN:
                case T_BREAK:
                case T_CATCH:
                case T_CLONE:
                case T_EXIT:
                case T_PRINT:
                case T_GLOBAL:
                case T_ECHO:
                case T_INCLUDE_ONCE:
                case T_INCLUDE:
                case T_EVAL:
                case T_FUNCTION: {
                        if (array_search($token[1], $this->allowedCalls) === false) {
                            $this->parseErrors[] = 'illegal call: '.$token[1];
                        }
                    }
                }
            } else {
                $vcall .= $token;
            }
        }

        if (stristr($vcall, 'v(') != '') {
            $this->parseErrors[] = array('illegal dynamic function call');
        }

        return $this->parseErrors;
    }

    public function execute($parameters = array())
    {
        foreach ($parameters as $k => $v) {
            $$k = $v;
        }
        if (sizeof($this->parseErrors) == 0) {
            eval($this->source);
        } else {
            echo 'cannot execute, script contains errors';
        }
    }
}
function InitUser($user = 0)
{
    global $lang;

    // Drop all cache currently in memory, excluding ['UC']
    ClearAllRunningCache();
    $GLOBALS['UC'] = array();

    if ($user == 0) {
        $user = $GLOBALS['USERID'];
    } else {
        $GLOBALS['USERID'] = $user;
    }
    //the language pack is already loaded by initiate.php, but we need to reload it if the user is switched (via rules or cron, etc.)
    $lang = do_language();

    $GLOBALS['SesMem'] = array();
    if ($user == $GLOBALS['USERID']) {
        // Fetch session cache
        $GLOBALS['SesMem'] = unserialize(db_GetValue("SELECT sessioncache FROM CRMsessions WHERE temp='".mres($GLOBALS['sessionid'])."'"));
    } else {
        // The user being loaded is not the user actually owning this session, so un-set SesMem
        $GLOBALS['SesMemDontCommit'] = true;
    }

    // Check if reasons for access must be shown
    if ((isset($_GET['reason'])) || (isset($_GET['reasons']))) {
        $GLOBALS['SesMem']['ShowReasons'] = true;
    } elseif ((isset($_GET['noreason'])) || (isset($_GET['noreasons']))) {
        $GLOBALS['SesMem']['ShowReasons'] = false;
    }

    if ((is_administrator()) || (GetSetting('DevelopmentOrProduction') == 'Development')) {
        // Check if debug must be enabled
        if (isset($_GET['debug'])) {
            $GLOBALS['SesMem']['debug'] = true;
        } elseif (isset($_GET['nodebug'])) {
            $GLOBALS['SesMem']['debug'] = false;
        }
    }

    $user_record = db_GetRow('SELECT `name`, `PROFILE`, `DASHBOARDFILEID`, `MENUTOUSE`, `TRACE` FROM `CRMloginusers` WHERE `id`='.$user);
    //TODO dubbel
    $GLOBALS['username'] = $user_record['name'];
    $GLOBALS['USERNAME'] = $user_record['name'];
    $GLOBALS['name'] = $user_record['name'];

    //TODO dubbel
    $GLOBALS['GROUPID'] = $user_record['PROFILE'];
    $GLOBALS['UC']['GROUP'] = $user_record['PROFILE'];
    $GLOBALS['UC']['USERPROFILE'] = $user_record['PROFILE'];
    $GLOBALS['GROUP'] = $user_record['PROFILE'];
    $GLOBALS['USERPROFILE'] = $user_record['PROFILE'];

    $GLOBALS['UC']['PERSONALTRACE'] = $user_record['TRACE'];

    $group_record = $user_record;
    if ($GLOBALS['GROUPID'] > 0) {
        $group_record = db_GetRow('SELECT `DASHBOARDFILEID`, `MENUTOUSE` FROM `CRMuserprofiles` WHERE `id`='.$GLOBALS['GROUPID']);
    }

    if ($group_record['DASHBOARDFILEID'] > 0) {
        $GLOBALS['UC']['DASHBOARDTEMPLATE'] = $group_record['DASHBOARDFILEID'];
    } else {
        $dashboard = GetSetting('DASHBOARDTEMPLATE');
        if ($dashboard > 0) {
            $GLOBALS['UC']['DASHBOARDTEMPLATE'] = $dashboard;
        }
    }

    $GLOBALS['UC']['MENUTOUSE'] = $group_record['MENUTOUSE'];

    $GLOBALS['UC']['DateFormat'] = GetSetting('DateFormat');
    $localDF = GetAttribute('user', 'DateFormat', $user);
    if (($localDF != '') && ($localDF != '{{system}}')) {
        $GLOBALS['UC']['DateFormat'] = $localDF;
    }

    CheckAndCreateSystemDataStructure();
    $GLOBALS['UC']['PersonalDataStructure'] = unserialize(db_GetValue("SELECT `datastructure` FROM `CRMdatastructures` WHERE `userid`='".$GLOBALS['USERID']."'"));
    if (!is_array($GLOBALS['UC']['PersonalDataStructure'])) {
        $GLOBALS['UC']['PersonalDataStructure'] = get_data_structure();
        //ON DUPLICATE voor het geval dat via een andere sessie de DS inmiddels al aangemaakt is
        mcq('INSERT INTO `CRMdatastructures` (`userid`, `datastructure`) VALUES ('.$GLOBALS['USERID'].", '".mres(serialize($GLOBALS['UC']['PersonalDataStructure']))."') ON DUPLICATE KEY UPDATE `userid`=`userid`");
    }

    if (isset($_REQUEST['Blur'])) {
        $GLOBALS['SesMem']['Blur'] = true;
    } elseif (isset($_REQUEST['Unblur']) || isset($_REQUEST['Noblur'])) {
        $GLOBALS['SesMem']['Blur'] = false;
    }

    if ($GLOBALS['SesMem']['Blur']) {
        echo '<style type="text/css">
	    input[type=text], select, p, .crm td, .crm th label, textarea, .diarycellcontent {
	    color: transparent;
	    text-shadow: 0 0 4px rgba(0,0,0,0.8);
	    }
	    </style>';
    }

    if (is_administrator()) {
        if (isset($_GET['EnableOnlineEditModeInlineLinks'])) {
            SetAttribute('user', 'OnlineEditMode-ShowInlineLinks', 'Yes', $GLOBALS['USERID']);
        } elseif (isset($_GET['DisableOnlineEditModeInlineLinks'])) {
            SetAttribute('user', 'OnlineEditMode-ShowInlineLinks', 'No', $GLOBALS['USERID']);
        }

        if (isset($_GET['EnableOnlineQlog'])) {
            SetAttribute('user', 'OnlineEditMode-OnlineQLOG', 'Yes', $GLOBALS['USERID']);
        } elseif (isset($_GET['DisableOnlineQlog'])) {
            SetAttribute('user', 'OnlineEditMode-OnlineQLOG', 'No', $GLOBALS['USERID']);
        }

        $attribinlinelinks = GetAttribute('user', 'OnlineEditMode-ShowInlineLinks', $GLOBALS['USERID']);
        $attribonlineqlog = GetAttribute('user', 'OnlineEditMode-OnlineQLOG', $GLOBALS['USERID']);
        if ($attribonlineqlog == 'Yes') {
            $GLOBALS['qlog_onscreen'] = true;
        }

        $GLOBALS['SesMem']['InlineEditMode'] = 'On';
        if ($attribinlinelinks == 'Yes') {
            $GLOBALS['SesMem']['InlineEditMode_InlineLinks'] = 'On';
        } else {
            $GLOBALS['SesMem']['InlineEditMode_InlineLinks'] = 'Off';
        }

        $url = $_SERVER['REQUEST_URI'];
        $url = str_replace('&EnableOnlineEditModeInlineLinks', '', $url);
        $url = str_replace('&DisableOnlineEditModeInlineLinks', '', $url);
        $url = str_replace('&DisableOnlineQlog', '', $url);
        $url = str_replace('&EnableOnlineQlog', '', $url);

        if (!strstr($url, '?')) {
            $url .= '?';
        }

        if ($_REQUEST['AddInPopup'] == '' && $_REQUEST['ParentAjaxHandler'] == '' && $_REQUEST['BYAJAX'] == '' && !$GLOBALS['webapp']) {
            $tp = '';
            $tp .= '<div id="adminpopup" class="adminpopup hide_content">';
            $tp .= '<nav class="adminbarnav">';
            $navs = get_admin_nav_items();
            foreach ($navs as $item) {
                $tp .= '<li><a href="'.$item[0].'">'.($item[1]).'</a></li>';
            }

            $tp .= '</nav></div>';

            $tp .= '<div class="InlineEditModeSwitch">';
            $tp .= '<a href="admin.php"><span class="fa fa-wrench"></span></a> ';
            if ($attribinlinelinks == 'Yes') {
                $tp .= '<a href="'.htme($url).'&amp;DisableOnlineEditModeInlineLinks"><span class="fa fa-eye"></span></a> ';
            } else {
                $tp .= '<a href="'.htme($url).'&amp;EnableOnlineEditModeInlineLinks"><span class="fa fa-eye"></span></a> ';
            }

            if ($attribonlineqlog == 'Yes') {
                $tp .= '<a href="'.htme($url).'&amp;DisableOnlineQlog"><span class="fa fa-book"></span></a> ';
            } else {
                $tp .= '<a href="'.htme($url).'&amp;EnableOnlineQlog"><span class="fa fa-book"></span></a> ';
            }
            //$tp .= "<a onmouseover='showLayer(\"admintablespopup\", 1);'><span class=\"fa fa-table\"></span></a> ";
            $tp .= "<a onmouseover='showLayer(\"adminpopup\", 1);'><span class=\"fa fa-bars\"></span></a>";
            $tp .= '</div>';
            $GLOBALS['JavascriptToPrintAtEndOfPage'][] = $tp;
        }
    }
}
function get_datamanagement_nav_items()
{
    $navs = array();
    $navs[] = array('dedup.php&amp;SkipMainNavigation', 'De-duplicate records');
    $navs[] = array('admin.php?FindAndReplace&amp;SkipMainNavigation', 'Find &amp; replace');
    $navs[] = array('admin.php?DropAllCache=1&amp;datman=1&amp;SkipMainNavigation', 'Drop all cache');
    $navs[] = array('admin.php?RecalculateCalculations=1&amp;SkipMainNavigation', 'Recalculate calculations');
    $navs[] = array('admin.php?RunCompression=1&amp;SkipMainNavigation', 'Compress old versions and old files');
    $navs[] = array('admin.php?ArchiveLog&amp;SkipMainNavigation', 'Archive table data');
    $navs[] = array('admin.php?MailQueueManager&amp;SkipMainNavigation', 'Manage mail queue');
    $navs[] = array('listadmin.php?mergeparents=1&amp;datman=1&amp;SkipMainNavigation', 'Merge/migrate parent records');
    $navs[] = array('attrib-assist.php?ShowAdminMenu=1&SkipMainNavigation', 'Attributes');
    $navs[] = array('import.php?SkipMainNavigation', 'Import/update records');
    $navs[] = array('admin.php?datman=1&amp;AnalyzeTables&amp;SkipMainNavigation', 'Analyze all tables');
    $navs[] = array('admin.php?check_database_fields&amp;SkipMainNavigation', 'Check/fix database schema');
    $navs[] = array('admin.php?datman=1&amp;recreate_mysql_triggers&amp;SkipMainNavigation', 'Re-create MySQL triggers');
    $navs[] = array('admin.php?datman=1&amp;create_indices&amp;SkipMainNavigation', 'Check indices');
    $navs[] = array('admin.php?checkdb=1&amp;web=1&amp;SkipMainNavigation', 'Database consistency');
    $navs[] = array('admin.php?excessfields=1&amp;SkipMainNavigation', 'Excess tables &amp; fields check');
    $navs[] = array('admin.php?checkfiles=1&amp;SkipMainNavigation', 'Excess files check');
    $navs[] = array('admin.php?PerformDatabaseMaintenance=1&amp;SkipMainNavigation', 'Database maintenance');

    return $navs;
}
function get_adminglobal_nav_items()
{
    $navs = array();
    $navs[] = array('dictedit.php?packman=1&amp;SkipMainNavigation', 'Manage language packs');
    $navs[] = array('admin.php?reposman=1&amp;resman=1&amp;manageres=1&amp;SkipMainNavigation', 'Manage repositories');

    $navs[] = array('admin.php?log=1&amp;SkipMainNavigation', 'View log');
    $navs[] = array('admin.php?ViewJournal=1&amp;SkipMainNavigation', 'View journals');
    $navs[] = array('admin.php?ViewDataJournal=1&amp;SkipMainNavigation', 'View datajournals');
    $navs[] = array('admin.php?GeneralFiles&amp;SkipMainNavigation', 'General purpose files');
    $navs[] = array('admin.php?SystemFiles&amp;SkipMainNavigation', 'System files');
    $navs[] = array('admin.php?PublicFiles&amp;SkipMainNavigation', 'Public files');
    $navs[] = array('listadmin.php?datastructure=1&amp;datman=1&amp;SkipMainNavigation', 'Data structure');
    $navs[] = array('listadmin.php?datastructuregraphic=1&amp;datman=1&amp;SkipMainNavigation', 'Data structure graphic');
    $navs[] = array('listadmin.php?tables=1&amp;datman=1&amp;SkipMainNavigation', 'System/data tables');
    $navs[] = array('listadmin.php?tablecomparison=1&amp;datman=1&amp;SkipMainNavigation', 'Table comparison');
    $navs[] = array('listadmin.php?fieldcomparison=1&amp;datman=1&amp;SkipMainNavigation', 'Field comparison');
    $navs[] = array('listadmin.php?groupcomparison=1&amp;datman=1&amp;SkipMainNavigation', 'Group comparison');
    $navs[] = array('listadmin.php?lists=1&amp;datman=1&amp;SkipMainNavigation', 'Available lists');
    $navs[] = array('list.php?searchalltables=1&amp;SkipMainNavigation', 'Search all tables');
    $navs[] = array('index.php?UserMessage=1&amp;SkipMainNavigation', 'Messages');
    $navs[] = array('listadmin.php?renumbertables=1&amp;SkipMainNavigation', 'Renumber ordering of tables');
    $navs[] = array('listadmin.php?renumberfields=1&amp;SkipMainNavigation', 'Renumber ordering of fields');
    $navs[] = array('admin.php?get_list_options_and_descriptions=1&amp;SkipMainNavigation', 'Show list options and descriptions');

    return $navs;
}
function get_admin_nav_items()
{
    $tables = array();
    $tables[] = array('flextable.php?EditFlexTable=new', 'New table');
    foreach ($GLOBALS['UC']['PersonalDataStructure'] as $table => $props) {
        if ($props['datatable']) {
            $tables[] = array('flextable.php?EditFlexTable='.str_replace('t', '', $table).'&amp;SkipMainNavigation', $table.' '.$props['plural']);
        }
    }
    $calendars = array();
    $calendars[] = array('record.php?table=calendars', 'New calendar');
    foreach (db_GetArray("SELECT id, description FROM CRMcalendars WHERE deleted='n'") as $cal) {
        $calendars[] = array('record.php?table=calendars&amp;record='.$cal['id'].'&amp;SkipMainNavigation', $cal['id'].' '.$cal['description']);
    }
    $groups = array();

    foreach (db_GetArray('SELECT id, name FROM CRMuserprofiles') as $group) {
        $groups[] = array('useradmin.php?EditGroup='.$group['id'].'&amp;SkipMainNavigation', $group['id'].' '.$group['name']);
    }
    $mods = array();
    $mods[] = array('modules.php?action=addonline', 'New module');

    foreach (db_GetArray('SELECT mid, module_name FROM CRMmodules WHERE version_belonging_to=0 ORDER BY timestamp_last_change DESC LIMIT 10') as $mod) {
        $mods[] = array('modules.php?action=edit&amp;mid='.$mod['mid'].'&amp;SkipMainNavigation', $mod['mid'].' '.$mod['module_name']);
    }
    $mainoptions = array();
    $mainoptions[] = array('admin.php?&sysval=1&amp;SkipMainNavigation', 'Global settings');
    $mainoptions[] = array('admin.php?actions=1&amp;SkipMainNavigation', 'Actions');

    $fields = array();
    foreach (db_GetArray("SELECT id, tabletype, name FROM CRMextrafields WHERE deleted='n' ORDER BY timestamp_last_change DESC LIMIT 10") as $field) {
        $fields[] = array('extrafields.php?editextrafield='.$field['id'].'&tabletype='.$field['tabletype'].'&amp;SkipMainNavigation', $field['id'].': '.$field['name']);
    }
    $templates = array();
    $templates[] = array('admin.php?templates=1&add=1', 'New template');
    $templates[] = array('admin.php?templates=1&amp;t1=all&amp;type=TEMPLATE_HTML_FORM&amp;SkipMainNavigation', 'Forms');
    $templates[] = array('admin.php?templates=1&amp;t1=all&amp;type=TEMPLATE_HTML&amp;SkipMainNavigation', 'HTML');
    $templates[] = array('admin.php?templates=1&amp;t1=all&amp;type=TEMPLATE_REPORT_PDF&amp;SkipMainNavigation', 'PDF');
    $templates[] = array('admin.php?templates=1&amp;t1=all&amp;type=TEMPLATE_CSS&amp;SkipMainNavigation', 'CSS');
    foreach (db_GetArray('SELECT templateid, templatename FROM CRMtemplates WHERE version_belonging_to = 0 ORDER BY timestamp_last_change DESC LIMIT 10') as $t) {
        $templates[] = array('admin.php?templates=1&amp;editHTMLtemplate='.$t['templateid'], $t['templateid'].': '.$t['templatename']);
    }

    $rules = array();
    $rules[] = array('record.php?table=rules', 'New rule');
    $rules[] = array('list.php?table=ruleconditions', 'Rule conditions');
    $rules[] = array('list.php?table=ruleactions', 'Rule actions');
    $rules[] = array('list.php?table=ruleactionconditions', 'Rule action conditions');
    foreach (db_GetArray('SELECT id, name FROM CRMrules ORDER BY timestamp_last_change DESC LIMIT 10') as $t) {
        $rules[] = array('record.php?table=rules&amp;record='.$t['id'], $t['id'].': '.$t['name']);
    }

    $navs = array();
    $navs[] = array('admin.php?SkipMainNavigation', '<span class="fa fa-fw fa-home"></span> Main', $mainoptions);
    $navs[] = array('admin.php?syscon=1&amp;SkipMainNavigation', '<span class="fa fa-fw fa-wrench"></span> System configuration', get_adminglobal_nav_items());
    $navs[] = array('admin.php?datman=1&amp;SkipMainNavigation', '<span class="fa fa-fw fa-database"></span> Data management', get_datamanagement_nav_items());
    $navs[] = array('useradmin.php?cur=1&amp;SkipMainNavigation', '<span class="fa fa-fw fa-users"></span> Users & Groups', $groups);
    $navs[] = array('extrafields.php?SkipMainNavigation', '<span class="fa fa-fw fa-caret-square-o-down"></span> Fields', $fields);
    $navs[] = array('flextable.php?TableAdmin=true&amp;SkipMainNavigation', '<span class="fa fa-fw fa-table"></span> Tables', $tables);
    $navs[] = array('rules.php?SkipMainNavigation', '<span class="fa fa-fw fa-exchange"></span> Rules', $rules);
    $navs[] = array('admin.php?templates=1&amp;t1=all&amp;SkipMainNavigation', '<span class="fa fa-fw fa-pencil-square-o"></span> Templates', $templates);
    $navs[] = array('admin.php?CalendarAdmin&amp;SkipMainNavigation', '<span class="fa fa-fw fa-calendar"></span> Calendars', $calendars);
    $navs[] = array('modules.php?SkipMainNavigation', '<span class="fa fa-fw fa-code"></span> Modules', $mods);

    return $navs;
}
function get_user_messages($BYAJAX = true)
{
    global $lang;
    /* todo: get _REQUEST queries out of this function */
    $result = array();

    $stp = false;

    if ($_REQUEST['my_rep_hash'] != md5(db_GetValue('SELECT DATABASE()')) && $BYAJAX) {

        /* this means the user has a valid session, but not connected to this repository. we redirect and alert the user */
        $result['command'] = 'redirect_to_dash';
        $stp = true;
    } else {
        $result['message'] = '';

        if (GetSetting('DisableAllInternalMessagePopups') == 'Yes') {
            $stp = false;
        } else {
            if (!is_array($GLOBALS['SesMem']['ShownMessages'])) {
                $GLOBALS['SesMem']['ShownMessages'] = array();
            }
            if (!is_array($GLOBALS['SesMem']['ShownMessages']['internalmessages'])) {
                $GLOBALS['SesMem']['ShownMessages']['internalmessages'] = array();
            }

            $calendars = GetAccessibleCalendars();

            $tmp_message = '';
            foreach ($calendars as $calKey => $calObj) {
                $calendarnameprinted = false;

                if ($calObj['display_popup'] == 'Yes' && GetAttribute('user', 'HideCalendar-'.$calKey, $GLOBALS['USERID']) != 'Yes') {
                    $local_calendar = GetCalendarEvents($calKey, 'messages', date('Y-m-d'), date('Y-m-d'));

                    foreach ($local_calendar as $event) {
                        if (trim($calObj['show_popup']) == '') {
                            $calObj['show_popup'] = '30,5,0';
                        }
                        $list = explode(',', $calObj['show_popup']);

                        foreach ($list as $minute_before) {
                            $minute_before = trim($minute_before) * 1;

                            $alert_time = date('Y-m-d H:i', strtotime($event['iso_start'].' -'.$minute_before.' minutes'));

                            if ($alert_time == date('Y-m-d H:i')) { // OK, action!

                                /* can this be removed? */
                                if ($event['iso_start'] == '') {
                                    $event['iso_start'] = $event['iso_end'];
                                }

                                // Create unique id to store so we know if we already did this one
                                $id = $event['id'].' '.$event['recordid'].$minute_before;

                                if (!$GLOBALS['SesMem']['ShownMessages'][$id]) {
                                    if (!$calendarnameprinted) {
                                        $tmp_message .= '<h2>'.htme($calObj['description']).'</h2>';
                                        $calendarnameprinted = true;
                                    }

                                    $closelink = false;
                                    $tmp_message .= '<div>';
                                    if ((($calObj['appointment_click_action'] == 'Open record in current window') || ($calObj['appointment_click_action'] == 'Open record in popup')) && ($event['openlink'] != '')) {
                                        $tmp_message .= '<a href="'.htme($event['openlink']).'" onclick="ilor(this.href,'.$popups[$event['id']].',\''.$listid.'\');return false;">';
                                        $closelink = true;
                                    }

                                    //summary is een html veld dus niet door htme()
                                    $tmp_message .= SQLDateTimeToFormattedDateTime($event['iso_start']).' '.$event['summary'];
                                    if ($closelink) {
                                        $tmp_message .= '</a>';
                                    }
                                    $tmp_message .= '</div>';

                                    $GLOBALS['SesMem']['ShownMessages'][$id] = true;

                                    $stp = true;
                                } else {

                                    /* not showing again: $id - " . $event['summary'] */
                                }
                            } else {

                                /*
                                    print "Alert time $alert_time != " . date('Y-m-d H:i') . ". No action needed.<br>";
                                  */
                            }
                        }
                    }
                } else {
                    /*
                     * Skipping events of calendar ' . $calKey . ', show_popup is : ' . $calObj['show_popup'] .
                     *
                     */
                }
            }
            if ($stp) {
                $result['message'] .= $tmp_message;
            }
            $sql_ins = '';
            if (is_administrator()) {
                $sql_ins = "(`to`='".$GLOBALS['USERID']."' OR `to`=0)";
            } else {
                $sql_ins = "`to`='".$GLOBALS['USERID']."'";
            }
            $to_show = db_GetFlatArray('SELECT * FROM CRMinternalmessages WHERE '.$sql_ins." AND `read`='n' AND shown_in_popup='n' ORDER BY id DESC");
            if (count($to_show) > 0) {
                $result['message'] .= '<h2><a href="index.php?UserMessage">'.htme($lang['messageinbox']).': '.count($to_show).' '.htme($lang['incomingmessages']).'</a></h2>';
                $lo = array('table' => 'messages', 'hiddenfilter' => array('messages-shown_in_popup' => array('n'), 'messages-to' => array($GLOBALS['USERID']), 'messages-read' => array('n')), 'type_of_list' => 'sublist', 'hide_all' => true);
                if (is_administrator()) {
                    $lo['hiddenfilter']['messages-to'][] = 0;
                }
                list($number_of_records, $output) = make_list($lo);
                $result['message'] .= $output;

                $sql = "UPDATE CRMinternalmessages SET shown_in_popup='y' WHERE id IN (".implode(',', $to_show).')';
                mcq($sql);
            }
        }
    }

    $result['result'] = 'ok';
    /* LEAVE: this commits the ShowMessages array to the session */
    EndSEssion();

    return $result;
}

function create_menu()
{
    $html = '';
    if ($GLOBALS['UC']['MENUTOUSE'] == 'default' || $GLOBALS['UC']['MENUTOUSE'] == '') {
        $lowest_template = db_GetValue("SELECT templateid FROM CRMtemplates WHERE templatetype='TEMPLATE_MENU' AND version_belonging_to=0 ORDER BY templateid LIMIT 1");
        if (CheckTemplateAccess($lowest_template) == 'ok') {
            $GLOBALS['UC']['MENUTOUSE'] = 't-'.$lowest_template;
        }
    }

    $template_id = 0;
    if (substr($GLOBALS['UC']['MENUTOUSE'], 0, 2) == 't-') {
        $template_id = str_replace('t-', '', $GLOBALS['UC']['MENUTOUSE']);
    }

    if (ipi($template_id)) {
        $html .= ParseTemplateMenu($template_id);

        if (is_administrator()) {
            if (!$GLOBALS['webapp']) {
                // Shortkeys for admins
                    $html .= '<div class="hide_content">';
                $html .= "<a accesskey='a' href='admin.php?info=1&amp;SkipMainNavigation'></a>";
                $html .= "<a accesskey='s' href='admin.php?sysval=1&amp;SkipMainNavigation'></a>";
                $html .= "<a accesskey='d' href='admin.php?checkdb=1&amp;web=1&amp;SkipMainNavigation'></a>";
                $html .= "<a accesskey='p' href='admin.php?fysdelete=1&amp;SkipMainNavigation'></a>";
                $html .= "<a accesskey='l' href='dictedit.php?packman=1&amp;SkipMainNavigation'></a>";
                $html .= "<a accesskey='u' href='useradmin.php?cur=1&amp;password=&amp;adduser=1&amp;userman=1&amp;SkipMainNavigation'></a>";
                $html .= "<a accesskey='p' href='admin.php?fysdelete=1&amp;SkipMainNavigation'></a>";
                $html .= "<a accesskey='e' href='extrafields.php?&amp;SkipMainNavigation'></a>";
                $html .= "<a accesskey='r' href='admin.php?reposman=1&amp;resman=1&amp;manageres=1&amp;SkipMainNavigation'></a>";
                $html .= "<a accesskey='f' href='flextable.php?TableAdmin=true&amp;SkipMainNavigation'></a>";
                $html .= '</div>';
            }
        }
    }

    return $html;
}
function Show404($message = '')
{
    header('HTTP/1.0 404 Not Found');
    header('Content-Type: text/html; charset=UTF-8');
    echo '<!DOCTYPE html>';
    echo '<html>';
    echo '<head>';
    echo '<meta charset="UTF-8">';
    echo '<title>Page not found</title>';
    echo '</head>';
    echo '<body>';
    echo '<h1>Page not found</h1>';
    echo '<img src="'.GetSetting('BASEURL').'images/interleave128.png" alt="">';
    echo '<p>'.htme($message).'</p>';
    echo '<p>The requested URL was not found on this server.</p>';
    echo '<p><a href="'.GetSetting('BASEURL').'index.php">Go back to dashboard</a></p>';

    echo '</body>';
    echo '</html>';
}
/* was moved to adminfunctions.php HF20161227 put back, in userside use in GFS */
function get_pastel_color_by_hash($name)
{
        $hash = md5($name);

        $color1 = hexdec(substr($hash, 8, 2));
        $color2 = hexdec(substr($hash, 4, 2));
        $color3 = hexdec(substr($hash, 0, 2));
        if ($color1 < 128) $color1 += 128;
        if ($color2 < 128) $color2 += 128;
        if ($color3 < 128) $color3 += 128;

        return dechex($color1) . dechex($color2) . dechex($color3);
}

?>
